﻿
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/


#include "Q7BCompiler.h"

#define COMMENT ;Me.types<<sType;Me.comments_types[sType]._COMMENT

#define Type ;sType=


void Parser::CreateListOfTypes()
{      
  QString sType;
    
  if (Me.types.size() == 0){    
    
    // ----------------------------------------------------------------------------------------------------------------------------
#ifdef Q7BASIC

    Type "Boolean"        COMMENT = "It is internally a bool object.";
    Type "String"      COMMENT = "It is internally a QString object. Unicode support is built-in. You need to have installed Unicode support (e.g. Asian language and character sets) for Windows for this feature.";

    Type "Integer"        COMMENT = "It is internally a qint64 object.";
    Type "Float"        COMMENT = "It is internally a qreal object.";

    Type "DateTime"        COMMENT = "A DateTime object is internally a QDateTime object.";
    Type "Decimal"        COMMENT = "It is internally a Q7Basic custom object based storing its value in a qint64.";
    Type "Object"        COMMENT = "An alias for id.";
    Type "Variant"        COMMENT = "Reserved.";

    Type "Byte"        COMMENT = "It is internally a qint64 object. If needed it gets converted to unsigned 8-bit.";
    Type "Short"        COMMENT = "It is internally a qint64 object. If needed it gets converted to 16-bit.";
    Type "Int8"        COMMENT = "It is internally a qint64 object. If needed it gets converted to signed 8-bit.";
    Type "Int16"        COMMENT = "It is internally a qint64 object. If needed it gets converted to signed 16-bit.";
    Type "Int32"        COMMENT = "It is internally a qint64 object. If needed it gets converted to signed 32-bit.";
    Type "Int64"        COMMENT = "An alias for Integer.";
    Type "Long"        COMMENT = "Reserved.";

    Type "Single"        COMMENT = "It is internally a qreal object. If needed it gets converted to 32-bit float (single).";
    Type "Double"        COMMENT = "An alias for Float.";

    Type "CString"        COMMENT = "It is internally a QString object. If needed it gets converted to a CString.";

    Type "List"        COMMENT = "It is internally a QList<id>.";
    Type "Dictionary"        COMMENT = "It is internally a QMap<QString, id>.";


    
    
    Type "id"        COMMENT = "";

#elif defined OBJB

    Type "Rect"        COMMENT = "The rect type defines a rect. It is a wrapped NSRect inside of a NSValue object.\n\nContains the properties Origin As Point and Size As Size.";
    Type "Range"        COMMENT = "";
    Type "Point"        COMMENT = "";
    Type "Size"        COMMENT = "";

    Type "id"        COMMENT = "Almost an alias for NSObject.";
    Type "Array"        COMMENT = "Alias for NSMutableArray.";
  //  Type "List"        COMMENT = "Alias for Array.";
    Type "Dictionary"        COMMENT = "Alias for NSMutableDictionary.";
    Type "Data"        COMMENT = "Alias for NSMutableData.";

    Type "Boolean"        COMMENT = "The boolean type. It is a wrapped BOOL inside of a NSNumber object.\n\nAllowed values are 'Yes' (for true) or 'No' (for false).";
    Type "String"        COMMENT = "Alias for NSMutableString.";
  //  Type "CString"        COMMENT = "Reserved.";
 //   Type "DateTime"        COMMENT = "Reserved.";
   // Type "Decimal"        COMMENT = "Reserved.";

    Type "Byte"        COMMENT = "";
    Type "Short"        COMMENT = "";
    Type "Integer"        COMMENT = "It is 32 bit on 32 bit systems and 64 bit on 64 bit systems.";
    /*
    Type "Int8"        COMMENT = "Reserved.";
    Type "Int16"        COMMENT = "Reserved.";
    Type "Int32"        COMMENT = "Reserved.";
    Type "Int64"        COMMENT = "Reserved.";*/

    Type "Long"        COMMENT = "Reserved.";
    Type "Single"        COMMENT = "";
    Type "Double"        COMMENT = "";
    Type "Float"        COMMENT = "";

#elif defined(DROIDBASIC)

    Type "Boolean"        COMMENT = "It is internally a boolean object.";
    Type "String"      COMMENT = "It is internally a string object.";

    Type "Integer"        COMMENT = "It is internally a int object.";
    Type "Long"        COMMENT = "It is internally a long object.";
    Type "Float"        COMMENT = "It is internally a double object.";
    Type "Char"        COMMENT = "It is internally a char object.";
    Type "Byte"        COMMENT = "It is internally a byte object.";
    Type "Short"        COMMENT = "It is internally a short object.";

    Type "Object"        COMMENT = "An alias for id.";
    Type "id"        COMMENT = "An alias for Object.";

    Type "Single"        COMMENT = "It is internally a float object.";
    Type "Double"        COMMENT = "An alias for Float.";

    Type "List"        COMMENT = "";
    Type "Dictionary"        COMMENT = "";
    

#endif // Q7BASIC_OBJB
    // ----------------------------------------------------------------------------------------------------------------------------
  }

  Me.types.sort();


}


#undef COMMENT
#undef Type
