﻿

/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/


#include "Q7BCompiler.h"

bool Parser::parseClassConst(_statements & Statements, bool bDeclare)
{
  bool bLocal = false;  
  return parseConst(Statements, bLocal, bDeclare);
}

bool Parser::parseClassDimOutlet(_statements & Statements, bool bDeclare)
{
  bool bLocal = false;  
  return parseDimOutlet(Statements, bLocal, bDeclare);
}  

bool Parser::parseClass(QString sFileName)
{
    Me.sFileName = sFileName;
    Me.nTokenPos = 0;
    Me.nLine = 1;
    Me.nBlock = 0;
    

    _statements ClassStatements;    

    while(Me.nTokenPos < Me.tokens[Me.sFileName].size()){
      if (Me.bError) return false;

      QString token = getToken();

      if (token == "K\n"){ // new line
        Me.nTokenPos++;
        Me.nLine++;
        continue;
      }

      if (token == "K:"){
        Me.nTokenPos++;
        continue;
      }

      if (token == "K<string>"){
        Me.nTokenPos++;
        Me.nLine++;
        continue;
      }

      if (token.at(0) == 'C'){ // comment
        Me.nTokenPos++;
        continue;
      }

#ifdef Q7BASIC
		  if (peekTerm("Outlet") || peekTerm("Declare") || peekTerm("Global") || peekTerm("Private") || peekTerm("Public") || peekTerm("Sub") || peekTerm("Signal") || peekTerm("Slot") || peekTerm("Event") || peekTerm("Function") || peekTerm("Dim") || peekTerm("Var") || peekTerm("Const") || peekTerm("Property") || peekTerm("Enum") || peekTerm("Type")){
#elif defined OBJB
		  if (peekTerm("Declare") || peekTerm("Private") || peekTerm("Public") || peekTerm("Sub") || peekTerm("Delegate") || peekTerm("IBOutlet") || peekTerm("IBAction") || peekTerm("Action") || peekTerm("Event") || peekTerm("Function") || peekTerm("Dim") || peekTerm("Var") || peekTerm("Const")){
#elif defined DROIDBASIC
		  if (peekTerm("Declare") || peekTerm("Private") || peekTerm("Public") || peekTerm("Sub") || peekTerm("Outlet") || peekTerm("Signal") || peekTerm("Event") || peekTerm("Function") || peekTerm("Dim") || peekTerm("Var") || peekTerm("Const")){
#endif // Q7BASIC_OBJB
          
          if (getClassName(Me.sFileName) == "Global"){
            Me.sPublicPrivateGlobal = "Public";
          } else {
            Me.sPublicPrivateGlobal = "Public";
          }
          QString sSubFunctionIBActionActionSignalEventDelegateSlot;
          bool bProperty = false;

          if (parseTerm("Private")){
            Me.sPublicPrivateGlobal = "Private";
          } else if (parseTerm("Public")){
            Me.sPublicPrivateGlobal = "Public";
#ifdef Q7BASIC
          } else if (parseTerm("Global")){
            Me.sPublicPrivateGlobal = "Global";
          } else if (parseTerm("Property")){
            bProperty = true;
            Me.sPublicPrivateGlobal = "Public";
#elif defined OBJB
#elif defined DROIDBASIC
#endif // Q7BASIC_OBJB
          }

          bool bDeclare = false;
          if (parseTerm("Declare")){
            bDeclare = true;
          }
      

          Me.SubFunction = _subfunction();


          if (parseTerm("Sub")){
            sSubFunctionIBActionActionSignalEventDelegateSlot = "Sub";
            //if (bDeclare && bPrivate){ error("Declare Sub cannot be private. It is always public."); return false; }
            //Me.SubFunction.bLocalSub = bSub = true;

#ifdef Q7BASIC

          } else if (parseTerm("Signal")){
            if (bProperty){ error("Signal with Property not allowed"); return false; }
            sSubFunctionIBActionActionSignalEventDelegateSlot = "Signal";

            
         //   if (bDeclare){
          //    { error("Signal with Declare not allowed yet"); return false; }
          //  }
            //bSignal = Me.SubFunction.bLocalSignal = Me.SubFunction.bLocalSub = bSub = true;
          } else if (parseTerm("Slot")){
            if (bProperty){ error("Slot with Property not allowed"); return false; }

            if (bDeclare){
              { error("Slot with Declare not allowed yet"); return false; }
            }

            { error("Slot not supported yet"); return false; }

            sSubFunctionIBActionActionSignalEventDelegateSlot = "Slot";

            //bSignal = Me.SubFunction.bLocalSub = bSub = true;
#elif defined OBJB
          } else if (parseTerm("Action")){
            /*
            if (bClass){
              { error("Action with Class not allowed"); return false; }
            }
            */
            if (bDeclare){
              { error("Action with Declare not allowed"); return false; }
            }
            sSubFunctionIBActionActionSignalEventDelegateSlot = "Action";
            //bAction = Me.SubFunction.bLocalSub = bSub = true;
          } else if (parseTerm("IBAction")){
            if (bDeclare){
              { error("IBAction with Declare not allowed"); return false; }
            }
            sSubFunctionIBActionActionSignalEventDelegateSlot = "IBAction";
            //bIBAction = Me.SubFunction.bLocalSub = bSub = true;
          } else if (parseTerm("Delegate")){
            /*
            if (bClass){
              { error("Delegate with Class not allowed"); return false; }
            } 
            */
            sSubFunctionIBActionActionSignalEventDelegateSlot = "Delegate";
            //bDelegate = Me.SubFunction.bLocalDelegateOrEvent  = true;
         //   bLocalSub = false;
#elif defined DROIDBASIC

          } else if (parseTerm("Signal")){
            if (bProperty){ error("Signal with Property not allowed"); return false; }
            sSubFunctionIBActionActionSignalEventDelegateSlot = "Signal";

#endif // Q7BASIC_OBJB

          } else if (parseTerm("Event")){
            if (bProperty){ error("Event with Property not allowed"); return false; }
            /*
            if (bClass){
              { error("Event with Class not allowed"); return false; }
            }
            */
            sSubFunctionIBActionActionSignalEventDelegateSlot = "Event";
            //bEvent = Me.SubFunction.bLocalDelegateOrEvent = true;
            //Me.SubFunction.bLocalSub = false;

          } else if (parseTerm("Function")){
            sSubFunctionIBActionActionSignalEventDelegateSlot = "Function";
            //if (bDeclare && bPrivate){ error("Declare Function cannot be private. It is always public."); return false; }
            //Me.SubFunction.bLocalSub = false;
          } else {
          //  bool bIBOutlet = false;
            /*
            if (bClass){
              { error("Class not allowed in this context"); return false; }
            } 
            */

            if (parseTerm("Enum")){

              if (bProperty){ error("Enum with Property not allowed"); return false; }

              QString sIdentifier;

              //if (bDeclare && bPrivate){ error("Declare Enum cannot be private. It is always public."); return false; }
              if (bDeclare){
/*
                QString sFramework;
                if (!parseString(&sFramework)){ error("Name of framework expected"); return false; }
                sFramework = plainString(sFramework);
*/
                if (!parseIdentifier(&sIdentifier)){ error("Name of enum expected"); return false; }
                //sIdentifier = plainString(sIdentifier);

                if (isCppObjcKeyword(sIdentifier, "Name of enum")) return false;

                QString sConstType = DEFAULTTYPE;
                QString sConstTypeL;
                QString sConstTypeR;
                _type Type;
                if (!parseTerm("As")){ error("As expected"); return false; }
                if (!parseAllType(&sConstType, &sConstTypeL, &sConstTypeR, &Type)){ error(""); return false; }
                Compiler::addReference(getFileNameForClass(sConstType));

                if (!parseTerm("{")){ error("{ expected"); return false; } 

                QStringList EnumNames;

                QString sConst;
                if (!parseIdentifier(&sConst)){ error("at least one Const missing"); return false; }             
                
                if (parseTerm(",")){ 
                  do {

                    if (isCppObjcKeyword(sConst, "Name of enum const")) return false;

                    EnumNames << sConst;                   

                    if (!parseIdentifier(&sConst)){ error("Name of enum element expected"); return false; }

                  } while (parseTerm(","));
                }

                if (!parseTerm("}")){ error("} expected"); return false; } 

                if (parseTerm(";")){ /*error("; expected"); return false;*/ }

                if (!parseReturn()){ error(""); return false; }

                addDeclareEnum(sIdentifier, sConstType, EnumNames);

              } else {
 
                QStringList EnumNames;
                QList<_statements> EnumValues;

                if (!parseIdentifier(&sIdentifier)){ error("identifier expected"); return false; }

                if (isCppObjcKeyword(sIdentifier, "Name of enum")) return false;

                QString sEnumType = "Integer";
                QString sEnumTypeL;
                QString sEnumTypeR;
                _type Type;
                if (parseTerm("As")){ 
                  if (!parseAllType(&sEnumType, &sEnumTypeL, &sEnumTypeR, &Type)){ error(""); return false; }            
                  if (convertType(sEnumType) != "Integer"){ error("enum type name must be an Integer type"); return false; }            
                  Compiler::addReference(getFileNameForClass(sEnumTypeL));
                }

                if (!parseReturn()){ error(""); return false; }

                while (parseReturn());

                QString sConst;
                if (!parseIdentifier(&sConst)){ error("at least one Const missing"); return false; }             
                
                int nCounter = 0;
                
                Me.sParsingPreviousValidEnumName = sIdentifier;

                do {            

                  if (isCppObjcKeyword(sConst, "Name of enum const")) return false;

                  EnumNames << sConst;                  

                  if (parseTerm("=")){ 
                    _expressions Expression;                   
                    if (!parseExpressionInteger(Expression)){ error(""); return false; }                      
                    EnumValues << Expression.Statements;
                  } else {
                    EnumValues << Compiler::pushInteger(nCounter);
                  }

                  if (!parseReturn()){ error(""); return false; }                  

                  while (parseReturn());

                  nCounter++;
                } while (parseIdentifier(&sConst));

                Me.sParsingPreviousValidEnumName = "";                

                if (!parseUntilNextProcecure("End", "Enum")){ error("'End Enum' missing"); return false; }
                
                if (!parseTerm("End")){ error(""); return false; }
                if (!parseTerm("Enum")){ error("'End Enum' expected"); return false; }

                if (Me.nPass == 0){
                  if (existsAllType(sIdentifier)){ error("Enum must not be named like existing type"); return false; }                  
                }

                addEnumType(Me.sFileName, sIdentifier, Me.sPublicPrivateGlobal, EnumNames, EnumValues);

                continue;
              }
                  
              continue;

            } else if (parseTerm("Type")){
              if (bProperty){ error("Type with Property not allowed"); return false; }

              QString sIdentifier;

              QStringList names;
              QStringList types;
              QList<int> sizes;
              QStringList encodings;              

              if (!parseIdentifier(&sIdentifier)){ error("identifier expected"); return false; }

              if (sIdentifier == "type4"){
                sIdentifier = sIdentifier;
              }

              if (existsAllType(sIdentifier)){ error("Type must not be named like existing type"); return false; }                  

              if (isCppObjcKeyword(sIdentifier, "Name of type")) return false;

              if (!parseReturn()){ error(""); return false; }    
              
              while (parseReturn()); 

              QString sField;
              if (!parseIdentifier(&sField)){ error("at least one field missing"); return false; }             
                            
              QList<_array> arrays;
              
              do {   

                 if (isCppObjcKeyword(sField, "Name of field type")) return false;

                  _array Array = parseArrayDimReDim(false);

                  arrays << Array;
                  names << sField;               

                  QString sFieldType = DEFAULTTYPE;
                  if (parseTerm("As")){ 
                /*
                      if (nCurrentLine == 15){
                        nCurrentLine = nCurrentLine;
                      }   */

                    if (Me.nPass == 0){

                      if (parseTerm("Global")){
                        sFieldType = "Global";
                        if (!peekTerm(".")){ error(". expected"); return false; }            
                      } else if (!parseIdentifier(&sFieldType)){ error("type name expected"); return false; }            

                      if (parseTerm(".")){
                        QString sFieldType2;
                        if (!parseIdentifier(&sFieldType2)){ error("type name expected"); return false; }            
                        types << sFieldType + "." + sFieldType2;
                      } else {
                        types << sFieldType;
                      }

                    } else {
                      // check type for validation in Me.nPass == 1, because type must be already known for statements

                      QString sFieldTypeL;
                      QString sFieldTypeR;
                      _type FieldType;

                      if (sField == "d2"){
                        sField = sField;
                      }
                      if (!parseAllType(&sFieldType, &sFieldTypeL, &sFieldTypeR, &FieldType)){ error(""); return false; }            
                      Compiler::addReference(getFileNameForClass(sFieldTypeL));

                    }
                  } else {
                    types << sFieldType;
                  }
                  if (parseTerm("*")){
                    QString sNumber;
                    if (parseNumber(&sNumber)){ 
                      sizes << sNumber.toInt();
                    } else {
                      sizes << -1;
                    }
                  } else {
                    sizes << -1;
                  }                  

                  if (sFieldType == "String"){
                    QString sString;
                    if (parseString(&sString)){ 
                      encodings << sString;                    
                    } else {
                      encodings << "";                    
                    }                                      
                  } else {
                    encodings << "";                    
                  }

                
                  if (!parseReturn()){ error(""); return false; }       

                  while (parseReturn());                  
                
              } while (parseIdentifier(&sField));                           

              if (!parseUntilNextProcecure("End", "Type")){ error("'End Type' missing"); return false; }
              
              if (!parseTerm("End")){ error(""); return false; }
              if (!parseTerm("Type")){ error("'End Type' expected"); return false; }

              addTypeType(Me.sFileName, sIdentifier, Me.sPublicPrivateGlobal, names, types, arrays, sizes, encodings);
                  
              continue;

            } else if (parseTerm("Class")){
              if (bProperty){ error("Class with Property not allowed"); return false; }

              QString sIdentifier;

              if (bDeclare){

                if (!parseString(&sIdentifier)){ error("Name of class expected"); return false; }

                if (Parser::Me.controls.contains(sIdentifier)){ error("Class must be of a built-in object type"); return false; }                  

           //     if (Me.nPass == 0){
            //      if (existsAllType(sIdentifier)){ error("Class must not be named like existing type"); return false; }                  
             //   }

                QString sSuperClass = DEFAULTCLASS;

                if (parseTerm("SuperClass")){
                  if (!parseString(&sSuperClass)){ error("Name of super class expected"); return false; }                                      
                }

                if (parseTerm("SuperClass")){
                  if (!parseString(&sSuperClass)){ error("Name of super class expected"); return false; }                                      
                }

               QString sDoImport; // for custom objc classes the import statement is needed in objc code later
#ifdef Q7BASIC
#elif defined OBJB                
                if (parseString(&sDoImport)){  }                    
#elif defined DROIDBASIC
#endif // Q7BASIC_OBJB

                if (Me.nPass == 0){
                  if (Parser::Me.controls.contains(sSuperClass)){ error("Super class must not be of a built-in object type"); return false; }
                  if (!existsAllType(sSuperClass)){ error("Super class must be an existing type"); return false; }                  


                    Me.DeclareClasses[sIdentifier] = sSuperClass;
                    Me.DeclareClassesFileName[sIdentifier] = Me.sFileName;
                    Me.DeclareClassesImport[sIdentifier] = sDoImport;

                    if (!Me.classes.contains(sIdentifier)){ // do add only if not built-in
                      Me.DeclareClassesDeclaredInClass[getClassName(Me.sFileName)] << sIdentifier;
                    }
                  }

                if (!parseReturn()){ error(""); return false; }

              } else {
 
                  { error(""); return false; }
              }

              continue;
#ifdef Q7BASIC
#elif defined OBJB

            } else if (bDeclare && parseTerm("Framework")){
              if (bProperty){ error("Framework with Property not allowed"); return false; }

              QString sIdentifier;              

                if (!parseString(&sIdentifier)){ error("Name of framework expected"); return false; }

                QString sImport;

                  if (parseString(&sImport)){
                  }

                 if (!parseReturn()){ error(""); return false; }

                if (Me.nPass == 0){
                  //sIdentifier = plainString(sIdentifier);
                  if (!Compiler::Me.OBJB_allFrameworks.contains(sIdentifier)) Compiler::Me.OBJB_allFrameworks[sIdentifier] = sImport;
                  /*
                  QString sImport;
                  if (!parseUntil("\n", "", &sImport)){ error(""); return false; }

                  if (!Compiler::Me.OBJB_allFrameworks.contains(sImport)) Compiler::Me.OBJB_allFrameworks.append(sImport);
*/
                } else {
                  /*
                  if (!parseUntil("\n")){ error(""); return false; }
                  if (!parseReturn()){ error(""); return false; }*/
               }
              continue;
#elif defined DROIDBASIC
#endif // Q7BASIC_OBJB

            } else if (parseClassConst(ClassStatements, bDeclare)){
              continue;

            } else if (parseClassDimOutlet(ClassStatements, bDeclare)){
              continue;

          }

         }

          if (!Me.bError){
            if (bDeclare){ 

              bool bStatic = false;
              if (parseTerm("Static")){
                bStatic = true;
              }
      
              if (!parseDeclareSubFunction(sSubFunctionIBActionActionSignalEventDelegateSlot, bStatic)) return false;
              continue;
            }

            QString sName;
            QString sType;
            _array Array;
/*
            if (Me.nPass == 1){
              Me.nPass = Me.nPass;
            }*/
            bool bSet = false;
            bool bGet = false;
            if (bProperty){
              if (parseTerm("Set")){ 
                bSet = true; 
              } else if (parseTerm("Get")){ 
                bGet = true; 
              } else {
                error("Name of property procedure must start with 'Set' or 'Get'"); return false; 
              }
              
            }
            
            if (!parseIdentifier(&sName)){ error("identifier expected"); return false; }

            if (bSet){
              sName = "Set" + sName;
            } else if (bGet){
              sName = "Get" + sName;
            }

            /*
            if (sSub == "on_actionQt_Reference_Documentation_triggered"){
              sSub = sSub;
            }*/
            if (sName.startsWith("_")){ error("Name of procedure must not start with '_'"); return false; }

          if (Me.SubsFunctions[getClassName(Me.sFileName)].contains(sName)){
            Me.SubFunction = Me.SubsFunctions[getClassName(Me.sFileName)][sName];
          } else if (Me.GlobalSubsFunctions.contains(sName)){ 
            Me.SubFunction = Me.GlobalSubsFunctions[sName];
          }
          
          Me.SubFunction.sFileName = Me.sFileName;

          Me.SubFunction.bProperty = bProperty;
       //   Me.SubFunction.bDeclare = bDeclare;

            Me.SubFunction.sName = sName;
            if (!parseTerm("(")){ error("( expected"); return false; }          

            QString sArgument;
            if (parseIdentifier(&sArgument)){  

              Me.SubFunction.Arguments.clear();

              _argument Argument;
              Argument.sName = sArgument;

              bool bArray = false;
#ifdef Q7BASIC
              if ((bArray = parseTerm("["))){
                if (!parseTerm("]")){ error("] expected"); return false; }          
              }
#elif defined OBJB
#elif defined DROIDBASIC
#endif // Q7BASIC_OBJB

              QString sType;              
              QString sTypeL;              
              QString sTypeR;
              _type Type;

              if (parseTerm("As")){               
                if (!parseAllType(&sType, &sTypeL, &sTypeR, &Type)){ error(""); return false; }          
                Argument.sType = sType;        
                Argument.bIsPointer = false;
              } else if (parseTerm("AsRef")){ 
                if (!parseAllType(&sType, &sTypeL, &sTypeR, &Type)){ error(""); return false; }          
                Argument.sType = sType;              
                Argument.bIsPointer = true;
              } else {
                Argument.sType = DEFAULTTYPE;
                Argument.bIsPointer = false;
              }
              //Argument.Array.nCount = (bArray ? Q7B_MAX_ARRAYDIM + 1 : 0);
              Argument.Array.bEmpty = true;

              Me.SubFunction.Arguments.append(Argument);
                     
              while (parseTerm(",")){
                Argument = _argument();

                if (!parseIdentifier(&sArgument)){ error(""); return false; }  
  
                bool bArray = false;
#ifdef Q7BASIC
                if ((bArray = parseTerm("["))){
                  if (!parseTerm("]")){ error("] expected"); return false; }          
                }
#elif defined OBJB
#elif defined DROIDBASIC
#endif // Q7BASIC_OBJB

                Argument.sName = sArgument;
                if (parseTerm("As")){ 
                  if (!parseAllType(&sType, &sTypeL, &sTypeR, &Type)){ error(""); return false; }          
                  Argument.sType = sType;                  
                  Argument.bIsPointer = false;
                                  
                } else if (parseTerm("AsRef")){ 
                  if (!parseAllType(&sType, &sTypeL, &sTypeR, &Type)){ error(""); return false; }          
                  Argument.sType = sType;                  
                  Argument.bIsPointer = true;
                                  
                } else {
                  Argument.sType = DEFAULTTYPE;
                  Argument.bIsPointer = false;
                                 
                }
                //Argument.Array.nCount = (bArray ? Q7B_MAX_ARRAYDIM + 1 : 0);
                Argument.Array.bEmpty = true;
              
                Me.SubFunction.Arguments.append(Argument);
              }            
            }

            if (!parseTerm(")")){ error(""); return false; }            

            if (sName == "GetAll"){
                sName=sName;
                 }

            if ( sSubFunctionIBActionActionSignalEventDelegateSlot == "Function" 
              || sSubFunctionIBActionActionSignalEventDelegateSlot == "Event"
              || sSubFunctionIBActionActionSignalEventDelegateSlot == "Delegate"
            ){
              if (parseTerm("As")){
              //  QString sType;
                QString sTypeL;              
                QString sTypeR;
                _type Type;
                if (!parseAllType(&sType, &sTypeL, &sTypeR, &Type)){ error(""); return false; }     
                Array = parseArrayDimReDim(true);

              }
            }

            if (!parseReturn()){ error(""); return false; }

            bool bHasReturnType = !sType.isEmpty();
            Me.SubFunction.sType = sType;

            if (!bHasReturnType && //Me.SubFunction.sName != "Init" && Me.SubFunction.sName != "Finalize" &&
              (
               sSubFunctionIBActionActionSignalEventDelegateSlot == "Function"
         //   || sSubFunctionIBActionActionSignalEventDelegateSlot == "Event"
         //   || sSubFunctionIBActionActionSignalEventDelegateSlot == "Delegate"
            )
            ){
              Me.SubFunction.sType = DEFAULTTYPE;
            }

            Me.SubFunction.sPublicPrivateGlobal = Me.sPublicPrivateGlobal;
            Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot = sSubFunctionIBActionActionSignalEventDelegateSlot;

            _statements Statements;
            if (Me.nPass == 0){


             // QString sdaf = Me.sFileName + Me.SubFunction.sName;
              if (!parseUntilNextProcecure("End", sSubFunctionIBActionActionSignalEventDelegateSlot)){ error("'End " + sSubFunctionIBActionActionSignalEventDelegateSlot + "' missing"); return false; }

            } else {
         
              Statements << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("0")) << Compiler::push(";");         
        
              Me.SubFunction.bExitFunctionUsed = false;
              Me.SubFunction.ExitFunctionVariable.sFileName = Me.SubFunction.sFileName;
              Me.SubFunction.ExitFunctionVariable.sName = Me.SubFunction.sName;
              Me.SubFunction.ExitFunctionVariable.sType = Me.SubFunction.sType;     

              if (!parseStatements(Statements)){ error(""); return false; }

              bool bHasReturnType = !Me.SubFunction.sType.isEmpty();

              if (              
                Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot == "Function"
                || ((bHasReturnType && Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot == "Event")
                || (bHasReturnType && Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot == "Delegate"))
              ){
                Statements << Compiler::push("Return ?", Compiler::pushNull());
              }


              Statements << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("2")) << Compiler::push(";");

              if (Me.SubFunction.bExitFunctionUsed){
          
                _statements Expression;
                _statements Array;
                bool bStatic = false;
                bool bType = false;

                _statements StatementsSAVE = Statements;
                Statements.clear();
                Statements << (Compiler::push("Local Dim", Compiler::pushIdentifier(PREFIX + Me.SubFunction.ExitFunctionVariable.sName), Compiler::pushIdentifier(Me.SubFunction.ExitFunctionVariable.sType), Compiler::pushExpression(Expression), Compiler::pushExpression(Array), Compiler::pushIdentifier(bStatic ? "true" : "false"), Compiler::pushBoolean(bType)));          

                Statements << StatementsSAVE;
          
              }           

            }
            
            if (!parseTerm("End")){ error(""); return false; }
        
            if (!parseTerm(sSubFunctionIBActionActionSignalEventDelegateSlot)){ error("'End " + sSubFunctionIBActionActionSignalEventDelegateSlot + "' expected"); return false; }
            //int kljk = Me.nLine;
            addSubFunction(sSubFunctionIBActionActionSignalEventDelegateSlot, Me.sFileName, sName, Statements, Me.sPublicPrivateGlobal, Me.SubFunction.Arguments, Me.SubFunction.sType, Array);

            _statements Arguments;

            for (int i = 0; i < Me.SubFunction.Arguments.size(); i++){
              _argument Argument = Me.SubFunction.Arguments.at(i);
              Arguments << Compiler::pushString(Argument.sName);
            }
       
            continue;
          }                
        

      }

      if (Me.nTokenPos != Me.tokens[Me.sFileName].size()){
        error(""); 
        return false;
      }
     
    }     

    Me.ClassStatements[getClassName(Me.sFileName)] = ClassStatements;
    
    return true;
}
