﻿
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use Expression source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/


#include "Q7BCompiler.h"

bool Parser::parseExpression(_expressions & Expression, bool bAllowNamedArguments)
{  
  if (bAllowNamedArguments && peekTerm(":=", 2)){
    QString sArgument;
    if (!parseIdentifier(&sArgument)){ error(""); return false; }                     
    if (!parseTerm(":=")){ error(":= expected"); return false; }           
  }

  bool bSave = Me.bOnlyFunction;
  Me.bOnlyFunction = true;

  if (parseOrElse(Expression)){

    Me.bOnlyFunction = bSave;
    return true; 
  }
  Me.bOnlyFunction = bSave;
  return false;
}

bool Parser::parseExpressionIntegerFloatDecimal(QString sExpressionType, QString sDummy){ return typeCompatible(sExpressionType, "Integer") || typeCompatible(sExpressionType, "Float") || typeCompatible(sExpressionType, "Decimal"); }

bool Parser::parseExpressionBoolean(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "Boolean"); }
bool Parser::parseExpressionInteger(_expressions & Expression){ bool b = parseExpression(Expression); return b && parseExpressionIntegerFloatDecimal(Expression.sType, "Integer"); }
bool Parser::parseExpressionFloat(_expressions & Expression){ bool b = parseExpression(Expression); return b && (parseExpressionIntegerFloatDecimal(Expression.sType, "Float")); }
bool Parser::parseExpressionString(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "String"); }
bool Parser::parseExpressionid(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "id"); }
bool Parser::parseExpressionList(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "Array"); }
bool Parser::parseExpressionDictionary(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "Dictionary"); }
bool Parser::parseExpressionData(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "Data"); }
bool Parser::parseExpressionDecimal(_expressions & Expression){ bool b = parseExpression(Expression); return b && parseExpressionIntegerFloatDecimal(Expression.sType, "Decimal"); }
bool Parser::parseExpressionDateTime(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "DateTime"); }

bool Parser::parseExpressionQWidget(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "QWidget"); }

bool Parser::parseExpressionRect(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "Rect"); }
bool Parser::parseExpressionPoint(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "Point"); }
bool Parser::parseExpressionLong(_expressions & Expression){ bool b = parseExpression(Expression); return b && parseExpressionIntegerFloatDecimal(Expression.sType, "Long"); }
bool Parser::parseExpressionByte(_expressions & Expression){ bool b = parseExpression(Expression); return b && parseExpressionIntegerFloatDecimal(Expression.sType, "Byte"); }
bool Parser::parseExpressionSingle(_expressions & Expression){ bool b = parseExpression(Expression); return b && parseExpressionIntegerFloatDecimal(Expression.sType, "Double"); }
bool Parser::parseExpressionDouble(_expressions & Expression){ bool b = parseExpression(Expression); return b && parseExpressionIntegerFloatDecimal(Expression.sType, "Double"); }
bool Parser::parseExpressionNSImage(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "NSImage"); }


bool Parser::parseExpressionNSView(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "NSView"); }
bool Parser::parseExpressionNSWindow(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "NSWindow"); }
bool Parser::parseExpressionNSDrawer(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "NSDrawer"); }
bool Parser::parseExpressionNSMenuItem(_expressions & Expression){ bool b = parseExpression(Expression); return b && typeCompatible(Expression.sType, "NSMenuItem"); }



bool Parser::parseCondition(_expressions & Expression)
{  
  bool bSave = Me.bOnlyFunction;
  Me.bOnlyFunction = true;

  if (parseOrElse(Expression)){
  
    Me.bOnlyFunction = bSave;
    return true; 
  }
  Me.bOnlyFunction = bSave;
  return false;
}

