﻿



/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/


#include "Q7BCompiler.h"


bool Parser::parseStatements(_statements & ReturnStatement, bool bOnlyOneStatement)
{  
  Me.nBlock++;

  int nCount = 0;
  
  while(Me.nTokenPos < Me.tokens[Me.sFileName].size()){
    nCount++;
    if (bOnlyOneStatement && nCount > 1) break;
    if (Me.bError) break;  

    QString token = getToken();

    if (token == "K\n"){ // new line
      Me.nTokenPos++;
      Me.nLine++;
      continue;
    }

    if (token == "K:"){
      Me.nTokenPos++;
      continue;
    }

    char c = token.at(0).toAscii();

    if (token.at(0) == 'C'){ // comment
      Me.nTokenPos++;
      continue;
    }

    if (c == 'K'){


        if (token == "K<objc>"){
          Me.nTokenPos++;
          QString sobjc;
          sobjc = Me.tokens[Me.sFileName].at(Me.nTokenPos).mid(1);

          Me.nTokenPos++;

          ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");
          ReturnStatement << Compiler::pushCode(sobjc);
          continue;
        }



   #ifdef Q7BASIC
   #elif defined OBJB

      if (parseTerm("Exception")){
        ///*CODE*/ Statements += addINFO();

        if (!parseTerm("(")){ error("( expected"); return false; }
        _expressions Expression; // name
        _expressions Expression2;  // reason
        if (!parseExpressionid(Expression)){ error(""); return false; }

        if (parseTerm(",")){
          if (!parseExpressionid(Expression2)){ error(""); return false; }
        } else Expression2.Statements << Compiler::pushCode("@\"\"");

        if (!parseTerm(")")){ error(") expected"); return false; }
        if (!parseReturn()){ error("new line expected"); return false; }

        ReturnStatement << Compiler::pushCode("OBJB_EXCEPTION(" + Compiler::decode(Expression.Statements) + ", " + Compiler::decode(Expression2.Statements) + ", @\"\");\n");
   
        ///*CODE*/ Statements += addINFO();
        continue;
      }

      if (parseTerm("Try")){
          if (!parseReturn()){ error("new line expected"); return false; }

          _statements Statements;
          if (!parseStatements(Statements)){ error(""); return false; }

          if (!parseTerm("Catch")){ error("'Catch' expected"); return false; }
          QString sIdentifier;
          QStringList identifiers;
          QList<_statements> statements;
          if (!parseIdentifier(&sIdentifier)){ error(""); return false; }
          identifiers << sIdentifier;
          if (!parseReturn()){ error("new line expected"); return false; }
          _statements Statements2;
          if (!parseStatements(Statements2)){ error(""); return false; }
          statements << Statements2;

          while (parseTerm("Catch")){
            sIdentifier = "";
            if (!parseIdentifier(&sIdentifier)){ error(""); return false; }
            identifiers << sIdentifier;
            if (!parseReturn()){ error("new line expected"); return false; }
            Statements2.clear();
            if (!parseStatements(Statements2)){ error(""); return false; }
            statements << Statements2;
          }                      
          bool bFinally = false;
          _statements FinallyStatements;
          if (parseTerm("Finally")){
            if (!parseReturn()){ error("new line expected"); return false; }
            if (!parseStatements(FinallyStatements)){ error(""); return false; }
            bFinally = true;
          }

          if (!parseTerm("End")){ error(""); break; }
          if (!parseTerm("Try")){ error("'End Try' expected"); return false; }
          if (!parseReturn()){ error("new line expected"); return false; }

          QString s;

          /*CODE*/ s += "@try{\n";
          /*CODE*/ s += Compiler::decode(Statements);

          for (int i = 0; i < identifiers.size(); i++){
            /*CODE*/ s += "}\n@catch (id " + identifiers.at(i) + ")\n";
            /*CODE*/ s += "{\n";
            _statements f = statements.at(i);
            /*CODE*/ s += Compiler::decode(f);
            /*CODE*/ s += "}\n";
          }         
          if (bFinally){
            /*CODE*/ s += "@finally\n";
            /*CODE*/ s += "{\n";
            /*CODE*/ s += Compiler::decode(FinallyStatements);
            /*CODE*/ s += "}\n";
          }

          ReturnStatement << Compiler::pushCode(s);

        ///*CODE*/ Statements += addINFO();
        continue;
      }

#elif defined DROIDBASIC

      if (parseTerm("Exception")){

        if (!parseTerm("(")){ error("( expected"); return false; }
        _expressions Expression; // name
        _expressions Expression2;  // reason
        if (!parseExpressionid(Expression)){ error(""); return false; }

        if (parseTerm(",")){
          if (!parseExpressionid(Expression2)){ error(""); return false; }
        } else Expression2.Statements << Compiler::pushCode("@\"\"");

        if (!parseTerm(")")){ error(") expected"); return false; }
        if (!parseReturn()){ error("new line expected"); return false; }

        ReturnStatement << Compiler::pushCode("DBA_EXCEPTION(" + Compiler::decode(Expression.Statements) + ", " + Compiler::decode(Expression2.Statements) + ", @\"\");\n");
           
        continue;
      }

      if (parseTerm("Try")){
          if (!parseReturn()){ error("new line expected"); return false; }

          _statements Statements;
          if (!parseStatements(Statements)){ error(""); return false; }

          if (!parseTerm("Catch")){ error("'Catch' expected"); return false; }
          QString sIdentifier;
          QStringList identifiers;
          QList<_statements> statements;
          if (!parseIdentifier(&sIdentifier)){ error(""); return false; }
          identifiers << sIdentifier;
          if (!parseReturn()){ error("new line expected"); return false; }
          _statements Statements2;
          if (!parseStatements(Statements2)){ error(""); return false; }
          statements << Statements2;

          while (parseTerm("Catch")){
            sIdentifier = "";
            if (!parseIdentifier(&sIdentifier)){ error(""); return false; }
            identifiers << sIdentifier;
            if (!parseReturn()){ error("new line expected"); return false; }
            Statements2.clear();
            if (!parseStatements(Statements2)){ error(""); return false; }
            statements << Statements2;
          }                      
          bool bFinally = false;
          _statements FinallyStatements;
          if (parseTerm("Finally")){
            if (!parseReturn()){ error("new line expected"); return false; }
            if (!parseStatements(FinallyStatements)){ error(""); return false; }
            bFinally = true;
          }

          if (!parseTerm("End")){ error(""); break; }
          if (!parseTerm("Try")){ error("'End Try' expected"); return false; }
          if (!parseReturn()){ error("new line expected"); return false; }

          QString s;

          /*CODE*/ s += "try{\n";
          /*CODE*/ s += Compiler::decode(Statements);

          for (int i = 0; i < identifiers.size(); i++){
            /*CODE*/ s += "}\ncatch (id " + identifiers.at(i) + ")\n";
            /*CODE*/ s += "{\n";
            _statements f = statements.at(i);
            /*CODE*/ s += Compiler::decode(f);
            /*CODE*/ s += "}\n";
          }         
          if (bFinally){
            /*CODE*/ s += "finally\n";
            /*CODE*/ s += "{\n";
            /*CODE*/ s += Compiler::decode(FinallyStatements);
            /*CODE*/ s += "}\n";
          }

          ReturnStatement << Compiler::pushCode(s);

        continue;
      }

#endif // Q7BASIC_OBJB

      if (Me.nLine == 168 && Me.sFileName == "Module2.QObject.q7b"){
          Me.nLine = Me.nLine;
        }

      if (parseTerm("If")){

        ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");          
        
        int ndfd = Me.nLine;

        if (Me.nLine == 564 && Me.sFileName == "MainWindow.QMainWindow.q7b"){
          Me.nLine = Me.nLine;
        }

        _expressions Expression;
        if (!parseCondition(Expression)){ error(""); return false; }
        if (!parseTerm("Then")){ error(""); return false; }
        bool bReturn = parseReturn();

        _statements Statements;
        if (!parseStatements(Statements, bReturn == false)){ error(""); return false; }

        ReturnStatement << Compiler::push("If", Expression.Statements, Statements);

_else:
        if (parseTerm("Else")){ 
          if (parseTerm("If")){
            _expressions Expression;
            if (!parseCondition(Expression)){ error(""); return false; }
            if (!parseTerm("Then")){ error(""); return false; }
            if (bReturn && !parseReturn()){ error("new line expected"); return false; }
            _statements Statements;
            if (!parseStatements(Statements, !bReturn)){ error(""); return false; }

            ReturnStatement << Compiler::push("Else If", Expression.Statements, Statements);

            goto _else;
          } else {

            _statements Statements;
            if (!parseStatements(Statements, !bReturn)){ error(""); return false; }

            ReturnStatement << Compiler::push("Else", Statements);

          }
        }

        ReturnStatement << Compiler::push("End If");

        bool bEnd = false;
        if (!(bEnd = parseTerm("End")) && bReturn){ error(""); return false; }
        if (!parseTerm("If") && (bEnd || bReturn)){ error("'End If' expected"); return false; }
        if (!parseReturn()){ error("new line expected"); return false; }
        
        continue;

      }

      if (!peekTerm(".", -1) && parseTerm("Select")){ // peekTerm: allow use of Select as non-keyword
          //peekTerm(".", -2);
          if (parseTerm("Case")){} // just provided for backward compatibility

          ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");

          _expressions Condition;

          if (!parseExpression(Condition)){ error(""); return false; }
          if (!parseReturn()){ error("new line expected"); return false; }

          while (parseReturn()){}
          
          _expressions Expression2;
          QMap<int, _expressions> conditions;
          QMap<int, _expressions> debugexpressions;
          QMap<int, QString> operators;

          QMap<int, _statements> statements;
          _statements DefaultStatements;
          _statements Statements;

          bool bCaseElseAllowed = false;

          bool bDefault = false;
          QMap<int, _expressions> to;
          
          int x = 0;

          while (parseTerm("Case")){

            int nCount = 0;     

            debugexpressions[x].Statements << Compiler::pushDebugAndAlso(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1"));

            QString sOperator = "EQUAL";

            if (parseTerm("Is")){ 

              if (parseTerm("=")){ sOperator = "EQUAL"; }
              else if (parseTerm("==")){
                sOperator = "EQUALEQUAL"; 
              } else if (parseTerm("===")){ 
                sOperator = "EQUALEQUALEQUAL"; } 

              else if (parseTerm("<>")){ sOperator = "UNEQUAL"; }
              else if (parseTerm(">")){ sOperator = "GREATER"; }
              else if (parseTerm("<")){ sOperator = "SMALLER"; }
              else if (parseTerm(">=")){ sOperator = "GREATEREQUAL"; }
              else if (parseTerm("<=")){ sOperator = "SMALLEREQUAL"; }
              else { error("=, <>, <, >, <= or >= missing"); return false; }
                
            }

            if (bCaseElseAllowed && parseTerm("Else")){ 
              if (!parseReturn()){ error("new line expected"); return false; }
              if (!parseStatements(DefaultStatements)){ error(""); return false; }              
              bDefault = true;
              break;
            }
            
            Expression2.Statements.clear();
            if (!parseExpression(Expression2)){ error(""); return false; }
            if (!typeCompatible(Condition.sType, Expression2.sType)){ error("types incompatible"); return false; }

            conditions[x].Statements << Compiler::pushExpression(Expression2.Statements);
            operators[x] = sOperator;
            
            if (parseTerm("To")){ 

              if (isStringType(Expression2.sType)){ error("String data type must not be used with 'To'"); return false; }

              Expression2.Statements.clear();
              if (!parseExpression(Expression2)){ error(""); return false; }
              if (!typeCompatible(Condition.sType, Expression2.sType)){ error("types incompatible"); return false; }
              to[x].Statements << Compiler::pushExpression(Expression2.Statements);

              if (isStringType(Expression2.sType)){ error("String data type must not be used with 'To'"); return false; }

            } else {
              to[x].Statements << _statements();

              while (parseTerm(",")){
                nCount++;

                to[x + nCount].Statements << _statements(); 
                debugexpressions[x + nCount].Statements << _statements(); 

                Expression2.Statements.clear();
                if (!parseExpression(Expression2)){ error(""); return false; }
                if (!typeCompatible(Condition.sType, Expression2.sType)){ error("types incompatible"); return false; }

                conditions[x + nCount].Statements << Compiler::pushExpression(Expression2.Statements);
                operators[x + nCount] = sOperator;
              }
              
            }
            bCaseElseAllowed = true;

            if (!parseReturn()){ error("new line expected"); return false; }
            Statements.clear();
            if (!parseStatements(Statements)){ error(""); return false; }            
            statements[x] << Statements;
            for (int mm = 0; mm < nCount; mm++){
              statements[x + 1 + mm] << Compiler::pushExpression(Statements);
            }
            x += nCount;
            x++;
          }                      
          if (bCaseElseAllowed == false){
            { error("Case statement missing"); return false; }
          }

          if (!parseTerm("End")){ error(""); break; }
          if (!parseTerm("Select")){ error("'End Select' expected"); return false; }
          if (!parseReturn()){ error("new line expected"); return false; }

          for (int i = 0; i < conditions.size(); i++){

            QString sId;
            if (i == 0){
              sId = "If";
            } else {
              sId = "Else If";
            }
            if (to[i].Statements.size() == 0){

              if (debugexpressions[i].Statements.size() == 0){
                ReturnStatement << Compiler::push(sId, Compiler::pushOperator(operators[i], Condition.Statements, conditions[i].Statements), statements[i]);
              } else {
                ReturnStatement << Compiler::push(sId, Compiler::pushOperator("DEBUG_ANDALSO", debugexpressions[i].Statements, Compiler::pushOperator(operators[i], Condition.Statements, conditions[i].Statements)), statements[i]);
              }
            } else {
              ReturnStatement << Compiler::push(sId, Compiler::pushOperator("DEBUG_ANDALSO", debugexpressions[i].Statements, Compiler::pushOperator("DEBUG_ANDALSO", Compiler::pushOperator("GREATEREQUAL", Condition.Statements, conditions[i].Statements), Compiler::pushOperator("SMALLEREQUAL", Condition.Statements, to[i].Statements))), statements[i]);
            }
          }

          if (bDefault){               
            ReturnStatement << Compiler::push("Else", DefaultStatements);
          }

          ReturnStatement << Compiler::push("End If");

        continue;
      }


      /*
      if (parseTerm("With")){
        
        QString sStatements;
        if (!parseStatements(&sStatements)){ error(""); return false; }            
        Statements += sStatements;            

        if (!parseTerm("End")){ error(""); break; }
        if (!parseTerm("With")){ error("'End With' expected"); return false; }
        if (!parseReturn()){ error("new line expected"); return false; }

        continue;
      }*/

      bool bWhile = false;
      if (parseTerm("Do") || (bWhile = parseTerm("While"))){
        ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");

        bool bUntil = false;
        if (bWhile || parseTerm("While") || (bUntil = parseTerm("Until"))){
          
          _expressions Condition;
          if (!parseCondition(Condition)){ error(""); return false; }
          if (!parseReturn()){ error("new line expected"); return false; }

          bool bSAVE = Me.SubFunction.bLocalLoop;
          Me.SubFunction.bLocalLoop = true;

          _statements Statements;
          if (!parseStatements(Statements)){ error(""); return false; }
          Me.SubFunction.bLocalLoop = bSAVE;
          if (bWhile){
            if (!parseTerm("End")){ error("'End While' missing"); return false; }
            if (!parseTerm("While")){ error("'End While' missing"); return false; }
          } else {
            if (!parseTerm("Loop")){ error("'Loop' missing"); return false; }
          }
          if (!parseReturn()){ error("new line expected"); return false; }

          if (bUntil){
            ReturnStatement << Compiler::push("Do Until ? ... Loop", Condition.Statements, Statements);
            ReturnStatement << Compiler::push("End Do Until ? ... Loop");
          } else {
            ReturnStatement << Compiler::push("Do While ? ... Loop", Condition.Statements, Statements);
            ReturnStatement << Compiler::push("End Do While ? ... Loop");
          }

        } else {
          if (!parseReturn()){ error("new line expected"); return false; }
          bool bSAVE = Me.SubFunction.bLocalLoop;
          Me.SubFunction.bLocalLoop = true;
          _statements Statements;
          if (!parseStatements(Statements)){ error(""); return false; }
          Me.SubFunction.bLocalLoop = bSAVE;
          if (!parseTerm("Loop")){ error(""); return false; }
          if (!(bUntil = parseTerm("Until"))){ 
            if (!parseTerm("While")){ error("'While' expected"); return false; }
          }
          _expressions Condition;
          if (!parseCondition(Condition)){ error(""); return false; }
          if (!parseReturn()){ error("new line expected"); return false; }

          if (bUntil){
            ReturnStatement << Compiler::push("Do ... Loop Until ?");
            ReturnStatement << Compiler::push("End ... Do Loop Until ?", Condition.Statements, Statements);
          } else {
            ReturnStatement << Compiler::push("Do ... Loop While ?");
            ReturnStatement << Compiler::push("End ... Do Loop While ?", Condition.Statements, Statements);
          }

        }

        continue;
      }
    

      if (parseTerm("For")){
        ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");
        _statements DebugInfo;
        DebugInfo << Compiler::pushDebugAndAlso(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1"));

          ///*CODE*/ Statements += addINFO();
        //if (parseTerm("Each"))
        
          /*
          QString sVariable;
          QString sType;
          if (!parseVariable(&sVariable, &sType)){ error("variable expected"); return false; }
          // TODO2 check auf variablen typ, nur bestimmte d�rfen FOR EACH verwenden
          if (!parseTerm("In")){ error("'In' expected"); return false; }
          _statements sExpression;
          if (!parseExpression(&sExpression)){ error(""); return false; }
          if (!parseReturn()){ error("new line expected"); return false; }

          bool bSAVE = Me.SubFunction.bLocalLoop;
          Me.SubFunction.bLocalLoop = true;
          QString sStatements;
          if (!parseStatements(&sStatements)){ error(""); return false; }
          Me.SubFunction.bLocalLoop = bSAVE;

          / *CODE* / Statements += "foreach(; in " + sExpression + ";){\n";
          / *CODE* / Statements += sStatements;
          / *CODE* / Statements += "}\n";
*/
        //} else {
          _variableconstant Variable;
          _statements VariableStatements;
          _statements Dummy;
          if (!parseVariable(VariableStatements, Variable, Dummy)){ error("variable expected"); return false; }

          if (convertType(Variable.sType) != "Integer"){ error("counter variable must be of type 'Integer'"); return false; }
          if (!parseTerm("=")){ error("= expected"); return false; }
          _expressions Expression;
          if (!parseExpression(Expression)){ error(""); return false; }
          if (!typeCompatible(Variable.sType, Expression.sType)){ error("types incompatible"); return false; }

          //bool bTill = false;
          //if (!(bTill = parseTerm("Till"))){ 
            if (!parseTerm("To")){ error("'To' expected"); return false; }
          //}
          _expressions Expression2;
           if (!parseExpression(Expression2)){ error(""); return false; }
          if (!typeCompatible(Variable.sType, Expression2.sType)){ error("types incompatible"); return false; }
      
          _expressions Expression3;

          bool bStep = false;
          if ((bStep = parseTerm("Step"))){                        
            if (!parseExpression(Expression3)){ error(""); return false; }
            if (!typeCompatible(Variable.sType, Expression3.sType)){ error("types incompatible"); return false; }
        //    QString sdf = Compiler::decode(Expression3.Statements);
        //    sdf = sdf;

          } else {
            Expression3.Statements = Compiler::pushInteger(1);
          }

          _expressions Expression4;
          Expression4.Statements = Compiler::pushInteger(0);

          if (!parseReturn()){ error("new line expected"); return false; }

          bool bSAVE = Me.SubFunction.bLocalLoop;
          Me.SubFunction.bLocalLoop = true;
          _statements Statements;
          if (!parseStatements(Statements)){ error(""); return false; }
          Me.SubFunction.bLocalLoop = bSAVE;

          if (convertType(Variable.sType) != "Integer"){ error("'For Next' variable must be of an 'Integer' type"); return false; }
              
            //          if (bTill){

             _statements Assignment; Assignment << Compiler::push("Assignment", VariableStatements, Expression.Statements, Compiler::pushIdentifier(Variable.sType)) << Compiler::push(";");
             _statements Increment = Compiler::pushOperator("DEBUG_ANDALSO", DebugInfo, Compiler::push("Assignment", VariableStatements, Compiler::pushOperator("ADD", VariableStatements, Expression3.Statements), Compiler::pushIdentifier(Variable.sType)));

             _statements Test;
             if (bStep){            
               Test << Compiler::push("IIf", Compiler::pushOperator("GREATEREQUAL", Expression3.Statements, Expression4.Statements), Compiler::pushOperator("SMALLEREQUAL", VariableStatements, Expression2.Statements), Compiler::pushOperator("GREATEREQUAL", VariableStatements, Expression2.Statements));
             } else {
               Test << Compiler::pushOperator("SMALLEREQUAL", VariableStatements, Expression2.Statements);
             }

             if (Statements.size() > 0){
               ReturnStatement << Compiler::push("For", VariableStatements, Assignment, Test, Compiler::pushExpression(Increment), Statements);
               ReturnStatement << Compiler::push("Next");
             }

        if (!parseTerm("Next")){ error("'Next' missing"); return false; }

        QString sVariable2;
	      QString sType2;
        //int nArrayCount2;
        //int nTypeIndex2;
        QStringList ArrayExpression2;

        _variableconstant Variable2;
        _statements Dummy2;
        if (parseVariable(VariableStatements, Variable2, Dummy2)){
          if (Variable2.sName != Variable.sName || Variable2.sType != Variable.sType){          
            { error("variable loop index different"); return false; }
          }
        }

        if (!parseReturn()){ error("new line expected"); return false; }

        continue;
      }

      if (parseTerm("Break")){

        ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");

        if (!Me.SubFunction.bLocalLoop){ error("'Break' must be used inside a loop"); return false; }

        ReturnStatement << Compiler::push("Break");
        continue;
      }

      if (peekTerm("For", 1) && parseTerm("Exit") && parseTerm("For")){

        ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");

        if (!Me.SubFunction.bLocalLoop){ error("'Exit For' must be used inside a loop"); return false; }

        ReturnStatement << Compiler::push("Break");
        continue;
      }

      if (peekTerm("Do", 1) && parseTerm("Exit") && parseTerm("Do")){

        ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");

        if (!Me.SubFunction.bLocalLoop){ error("'Exit Do' must be used inside a loop"); return false; }

        ReturnStatement << Compiler::push("Break");
        continue;
      }


      if (parseTerm("Continue")){

        ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");

        if (!Me.SubFunction.bLocalLoop){ error("'Continue' must be used inside a loop"); return false; }

        ReturnStatement << Compiler::push("Continue");
        continue;
      }

      if (peekTerm("For", 1) && parseTerm("Iterate") && parseTerm("For")){

        ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");

        if (!Me.SubFunction.bLocalLoop){ error("'Iterate For' must be used inside a loop"); return false; }

        ReturnStatement << Compiler::push("Continue");
        continue;
      }

      if (peekTerm("Do", 1) && parseTerm("Iterate") && parseTerm("Do")){

        ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");

        if (!Me.SubFunction.bLocalLoop){ error("'Iterate Do' must be used inside a loop"); return false; }
        
        ReturnStatement << Compiler::push("Continue");
        continue;
      }

      
      if (Me.nLine == 2460){
        Me.nLine = Me.nLine;
      }



      bool bExit = false;
      if (parseTerm("Return") || (bExit = parseTerm("Exit"))){

        ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");

        if (bExit){
          if (Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot == "Event"){
            if (!parseTerm("Event")){ error(""); return false; } 
          } else if (Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot == "Signal"){
            if (!parseTerm("Signal")){ error(""); return false; } 
          } else if (Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot == "Sub"){
            if (!parseTerm("Sub")){ error(""); return false; } 
          } else {
            if (!parseTerm("Function")){ error("'Function' missing"); return false; } 

            Me.SubFunction.bExitFunctionUsed = true;    

            ReturnStatement << Compiler::push("Exit Function");

            continue;
          }

          ReturnStatement << Compiler::push("Return");

          continue;
        }

        if (
          Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot != "Function"
          && Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot != "Event"
          && Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot != "Delegate"
        ){

          ReturnStatement << Compiler::push("Return");
          _expressions Expression;
          if (parseExpression(Expression)){ 
            error(""); return false; 
          }
          continue;

        } else {


            if (Me.nLine == 2460){
              Me.nLine = Me.nLine;
            }


          _expressions Expression;
          if (!parseExpression(Expression)){ 
            if (              
              Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot == "Signal"
              || Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot == "Event"
              || Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot == "Delegate"
              ){ // delegate and event might return nothing or return something

              ReturnStatement << Compiler::push("Return");
              continue;

             } else {
                error(""); return false; 
             }
          }

          bool bHasReturnType = !Me.SubFunction.sType.isEmpty();
          if (bHasReturnType){
            if (!typeCompatible(Me.SubFunction.sType, Expression.sType)){ error("types incompatible"); return false; }
          }
          ReturnStatement << Compiler::push("Return ?", Expression.Statements);

        }

        continue;
      }

      if (parseTerm("GoTo")){

        ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");          
        
        QString sIdentifier;
        if (!parseIdentifier(&sIdentifier)){ error("identifier expected"); return false; }

        if (isCppObjcKeyword(sIdentifier, "Name for GoTo")) return false;

        ReturnStatement << Compiler::push("GoTo", Compiler::pushIdentifier(sIdentifier));

        Me.SubFunction.GoTos << _label(sIdentifier, Me.nLine);

        if (!parseReturn()){ error(""); return false; }

        continue;
      }

      if (parseTerm("IIf")){

        ReturnStatement << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");          
        
        if (!parseTerm("(")){ error("'(' expected"); return false; }
        _expressions Condition;
        if (!parseCondition(Condition)){ error(""); return false; }
        if (!parseTerm(",")){ error("',' expected"); return false; }

        _statements Statements;
        _statements AllStatements;
        do {
          if (!parseStatements(Statements, true)){ error(""); return false; }
          AllStatements << Statements;
        } while (parseReturn(true));

        if (!parseTerm(",")){ error("',' expected"); return false; }

        _statements Statements2;
        _statements AllStatements2;
        do {
          if (!parseStatements(Statements2, true)){ error(""); return false; }
          AllStatements2 << Statements2;
        } while (parseReturn(true));

        if (!parseTerm(")")){ error("')' expected"); return false; }
        if (!parseReturn()){ error("new line expected"); return false; }

        ReturnStatement << Compiler::push("If", Condition.Statements, Statements);
        ReturnStatement << Compiler::push("Else", Statements2);
        ReturnStatement << Compiler::push("End If");

        continue;                    
      }
    }
    
    if (peekIdentifier(0) && peekTerm(":", 1) && peekReturn(2)){

      QString sIdentifier;
      if (!parseIdentifier(&sIdentifier)){ error("identifier expected"); return false; }

      if (isCppObjcKeyword(sIdentifier, "Name for label")) return false;

      if (!parseTerm(":", true)){ error(""); return false; }
      if (!parseReturn()){ error(""); return false; }

      Me.SubFunction.Labels << _label(sIdentifier, Me.nLine);

      ReturnStatement << Compiler::push("Label", Compiler::pushIdentifier(sIdentifier));

      continue;
    }

    _statements DebugInfo;
    DebugInfo << Compiler::pushDebug(Compiler::pushIdentifier(Me.sFileName), Compiler::pushIdentifier(Me.SubFunction.sName), Compiler::pushIdentifier(QString("%1").arg(Me.nLine)), Compiler::pushIdentifier("1")) << Compiler::push(";");          

    _statements StatementsSAVE = ReturnStatement;
    ReturnStatement.clear();
    _statements Statements2 = _statements();
    
    if (parseLocalConst(Statements2)){ 
      ReturnStatement << StatementsSAVE << DebugInfo << Statements2;
      continue; 
    }

    if (parseLocalDim(Statements2)){ 
      ReturnStatement << StatementsSAVE << DebugInfo << Statements2;
      continue; 
    }

    if (parseAssignment(Statements2)){ 
      ReturnStatement << StatementsSAVE << DebugInfo << Statements2;
      continue; 
    }

    if (parseFactor(Statements2)){
      ReturnStatement << StatementsSAVE << DebugInfo << Statements2;
      continue; 
    }


    ReturnStatement << StatementsSAVE << Statements2;

    break;
  }  

  // check if all gotos has valid labels inside procedure  
  for (int qz = 0; qz < Me.SubFunction.GoTos.count(); qz++){
    if (!Me.SubFunction.Labels.contains(Me.SubFunction.GoTos.at(qz))){
      { error("Label " + Me.SubFunction.GoTos.at(qz).sName + " has not been declared in line " + Me.SubFunction.GoTos.at(qz).nLine); break; }
    }
  }

  // check if label by-pass dim/const
  for (int qz = 0; Me.bError == false && qz < Me.SubFunction.Labels.count() && qz < Me.SubFunction.GoTos.count(); qz++){
    if (Me.SubFunction.GoTos.at(qz).nLine < Me.SubFunction.Labels.at(qz).nLine && Me.SubFunction.GoTos.at(qz).sName == Me.SubFunction.Labels.at(qz).sName){
      for (int xx = 0; xx < Me.SubFunction.VariablesConstants.count(); xx++){
        if (Me.SubFunction.VariablesConstants.at(xx).nLine > Me.SubFunction.GoTos.at(qz).nLine && Me.SubFunction.VariablesConstants.at(xx).nLine < Me.SubFunction.Labels.at(qz).nLine){
          { error(QString("GoTo (in line %1) to label ").arg(Me.SubFunction.GoTos.at(qz).nLine) + Me.SubFunction.Labels.at(qz).sName + " by-passes declaration of " + Me.SubFunction.VariablesConstants.at(xx).sName + QString(" in line %1 in file %2\n").arg(Me.SubFunction.VariablesConstants.at(xx).nLine).arg(Me.sFileName)); return false; }
        }
      }

    }
  }
 
  return true;
}
