#ifndef BASICMETHODTRANSLATOR_H
#define BASICMETHODTRANSLATOR_H
#include <QMetaMethod>
#include <QStringList>
class BasicMethodTranslator
{
    QStringList fArgNames ;
    QStringList fArgTypes ;
    QString fName ;
    QMetaMethod::MethodType fType ;
    QString fRetType ;
public:
    BasicMethodTranslator( QMetaMethod  & method );
    BasicMethodTranslator( const BasicMethodTranslator &) ;
    QMetaMethod::MethodType type () ;
    QStringList argNames () ;
    QStringList argTypes () ;
    QString name() ;
    QString retType() ;
    static QList < BasicMethodTranslator > fromQObject(QObject * o) ;
    QHash < QString , QString > basicTypesTranslations ;
    static QString translateToBasicType ( QString type ) ;
    QString basicLangVariant () ;
    bool isSignal () ;
};

#endif // BASICMETHODTRANSLATOR_H
