/*
    Declaration of helper QResizebleSplitter class
*/

#ifndef QRESIZEBLESPLITTER_H
#define QRESIZEBLESPLITTER_H

#include <QSplitter>
#include <QSize>
#include <QVariantMap>
/*
    QResizebleSplitter is a QSplitter with two additional features:
    enlargeSectionHeight allows to enlarg section size by emitting
    signal from DesigningArea, which occupates this section,
    enlargeHeight signal is emitted when bottom section enlargement
    is needed.
*/
class QResizebleSplitter : public QSplitter
{
    Q_OBJECT
public :
    explicit QResizebleSplitter ( QWidget * parent = 0 ) ;
    QVariantMap positions ( ) ;
    void setPositions ( QVariantMap ) ;
signals :
    void enlargeHeight ( int d ) ;
public slots :

    void enlargeSectionHeight ( int d ) ;
protected :
private slots :
};

#endif // QRESIZEBLESPLITTER_H
