#include "Q7BHexEditWidget.h"

Q7BHexEditWidget::Q7BHexEditWidget(QWidget * parent):QHexEdit( parent )
{

}
bool Q7BHexEditWidget::loadFromFile( QString filename )
{
    QFile file( filename );
    if( ! file.open( QIODevice::ReadOnly ) )
        return false ;
    QByteArray data = file.readAll() ;
    setData( data ) ;
    return true ;
}

bool Q7BHexEditWidget::saveToFile( QString filename )
{
    QFile file( filename );
    if( ! file.open( QIODevice::WriteOnly ) )
        return false ;
    QByteArray d = data() ;
    file.write( d ) ;
    return file.error() == QFile::NoError ;
}

QString Q7BHexEditWidget::toHexString()
{
    return QString( data().toHex() ) ;
}

void Q7BHexEditWidget::fromHexString( QString s )
{
    setData( QByteArray::fromHex( s.toUtf8() ) ) ;
}

QString Q7BHexEditWidget::toString()
{
    return QString( data() ) ;
}

void Q7BHexEditWidget::fromString( QString s )
{
    setData( s.toUtf8() ) ;
}

int Q7BHexEditWidget::find( QByteArray s )
{
    int i = data().indexOf( s ) ;
    if( i == - 1 )
        return - 1 ;
    setPosition( i * 2 ) ;
    return i ;
}

int Q7BHexEditWidget::findHex( QString s )
{
    return find( QByteArray::fromHex( s.toUtf8() ) ) ;
}
