/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
' 
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/


#include "Q7BRuntime.h"

#ifndef Q_WS_MAC
  #include <QtUiTools>
#endif


Q7B Q7B_IDNIL(){ return Q7B_idnil; }
Q7B Q7B_IDNULL(){ return Q7B_idnil; }

Q7B_id::~Q7B_id()
{
  //return ; 

  if (!gc_enabled) return;

  if (q7b_array){
    delete q7b_array;
    q7b_array = 0;
  }

  if (q7b_type){
    delete q7b_type;
    q7b_type = 0;
  }

  if (q7b_properties){
    delete q7b_properties;
    q7b_properties = 0;
  }

  if (ref == 0) return;


  // QOBJECT vs. void * siehe auch ClassName()
  if (type == typeid(qint64).name()){
    delete (qint64 *) ref;

  } else if (type == typeid(bool).name()){
    delete (bool *) ref;

  } else if (type == typeid(QString).name()){
    delete (QString *) ref;

  } else if (type == typeid(qreal).name()){
    delete (qreal *) ref;

  } else if (type == typeid(Q7B_Decimal).name()){
    delete (Q7B_Decimal *) ref;

  } else if (type == typeid(Q7B_List).name()){
    delete (Q7B_List *) ref;

  } else if (type == typeid(Q7B_Dictionary).name()){
     delete (Q7B_Dictionary *) ref;


  } else if (type == typeid(QWidget).name()){
     // workaround for sometimes crash later qobject->isWidgetType()

  } else if (type == typeid(QAction).name()){
     // no delete needed

  } else if (type == typeid(QMenu).name()){
     // no delete needed

  } else if (type == typeid(QSystemTrayIcon).name()){
     // no delete needed, because it is fake if no custom QSystemTrayIcon file is present

  } else if (type == typeid(QApplication).name()){
     // no delete needed, because it is fake if no custom QApplication file is present

  } else if (type == typeid(QWebSettings).name()){
     // no delete needed, because it is not allowed by Qt/Compiler

    

  } else if (type == typeid(QDateTime).name()){
    delete (QDateTime *) ref;


  // Begin Generator h#2
  } else if (type == typeid(QAccessibleEvent).name()){

  } else if (type == typeid(QActionEvent).name()){

  } else if (type == typeid(QBitmap).name()){
     delete (QBitmap *) ref;

  } else if (type == typeid(QBoxLayout).name()){
     delete (QBoxLayout *) ref;

  } else if (type == typeid(QBrush).name()){
     delete (QBrush *) ref;

  } else if (type == typeid(QByteArray).name()){
     delete (QByteArray *) ref;

  } else if (type == typeid(QChar).name()){
     delete (QChar *) ref;

  } else if (type == typeid(QChildEvent).name()){

  } else if (type == typeid(QCloseEvent).name()){

  } else if (type == typeid(QColor).name()){
     delete (QColor *) ref;

  } else if (type == typeid(QContextMenuEvent).name()){
     delete (QContextMenuEvent *) ref;

  } else if (type == typeid(QCursor).name()){
     delete (QCursor *) ref;

  } else if (type == typeid(QDate).name()){
     delete (QDate *) ref;

  } else if (type == typeid(QDateTime).name()){
     delete (QDateTime *) ref;

  } else if (type == typeid(QDeclarativeContext).name()){
     delete (QDeclarativeContext *) ref;

  } else if (type == typeid(QDir).name()){
     delete (QDir *) ref;

  } else if (type == typeid(QDragLeaveEvent).name()){

  } else if (type == typeid(QDropEvent).name()){

  } else if (type == typeid(QDynamicPropertyChangeEvent).name()){

  } else if (type == typeid(QElapsedTimer).name()){
     delete (QElapsedTimer *) ref;

  } else if (type == typeid(QEvent).name()){

  } else if (type == typeid(QFileInfo).name()){
     delete (QFileInfo *) ref;

  } else if (type == typeid(QFileInfoList).name()){
     delete (QFileInfoList *) ref;

  } else if (type == typeid(QFileOpenEvent).name()){

  } else if (type == typeid(QFocusEvent).name()){

  } else if (type == typeid(QFont).name()){
     delete (QFont *) ref;

  } else if (type == typeid(QFontDatabase).name()){
     delete (QFontDatabase *) ref;

  } else if (type == typeid(QFontInfo).name()){
     delete (QFontInfo *) ref;

  } else if (type == typeid(QFontMetrics).name()){
     delete (QFontMetrics *) ref;

  } else if (type == typeid(QFormLayout).name()){
     delete (QFormLayout *) ref;

  } else if (type == typeid(QGraphicsSceneEvent).name()){

  } else if (type == typeid(QGridLayout).name()){
     delete (QGridLayout *) ref;

  } else if (type == typeid(QHBoxLayout).name()){
     delete (QHBoxLayout *) ref;

  } else if (type == typeid(QHelpEvent).name()){

  } else if (type == typeid(QHideEvent).name()){

  } else if (type == typeid(QHostAddress).name()){
     delete (QHostAddress *) ref;

  } else if (type == typeid(QHostInfo).name()){
     delete (QHostInfo *) ref;

  } else if (type == typeid(QHoverEvent).name()){

  } else if (type == typeid(QIcon).name()){
     delete (QIcon *) ref;

  } else if (type == typeid(QIconDragEvent).name()){

  } else if (type == typeid(QImage).name()){
     delete (QImage *) ref;

  } else if (type == typeid(QInputEvent).name()){

  } else if (type == typeid(QInputMethodEvent).name()){

  } else if (type == typeid(QKeySequence).name()){
     delete (QKeySequence *) ref;

  } else if (type == typeid(QLayout).name()){
     delete (QLayout *) ref;

  } else if (type == typeid(QLayoutItem).name()){
     delete (QLayoutItem *) ref;

  } else if (type == typeid(QLine).name()){
     delete (QLine *) ref;

  } else if (type == typeid(QList<QStringList>).name()){
     delete (QList<QStringList> *) ref;

  } else if (type == typeid(QListWidgetItem).name()){

  } else if (type == typeid(QLocalSocket).name()){
     delete (QLocalSocket *) ref;

  } else if (type == typeid(QLocale).name()){
     delete (QLocale *) ref;

  } else if (type == typeid(QMargins).name()){
     delete (QMargins *) ref;

  } else if (type == typeid(QMatrix).name()){
     delete (QMatrix *) ref;

  } else if (type == typeid(QModelIndex).name()){
     delete (QModelIndex *) ref;

  } else if (type == typeid(QMoveEvent).name()){

  } else if (type == typeid(QNetworkRequest).name()){
     delete (QNetworkRequest *) ref;

  } else if (type == typeid(QPaintEvent).name()){

  } else if (type == typeid(QPainter).name()){
     delete (QPainter *) ref;

  } else if (type == typeid(QPalette).name()){
     delete (QPalette *) ref;

  } else if (type == typeid(QPen).name()){
     delete (QPen *) ref;

  } else if (type == typeid(QPicture).name()){
     delete (QPicture *) ref;

  } else if (type == typeid(QPixmap).name()){
     delete (QPixmap *) ref;

  } else if (type == typeid(QPoint).name()){
     delete (QPoint *) ref;

  } else if (type == typeid(QPolygon).name()){
     delete (QPolygon *) ref;

  } else if (type == typeid(QPrinter).name()){
     delete (QPrinter *) ref;

  } else if (type == typeid(QPrinterInfo).name()){
     delete (QPrinterInfo *) ref;

  } else if (type == typeid(QProcess).name()){
     delete (QProcess *) ref;

  } else if (type == typeid(QProcessEnvironment).name()){
     delete (QProcessEnvironment *) ref;

  } else if (type == typeid(QRect).name()){
     delete (QRect *) ref;

  } else if (type == typeid(QRegExp).name()){
     delete (QRegExp *) ref;

  } else if (type == typeid(QRegion).name()){
     delete (QRegion *) ref;

  } else if (type == typeid(QResizeEvent).name()){

  } else if (type == typeid(QResource).name()){
     delete (QResource *) ref;

  } else if (type == typeid(QRgb).name()){
     delete (QRgb *) ref;

  } else if (type == typeid(QShortcutEvent).name()){

  } else if (type == typeid(QShowEvent).name()){

  } else if (type == typeid(QSize).name()){
     delete (QSize *) ref;

  } else if (type == typeid(QSizeF).name()){
     delete (QSizeF *) ref;

  } else if (type == typeid(QSizePolicy).name()){
     delete (QSizePolicy *) ref;

  } else if (type == typeid(QStackedLayout).name()){
     delete (QStackedLayout *) ref;

  } else if (type == typeid(QStatusTipEvent).name()){

  } else if (type == typeid(QString).name()){
     delete (QString *) ref;

  } else if (type == typeid(QStringList).name()){
     delete (QStringList *) ref;

  } else if (type == typeid(QSystemLocale).name()){
     delete (QSystemLocale *) ref;

  } else if (type == typeid(QSystemTrayIcon).name()){
     delete (QSystemTrayIcon *) ref;

  } else if (type == typeid(QTableWidgetItem).name()){
     delete (QTableWidgetItem *) ref;

  } else if (type == typeid(QTextBlock).name()){
     delete (QTextBlock *) ref;

  } else if (type == typeid(QTextBlockFormat).name()){
     delete (QTextBlockFormat *) ref;

  } else if (type == typeid(QTextCharFormat).name()){
     delete (QTextCharFormat *) ref;

  } else if (type == typeid(QTextCursor).name()){
     delete (QTextCursor *) ref;

  } else if (type == typeid(QTextDocumentFragment).name()){
     delete (QTextDocumentFragment *) ref;

  } else if (type == typeid(QTextFormat).name()){
     delete (QTextFormat *) ref;

  } else if (type == typeid(QTextFrameFormat).name()){
     delete (QTextFrameFormat *) ref;

  } else if (type == typeid(QTextOption).name()){
     delete (QTextOption *) ref;

  } else if (type == typeid(QTime).name()){
     delete (QTime *) ref;

  } else if (type == typeid(QTimerEvent).name()){

  } else if (type == typeid(QTransform).name()){
     delete (QTransform *) ref;

  } else if (type == typeid(QTreeWidgetItem).name()){
     delete (QTreeWidgetItem *) ref;

  } else if (type == typeid(QUrl).name()){
     delete (QUrl *) ref;

  } else if (type == typeid(QUrlInfo).name()){
     delete (QUrlInfo *) ref;

  } else if (type == typeid(QVBoxLayout).name()){
     delete (QVBoxLayout *) ref;

  } else if (type == typeid(QVariant).name()){
     delete (QVariant *) ref;

  } else if (type == typeid(QWebSettings).name()){

  } else if (type == typeid(QWhatsThisClickedEvent).name()){

  } else if (type == typeid(QWindowStateChangeEvent).name()){

// End Generator h#2



  } else {
   
/*
  QFile file(QDesktopServices::storageLocation(QDesktopServices::DesktopLocation) + "/" + "DEBUG " + QDateTime::currentDateTime().toString("hh mm ss z") + ".txt");
  if (file.open(QIODevice::WriteOnly)){
    QString ss = QString("!%1!   %2").arg( (qint64) ref).arg((qint64) this);

    const char *ac = ss.toAscii().constData();
    file.write(ac, qstrlen(ac)); 
    file.flush();
    file.close();
  }    
*/
 // Q7B_GLOBAL_DELETELATER(this);
 // return;




    QObject *o = (QObject *) ref;

    /*
    QString ss = this->type;

  QFile file;
  if (file.open(stdout, QIODevice::WriteOnly)){
    const char *ac = ss.toLocal8Bit().constData();
    file.write(ac, qstrlen(ac)); 
    file.flush();
    file.close();
  }
  

  */

    //qDebug() << ss;

/*
    QString fss = this->type;
    if (fss.contains("MainWindow")){
        fss = fss;
    }
    if (fss.contains("CodeWindow")){
        fss = fss;
    }

    if (ss.isEmpty()){
        ss = ss;
    }
*/
    if (o->isWidgetType()){
      ref = 0;
      return; // QWidgets have to be deleted manually be the user, if they have no parents

      /*
        if (((QWidget *)o)->parentWidget() || o->parent()){
          return;
        } else {

          // QWidgets have to be deleted manually be the user
          return;
        }*/
    }


   // if (o->metaObject()->className() == "MainWindow"){
   //     QMessageBox::information(0, "MainWindow", "deleteLater");
   // }
    if (o->parent()){
        ref = 0;
        return;
    }
    
    o->deleteLater();
    ref = 0;
  
  }
}

bool Q7B_id::isQObjectBased()
{
  if (type == typeid(qint64).name()){
    return false;

  } else if (type == typeid(bool).name()){
    return false;

  } else if (type == typeid(QString).name()){
    return false;

  } else if (type == typeid(qreal).name()){
    return false;

  } else if (type == typeid(QDateTime).name()){
    return false;

  } else if (type == typeid(Q7B_Decimal).name()){
    return false;

  } else if (type == typeid(Q7B_List).name()){
    return false;

  } else if (type == typeid(Q7B_Dictionary).name()){
     return false;

  // Begin Generator h#7
  } else if (type == typeid(QAccessibleEvent).name()){
     return false;

  } else if (type == typeid(QActionEvent).name()){
     return false;

  } else if (type == typeid(QBitmap).name()){
     return false;

  } else if (type == typeid(QBoxLayout).name()){
     return false;

  } else if (type == typeid(QBrush).name()){
     return false;

  } else if (type == typeid(QByteArray).name()){
     return false;

  } else if (type == typeid(QChar).name()){
     return false;

  } else if (type == typeid(QChildEvent).name()){
     return false;

  } else if (type == typeid(QCloseEvent).name()){
     return false;

  } else if (type == typeid(QColor).name()){
     return false;

  } else if (type == typeid(QContextMenuEvent).name()){
     return false;

  } else if (type == typeid(QCursor).name()){
     return false;

  } else if (type == typeid(QDate).name()){
     return false;

  } else if (type == typeid(QDateTime).name()){
     return false;

  } else if (type == typeid(QDeclarativeContext).name()){
     return false;

  } else if (type == typeid(QDir).name()){
     return false;

  } else if (type == typeid(QDragLeaveEvent).name()){
     return false;

  } else if (type == typeid(QDropEvent).name()){
     return false;

  } else if (type == typeid(QDynamicPropertyChangeEvent).name()){
     return false;

  } else if (type == typeid(QElapsedTimer).name()){
     return false;

  } else if (type == typeid(QEvent).name()){
     return false;

  } else if (type == typeid(QFileInfo).name()){
     return false;

  } else if (type == typeid(QFileInfoList).name()){
     return false;

  } else if (type == typeid(QFileOpenEvent).name()){
     return false;

  } else if (type == typeid(QFocusEvent).name()){
     return false;

  } else if (type == typeid(QFont).name()){
     return false;

  } else if (type == typeid(QFontDatabase).name()){
     return false;

  } else if (type == typeid(QFontInfo).name()){
     return false;

  } else if (type == typeid(QFontMetrics).name()){
     return false;

  } else if (type == typeid(QFormLayout).name()){
     return false;

  } else if (type == typeid(QGraphicsSceneEvent).name()){
     return false;

  } else if (type == typeid(QGridLayout).name()){
     return false;

  } else if (type == typeid(QHBoxLayout).name()){
     return false;

  } else if (type == typeid(QHelpEvent).name()){
     return false;

  } else if (type == typeid(QHideEvent).name()){
     return false;

  } else if (type == typeid(QHostAddress).name()){
     return false;

  } else if (type == typeid(QHostInfo).name()){
     return false;

  } else if (type == typeid(QHoverEvent).name()){
     return false;

  } else if (type == typeid(QIcon).name()){
     return false;

  } else if (type == typeid(QIconDragEvent).name()){
     return false;

  } else if (type == typeid(QImage).name()){
     return false;

  } else if (type == typeid(QInputEvent).name()){
     return false;

  } else if (type == typeid(QInputMethodEvent).name()){
     return false;

  } else if (type == typeid(QKeySequence).name()){
     return false;

  } else if (type == typeid(QLayout).name()){
     return false;

  } else if (type == typeid(QLayoutItem).name()){
     return false;

  } else if (type == typeid(QLine).name()){
     return false;

  } else if (type == typeid(QList<QStringList>).name()){
     return false;

  } else if (type == typeid(QListWidgetItem).name()){
     return false;

  } else if (type == typeid(QLocalSocket).name()){
     return false;

  } else if (type == typeid(QLocale).name()){
     return false;

  } else if (type == typeid(QMargins).name()){
     return false;

  } else if (type == typeid(QMatrix).name()){
     return false;

  } else if (type == typeid(QModelIndex).name()){
     return false;

  } else if (type == typeid(QMoveEvent).name()){
     return false;

  } else if (type == typeid(QNetworkRequest).name()){
     return false;

  } else if (type == typeid(QPaintEvent).name()){
     return false;

  } else if (type == typeid(QPainter).name()){
     return false;

  } else if (type == typeid(QPalette).name()){
     return false;

  } else if (type == typeid(QPen).name()){
     return false;

  } else if (type == typeid(QPicture).name()){
     return false;

  } else if (type == typeid(QPixmap).name()){
     return false;

  } else if (type == typeid(QPoint).name()){
     return false;

  } else if (type == typeid(QPolygon).name()){
     return false;

  } else if (type == typeid(QPrinter).name()){
     return false;

  } else if (type == typeid(QPrinterInfo).name()){
     return false;

  } else if (type == typeid(QProcess).name()){
     return false;

  } else if (type == typeid(QProcessEnvironment).name()){
     return false;

  } else if (type == typeid(QRect).name()){
     return false;

  } else if (type == typeid(QRegExp).name()){
     return false;

  } else if (type == typeid(QRegion).name()){
     return false;

  } else if (type == typeid(QResizeEvent).name()){
     return false;

  } else if (type == typeid(QResource).name()){
     return false;

  } else if (type == typeid(QRgb).name()){
     return false;

  } else if (type == typeid(QShortcutEvent).name()){
     return false;

  } else if (type == typeid(QShowEvent).name()){
     return false;

  } else if (type == typeid(QSize).name()){
     return false;

  } else if (type == typeid(QSizeF).name()){
     return false;

  } else if (type == typeid(QSizePolicy).name()){
     return false;

  } else if (type == typeid(QStackedLayout).name()){
     return false;

  } else if (type == typeid(QStatusTipEvent).name()){
     return false;

  } else if (type == typeid(QString).name()){
     return false;

  } else if (type == typeid(QStringList).name()){
     return false;

  } else if (type == typeid(QSystemLocale).name()){
     return false;

  } else if (type == typeid(QSystemTrayIcon).name()){
     return false;

  } else if (type == typeid(QTableWidgetItem).name()){
     return false;

  } else if (type == typeid(QTextBlock).name()){
     return false;

  } else if (type == typeid(QTextBlockFormat).name()){
     return false;

  } else if (type == typeid(QTextCharFormat).name()){
     return false;

  } else if (type == typeid(QTextCursor).name()){
     return false;

  } else if (type == typeid(QTextDocumentFragment).name()){
     return false;

  } else if (type == typeid(QTextFormat).name()){
     return false;

  } else if (type == typeid(QTextFrameFormat).name()){
     return false;

  } else if (type == typeid(QTextOption).name()){
     return false;

  } else if (type == typeid(QTime).name()){
     return false;

  } else if (type == typeid(QTimerEvent).name()){
     return false;

  } else if (type == typeid(QTransform).name()){
     return false;

  } else if (type == typeid(QTreeWidgetItem).name()){
     return false;

  } else if (type == typeid(QUrl).name()){
     return false;

  } else if (type == typeid(QUrlInfo).name()){
     return false;

  } else if (type == typeid(QVBoxLayout).name()){
     return false;

  } else if (type == typeid(QVariant).name()){
     return false;

  } else if (type == typeid(QWebSettings).name()){
     return false;

  } else if (type == typeid(QWhatsThisClickedEvent).name()){
     return false;

  } else if (type == typeid(QWindowStateChangeEvent).name()){
     return false;

// End Generator h#7

  //} else if (type == typeid(QIcon).name()){
    // return false;
  }

  return true;
}

Q7B Q7B_Dictionary::init(Q7B values, Q7B keys)
{
  Q7B_Dictionary *d = new Q7B_Dictionary();
  Q7B q (new Q7B_id(typeid(Q7B_Dictionary).name(), d));   

  if (Q7B_nil(Q7B_LIST(values))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_LIST(keys))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }

  QList<Q7B> v = ((Q7B_List *) values->ref)->values();
  QList<Q7B> k = ((Q7B_List *) keys->ref)->values();    

  if (v.length() != k.length()){ Q7B_EXCEPTION(QString("Dictionary init: Count of keys and values are different %1 %2").arg(v.length()).arg(k.length())); return Q7B_idnil; }

  for (qint64 i = 0; i < v.length(); i++){
    d->me[Q7B_toString2(k.at(i))] = v.at(i);  
  }

  return q;
}











Q7B Q7B_ID() 
{
  Q7B q (new Q7B_id()); 
  return q;
}

Q7B Q7B_ID(Q7B o) 
{
  return o;
}

Q7B Q7B_ID(bool o) 
{
  Q7B q (new Q7B_id(typeid(bool).name(), new bool(o))); 
  return q;
}

Q7B Q7B_ID(char * o)
{
  Q7B q (new Q7B_id(typeid(QString).name(), new QString(o))); 
  return q;
}

Q7B Q7B_ID(const char * o)
{
  Q7B q (new Q7B_id(typeid(QString).name(), new QString(o))); 
  return q;
}

Q7B Q7B_ID(QString o)
{
  Q7B q (new Q7B_id(typeid(QString).name(), new QString(o))); 
  return q;
}

Q7B Q7B_ID(qint8 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_ID(qint16 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_ID(qint32 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_ID(qint64 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_ID(quint8 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_ID(quint16 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_ID(quint32 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_ID(quint64 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_ID(float o)
{
  Q7B q (new Q7B_id(typeid(qreal).name(), new qreal(o))); 
  return q;
}

Q7B Q7B_ID(double o)
{
  Q7B q (new Q7B_id(typeid(qreal).name(), new qreal(o))); 
  return q;
}
/*
Q7B Q7B_ID(QIcon o)
{
  Q7B q (new Q7B_id(typeid(QIcon).name(), new QIcon(o))); 
  return q;
}*/
/*
Q7B Q7B_ID(QByteArray o)
{
  Q7B q (new Q7B_id(typeid(QByteArray).name(), new QByteArray(o))); 
  return q;
}*/
/*
Q7B Q7B_ID(QSize o)
{
  Q7B q (new Q7B_id(typeid(QSize).name(), new QSize(o))); 
  return q;
}

Q7B Q7B_ID(QRect o)
{
  Q7B q (new Q7B_id(typeid(QRect).name(), new QRect(o))); 
  return q;
}*/

/*
Q7B Q7B_QOBJECTNULL(qint64 *dummy)
{
  return Q7B_IDNIL();
}*/

/*
Q7B Q7B_ID(QDateTime o) 
{
  Q7B q (new Q7B_id(typeid(QDateTime).name(), new QDateTime(o))); 
  return q;
}*/

Q7B Q7B_ID(const char *name, QObject *o)
{
  static QMap<QString, QString> user_types;

  if (!user_types.contains(name)){
    user_types[name] = QString("class ") + name;
  }
  Q7B q (new Q7B_id(user_types[name].toAscii().constData(), o)); 
  return q;
}

Q7B Q7B_ID(const char *name, void *o)
{
  static QMap<QString, QString> user_types;

  if (!user_types.contains(name)){
    user_types[name] = QString("class ") + name;
  }
  Q7B q (new Q7B_id(user_types[name].toAscii().constData(), o)); 
  return q;
}

Q7B Q7B_ID(QStringList o) 
{
  Q7B q (new Q7B_id(typeid(QStringList).name(), new QStringList(o))); 
  return q;
}

Q7B Q7B_ID(Q7B_Decimal o) 
{
  Q7B q (new Q7B_id(typeid(Q7B_Decimal).name(), new Q7B_Decimal(o))); 
  return q;
}

Q7B Q7B_ID_DECIMAL(qint64 bc, qint64 ad)
{
  Q7B q (new Q7B_id(typeid(Q7B_Decimal).name(), new Q7B_Decimal(bc, ad))); 
  return q;
}

/*
Q7B Q7B_ID(QList<> o)
{
  Q7B_List *l = new Q7B_List(); 
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), l)); 

  for (int i = 0; i < o.size(); i++){
    l->append(o.at(i));
  }
  
  return q;
}
*/



Q7B Q7B_idnil(new Q7B_id());
Q7B Q7B_IDNIL();

//QMap<QString, Q7B>q7b_object;

// *** meta ****

QString Q7B_META_sCurrentLine;
QString Q7B_META_sCurrentFile;
QString Q7B_META_sCurrentScope;

QString Q7B_QtBL()
{
  return QString("%1").arg(Q7B_META_sCurrentLine);
}

QString Q7B_QtBF()
{
  return QString(Q7B_META_sCurrentFile);  
}

QString Q7B_QtBS()
{
  return QString(Q7B_META_sCurrentScope);
}

bool Q7B_bException = false;

void Q7B_EXCEPTION(QString a)
{
  if (Q7B_bException) return;
  Q7B_bException = true;

  QString s = QString("%1File '%2'\n at '%3'\n line '%4'").arg(a.isEmpty() ? a : a + "\n\n").arg(Q7B_QtBF()).arg(Q7B_QtBS()).arg(Q7B_QtBL());
  QMessageBox::warning(0, "Runtime Exception", s);
}

void Q7B_NULLPOINTEREXCEPTION(QString a)
{
  if (Q7B_bException) return;
  Q7B_bException = true;

  QString s = QString("%1File '%2'\n at '%3'\n line '%4'").arg(a.isEmpty() ? a : a + "\n\n").arg(Q7B_QtBF()).arg(Q7B_QtBS()).arg(Q7B_QtBL());
  QMessageBox::warning(0, "Null Pointer Exception", s);
}

void Q7B_CASTEXCEPTION(QString a)
{
  if (Q7B_bException) return;
  Q7B_bException = true;

  QString s = QString("%1File '%2'\n at '%3'\n line '%4'").arg(a.isEmpty() ? a : a + "\n\n").arg(Q7B_QtBF()).arg(Q7B_QtBS()).arg(Q7B_QtBL());
  QMessageBox::warning(0, "Cast Exception", s);
}

void Q7B_INVALIDARGUMENTEXCEPTION(QString a)
{
  if (Q7B_bException) return;
  Q7B_bException = true;

  QString s = QString("%1File '%2'\n at '%3'\n line '%4'").arg(a.isEmpty() ? a : a + "\n\n").arg(Q7B_QtBF()).arg(Q7B_QtBS()).arg(Q7B_QtBL());
  QMessageBox::warning(0, "Invalid Argument Exception", s);
}
// *** 


// *** Array

void q7b_array_dimhelper(Q7B o, qint32 a0, qint32 a1, qint32 a2, qint32 a3)
{ 
  //QMessageBox::information(0, "", "aa");
  if (a0 >= 0){
//    QMessageBox::information(0, "", "???");

   // o->q7b_array_count = 4;

    //QMessageBox::information(0, "", "????????");

    o->array_indexes[0] = a0;

    

   //   QMessageBox::information(0, "", "!!!");
  
  }
  
  else { o->array_indexes[0] = -1; o->array_indexes[1] = -1; o->array_indexes[2] = -1; o->array_indexes[3] = -1; o->q7b_array_count = 0; return; }
 // QMessageBox::information(0, "", "bb");
  if (a1 >= 0) o->array_indexes[1] = a1; else { o->array_indexes[1] = -1; o->array_indexes[2] = -1; o->array_indexes[3] = -1; o->q7b_array_count = 1; return; }
 // QMessageBox::information(0, "", "cc");
  if (a2 >= 0) o->array_indexes[2] = a2; else { o->array_indexes[2] = -1; o->array_indexes[3] = -1;o->q7b_array_count = 2; return; }
 // QMessageBox::information(0, "", "dd");
  if (a3 >= 0) o->array_indexes[3] = a3; else { o->array_indexes[3] = -1;o->q7b_array_count = 3; return; }
 // QMessageBox::information(0, "", "ee");

  o->q7b_array_count = 4;
}

qint64 q7b_array_offset(Q7B o, qint32 a0, qint32 a1, qint32 a2, qint32 a3, bool bCheck)
{
  //if (o->q7b_array == 0) return -1;
  /*
  qint64 f0 = o->array_indexes[0]; 
  qint64 f1 = o->array_indexes[1]; 
  qint64 f2 = o->array_indexes[2]; 
  qint64 f3 = o->array_indexes[3]; */

  if (bCheck){
    if (!(a0 >= 0 && a0 < o->array_indexes[0]) && a0 != -1 && o->array_indexes[0] >= 0) return -1;
    if (!(a1 >= 0 && a1 < o->array_indexes[1]) && a1 != -1 && o->array_indexes[1] >= 0) return -1;
    if (!(a2 >= 0 && a2 < o->array_indexes[2]) && a2 != -1 && o->array_indexes[2] >= 0){
       //QMessageBox::information(0, "a2", QString("%1").arg(a2));
      // QMessageBox::information(0, "o->array_indexes[2]", QString("%1").arg(o->array_indexes[2]));

      return -1;
    }
    if (!(a3 >= 0 && a3 < o->array_indexes[3]) && a3 != -1 && o->array_indexes[3] >= 0) return -1;
  }

  qint64 nSize = o->array_indexes[0];
  qint64 n = a0;
 // if (o->array_indexes[0] >= 0){
   // n += a0;
  //} else n = 1;
    
  if (o->array_indexes[1] >= 0 && a1 > 0){ n += a1 * nSize; nSize = nSize * o->array_indexes[1]; }
  if (o->array_indexes[2] >= 0 && a2 > 0){ n += a2 * nSize; nSize = nSize * o->array_indexes[2]; }
  if (o->array_indexes[3] >= 0 && a3 > 0){ n += a3 * nSize; nSize = nSize * o->array_indexes[3]; }

  if (o->q7b_array && !(n < o->q7b_array->size())){
    if (o->q7b_array->size() > 0){
      Q7B_EXCEPTION(QString("%1 %2 array internal offset error %3 %4 %5 %6").arg(n).arg(o->q7b_array->size()) .arg(a0) .arg(a1) .arg(a2) .arg(a3) ); 
    }
    return -1; 
  }

  return n;
}


void q7b_array_dim(Q7B o, Q7B a0, Q7B a1, Q7B a2, Q7B a3)
{

  //QMessageBox::information(0, "", "-1");

 // o->ref = (void *)1;

  //if (o->q7b_array){ Q7B_EXCEPTION("array has already been declared with Dim"); return; }


  //QMessageBox::information(0, "", "0");
  o->q7b_array = new QVector<Q7B>;
 // QMessageBox::information(0, "", "1");
  q7b_array_dimhelper(o, Q7B_IDqint64(a0), Q7B_IDqint64(a1), Q7B_IDqint64(a2), Q7B_IDqint64(a3));  
  //QMessageBox::information(0, "", "2");
  //o->q7b_array->resize(0);
  qint64 m = o->array_indexes[0] * (o->array_indexes[1] > 0 ? o->array_indexes[1] : 1) * (o->array_indexes[2] > 0 ? o->array_indexes[2] : 1) * (o->array_indexes[3] > 0 ? o->array_indexes[3] : 1);
  if (m > 0) o->q7b_array->resize(m);
   // QMessageBox::information(0, "", "3");

 // QMessageBox::information(0, "", QString("%1 %2 ").arg(-1).arg(o->q7b_array->size()));


}

void q7b_array_redim(Q7B o, Q7B Preserve, Q7B aa0, Q7B aa1, Q7B aa2, Q7B aa3)
{
  
  //if (o->q7b_array == 0){ Q7B_EXCEPTION("array has not been declared with Dim"); return; }
 //bool b = false;

  qint64 a0 = Q7B_IDqint64(aa0);
  qint64 a1 = Q7B_IDqint64(aa1);
  qint64 a2 = Q7B_IDqint64(aa2);
  qint64 a3 = Q7B_IDqint64(aa3);

  if (Q7B_IDbool(Preserve) && o->q7b_array){
  //  QMessageBox::information(0, "", QString("a %1").arg((long) -1));

    Q7B newcopy ( new Q7B_id());

    q7b_array_dimhelper(newcopy, a0 == 0 ? -1 : a0, a1 == 0 ? -1 : a1, a2 == 0 ? -1 : a2, a3 == 0 ? -1 : a3);

  //  QMessageBox::information(0, "", QString("aa %1").arg((long) -1));

    QVector<Q7B> *q7b_array = new QVector<Q7B>;
    q7b_array->resize(a0 * (a1 > 0 ? a1 : 1) * (a2 > 0 ? a2 : 1) * (a3 > 0 ? a3 : 1));

   // QMessageBox::information(0, "", QString("aaa %1").arg((long) -1));

         //   QMessageBox::information(0, "", QString("%1 %2 %3 %4") .arg((long) a0)  .arg((long) a1)  .arg((long) a2)  .arg((long) a3) );
            
   for (qint64 b3 = -1; b3 <= o->array_indexes[3]; b3++){ 
     for (qint64 b2 = -1; b2 <= o->array_indexes[2]; b2++){   
       for (qint64 b1 = -1; b1 <= o->array_indexes[1]; b1++){
         for (qint64 b0 = -1; b0 <= o->array_indexes[0]; b0++){


            if (b0 + 1 >= o->array_indexes[0] + 0 && b0 > -1) continue;
            if (b1 + 1 >= o->array_indexes[1] + 0 && b1 > -1) continue;
            if (b2 + 1 >= o->array_indexes[2] + 0 && b2 > -1 ) continue;
            if (b3 + 1 >= o->array_indexes[3] + 0 && b3 > -1 ) continue;


            qint64 n = q7b_array_offset(o, b0 + 1, b1 + 1, b2 + 1, b3 + 1, false);

           //  QMessageBox::information(0, "", QString("n=%1 %2 %3 %4 %5") .arg(n) .arg((long) b0 + 1)  .arg((long) b1 + 1)  .arg((long) b2 + 1)  .arg((long) b3 + 1) );

            if (n >= 0 && (a0 == -1 || b0 + 1 <= a0) && (a1 == -1 || b1 + 1 <= a1) && (a2 == -1 || b2 + 1 <= a2) && (a3 == -1 || b3 + 1 <= a3)){
             // Q7B Value = o->q7b_array->at(n);

             // if (!Value.isNull()){
              if (!(*o->q7b_array)[n].isNull()){
             
                

            if (b1 + 1 == 9){
              b1 = b1;
            //  QMessageBox::information(0, "", QString("b=%1 %2 %3 %4 %5") .arg(n) .arg((long) b0 + 1)  .arg((long) b1 + 1)  .arg((long) b2 + 1)  .arg((long) b3 + 1) );
             // QMessageBox::information(0, "", QString("a=%1 %2 %3 %4 %5") .arg(n) .arg((long) a0)  .arg((long) a1)  .arg((long) a2)  .arg((long) a3) );
            }
            int k = q7b_array_offset(newcopy, b0 + 1, b1 + 1, b2 + 1, b3 + 1, true);
            if (k >= 0)
            {
 
            //    QMessageBox::information(0, "", QString("==_copy!!!!!!!!!!!!1 %1 %2 %3 %4") .arg((long) b0 + 1)  .arg((long) b1 + 1)  .arg((long) b2 + 1)  .arg((long) b3 + 1) );
                
           //  QMessageBox::information(0, "", QString("%1") .arg(k)  );

                q7b_array->replace(k, (*o->q7b_array)[n]);

                //QMessageBox::information(0, "", QString("copy2222!!!!!!!!!!!!1 %1 %2 %3 %4") .arg((long) b0 + 1)  .arg((long) b1 + 1)  .arg((long) b2 + 1)  .arg((long) b3 + 1) );
            }

              }
            }
              
          }      
        }            
      }      
    }

    //QMessageBox::information(0, "", QString("b %1").arg((long) -1));

    // QMessageBox::information(0, "", QString("%1 %2 %3").arg(q7b_array->size()) .arg((long) o->q7b_array) .arg((long) q7b_array) );

    delete o->q7b_array;

    o->q7b_array = q7b_array;

    q7b_array_dimhelper(o, (a0), (a1), (a2), (a3));
    

    
  //  b = true;

    //    QMessageBox::information(0, "", QString("c %1").arg((long) -1));


  } else {
    if (o->q7b_array) delete o->q7b_array;
    q7b_array_dim(o, (aa0), (aa1), (aa2), (aa3));
  }
/*
  if (b){
    
     QMessageBox::information(0, "", QString("  if (b){  %1 %2").arg(o->q7b_array->size()) .arg((long) o->q7b_array) );

  }*/

}

/*
void q7b_array_set(Q7B o, Q7B Value, Q7B a0, Q7B a1, Q7B a2, Q7B a3)
{
  if (o->q7b_array == 0){ Q7B_EXCEPTION("array has not been declared with Dim"); return; }

  qint64 nOffset = q7b_array_offset(o, Q7B_IDqint64(a0), Q7B_IDqint64(a1), Q7B_IDqint64(a2), Q7B_IDqint64(a3), true);
  if (nOffset == -1){ Q7B_EXCEPTION("array offset out of bounds"); return; }

  o->q7b_array->replace(nOffset, Value);
}*/

Q7B *q7b_array_get(Q7B o, Q7B a0, Q7B a1, Q7B a2, Q7B a3)
{
  if (o->q7b_array == 0){ Q7B_EXCEPTION("array has not been declared with Dim"); return &Q7B_idnil; }

  
   // QMessageBox::information(0, "*********", QString("%1 %2").arg(o->q7b_array->size()) .arg((long) o->q7b_array));

  qint64 nOffset = q7b_array_offset(o, Q7B_IDqint64(a0), Q7B_IDqint64(a1), Q7B_IDqint64(a2), Q7B_IDqint64(a3), true);
  if (nOffset == -1){ Q7B_EXCEPTION("array offset out of bounds"); return &Q7B_idnil; }

 // Q7B Value;
  
 // Value = o->q7b_array->at(nOffset);
  
  //QMessageBox::information(0, "", QString("ref?"));
  //QMessageBox::information(0, "", QString("ref %1").arg((long) Value.isNull()));

//  if (Value.isNull()) return &Q7B_IDNIL(); // prevent crashing
  if ((*o->q7b_array)[nOffset].isNull()) return &Q7B_idnil; // prevent crashing

  return &(*o->q7b_array)[nOffset];
}

Q7B *q7b_array_at(Q7B o, Q7B a0, Q7B a1, Q7B a2, Q7B a3) // needed for types, same like q7b_array_get, but without null checking overriding with Q7B_idnil
{
  if (o->q7b_array == 0){ Q7B_EXCEPTION("array has not been declared with Dim"); return &Q7B_idnil; }

  qint64 nOffset = q7b_array_offset(o, Q7B_IDqint64(a0), Q7B_IDqint64(a1), Q7B_IDqint64(a2), Q7B_IDqint64(a3), true);
  if (nOffset == -1){ 
    /*int a = Q7B_IDqint64(a0);
    int b = Q7B_IDqint64(a1);
    int c = Q7B_IDqint64(a2);
    int d = Q7B_IDqint64(a3);*/
    Q7B_EXCEPTION("array offset out of bounds"); return &Q7B_idnil; 
  }

  //Q7B Value;
  
  //Value = o->q7b_array->at(nOffset);

  if ((*o->q7b_array)[nOffset].isNull()){
    //Q7B Value2 = Q7B_ID();
    //o->q7b_array->replace(nOffset, Value2);
    (*o->q7b_array)[nOffset] = Q7B_ID();
  //  return &(*o->q7b_array)[nOffset];
  }
  
  return &(*o->q7b_array)[nOffset];
}

Q7B q7b_array_ubound(Q7B o, Q7B i)
{
  //if (o->q7b_array == 0){ Q7B_EXCEPTION("array has not been declared with Dim"); return Q7B_idnil; }

  qint64 ii = Q7B_IDqint64(i);

  if (ii == -1){

    return Q7B_ID(o->q7b_array_count);   

  } else if (ii < o->q7b_array_count){

    return Q7B_ID(o->array_indexes[ii]);
  
  }

  { Q7B_EXCEPTION("UBound: array dimension index out of bounds"); return Q7B_idnil; }
}

Q7B q7b_array_lbound(Q7B o, Q7B i)
{
  //if (o->q7b_array == 0){ Q7B_EXCEPTION("array has not been declared with Dim"); return Q7B_idnil; }

  return Q7B_ID(0);   
}

// ***

// *** Type

Q7B *q7b_type_get(Q7B o, Q7B index, Q7B a0, Q7B a1, Q7B a2, Q7B a3)
{
  if (o->q7b_type == 0 /*&& o->q7b_array == 0*/){ Q7B_EXCEPTION(QString("internal error: q7b_type == 0 variable has not been set as a type %1").arg((int)Q7B_IDqint64(index))); return &Q7B_idnil; }
  //if (o->q7b_type == 0){ Q7B_EXCEPTION(QString("variable has not been set as a type %1").arg((int)Q7B_IDqint64(index))); return &Q7B_idnil; }
  
  //Q7B Value = o->q7b_type->at(Q7B_IDqint64(index));

  //QMessageBox::information(0, "q7b_type_get", Value.isNull() ? "NULL!!!" : QString("%1") .arg((int)Value->ref)  );

  if ((*o->q7b_type)[Q7B_IDqint64(index)].isNull()){
    //Q7B Value2 = Q7B_ID();
    //o->q7b_type->replace(Q7B_IDqint64(index), Value2);
   // return Value2;
    //o->q7b_type->replace(Q7B_IDqint64(index), Value2);
    (*o->q7b_type)[Q7B_IDqint64(index)] = Q7B_ID();

    //int asdf = Q7B_IDqint64(a0) >= 0;
    //if (!(Q7B_IDqint64(a0) >= 0)) 
    return &(*o->q7b_type)[Q7B_IDqint64(index)];

    //return Q7B_IDNIL(); // prevent crashing
  } 

  if ((*o->q7b_type)[Q7B_IDqint64(index)]->q7b_array && Q7B_IDqint64(a0) >= 0){ // Q7B_IDqint64(a0) >= 0 needed for MsgBox("UBound", UBound(t2.a2))  

    qint64 nOffset = q7b_array_offset((*o->q7b_type)[Q7B_IDqint64(index)], Q7B_IDqint64(a0), Q7B_IDqint64(a1), Q7B_IDqint64(a2), Q7B_IDqint64(a3), true);
    if (nOffset == -1){ Q7B_EXCEPTION("array offset out of bounds"); return &Q7B_idnil; }      

    QVector<Q7B> *q7b_array = (*o->q7b_type)[Q7B_IDqint64(index)]->q7b_array;

    if ((*q7b_array)[nOffset].isNull()){
  //QMessageBox::information(0, "nOffset", QString("%1") .arg((int)nOffset)  );      
      
      (*q7b_array)[nOffset] = Q7B_ID();
    }

    return &(*q7b_array)[nOffset];          

    //if (Value.isNull()) return Q7B_IDNIL(); // prevent crashing
        
  }  

  return &(*o->q7b_type)[Q7B_IDqint64(index)];
}

// ***




const QPixmap &Q7B_loadPixmap(QString fn)
{
  static QPixmap p;

 // p = QPixmap();
  /*
  if (!(fn.contains("/") || fn.contains("\\"))){

      p = my_form_loadProjectImage(my_form, fn);
    
  } else {
//re:*/
    //if (QFile::exists(fn))

  if (!fn.contains("/") && !fn.contains("\\")){
    fn = qApp->applicationDirPath() + "/" + fn;

  //  QMessageBox::information(0, "fn", fn);



  }

    {
      p = QPixmap(fn);
    }
    
  //}

  return p;
  
}

const QPixmap &Q7B_createPixmap(QString n)
{
  static QPixmap qpixmap;

   if (n.length() > 200){ // QString contains binary data

      if (n.left(200).contains("<svg ", Qt::CaseInsensitive)){
        QString m = n;
        m = m.trimmed();
        QSvgWidget w(0);
        w.resize(100, 100);
        QSvgRenderer *r = w.renderer();
        if (r->load(m.toLatin1())){

          QPixmap p(100, 100);
          QPainter painter(&p);
          r->render(&painter);
          qpixmap = p;       
        }
      } else {
         QPixmap pi; pi.loadFromData(n.toLatin1());
         qpixmap = pi;
      }

   } else {
     if (n.isEmpty()){
         static QPixmap empty;
         return empty;
     }

     qpixmap = Q7B_loadPixmap(n.contains(".") ? n : n + ".png");
   }

   return qpixmap;
}

// *** QByteArray conversions

// TODO2 alle klassen markieren in doku, die zu qbytearray serializiert werden k?nnen

QIcon Q7B_QByteArray2QIcon(QByteArray ba)
{
  QDataStream d(ba);

  QIcon icon;

  d >> icon;
  return icon;
}

QByteArray Q7B_QIcon2QByteArray(QIcon icon)
{
  QByteArray ba;
  QDataStream d(&ba, QIODevice::WriteOnly);
  d << icon;
  return ba;
}



QString Q7B_toString2(Q7B Q7B_Object)
{
  if (Q7B_Object->q7b_array){

   QString k = "Array[] = {";

   bool bFirst = true;
            
   for (qint64 b3 = -1; b3 <= Q7B_Object->array_indexes[3]; b3++){ 
     for (qint64 b2 = -1; b2 <= Q7B_Object->array_indexes[2]; b2++){   
       for (qint64 b1 = -1; b1 <= Q7B_Object->array_indexes[1]; b1++){
         for (qint64 b0 = -1; b0 <= Q7B_Object->array_indexes[0]; b0++){

            if (b0 + 1 >= Q7B_Object->array_indexes[0] + 0 && b0 > -1) continue;
            if (b1 + 1 >= Q7B_Object->array_indexes[1] + 0 && b1 > -1) continue;
            if (b2 + 1 >= Q7B_Object->array_indexes[2] + 0 && b2 > -1 ) continue;
            if (b3 + 1 >= Q7B_Object->array_indexes[3] + 0 && b3 > -1 ) continue;

            qint64 n = q7b_array_offset(Q7B_Object, b0 + 1, b1 + 1, b2 + 1, b3 + 1, false);

            if (n >= 0){
              Q7B Value = Q7B_Object->q7b_array->at(n);

              if (!bFirst){
                k += ", ";                
              }
              bFirst = false;

              if (!Value.isNull()){
                k += Q7B_toString2(Value);
              } else {
                k += "Null";
              }
            }
         }
       }
     }
   }
   k += "}";
   return k;

  } else if (Q7B_Object->q7b_type){

     QString k = "Type = {";

     bool bFirst = true;
            
     int nnnn = Q7B_Object->q7b_type->size();
     for (qint64 n = 0; n < Q7B_Object->q7b_type->size(); n++){   

      Q7B Value = Q7B_Object->q7b_type->at(n);

      if (!bFirst){
        k += ", ";                
      }
      bFirst = false;

      if (!Value.isNull()){
        k += Q7B_toString2(Value);
      } else {
        k += "Null";
      }   

      //QMessageBox::information(0, "Q7B_toString2", Value.isNull() ? "NULL!!!" : QString("%1") .arg((int)Value->ref)  );

//      k += "\n";   
    }
    k += "}";
    return k;

  } else {

   // TODO2 decimal, qsize, qrect...
    if (Q7B_Object->ref == 0){
      return QString("Null");

    } else if (Q7B_Object->type == typeid(qint64).name()){
      return QString("%1").arg( Q7B_IDqint64(Q7B_Object) );

    } else if (Q7B_Object->type == typeid(qreal).name()){
      return QString("%1").arg( *((qreal *) Q7B_Object->ref) );

    } else if (Q7B_Object->type == typeid(bool).name()){
      return QString("%1").arg( *((bool *) Q7B_Object->ref) );
//      return QString("%1: %2 ").arg(QString(Q7B_Object->type)).arg((qint64) Q7B_Object->ref) + QString("%1").arg( *((bool *) Q7B_Object->ref) );

    } else if (Q7B_Object->type == typeid(QDateTime).name()){
      return QString("%1").arg( ((QDateTime *) Q7B_Object->ref)->toString("yyyy-MM-dd hh:mm:ss") );

    } else if (Q7B_Object->type == typeid(QTime).name()){
      return QString("%1").arg( ((QTime *) Q7B_Object->ref)->toString("hh:mm:ss") );

    } else if (Q7B_Object->type == typeid(QDate).name()){
      return QString("%1").arg( ((QDate *) Q7B_Object->ref)->toString("yyyy-MM-dd") );      

    } else if (Q7B_Object->type == typeid(Q7B_Decimal).name()){
      return QString("%1").arg( ((Q7B_Decimal *) Q7B_Object->ref)->toString() );      

    } else if (Q7B_Object->type == typeid(Q7B_List).name()){
      return ((Q7B_List *) Q7B_Object->ref)->toString();

    } else if (Q7B_Object->type == typeid(Q7B_Dictionary).name()){
      return ((Q7B_Dictionary *) Q7B_Object->ref)->toString();

    //} else if (Q7B_Object->type == typeid(Data).name()){
  //    return ((Data *) Q7B_Object->ref)->toString();

    } else if (Q7B_Object->type == typeid(QString).name()){
      return *((QString *) Q7B_Object->ref);
//      return QString("%1: %2 ").arg(QString(Q7B_Object->type)).arg((qint64) Q7B_Object->ref) + *((QString *) Q7B_Object->ref);
 
    } else if (Q7B_Object->type == typeid(QChar).name()){
      return QString(*((QChar *) Q7B_Object->ref));


    } else if (Q7B_Object->type == typeid(QStringList).name()){

      QString k = "QStringList = {";
      QStringList l = (*((QStringList *) Q7B_Object->ref));

      bool bFirst = true;
      for (int i = 0; i < l.size(); i++){
        
        if (!bFirst){
          k += ", ";                
        }
        k += "\"" + l.at(i) + "\"";
        bFirst = false;
      }

      k += "}";   
      return k;   

    } else if (Q7B_Object->type == typeid(QList<QStringList>).name()){

      QString k = "QList<QStringList> = {\n";
      QList<QStringList> l = (*((QList<QStringList> *) Q7B_Object->ref));
      
      for (int i = 0; i < l.size(); i++){

        QStringList ll = l.at(i);

        k += "QStringList = {\n";
        bool bFirst = true;
        for (int ii = 0; ii < ll.size(); ii++){
          
          if (!bFirst){
            k += ", ";                
          }
          k += "\"" + ll.at(ii) + "\"";
          bFirst = false;
        }
        k += "}\n";   
      }

      k += "}";   
      return k;
   }
    // expected to be string
    //if (Q7B_Object->ref == 0){
   //   return QString("Null");
   // } else {
      return QString("%1: %2").arg(QString(Q7B_Object->type)).arg((qint64) Q7B_Object->ref);
    //}
  }
}

void Q7B_toXML2(QXmlStreamWriter & xmlWriter, Q7B Q7B_Object)
{

  if (Q7B_Object->q7b_array){

  xmlWriter.writeStartElement("array2");

  xmlWriter.writeTextElement("count", QString::number( Q7B_Object->q7b_array_count ));
  xmlWriter.writeTextElement("index0", QString::number( Q7B_Object->array_indexes[0] ));
  xmlWriter.writeTextElement("index1", QString::number( Q7B_Object->array_indexes[1] ));
  xmlWriter.writeTextElement("index2", QString::number( Q7B_Object->array_indexes[2] ));
  xmlWriter.writeTextElement("index3", QString::number( Q7B_Object->array_indexes[3] ));

   for (qint64 b3 = -1; b3 <= Q7B_Object->array_indexes[3]; b3++){ 
     for (qint64 b2 = -1; b2 <= Q7B_Object->array_indexes[2]; b2++){   
       for (qint64 b1 = -1; b1 <= Q7B_Object->array_indexes[1]; b1++){
         for (qint64 b0 = -1; b0 <= Q7B_Object->array_indexes[0]; b0++){

            if (b0 + 1 >= Q7B_Object->array_indexes[0] + 0 && b0 > -1) continue;
            if (b1 + 1 >= Q7B_Object->array_indexes[1] + 0 && b1 > -1) continue;
            if (b2 + 1 >= Q7B_Object->array_indexes[2] + 0 && b2 > -1 ) continue;
            if (b3 + 1 >= Q7B_Object->array_indexes[3] + 0 && b3 > -1 ) continue;

            qint64 n = q7b_array_offset(Q7B_Object, b0 + 1, b1 + 1, b2 + 1, b3 + 1, false);

            if (n >= 0){
              Q7B Value = Q7B_Object->q7b_array->at(n);

              if (!Value.isNull()){
                Q7B_toXML2(xmlWriter, Value);
              } else {
                xmlWriter.writeTextElement("null", "");
             //   Q7B_toXML2(xmlWriter, "Null");
              }
            }
         }
       }
     }
   }      
   
   xmlWriter.writeEndElement();

  } else if (Q7B_Object->q7b_type){

  xmlWriter.writeStartElement("type");

  xmlWriter.writeTextElement("count", QString::number( Q7B_Object->q7b_type->count() ));

   for (qint64 n = 0; n < Q7B_Object->q7b_type->count(); n++){ 

      Q7B Value = Q7B_Object->q7b_type->at(n);

      if (!Value.isNull()){
        Q7B_toXML2(xmlWriter, Value);
      } else {
        xmlWriter.writeTextElement("null", "");
      }
   }      
   
   xmlWriter.writeEndElement();

  } else {

    // TODO2 decimal, qsize, qrect...
    if (Q7B_Object->type == typeid(qint64).name()){
      xmlWriter.writeTextElement("integer", QString::number( *((qint64 *) Q7B_Object->ref) ));

    } else if (Q7B_Object->type == typeid(qreal).name()){
      xmlWriter.writeTextElement("float", QString::number( *((qreal *) Q7B_Object->ref) ));      

    } else if (Q7B_Object->type == typeid(QDateTime).name()){
      xmlWriter.writeTextElement("datetime", ((QDateTime *) Q7B_Object->ref)->toString("yyyy-MM-dd hh:mm:ss") );

    } else if (Q7B_Object->type == typeid(Q7B_Decimal).name()){
      xmlWriter.writeTextElement("decimal", ((QDateTime *) Q7B_Object->ref)->toString() );

    } else if (Q7B_Object->type == typeid(bool).name()){
      xmlWriter.writeTextElement("boolean", QString::number( *((bool *) Q7B_Object->ref) ));

    } else if (Q7B_Object->type == typeid(Q7B_List).name()){
      return ((Q7B_List *) Q7B_Object->ref)->toXML(xmlWriter);

    } else if (Q7B_Object->type == typeid(Q7B_Dictionary).name()){
      return ((Q7B_Dictionary *) Q7B_Object->ref)->toXML(xmlWriter);

    } else if (Q7B_Object->type == typeid(QByteArray).name()){    
      QByteArray ba = *((QByteArray *) Q7B_Object->ref);
      xmlWriter.writeTextElement("QByteArray", QString(ba.toBase64()) );

    } else if (Q7B_Object->type == typeid(QIcon).name()){    
      QByteArray ba = Q7B_QIcon2QByteArray(*((QIcon *) Q7B_Object->ref));
      xmlWriter.writeTextElement("QIcon", QString(ba.toBase64()) );

    //} else if (Q7B_Object->type == typeid(Data).name()){
  //    return ((Data *) Q7B_Object->ref)->toXML(xmlWriter);

    } else if (Q7B_Object->type == typeid(QString).name()){
      xmlWriter.writeTextElement("string", *((QString *) Q7B_Object->ref) );

    } else {
      // expected to be string
      xmlWriter.writeTextElement("string", QString("%1: %2").arg(QString(Q7B_Object->type)).arg((qint64) Q7B_Object->ref) );
    }
  }
  return ;
}




QMap<QString, QSqlDatabase> Q7B_Database::databases; 
QMap<QString, QSqlQuery *> Q7B_Database::records;
QMap<QString, QString> Q7B_Database::records_database;
QMap<QString, QString> Q7B_Database::records_table;

QSqlDatabase Q7B_Database::_CurrentDatabase;

QString Q7B_Database::sLastSQLError;

QMap<QString, QString> Q7B_Database::sLastSQLCommands;
QMap<QString, QString> Q7B_Database::sLastSQLCommandFailed;


QList<Q7B> Q7B_binds;


bool Q7B_nil(Q7B o){
 // QString s = QString("%1 %2 %3").arg((int) o.type).arg((int) o->ref).arg((int) o.count);
 // QMessageBox::information(0, "nil", s);

//  return /*o.isNull() || */((QString(o->type) == 0 || o->ref == 0) && o->q7b_array == 0);
  return /*o.isNull() || */(((o->type) == 0 || o->ref == 0) && o->q7b_array == 0);
}


qreal Q7B_toFloat2(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return 0; }

  if (Q7B_Object->type == typeid(qreal).name()){
    return *((qreal *) Q7B_Object->ref);

  } else if (Q7B_Object->type == typeid(qint64).name()){
    return *((qint64 *) Q7B_Object->ref);

  } else if (Q7B_Object->type == typeid(Q7B_Decimal).name()){
    return ((Q7B_Decimal *) Q7B_Object->ref)->toFloat();
/*
  } else if (Q7B_Object->type == typeid(bool).name()){
    return *((bool *) Q7B_Object->ref);*/
  }

  Q7B_EXCEPTION("Float expected");
  return 0;
}

qint64 Q7B_toInteger2(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return 0; }

  if (Q7B_Object->type == typeid(qint64).name()){
    return *((qint64 *) Q7B_Object->ref);

  } else if (Q7B_Object->type == typeid(qreal).name()){
    return *((qreal *) Q7B_Object->ref);

  } else if (Q7B_Object->type == typeid(Q7B_Decimal).name()){
    return ((Q7B_Decimal *) Q7B_Object->ref)->toInteger();
/*
  } else if (Q7B_Object->type == typeid(bool).name()){
    return *((bool *) Q7B_Object->ref);*/
  }

  Q7B_EXCEPTION("Integer expected");
  return 0;
}

bool Q7B_toBoolean2(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return 0; }

  if (Q7B_Object->type == typeid(qint64).name()){
    return *((qint64 *) Q7B_Object->ref) != 0;

  } else if (Q7B_Object->type == typeid(qreal).name()){
    return *((qreal *) Q7B_Object->ref) != 0;

  } else if (Q7B_Object->type == typeid(Q7B_Decimal).name()){
    return ((Q7B_Decimal *) Q7B_Object->ref)->toInteger() != 0;

  } else if (Q7B_Object->type == typeid(bool).name()){
    return *((bool *) Q7B_Object->ref);
 
  } else if (Q7B_Object->type == typeid(QString).name()){// needed for If s Then   ' s As String
    return !((QString *) Q7B_Object->ref)->isEmpty();
 
  }

  Q7B_EXCEPTION("Boolean expected");
  return 0;
}


bool Q7B_connect(QObject *a, const char * _signal, QObject *b, QString _slot)
{
  QString signal = QString("2") + _signal;
  QString slot = QString("1") + _slot;

  if (QObject::connect((QObject *) a, signal.toAscii().constData(), (QObject *) b, slot.toAscii().constData())){
    return true;
  }
  return false;
}

void Q7B_connectSlotsByName(QObject *Me, QObject *Parent)
{
  
//  QObject *SAVE = Me->parent();

  QString sObjectName = QString("on_") + Me->objectName() + "_";

  const QMetaObject* metaObject = Me->metaObject();
  const QMetaObject* metaObject2 = Parent->metaObject();

  QHash<QString, bool> connected; // surpress optional paramater of signals, which are not used by Q7Basic, but would make more connections when allowed

  do {

    for(int i = metaObject->methodOffset(); i < metaObject->methodCount(); i++){
      QByteArray baSignal = metaObject->normalizedSignature(metaObject->method(i).signature());
      if (metaObject->indexOfSignal(baSignal) >= 0){

        QByteArray baSlot = metaObject2->normalizedSignature(QString(sObjectName + metaObject->method(i).signature()).toAscii().constData());

        QString sSlot = QString::fromAscii(baSlot);
        int n = sSlot.indexOf("(");
        sSlot = sSlot.left(n);

        if (metaObject2->indexOfSlot(baSlot) >= 0){
          if (QMetaObject::checkConnectArgs(baSignal.constData(), baSlot.constData())){          

            if (!connected.contains(sSlot) && Q7B_connect(Me, baSignal.constData(), Parent, baSlot.constData())){

              connected[sSlot] = true;
/*
              if (sObjectName.contains("on_p_")){
                QMessageBox::information(0, metaObject->className(), QString::fromAscii(baSlot));

              }*/
           
            }
          }
        }

      }

    }
  } while ((metaObject = metaObject->superClass()));
  
}

QObject *Q7B_connectSlotsByNameForGivenObjectAndReturnIt(QObject *parent, QObject *o, const char *objectName)
{  
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);
  Q7B_connectSlotsByName((QObject *) o, parent);

  return o;
}

void *Q7B_connectSlotsByNameWithNewAndReturnIt(void *_Me, QObject *Parent)
{  
  Q7B_connectSlotsByName((QObject *) _Me, Parent);
  return _Me;
}

void Q7B_RECONNECTSIGNALS(Q7B Argument, QObject *Q7B_Parent)
{  
  if (Q7B_nil(Argument)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  QObject *o = (QObject *) Argument->ref; 
  Q7B_connectSlotsByName(o, Q7B_Parent);//(QObject *) o->property("Parent").toLongLong());
}


// ***



// *** Assignment
/*
Q7B Q7B__ID(bool o)
{
  Q7B q (new Q7B_id(typeid(bool).name(), new bool(o))); 
  return q;
}

Q7B Q7B__ID(char * o)
{
  Q7B q (new Q7B_id(typeid(QString).name(), new QString(o))); 
  return q;
}

Q7B Q7B__ID(const char * o)
{
  Q7B q (new Q7B_id(typeid(QString).name(), new QString(o))); 
  return q;
}

Q7B Q7B__ID(QString o)
{
  Q7B q (new Q7B_id(typeid(QString).name(), new QString(o))); 
  return q;
}

Q7B Q7B__ID(qint8 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B__ID(qint16 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B__ID(qint32 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B__ID(qint64 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B__ID(float o)
{
  Q7B q (new Q7B_id(typeid(qreal).name(), new qreal(o))); 
  return q;
}

Q7B Q7B__ID(double o)
{
  Q7B q (new Q7B_id(typeid(qreal).name(), new qreal(o))); 
  return q;
}

Q7B Q7B__ID(QStringList o)
{
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(o))); 
  return q;
}

Q7B Q7B__ID(QDateTime o)
{
  Q7B q (new Q7B_id(typeid(QDateTime).name(), new QDateTime(o))); 
  return q;
}
*/


Q7B Q7B__BOOLEAN(Q7B o)
{
  if (QString(o->type) == typeid(bool).name()){
    return o;
  }
  if (QString(o->type) == typeid(qint64).name()){ // auto-cast from Integer
    return Q7B_ID((bool) *((qint64*) o->ref));
  }
  if (QString(o->type) == typeid(qreal).name()){ // auto-cast from Float
    return Q7B_ID((bool) *((qreal*) o->ref));
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION(QString("'Boolean' for assignment expected, tried '%1'").arg(o->type));
  return Q7B_idnil;  
}

Q7B Q7B__ID(Q7B o)
{
  return o;
}

Q7B Q7B__QSTRINGLIST(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QStringList).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  if (Q7B_Object->type == typeid(Q7B_List).name()) return Q7B_ID(Q7B_IDQ7B_List(Q7B_Object)->toStringList());

  Q7B_CASTEXCEPTION("'QStringList' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__STRING(Q7B o)
{
  if (QString(o->type) == typeid(QString).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION(QString("'String' for assignment expected, tried '%1'").arg(o->type));
  return Q7B_idnil;  
}
Q7B Q7B__CSTRING(Q7B o){ return Q7B__STRING(o); }

Q7B Q7B__INTEGER(Q7B o)
{
  if (QString(o->type) == typeid(qint64).name()){
    return o;
  }
  if (QString(o->type) == typeid(qreal).name()){ // auto-cast from Float
    return Q7B_ID((qint64) *((qreal*) o->ref));
  }
  if (QString(o->type) == typeid(bool).name()){ // auto-cast from Boolean
    return Q7B_ID((qint64) *((bool*) o->ref));
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION(QString("'Integer' for assignment expected, tried '%1'").arg(o->type));
  return Q7B_idnil;  
}
Q7B Q7B__BYTE(Q7B o){ return Q7B__INTEGER(o); }
Q7B Q7B__SHORT(Q7B o){ return Q7B__INTEGER(o); }
Q7B Q7B__INT8(Q7B o){ return Q7B__INTEGER(o); }
Q7B Q7B__INT16(Q7B o){ return Q7B__INTEGER(o); }
Q7B Q7B__INT32(Q7B o){ return Q7B__INTEGER(o); }
Q7B Q7B__INT64(Q7B o){ return Q7B__INTEGER(o); }

Q7B Q7B__FLOAT(Q7B o)
{
  if (QString(o->type) == typeid(qreal).name()){
    return o;
  }
  if (QString(o->type) == typeid(qint64).name()){ // auto-cast from Integer
    return Q7B_ID((qreal) *((qint64*) o->ref));
  }
  if (QString(o->type) == typeid(bool).name()){ // auto-cast from Boolean
    return Q7B_ID((qreal) *((bool*) o->ref));
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION(QString("'Float' for assignment expected, tried '%1'").arg(o->type));
  return Q7B_idnil;  
}
Q7B Q7B__SINGLE(Q7B o){ return Q7B__FLOAT(o); }
Q7B Q7B__DOUBLE(Q7B o){ return Q7B__FLOAT(o); }

Q7B Q7B__DATETIME(Q7B o)
{
  if (QString(o->type) == typeid(QDateTime).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION(QString("'DateTime' for assignment expected, tried '%1'").arg(o->type));
  return Q7B_idnil;  
}

Q7B Q7B__DECIMAL(Q7B o)
{
  if (QString(o->type) == typeid(Q7B_Decimal).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION(QString("'Decimal' for assignment expected, tried '%1'").arg(o->type));
  return Q7B_idnil;  
}

Q7B Q7B__LIST(Q7B o)
{
  if (QString(o->type) == typeid(Q7B_List).name()){
    return o;
  }
  if (QString(o->type) == typeid(QStringList).name()){
    Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(Q7B_IDQStringList(o)))); 
    return q;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION(QString("'List' for assignment expected, tried '%1'").arg(o->type));
  return Q7B_idnil;  
}

Q7B Q7B__DICTIONARY(Q7B o)
{
  if (QString(o->type) == typeid(Q7B_Dictionary).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION(QString("'Dictionary' for assignment expected, tried '%1'").arg(o->type));  
  return Q7B_idnil;  
}

Q7B Q7B__DATA(Q7B o)
{
  if (QString(o->type) == typeid(Q7B_Data).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION(QString("'Data' for assignment expected, tried '%1'").arg(o->type));  
  return Q7B_idnil;  
}

// ***



Q7B Q7B_BOOLEAN(Q7B o)
{
  if (QString(o->type) == typeid(bool).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION("'Boolean' expected");

  return Q7B_idnil;
}

Q7B Q7B_QSTRINGLIST(Q7B o)
{
  if (o->type == typeid(QStringList).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION("'QStringList' expected");

  return Q7B_idnil;
}

Q7B Q7B_QSTRING(Q7B o)
{
  if (o->type == typeid(QString).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION("'String' expected");

  return Q7B_idnil;
}
Q7B Q7B_CSTRING(Q7B o){ return Q7B_QSTRING(o); }

Q7B Q7B_INTEGER(Q7B o)
{
  if (QString(o->type) == typeid(qint64).name()){
    return o;
  }
  if (QString(o->type) == typeid(qreal).name()){
    return Q7B_ID( (qint64) (*((qreal *) o->ref)) );  
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION("Integer type expected");

  return Q7B_idnil;
}

Q7B Q7B_BYTE(Q7B o){ return Q7B_INTEGER(o); }
Q7B Q7B_SHORT(Q7B o){ return Q7B_INTEGER(o); }
Q7B Q7B_INT8(Q7B o){ return Q7B_INTEGER(o); }
Q7B Q7B_INT16(Q7B o){ return Q7B_INTEGER(o); }
Q7B Q7B_INT32(Q7B o){ return Q7B_INTEGER(o); }
Q7B Q7B_INT64(Q7B o){ return Q7B_INTEGER(o); }

Q7B Q7B_FLOAT(Q7B o)
{
  //checker();

  if (QString(o->type) == typeid(qreal).name()){
    return o;
  }
  if (QString(o->type) == typeid(qint64).name()){
    return Q7B_ID( (qreal) (*((qint64 *) o->ref)) );  
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION("Float type expected");

  return Q7B_idnil;
}
Q7B Q7B_SINGLE(Q7B o){ return Q7B_FLOAT(o); }
Q7B Q7B_DOUBLE(Q7B o){ return Q7B_FLOAT(o); }

Q7B Q7B_DATETIME(Q7B o)
{
  if (QString(o->type) == typeid(QDateTime).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION("DateTime expected");
  return Q7B_idnil;
}

Q7B Q7B_DECIMAL(Q7B o)
{
  if (QString(o->type) == typeid(Q7B_Decimal).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION("Decimal expected");
  return Q7B_idnil;
}
/*
Q7B Q7B_QSIZE(Q7B o)
{
  if (QString(o->type) == typeid(QSize).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  return Q7B_idnil;
}

Q7B Q7B_QRECT(Q7B o)
{
  if (QString(o->type) == typeid(QRect).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  return Q7B_idnil;
}*/

Q7B Q7B_LIST(Q7B o)
{
  if (QString(o->type) == typeid(Q7B_List).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION("List expected");
  return Q7B_idnil;
}

Q7B Q7B_DICTIONARY(Q7B o)
{
  if (QString(o->type) == typeid(Q7B_Dictionary).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION("Dictionary expected");
  return Q7B_idnil;
}


Q7B Q7B_DATA(Q7B o)
{
  if (QString(o->type) == typeid(Q7B_Data).name()){
    return o;
  }
  if (Q7B_nil(o)){
    return o;
  }

  Q7B_CASTEXCEPTION("Data expected");
  return Q7B_idnil;
}









// Begin Generator h#1
Q7B Q7B_CLASS(Q7B Q7B_Object)
{
  if (qobject_cast<QObject *>((QObject* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'Class' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__CLASS(Q7B Q7B_Object)
{
  if (qobject_cast<QObject *>((QObject* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'Class' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_FORMCLASS(Q7B Q7B_Object)
{
  if (qobject_cast<QObject *>((QObject* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'FormClass' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__FORMCLASS(Q7B Q7B_Object)
{
  if (qobject_cast<QObject *>((QObject* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'FormClass' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_MODULE(Q7B Q7B_Object)
{
  if (qobject_cast<QObject *>((QObject* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'Module' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__MODULE(Q7B Q7B_Object)
{
  if (qobject_cast<QObject *>((QObject* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'Module' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_PHONONSEEKSLIDER(Q7B Q7B_Object)
{
  if (qobject_cast<Phonon::SeekSlider *>((Phonon::SeekSlider* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'PhononSeekSlider' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__PHONONSEEKSLIDER(Q7B Q7B_Object)
{
  if (qobject_cast<Phonon::SeekSlider *>((Phonon::SeekSlider* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'PhononSeekSlider' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Phonon::SeekSlider* o)
{
  Q7B q (new Q7B_id(typeid(Phonon::SeekSlider).name(), o));
  return q;
}

Q7B Q7B_PHONONVIDEOPLAYER(Q7B Q7B_Object)
{
  if (qobject_cast<Phonon::VideoPlayer *>((Phonon::VideoPlayer* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'PhononVideoPlayer' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__PHONONVIDEOPLAYER(Q7B Q7B_Object)
{
  if (qobject_cast<Phonon::VideoPlayer *>((Phonon::VideoPlayer* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'PhononVideoPlayer' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Phonon::VideoPlayer* o)
{
  Q7B q (new Q7B_id(typeid(Phonon::VideoPlayer).name(), o));
  return q;
}

Q7B Q7B_PHONONVOLUMESLIDER(Q7B Q7B_Object)
{
  if (qobject_cast<Phonon::VolumeSlider *>((Phonon::VolumeSlider* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'PhononVolumeSlider' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__PHONONVOLUMESLIDER(Q7B Q7B_Object)
{
  if (qobject_cast<Phonon::VolumeSlider *>((Phonon::VolumeSlider* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'PhononVolumeSlider' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Phonon::VolumeSlider* o)
{
  Q7B q (new Q7B_id(typeid(Phonon::VolumeSlider).name(), o));
  return q;
}

Q7B Q7B_QABSTRACTBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractButton *>((QAbstractButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QABSTRACTBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractButton *>((QAbstractButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QAbstractButton* o)
{
  Q7B q (new Q7B_id(typeid(QAbstractButton).name(), o));
  return q;
}

Q7B Q7B_QABSTRACTITEMMODEL(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractItemModel *>((QAbstractItemModel* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractItemModel' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QABSTRACTITEMMODEL(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractItemModel *>((QAbstractItemModel* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractItemModel' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QAbstractItemModel* o)
{
  Q7B q (new Q7B_id(typeid(QAbstractItemModel).name(), o));
  return q;
}

Q7B Q7B_QABSTRACTITEMVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractItemView *>((QAbstractItemView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractItemView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QABSTRACTITEMVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractItemView *>((QAbstractItemView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractItemView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QAbstractItemView* o)
{
  Q7B q (new Q7B_id(typeid(QAbstractItemView).name(), o));
  return q;
}

Q7B Q7B_QABSTRACTPRINTDIALOG(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractPrintDialog *>((QAbstractPrintDialog* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractPrintDialog' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QABSTRACTPRINTDIALOG(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractPrintDialog *>((QAbstractPrintDialog* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractPrintDialog' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QAbstractPrintDialog* o)
{
  Q7B q (new Q7B_id(typeid(QAbstractPrintDialog).name(), o));
  return q;
}

Q7B Q7B_QABSTRACTSCROLLAREA(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractScrollArea *>((QAbstractScrollArea* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractScrollArea' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QABSTRACTSCROLLAREA(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractScrollArea *>((QAbstractScrollArea* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractScrollArea' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QAbstractScrollArea* o)
{
  Q7B q (new Q7B_id(typeid(QAbstractScrollArea).name(), o));
  return q;
}

Q7B Q7B_QABSTRACTSLIDER(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractSlider *>((QAbstractSlider* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractSlider' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QABSTRACTSLIDER(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractSlider *>((QAbstractSlider* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractSlider' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QAbstractSlider* o)
{
  Q7B q (new Q7B_id(typeid(QAbstractSlider).name(), o));
  return q;
}

Q7B Q7B_QABSTRACTSPINBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractSpinBox *>((QAbstractSpinBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractSpinBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QABSTRACTSPINBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractSpinBox *>((QAbstractSpinBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractSpinBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QAbstractSpinBox* o)
{
  Q7B q (new Q7B_id(typeid(QAbstractSpinBox).name(), o));
  return q;
}

Q7B Q7B_QABSTRACTTEXTDOCUMENTLAYOUT(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractTextDocumentLayout *>((QAbstractTextDocumentLayout* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractTextDocumentLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QABSTRACTTEXTDOCUMENTLAYOUT(Q7B Q7B_Object)
{
  if (qobject_cast<QAbstractTextDocumentLayout *>((QAbstractTextDocumentLayout* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAbstractTextDocumentLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QAbstractTextDocumentLayout* o)
{
  Q7B q (new Q7B_id(typeid(QAbstractTextDocumentLayout).name(), o));
  return q;
}

Q7B Q7B_QACCESSIBLEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QAccessibleEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAccessibleEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QACCESSIBLEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QAccessibleEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAccessibleEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QAccessibleEvent* o)
{
  Q7B q (new Q7B_id(typeid(QAccessibleEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QAccessibleEvent o)
{
  Q7B q (new Q7B_id(typeid(QAccessibleEvent).name(), new QAccessibleEvent(o)));
  return q;
}

Q7B Q7B_QACTION(Q7B Q7B_Object)
{
  if (qobject_cast<QAction *>((QAction* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAction' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QACTION(Q7B Q7B_Object)
{
  if (qobject_cast<QAction *>((QAction* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QAction' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QAction* o)
{
  Q7B q (new Q7B_id(typeid(QAction).name(), o));
  return q;
}

Q7B Q7B_QACTIONEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QActionEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QActionEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QACTIONEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QActionEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QActionEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QActionEvent* o)
{
  Q7B q (new Q7B_id(typeid(QActionEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QActionEvent o)
{
  Q7B q (new Q7B_id(typeid(QActionEvent).name(), new QActionEvent(o)));
  return q;
}

Q7B Q7B_QACTIONGROUP(Q7B Q7B_Object)
{
  if (qobject_cast<QActionGroup *>((QActionGroup* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QActionGroup' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QACTIONGROUP(Q7B Q7B_Object)
{
  if (qobject_cast<QActionGroup *>((QActionGroup* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QActionGroup' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QActionGroup* o)
{
  Q7B q (new Q7B_id(typeid(QActionGroup).name(), o));
  return q;
}

Q7B Q7B_QAPPLICATION(Q7B Q7B_Object)
{
  if (qobject_cast<QApplication *>((QApplication* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QApplication' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QAPPLICATION(Q7B Q7B_Object)
{
  if (qobject_cast<QApplication *>((QApplication* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QApplication' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QApplication* o)
{
  Q7B q (new Q7B_id(typeid(QApplication).name(), o));
  return q;
}

Q7B Q7B_QBITMAP(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QBitmap).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QBitmap' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QBITMAP(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QBitmap).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QBitmap' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QBitmap* o)
{
  Q7B q (new Q7B_id(typeid(QBitmap).name(), o));
  return q;
}

Q7B Q7B_ID(QBitmap o)
{
  Q7B q (new Q7B_id(typeid(QBitmap).name(), new QBitmap(o)));
  return q;
}

Q7B Q7B_QBOXLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QBoxLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QBoxLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QBOXLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QBoxLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QBoxLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QBoxLayout* o)
{
  Q7B q (new Q7B_id(typeid(QBoxLayout).name(), o));
  return q;
}

Q7B Q7B_QBRUSH(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QBrush).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QBrush' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QBRUSH(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QBrush).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QBrush' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QBrush* o)
{
  Q7B q (new Q7B_id(typeid(QBrush).name(), o));
  return q;
}

Q7B Q7B_ID(QBrush o)
{
  Q7B q (new Q7B_id(typeid(QBrush).name(), new QBrush(o)));
  return q;
}

Q7B Q7B_QBUTTONGROUP(Q7B Q7B_Object)
{
  if (qobject_cast<QButtonGroup *>((QButtonGroup* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QButtonGroup' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QBUTTONGROUP(Q7B Q7B_Object)
{
  if (qobject_cast<QButtonGroup *>((QButtonGroup* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QButtonGroup' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QButtonGroup* o)
{
  Q7B q (new Q7B_id(typeid(QButtonGroup).name(), o));
  return q;
}

Q7B Q7B_QBYTEARRAY(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QByteArray).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QByteArray' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QBYTEARRAY(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QByteArray).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QByteArray' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QByteArray* o)
{
  Q7B q (new Q7B_id(typeid(QByteArray).name(), o));
  return q;
}

Q7B Q7B_ID(QByteArray o)
{
  Q7B q (new Q7B_id(typeid(QByteArray).name(), new QByteArray(o)));
  return q;
}

Q7B Q7B_QCALENDARWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QCalendarWidget *>((QCalendarWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCalendarWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCALENDARWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QCalendarWidget *>((QCalendarWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCalendarWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QCalendarWidget* o)
{
  Q7B q (new Q7B_id(typeid(QCalendarWidget).name(), o));
  return q;
}

Q7B Q7B_QCHAR(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QChar).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QChar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCHAR(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QChar).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QChar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QChar* o)
{
  Q7B q (new Q7B_id(typeid(QChar).name(), o));
  return q;
}

Q7B Q7B_ID(QChar o)
{
  Q7B q (new Q7B_id(typeid(QChar).name(), new QChar(o)));
  return q;
}

Q7B Q7B_QCHECKBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QCheckBox *>((QCheckBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCheckBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCHECKBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QCheckBox *>((QCheckBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCheckBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QCheckBox* o)
{
  Q7B q (new Q7B_id(typeid(QCheckBox).name(), o));
  return q;
}

Q7B Q7B_QCHILDEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QChildEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QChildEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCHILDEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QChildEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QChildEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QChildEvent* o)
{
  Q7B q (new Q7B_id(typeid(QChildEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QChildEvent o)
{
  Q7B q (new Q7B_id(typeid(QChildEvent).name(), new QChildEvent(o)));
  return q;
}

Q7B Q7B_QCLIPBOARD(Q7B Q7B_Object)
{
  if (qobject_cast<QClipboard *>((QClipboard* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QClipboard' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCLIPBOARD(Q7B Q7B_Object)
{
  if (qobject_cast<QClipboard *>((QClipboard* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QClipboard' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QClipboard* o)
{
  Q7B q (new Q7B_id(typeid(QClipboard).name(), o));
  return q;
}

Q7B Q7B_QCLOSEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QCloseEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCloseEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCLOSEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QCloseEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCloseEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QCloseEvent* o)
{
  Q7B q (new Q7B_id(typeid(QCloseEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QCloseEvent o)
{
  Q7B q (new Q7B_id(typeid(QCloseEvent).name(), new QCloseEvent(o)));
  return q;
}

Q7B Q7B_QCOLOR(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QColor).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QColor' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCOLOR(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QColor).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QColor' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QColor* o)
{
  Q7B q (new Q7B_id(typeid(QColor).name(), o));
  return q;
}

Q7B Q7B_ID(QColor o)
{
  Q7B q (new Q7B_id(typeid(QColor).name(), new QColor(o)));
  return q;
}

Q7B Q7B_QCOLUMNVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QColumnView *>((QColumnView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QColumnView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCOLUMNVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QColumnView *>((QColumnView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QColumnView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QColumnView* o)
{
  Q7B q (new Q7B_id(typeid(QColumnView).name(), o));
  return q;
}

Q7B Q7B_QCOMBOBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QComboBox *>((QComboBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QComboBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCOMBOBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QComboBox *>((QComboBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QComboBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QComboBox* o)
{
  Q7B q (new Q7B_id(typeid(QComboBox).name(), o));
  return q;
}

Q7B Q7B_QCOMMANDLINKBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<QCommandLinkButton *>((QCommandLinkButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCommandLinkButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCOMMANDLINKBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<QCommandLinkButton *>((QCommandLinkButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCommandLinkButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QCommandLinkButton* o)
{
  Q7B q (new Q7B_id(typeid(QCommandLinkButton).name(), o));
  return q;
}

Q7B Q7B_QCOMPLETER(Q7B Q7B_Object)
{
  if (qobject_cast<QCompleter *>((QCompleter* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCompleter' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCOMPLETER(Q7B Q7B_Object)
{
  if (qobject_cast<QCompleter *>((QCompleter* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCompleter' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QCompleter* o)
{
  Q7B q (new Q7B_id(typeid(QCompleter).name(), o));
  return q;
}

Q7B Q7B_QCONTEXTMENUEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QContextMenuEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QContextMenuEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCONTEXTMENUEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QContextMenuEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QContextMenuEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QContextMenuEvent* o)
{
  Q7B q (new Q7B_id(typeid(QContextMenuEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QContextMenuEvent o)
{
  Q7B q (new Q7B_id(typeid(QContextMenuEvent).name(), new QContextMenuEvent(o)));
  return q;
}

Q7B Q7B_QCOREAPPLICATION(Q7B Q7B_Object)
{
  if (qobject_cast<QCoreApplication *>((QCoreApplication* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCoreApplication' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCOREAPPLICATION(Q7B Q7B_Object)
{
  if (qobject_cast<QCoreApplication *>((QCoreApplication* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCoreApplication' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QCoreApplication* o)
{
  Q7B q (new Q7B_id(typeid(QCoreApplication).name(), o));
  return q;
}

Q7B Q7B_QCURSOR(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QCursor).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCursor' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QCURSOR(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QCursor).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QCursor' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QCursor* o)
{
  Q7B q (new Q7B_id(typeid(QCursor).name(), o));
  return q;
}

Q7B Q7B_ID(QCursor o)
{
  Q7B q (new Q7B_id(typeid(QCursor).name(), new QCursor(o)));
  return q;
}

Q7B Q7B_QDATE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDate).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDate' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDATE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDate).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDate' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDate* o)
{
  Q7B q (new Q7B_id(typeid(QDate).name(), o));
  return q;
}

Q7B Q7B_ID(QDate o)
{
  Q7B q (new Q7B_id(typeid(QDate).name(), new QDate(o)));
  return q;
}

Q7B Q7B_QDATEEDIT(Q7B Q7B_Object)
{
  if (qobject_cast<QDateEdit *>((QDateEdit* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDateEdit' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDATEEDIT(Q7B Q7B_Object)
{
  if (qobject_cast<QDateEdit *>((QDateEdit* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDateEdit' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDateEdit* o)
{
  Q7B q (new Q7B_id(typeid(QDateEdit).name(), o));
  return q;
}

Q7B Q7B_QDATETIME(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDateTime).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDateTime' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDATETIME(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDateTime).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDateTime' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDateTime* o)
{
  Q7B q (new Q7B_id(typeid(QDateTime).name(), o));
  return q;
}

Q7B Q7B_ID(QDateTime o)
{
  Q7B q (new Q7B_id(typeid(QDateTime).name(), new QDateTime(o)));
  return q;
}

Q7B Q7B_QDATETIMEEDIT(Q7B Q7B_Object)
{
  if (qobject_cast<QDateTimeEdit *>((QDateTimeEdit* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDateTimeEdit' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDATETIMEEDIT(Q7B Q7B_Object)
{
  if (qobject_cast<QDateTimeEdit *>((QDateTimeEdit* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDateTimeEdit' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDateTimeEdit* o)
{
  Q7B q (new Q7B_id(typeid(QDateTimeEdit).name(), o));
  return q;
}

Q7B Q7B_QDECLARATIVECONTEXT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDeclarativeContext).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDeclarativeContext' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDECLARATIVECONTEXT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDeclarativeContext).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDeclarativeContext' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDeclarativeContext* o)
{
  Q7B q (new Q7B_id(typeid(QDeclarativeContext).name(), o));
  return q;
}

Q7B Q7B_QDECLARATIVEVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QDeclarativeView *>((QDeclarativeView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDeclarativeView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDECLARATIVEVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QDeclarativeView *>((QDeclarativeView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDeclarativeView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDeclarativeView* o)
{
  Q7B q (new Q7B_id(typeid(QDeclarativeView).name(), o));
  return q;
}

Q7B Q7B_QDIAL(Q7B Q7B_Object)
{
  if (qobject_cast<QDial *>((QDial* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDial' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDIAL(Q7B Q7B_Object)
{
  if (qobject_cast<QDial *>((QDial* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDial' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDial* o)
{
  Q7B q (new Q7B_id(typeid(QDial).name(), o));
  return q;
}

Q7B Q7B_QDIALOG(Q7B Q7B_Object)
{
  if (qobject_cast<QDialog *>((QDialog* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDialog' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDIALOG(Q7B Q7B_Object)
{
  if (qobject_cast<QDialog *>((QDialog* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDialog' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDialog* o)
{
  Q7B q (new Q7B_id(typeid(QDialog).name(), o));
  return q;
}

Q7B Q7B_QDIALOGBUTTONBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QDialogButtonBox *>((QDialogButtonBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDialogButtonBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDIALOGBUTTONBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QDialogButtonBox *>((QDialogButtonBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDialogButtonBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDialogButtonBox* o)
{
  Q7B q (new Q7B_id(typeid(QDialogButtonBox).name(), o));
  return q;
}

Q7B Q7B_QDIR(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDir).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDir' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDIR(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDir).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDir' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDir* o)
{
  Q7B q (new Q7B_id(typeid(QDir).name(), o));
  return q;
}

Q7B Q7B_ID(QDir o)
{
  Q7B q (new Q7B_id(typeid(QDir).name(), new QDir(o)));
  return q;
}

Q7B Q7B_QDOCKWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QDockWidget *>((QDockWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDockWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDOCKWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QDockWidget *>((QDockWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDockWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDockWidget* o)
{
  Q7B q (new Q7B_id(typeid(QDockWidget).name(), o));
  return q;
}

Q7B Q7B_QDOUBLESPINBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QDoubleSpinBox *>((QDoubleSpinBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDoubleSpinBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDOUBLESPINBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QDoubleSpinBox *>((QDoubleSpinBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDoubleSpinBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDoubleSpinBox* o)
{
  Q7B q (new Q7B_id(typeid(QDoubleSpinBox).name(), o));
  return q;
}

Q7B Q7B_QDRAG(Q7B Q7B_Object)
{
  if (qobject_cast<QDrag *>((QDrag* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDrag' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDRAG(Q7B Q7B_Object)
{
  if (qobject_cast<QDrag *>((QDrag* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDrag' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDrag* o)
{
  Q7B q (new Q7B_id(typeid(QDrag).name(), o));
  return q;
}

Q7B Q7B_QDRAGLEAVEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDragLeaveEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDragLeaveEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDRAGLEAVEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDragLeaveEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDragLeaveEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDragLeaveEvent* o)
{
  Q7B q (new Q7B_id(typeid(QDragLeaveEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QDragLeaveEvent o)
{
  Q7B q (new Q7B_id(typeid(QDragLeaveEvent).name(), new QDragLeaveEvent(o)));
  return q;
}

Q7B Q7B_QDROPEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDropEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDropEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDROPEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDropEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDropEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDropEvent* o)
{
  Q7B q (new Q7B_id(typeid(QDropEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QDropEvent o)
{
  Q7B q (new Q7B_id(typeid(QDropEvent).name(), new QDropEvent(o)));
  return q;
}

Q7B Q7B_QDYNAMICPROPERTYCHANGEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDynamicPropertyChangeEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDynamicPropertyChangeEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QDYNAMICPROPERTYCHANGEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QDynamicPropertyChangeEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QDynamicPropertyChangeEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QDynamicPropertyChangeEvent* o)
{
  Q7B q (new Q7B_id(typeid(QDynamicPropertyChangeEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QDynamicPropertyChangeEvent o)
{
  Q7B q (new Q7B_id(typeid(QDynamicPropertyChangeEvent).name(), new QDynamicPropertyChangeEvent(o)));
  return q;
}

Q7B Q7B_QELAPSEDTIMER(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QElapsedTimer).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QElapsedTimer' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QELAPSEDTIMER(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QElapsedTimer).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QElapsedTimer' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QElapsedTimer* o)
{
  Q7B q (new Q7B_id(typeid(QElapsedTimer).name(), o));
  return q;
}

Q7B Q7B_ID(QElapsedTimer o)
{
  Q7B q (new Q7B_id(typeid(QElapsedTimer).name(), new QElapsedTimer(o)));
  return q;
}

Q7B Q7B_QEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QEvent* o)
{
  Q7B q (new Q7B_id(typeid(QEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QEvent o)
{
  Q7B q (new Q7B_id(typeid(QEvent).name(), new QEvent(o)));
  return q;
}

Q7B Q7B_QFILEINFO(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFileInfo).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFileInfo' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QFILEINFO(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFileInfo).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFileInfo' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QFileInfo* o)
{
  Q7B q (new Q7B_id(typeid(QFileInfo).name(), o));
  return q;
}

Q7B Q7B_ID(QFileInfo o)
{
  Q7B q (new Q7B_id(typeid(QFileInfo).name(), new QFileInfo(o)));
  return q;
}

Q7B Q7B_QFILEINFOLIST(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFileInfoList).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFileInfoList' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QFILEINFOLIST(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFileInfoList).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFileInfoList' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QFileInfoList* o)
{
  Q7B q (new Q7B_id(typeid(QFileInfoList).name(), o));
  return q;
}

Q7B Q7B_ID(QFileInfoList o)
{
  Q7B q (new Q7B_id(typeid(QFileInfoList).name(), new QFileInfoList(o)));
  return q;
}

Q7B Q7B_QFILEOPENEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFileOpenEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFileOpenEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QFILEOPENEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFileOpenEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFileOpenEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QFileOpenEvent* o)
{
  Q7B q (new Q7B_id(typeid(QFileOpenEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QFileOpenEvent o)
{
  Q7B q (new Q7B_id(typeid(QFileOpenEvent).name(), new QFileOpenEvent(o)));
  return q;
}

Q7B Q7B_QFILESYSTEMWATCHER(Q7B Q7B_Object)
{
  if (qobject_cast<QFileSystemWatcher *>((QFileSystemWatcher* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFileSystemWatcher' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QFILESYSTEMWATCHER(Q7B Q7B_Object)
{
  if (qobject_cast<QFileSystemWatcher *>((QFileSystemWatcher* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFileSystemWatcher' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QFileSystemWatcher* o)
{
  Q7B q (new Q7B_id(typeid(QFileSystemWatcher).name(), o));
  return q;
}

Q7B Q7B_QFOCUSEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFocusEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFocusEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QFOCUSEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFocusEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFocusEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QFocusEvent* o)
{
  Q7B q (new Q7B_id(typeid(QFocusEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QFocusEvent o)
{
  Q7B q (new Q7B_id(typeid(QFocusEvent).name(), new QFocusEvent(o)));
  return q;
}

Q7B Q7B_QFONT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFont).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFont' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QFONT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFont).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFont' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QFont* o)
{
  Q7B q (new Q7B_id(typeid(QFont).name(), o));
  return q;
}

Q7B Q7B_ID(QFont o)
{
  Q7B q (new Q7B_id(typeid(QFont).name(), new QFont(o)));
  return q;
}

Q7B Q7B_QFONTCOMBOBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QFontComboBox *>((QFontComboBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFontComboBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QFONTCOMBOBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QFontComboBox *>((QFontComboBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFontComboBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QFontComboBox* o)
{
  Q7B q (new Q7B_id(typeid(QFontComboBox).name(), o));
  return q;
}

Q7B Q7B_QFONTDATABASE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFontDatabase).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFontDatabase' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QFONTDATABASE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFontDatabase).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFontDatabase' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QFontDatabase* o)
{
  Q7B q (new Q7B_id(typeid(QFontDatabase).name(), o));
  return q;
}

Q7B Q7B_ID(QFontDatabase o)
{
  Q7B q (new Q7B_id(typeid(QFontDatabase).name(), new QFontDatabase(o)));
  return q;
}

Q7B Q7B_QFONTINFO(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFontInfo).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFontInfo' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QFONTINFO(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFontInfo).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFontInfo' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QFontInfo* o)
{
  Q7B q (new Q7B_id(typeid(QFontInfo).name(), o));
  return q;
}

Q7B Q7B_ID(QFontInfo o)
{
  Q7B q (new Q7B_id(typeid(QFontInfo).name(), new QFontInfo(o)));
  return q;
}

Q7B Q7B_QFONTMETRICS(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFontMetrics).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFontMetrics' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QFONTMETRICS(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFontMetrics).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFontMetrics' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QFontMetrics* o)
{
  Q7B q (new Q7B_id(typeid(QFontMetrics).name(), o));
  return q;
}

Q7B Q7B_ID(QFontMetrics o)
{
  Q7B q (new Q7B_id(typeid(QFontMetrics).name(), new QFontMetrics(o)));
  return q;
}

Q7B Q7B_QFORMLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFormLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFormLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QFORMLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QFormLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFormLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QFormLayout* o)
{
  Q7B q (new Q7B_id(typeid(QFormLayout).name(), o));
  return q;
}

Q7B Q7B_QFRAME(Q7B Q7B_Object)
{
  if (qobject_cast<QFrame *>((QFrame* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFrame' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QFRAME(Q7B Q7B_Object)
{
  if (qobject_cast<QFrame *>((QFrame* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFrame' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QFrame* o)
{
  Q7B q (new Q7B_id(typeid(QFrame).name(), o));
  return q;
}

Q7B Q7B_QFTP(Q7B Q7B_Object)
{
  if (qobject_cast<QFtp *>((QFtp* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFtp' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QFTP(Q7B Q7B_Object)
{
  if (qobject_cast<QFtp *>((QFtp* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QFtp' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QFtp* o)
{
  Q7B q (new Q7B_id(typeid(QFtp).name(), o));
  return q;
}

Q7B Q7B_QGRAPHICSSCENEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QGraphicsSceneEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QGraphicsSceneEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QGRAPHICSSCENEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QGraphicsSceneEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QGraphicsSceneEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QGraphicsSceneEvent* o)
{
  Q7B q (new Q7B_id(typeid(QGraphicsSceneEvent).name(), o));
  return q;
}

Q7B Q7B_QGRAPHICSVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QGraphicsView *>((QGraphicsView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QGraphicsView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QGRAPHICSVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QGraphicsView *>((QGraphicsView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QGraphicsView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QGraphicsView* o)
{
  Q7B q (new Q7B_id(typeid(QGraphicsView).name(), o));
  return q;
}

Q7B Q7B_QGRIDLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QGridLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QGridLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QGRIDLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QGridLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QGridLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QGridLayout* o)
{
  Q7B q (new Q7B_id(typeid(QGridLayout).name(), o));
  return q;
}

Q7B Q7B_QGROUPBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QGroupBox *>((QGroupBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QGroupBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QGROUPBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QGroupBox *>((QGroupBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QGroupBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QGroupBox* o)
{
  Q7B q (new Q7B_id(typeid(QGroupBox).name(), o));
  return q;
}

Q7B Q7B_QHBOXLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QHBoxLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHBoxLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QHBOXLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QHBoxLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHBoxLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QHBoxLayout* o)
{
  Q7B q (new Q7B_id(typeid(QHBoxLayout).name(), o));
  return q;
}

Q7B Q7B_QHEADERVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QHeaderView *>((QHeaderView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHeaderView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QHEADERVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QHeaderView *>((QHeaderView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHeaderView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QHeaderView* o)
{
  Q7B q (new Q7B_id(typeid(QHeaderView).name(), o));
  return q;
}

Q7B Q7B_QHELPEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QHelpEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHelpEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QHELPEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QHelpEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHelpEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QHelpEvent* o)
{
  Q7B q (new Q7B_id(typeid(QHelpEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QHelpEvent o)
{
  Q7B q (new Q7B_id(typeid(QHelpEvent).name(), new QHelpEvent(o)));
  return q;
}

Q7B Q7B_QHIDEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QHideEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHideEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QHIDEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QHideEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHideEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QHideEvent* o)
{
  Q7B q (new Q7B_id(typeid(QHideEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QHideEvent o)
{
  Q7B q (new Q7B_id(typeid(QHideEvent).name(), new QHideEvent(o)));
  return q;
}

Q7B Q7B_QHOSTADDRESS(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QHostAddress).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHostAddress' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QHOSTADDRESS(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QHostAddress).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHostAddress' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QHostAddress* o)
{
  Q7B q (new Q7B_id(typeid(QHostAddress).name(), o));
  return q;
}

Q7B Q7B_ID(QHostAddress o)
{
  Q7B q (new Q7B_id(typeid(QHostAddress).name(), new QHostAddress(o)));
  return q;
}

Q7B Q7B_QHOSTINFO(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QHostInfo).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHostInfo' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QHOSTINFO(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QHostInfo).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHostInfo' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QHostInfo* o)
{
  Q7B q (new Q7B_id(typeid(QHostInfo).name(), o));
  return q;
}

Q7B Q7B_ID(QHostInfo o)
{
  Q7B q (new Q7B_id(typeid(QHostInfo).name(), new QHostInfo(o)));
  return q;
}

Q7B Q7B_QHOVEREVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QHoverEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHoverEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QHOVEREVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QHoverEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QHoverEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QHoverEvent* o)
{
  Q7B q (new Q7B_id(typeid(QHoverEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QHoverEvent o)
{
  Q7B q (new Q7B_id(typeid(QHoverEvent).name(), new QHoverEvent(o)));
  return q;
}

Q7B Q7B_QICON(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QIcon).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QIcon' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QICON(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QIcon).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QIcon' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QIcon* o)
{
  Q7B q (new Q7B_id(typeid(QIcon).name(), o));
  return q;
}

Q7B Q7B_ID(QIcon o)
{
  Q7B q (new Q7B_id(typeid(QIcon).name(), new QIcon(o)));
  return q;
}

Q7B Q7B_QICONDRAGEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QIconDragEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QIconDragEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QICONDRAGEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QIconDragEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QIconDragEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QIconDragEvent* o)
{
  Q7B q (new Q7B_id(typeid(QIconDragEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QIconDragEvent o)
{
  Q7B q (new Q7B_id(typeid(QIconDragEvent).name(), new QIconDragEvent(o)));
  return q;
}

Q7B Q7B_QIMAGE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QImage).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QImage' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QIMAGE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QImage).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QImage' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QImage* o)
{
  Q7B q (new Q7B_id(typeid(QImage).name(), o));
  return q;
}

Q7B Q7B_ID(QImage o)
{
  Q7B q (new Q7B_id(typeid(QImage).name(), new QImage(o)));
  return q;
}

Q7B Q7B_QINPUTDIALOG(Q7B Q7B_Object)
{
  if (qobject_cast<QInputDialog *>((QInputDialog* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QInputDialog' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QINPUTDIALOG(Q7B Q7B_Object)
{
  if (qobject_cast<QInputDialog *>((QInputDialog* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QInputDialog' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QInputDialog* o)
{
  Q7B q (new Q7B_id(typeid(QInputDialog).name(), o));
  return q;
}

Q7B Q7B_QINPUTEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QInputEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QInputEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QINPUTEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QInputEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QInputEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QInputEvent* o)
{
  Q7B q (new Q7B_id(typeid(QInputEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QInputEvent o)
{
  Q7B q (new Q7B_id(typeid(QInputEvent).name(), new QInputEvent(o)));
  return q;
}

Q7B Q7B_QINPUTMETHODEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QInputMethodEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QInputMethodEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QINPUTMETHODEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QInputMethodEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QInputMethodEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QInputMethodEvent* o)
{
  Q7B q (new Q7B_id(typeid(QInputMethodEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QInputMethodEvent o)
{
  Q7B q (new Q7B_id(typeid(QInputMethodEvent).name(), new QInputMethodEvent(o)));
  return q;
}

Q7B Q7B_QINTVALIDATOR(Q7B Q7B_Object)
{
  if (qobject_cast<QIntValidator *>((QIntValidator* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QIntValidator' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QINTVALIDATOR(Q7B Q7B_Object)
{
  if (qobject_cast<QIntValidator *>((QIntValidator* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QIntValidator' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QIntValidator* o)
{
  Q7B q (new Q7B_id(typeid(QIntValidator).name(), o));
  return q;
}

Q7B Q7B_QITEMSELECTIONMODEL(Q7B Q7B_Object)
{
  if (qobject_cast<QItemSelectionModel *>((QItemSelectionModel* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QItemSelectionModel' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QITEMSELECTIONMODEL(Q7B Q7B_Object)
{
  if (qobject_cast<QItemSelectionModel *>((QItemSelectionModel* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QItemSelectionModel' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QItemSelectionModel* o)
{
  Q7B q (new Q7B_id(typeid(QItemSelectionModel).name(), o));
  return q;
}

Q7B Q7B_QKEYSEQUENCE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QKeySequence).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QKeySequence' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QKEYSEQUENCE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QKeySequence).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QKeySequence' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QKeySequence* o)
{
  Q7B q (new Q7B_id(typeid(QKeySequence).name(), o));
  return q;
}

Q7B Q7B_ID(QKeySequence o)
{
  Q7B q (new Q7B_id(typeid(QKeySequence).name(), new QKeySequence(o)));
  return q;
}

Q7B Q7B_QLCDNUMBER(Q7B Q7B_Object)
{
  if (qobject_cast<QLCDNumber *>((QLCDNumber* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLCDNumber' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QLCDNUMBER(Q7B Q7B_Object)
{
  if (qobject_cast<QLCDNumber *>((QLCDNumber* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLCDNumber' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QLCDNumber* o)
{
  Q7B q (new Q7B_id(typeid(QLCDNumber).name(), o));
  return q;
}

Q7B Q7B_QLABEL(Q7B Q7B_Object)
{
  if (qobject_cast<QLabel *>((QLabel* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLabel' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QLABEL(Q7B Q7B_Object)
{
  if (qobject_cast<QLabel *>((QLabel* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLabel' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QLabel* o)
{
  Q7B q (new Q7B_id(typeid(QLabel).name(), o));
  return q;
}

Q7B Q7B_QLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QLayout* o)
{
  Q7B q (new Q7B_id(typeid(QLayout).name(), o));
  return q;
}

Q7B Q7B_QLAYOUTITEM(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QLayoutItem).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLayoutItem' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QLAYOUTITEM(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QLayoutItem).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLayoutItem' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QLayoutItem* o)
{
  Q7B q (new Q7B_id(typeid(QLayoutItem).name(), o));
  return q;
}

Q7B Q7B_QLINE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QLine).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLine' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QLINE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QLine).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLine' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QLine* o)
{
  Q7B q (new Q7B_id(typeid(QLine).name(), o));
  return q;
}

Q7B Q7B_ID(QLine o)
{
  Q7B q (new Q7B_id(typeid(QLine).name(), new QLine(o)));
  return q;
}

Q7B Q7B_QLINEEDIT(Q7B Q7B_Object)
{
  if (qobject_cast<QLineEdit *>((QLineEdit* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLineEdit' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QLINEEDIT(Q7B Q7B_Object)
{
  if (qobject_cast<QLineEdit *>((QLineEdit* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLineEdit' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QLineEdit* o)
{
  Q7B q (new Q7B_id(typeid(QLineEdit).name(), o));
  return q;
}

Q7B Q7B_QLISTQSTRINGLIST(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QList<QStringList>).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QListQStringList' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QLISTQSTRINGLIST(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QList<QStringList>).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QListQStringList' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QList<QStringList>* o)
{
  Q7B q (new Q7B_id(typeid(QList<QStringList>).name(), o));
  return q;
}

Q7B Q7B_ID(QList<QStringList> o)
{
  Q7B q (new Q7B_id(typeid(QList<QStringList>).name(), new QList<QStringList>(o)));
  return q;
}

Q7B Q7B_QLISTVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QListView *>((QListView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QListView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QLISTVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QListView *>((QListView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QListView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QListView* o)
{
  Q7B q (new Q7B_id(typeid(QListView).name(), o));
  return q;
}

Q7B Q7B_QLISTWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QListWidget *>((QListWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QListWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QLISTWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QListWidget *>((QListWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QListWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QListWidget* o)
{
  Q7B q (new Q7B_id(typeid(QListWidget).name(), o));
  return q;
}

Q7B Q7B_QLISTWIDGETITEM(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QListWidgetItem).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QListWidgetItem' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QLISTWIDGETITEM(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QListWidgetItem).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QListWidgetItem' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QListWidgetItem* o)
{
  Q7B q (new Q7B_id(typeid(QListWidgetItem).name(), o));
  return q;
}

Q7B Q7B_ID(QListWidgetItem o)
{
  Q7B q (new Q7B_id(typeid(QListWidgetItem).name(), new QListWidgetItem(o)));
  return q;
}

Q7B Q7B_QLOCALSERVER(Q7B Q7B_Object)
{
  if (qobject_cast<QLocalServer *>((QLocalServer* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLocalServer' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QLOCALSERVER(Q7B Q7B_Object)
{
  if (qobject_cast<QLocalServer *>((QLocalServer* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLocalServer' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QLocalServer* o)
{
  Q7B q (new Q7B_id(typeid(QLocalServer).name(), o));
  return q;
}

Q7B Q7B_QLOCALSOCKET(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QLocalSocket).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLocalSocket' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QLOCALSOCKET(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QLocalSocket).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLocalSocket' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QLocalSocket* o)
{
  Q7B q (new Q7B_id(typeid(QLocalSocket).name(), o));
  return q;
}

Q7B Q7B_QLOCALE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QLocale).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLocale' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QLOCALE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QLocale).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QLocale' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QLocale* o)
{
  Q7B q (new Q7B_id(typeid(QLocale).name(), o));
  return q;
}

Q7B Q7B_ID(QLocale o)
{
  Q7B q (new Q7B_id(typeid(QLocale).name(), new QLocale(o)));
  return q;
}

Q7B Q7B_QMAINWINDOW(Q7B Q7B_Object)
{
  if (qobject_cast<QMainWindow *>((QMainWindow* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMainWindow' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QMAINWINDOW(Q7B Q7B_Object)
{
  if (qobject_cast<QMainWindow *>((QMainWindow* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMainWindow' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QMainWindow* o)
{
  Q7B q (new Q7B_id(typeid(QMainWindow).name(), o));
  return q;
}

Q7B Q7B_QMARGINS(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QMargins).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMargins' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QMARGINS(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QMargins).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMargins' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QMargins* o)
{
  Q7B q (new Q7B_id(typeid(QMargins).name(), o));
  return q;
}

Q7B Q7B_ID(QMargins o)
{
  Q7B q (new Q7B_id(typeid(QMargins).name(), new QMargins(o)));
  return q;
}

Q7B Q7B_QMATRIX(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QMatrix).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMatrix' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QMATRIX(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QMatrix).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMatrix' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QMatrix* o)
{
  Q7B q (new Q7B_id(typeid(QMatrix).name(), o));
  return q;
}

Q7B Q7B_ID(QMatrix o)
{
  Q7B q (new Q7B_id(typeid(QMatrix).name(), new QMatrix(o)));
  return q;
}

Q7B Q7B_QMDIAREA(Q7B Q7B_Object)
{
  if (qobject_cast<QMdiArea *>((QMdiArea* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMdiArea' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QMDIAREA(Q7B Q7B_Object)
{
  if (qobject_cast<QMdiArea *>((QMdiArea* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMdiArea' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QMdiArea* o)
{
  Q7B q (new Q7B_id(typeid(QMdiArea).name(), o));
  return q;
}

Q7B Q7B_QMDISUBWINDOW(Q7B Q7B_Object)
{
  if (qobject_cast<QMdiSubWindow *>((QMdiSubWindow* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMdiSubWindow' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QMDISUBWINDOW(Q7B Q7B_Object)
{
  if (qobject_cast<QMdiSubWindow *>((QMdiSubWindow* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMdiSubWindow' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QMdiSubWindow* o)
{
  Q7B q (new Q7B_id(typeid(QMdiSubWindow).name(), o));
  return q;
}

Q7B Q7B_QMENU(Q7B Q7B_Object)
{
  if (qobject_cast<QMenu *>((QMenu* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMenu' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QMENU(Q7B Q7B_Object)
{
  if (qobject_cast<QMenu *>((QMenu* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMenu' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QMenu* o)
{
  Q7B q (new Q7B_id(typeid(QMenu).name(), o));
  return q;
}

Q7B Q7B_QMENUBAR(Q7B Q7B_Object)
{
  if (qobject_cast<QMenuBar *>((QMenuBar* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMenuBar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QMENUBAR(Q7B Q7B_Object)
{
  if (qobject_cast<QMenuBar *>((QMenuBar* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMenuBar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QMenuBar* o)
{
  Q7B q (new Q7B_id(typeid(QMenuBar).name(), o));
  return q;
}

Q7B Q7B_QMIMEDATA(Q7B Q7B_Object)
{
  if (qobject_cast<QMimeData *>((QMimeData* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMimeData' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QMIMEDATA(Q7B Q7B_Object)
{
  if (qobject_cast<QMimeData *>((QMimeData* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMimeData' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QMimeData* o)
{
  Q7B q (new Q7B_id(typeid(QMimeData).name(), o));
  return q;
}

Q7B Q7B_QMODELINDEX(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QModelIndex).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QModelIndex' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QMODELINDEX(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QModelIndex).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QModelIndex' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QModelIndex* o)
{
  Q7B q (new Q7B_id(typeid(QModelIndex).name(), o));
  return q;
}

Q7B Q7B_ID(QModelIndex o)
{
  Q7B q (new Q7B_id(typeid(QModelIndex).name(), new QModelIndex(o)));
  return q;
}

Q7B Q7B_QMOVEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QMoveEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMoveEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QMOVEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QMoveEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMoveEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QMoveEvent* o)
{
  Q7B q (new Q7B_id(typeid(QMoveEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QMoveEvent o)
{
  Q7B q (new Q7B_id(typeid(QMoveEvent).name(), new QMoveEvent(o)));
  return q;
}

Q7B Q7B_QMOVIE(Q7B Q7B_Object)
{
  if (qobject_cast<QMovie *>((QMovie* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMovie' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QMOVIE(Q7B Q7B_Object)
{
  if (qobject_cast<QMovie *>((QMovie* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QMovie' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QMovie* o)
{
  Q7B q (new Q7B_id(typeid(QMovie).name(), o));
  return q;
}

Q7B Q7B_QNETWORKREQUEST(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QNetworkRequest).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QNetworkRequest' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QNETWORKREQUEST(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QNetworkRequest).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QNetworkRequest' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QNetworkRequest* o)
{
  Q7B q (new Q7B_id(typeid(QNetworkRequest).name(), o));
  return q;
}

Q7B Q7B_ID(QNetworkRequest o)
{
  Q7B q (new Q7B_id(typeid(QNetworkRequest).name(), new QNetworkRequest(o)));
  return q;
}

Q7B Q7B_QNETWORKSESSION(Q7B Q7B_Object)
{
  if (qobject_cast<QNetworkSession *>((QNetworkSession* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QNetworkSession' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QNETWORKSESSION(Q7B Q7B_Object)
{
  if (qobject_cast<QNetworkSession *>((QNetworkSession* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QNetworkSession' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QNetworkSession* o)
{
  Q7B q (new Q7B_id(typeid(QNetworkSession).name(), o));
  return q;
}

Q7B Q7B_QOBJECT(Q7B Q7B_Object)
{
  if (qobject_cast<QObject *>((QObject* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QObject' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QOBJECT(Q7B Q7B_Object)
{
  if (qobject_cast<QObject *>((QObject* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QObject' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QObject* o)
{
  Q7B q (new Q7B_id(typeid(QObject).name(), o));
  return q;
}

Q7B Q7B_QPAINTEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPaintEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPaintEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPAINTEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPaintEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPaintEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPaintEvent* o)
{
  Q7B q (new Q7B_id(typeid(QPaintEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QPaintEvent o)
{
  Q7B q (new Q7B_id(typeid(QPaintEvent).name(), new QPaintEvent(o)));
  return q;
}

Q7B Q7B_QPAINTER(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPainter).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPainter' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPAINTER(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPainter).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPainter' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPainter* o)
{
  Q7B q (new Q7B_id(typeid(QPainter).name(), o));
  return q;
}

Q7B Q7B_QPALETTE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPalette).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPalette' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPALETTE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPalette).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPalette' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPalette* o)
{
  Q7B q (new Q7B_id(typeid(QPalette).name(), o));
  return q;
}

Q7B Q7B_ID(QPalette o)
{
  Q7B q (new Q7B_id(typeid(QPalette).name(), new QPalette(o)));
  return q;
}

Q7B Q7B_QPEN(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPen).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPen' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPEN(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPen).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPen' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPen* o)
{
  Q7B q (new Q7B_id(typeid(QPen).name(), o));
  return q;
}

Q7B Q7B_ID(QPen o)
{
  Q7B q (new Q7B_id(typeid(QPen).name(), new QPen(o)));
  return q;
}

Q7B Q7B_QPICTURE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPicture).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPicture' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPICTURE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPicture).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPicture' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPicture* o)
{
  Q7B q (new Q7B_id(typeid(QPicture).name(), o));
  return q;
}

Q7B Q7B_ID(QPicture o)
{
  Q7B q (new Q7B_id(typeid(QPicture).name(), new QPicture(o)));
  return q;
}

Q7B Q7B_QPIXMAP(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPixmap).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPixmap' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPIXMAP(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPixmap).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPixmap' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPixmap* o)
{
  Q7B q (new Q7B_id(typeid(QPixmap).name(), o));
  return q;
}

Q7B Q7B_ID(QPixmap o)
{
  Q7B q (new Q7B_id(typeid(QPixmap).name(), new QPixmap(o)));
  return q;
}

Q7B Q7B_QPLAINTEXTEDIT(Q7B Q7B_Object)
{
  if (qobject_cast<QPlainTextEdit *>((QPlainTextEdit* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPlainTextEdit' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPLAINTEXTEDIT(Q7B Q7B_Object)
{
  if (qobject_cast<QPlainTextEdit *>((QPlainTextEdit* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPlainTextEdit' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPlainTextEdit* o)
{
  Q7B q (new Q7B_id(typeid(QPlainTextEdit).name(), o));
  return q;
}

Q7B Q7B_QPOINT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPoint).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPoint' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPOINT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPoint).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPoint' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPoint* o)
{
  Q7B q (new Q7B_id(typeid(QPoint).name(), o));
  return q;
}

Q7B Q7B_ID(QPoint o)
{
  Q7B q (new Q7B_id(typeid(QPoint).name(), new QPoint(o)));
  return q;
}

Q7B Q7B_QPOLYGON(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPolygon).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPolygon' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPOLYGON(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPolygon).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPolygon' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPolygon* o)
{
  Q7B q (new Q7B_id(typeid(QPolygon).name(), o));
  return q;
}

Q7B Q7B_ID(QPolygon o)
{
  Q7B q (new Q7B_id(typeid(QPolygon).name(), new QPolygon(o)));
  return q;
}

Q7B Q7B_QPRINTDIALOG(Q7B Q7B_Object)
{
  if (qobject_cast<QPrintDialog *>((QPrintDialog* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPrintDialog' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPRINTDIALOG(Q7B Q7B_Object)
{
  if (qobject_cast<QPrintDialog *>((QPrintDialog* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPrintDialog' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPrintDialog* o)
{
  Q7B q (new Q7B_id(typeid(QPrintDialog).name(), o));
  return q;
}

Q7B Q7B_QPRINTPREVIEWDIALOG(Q7B Q7B_Object)
{
  if (qobject_cast<QPrintPreviewDialog *>((QPrintPreviewDialog* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPrintPreviewDialog' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPRINTPREVIEWDIALOG(Q7B Q7B_Object)
{
  if (qobject_cast<QPrintPreviewDialog *>((QPrintPreviewDialog* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPrintPreviewDialog' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPrintPreviewDialog* o)
{
  Q7B q (new Q7B_id(typeid(QPrintPreviewDialog).name(), o));
  return q;
}

Q7B Q7B_QPRINTPREVIEWWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QPrintPreviewWidget *>((QPrintPreviewWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPrintPreviewWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPRINTPREVIEWWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QPrintPreviewWidget *>((QPrintPreviewWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPrintPreviewWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPrintPreviewWidget* o)
{
  Q7B q (new Q7B_id(typeid(QPrintPreviewWidget).name(), o));
  return q;
}

Q7B Q7B_QPRINTER(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPrinter).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPrinter' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPRINTER(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPrinter).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPrinter' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPrinter* o)
{
  Q7B q (new Q7B_id(typeid(QPrinter).name(), o));
  return q;
}

Q7B Q7B_QPRINTERINFO(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPrinterInfo).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPrinterInfo' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPRINTERINFO(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QPrinterInfo).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPrinterInfo' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPrinterInfo* o)
{
  Q7B q (new Q7B_id(typeid(QPrinterInfo).name(), o));
  return q;
}

Q7B Q7B_ID(QPrinterInfo o)
{
  Q7B q (new Q7B_id(typeid(QPrinterInfo).name(), new QPrinterInfo(o)));
  return q;
}

Q7B Q7B_QPROCESS(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QProcess).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QProcess' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPROCESS(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QProcess).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QProcess' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QProcess* o)
{
  Q7B q (new Q7B_id(typeid(QProcess).name(), o));
  return q;
}

Q7B Q7B_QPROCESSENVIRONMENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QProcessEnvironment).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QProcessEnvironment' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPROCESSENVIRONMENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QProcessEnvironment).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QProcessEnvironment' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QProcessEnvironment* o)
{
  Q7B q (new Q7B_id(typeid(QProcessEnvironment).name(), o));
  return q;
}

Q7B Q7B_ID(QProcessEnvironment o)
{
  Q7B q (new Q7B_id(typeid(QProcessEnvironment).name(), new QProcessEnvironment(o)));
  return q;
}

Q7B Q7B_QPROGRESSBAR(Q7B Q7B_Object)
{
  if (qobject_cast<QProgressBar *>((QProgressBar* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QProgressBar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPROGRESSBAR(Q7B Q7B_Object)
{
  if (qobject_cast<QProgressBar *>((QProgressBar* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QProgressBar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QProgressBar* o)
{
  Q7B q (new Q7B_id(typeid(QProgressBar).name(), o));
  return q;
}

Q7B Q7B_QPROGRESSDIALOG(Q7B Q7B_Object)
{
  if (qobject_cast<QProgressDialog *>((QProgressDialog* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QProgressDialog' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPROGRESSDIALOG(Q7B Q7B_Object)
{
  if (qobject_cast<QProgressDialog *>((QProgressDialog* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QProgressDialog' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QProgressDialog* o)
{
  Q7B q (new Q7B_id(typeid(QProgressDialog).name(), o));
  return q;
}

Q7B Q7B_QPUSHBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<QPushButton *>((QPushButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPushButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QPUSHBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<QPushButton *>((QPushButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QPushButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QPushButton* o)
{
  Q7B q (new Q7B_id(typeid(QPushButton).name(), o));
  return q;
}

Q7B Q7B_QRADIOBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<QRadioButton *>((QRadioButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRadioButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QRADIOBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<QRadioButton *>((QRadioButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRadioButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QRadioButton* o)
{
  Q7B q (new Q7B_id(typeid(QRadioButton).name(), o));
  return q;
}

Q7B Q7B_QRECT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QRect).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRect' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QRECT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QRect).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRect' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QRect* o)
{
  Q7B q (new Q7B_id(typeid(QRect).name(), o));
  return q;
}

Q7B Q7B_ID(QRect o)
{
  Q7B q (new Q7B_id(typeid(QRect).name(), new QRect(o)));
  return q;
}

Q7B Q7B_QREGEXP(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QRegExp).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRegExp' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QREGEXP(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QRegExp).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRegExp' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QRegExp* o)
{
  Q7B q (new Q7B_id(typeid(QRegExp).name(), o));
  return q;
}

Q7B Q7B_ID(QRegExp o)
{
  Q7B q (new Q7B_id(typeid(QRegExp).name(), new QRegExp(o)));
  return q;
}

Q7B Q7B_QREGEXPVALIDATOR(Q7B Q7B_Object)
{
  if (qobject_cast<QRegExpValidator *>((QRegExpValidator* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRegExpValidator' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QREGEXPVALIDATOR(Q7B Q7B_Object)
{
  if (qobject_cast<QRegExpValidator *>((QRegExpValidator* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRegExpValidator' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QRegExpValidator* o)
{
  Q7B q (new Q7B_id(typeid(QRegExpValidator).name(), o));
  return q;
}

Q7B Q7B_QREGION(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QRegion).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRegion' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QREGION(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QRegion).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRegion' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QRegion* o)
{
  Q7B q (new Q7B_id(typeid(QRegion).name(), o));
  return q;
}

Q7B Q7B_ID(QRegion o)
{
  Q7B q (new Q7B_id(typeid(QRegion).name(), new QRegion(o)));
  return q;
}

Q7B Q7B_QRESIZEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QResizeEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QResizeEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QRESIZEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QResizeEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QResizeEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QResizeEvent* o)
{
  Q7B q (new Q7B_id(typeid(QResizeEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QResizeEvent o)
{
  Q7B q (new Q7B_id(typeid(QResizeEvent).name(), new QResizeEvent(o)));
  return q;
}

Q7B Q7B_QRESOURCE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QResource).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QResource' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QRESOURCE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QResource).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QResource' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QResource* o)
{
  Q7B q (new Q7B_id(typeid(QResource).name(), o));
  return q;
}

Q7B Q7B_QRGB(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QRgb).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRgb' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QRGB(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QRgb).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRgb' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QRgb* o)
{
  Q7B q (new Q7B_id(typeid(QRgb).name(), o));
  return q;
}

Q7B Q7B_QRUBBERBAND(Q7B Q7B_Object)
{
  if (qobject_cast<QRubberBand *>((QRubberBand* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRubberBand' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QRUBBERBAND(Q7B Q7B_Object)
{
  if (qobject_cast<QRubberBand *>((QRubberBand* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QRubberBand' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QRubberBand* o)
{
  Q7B q (new Q7B_id(typeid(QRubberBand).name(), o));
  return q;
}

Q7B Q7B_QSCROLLAREA(Q7B Q7B_Object)
{
  if (qobject_cast<QScrollArea *>((QScrollArea* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QScrollArea' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSCROLLAREA(Q7B Q7B_Object)
{
  if (qobject_cast<QScrollArea *>((QScrollArea* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QScrollArea' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QScrollArea* o)
{
  Q7B q (new Q7B_id(typeid(QScrollArea).name(), o));
  return q;
}

Q7B Q7B_QSCROLLBAR(Q7B Q7B_Object)
{
  if (qobject_cast<QScrollBar *>((QScrollBar* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QScrollBar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSCROLLBAR(Q7B Q7B_Object)
{
  if (qobject_cast<QScrollBar *>((QScrollBar* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QScrollBar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QScrollBar* o)
{
  Q7B q (new Q7B_id(typeid(QScrollBar).name(), o));
  return q;
}

Q7B Q7B_QSESSIONMANAGER(Q7B Q7B_Object)
{
  if (qobject_cast<QSessionManager *>((QSessionManager* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSessionManager' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSESSIONMANAGER(Q7B Q7B_Object)
{
  if (qobject_cast<QSessionManager *>((QSessionManager* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSessionManager' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSessionManager* o)
{
  Q7B q (new Q7B_id(typeid(QSessionManager).name(), o));
  return q;
}

Q7B Q7B_QSHORTCUTEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QShortcutEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QShortcutEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSHORTCUTEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QShortcutEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QShortcutEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QShortcutEvent* o)
{
  Q7B q (new Q7B_id(typeid(QShortcutEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QShortcutEvent o)
{
  Q7B q (new Q7B_id(typeid(QShortcutEvent).name(), new QShortcutEvent(o)));
  return q;
}

Q7B Q7B_QSHOWEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QShowEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QShowEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSHOWEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QShowEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QShowEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QShowEvent* o)
{
  Q7B q (new Q7B_id(typeid(QShowEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QShowEvent o)
{
  Q7B q (new Q7B_id(typeid(QShowEvent).name(), new QShowEvent(o)));
  return q;
}

Q7B Q7B_QSIGNALMAPPER(Q7B Q7B_Object)
{
  if (qobject_cast<QSignalMapper *>((QSignalMapper* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSignalMapper' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSIGNALMAPPER(Q7B Q7B_Object)
{
  if (qobject_cast<QSignalMapper *>((QSignalMapper* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSignalMapper' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSignalMapper* o)
{
  Q7B q (new Q7B_id(typeid(QSignalMapper).name(), o));
  return q;
}

Q7B Q7B_QSIZE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QSize).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSize' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSIZE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QSize).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSize' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSize* o)
{
  Q7B q (new Q7B_id(typeid(QSize).name(), o));
  return q;
}

Q7B Q7B_ID(QSize o)
{
  Q7B q (new Q7B_id(typeid(QSize).name(), new QSize(o)));
  return q;
}

Q7B Q7B_QSIZEF(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QSizeF).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSizeF' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSIZEF(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QSizeF).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSizeF' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSizeF* o)
{
  Q7B q (new Q7B_id(typeid(QSizeF).name(), o));
  return q;
}

Q7B Q7B_ID(QSizeF o)
{
  Q7B q (new Q7B_id(typeid(QSizeF).name(), new QSizeF(o)));
  return q;
}

Q7B Q7B_QSIZEGRIP(Q7B Q7B_Object)
{
  if (qobject_cast<QSizeGrip *>((QSizeGrip* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSizeGrip' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSIZEGRIP(Q7B Q7B_Object)
{
  if (qobject_cast<QSizeGrip *>((QSizeGrip* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSizeGrip' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSizeGrip* o)
{
  Q7B q (new Q7B_id(typeid(QSizeGrip).name(), o));
  return q;
}

Q7B Q7B_QSIZEPOLICY(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QSizePolicy).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSizePolicy' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSIZEPOLICY(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QSizePolicy).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSizePolicy' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSizePolicy* o)
{
  Q7B q (new Q7B_id(typeid(QSizePolicy).name(), o));
  return q;
}

Q7B Q7B_ID(QSizePolicy o)
{
  Q7B q (new Q7B_id(typeid(QSizePolicy).name(), new QSizePolicy(o)));
  return q;
}

Q7B Q7B_QSLIDER(Q7B Q7B_Object)
{
  if (qobject_cast<QSlider *>((QSlider* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSlider' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSLIDER(Q7B Q7B_Object)
{
  if (qobject_cast<QSlider *>((QSlider* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSlider' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSlider* o)
{
  Q7B q (new Q7B_id(typeid(QSlider).name(), o));
  return q;
}

Q7B Q7B_QSOUND(Q7B Q7B_Object)
{
  if (qobject_cast<QSound *>((QSound* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSound' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSOUND(Q7B Q7B_Object)
{
  if (qobject_cast<QSound *>((QSound* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSound' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSound* o)
{
  Q7B q (new Q7B_id(typeid(QSound).name(), o));
  return q;
}

Q7B Q7B_QSPINBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QSpinBox *>((QSpinBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSpinBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSPINBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QSpinBox *>((QSpinBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSpinBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSpinBox* o)
{
  Q7B q (new Q7B_id(typeid(QSpinBox).name(), o));
  return q;
}

Q7B Q7B_QSPLASHSCREEN(Q7B Q7B_Object)
{
  if (qobject_cast<QSplashScreen *>((QSplashScreen* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSplashScreen' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSPLASHSCREEN(Q7B Q7B_Object)
{
  if (qobject_cast<QSplashScreen *>((QSplashScreen* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSplashScreen' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSplashScreen* o)
{
  Q7B q (new Q7B_id(typeid(QSplashScreen).name(), o));
  return q;
}

Q7B Q7B_QSPLITTER(Q7B Q7B_Object)
{
  if (qobject_cast<QSplitter *>((QSplitter* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSplitter' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSPLITTER(Q7B Q7B_Object)
{
  if (qobject_cast<QSplitter *>((QSplitter* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSplitter' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSplitter* o)
{
  Q7B q (new Q7B_id(typeid(QSplitter).name(), o));
  return q;
}

Q7B Q7B_QSPLITTERHANDLE(Q7B Q7B_Object)
{
  if (qobject_cast<QSplitterHandle *>((QSplitterHandle* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSplitterHandle' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSPLITTERHANDLE(Q7B Q7B_Object)
{
  if (qobject_cast<QSplitterHandle *>((QSplitterHandle* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSplitterHandle' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSplitterHandle* o)
{
  Q7B q (new Q7B_id(typeid(QSplitterHandle).name(), o));
  return q;
}

Q7B Q7B_QSTACKEDLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QStackedLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QStackedLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSTACKEDLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QStackedLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QStackedLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QStackedLayout* o)
{
  Q7B q (new Q7B_id(typeid(QStackedLayout).name(), o));
  return q;
}

Q7B Q7B_QSTACKEDWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QStackedWidget *>((QStackedWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QStackedWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSTACKEDWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QStackedWidget *>((QStackedWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QStackedWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QStackedWidget* o)
{
  Q7B q (new Q7B_id(typeid(QStackedWidget).name(), o));
  return q;
}

Q7B Q7B_QSTATUSBAR(Q7B Q7B_Object)
{
  if (qobject_cast<QStatusBar *>((QStatusBar* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QStatusBar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSTATUSBAR(Q7B Q7B_Object)
{
  if (qobject_cast<QStatusBar *>((QStatusBar* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QStatusBar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QStatusBar* o)
{
  Q7B q (new Q7B_id(typeid(QStatusBar).name(), o));
  return q;
}

Q7B Q7B_QSTATUSTIPEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QStatusTipEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QStatusTipEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSTATUSTIPEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QStatusTipEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QStatusTipEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QStatusTipEvent* o)
{
  Q7B q (new Q7B_id(typeid(QStatusTipEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QStatusTipEvent o)
{
  Q7B q (new Q7B_id(typeid(QStatusTipEvent).name(), new QStatusTipEvent(o)));
  return q;
}

Q7B Q7B_QSVGWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QSvgWidget *>((QSvgWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSvgWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSVGWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QSvgWidget *>((QSvgWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSvgWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSvgWidget* o)
{
  Q7B q (new Q7B_id(typeid(QSvgWidget).name(), o));
  return q;
}

Q7B Q7B_QSYNTAXHIGHLIGHTER(Q7B Q7B_Object)
{
  if (qobject_cast<QSyntaxHighlighter *>((QSyntaxHighlighter* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSyntaxHighlighter' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSYNTAXHIGHLIGHTER(Q7B Q7B_Object)
{
  if (qobject_cast<QSyntaxHighlighter *>((QSyntaxHighlighter* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSyntaxHighlighter' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSyntaxHighlighter* o)
{
  Q7B q (new Q7B_id(typeid(QSyntaxHighlighter).name(), o));
  return q;
}

Q7B Q7B_QSYSTEMLOCALE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QSystemLocale).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSystemLocale' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSYSTEMLOCALE(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QSystemLocale).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSystemLocale' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSystemLocale* o)
{
  Q7B q (new Q7B_id(typeid(QSystemLocale).name(), o));
  return q;
}

Q7B Q7B_ID(QSystemLocale o)
{
  Q7B q (new Q7B_id(typeid(QSystemLocale).name(), new QSystemLocale(o)));
  return q;
}

Q7B Q7B_QSYSTEMTRAYICON(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QSystemTrayIcon).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSystemTrayIcon' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QSYSTEMTRAYICON(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QSystemTrayIcon).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QSystemTrayIcon' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QSystemTrayIcon* o)
{
  Q7B q (new Q7B_id(typeid(QSystemTrayIcon).name(), o));
  return q;
}

Q7B Q7B_QTABBAR(Q7B Q7B_Object)
{
  if (qobject_cast<QTabBar *>((QTabBar* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTabBar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTABBAR(Q7B Q7B_Object)
{
  if (qobject_cast<QTabBar *>((QTabBar* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTabBar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTabBar* o)
{
  Q7B q (new Q7B_id(typeid(QTabBar).name(), o));
  return q;
}

Q7B Q7B_QTABWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QTabWidget *>((QTabWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTabWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTABWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QTabWidget *>((QTabWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTabWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTabWidget* o)
{
  Q7B q (new Q7B_id(typeid(QTabWidget).name(), o));
  return q;
}

Q7B Q7B_QTABLEVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QTableView *>((QTableView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTableView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTABLEVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QTableView *>((QTableView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTableView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTableView* o)
{
  Q7B q (new Q7B_id(typeid(QTableView).name(), o));
  return q;
}

Q7B Q7B_QTABLEWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QTableWidget *>((QTableWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTableWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTABLEWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QTableWidget *>((QTableWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTableWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTableWidget* o)
{
  Q7B q (new Q7B_id(typeid(QTableWidget).name(), o));
  return q;
}

Q7B Q7B_QTABLEWIDGETITEM(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTableWidgetItem).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTableWidgetItem' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTABLEWIDGETITEM(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTableWidgetItem).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTableWidgetItem' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTableWidgetItem* o)
{
  Q7B q (new Q7B_id(typeid(QTableWidgetItem).name(), o));
  return q;
}

Q7B Q7B_ID(QTableWidgetItem o)
{
  Q7B q (new Q7B_id(typeid(QTableWidgetItem).name(), new QTableWidgetItem(o)));
  return q;
}

Q7B Q7B_QTEXTBLOCK(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextBlock).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextBlock' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTEXTBLOCK(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextBlock).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextBlock' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTextBlock* o)
{
  Q7B q (new Q7B_id(typeid(QTextBlock).name(), o));
  return q;
}

Q7B Q7B_ID(QTextBlock o)
{
  Q7B q (new Q7B_id(typeid(QTextBlock).name(), new QTextBlock(o)));
  return q;
}

Q7B Q7B_QTEXTBLOCKFORMAT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextBlockFormat).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextBlockFormat' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTEXTBLOCKFORMAT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextBlockFormat).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextBlockFormat' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTextBlockFormat* o)
{
  Q7B q (new Q7B_id(typeid(QTextBlockFormat).name(), o));
  return q;
}

Q7B Q7B_ID(QTextBlockFormat o)
{
  Q7B q (new Q7B_id(typeid(QTextBlockFormat).name(), new QTextBlockFormat(o)));
  return q;
}

Q7B Q7B_QTEXTBROWSER(Q7B Q7B_Object)
{
  if (qobject_cast<QTextBrowser *>((QTextBrowser* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextBrowser' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTEXTBROWSER(Q7B Q7B_Object)
{
  if (qobject_cast<QTextBrowser *>((QTextBrowser* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextBrowser' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTextBrowser* o)
{
  Q7B q (new Q7B_id(typeid(QTextBrowser).name(), o));
  return q;
}

Q7B Q7B_QTEXTCHARFORMAT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextCharFormat).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextCharFormat' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTEXTCHARFORMAT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextCharFormat).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextCharFormat' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTextCharFormat* o)
{
  Q7B q (new Q7B_id(typeid(QTextCharFormat).name(), o));
  return q;
}

Q7B Q7B_ID(QTextCharFormat o)
{
  Q7B q (new Q7B_id(typeid(QTextCharFormat).name(), new QTextCharFormat(o)));
  return q;
}

Q7B Q7B_QTEXTCURSOR(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextCursor).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextCursor' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTEXTCURSOR(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextCursor).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextCursor' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTextCursor* o)
{
  Q7B q (new Q7B_id(typeid(QTextCursor).name(), o));
  return q;
}

Q7B Q7B_ID(QTextCursor o)
{
  Q7B q (new Q7B_id(typeid(QTextCursor).name(), new QTextCursor(o)));
  return q;
}

Q7B Q7B_QTEXTDOCUMENT(Q7B Q7B_Object)
{
  if (qobject_cast<QTextDocument *>((QTextDocument* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextDocument' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTEXTDOCUMENT(Q7B Q7B_Object)
{
  if (qobject_cast<QTextDocument *>((QTextDocument* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextDocument' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTextDocument* o)
{
  Q7B q (new Q7B_id(typeid(QTextDocument).name(), o));
  return q;
}

Q7B Q7B_QTEXTDOCUMENTFRAGMENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextDocumentFragment).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextDocumentFragment' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTEXTDOCUMENTFRAGMENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextDocumentFragment).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextDocumentFragment' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTextDocumentFragment* o)
{
  Q7B q (new Q7B_id(typeid(QTextDocumentFragment).name(), o));
  return q;
}

Q7B Q7B_ID(QTextDocumentFragment o)
{
  Q7B q (new Q7B_id(typeid(QTextDocumentFragment).name(), new QTextDocumentFragment(o)));
  return q;
}

Q7B Q7B_QTEXTEDIT(Q7B Q7B_Object)
{
  if (qobject_cast<QTextEdit *>((QTextEdit* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextEdit' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTEXTEDIT(Q7B Q7B_Object)
{
  if (qobject_cast<QTextEdit *>((QTextEdit* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextEdit' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTextEdit* o)
{
  Q7B q (new Q7B_id(typeid(QTextEdit).name(), o));
  return q;
}

Q7B Q7B_QTEXTFORMAT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextFormat).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextFormat' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTEXTFORMAT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextFormat).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextFormat' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTextFormat* o)
{
  Q7B q (new Q7B_id(typeid(QTextFormat).name(), o));
  return q;
}

Q7B Q7B_ID(QTextFormat o)
{
  Q7B q (new Q7B_id(typeid(QTextFormat).name(), new QTextFormat(o)));
  return q;
}

Q7B Q7B_QTEXTFRAMEFORMAT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextFrameFormat).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextFrameFormat' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTEXTFRAMEFORMAT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextFrameFormat).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextFrameFormat' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTextFrameFormat* o)
{
  Q7B q (new Q7B_id(typeid(QTextFrameFormat).name(), o));
  return q;
}

Q7B Q7B_ID(QTextFrameFormat o)
{
  Q7B q (new Q7B_id(typeid(QTextFrameFormat).name(), new QTextFrameFormat(o)));
  return q;
}

Q7B Q7B_QTEXTOPTION(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextOption).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextOption' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTEXTOPTION(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTextOption).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTextOption' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTextOption* o)
{
  Q7B q (new Q7B_id(typeid(QTextOption).name(), o));
  return q;
}

Q7B Q7B_ID(QTextOption o)
{
  Q7B q (new Q7B_id(typeid(QTextOption).name(), new QTextOption(o)));
  return q;
}

Q7B Q7B_QTHREAD(Q7B Q7B_Object)
{
  if (qobject_cast<QThread *>((QThread* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QThread' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTHREAD(Q7B Q7B_Object)
{
  if (qobject_cast<QThread *>((QThread* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QThread' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QThread* o)
{
  Q7B q (new Q7B_id(typeid(QThread).name(), o));
  return q;
}

Q7B Q7B_QTIME(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTime).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTime' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTIME(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTime).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTime' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTime* o)
{
  Q7B q (new Q7B_id(typeid(QTime).name(), o));
  return q;
}

Q7B Q7B_ID(QTime o)
{
  Q7B q (new Q7B_id(typeid(QTime).name(), new QTime(o)));
  return q;
}

Q7B Q7B_QTIMEEDIT(Q7B Q7B_Object)
{
  if (qobject_cast<QTimeEdit *>((QTimeEdit* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTimeEdit' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTIMEEDIT(Q7B Q7B_Object)
{
  if (qobject_cast<QTimeEdit *>((QTimeEdit* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTimeEdit' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTimeEdit* o)
{
  Q7B q (new Q7B_id(typeid(QTimeEdit).name(), o));
  return q;
}

Q7B Q7B_QTIMELINE(Q7B Q7B_Object)
{
  if (qobject_cast<QTimeLine *>((QTimeLine* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTimeLine' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTIMELINE(Q7B Q7B_Object)
{
  if (qobject_cast<QTimeLine *>((QTimeLine* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTimeLine' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTimeLine* o)
{
  Q7B q (new Q7B_id(typeid(QTimeLine).name(), o));
  return q;
}

Q7B Q7B_QTIMER(Q7B Q7B_Object)
{
  if (qobject_cast<QTimer *>((QTimer* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTimer' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTIMER(Q7B Q7B_Object)
{
  if (qobject_cast<QTimer *>((QTimer* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTimer' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTimer* o)
{
  Q7B q (new Q7B_id(typeid(QTimer).name(), o));
  return q;
}

Q7B Q7B_QTIMEREVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTimerEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTimerEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTIMEREVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTimerEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTimerEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTimerEvent* o)
{
  Q7B q (new Q7B_id(typeid(QTimerEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QTimerEvent o)
{
  Q7B q (new Q7B_id(typeid(QTimerEvent).name(), new QTimerEvent(o)));
  return q;
}

Q7B Q7B_QTOOLBAR(Q7B Q7B_Object)
{
  if (qobject_cast<QToolBar *>((QToolBar* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QToolBar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTOOLBAR(Q7B Q7B_Object)
{
  if (qobject_cast<QToolBar *>((QToolBar* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QToolBar' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QToolBar* o)
{
  Q7B q (new Q7B_id(typeid(QToolBar).name(), o));
  return q;
}

Q7B Q7B_QTOOLBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QToolBox *>((QToolBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QToolBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTOOLBOX(Q7B Q7B_Object)
{
  if (qobject_cast<QToolBox *>((QToolBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QToolBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QToolBox* o)
{
  Q7B q (new Q7B_id(typeid(QToolBox).name(), o));
  return q;
}

Q7B Q7B_QTOOLBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<QToolButton *>((QToolButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QToolButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTOOLBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<QToolButton *>((QToolButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QToolButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QToolButton* o)
{
  Q7B q (new Q7B_id(typeid(QToolButton).name(), o));
  return q;
}

Q7B Q7B_QTRANSFORM(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTransform).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTransform' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTRANSFORM(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTransform).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTransform' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTransform* o)
{
  Q7B q (new Q7B_id(typeid(QTransform).name(), o));
  return q;
}

Q7B Q7B_ID(QTransform o)
{
  Q7B q (new Q7B_id(typeid(QTransform).name(), new QTransform(o)));
  return q;
}

Q7B Q7B_QTREEVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QTreeView *>((QTreeView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTreeView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTREEVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QTreeView *>((QTreeView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTreeView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTreeView* o)
{
  Q7B q (new Q7B_id(typeid(QTreeView).name(), o));
  return q;
}

Q7B Q7B_QTREEWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QTreeWidget *>((QTreeWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTreeWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTREEWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QTreeWidget *>((QTreeWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTreeWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTreeWidget* o)
{
  Q7B q (new Q7B_id(typeid(QTreeWidget).name(), o));
  return q;
}

Q7B Q7B_QTREEWIDGETITEM(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTreeWidgetItem).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTreeWidgetItem' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QTREEWIDGETITEM(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QTreeWidgetItem).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QTreeWidgetItem' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QTreeWidgetItem* o)
{
  Q7B q (new Q7B_id(typeid(QTreeWidgetItem).name(), o));
  return q;
}

Q7B Q7B_ID(QTreeWidgetItem o)
{
  Q7B q (new Q7B_id(typeid(QTreeWidgetItem).name(), new QTreeWidgetItem(o)));
  return q;
}

Q7B Q7B_QURL(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QUrl).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QUrl' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QURL(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QUrl).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QUrl' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QUrl* o)
{
  Q7B q (new Q7B_id(typeid(QUrl).name(), o));
  return q;
}

Q7B Q7B_ID(QUrl o)
{
  Q7B q (new Q7B_id(typeid(QUrl).name(), new QUrl(o)));
  return q;
}

Q7B Q7B_QURLINFO(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QUrlInfo).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QUrlInfo' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QURLINFO(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QUrlInfo).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QUrlInfo' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QUrlInfo* o)
{
  Q7B q (new Q7B_id(typeid(QUrlInfo).name(), o));
  return q;
}

Q7B Q7B_ID(QUrlInfo o)
{
  Q7B q (new Q7B_id(typeid(QUrlInfo).name(), new QUrlInfo(o)));
  return q;
}

Q7B Q7B_QVBOXLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QVBoxLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QVBoxLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QVBOXLAYOUT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QVBoxLayout).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QVBoxLayout' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QVBoxLayout* o)
{
  Q7B q (new Q7B_id(typeid(QVBoxLayout).name(), o));
  return q;
}

Q7B Q7B_QVALIDATOR(Q7B Q7B_Object)
{
  if (qobject_cast<QValidator *>((QValidator* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QValidator' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QVALIDATOR(Q7B Q7B_Object)
{
  if (qobject_cast<QValidator *>((QValidator* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QValidator' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QValidator* o)
{
  Q7B q (new Q7B_id(typeid(QValidator).name(), o));
  return q;
}

Q7B Q7B_QVARIANT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QVariant).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QVariant' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QVARIANT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QVariant).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QVariant' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QVariant* o)
{
  Q7B q (new Q7B_id(typeid(QVariant).name(), o));
  return q;
}

Q7B Q7B_ID(QVariant o)
{
  Q7B q (new Q7B_id(typeid(QVariant).name(), new QVariant(o)));
  return q;
}

Q7B Q7B_QWEBPAGE(Q7B Q7B_Object)
{
  if (qobject_cast<QWebPage *>((QWebPage* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QWebPage' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QWEBPAGE(Q7B Q7B_Object)
{
  if (qobject_cast<QWebPage *>((QWebPage* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QWebPage' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QWebPage* o)
{
  Q7B q (new Q7B_id(typeid(QWebPage).name(), o));
  return q;
}

Q7B Q7B_QWEBSETTINGS(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QWebSettings).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QWebSettings' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QWEBSETTINGS(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QWebSettings).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QWebSettings' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_QWEBVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QWebView *>((QWebView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QWebView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QWEBVIEW(Q7B Q7B_Object)
{
  if (qobject_cast<QWebView *>((QWebView* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QWebView' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QWebView* o)
{
  Q7B q (new Q7B_id(typeid(QWebView).name(), o));
  return q;
}

Q7B Q7B_QWHATSTHISCLICKEDEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QWhatsThisClickedEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QWhatsThisClickedEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QWHATSTHISCLICKEDEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QWhatsThisClickedEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QWhatsThisClickedEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QWhatsThisClickedEvent* o)
{
  Q7B q (new Q7B_id(typeid(QWhatsThisClickedEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QWhatsThisClickedEvent o)
{
  Q7B q (new Q7B_id(typeid(QWhatsThisClickedEvent).name(), new QWhatsThisClickedEvent(o)));
  return q;
}

Q7B Q7B_QWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QWidget *>((QWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QWIDGET(Q7B Q7B_Object)
{
  if (qobject_cast<QWidget *>((QWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QWidget' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QWidget* o)
{
  Q7B q (new Q7B_id(typeid(QWidget).name(), o));
  return q;
}

Q7B Q7B_QWINDOWSTATECHANGEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QWindowStateChangeEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QWindowStateChangeEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__QWINDOWSTATECHANGEEVENT(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QWindowStateChangeEvent).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'QWindowStateChangeEvent' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(QWindowStateChangeEvent* o)
{
  Q7B q (new Q7B_id(typeid(QWindowStateChangeEvent).name(), o));
  return q;
}

Q7B Q7B_ID(QWindowStateChangeEvent o)
{
  Q7B q (new Q7B_id(typeid(QWindowStateChangeEvent).name(), new QWindowStateChangeEvent(o)));
  return q;
}

Q7B Q7B_UICLASS(Q7B Q7B_Object)
{
  if (qobject_cast<QObject *>((QObject* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'uiClass' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__UICLASS(Q7B Q7B_Object)
{
  if (qobject_cast<QObject *>((QObject* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'uiClass' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_CHECKBOX(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_CheckBox *>((Q7B_CheckBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'CheckBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__CHECKBOX(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_CheckBox *>((Q7B_CheckBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'CheckBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B_CheckBox* o)
{
  Q7B q (new Q7B_id(typeid(Q7B_CheckBox).name(), o));
  return q;
}

Q7B Q7B_COMMANDBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_CommandButton *>((Q7B_CommandButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'CommandButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__COMMANDBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_CommandButton *>((Q7B_CommandButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'CommandButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B_CommandButton* o)
{
  Q7B q (new Q7B_id(typeid(Q7B_CommandButton).name(), o));
  return q;
}

Q7B Q7B_COMMANDLINKBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_CommandLinkButton *>((Q7B_CommandLinkButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'CommandLinkButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__COMMANDLINKBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_CommandLinkButton *>((Q7B_CommandLinkButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'CommandLinkButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B_CommandLinkButton* o)
{
  Q7B q (new Q7B_id(typeid(Q7B_CommandLinkButton).name(), o));
  return q;
}

Q7B Q7B_CONTROL(Q7B Q7B_Object)
{
  if (qobject_cast<QWidget *>((QWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'Control' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__CONTROL(Q7B Q7B_Object)
{
  if (qobject_cast<QWidget *>((QWidget* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'Control' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B_Control* o)
{
  Q7B q (new Q7B_id(typeid(Q7B_Control).name(), o));
  return q;
}

Q7B Q7B_FRAME(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_Frame *>((Q7B_Frame* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'Frame' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__FRAME(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_Frame *>((Q7B_Frame* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'Frame' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B_Frame* o)
{
  Q7B q (new Q7B_id(typeid(Q7B_Frame).name(), o));
  return q;
}

Q7B Q7B_IMAGEBOX(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_ImageBox *>((Q7B_ImageBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'ImageBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__IMAGEBOX(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_ImageBox *>((Q7B_ImageBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'ImageBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B_ImageBox* o)
{
  Q7B q (new Q7B_id(typeid(Q7B_ImageBox).name(), o));
  return q;
}

Q7B Q7B_IMAGEBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_ImageButton *>((Q7B_ImageButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'ImageButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__IMAGEBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_ImageButton *>((Q7B_ImageButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'ImageButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B_ImageButton* o)
{
  Q7B q (new Q7B_id(typeid(Q7B_ImageButton).name(), o));
  return q;
}

Q7B Q7B_LABEL(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_Label *>((Q7B_Label* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'Label' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__LABEL(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_Label *>((Q7B_Label* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'Label' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B_Label* o)
{
  Q7B q (new Q7B_id(typeid(Q7B_Label).name(), o));
  return q;
}

Q7B Q7B_RADIOBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_RadioButton *>((Q7B_RadioButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'RadioButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__RADIOBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_RadioButton *>((Q7B_RadioButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'RadioButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B_RadioButton* o)
{
  Q7B q (new Q7B_id(typeid(Q7B_RadioButton).name(), o));
  return q;
}

Q7B Q7B_TEXTBOX(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_TextBox *>((Q7B_TextBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'TextBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__TEXTBOX(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_TextBox *>((Q7B_TextBox* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'TextBox' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B_TextBox* o)
{
  Q7B q (new Q7B_id(typeid(Q7B_TextBox).name(), o));
  return q;
}

Q7B Q7B_TIMER(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_Timer *>((Q7B_Timer* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'Timer' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__TIMER(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_Timer *>((Q7B_Timer* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'Timer' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B_Timer* o)
{
  Q7B q (new Q7B_id(typeid(Q7B_Timer).name(), o));
  return q;
}

Q7B Q7B_TOOLBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_ToolButton *>((Q7B_ToolButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'ToolButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__TOOLBUTTON(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_ToolButton *>((Q7B_ToolButton* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'ToolButton' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B_ToolButton* o)
{
  Q7B q (new Q7B_id(typeid(Q7B_ToolButton).name(), o));
  return q;
}

Q7B Q7B_UDPSOCKET(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_UdpSocket *>((Q7B_UdpSocket* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'UdpSocket' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B__UDPSOCKET(Q7B Q7B_Object)
{
  if (qobject_cast<Q7B_UdpSocket *>((Q7B_UdpSocket* )(Q7B_Object->ref))) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  Q7B_CASTEXCEPTION("'UdpSocket' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B_UdpSocket* o)
{
  Q7B q (new Q7B_id(typeid(Q7B_UdpSocket).name(), o));
  return q;
}

// End Generator h#1

// *** Cast

bool Q7B_CBOOL(Q7B l)
{
  if (l->type == typeid(bool).name()){
    return ( *((bool *) l->ref) );
  }
  if (l->type == typeid(qint64).name()){
    return ( (bool) *((qint64 *) l->ref) );
  }
  if (l->type == typeid(qreal).name()){
    return ( (bool) *((qreal *) l->ref) );
  }
  
  if (l->type == typeid(QString).name()){ // needed for If s Then   ' s As String
    return ( !((QString *) l->ref)->isEmpty() );
  }
  
  Q7B_CASTEXCEPTION("'Boolean' expected");
  return false;
}


bool Q7B_CBOOL(bool l)
{
  return l;
}

qint64 Q7B_CQINT64(Q7B l)
{
  if (l->type == typeid(qint64).name()){
    return ( *((qint64 *) l->ref) );
  }
  if (l->type == typeid(qreal).name()){
    return ( (qint64) *((qreal *) l->ref) );
  }
  if (l->type == typeid(bool).name()){
    return ( (qint64) *((bool *) l->ref) );
  }

  Q7B_CASTEXCEPTION("'Integer' expected");
  return 0;
}

qreal Q7B_CQREAL(Q7B l)
{
  if (l->type == typeid(qreal).name()){
    return ( *((qreal *) l->ref) );
  }
  if (l->type == typeid(qint64).name()){
    return ( (qreal) *((qint64 *) l->ref) );
  }
  if (l->type == typeid(bool).name()){
    return ( (qreal) *((bool *) l->ref) );
  }
  
  Q7B_CASTEXCEPTION("'Float' expected");
  return 0;
}

QString Q7B_CQSTRING(Q7B l)
{
  return Q7B_toString2(l);
}

QStringList Q7B_CQSTRINGLIST(Q7B l)
{
  if (l->type == typeid(Q7B_List).name()){
    QStringList ll = ((Q7B_List *) l->ref)->toStringList();
    return ll;
  }
  if (l->type == typeid(QStringList).name()){
    return *((QStringList *) l->ref);
  }

  Q7B_CASTEXCEPTION("'List' expected");
  return QStringList();
}

// Begin Generator h#4
Phonon::SeekSlider *Q7B_CPHONONSEEKSLIDER(Q7B l){ if (l->type == typeid(Phonon::SeekSlider).name()){ return ( (Phonon::SeekSlider *) l->ref ); } Q7B_CASTEXCEPTION("'PhononSeekSlider' expected"); return 0; }
Phonon::VideoPlayer *Q7B_CPHONONVIDEOPLAYER(Q7B l){ if (l->type == typeid(Phonon::VideoPlayer).name()){ return ( (Phonon::VideoPlayer *) l->ref ); } Q7B_CASTEXCEPTION("'PhononVideoPlayer' expected"); return 0; }
Phonon::VolumeSlider *Q7B_CPHONONVOLUMESLIDER(Q7B l){ if (l->type == typeid(Phonon::VolumeSlider).name()){ return ( (Phonon::VolumeSlider *) l->ref ); } Q7B_CASTEXCEPTION("'PhononVolumeSlider' expected"); return 0; }
QAbstractButton *Q7B_CQABSTRACTBUTTON(Q7B l){ if (l->type == typeid(QAbstractButton).name()){ return ( (QAbstractButton *) l->ref ); } Q7B_CASTEXCEPTION("'QAbstractButton' expected"); return 0; }
QAbstractItemModel *Q7B_CQABSTRACTITEMMODEL(Q7B l){ if (l->type == typeid(QAbstractItemModel).name()){ return ( (QAbstractItemModel *) l->ref ); } Q7B_CASTEXCEPTION("'QAbstractItemModel' expected"); return 0; }
QAbstractItemView *Q7B_CQABSTRACTITEMVIEW(Q7B l){ if (l->type == typeid(QAbstractItemView).name()){ return ( (QAbstractItemView *) l->ref ); } Q7B_CASTEXCEPTION("'QAbstractItemView' expected"); return 0; }
QAbstractPrintDialog *Q7B_CQABSTRACTPRINTDIALOG(Q7B l){ if (l->type == typeid(QAbstractPrintDialog).name()){ return ( (QAbstractPrintDialog *) l->ref ); } Q7B_CASTEXCEPTION("'QAbstractPrintDialog' expected"); return 0; }
QAbstractScrollArea *Q7B_CQABSTRACTSCROLLAREA(Q7B l){ if (l->type == typeid(QAbstractScrollArea).name()){ return ( (QAbstractScrollArea *) l->ref ); } Q7B_CASTEXCEPTION("'QAbstractScrollArea' expected"); return 0; }
QAbstractSlider *Q7B_CQABSTRACTSLIDER(Q7B l){ if (l->type == typeid(QAbstractSlider).name()){ return ( (QAbstractSlider *) l->ref ); } Q7B_CASTEXCEPTION("'QAbstractSlider' expected"); return 0; }
QAbstractSpinBox *Q7B_CQABSTRACTSPINBOX(Q7B l){ if (l->type == typeid(QAbstractSpinBox).name()){ return ( (QAbstractSpinBox *) l->ref ); } Q7B_CASTEXCEPTION("'QAbstractSpinBox' expected"); return 0; }
QAbstractTextDocumentLayout *Q7B_CQABSTRACTTEXTDOCUMENTLAYOUT(Q7B l){ if (l->type == typeid(QAbstractTextDocumentLayout).name()){ return ( (QAbstractTextDocumentLayout *) l->ref ); } Q7B_CASTEXCEPTION("'QAbstractTextDocumentLayout' expected"); return 0; }
QAccessibleEvent *Q7B_CQACCESSIBLEEVENT(Q7B l){ if (l->type == typeid(QAccessibleEvent).name()){ return ( (QAccessibleEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QAccessibleEvent' expected"); return 0; }
QAction *Q7B_CQACTION(Q7B l){ if (l->type == typeid(QAction).name()){ return ( (QAction *) l->ref ); } Q7B_CASTEXCEPTION("'QAction' expected"); return 0; }
QActionEvent *Q7B_CQACTIONEVENT(Q7B l){ if (l->type == typeid(QActionEvent).name()){ return ( (QActionEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QActionEvent' expected"); return 0; }
QActionGroup *Q7B_CQACTIONGROUP(Q7B l){ if (l->type == typeid(QActionGroup).name()){ return ( (QActionGroup *) l->ref ); } Q7B_CASTEXCEPTION("'QActionGroup' expected"); return 0; }
QApplication *Q7B_CQAPPLICATION(Q7B l){ if (l->type == typeid(QApplication).name()){ return ( (QApplication *) l->ref ); } Q7B_CASTEXCEPTION("'QApplication' expected"); return 0; }
QBitmap *Q7B_CQBITMAP(Q7B l){ if (l->type == typeid(QBitmap).name()){ return ( (QBitmap *) l->ref ); } Q7B_CASTEXCEPTION("'QBitmap' expected"); return 0; }
QBoxLayout *Q7B_CQBOXLAYOUT(Q7B l){ if (l->type == typeid(QBoxLayout).name()){ return ( (QBoxLayout *) l->ref ); } Q7B_CASTEXCEPTION("'QBoxLayout' expected"); return 0; }
QBrush *Q7B_CQBRUSH(Q7B l){ if (l->type == typeid(QBrush).name()){ return ( (QBrush *) l->ref ); } Q7B_CASTEXCEPTION("'QBrush' expected"); return 0; }
QButtonGroup *Q7B_CQBUTTONGROUP(Q7B l){ if (l->type == typeid(QButtonGroup).name()){ return ( (QButtonGroup *) l->ref ); } Q7B_CASTEXCEPTION("'QButtonGroup' expected"); return 0; }
QByteArray *Q7B_CQBYTEARRAY(Q7B l){ if (l->type == typeid(QByteArray).name()){ return ( (QByteArray *) l->ref ); } Q7B_CASTEXCEPTION("'QByteArray' expected"); return 0; }
QCalendarWidget *Q7B_CQCALENDARWIDGET(Q7B l){ if (l->type == typeid(QCalendarWidget).name()){ return ( (QCalendarWidget *) l->ref ); } Q7B_CASTEXCEPTION("'QCalendarWidget' expected"); return 0; }
QChar *Q7B_CQCHAR(Q7B l){ if (l->type == typeid(QChar).name()){ return ( (QChar *) l->ref ); } Q7B_CASTEXCEPTION("'QChar' expected"); return 0; }
QCheckBox *Q7B_CQCHECKBOX(Q7B l){ if (l->type == typeid(QCheckBox).name()){ return ( (QCheckBox *) l->ref ); } Q7B_CASTEXCEPTION("'QCheckBox' expected"); return 0; }
QChildEvent *Q7B_CQCHILDEVENT(Q7B l){ if (l->type == typeid(QChildEvent).name()){ return ( (QChildEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QChildEvent' expected"); return 0; }
QClipboard *Q7B_CQCLIPBOARD(Q7B l){ if (l->type == typeid(QClipboard).name()){ return ( (QClipboard *) l->ref ); } Q7B_CASTEXCEPTION("'QClipboard' expected"); return 0; }
QCloseEvent *Q7B_CQCLOSEEVENT(Q7B l){ if (l->type == typeid(QCloseEvent).name()){ return ( (QCloseEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QCloseEvent' expected"); return 0; }
QColor *Q7B_CQCOLOR(Q7B l){ if (l->type == typeid(QColor).name()){ return ( (QColor *) l->ref ); } Q7B_CASTEXCEPTION("'QColor' expected"); return 0; }
QColumnView *Q7B_CQCOLUMNVIEW(Q7B l){ if (l->type == typeid(QColumnView).name()){ return ( (QColumnView *) l->ref ); } Q7B_CASTEXCEPTION("'QColumnView' expected"); return 0; }
QComboBox *Q7B_CQCOMBOBOX(Q7B l){ if (l->type == typeid(QComboBox).name()){ return ( (QComboBox *) l->ref ); } Q7B_CASTEXCEPTION("'QComboBox' expected"); return 0; }
QCommandLinkButton *Q7B_CQCOMMANDLINKBUTTON(Q7B l){ if (l->type == typeid(QCommandLinkButton).name()){ return ( (QCommandLinkButton *) l->ref ); } Q7B_CASTEXCEPTION("'QCommandLinkButton' expected"); return 0; }
QCompleter *Q7B_CQCOMPLETER(Q7B l){ if (l->type == typeid(QCompleter).name()){ return ( (QCompleter *) l->ref ); } Q7B_CASTEXCEPTION("'QCompleter' expected"); return 0; }
QContextMenuEvent *Q7B_CQCONTEXTMENUEVENT(Q7B l){ if (l->type == typeid(QContextMenuEvent).name()){ return ( (QContextMenuEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QContextMenuEvent' expected"); return 0; }
QCoreApplication *Q7B_CQCOREAPPLICATION(Q7B l){ if (l->type == typeid(QCoreApplication).name()){ return ( (QCoreApplication *) l->ref ); } Q7B_CASTEXCEPTION("'QCoreApplication' expected"); return 0; }
QCursor *Q7B_CQCURSOR(Q7B l){ if (l->type == typeid(QCursor).name()){ return ( (QCursor *) l->ref ); } Q7B_CASTEXCEPTION("'QCursor' expected"); return 0; }
QDate *Q7B_CQDATE(Q7B l){ if (l->type == typeid(QDate).name()){ return ( (QDate *) l->ref ); } Q7B_CASTEXCEPTION("'QDate' expected"); return 0; }
QDateEdit *Q7B_CQDATEEDIT(Q7B l){ if (l->type == typeid(QDateEdit).name()){ return ( (QDateEdit *) l->ref ); } Q7B_CASTEXCEPTION("'QDateEdit' expected"); return 0; }
QDateTime *Q7B_CQDATETIME(Q7B l){ if (l->type == typeid(QDateTime).name()){ return ( (QDateTime *) l->ref ); } Q7B_CASTEXCEPTION("'QDateTime' expected"); return 0; }
QDateTimeEdit *Q7B_CQDATETIMEEDIT(Q7B l){ if (l->type == typeid(QDateTimeEdit).name()){ return ( (QDateTimeEdit *) l->ref ); } Q7B_CASTEXCEPTION("'QDateTimeEdit' expected"); return 0; }
QDeclarativeContext *Q7B_CQDECLARATIVECONTEXT(Q7B l){ if (l->type == typeid(QDeclarativeContext).name()){ return ( (QDeclarativeContext *) l->ref ); } Q7B_CASTEXCEPTION("'QDeclarativeContext' expected"); return 0; }
QDeclarativeView *Q7B_CQDECLARATIVEVIEW(Q7B l){ if (l->type == typeid(QDeclarativeView).name()){ return ( (QDeclarativeView *) l->ref ); } Q7B_CASTEXCEPTION("'QDeclarativeView' expected"); return 0; }
QDial *Q7B_CQDIAL(Q7B l){ if (l->type == typeid(QDial).name()){ return ( (QDial *) l->ref ); } Q7B_CASTEXCEPTION("'QDial' expected"); return 0; }
QDialog *Q7B_CQDIALOG(Q7B l){ if (l->type == typeid(QDialog).name()){ return ( (QDialog *) l->ref ); } Q7B_CASTEXCEPTION("'QDialog' expected"); return 0; }
QDialogButtonBox *Q7B_CQDIALOGBUTTONBOX(Q7B l){ if (l->type == typeid(QDialogButtonBox).name()){ return ( (QDialogButtonBox *) l->ref ); } Q7B_CASTEXCEPTION("'QDialogButtonBox' expected"); return 0; }
QDir *Q7B_CQDIR(Q7B l){ if (l->type == typeid(QDir).name()){ return ( (QDir *) l->ref ); } Q7B_CASTEXCEPTION("'QDir' expected"); return 0; }
QDockWidget *Q7B_CQDOCKWIDGET(Q7B l){ if (l->type == typeid(QDockWidget).name()){ return ( (QDockWidget *) l->ref ); } Q7B_CASTEXCEPTION("'QDockWidget' expected"); return 0; }
QDoubleSpinBox *Q7B_CQDOUBLESPINBOX(Q7B l){ if (l->type == typeid(QDoubleSpinBox).name()){ return ( (QDoubleSpinBox *) l->ref ); } Q7B_CASTEXCEPTION("'QDoubleSpinBox' expected"); return 0; }
QDrag *Q7B_CQDRAG(Q7B l){ if (l->type == typeid(QDrag).name()){ return ( (QDrag *) l->ref ); } Q7B_CASTEXCEPTION("'QDrag' expected"); return 0; }
QDragLeaveEvent *Q7B_CQDRAGLEAVEEVENT(Q7B l){ if (l->type == typeid(QDragLeaveEvent).name()){ return ( (QDragLeaveEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QDragLeaveEvent' expected"); return 0; }
QDropEvent *Q7B_CQDROPEVENT(Q7B l){ if (l->type == typeid(QDropEvent).name()){ return ( (QDropEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QDropEvent' expected"); return 0; }
QDynamicPropertyChangeEvent *Q7B_CQDYNAMICPROPERTYCHANGEEVENT(Q7B l){ if (l->type == typeid(QDynamicPropertyChangeEvent).name()){ return ( (QDynamicPropertyChangeEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QDynamicPropertyChangeEvent' expected"); return 0; }
QElapsedTimer *Q7B_CQELAPSEDTIMER(Q7B l){ if (l->type == typeid(QElapsedTimer).name()){ return ( (QElapsedTimer *) l->ref ); } Q7B_CASTEXCEPTION("'QElapsedTimer' expected"); return 0; }
QEvent *Q7B_CQEVENT(Q7B l){ if (l->type == typeid(QEvent).name()){ return ( (QEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QEvent' expected"); return 0; }
QFileInfo *Q7B_CQFILEINFO(Q7B l){ if (l->type == typeid(QFileInfo).name()){ return ( (QFileInfo *) l->ref ); } Q7B_CASTEXCEPTION("'QFileInfo' expected"); return 0; }
QFileInfoList *Q7B_CQFILEINFOLIST(Q7B l){ if (l->type == typeid(QFileInfoList).name()){ return ( (QFileInfoList *) l->ref ); } Q7B_CASTEXCEPTION("'QFileInfoList' expected"); return 0; }
QFileOpenEvent *Q7B_CQFILEOPENEVENT(Q7B l){ if (l->type == typeid(QFileOpenEvent).name()){ return ( (QFileOpenEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QFileOpenEvent' expected"); return 0; }
QFileSystemWatcher *Q7B_CQFILESYSTEMWATCHER(Q7B l){ if (l->type == typeid(QFileSystemWatcher).name()){ return ( (QFileSystemWatcher *) l->ref ); } Q7B_CASTEXCEPTION("'QFileSystemWatcher' expected"); return 0; }
QFocusEvent *Q7B_CQFOCUSEVENT(Q7B l){ if (l->type == typeid(QFocusEvent).name()){ return ( (QFocusEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QFocusEvent' expected"); return 0; }
QFont *Q7B_CQFONT(Q7B l){ if (l->type == typeid(QFont).name()){ return ( (QFont *) l->ref ); } Q7B_CASTEXCEPTION("'QFont' expected"); return 0; }
QFontComboBox *Q7B_CQFONTCOMBOBOX(Q7B l){ if (l->type == typeid(QFontComboBox).name()){ return ( (QFontComboBox *) l->ref ); } Q7B_CASTEXCEPTION("'QFontComboBox' expected"); return 0; }
QFontDatabase *Q7B_CQFONTDATABASE(Q7B l){ if (l->type == typeid(QFontDatabase).name()){ return ( (QFontDatabase *) l->ref ); } Q7B_CASTEXCEPTION("'QFontDatabase' expected"); return 0; }
QFontInfo *Q7B_CQFONTINFO(Q7B l){ if (l->type == typeid(QFontInfo).name()){ return ( (QFontInfo *) l->ref ); } Q7B_CASTEXCEPTION("'QFontInfo' expected"); return 0; }
QFontMetrics *Q7B_CQFONTMETRICS(Q7B l){ if (l->type == typeid(QFontMetrics).name()){ return ( (QFontMetrics *) l->ref ); } Q7B_CASTEXCEPTION("'QFontMetrics' expected"); return 0; }
QFormLayout *Q7B_CQFORMLAYOUT(Q7B l){ if (l->type == typeid(QFormLayout).name()){ return ( (QFormLayout *) l->ref ); } Q7B_CASTEXCEPTION("'QFormLayout' expected"); return 0; }
QFrame *Q7B_CQFRAME(Q7B l){ if (l->type == typeid(QFrame).name()){ return ( (QFrame *) l->ref ); } Q7B_CASTEXCEPTION("'QFrame' expected"); return 0; }
QFtp *Q7B_CQFTP(Q7B l){ if (l->type == typeid(QFtp).name()){ return ( (QFtp *) l->ref ); } Q7B_CASTEXCEPTION("'QFtp' expected"); return 0; }
QGraphicsSceneEvent *Q7B_CQGRAPHICSSCENEEVENT(Q7B l){ if (l->type == typeid(QGraphicsSceneEvent).name()){ return ( (QGraphicsSceneEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QGraphicsSceneEvent' expected"); return 0; }
QGraphicsView *Q7B_CQGRAPHICSVIEW(Q7B l){ if (l->type == typeid(QGraphicsView).name()){ return ( (QGraphicsView *) l->ref ); } Q7B_CASTEXCEPTION("'QGraphicsView' expected"); return 0; }
QGridLayout *Q7B_CQGRIDLAYOUT(Q7B l){ if (l->type == typeid(QGridLayout).name()){ return ( (QGridLayout *) l->ref ); } Q7B_CASTEXCEPTION("'QGridLayout' expected"); return 0; }
QGroupBox *Q7B_CQGROUPBOX(Q7B l){ if (l->type == typeid(QGroupBox).name()){ return ( (QGroupBox *) l->ref ); } Q7B_CASTEXCEPTION("'QGroupBox' expected"); return 0; }
QHBoxLayout *Q7B_CQHBOXLAYOUT(Q7B l){ if (l->type == typeid(QHBoxLayout).name()){ return ( (QHBoxLayout *) l->ref ); } Q7B_CASTEXCEPTION("'QHBoxLayout' expected"); return 0; }
QHeaderView *Q7B_CQHEADERVIEW(Q7B l){ if (l->type == typeid(QHeaderView).name()){ return ( (QHeaderView *) l->ref ); } Q7B_CASTEXCEPTION("'QHeaderView' expected"); return 0; }
QHelpEvent *Q7B_CQHELPEVENT(Q7B l){ if (l->type == typeid(QHelpEvent).name()){ return ( (QHelpEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QHelpEvent' expected"); return 0; }
QHideEvent *Q7B_CQHIDEEVENT(Q7B l){ if (l->type == typeid(QHideEvent).name()){ return ( (QHideEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QHideEvent' expected"); return 0; }
QHostAddress *Q7B_CQHOSTADDRESS(Q7B l){ if (l->type == typeid(QHostAddress).name()){ return ( (QHostAddress *) l->ref ); } Q7B_CASTEXCEPTION("'QHostAddress' expected"); return 0; }
QHostInfo *Q7B_CQHOSTINFO(Q7B l){ if (l->type == typeid(QHostInfo).name()){ return ( (QHostInfo *) l->ref ); } Q7B_CASTEXCEPTION("'QHostInfo' expected"); return 0; }
QHoverEvent *Q7B_CQHOVEREVENT(Q7B l){ if (l->type == typeid(QHoverEvent).name()){ return ( (QHoverEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QHoverEvent' expected"); return 0; }
QIcon *Q7B_CQICON(Q7B l){ if (l->type == typeid(QIcon).name()){ return ( (QIcon *) l->ref ); } Q7B_CASTEXCEPTION("'QIcon' expected"); return 0; }
QIconDragEvent *Q7B_CQICONDRAGEVENT(Q7B l){ if (l->type == typeid(QIconDragEvent).name()){ return ( (QIconDragEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QIconDragEvent' expected"); return 0; }
QImage *Q7B_CQIMAGE(Q7B l){ if (l->type == typeid(QImage).name()){ return ( (QImage *) l->ref ); } Q7B_CASTEXCEPTION("'QImage' expected"); return 0; }
QInputDialog *Q7B_CQINPUTDIALOG(Q7B l){ if (l->type == typeid(QInputDialog).name()){ return ( (QInputDialog *) l->ref ); } Q7B_CASTEXCEPTION("'QInputDialog' expected"); return 0; }
QInputEvent *Q7B_CQINPUTEVENT(Q7B l){ if (l->type == typeid(QInputEvent).name()){ return ( (QInputEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QInputEvent' expected"); return 0; }
QInputMethodEvent *Q7B_CQINPUTMETHODEVENT(Q7B l){ if (l->type == typeid(QInputMethodEvent).name()){ return ( (QInputMethodEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QInputMethodEvent' expected"); return 0; }
QIntValidator *Q7B_CQINTVALIDATOR(Q7B l){ if (l->type == typeid(QIntValidator).name()){ return ( (QIntValidator *) l->ref ); } Q7B_CASTEXCEPTION("'QIntValidator' expected"); return 0; }
QItemSelectionModel *Q7B_CQITEMSELECTIONMODEL(Q7B l){ if (l->type == typeid(QItemSelectionModel).name()){ return ( (QItemSelectionModel *) l->ref ); } Q7B_CASTEXCEPTION("'QItemSelectionModel' expected"); return 0; }
QKeySequence *Q7B_CQKEYSEQUENCE(Q7B l){ if (l->type == typeid(QKeySequence).name()){ return ( (QKeySequence *) l->ref ); } Q7B_CASTEXCEPTION("'QKeySequence' expected"); return 0; }
QLCDNumber *Q7B_CQLCDNUMBER(Q7B l){ if (l->type == typeid(QLCDNumber).name()){ return ( (QLCDNumber *) l->ref ); } Q7B_CASTEXCEPTION("'QLCDNumber' expected"); return 0; }
QLabel *Q7B_CQLABEL(Q7B l){ if (l->type == typeid(QLabel).name()){ return ( (QLabel *) l->ref ); } Q7B_CASTEXCEPTION("'QLabel' expected"); return 0; }
QLayout *Q7B_CQLAYOUT(Q7B l){ if (l->type == typeid(QLayout).name()){ return ( (QLayout *) l->ref ); } Q7B_CASTEXCEPTION("'QLayout' expected"); return 0; }
QLayoutItem *Q7B_CQLAYOUTITEM(Q7B l){ if (l->type == typeid(QLayoutItem).name()){ return ( (QLayoutItem *) l->ref ); } Q7B_CASTEXCEPTION("'QLayoutItem' expected"); return 0; }
QLine *Q7B_CQLINE(Q7B l){ if (l->type == typeid(QLine).name()){ return ( (QLine *) l->ref ); } Q7B_CASTEXCEPTION("'QLine' expected"); return 0; }
QLineEdit *Q7B_CQLINEEDIT(Q7B l){ if (l->type == typeid(QLineEdit).name()){ return ( (QLineEdit *) l->ref ); } Q7B_CASTEXCEPTION("'QLineEdit' expected"); return 0; }
QList<QStringList> Q7B_CQLISTQSTRINGLIST(Q7B l){ if (l->type == typeid(QList<QStringList>).name()){ return ( *(QList<QStringList> *) l->ref ); } Q7B_CASTEXCEPTION("'QListQStringList' expected"); return QList<QStringList>(); }
QListView *Q7B_CQLISTVIEW(Q7B l){ if (l->type == typeid(QListView).name()){ return ( (QListView *) l->ref ); } Q7B_CASTEXCEPTION("'QListView' expected"); return 0; }
QListWidget *Q7B_CQLISTWIDGET(Q7B l){ if (l->type == typeid(QListWidget).name()){ return ( (QListWidget *) l->ref ); } Q7B_CASTEXCEPTION("'QListWidget' expected"); return 0; }
QListWidgetItem *Q7B_CQLISTWIDGETITEM(Q7B l){ if (l->type == typeid(QListWidgetItem).name()){ return ( (QListWidgetItem *) l->ref ); } Q7B_CASTEXCEPTION("'QListWidgetItem' expected"); return 0; }
QLocalServer *Q7B_CQLOCALSERVER(Q7B l){ if (l->type == typeid(QLocalServer).name()){ return ( (QLocalServer *) l->ref ); } Q7B_CASTEXCEPTION("'QLocalServer' expected"); return 0; }
QLocalSocket *Q7B_CQLOCALSOCKET(Q7B l){ if (l->type == typeid(QLocalSocket).name()){ return ( (QLocalSocket *) l->ref ); } Q7B_CASTEXCEPTION("'QLocalSocket' expected"); return 0; }
QLocale *Q7B_CQLOCALE(Q7B l){ if (l->type == typeid(QLocale).name()){ return ( (QLocale *) l->ref ); } Q7B_CASTEXCEPTION("'QLocale' expected"); return 0; }
QMainWindow *Q7B_CQMAINWINDOW(Q7B l){ if (l->type == typeid(QMainWindow).name()){ return ( (QMainWindow *) l->ref ); } Q7B_CASTEXCEPTION("'QMainWindow' expected"); return 0; }
QMargins *Q7B_CQMARGINS(Q7B l){ if (l->type == typeid(QMargins).name()){ return ( (QMargins *) l->ref ); } Q7B_CASTEXCEPTION("'QMargins' expected"); return 0; }
QMatrix *Q7B_CQMATRIX(Q7B l){ if (l->type == typeid(QMatrix).name()){ return ( (QMatrix *) l->ref ); } Q7B_CASTEXCEPTION("'QMatrix' expected"); return 0; }
QMdiArea *Q7B_CQMDIAREA(Q7B l){ if (l->type == typeid(QMdiArea).name()){ return ( (QMdiArea *) l->ref ); } Q7B_CASTEXCEPTION("'QMdiArea' expected"); return 0; }
QMdiSubWindow *Q7B_CQMDISUBWINDOW(Q7B l){ if (l->type == typeid(QMdiSubWindow).name()){ return ( (QMdiSubWindow *) l->ref ); } Q7B_CASTEXCEPTION("'QMdiSubWindow' expected"); return 0; }
QMenu *Q7B_CQMENU(Q7B l){ if (l->type == typeid(QMenu).name()){ return ( (QMenu *) l->ref ); } Q7B_CASTEXCEPTION("'QMenu' expected"); return 0; }
QMenuBar *Q7B_CQMENUBAR(Q7B l){ if (l->type == typeid(QMenuBar).name()){ return ( (QMenuBar *) l->ref ); } Q7B_CASTEXCEPTION("'QMenuBar' expected"); return 0; }
QMimeData *Q7B_CQMIMEDATA(Q7B l){ if (l->type == typeid(QMimeData).name()){ return ( (QMimeData *) l->ref ); } Q7B_CASTEXCEPTION("'QMimeData' expected"); return 0; }
QModelIndex *Q7B_CQMODELINDEX(Q7B l){ if (l->type == typeid(QModelIndex).name()){ return ( (QModelIndex *) l->ref ); } Q7B_CASTEXCEPTION("'QModelIndex' expected"); return 0; }
QMoveEvent *Q7B_CQMOVEEVENT(Q7B l){ if (l->type == typeid(QMoveEvent).name()){ return ( (QMoveEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QMoveEvent' expected"); return 0; }
QMovie *Q7B_CQMOVIE(Q7B l){ if (l->type == typeid(QMovie).name()){ return ( (QMovie *) l->ref ); } Q7B_CASTEXCEPTION("'QMovie' expected"); return 0; }
QNetworkRequest *Q7B_CQNETWORKREQUEST(Q7B l){ if (l->type == typeid(QNetworkRequest).name()){ return ( (QNetworkRequest *) l->ref ); } Q7B_CASTEXCEPTION("'QNetworkRequest' expected"); return 0; }
QNetworkSession *Q7B_CQNETWORKSESSION(Q7B l){ if (l->type == typeid(QNetworkSession).name()){ return ( (QNetworkSession *) l->ref ); } Q7B_CASTEXCEPTION("'QNetworkSession' expected"); return 0; }
QObject *Q7B_CQOBJECT(Q7B l){ if (l->type == typeid(QObject).name()){ return ( (QObject *) l->ref ); } Q7B_CASTEXCEPTION("'QObject' expected"); return 0; }
QPaintEvent *Q7B_CQPAINTEVENT(Q7B l){ if (l->type == typeid(QPaintEvent).name()){ return ( (QPaintEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QPaintEvent' expected"); return 0; }
QPainter *Q7B_CQPAINTER(Q7B l){ if (l->type == typeid(QPainter).name()){ return ( (QPainter *) l->ref ); } Q7B_CASTEXCEPTION("'QPainter' expected"); return 0; }
QPalette *Q7B_CQPALETTE(Q7B l){ if (l->type == typeid(QPalette).name()){ return ( (QPalette *) l->ref ); } Q7B_CASTEXCEPTION("'QPalette' expected"); return 0; }
QPen *Q7B_CQPEN(Q7B l){ if (l->type == typeid(QPen).name()){ return ( (QPen *) l->ref ); } Q7B_CASTEXCEPTION("'QPen' expected"); return 0; }
QPicture *Q7B_CQPICTURE(Q7B l){ if (l->type == typeid(QPicture).name()){ return ( (QPicture *) l->ref ); } Q7B_CASTEXCEPTION("'QPicture' expected"); return 0; }
QPixmap *Q7B_CQPIXMAP(Q7B l){ if (l->type == typeid(QPixmap).name()){ return ( (QPixmap *) l->ref ); } Q7B_CASTEXCEPTION("'QPixmap' expected"); return 0; }
QPlainTextEdit *Q7B_CQPLAINTEXTEDIT(Q7B l){ if (l->type == typeid(QPlainTextEdit).name()){ return ( (QPlainTextEdit *) l->ref ); } Q7B_CASTEXCEPTION("'QPlainTextEdit' expected"); return 0; }
QPoint *Q7B_CQPOINT(Q7B l){ if (l->type == typeid(QPoint).name()){ return ( (QPoint *) l->ref ); } Q7B_CASTEXCEPTION("'QPoint' expected"); return 0; }
QPolygon *Q7B_CQPOLYGON(Q7B l){ if (l->type == typeid(QPolygon).name()){ return ( (QPolygon *) l->ref ); } Q7B_CASTEXCEPTION("'QPolygon' expected"); return 0; }
QPrintDialog *Q7B_CQPRINTDIALOG(Q7B l){ if (l->type == typeid(QPrintDialog).name()){ return ( (QPrintDialog *) l->ref ); } Q7B_CASTEXCEPTION("'QPrintDialog' expected"); return 0; }
QPrintPreviewDialog *Q7B_CQPRINTPREVIEWDIALOG(Q7B l){ if (l->type == typeid(QPrintPreviewDialog).name()){ return ( (QPrintPreviewDialog *) l->ref ); } Q7B_CASTEXCEPTION("'QPrintPreviewDialog' expected"); return 0; }
QPrintPreviewWidget *Q7B_CQPRINTPREVIEWWIDGET(Q7B l){ if (l->type == typeid(QPrintPreviewWidget).name()){ return ( (QPrintPreviewWidget *) l->ref ); } Q7B_CASTEXCEPTION("'QPrintPreviewWidget' expected"); return 0; }
QPrinter *Q7B_CQPRINTER(Q7B l){ if (l->type == typeid(QPrinter).name()){ return ( (QPrinter *) l->ref ); } Q7B_CASTEXCEPTION("'QPrinter' expected"); return 0; }
QPrinterInfo *Q7B_CQPRINTERINFO(Q7B l){ if (l->type == typeid(QPrinterInfo).name()){ return ( (QPrinterInfo *) l->ref ); } Q7B_CASTEXCEPTION("'QPrinterInfo' expected"); return 0; }
QProcess *Q7B_CQPROCESS(Q7B l){ if (l->type == typeid(QProcess).name()){ return ( (QProcess *) l->ref ); } Q7B_CASTEXCEPTION("'QProcess' expected"); return 0; }
QProcessEnvironment *Q7B_CQPROCESSENVIRONMENT(Q7B l){ if (l->type == typeid(QProcessEnvironment).name()){ return ( (QProcessEnvironment *) l->ref ); } Q7B_CASTEXCEPTION("'QProcessEnvironment' expected"); return 0; }
QProgressBar *Q7B_CQPROGRESSBAR(Q7B l){ if (l->type == typeid(QProgressBar).name()){ return ( (QProgressBar *) l->ref ); } Q7B_CASTEXCEPTION("'QProgressBar' expected"); return 0; }
QProgressDialog *Q7B_CQPROGRESSDIALOG(Q7B l){ if (l->type == typeid(QProgressDialog).name()){ return ( (QProgressDialog *) l->ref ); } Q7B_CASTEXCEPTION("'QProgressDialog' expected"); return 0; }
QPushButton *Q7B_CQPUSHBUTTON(Q7B l){ if (l->type == typeid(QPushButton).name()){ return ( (QPushButton *) l->ref ); } Q7B_CASTEXCEPTION("'QPushButton' expected"); return 0; }
QRadioButton *Q7B_CQRADIOBUTTON(Q7B l){ if (l->type == typeid(QRadioButton).name()){ return ( (QRadioButton *) l->ref ); } Q7B_CASTEXCEPTION("'QRadioButton' expected"); return 0; }
QRect *Q7B_CQRECT(Q7B l){ if (l->type == typeid(QRect).name()){ return ( (QRect *) l->ref ); } Q7B_CASTEXCEPTION("'QRect' expected"); return 0; }
QRegExp *Q7B_CQREGEXP(Q7B l){ if (l->type == typeid(QRegExp).name()){ return ( (QRegExp *) l->ref ); } Q7B_CASTEXCEPTION("'QRegExp' expected"); return 0; }
QRegExpValidator *Q7B_CQREGEXPVALIDATOR(Q7B l){ if (l->type == typeid(QRegExpValidator).name()){ return ( (QRegExpValidator *) l->ref ); } Q7B_CASTEXCEPTION("'QRegExpValidator' expected"); return 0; }
QRegion *Q7B_CQREGION(Q7B l){ if (l->type == typeid(QRegion).name()){ return ( (QRegion *) l->ref ); } Q7B_CASTEXCEPTION("'QRegion' expected"); return 0; }
QResizeEvent *Q7B_CQRESIZEEVENT(Q7B l){ if (l->type == typeid(QResizeEvent).name()){ return ( (QResizeEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QResizeEvent' expected"); return 0; }
QResource *Q7B_CQRESOURCE(Q7B l){ if (l->type == typeid(QResource).name()){ return ( (QResource *) l->ref ); } Q7B_CASTEXCEPTION("'QResource' expected"); return 0; }
QRgb *Q7B_CQRGB(Q7B l){ if (l->type == typeid(QRgb).name()){ return ( (QRgb *) l->ref ); } Q7B_CASTEXCEPTION("'QRgb' expected"); return 0; }
QRubberBand *Q7B_CQRUBBERBAND(Q7B l){ if (l->type == typeid(QRubberBand).name()){ return ( (QRubberBand *) l->ref ); } Q7B_CASTEXCEPTION("'QRubberBand' expected"); return 0; }
QScrollArea *Q7B_CQSCROLLAREA(Q7B l){ if (l->type == typeid(QScrollArea).name()){ return ( (QScrollArea *) l->ref ); } Q7B_CASTEXCEPTION("'QScrollArea' expected"); return 0; }
QScrollBar *Q7B_CQSCROLLBAR(Q7B l){ if (l->type == typeid(QScrollBar).name()){ return ( (QScrollBar *) l->ref ); } Q7B_CASTEXCEPTION("'QScrollBar' expected"); return 0; }
QSessionManager *Q7B_CQSESSIONMANAGER(Q7B l){ if (l->type == typeid(QSessionManager).name()){ return ( (QSessionManager *) l->ref ); } Q7B_CASTEXCEPTION("'QSessionManager' expected"); return 0; }
QShortcutEvent *Q7B_CQSHORTCUTEVENT(Q7B l){ if (l->type == typeid(QShortcutEvent).name()){ return ( (QShortcutEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QShortcutEvent' expected"); return 0; }
QShowEvent *Q7B_CQSHOWEVENT(Q7B l){ if (l->type == typeid(QShowEvent).name()){ return ( (QShowEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QShowEvent' expected"); return 0; }
QSignalMapper *Q7B_CQSIGNALMAPPER(Q7B l){ if (l->type == typeid(QSignalMapper).name()){ return ( (QSignalMapper *) l->ref ); } Q7B_CASTEXCEPTION("'QSignalMapper' expected"); return 0; }
QSize *Q7B_CQSIZE(Q7B l){ if (l->type == typeid(QSize).name()){ return ( (QSize *) l->ref ); } Q7B_CASTEXCEPTION("'QSize' expected"); return 0; }
QSizeF *Q7B_CQSIZEF(Q7B l){ if (l->type == typeid(QSizeF).name()){ return ( (QSizeF *) l->ref ); } Q7B_CASTEXCEPTION("'QSizeF' expected"); return 0; }
QSizeGrip *Q7B_CQSIZEGRIP(Q7B l){ if (l->type == typeid(QSizeGrip).name()){ return ( (QSizeGrip *) l->ref ); } Q7B_CASTEXCEPTION("'QSizeGrip' expected"); return 0; }
QSizePolicy *Q7B_CQSIZEPOLICY(Q7B l){ if (l->type == typeid(QSizePolicy).name()){ return ( (QSizePolicy *) l->ref ); } Q7B_CASTEXCEPTION("'QSizePolicy' expected"); return 0; }
QSlider *Q7B_CQSLIDER(Q7B l){ if (l->type == typeid(QSlider).name()){ return ( (QSlider *) l->ref ); } Q7B_CASTEXCEPTION("'QSlider' expected"); return 0; }
QSound *Q7B_CQSOUND(Q7B l){ if (l->type == typeid(QSound).name()){ return ( (QSound *) l->ref ); } Q7B_CASTEXCEPTION("'QSound' expected"); return 0; }
QSpinBox *Q7B_CQSPINBOX(Q7B l){ if (l->type == typeid(QSpinBox).name()){ return ( (QSpinBox *) l->ref ); } Q7B_CASTEXCEPTION("'QSpinBox' expected"); return 0; }
QSplashScreen *Q7B_CQSPLASHSCREEN(Q7B l){ if (l->type == typeid(QSplashScreen).name()){ return ( (QSplashScreen *) l->ref ); } Q7B_CASTEXCEPTION("'QSplashScreen' expected"); return 0; }
QSplitter *Q7B_CQSPLITTER(Q7B l){ if (l->type == typeid(QSplitter).name()){ return ( (QSplitter *) l->ref ); } Q7B_CASTEXCEPTION("'QSplitter' expected"); return 0; }
QSplitterHandle *Q7B_CQSPLITTERHANDLE(Q7B l){ if (l->type == typeid(QSplitterHandle).name()){ return ( (QSplitterHandle *) l->ref ); } Q7B_CASTEXCEPTION("'QSplitterHandle' expected"); return 0; }
QStackedLayout *Q7B_CQSTACKEDLAYOUT(Q7B l){ if (l->type == typeid(QStackedLayout).name()){ return ( (QStackedLayout *) l->ref ); } Q7B_CASTEXCEPTION("'QStackedLayout' expected"); return 0; }
QStackedWidget *Q7B_CQSTACKEDWIDGET(Q7B l){ if (l->type == typeid(QStackedWidget).name()){ return ( (QStackedWidget *) l->ref ); } Q7B_CASTEXCEPTION("'QStackedWidget' expected"); return 0; }
QStatusBar *Q7B_CQSTATUSBAR(Q7B l){ if (l->type == typeid(QStatusBar).name()){ return ( (QStatusBar *) l->ref ); } Q7B_CASTEXCEPTION("'QStatusBar' expected"); return 0; }
QStatusTipEvent *Q7B_CQSTATUSTIPEVENT(Q7B l){ if (l->type == typeid(QStatusTipEvent).name()){ return ( (QStatusTipEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QStatusTipEvent' expected"); return 0; }
QSvgWidget *Q7B_CQSVGWIDGET(Q7B l){ if (l->type == typeid(QSvgWidget).name()){ return ( (QSvgWidget *) l->ref ); } Q7B_CASTEXCEPTION("'QSvgWidget' expected"); return 0; }
QSyntaxHighlighter *Q7B_CQSYNTAXHIGHLIGHTER(Q7B l){ if (l->type == typeid(QSyntaxHighlighter).name()){ return ( (QSyntaxHighlighter *) l->ref ); } Q7B_CASTEXCEPTION("'QSyntaxHighlighter' expected"); return 0; }
QSystemLocale *Q7B_CQSYSTEMLOCALE(Q7B l){ if (l->type == typeid(QSystemLocale).name()){ return ( (QSystemLocale *) l->ref ); } Q7B_CASTEXCEPTION("'QSystemLocale' expected"); return 0; }
QSystemTrayIcon *Q7B_CQSYSTEMTRAYICON(Q7B l){ if (l->type == typeid(QSystemTrayIcon).name()){ return ( (QSystemTrayIcon *) l->ref ); } Q7B_CASTEXCEPTION("'QSystemTrayIcon' expected"); return 0; }
QTabBar *Q7B_CQTABBAR(Q7B l){ if (l->type == typeid(QTabBar).name()){ return ( (QTabBar *) l->ref ); } Q7B_CASTEXCEPTION("'QTabBar' expected"); return 0; }
QTabWidget *Q7B_CQTABWIDGET(Q7B l){ if (l->type == typeid(QTabWidget).name()){ return ( (QTabWidget *) l->ref ); } Q7B_CASTEXCEPTION("'QTabWidget' expected"); return 0; }
QTableView *Q7B_CQTABLEVIEW(Q7B l){ if (l->type == typeid(QTableView).name()){ return ( (QTableView *) l->ref ); } Q7B_CASTEXCEPTION("'QTableView' expected"); return 0; }
QTableWidget *Q7B_CQTABLEWIDGET(Q7B l){ if (l->type == typeid(QTableWidget).name()){ return ( (QTableWidget *) l->ref ); } Q7B_CASTEXCEPTION("'QTableWidget' expected"); return 0; }
QTableWidgetItem *Q7B_CQTABLEWIDGETITEM(Q7B l){ if (l->type == typeid(QTableWidgetItem).name()){ return ( (QTableWidgetItem *) l->ref ); } Q7B_CASTEXCEPTION("'QTableWidgetItem' expected"); return 0; }
QTextBlock *Q7B_CQTEXTBLOCK(Q7B l){ if (l->type == typeid(QTextBlock).name()){ return ( (QTextBlock *) l->ref ); } Q7B_CASTEXCEPTION("'QTextBlock' expected"); return 0; }
QTextBlockFormat *Q7B_CQTEXTBLOCKFORMAT(Q7B l){ if (l->type == typeid(QTextBlockFormat).name()){ return ( (QTextBlockFormat *) l->ref ); } Q7B_CASTEXCEPTION("'QTextBlockFormat' expected"); return 0; }
QTextBrowser *Q7B_CQTEXTBROWSER(Q7B l){ if (l->type == typeid(QTextBrowser).name()){ return ( (QTextBrowser *) l->ref ); } Q7B_CASTEXCEPTION("'QTextBrowser' expected"); return 0; }
QTextCharFormat *Q7B_CQTEXTCHARFORMAT(Q7B l){ if (l->type == typeid(QTextCharFormat).name()){ return ( (QTextCharFormat *) l->ref ); } Q7B_CASTEXCEPTION("'QTextCharFormat' expected"); return 0; }
QTextCursor *Q7B_CQTEXTCURSOR(Q7B l){ if (l->type == typeid(QTextCursor).name()){ return ( (QTextCursor *) l->ref ); } Q7B_CASTEXCEPTION("'QTextCursor' expected"); return 0; }
QTextDocument *Q7B_CQTEXTDOCUMENT(Q7B l){ if (l->type == typeid(QTextDocument).name()){ return ( (QTextDocument *) l->ref ); } Q7B_CASTEXCEPTION("'QTextDocument' expected"); return 0; }
QTextDocumentFragment *Q7B_CQTEXTDOCUMENTFRAGMENT(Q7B l){ if (l->type == typeid(QTextDocumentFragment).name()){ return ( (QTextDocumentFragment *) l->ref ); } Q7B_CASTEXCEPTION("'QTextDocumentFragment' expected"); return 0; }
QTextEdit *Q7B_CQTEXTEDIT(Q7B l){ if (l->type == typeid(QTextEdit).name()){ return ( (QTextEdit *) l->ref ); } Q7B_CASTEXCEPTION("'QTextEdit' expected"); return 0; }
QTextFormat *Q7B_CQTEXTFORMAT(Q7B l){ if (l->type == typeid(QTextFormat).name()){ return ( (QTextFormat *) l->ref ); } Q7B_CASTEXCEPTION("'QTextFormat' expected"); return 0; }
QTextFrameFormat *Q7B_CQTEXTFRAMEFORMAT(Q7B l){ if (l->type == typeid(QTextFrameFormat).name()){ return ( (QTextFrameFormat *) l->ref ); } Q7B_CASTEXCEPTION("'QTextFrameFormat' expected"); return 0; }
QTextOption *Q7B_CQTEXTOPTION(Q7B l){ if (l->type == typeid(QTextOption).name()){ return ( (QTextOption *) l->ref ); } Q7B_CASTEXCEPTION("'QTextOption' expected"); return 0; }
QThread *Q7B_CQTHREAD(Q7B l){ if (l->type == typeid(QThread).name()){ return ( (QThread *) l->ref ); } Q7B_CASTEXCEPTION("'QThread' expected"); return 0; }
QTime *Q7B_CQTIME(Q7B l){ if (l->type == typeid(QTime).name()){ return ( (QTime *) l->ref ); } Q7B_CASTEXCEPTION("'QTime' expected"); return 0; }
QTimeEdit *Q7B_CQTIMEEDIT(Q7B l){ if (l->type == typeid(QTimeEdit).name()){ return ( (QTimeEdit *) l->ref ); } Q7B_CASTEXCEPTION("'QTimeEdit' expected"); return 0; }
QTimeLine *Q7B_CQTIMELINE(Q7B l){ if (l->type == typeid(QTimeLine).name()){ return ( (QTimeLine *) l->ref ); } Q7B_CASTEXCEPTION("'QTimeLine' expected"); return 0; }
QTimer *Q7B_CQTIMER(Q7B l){ if (l->type == typeid(QTimer).name()){ return ( (QTimer *) l->ref ); } Q7B_CASTEXCEPTION("'QTimer' expected"); return 0; }
QTimerEvent *Q7B_CQTIMEREVENT(Q7B l){ if (l->type == typeid(QTimerEvent).name()){ return ( (QTimerEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QTimerEvent' expected"); return 0; }
QToolBar *Q7B_CQTOOLBAR(Q7B l){ if (l->type == typeid(QToolBar).name()){ return ( (QToolBar *) l->ref ); } Q7B_CASTEXCEPTION("'QToolBar' expected"); return 0; }
QToolBox *Q7B_CQTOOLBOX(Q7B l){ if (l->type == typeid(QToolBox).name()){ return ( (QToolBox *) l->ref ); } Q7B_CASTEXCEPTION("'QToolBox' expected"); return 0; }
QToolButton *Q7B_CQTOOLBUTTON(Q7B l){ if (l->type == typeid(QToolButton).name()){ return ( (QToolButton *) l->ref ); } Q7B_CASTEXCEPTION("'QToolButton' expected"); return 0; }
QTransform *Q7B_CQTRANSFORM(Q7B l){ if (l->type == typeid(QTransform).name()){ return ( (QTransform *) l->ref ); } Q7B_CASTEXCEPTION("'QTransform' expected"); return 0; }
QTreeView *Q7B_CQTREEVIEW(Q7B l){ if (l->type == typeid(QTreeView).name()){ return ( (QTreeView *) l->ref ); } Q7B_CASTEXCEPTION("'QTreeView' expected"); return 0; }
QTreeWidget *Q7B_CQTREEWIDGET(Q7B l){ if (l->type == typeid(QTreeWidget).name()){ return ( (QTreeWidget *) l->ref ); } Q7B_CASTEXCEPTION("'QTreeWidget' expected"); return 0; }
QTreeWidgetItem *Q7B_CQTREEWIDGETITEM(Q7B l){ if (l->type == typeid(QTreeWidgetItem).name()){ return ( (QTreeWidgetItem *) l->ref ); } Q7B_CASTEXCEPTION("'QTreeWidgetItem' expected"); return 0; }
QUrl *Q7B_CQURL(Q7B l){ if (l->type == typeid(QUrl).name()){ return ( (QUrl *) l->ref ); } Q7B_CASTEXCEPTION("'QUrl' expected"); return 0; }
QUrlInfo *Q7B_CQURLINFO(Q7B l){ if (l->type == typeid(QUrlInfo).name()){ return ( (QUrlInfo *) l->ref ); } Q7B_CASTEXCEPTION("'QUrlInfo' expected"); return 0; }
QVBoxLayout *Q7B_CQVBOXLAYOUT(Q7B l){ if (l->type == typeid(QVBoxLayout).name()){ return ( (QVBoxLayout *) l->ref ); } Q7B_CASTEXCEPTION("'QVBoxLayout' expected"); return 0; }
QValidator *Q7B_CQVALIDATOR(Q7B l){ if (l->type == typeid(QValidator).name()){ return ( (QValidator *) l->ref ); } Q7B_CASTEXCEPTION("'QValidator' expected"); return 0; }
QVariant *Q7B_CQVARIANT(Q7B l){ if (l->type == typeid(QVariant).name()){ return ( (QVariant *) l->ref ); } Q7B_CASTEXCEPTION("'QVariant' expected"); return 0; }
QWebPage *Q7B_CQWEBPAGE(Q7B l){ if (l->type == typeid(QWebPage).name()){ return ( (QWebPage *) l->ref ); } Q7B_CASTEXCEPTION("'QWebPage' expected"); return 0; }
QWebSettings *Q7B_CQWEBSETTINGS(Q7B l){ if (l->type == typeid(QWebSettings).name()){ return ( (QWebSettings *) l->ref ); } Q7B_CASTEXCEPTION("'QWebSettings' expected"); return 0; }
QWebView *Q7B_CQWEBVIEW(Q7B l){ if (l->type == typeid(QWebView).name()){ return ( (QWebView *) l->ref ); } Q7B_CASTEXCEPTION("'QWebView' expected"); return 0; }
QWhatsThisClickedEvent *Q7B_CQWHATSTHISCLICKEDEVENT(Q7B l){ if (l->type == typeid(QWhatsThisClickedEvent).name()){ return ( (QWhatsThisClickedEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QWhatsThisClickedEvent' expected"); return 0; }
QWidget *Q7B_CQWIDGET(Q7B l){ if (l->type == typeid(QWidget).name()){ return ( (QWidget *) l->ref ); } Q7B_CASTEXCEPTION("'QWidget' expected"); return 0; }
QWindowStateChangeEvent *Q7B_CQWINDOWSTATECHANGEEVENT(Q7B l){ if (l->type == typeid(QWindowStateChangeEvent).name()){ return ( (QWindowStateChangeEvent *) l->ref ); } Q7B_CASTEXCEPTION("'QWindowStateChangeEvent' expected"); return 0; }

// End Generator h#4

// BEGIN Q7B_Compiler_ConvertDeclareType
bool Q7B_Compiler_ConvertDeclareType(QString *sCast)
{
  // Begin Generator h#3
  if (*sCast == "FormClass"){ *sCast = "CFORMCLASS"; return true; }
  if (*sCast == "PhononSeekSlider"){ *sCast = "CPHONONSEEKSLIDER"; return true; }
  if (*sCast == "PhononVideoPlayer"){ *sCast = "CPHONONVIDEOPLAYER"; return true; }
  if (*sCast == "PhononVolumeSlider"){ *sCast = "CPHONONVOLUMESLIDER"; return true; }
  if (*sCast == "QAbstractButton"){ *sCast = "CQABSTRACTBUTTON"; return true; }
  if (*sCast == "QAbstractItemModel"){ *sCast = "CQABSTRACTITEMMODEL"; return true; }
  if (*sCast == "QAbstractItemView"){ *sCast = "CQABSTRACTITEMVIEW"; return true; }
  if (*sCast == "QAbstractPrintDialog"){ *sCast = "CQABSTRACTPRINTDIALOG"; return true; }
  if (*sCast == "QAbstractScrollArea"){ *sCast = "CQABSTRACTSCROLLAREA"; return true; }
  if (*sCast == "QAbstractSlider"){ *sCast = "CQABSTRACTSLIDER"; return true; }
  if (*sCast == "QAbstractSpinBox"){ *sCast = "CQABSTRACTSPINBOX"; return true; }
  if (*sCast == "QAbstractTextDocumentLayout"){ *sCast = "CQABSTRACTTEXTDOCUMENTLAYOUT"; return true; }
  if (*sCast == "QAccessibleEvent"){ *sCast = "CQACCESSIBLEEVENT"; return true; }
  if (*sCast == "QAction"){ *sCast = "CQACTION"; return true; }
  if (*sCast == "QActionEvent"){ *sCast = "CQACTIONEVENT"; return true; }
  if (*sCast == "QActionGroup"){ *sCast = "CQACTIONGROUP"; return true; }
  if (*sCast == "QApplication"){ *sCast = "CQAPPLICATION"; return true; }
  if (*sCast == "QBitmap"){ *sCast = "CQBITMAP"; return true; }
  if (*sCast == "QBoxLayout"){ *sCast = "CQBOXLAYOUT"; return true; }
  if (*sCast == "QBrush"){ *sCast = "CQBRUSH"; return true; }
  if (*sCast == "QButtonGroup"){ *sCast = "CQBUTTONGROUP"; return true; }
  if (*sCast == "QByteArray"){ *sCast = "CQBYTEARRAY"; return true; }
  if (*sCast == "QCalendarWidget"){ *sCast = "CQCALENDARWIDGET"; return true; }
  if (*sCast == "QChar"){ *sCast = "CQCHAR"; return true; }
  if (*sCast == "QCheckBox"){ *sCast = "CQCHECKBOX"; return true; }
  if (*sCast == "QChildEvent"){ *sCast = "CQCHILDEVENT"; return true; }
  if (*sCast == "QClipboard"){ *sCast = "CQCLIPBOARD"; return true; }
  if (*sCast == "QCloseEvent"){ *sCast = "CQCLOSEEVENT"; return true; }
  if (*sCast == "QColor"){ *sCast = "CQCOLOR"; return true; }
  if (*sCast == "QColumnView"){ *sCast = "CQCOLUMNVIEW"; return true; }
  if (*sCast == "QComboBox"){ *sCast = "CQCOMBOBOX"; return true; }
  if (*sCast == "QCommandLinkButton"){ *sCast = "CQCOMMANDLINKBUTTON"; return true; }
  if (*sCast == "QCompleter"){ *sCast = "CQCOMPLETER"; return true; }
  if (*sCast == "QContextMenuEvent"){ *sCast = "CQCONTEXTMENUEVENT"; return true; }
  if (*sCast == "QCoreApplication"){ *sCast = "CQCOREAPPLICATION"; return true; }
  if (*sCast == "QCursor"){ *sCast = "CQCURSOR"; return true; }
  if (*sCast == "QDate"){ *sCast = "CQDATE"; return true; }
  if (*sCast == "QDateEdit"){ *sCast = "CQDATEEDIT"; return true; }
  if (*sCast == "QDateTime"){ *sCast = "CQDATETIME"; return true; }
  if (*sCast == "QDateTimeEdit"){ *sCast = "CQDATETIMEEDIT"; return true; }
  if (*sCast == "QDeclarativeContext"){ *sCast = "CQDECLARATIVECONTEXT"; return true; }
  if (*sCast == "QDeclarativeView"){ *sCast = "CQDECLARATIVEVIEW"; return true; }
  if (*sCast == "QDial"){ *sCast = "CQDIAL"; return true; }
  if (*sCast == "QDialog"){ *sCast = "CQDIALOG"; return true; }
  if (*sCast == "QDialogButtonBox"){ *sCast = "CQDIALOGBUTTONBOX"; return true; }
  if (*sCast == "QDir"){ *sCast = "CQDIR"; return true; }
  if (*sCast == "QDockWidget"){ *sCast = "CQDOCKWIDGET"; return true; }
  if (*sCast == "QDoubleSpinBox"){ *sCast = "CQDOUBLESPINBOX"; return true; }
  if (*sCast == "QDrag"){ *sCast = "CQDRAG"; return true; }
  if (*sCast == "QDragLeaveEvent"){ *sCast = "CQDRAGLEAVEEVENT"; return true; }
  if (*sCast == "QDropEvent"){ *sCast = "CQDROPEVENT"; return true; }
  if (*sCast == "QDynamicPropertyChangeEvent"){ *sCast = "CQDYNAMICPROPERTYCHANGEEVENT"; return true; }
  if (*sCast == "QElapsedTimer"){ *sCast = "CQELAPSEDTIMER"; return true; }
  if (*sCast == "QEvent"){ *sCast = "CQEVENT"; return true; }
  if (*sCast == "QFileInfo"){ *sCast = "CQFILEINFO"; return true; }
  if (*sCast == "QFileInfoList"){ *sCast = "CQFILEINFOLIST"; return true; }
  if (*sCast == "QFileOpenEvent"){ *sCast = "CQFILEOPENEVENT"; return true; }
  if (*sCast == "QFileSystemWatcher"){ *sCast = "CQFILESYSTEMWATCHER"; return true; }
  if (*sCast == "QFocusEvent"){ *sCast = "CQFOCUSEVENT"; return true; }
  if (*sCast == "QFont"){ *sCast = "CQFONT"; return true; }
  if (*sCast == "QFontComboBox"){ *sCast = "CQFONTCOMBOBOX"; return true; }
  if (*sCast == "QFontDatabase"){ *sCast = "CQFONTDATABASE"; return true; }
  if (*sCast == "QFontInfo"){ *sCast = "CQFONTINFO"; return true; }
  if (*sCast == "QFontMetrics"){ *sCast = "CQFONTMETRICS"; return true; }
  if (*sCast == "QFormLayout"){ *sCast = "CQFORMLAYOUT"; return true; }
  if (*sCast == "QFrame"){ *sCast = "CQFRAME"; return true; }
  if (*sCast == "QFtp"){ *sCast = "CQFTP"; return true; }
  if (*sCast == "QGraphicsSceneEvent"){ *sCast = "CQGRAPHICSSCENEEVENT"; return true; }
  if (*sCast == "QGraphicsView"){ *sCast = "CQGRAPHICSVIEW"; return true; }
  if (*sCast == "QGridLayout"){ *sCast = "CQGRIDLAYOUT"; return true; }
  if (*sCast == "QGroupBox"){ *sCast = "CQGROUPBOX"; return true; }
  if (*sCast == "QHBoxLayout"){ *sCast = "CQHBOXLAYOUT"; return true; }
  if (*sCast == "QHeaderView"){ *sCast = "CQHEADERVIEW"; return true; }
  if (*sCast == "QHelpEvent"){ *sCast = "CQHELPEVENT"; return true; }
  if (*sCast == "QHideEvent"){ *sCast = "CQHIDEEVENT"; return true; }
  if (*sCast == "QHostAddress"){ *sCast = "CQHOSTADDRESS"; return true; }
  if (*sCast == "QHostInfo"){ *sCast = "CQHOSTINFO"; return true; }
  if (*sCast == "QHoverEvent"){ *sCast = "CQHOVEREVENT"; return true; }
  if (*sCast == "QIcon"){ *sCast = "CQICON"; return true; }
  if (*sCast == "QIconDragEvent"){ *sCast = "CQICONDRAGEVENT"; return true; }
  if (*sCast == "QImage"){ *sCast = "CQIMAGE"; return true; }
  if (*sCast == "QInputDialog"){ *sCast = "CQINPUTDIALOG"; return true; }
  if (*sCast == "QInputEvent"){ *sCast = "CQINPUTEVENT"; return true; }
  if (*sCast == "QInputMethodEvent"){ *sCast = "CQINPUTMETHODEVENT"; return true; }
  if (*sCast == "QIntValidator"){ *sCast = "CQINTVALIDATOR"; return true; }
  if (*sCast == "QItemSelectionModel"){ *sCast = "CQITEMSELECTIONMODEL"; return true; }
  if (*sCast == "QKeySequence"){ *sCast = "CQKEYSEQUENCE"; return true; }
  if (*sCast == "QLCDNumber"){ *sCast = "CQLCDNUMBER"; return true; }
  if (*sCast == "QLabel"){ *sCast = "CQLABEL"; return true; }
  if (*sCast == "QLayout"){ *sCast = "CQLAYOUT"; return true; }
  if (*sCast == "QLayoutItem"){ *sCast = "CQLAYOUTITEM"; return true; }
  if (*sCast == "QLine"){ *sCast = "CQLINE"; return true; }
  if (*sCast == "QLineEdit"){ *sCast = "CQLINEEDIT"; return true; }
  if (*sCast == "QListQStringList"){ *sCast = "CQLISTQSTRINGLIST"; return true; }
  if (*sCast == "QListView"){ *sCast = "CQLISTVIEW"; return true; }
  if (*sCast == "QListWidget"){ *sCast = "CQLISTWIDGET"; return true; }
  if (*sCast == "QListWidgetItem"){ *sCast = "CQLISTWIDGETITEM"; return true; }
  if (*sCast == "QLocalServer"){ *sCast = "CQLOCALSERVER"; return true; }
  if (*sCast == "QLocalSocket"){ *sCast = "CQLOCALSOCKET"; return true; }
  if (*sCast == "QLocale"){ *sCast = "CQLOCALE"; return true; }
  if (*sCast == "QMainWindow"){ *sCast = "CQMAINWINDOW"; return true; }
  if (*sCast == "QMargins"){ *sCast = "CQMARGINS"; return true; }
  if (*sCast == "QMatrix"){ *sCast = "CQMATRIX"; return true; }
  if (*sCast == "QMdiArea"){ *sCast = "CQMDIAREA"; return true; }
  if (*sCast == "QMdiSubWindow"){ *sCast = "CQMDISUBWINDOW"; return true; }
  if (*sCast == "QMenu"){ *sCast = "CQMENU"; return true; }
  if (*sCast == "QMenuBar"){ *sCast = "CQMENUBAR"; return true; }
  if (*sCast == "QMimeData"){ *sCast = "CQMIMEDATA"; return true; }
  if (*sCast == "QModelIndex"){ *sCast = "CQMODELINDEX"; return true; }
  if (*sCast == "QMoveEvent"){ *sCast = "CQMOVEEVENT"; return true; }
  if (*sCast == "QMovie"){ *sCast = "CQMOVIE"; return true; }
  if (*sCast == "QNetworkRequest"){ *sCast = "CQNETWORKREQUEST"; return true; }
  if (*sCast == "QNetworkSession"){ *sCast = "CQNETWORKSESSION"; return true; }
  if (*sCast == "QObject"){ *sCast = "CQOBJECT"; return true; }
  if (*sCast == "QPaintEvent"){ *sCast = "CQPAINTEVENT"; return true; }
  if (*sCast == "QPainter"){ *sCast = "CQPAINTER"; return true; }
  if (*sCast == "QPalette"){ *sCast = "CQPALETTE"; return true; }
  if (*sCast == "QPen"){ *sCast = "CQPEN"; return true; }
  if (*sCast == "QPicture"){ *sCast = "CQPICTURE"; return true; }
  if (*sCast == "QPixmap"){ *sCast = "CQPIXMAP"; return true; }
  if (*sCast == "QPlainTextEdit"){ *sCast = "CQPLAINTEXTEDIT"; return true; }
  if (*sCast == "QPoint"){ *sCast = "CQPOINT"; return true; }
  if (*sCast == "QPolygon"){ *sCast = "CQPOLYGON"; return true; }
  if (*sCast == "QPrintDialog"){ *sCast = "CQPRINTDIALOG"; return true; }
  if (*sCast == "QPrintPreviewDialog"){ *sCast = "CQPRINTPREVIEWDIALOG"; return true; }
  if (*sCast == "QPrintPreviewWidget"){ *sCast = "CQPRINTPREVIEWWIDGET"; return true; }
  if (*sCast == "QPrinter"){ *sCast = "CQPRINTER"; return true; }
  if (*sCast == "QPrinterInfo"){ *sCast = "CQPRINTERINFO"; return true; }
  if (*sCast == "QProcess"){ *sCast = "CQPROCESS"; return true; }
  if (*sCast == "QProcessEnvironment"){ *sCast = "CQPROCESSENVIRONMENT"; return true; }
  if (*sCast == "QProgressBar"){ *sCast = "CQPROGRESSBAR"; return true; }
  if (*sCast == "QProgressDialog"){ *sCast = "CQPROGRESSDIALOG"; return true; }
  if (*sCast == "QPushButton"){ *sCast = "CQPUSHBUTTON"; return true; }
  if (*sCast == "QRadioButton"){ *sCast = "CQRADIOBUTTON"; return true; }
  if (*sCast == "QRect"){ *sCast = "CQRECT"; return true; }
  if (*sCast == "QRegExp"){ *sCast = "CQREGEXP"; return true; }
  if (*sCast == "QRegExpValidator"){ *sCast = "CQREGEXPVALIDATOR"; return true; }
  if (*sCast == "QRegion"){ *sCast = "CQREGION"; return true; }
  if (*sCast == "QResizeEvent"){ *sCast = "CQRESIZEEVENT"; return true; }
  if (*sCast == "QResource"){ *sCast = "CQRESOURCE"; return true; }
  if (*sCast == "QRgb"){ *sCast = "CQRGB"; return true; }
  if (*sCast == "QRubberBand"){ *sCast = "CQRUBBERBAND"; return true; }
  if (*sCast == "QScrollArea"){ *sCast = "CQSCROLLAREA"; return true; }
  if (*sCast == "QScrollBar"){ *sCast = "CQSCROLLBAR"; return true; }
  if (*sCast == "QSessionManager"){ *sCast = "CQSESSIONMANAGER"; return true; }
  if (*sCast == "QShortcutEvent"){ *sCast = "CQSHORTCUTEVENT"; return true; }
  if (*sCast == "QShowEvent"){ *sCast = "CQSHOWEVENT"; return true; }
  if (*sCast == "QSignalMapper"){ *sCast = "CQSIGNALMAPPER"; return true; }
  if (*sCast == "QSize"){ *sCast = "CQSIZE"; return true; }
  if (*sCast == "QSizeF"){ *sCast = "CQSIZEF"; return true; }
  if (*sCast == "QSizeGrip"){ *sCast = "CQSIZEGRIP"; return true; }
  if (*sCast == "QSizePolicy"){ *sCast = "CQSIZEPOLICY"; return true; }
  if (*sCast == "QSlider"){ *sCast = "CQSLIDER"; return true; }
  if (*sCast == "QSound"){ *sCast = "CQSOUND"; return true; }
  if (*sCast == "QSpinBox"){ *sCast = "CQSPINBOX"; return true; }
  if (*sCast == "QSplashScreen"){ *sCast = "CQSPLASHSCREEN"; return true; }
  if (*sCast == "QSplitter"){ *sCast = "CQSPLITTER"; return true; }
  if (*sCast == "QSplitterHandle"){ *sCast = "CQSPLITTERHANDLE"; return true; }
  if (*sCast == "QStackedLayout"){ *sCast = "CQSTACKEDLAYOUT"; return true; }
  if (*sCast == "QStackedWidget"){ *sCast = "CQSTACKEDWIDGET"; return true; }
  if (*sCast == "QStatusBar"){ *sCast = "CQSTATUSBAR"; return true; }
  if (*sCast == "QStatusTipEvent"){ *sCast = "CQSTATUSTIPEVENT"; return true; }
  if (*sCast == "QString"){ *sCast = "CQSTRING"; return true; }
  if (*sCast == "QStringList"){ *sCast = "CQSTRINGLIST"; return true; }
  if (*sCast == "QSvgWidget"){ *sCast = "CQSVGWIDGET"; return true; }
  if (*sCast == "QSyntaxHighlighter"){ *sCast = "CQSYNTAXHIGHLIGHTER"; return true; }
  if (*sCast == "QSystemLocale"){ *sCast = "CQSYSTEMLOCALE"; return true; }
  if (*sCast == "QSystemTrayIcon"){ *sCast = "CQSYSTEMTRAYICON"; return true; }
  if (*sCast == "QTabBar"){ *sCast = "CQTABBAR"; return true; }
  if (*sCast == "QTabWidget"){ *sCast = "CQTABWIDGET"; return true; }
  if (*sCast == "QTableView"){ *sCast = "CQTABLEVIEW"; return true; }
  if (*sCast == "QTableWidget"){ *sCast = "CQTABLEWIDGET"; return true; }
  if (*sCast == "QTableWidgetItem"){ *sCast = "CQTABLEWIDGETITEM"; return true; }
  if (*sCast == "QTextBlock"){ *sCast = "CQTEXTBLOCK"; return true; }
  if (*sCast == "QTextBlockFormat"){ *sCast = "CQTEXTBLOCKFORMAT"; return true; }
  if (*sCast == "QTextBrowser"){ *sCast = "CQTEXTBROWSER"; return true; }
  if (*sCast == "QTextCharFormat"){ *sCast = "CQTEXTCHARFORMAT"; return true; }
  if (*sCast == "QTextCursor"){ *sCast = "CQTEXTCURSOR"; return true; }
  if (*sCast == "QTextDocument"){ *sCast = "CQTEXTDOCUMENT"; return true; }
  if (*sCast == "QTextDocumentFragment"){ *sCast = "CQTEXTDOCUMENTFRAGMENT"; return true; }
  if (*sCast == "QTextEdit"){ *sCast = "CQTEXTEDIT"; return true; }
  if (*sCast == "QTextFormat"){ *sCast = "CQTEXTFORMAT"; return true; }
  if (*sCast == "QTextFrameFormat"){ *sCast = "CQTEXTFRAMEFORMAT"; return true; }
  if (*sCast == "QTextOption"){ *sCast = "CQTEXTOPTION"; return true; }
  if (*sCast == "QThread"){ *sCast = "CQTHREAD"; return true; }
  if (*sCast == "QTime"){ *sCast = "CQTIME"; return true; }
  if (*sCast == "QTimeEdit"){ *sCast = "CQTIMEEDIT"; return true; }
  if (*sCast == "QTimeLine"){ *sCast = "CQTIMELINE"; return true; }
  if (*sCast == "QTimer"){ *sCast = "CQTIMER"; return true; }
  if (*sCast == "QTimerEvent"){ *sCast = "CQTIMEREVENT"; return true; }
  if (*sCast == "QToolBar"){ *sCast = "CQTOOLBAR"; return true; }
  if (*sCast == "QToolBox"){ *sCast = "CQTOOLBOX"; return true; }
  if (*sCast == "QToolButton"){ *sCast = "CQTOOLBUTTON"; return true; }
  if (*sCast == "QTransform"){ *sCast = "CQTRANSFORM"; return true; }
  if (*sCast == "QTreeView"){ *sCast = "CQTREEVIEW"; return true; }
  if (*sCast == "QTreeWidget"){ *sCast = "CQTREEWIDGET"; return true; }
  if (*sCast == "QTreeWidgetItem"){ *sCast = "CQTREEWIDGETITEM"; return true; }
  if (*sCast == "QUrl"){ *sCast = "CQURL"; return true; }
  if (*sCast == "QUrlInfo"){ *sCast = "CQURLINFO"; return true; }
  if (*sCast == "QVBoxLayout"){ *sCast = "CQVBOXLAYOUT"; return true; }
  if (*sCast == "QValidator"){ *sCast = "CQVALIDATOR"; return true; }
  if (*sCast == "QVariant"){ *sCast = "CQVARIANT"; return true; }
  if (*sCast == "QWebPage"){ *sCast = "CQWEBPAGE"; return true; }
  if (*sCast == "QWebSettings"){ *sCast = "CQWEBSETTINGS"; return true; }
  if (*sCast == "QWebView"){ *sCast = "CQWEBVIEW"; return true; }
  if (*sCast == "QWhatsThisClickedEvent"){ *sCast = "CQWHATSTHISCLICKEDEVENT"; return true; }
  if (*sCast == "QWidget"){ *sCast = "CQWIDGET"; return true; }
  if (*sCast == "QWindowStateChangeEvent"){ *sCast = "CQWINDOWSTATECHANGEEVENT"; return true; }
  if (*sCast == "uiClass"){ *sCast = "CUICLASS"; return true; }

// End Generator h#3

  return false;
}
// END Q7B_Compiler_ConvertDeclareType

// ***


// *** OPERATOR ***********************************************************************************

Q7B Q7B_ASSIGNMENT(Q7B *l, Q7B *r)
{  
  *l = *r;

  return Q7B_ID(true); // needed for debug Q7B_ANDALSO 
}

Q7B Q7B_ASSIGNMENT2(Q7B *l, Q7B *r)
{  
  *l = *r;

  return *l; // needed for debug global variables with keyword Global
}

Q7B Q7B_STATICASSIGNMENT(Q7B *l, Q7B *r)
{  
  *l = *r;

  return *l; 
}

Q7B Q7B_ISEQUALCLASS(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_ID(l->type == r->type);
}

Q7B Q7B_EQUALEQUALEQUAL(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_ID(l->type == r->type);
}

Q7B Q7B_ISEQUALOBJECT(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_ID(l->ref == r->ref);
}

Q7B Q7B_EQUALEQUAL(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_ID(l->ref == r->ref);
}

Q7B Q7B_IsEqualValue(Q7B l, Q7B r)
{
  if (Q7B_nil(l) && Q7B_nil(r)){ return Q7B_ID(true); }
  
  if (!Q7B_nil(l) && !Q7B_nil(r)){
    if (l->type == typeid(QString).name()){
      if (r->type == typeid(QString).name()){
        return Q7B_ID( *((QString *) l->ref) == *((QString *) r->ref) );
      }

      QString s = Q7B_toString2(r);
      return Q7B_ID( *((QString *) l->ref) == s );

    }
    
    if (l->type == typeid(qint64).name()){
      if (r->type == typeid(qint64).name()){
        return Q7B_ID( *((qint64 *) l->ref) == *((qint64 *) r->ref) );
      }
      if (r->type == typeid(qreal).name()){
        return Q7B_ID( *((qint64 *) l->ref) == *((qreal *) r->ref) );
      }
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_ID( *((qint64 *) l->ref) == ((Q7B_Decimal *) r->ref)->toInteger() );
      }
      if (r->type == typeid(bool).name()){
        return Q7B_ID( *((qint64 *) l->ref) == *((bool *) r->ref) );
      }
    }

    if (l->type == typeid(qreal).name()){
      if (r->type == typeid(qreal).name()){
        return Q7B_ID( *((qreal *) l->ref) == *((qreal *) r->ref) );
      }
      if (r->type == typeid(qint64).name()){
        return Q7B_ID( *((qreal *) l->ref) == *((qint64 *) r->ref) );
      }
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_ID( *((qreal *) l->ref) == ((Q7B_Decimal *) r->ref)->toFloat() );
      }
      if (r->type == typeid(bool).name()){
        return Q7B_ID( *((qreal *) l->ref) == *((bool *) r->ref) );
      }
    }
 
    if (l->type == typeid(Q7B_Decimal).name()){
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_ID( ((Q7B_Decimal *) l->ref)->value() == ((Q7B_Decimal *) r->ref)->value() );
      }
      if (r->type == typeid(qint64).name()){
        return Q7B_ID( ((Q7B_Decimal *) l->ref)->toInteger() == *((qint64 *) r->ref) );
      }
      if (r->type == typeid(qreal).name()){
        return Q7B_ID( ((Q7B_Decimal *) l->ref)->toFloat() == *((qreal *) r->ref) );
      }
      if (r->type == typeid(bool).name()){
        return Q7B_ID( ((Q7B_Decimal *) l->ref)->value() == *((bool *) r->ref) );
      }
    }

    if (l->type == typeid(bool).name()){
      if (r->type == typeid(bool).name()){
        return Q7B_ID( *((bool *) l->ref) == *((bool *) r->ref) );
      }
      if (r->type == typeid(qint64).name()){
        return Q7B_ID( *((bool *) l->ref) == *((qint64 *) r->ref) );
      }
      if (r->type == typeid(qreal).name()){
        return Q7B_ID( *((bool *) l->ref) == *((qreal *) r->ref) );
      }
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_ID( *((bool *) l->ref) == ((Q7B_Decimal *) r->ref)->toInteger() );
      }

    }


    // TODO2 List,Dictionary f?r alle operators

    // TODO2 qsize, qrect..., Data,decimal f?r alle operators

  }

  QString a = Q7B_toString2(l);
  QString b = Q7B_toString2(r);
  return Q7B_ID( a == b );
}


Q7B Q7B_ISEQUALVALUE(Q7B l, Q7B r)
{
  return Q7B_IsEqualValue(l, r);
}

Q7B Q7B_EQUAL(Q7B l, Q7B r)
{
  return Q7B_IsEqualValue(l, r);
}

Q7B Q7B_UNEQUAL(Q7B l, Q7B r)
{ 
  if (Q7B_nil(l) && Q7B_nil(r)){ return Q7B_ID(false); }
  
  if (!Q7B_nil(l) && !Q7B_nil(r)){
    if (l->type == typeid(QString).name()){
      if (r->type == typeid(QString).name()){
        return Q7B_ID( *((QString *) l->ref) != *((QString *) r->ref) );
      }

      QString s = Q7B_toString2(r);
      return Q7B_ID( *((QString *) l->ref) != s );
    }
    
    if (l->type == typeid(qint64).name()){
      if (r->type == typeid(qint64).name()){
        return Q7B_ID( *((qint64 *) l->ref) != *((qint64 *) r->ref) );
      }
      if (r->type == typeid(qreal).name()){
        return Q7B_ID( *((qint64 *) l->ref) != *((qreal *) r->ref) );
      }
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_ID( *((qint64 *) l->ref) != ((Q7B_Decimal *) r->ref)->toInteger() );
      }
      if (r->type == typeid(bool).name()){
        return Q7B_ID( *((qint64 *) l->ref) != *((bool *) r->ref) );
      }
    }

    if (l->type == typeid(qreal).name()){
      if (r->type == typeid(qreal).name()){
        return Q7B_ID( *((qreal *) l->ref) != *((qreal *) r->ref) );
      }
      if (r->type == typeid(qint64).name()){
        return Q7B_ID( *((qreal *) l->ref) != *((qint64 *) r->ref) );
      }
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_ID( *((qreal *) l->ref) != ((Q7B_Decimal *) r->ref)->toFloat() );
      }
      if (r->type == typeid(bool).name()){
        return Q7B_ID( *((qreal *) l->ref) != *((bool *) r->ref) );
      }
    }

    if (l->type == typeid(Q7B_Decimal).name()){
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_ID( ((Q7B_Decimal *) l->ref)->value() != ((Q7B_Decimal *) r->ref)->value() );
      }
      if (r->type == typeid(qint64).name()){
        return Q7B_ID( ((Q7B_Decimal *) l->ref)->toInteger() != *((qint64 *) r->ref) );
      }
      if (r->type == typeid(qreal).name()){
        return Q7B_ID( ((Q7B_Decimal *) l->ref)->toFloat() != *((qreal *) r->ref) );
      }
      if (r->type == typeid(bool).name()){
        return Q7B_ID( ((Q7B_Decimal *) l->ref)->value() != *((bool *) r->ref) );
      }
    }

    if (l->type == typeid(bool).name()){
      if (r->type == typeid(bool).name()){
        return Q7B_ID( *((bool *) l->ref) != *((bool *) r->ref) );
      }
      if (r->type == typeid(qint64).name()){
        return Q7B_ID( *((bool *) l->ref) != *((qint64 *) r->ref) );
      }
      if (r->type == typeid(qreal).name()){
        return Q7B_ID( *((bool *) l->ref) != *((qreal *) r->ref) );
      }
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_ID( *((bool *) l->ref) != ((Q7B_Decimal *) r->ref)->toInteger() );
      }
    }
  }

  QString a = Q7B_toString2(l);
  QString b = Q7B_toString2(r);
  return Q7B_ID( a != b );  
}

Q7B Q7B_SMALLER(Q7B l, Q7B r)
{  
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qint64 *) l->ref) < *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) < *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) < ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qint64 *) l->ref) < *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qreal *) l->ref) < *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qreal *) l->ref) < *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qreal *) l->ref) < ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qreal *) l->ref) < *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->value() < ((Q7B_Decimal *) r->ref)->value() );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->toInteger() < *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->toFloat() < *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->value() < *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((bool *) l->ref) < *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((bool *) l->ref) < *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((bool *) l->ref) < *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((bool *) l->ref) < ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_ID(false);
} 

Q7B Q7B_GREATER(Q7B l, Q7B r)
{  
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qint64 *) l->ref) > *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) > *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) > ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qint64 *) l->ref) > *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qreal *) l->ref) > *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qreal *) l->ref) > *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qreal *) l->ref) > ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qreal *) l->ref) > *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->value() > ((Q7B_Decimal *) r->ref)->value() );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->toInteger() > *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->toFloat() > *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->value() > *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((bool *) l->ref) > *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((bool *) l->ref) > *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((bool *) l->ref) > *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((bool *) l->ref) > ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_ID(false);
} 

Q7B Q7B_SMALLEREQUAL(Q7B l, Q7B r)
{  
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
   /*   int ll = *((qint64 *) l->ref);
      int rr = *((qint64 *) r->ref);
      bool bb = *((qint64 *) l->ref) <= *((qint64 *) r->ref);*/
      return Q7B_ID( *((qint64 *) l->ref) <= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) <= *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) <= ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qint64 *) l->ref) <= *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qreal *) l->ref) <= *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qreal *) l->ref) <= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) <= ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qreal *) l->ref) <= *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->value() <= ((Q7B_Decimal *) r->ref)->value() );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->toInteger() <= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->toFloat() <= *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->value() <= *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((bool *) l->ref) <= *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((bool *) l->ref) <= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((bool *) l->ref) <= *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((bool *) l->ref) <= ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_ID(false);
} 

Q7B Q7B_GREATEREQUAL(Q7B l, Q7B r)
{  
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qint64 *) l->ref) >= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) >= *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) >= ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qint64 *) l->ref) >= *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qreal *) l->ref) >= *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qreal *) l->ref) >= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) >= ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qreal *) l->ref) >= *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->value() >= ((Q7B_Decimal *) r->ref)->value() );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->toInteger() >= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->toFloat() >= *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->value() >= *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((bool *) l->ref) >= *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((bool *) l->ref) >= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((bool *) l->ref) >= *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((bool *) l->ref) >= ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_ID(false);
} 

Q7B Q7B_FLIP(Q7B l)
{
  if (Q7B_nil(l)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
/*
unsigned int Value=4;          //   4 = 0000 0100 
Value = ~ Value;               // 251 = 1111 1011 
*/
    
  if (l->type == typeid(qint64).name()){
    return Q7B_ID( ~ *((qint64 *) l->ref) );
  }  
  
  Q7B_CASTEXCEPTION("Integer expected");
  return Q7B_ID(false);
} 


Q7B Q7B_NOT(Q7B l)
{
  if (Q7B_nil(l)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    return Q7B_ID( ! *((qint64 *) l->ref) );
  }
  if (l->type == typeid(bool).name()){
    return Q7B_ID( ! *((bool *) l->ref) );
  }
  if (l->type == typeid(qreal).name()){
    return Q7B_ID( ! *((qreal *) l->ref) );
  }
  if (l->type == typeid(Q7B_Decimal).name()){
    return Q7B_ID( ! ((Q7B_Decimal *) l->ref)->toInteger() );
  }  
  if (l->type == typeid(QString).name()){ // needed for If Not s Then   ' s As String
    return Q7B_ID( ((QString *) l->ref)->isEmpty() );
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_ID(false);
} 

Q7B Q7B_MINUS(Q7B l)
{
  if (Q7B_nil(l)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    return Q7B_ID( - *((qint64 *) l->ref) );
  }
  if (l->type == typeid(qreal).name()){
    return Q7B_ID( - *((qreal *) l->ref) );
  }
  if (l->type == typeid(Q7B_Decimal).name()){
    return Q7B_ID( ((Q7B_Decimal *) l->ref)->minus() );
  }
  
  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_ID(false);
} 

Q7B Q7B_AND(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qint64 *) l->ref) & *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) & (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) & (qint64) ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qint64 *) l->ref) & (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) & (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) & *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) & (qint64) ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) & (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() & ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->toInteger() & *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) ((Q7B_Decimal *) l->ref)->toFloat() & (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() & *((bool *) r->ref) );
      return Q7B_ID( d );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) & (qint64) *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) & *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) & (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) & ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_ID(false);
} 

Q7B Q7B_ANDALSO(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qint64 *) l->ref) && *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) && (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) && (qint64) ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qint64 *) l->ref) && (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) && (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) && *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) && (qint64) ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) && (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() && ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->toInteger() && *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) ((Q7B_Decimal *) l->ref)->toFloat() && (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() && *((bool *) r->ref) );
      return Q7B_ID( d );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) && (qint64) *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) && *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) && (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) && ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_ID(false);
} 

Q7B Q7B_ORELSE(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qint64 *) l->ref) || *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) || (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) || ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qint64 *) l->ref) || (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) || (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) || *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) || (qint64) ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) || (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() || ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->toInteger() || *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) ((Q7B_Decimal *) l->ref)->toFloat() || (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() || *((bool *) r->ref) );
      return Q7B_ID( d );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) || (qint64) *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) || *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) || (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) || (qint64) ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_ID(false);
} 

Q7B Q7B_OR(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qint64 *) l->ref) | *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) | (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) | ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qint64 *) l->ref) | (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) | (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) | *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) | (qint64) ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) | (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() | ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->toInteger() | *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) ((Q7B_Decimal *) l->ref)->toFloat() | (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() | *((bool *) r->ref) );
      return Q7B_ID( d );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) | (qint64) *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) | *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) | (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) | (qint64) ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_ID(false);
} 

Q7B Q7B_XOR(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qint64 *) l->ref) ^ *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) ^ (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) ^ ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qint64 *) l->ref) ^ (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) ^ (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) ^ *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) ^ (qint64) ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) ^ (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() ^ ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( ((Q7B_Decimal *) l->ref)->toInteger() ^ *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) ((Q7B_Decimal *) l->ref)->toFloat() ^ (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() ^ *((bool *) r->ref) );
      return Q7B_ID( d );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) ^ (qint64) *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) ^ *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) ^ (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( (qint64) *((bool *) l->ref) ^ (qint64) ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_ID(false);
} 

Q7B Q7B_SHL(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name() && r->type == typeid(qint64).name()){
    return Q7B_ID( *((qint64 *) l->ref) << *((qint64 *) r->ref) );
  }
  
  Q7B_CASTEXCEPTION("Integer expected");
  return Q7B_ID(false);
} 

Q7B Q7B_SHR(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name() && r->type == typeid(qint64).name()){
    return Q7B_ID( *((qint64 *) l->ref) >> *((qint64 *) r->ref) );
  }

  Q7B_CASTEXCEPTION("Integer expected");
  return Q7B_ID(false);
} 

Q7B Q7B_ADD(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  //checker();
  
  if (l->type == typeid(QString).name()){
    if (r->type == typeid(QString).name()){
      return Q7B_ID( *((QString *) l->ref) + *((QString *) r->ref) );
    }

    QString s = Q7B_toString2(r);
    return Q7B_ID( *((QString *) l->ref) + s );
  }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qint64 *) l->ref) + *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) + *((qreal *) r->ref) );
    }
  /*  if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qint64 *) l->ref) + *((bool *) r->ref) );
    }*/
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) + ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(QString).name()){
      Q7B_CASTEXCEPTION("'String' not allowed with + on the right side. Use & instead.");
      return Q7B_ID(false);      
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qreal *) l->ref) + *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qreal *) l->ref) + *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qreal *) l->ref) + ((Q7B_Decimal *) r->ref)->toFloat() );
    }
   /* if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qreal *) l->ref) + *((bool *) r->ref) );
    }*/
    if (r->type == typeid(QString).name()){
      Q7B_CASTEXCEPTION("'String' not allowed with + on the right side. Use & instead.");
      return Q7B_ID(false);      
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() + ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qint64).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() + (*((qint64 *) r->ref) * 10000) );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qreal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() + (*((qreal *) r->ref) * 10000) );
      return Q7B_ID( d );
    }
  /* if (r->type == typeid(bool).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() + *((bool *) r->ref) );
      return Q7B_ID( d );
    }*/
  }
/*
  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((bool *) l->ref) + *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((bool *) l->ref) + *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((bool *) l->ref) + *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((bool *) l->ref) + ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(QString).name()){
      Q7B_CASTEXCEPTION("'String' not allowed with + on the right side. Use & instead.");
      return Q7B_ID(false);      
    }
  }*/

  // TODO2 List add
  
  Q7B_CASTEXCEPTION("'String' or number expected");
  return Q7B_ID(false);
}

Q7B Q7B_SUB(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  //checker();

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
    /*  int ll = *((qint64 *) l->ref);
      int rr = *((qint64 *) r->ref);*/
      return Q7B_ID( *((qint64 *) l->ref) - *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) - *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) - ((Q7B_Decimal *) r->ref)->toInteger() );
    }
 /*   if (r->type == typeid(bool).name()){
      return Q7B_ID( *((qint64 *) l->ref) - *((bool *) r->ref) );
    }*/
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qreal *) l->ref) - *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qreal *) l->ref) - *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qreal *) l->ref) - ((Q7B_Decimal *) r->ref)->toFloat() );
    }
  /*  if (r->type == typeid(bool).name()){ 
      return Q7B_ID( *((qreal *) l->ref) - *((bool *) r->ref) );
    }*/
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() - ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qint64).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() - (*((qint64 *) r->ref) * 10000) );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qreal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() - (*((qreal *) r->ref) * 10000) );
      return Q7B_ID( d );
    }
  /*  if (r->type == typeid(bool).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() - *((bool *) r->ref) );
      return Q7B_ID( d );
    }*/
  }
/*
  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_ID( *((bool *) l->ref) - *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((bool *) l->ref) - *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((bool *) l->ref) - *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((bool *) l->ref) - ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }*/

  // TODO2 List add
  
  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_ID(false);
}

Q7B Q7B_CONCAT(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(QString).name()){
    if (r->type == typeid(QString).name()){
      return Q7B_ID( *((QString *) l->ref) + *((QString *) r->ref) );
    }

    QString s = Q7B_toString2(r);
    return Q7B_ID( *((QString *) l->ref) + s );
  }

  QString ss = Q7B_toString2(l);
  
  if (r->type == typeid(QString).name()){
    return Q7B_ID( ss + *((QString *) r->ref) );
  }

  QString s = Q7B_toString2(r);
  return Q7B_ID( ss + s );
}

Q7B Q7B_POWER(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( pow((qreal) (Q7B_IDqint64(l)), (int) Q7B_IDqint64((r))) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( pow((qreal) (Q7B_IDqint64(l)), Q7B_IDqreal((r))) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( pow((qreal) (Q7B_IDqint64(l)), (int) ((Q7B_Decimal *) r->ref)->toInteger()) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( pow(Q7B_IDqreal((l)), Q7B_IDqreal((r))) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( pow(Q7B_IDqreal((l)), (int) Q7B_IDqint64((r))) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( pow(Q7B_IDqreal((l)), (int) ((Q7B_Decimal *) r->ref)->toFloat()) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( pow(((Q7B_Decimal *) l->ref)->toFloat(), (int) ((Q7B_Decimal *) r->ref)->toInteger()) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( pow(((Q7B_Decimal *) l->ref)->toFloat(), (int) Q7B_IDqint64((r))) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( pow(((Q7B_Decimal *) l->ref)->toFloat(), Q7B_IDqreal((r))) );
    }
  }

  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_ID(false);
}

Q7B Q7B_MUL(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  //checker();

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qint64 *) l->ref) * *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) * *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) * ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qreal *) l->ref) * *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qreal *) l->ref) * *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) * ((Q7B_Decimal *) r->ref)->toFloat() );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() * ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qint64).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() * (*((qint64 *) r->ref) * 10000) );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qreal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() * (*((qreal *) r->ref) * 10000) );
      return Q7B_ID( d );
    }    
  }

  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_ID(false);
}

Q7B Q7B_IDIV(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qint64 *) l->ref) / *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) / (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) / ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) / (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) / *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) / (qint64) ((Q7B_Decimal *) r->ref)->toFloat() );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() / ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qint64).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() / (*((qint64 *) r->ref) * 10000) );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qreal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() / (qint64) (*((qreal *) r->ref) * 10000) );
      return Q7B_ID( d );
    }
  }

  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_ID(false);
}

Q7B Q7B_DIV(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  //checker();

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( (qreal) (*((qint64 *) l->ref)) / *((qint64 *) r->ref) ); // force qreal for l, to get a float division
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qreal) (*((qint64 *) l->ref)) / *((qreal *) r->ref) ); // force qreal for l, to get a float division
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( (qreal) (*((qint64 *) l->ref)) / ((Q7B_Decimal *) r->ref)->toFloat() ); // force qreal for l, to get a float division
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qreal *) l->ref) / *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qreal *) l->ref) / *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qreal *) l->ref) / ((Q7B_Decimal *) r->ref)->toFloat() );
    }
  }
  
  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() / ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qint64).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() / (*((qint64 *) r->ref) * 10000) );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qreal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() / (*((qreal *) r->ref) * 10000) );
      return Q7B_ID( d );
    }
  }

  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_ID(false);
}

Q7B Q7B_MOD(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( *((qint64 *) l->ref) % *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( *((qint64 *) l->ref) % (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( *((qint64 *) l->ref) % ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) % (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) % *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_ID( (qint64) *((qreal *) l->ref) % (qint64) ((Q7B_Decimal *) r->ref)->toFloat() );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() % ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qint64).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() % (*((qint64 *) r->ref) * 10000) );
      return Q7B_ID( d );
    }
    if (r->type == typeid(qreal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() % (qint64) (*((qreal *) r->ref) * 10000) );
      return Q7B_ID( d );
    }
  }

  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_ID(false);
}

// ***************************************************************************************************************************************************************



// ***************************************************************************************************************************************************************

Q7B Q7B_VB6MsgBox(QString sMessage, int n, QString sTitle)
{
    //bool kbOKOnly = (n & 0) == 0;
    bool kbOKCancel = (n & 1) == 1;
    bool kbAbortRetryIgnore = (n & 2) == 2;
    bool kbYesNoCancel = (n & 3) == 3;
    bool kbYesNo = (n & 4) == 4;
    bool kbRetryCancel = (n & 5) == 5;

    bool kbOKOnly = !kbOKCancel && !kbAbortRetryIgnore && !kbYesNoCancel && !kbYesNo && !kbRetryCancel;

    bool kbInformation = (n & 64) == 64;
    bool kbExclamation = kbInformation ? false : (n & 48) == 48;
    bool kbQuestion = kbExclamation | kbInformation ? false : (n & 32) == 32;
    bool kbCritical = kbExclamation | kbInformation | kbQuestion ? false : (n & 16) == 16;

    bool kbDefaultButton1 = n & 0;
    bool kbDefaultButton2 = (n & 256) == 256;
    bool kbDefaultButton3 = (n & 512) == 512;

    int k0 = QMessageBox::NoIcon;
    int k1 = QMessageBox::Yes | QMessageBox::Default;
    int k2 = QMessageBox::NoButton;
    int k3 = QMessageBox::NoButton;

    if (kbCritical) k0 = QMessageBox::Critical;
    else if (kbQuestion) k0 = QMessageBox::Question;
    else if (kbExclamation) k0 = QMessageBox::Warning;
    else if (kbInformation) k0 = QMessageBox::Information;
    
    if (kbOKOnly){
      k1 = QMessageBox::Ok | QMessageBox::Escape;
    } else if (kbOKCancel){
      k1 = QMessageBox::Ok;
      k2 = QMessageBox::Cancel | QMessageBox::Escape;
    } else if (kbAbortRetryIgnore){
      k1 = QMessageBox::Abort;
      k2 = QMessageBox::Retry | QMessageBox::Escape;
      k3 = QMessageBox::Ignore;
    } else if (kbYesNoCancel){
      k1 = QMessageBox::Yes;
      k2 = QMessageBox::No;
      k3 = QMessageBox::Cancel | QMessageBox::Escape;
    } else if (kbYesNo){
      k1 = QMessageBox::Yes;
      k2 = QMessageBox::No | QMessageBox::Escape;
    } else if (kbRetryCancel){
      k1 = QMessageBox::Retry;
      k2 = QMessageBox::Cancel | QMessageBox::Escape;
    }

    if (kbDefaultButton1) k1 = k1 | QMessageBox::Default;
    else if (kbDefaultButton2) k2 = k2 | QMessageBox::Default;
    else if (kbDefaultButton3) k3 = k3 | QMessageBox::Default;    
    
    QMessageBox mb((QMessageBox::Icon) k0, !sTitle.isEmpty() ? sTitle : qApp->applicationName().isEmpty() ? "Q7Basic" : qApp->applicationName(), 
      sMessage, (QMessageBox::StandardButton) (k1| k2 | k3), 0); //qApp->activeWindow()


    if (kbOKOnly){
      mb.setButtonText( QMessageBox::Yes, QObject::tr("&OK") );
    } else if (kbOKCancel){
      mb.setButtonText( QMessageBox::Yes, QObject::tr("&OK") );
      mb.setButtonText( QMessageBox::No, QObject::tr("&Cancel") );
    } else if (kbAbortRetryIgnore){
      mb.setButtonText( QMessageBox::Yes, QObject::tr("&Abort") );
      mb.setButtonText( QMessageBox::No, QObject::tr("&Retry") );
      mb.setButtonText( QMessageBox::Cancel, QObject::tr("&Ignore") );
    } else if (kbYesNoCancel){
      mb.setButtonText( QMessageBox::Yes, QObject::tr("&Yes") );
      mb.setButtonText( QMessageBox::No, QObject::tr("&No") );
      mb.setButtonText( QMessageBox::Cancel, QObject::tr("&Cancel") );
    } else if (kbYesNo){
      mb.setButtonText( QMessageBox::Yes, QObject::tr("&Yes") );
      mb.setButtonText( QMessageBox::No, QObject::tr("&No") );
    } else if (kbRetryCancel){
      mb.setButtonText( QMessageBox::Yes, QObject::tr("&Retry") );
      mb.setButtonText( QMessageBox::No, QObject::tr("&Cancel") );
    }

    switch( mb.exec() ) {
    case QMessageBox::Ok:
        return Q7B_ID(1);
    case QMessageBox::Cancel:
        return Q7B_ID(2);
    case QMessageBox::Abort:
        return Q7B_ID(3);
    case QMessageBox::Retry:
        return Q7B_ID(4);
    case QMessageBox::Ignore:
        return Q7B_ID(5);
    case QMessageBox::Yes:
        return Q7B_ID(6);
        break;
    case QMessageBox::No:
        return Q7B_ID(7);
    default:
      return Q7B_ID(0);
    }
    return Q7B_ID(0);
}

// *** builtins ****

void Q7B_DOEVENTS(Q7B MilliSeconds)
{
  if (Q7B_nil(Q7B_INTEGER(MilliSeconds))){ Q7B_EXCEPTION("Integer expected"); return; }

  qint64 n = Q7B_IDqint64(MilliSeconds);
  if (n > 0){
    qApp->processEvents(QEventLoop::AllEvents, n);
  } else {
    qApp->processEvents();
  }
  
}

void Q7B_EXECAFTERMSEC(Q7B MilliSeconds, Q7B SignalProcedureName, Q7B Object)
{
  QString SLOT_ESCAPE = "1";

  if (Q7B_nil(Q7B_INTEGER(MilliSeconds))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(SignalProcedureName))){ Q7B_EXCEPTION("String expected"); return; }

  QTimer::singleShot(Q7B_IDqint64(MilliSeconds), (QObject *)(Object->ref), QString(SLOT_ESCAPE + Q7B_IDQString(SignalProcedureName) + "()").toAscii().constData());
}

Q7B Q7B_MSGBOX(Q7B a, Q7B b, Q7B VB6MsgBox)
{
  QString s = Q7B_toString2(a); if (Q7B_bException){ return Q7B_idnil; }

  bool bVB6MsgBox = Q7B_IDbool(VB6MsgBox);

  if (bVB6MsgBox){
    return Q7B_ID( Q7B_VB6MsgBox(s, Q7B_IDqint64(b), "" ) );

  } else {
    QString ss = Q7B_toString2(b); if (Q7B_bException){ return Q7B_idnil; }

    return Q7B_ID( QMessageBox::information(0, s, ss) );//qApp->activeWindow()
  }
}

Q7B Q7B___MSGBOX(Q7B a, Q7B b, Q7B Buttons, Q7B VB6MsgBox)
{
  QString s = Q7B_toString2(a); if (Q7B_bException){ return Q7B_idnil; }

  bool bVB6MsgBox = Q7B_IDbool(VB6MsgBox);

  if (bVB6MsgBox){

    QString ss = Q7B_toString2(Buttons); if (Q7B_bException){ return Q7B_idnil; }

    return Q7B_ID( Q7B_VB6MsgBox(s, Q7B_IDqint64(b), Q7B_IDQString(Buttons) ) );

  } else {
    QString ss = Q7B_toString2(b); if (Q7B_bException){ return Q7B_idnil; }
    if (Q7B_nil(Q7B_INTEGER(Buttons))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

    return Q7B_ID( QMessageBox::information(0, s, ss, (QMessageBox::StandardButton) *((qint64 *) Buttons->ref ) ) );//qApp->activeWindow()
  }
}

Q7B Q7B__MSGBOX(Q7B Q7B_Object)
{
  QString s = Q7B_toString2(Q7B_Object); if (Q7B_bException){ return Q7B_idnil; }

  return Q7B_ID( QMessageBox::information(0, "", s) ); //qApp->activeWindow()
}

Q7B Q7B_INPUTBOX(Q7B Prompt, Q7B Title, Q7B Default)
{
  if (Q7B_nil(Q7B_QSTRING(Prompt))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Title))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Default))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  bool ok;
  QString text;
  
  text = QInputDialog::getText(qApp->focusWidget(), ((QString *) Title->ref)->isEmpty() ? *((QString *) Title->ref) : qApp->applicationName(), *((QString *) Prompt->ref), QLineEdit::Normal, ((QString *) Default->ref)->isEmpty() ? "" : *((QString *) Default->ref), &ok, 0);

  if (ok && !text.isEmpty()){
    return Q7B_ID(text);
  }    

  return Q7B_idnil;
}     

bool Q7B_fileExists(QString & s)
{

  bool b = false;
  
  b = QFile::exists(qApp->applicationDirPath() + "/" + s); // important first check applicationDirPath

  if (b == false){
    b = QFile::exists( s );
  }

  if (b){ // check for directory
    QDir d(s);
    b = !d.exists(); 
  }

  return b;
}

Q7B Q7B_ISDIR(Q7B FilePath)
{
  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_ID( QFileInfo( *((QString *) FilePath->ref)).isDir() );
}    

Q7B Q7B_FILE(Q7B FilePath)
{
  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_ID( Q7B_fileExists( *((QString *) FilePath->ref) ) );
}    

bool Q7B_copyFile (const QString& from, const QString& to)
{

  //QMessageBox::information(0, from, to);

  QString TO = to;
  if (from.toLower() != TO.toLower()){
    QFile file(from);
    if (file.exists()){
      QFile file2(TO);  
      file2.remove();
      
      if (QDir(TO).exists()){
        QFileInfo fi(from);
        QFileInfo fi2(TO);
        TO = fi2.absoluteFilePath(); // absoluteFilePath = dir       
        TO += QString("/") + fi.fileName();        
      }
      return file.copy(TO);
    }
  }
  return false;
} 

bool Q7B_copyDir (const QString& from, const QString& to, bool bFirst)
{
  if (QDir(from).exists()){

    QFileInfo fi(from);
    QString TO = to;
    if (bFirst){
      TO += "/" + fi.fileName(); // fileName = dir       
    }

    QDir d;
    d.mkpath(TO);

    QDir thisDir( from );	
    QFileInfoList files = thisDir.entryInfoList();

    if ( files.size() ) {

      QFileInfo fi;
      for (int i = 0; i < files.size(); ++i) {
        fi = files.at(i);

        //qApp->processEvents();

        QString ss = fi.absoluteFilePath();

		    if (fi.fileName() == "." || fi.fileName() == ".."){
		        ; // nothing
		    } else if ( fi.isSymLink()){
            ; // nothing
		    } else if ( fi.isDir() ){

          if (!Q7B_copyDir(fi.absoluteFilePath(), TO + "/" + fi.fileName(), false)) return false;

        } else {

          if (!Q7B_copyFile(fi.absoluteFilePath(), TO + "/" + fi.fileName())) return false;

        }		    
	    }
    
    }    
    return true;
  }
  return false;
}

// Q7B_COPY kopiert verzeichnisse wie dateien
// Q7B_COPYDIR kopiert verzeichnisse und erstellt am ziel eine ordnerebene zus?tzlich
Q7B Q7B_COPY(Q7B SourceFilePath, Q7B DestinationFilePath)
{
  if (Q7B_nil(Q7B_QSTRING(SourceFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo fi(*((QString *) SourceFilePath->ref));  

  if (fi.isDir()){
    return Q7B_ID( Q7B_copyDir(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref), false) );
  } else {
    return Q7B_ID( Q7B_copyFile(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref)) );
  }
}    

// Q7B_COPY kopiert verzeichnisse wie dateien
// Q7B_COPYDIR kopiert verzeichnisse und erstellt am ziel eine ordnerebene zus?tzlich
Q7B Q7B_COPYDIR(Q7B SourceFilePath, Q7B DestinationFilePath)
{
  if (Q7B_nil(Q7B_QSTRING(SourceFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo fi(*((QString *) SourceFilePath->ref));  

  if (fi.isDir()){
    return Q7B_ID( Q7B_copyDir(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref), true) );
  } else {
    return Q7B_ID( Q7B_copyFile(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref)) );
  }
}    

Q7B Q7B_MOVE(Q7B SourceFilePath, Q7B DestinationFilePath)
{
  if (Q7B_nil(Q7B_QSTRING(SourceFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo fi(*((QString *) SourceFilePath->ref));  

  if (fi.isDir()){
    QDir d;
    return Q7B_ID( d.rename(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref)) );
  } else {
    if (Q7B_copyFile(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref))){
      return Q7B_ID(QFile::remove(*((QString *) SourceFilePath->ref)));      
    }
  }
  return Q7B_ID(false);
}    


Q7B Q7B_DELETE(Q7B FilePath)
{
  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo fi(*((QString *) FilePath->ref));  

  if (fi.isDir()){
    QDir d;
    return Q7B_ID( d.rmpath( *((QString *) FilePath->ref) ));
  } else {
    return Q7B_ID(QFile::remove( *((QString *) FilePath->ref) ));
  }
}    

Q7B Q7B_DRIVES()
{
  QFileInfoList l = QDir::drives();

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

  for (int i = 0; i < l.size(); i++){
     a->append(Q7B_ID( l.at(i).absoluteFilePath()));
  }

  return q;
}     

Q7B Q7B_DIR(Q7B FilePath, Q7B Create)
{
  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Create))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (*((bool *) Create->ref)){ 
    QDir d;

    return Q7B_ID( d.mkpath( *((QString *) FilePath->ref) ) );
  } else {

    QDir d;
    return Q7B_ID( d.exists( *((QString *) FilePath->ref) ) );
  }
}     

Q7B Q7B_CLASSNAME(Q7B Q7B_Object)
{
  if (Q7B_Object->q7b_array) return Q7B_ID("Array");
  if (Q7B_Object->q7b_type) return Q7B_ID("User defined type");

  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }  

  // QOBJECT vs. void siehe auch Q7B_CLASSNAME(...)
  if (Q7B_Object->type == typeid(qint64).name()){
    return Q7B_ID("Integer");

  } else if (Q7B_Object->type == typeid(qreal).name()){
    return Q7B_ID("Float");

  } else if (Q7B_Object->type == typeid(bool).name()){
    return Q7B_ID("Boolean");

  } else if (Q7B_Object->type == typeid(QDateTime).name()){
    return Q7B_ID("DateTime");

  } else if (Q7B_Object->type == typeid(Q7B_Decimal).name()){
    return Q7B_ID("Decimal");

  } else if (Q7B_Object->type == typeid(QString).name()){    
    return Q7B_ID("String");

  } else if (Q7B_Object->type == typeid(Q7B_List).name()){    
    return Q7B_ID("List");

  } else if (Q7B_Object->type == typeid(Q7B_Dictionary).name()){    
    return Q7B_ID("Dictionary");

  // Begin Generator h#8
  } else if (Q7B_Object->type == typeid(QAccessibleEvent).name()){
     return Q7B_ID("QAccessibleEvent");

  } else if (Q7B_Object->type == typeid(QActionEvent).name()){
     return Q7B_ID("QActionEvent");

  } else if (Q7B_Object->type == typeid(QBitmap).name()){
     return Q7B_ID("QBitmap");

  } else if (Q7B_Object->type == typeid(QBoxLayout).name()){
     return Q7B_ID("QBoxLayout");

  } else if (Q7B_Object->type == typeid(QBrush).name()){
     return Q7B_ID("QBrush");

  } else if (Q7B_Object->type == typeid(QByteArray).name()){
     return Q7B_ID("QByteArray");

  } else if (Q7B_Object->type == typeid(QChar).name()){
     return Q7B_ID("QChar");

  } else if (Q7B_Object->type == typeid(QChildEvent).name()){
     return Q7B_ID("QChildEvent");

  } else if (Q7B_Object->type == typeid(QCloseEvent).name()){
     return Q7B_ID("QCloseEvent");

  } else if (Q7B_Object->type == typeid(QColor).name()){
     return Q7B_ID("QColor");

  } else if (Q7B_Object->type == typeid(QContextMenuEvent).name()){
     return Q7B_ID("QContextMenuEvent");

  } else if (Q7B_Object->type == typeid(QCursor).name()){
     return Q7B_ID("QCursor");

  } else if (Q7B_Object->type == typeid(QDate).name()){
     return Q7B_ID("QDate");

  } else if (Q7B_Object->type == typeid(QDateTime).name()){
     return Q7B_ID("QDateTime");

  } else if (Q7B_Object->type == typeid(QDeclarativeContext).name()){
     return Q7B_ID("QDeclarativeContext");

  } else if (Q7B_Object->type == typeid(QDir).name()){
     return Q7B_ID("QDir");

  } else if (Q7B_Object->type == typeid(QDragLeaveEvent).name()){
     return Q7B_ID("QDragLeaveEvent");

  } else if (Q7B_Object->type == typeid(QDropEvent).name()){
     return Q7B_ID("QDropEvent");

  } else if (Q7B_Object->type == typeid(QDynamicPropertyChangeEvent).name()){
     return Q7B_ID("QDynamicPropertyChangeEvent");

  } else if (Q7B_Object->type == typeid(QElapsedTimer).name()){
     return Q7B_ID("QElapsedTimer");

  } else if (Q7B_Object->type == typeid(QEvent).name()){
     return Q7B_ID("QEvent");

  } else if (Q7B_Object->type == typeid(QFileInfo).name()){
     return Q7B_ID("QFileInfo");

  } else if (Q7B_Object->type == typeid(QFileInfoList).name()){
     return Q7B_ID("QFileInfoList");

  } else if (Q7B_Object->type == typeid(QFileOpenEvent).name()){
     return Q7B_ID("QFileOpenEvent");

  } else if (Q7B_Object->type == typeid(QFocusEvent).name()){
     return Q7B_ID("QFocusEvent");

  } else if (Q7B_Object->type == typeid(QFont).name()){
     return Q7B_ID("QFont");

  } else if (Q7B_Object->type == typeid(QFontDatabase).name()){
     return Q7B_ID("QFontDatabase");

  } else if (Q7B_Object->type == typeid(QFontInfo).name()){
     return Q7B_ID("QFontInfo");

  } else if (Q7B_Object->type == typeid(QFontMetrics).name()){
     return Q7B_ID("QFontMetrics");

  } else if (Q7B_Object->type == typeid(QFormLayout).name()){
     return Q7B_ID("QFormLayout");

  } else if (Q7B_Object->type == typeid(QGraphicsSceneEvent).name()){
     return Q7B_ID("QGraphicsSceneEvent");

  } else if (Q7B_Object->type == typeid(QGridLayout).name()){
     return Q7B_ID("QGridLayout");

  } else if (Q7B_Object->type == typeid(QHBoxLayout).name()){
     return Q7B_ID("QHBoxLayout");

  } else if (Q7B_Object->type == typeid(QHelpEvent).name()){
     return Q7B_ID("QHelpEvent");

  } else if (Q7B_Object->type == typeid(QHideEvent).name()){
     return Q7B_ID("QHideEvent");

  } else if (Q7B_Object->type == typeid(QHostAddress).name()){
     return Q7B_ID("QHostAddress");

  } else if (Q7B_Object->type == typeid(QHostInfo).name()){
     return Q7B_ID("QHostInfo");

  } else if (Q7B_Object->type == typeid(QHoverEvent).name()){
     return Q7B_ID("QHoverEvent");

  } else if (Q7B_Object->type == typeid(QIcon).name()){
     return Q7B_ID("QIcon");

  } else if (Q7B_Object->type == typeid(QIconDragEvent).name()){
     return Q7B_ID("QIconDragEvent");

  } else if (Q7B_Object->type == typeid(QImage).name()){
     return Q7B_ID("QImage");

  } else if (Q7B_Object->type == typeid(QInputEvent).name()){
     return Q7B_ID("QInputEvent");

  } else if (Q7B_Object->type == typeid(QInputMethodEvent).name()){
     return Q7B_ID("QInputMethodEvent");

  } else if (Q7B_Object->type == typeid(QKeySequence).name()){
     return Q7B_ID("QKeySequence");

  } else if (Q7B_Object->type == typeid(QLayout).name()){
     return Q7B_ID("QLayout");

  } else if (Q7B_Object->type == typeid(QLayoutItem).name()){
     return Q7B_ID("QLayoutItem");

  } else if (Q7B_Object->type == typeid(QLine).name()){
     return Q7B_ID("QLine");

  } else if (Q7B_Object->type == typeid(QList<QStringList>).name()){
     return Q7B_ID("QList<QStringList>");

  } else if (Q7B_Object->type == typeid(QListWidgetItem).name()){
     return Q7B_ID("QListWidgetItem");

  } else if (Q7B_Object->type == typeid(QLocalSocket).name()){
     return Q7B_ID("QLocalSocket");

  } else if (Q7B_Object->type == typeid(QLocale).name()){
     return Q7B_ID("QLocale");

  } else if (Q7B_Object->type == typeid(QMargins).name()){
     return Q7B_ID("QMargins");

  } else if (Q7B_Object->type == typeid(QMatrix).name()){
     return Q7B_ID("QMatrix");

  } else if (Q7B_Object->type == typeid(QModelIndex).name()){
     return Q7B_ID("QModelIndex");

  } else if (Q7B_Object->type == typeid(QMoveEvent).name()){
     return Q7B_ID("QMoveEvent");

  } else if (Q7B_Object->type == typeid(QNetworkRequest).name()){
     return Q7B_ID("QNetworkRequest");

  } else if (Q7B_Object->type == typeid(QPaintEvent).name()){
     return Q7B_ID("QPaintEvent");

  } else if (Q7B_Object->type == typeid(QPainter).name()){
     return Q7B_ID("QPainter");

  } else if (Q7B_Object->type == typeid(QPalette).name()){
     return Q7B_ID("QPalette");

  } else if (Q7B_Object->type == typeid(QPen).name()){
     return Q7B_ID("QPen");

  } else if (Q7B_Object->type == typeid(QPicture).name()){
     return Q7B_ID("QPicture");

  } else if (Q7B_Object->type == typeid(QPixmap).name()){
     return Q7B_ID("QPixmap");

  } else if (Q7B_Object->type == typeid(QPoint).name()){
     return Q7B_ID("QPoint");

  } else if (Q7B_Object->type == typeid(QPolygon).name()){
     return Q7B_ID("QPolygon");

  } else if (Q7B_Object->type == typeid(QPrinter).name()){
     return Q7B_ID("QPrinter");

  } else if (Q7B_Object->type == typeid(QPrinterInfo).name()){
     return Q7B_ID("QPrinterInfo");

  } else if (Q7B_Object->type == typeid(QProcess).name()){
     return Q7B_ID("QProcess");

  } else if (Q7B_Object->type == typeid(QProcessEnvironment).name()){
     return Q7B_ID("QProcessEnvironment");

  } else if (Q7B_Object->type == typeid(QRect).name()){
     return Q7B_ID("QRect");

  } else if (Q7B_Object->type == typeid(QRegExp).name()){
     return Q7B_ID("QRegExp");

  } else if (Q7B_Object->type == typeid(QRegion).name()){
     return Q7B_ID("QRegion");

  } else if (Q7B_Object->type == typeid(QResizeEvent).name()){
     return Q7B_ID("QResizeEvent");

  } else if (Q7B_Object->type == typeid(QResource).name()){
     return Q7B_ID("QResource");

  } else if (Q7B_Object->type == typeid(QRgb).name()){
     return Q7B_ID("QRgb");

  } else if (Q7B_Object->type == typeid(QShortcutEvent).name()){
     return Q7B_ID("QShortcutEvent");

  } else if (Q7B_Object->type == typeid(QShowEvent).name()){
     return Q7B_ID("QShowEvent");

  } else if (Q7B_Object->type == typeid(QSize).name()){
     return Q7B_ID("QSize");

  } else if (Q7B_Object->type == typeid(QSizeF).name()){
     return Q7B_ID("QSizeF");

  } else if (Q7B_Object->type == typeid(QSizePolicy).name()){
     return Q7B_ID("QSizePolicy");

  } else if (Q7B_Object->type == typeid(QStackedLayout).name()){
     return Q7B_ID("QStackedLayout");

  } else if (Q7B_Object->type == typeid(QStatusTipEvent).name()){
     return Q7B_ID("QStatusTipEvent");

  } else if (Q7B_Object->type == typeid(QString).name()){
     return Q7B_ID("QString");

  } else if (Q7B_Object->type == typeid(QStringList).name()){
     return Q7B_ID("QStringList");

  } else if (Q7B_Object->type == typeid(QSystemLocale).name()){
     return Q7B_ID("QSystemLocale");

  } else if (Q7B_Object->type == typeid(QSystemTrayIcon).name()){
     return Q7B_ID("QSystemTrayIcon");

  } else if (Q7B_Object->type == typeid(QTableWidgetItem).name()){
     return Q7B_ID("QTableWidgetItem");

  } else if (Q7B_Object->type == typeid(QTextBlock).name()){
     return Q7B_ID("QTextBlock");

  } else if (Q7B_Object->type == typeid(QTextBlockFormat).name()){
     return Q7B_ID("QTextBlockFormat");

  } else if (Q7B_Object->type == typeid(QTextCharFormat).name()){
     return Q7B_ID("QTextCharFormat");

  } else if (Q7B_Object->type == typeid(QTextCursor).name()){
     return Q7B_ID("QTextCursor");

  } else if (Q7B_Object->type == typeid(QTextDocumentFragment).name()){
     return Q7B_ID("QTextDocumentFragment");

  } else if (Q7B_Object->type == typeid(QTextFormat).name()){
     return Q7B_ID("QTextFormat");

  } else if (Q7B_Object->type == typeid(QTextFrameFormat).name()){
     return Q7B_ID("QTextFrameFormat");

  } else if (Q7B_Object->type == typeid(QTextOption).name()){
     return Q7B_ID("QTextOption");

  } else if (Q7B_Object->type == typeid(QTime).name()){
     return Q7B_ID("QTime");

  } else if (Q7B_Object->type == typeid(QTimerEvent).name()){
     return Q7B_ID("QTimerEvent");

  } else if (Q7B_Object->type == typeid(QTransform).name()){
     return Q7B_ID("QTransform");

  } else if (Q7B_Object->type == typeid(QTreeWidgetItem).name()){
     return Q7B_ID("QTreeWidgetItem");

  } else if (Q7B_Object->type == typeid(QUrl).name()){
     return Q7B_ID("QUrl");

  } else if (Q7B_Object->type == typeid(QUrlInfo).name()){
     return Q7B_ID("QUrlInfo");

  } else if (Q7B_Object->type == typeid(QVBoxLayout).name()){
     return Q7B_ID("QVBoxLayout");

  } else if (Q7B_Object->type == typeid(QVariant).name()){
     return Q7B_ID("QVariant");

  } else if (Q7B_Object->type == typeid(QWebSettings).name()){
     return Q7B_ID("QWebSettings");

  } else if (Q7B_Object->type == typeid(QWhatsThisClickedEvent).name()){
     return Q7B_ID("QWhatsThisClickedEvent");

  } else if (Q7B_Object->type == typeid(QWindowStateChangeEvent).name()){
     return Q7B_ID("QWindowStateChangeEvent");

// End Generator h#8

  //} else if (Q7B_Object->type == typeid(QIcon).name()){    
  //  return Q7B_ID("QIcon");

  } 

  QObject *o = ((QObject *) Q7B_Object->ref);
  return Q7B_ID( o->metaObject()->className() );

  //return Q7B_ID( QString::fromAscii(Q7B_Object->type) );
}     

Q7B Q7B_MESSAGEBOX(Q7B Icon, Q7B Title, Q7B Text, Q7B InformativeText, Q7B DetailedText, Q7B o1, Q7B o2, Q7B o3, Q7B o4, Q7B o5, Q7B o6, Q7B o7, Q7B o8, Q7B o9, Q7B o10)
{
  qint64 nIcon = Q7B_toInteger2(Icon);
  QMessageBox *qmessagebox = new QMessageBox(qApp->focusWidget());
  if (nIcon == 999999){ // MessageBoxSheet
#ifdef Q_WS_MAC
    qmessagebox->setWindowModality(Qt::WindowModal);
    nIcon = QMessageBox::NoIcon;
#endif
  }
  qmessagebox->setIcon((QMessageBox::Icon) nIcon);
  qmessagebox->setWindowTitle(Q7B_toString2(Title));
  qmessagebox->setText(Q7B_toString2(Text));
  
  for (qint64 i = 0; i < 10; i++){
    Q7B o; 
    switch(i){
      case 0: o = o1; break;
      case 1: o = o2; break;
      case 2: o = o3; break;
      case 3: o = o4; break;
      case 4: o = o5; break;
      case 5: o = o6; break;
      case 6: o = o7; break;
      case 7: o = o8; break;
      case 8: o = o9; break;
      case 9: o = o10; break;
    }
    if (i > 0 && o->ref == 0) goto _exec;
    if (QString(o->type) == typeid(Q7B_List).name()){
      Q7B_List *a = (Q7B_List *) o->ref;
      if (a->me.size() < 2){ Q7B_INVALIDARGUMENTEXCEPTION("List contains not enough values"); return Q7B_ID(0); }
      qmessagebox->addButton(Q7B_toString2(a->me.at(0)), (QMessageBox::ButtonRole) Q7B_toInteger2(a->me.at(1)));
    } else {
      qmessagebox->addButton((QMessageBox::StandardButton) Q7B_toInteger2(o));
    }
  }
/*
  
  if (o2->type == typeid(Q7B_List).name()){
    Q7B_List *a = (Q7B_List *) o2->ref;
    if (a->me.size() < 2){ Q7B_EXCEPTION("List contains not enough values"); return Q7B_ID(0); }
    qmessagebox->addButton(Q7B_toString2(a->me.at(0)), (QMessageBox::ButtonRole) toInteger2(a->me.at(1)));
  } else {
    qmessagebox->addButton((QMessageBox::StandardButton) toInteger2(o2));
  }
  */

_exec:

  qmessagebox->setInformativeText(Q7B_toString2(InformativeText));
  qmessagebox->setDetailedText(Q7B_toString2(DetailedText));

  qint64 n = qmessagebox->exec();
  if (n < (qint64) QMessageBox::Ok){
    if (qmessagebox->clickedButton() != 0){
      QList<QAbstractButton *> buttons = qmessagebox->buttons();
      for (qint64 i = 0; i < buttons.size(); i++){
        if (buttons.at(i) == qmessagebox->clickedButton()){
          return Q7B_ID(i);
        }
      }
    }     
  } else {
    return Q7B_ID(n);
  }
  return Q7B_ID(0);
}


// *******




// *** MAINWINDOW ***********************************************************************************

//Q7B q7b_MainWindow_Object_Q7B = Q7B_idnil;

extern Q7B q7b_MainWindow_Object_Q7B;

// *** OS ***********************************************************************************

Q7B Q7B_idOS = Q7B_idnil;
Q7B Q7B_OS_Object(){ return Q7B_idOS; }

Q7B Q7B_OS_ISWINDOWS(Q7B dummy)
{  
#ifdef Q_WS_WIN
  return Q7B_ID( true );
#endif
  return Q7B_ID( false );
}

Q7B Q7B_OS_ISMAC(Q7B dummy)
{  
#ifdef Q_WS_MAC
  return Q7B_ID( true );
#endif
  return Q7B_ID( false );
}

Q7B Q7B_OS_ISLINUX(Q7B dummy)
{  
#ifdef Q_WS_X11
  return Q7B_ID( true );
#endif
  return Q7B_ID( false );
}

// *** QPAINTER ***********************************************************************************

Q7B Q7B_QPAINTER_INIT(QObject *parent, const char *objectName)
{
  QPainter *o = new QPainter(parent->isWidgetType() ? (QWidget *) parent : 0);
//  o->setProperty("Parent", (qint64) parent);
//  o->setObjectName(objectName);

  Q7B q (new Q7B_id(typeid(QPainter).name(), o, !parent->isWidgetType())); 
  return q;
}

void Q7B_QPAINTER_DRAWLINE(Q7B qpainter, Q7B X1, Q7B Y1, Q7B X2, Q7B Y2)
{  
  if (Q7B_nil(Q7B_QPAINTER(qpainter))){ Q7B_EXCEPTION("QPainter expected"); return; }

  if (Q7B_nil(Q7B_INTEGER(X1))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Y1))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(X2))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Y2))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QPainter *) qpainter->ref)->drawLine( *((qint64 *) X1->ref), *((qint64 *) Y1->ref), *((qint64 *) X2->ref), *((qint64 *) Y2->ref));  
}

// *** FILE ***********************************************************************************

Q7B Q7B_idFILE = Q7B_idnil;
Q7B Q7B_File_Object(){ return Q7B_idFILE; }

QFile Q7B_qfile;

Q7B Q7B_FILE_SIZE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B_qfile.setFileName(Q7B_IDQString(FileName));
  return Q7B_ID( Q7B_qfile.size() );
}

Q7B Q7B_FILE_RESIZE(Q7B dummy, Q7B FileName, Q7B NewSize)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(NewSize))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  Q7B_qfile.setFileName(Q7B_IDQString(FileName));
  return Q7B_ID( Q7B_qfile.resize(Q7B_IDqint64(NewSize)) );
}

Q7B Q7B_FILE_TRUNCATE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B_qfile.setFileName(Q7B_IDQString(FileName));
  if (Q7B_qfile.open(QIODevice::Truncate | QIODevice::WriteOnly)){
    Q7B_qfile.close();
    return Q7B_ID(true);
  }
  return Q7B_ID(false);
}

Q7B Q7B_FILE_READSTRING(Q7B dummy, Q7B FileName, Q7B Codec, Q7B AutoDetectUnicode, Q7B GenerateByteOrderMark)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Codec))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(AutoDetectUnicode))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(GenerateByteOrderMark))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QString sFileName = Q7B_IDQString(FileName);
  QFile f(sFileName);
  bool b = false;

  if (sFileName.compare("stderr", Qt::CaseInsensitive) == 0) b = f.open(stderr, QIODevice::ReadOnly);
  else if (sFileName.compare("stdin", Qt::CaseInsensitive) == 0) b = f.open(stdin, QIODevice::ReadOnly);
  else if (sFileName.compare("stdout", Qt::CaseInsensitive) == 0) b = f.open(stdout, QIODevice::ReadOnly);
  else b = f.open(QIODevice::ReadOnly);

  QString s;
  QString sCodec = Q7B_IDQString(Codec);
  if (sCodec == ""){
    sCodec = "UTF-8";
  }

  if (b){
    //int nSize = f.size();
    if (f.size() > 100000000){ // avoid out of memory Qt/C++ runtime crash on large files
      QByteArray ba = f.readAll();

      if (sCodec == "Local8Bit"){
        s = QString(QString::fromLocal8Bit(ba.constData()));
      } else {
        s = QString(QString::fromUtf8(ba.constData()));
      }
      
      ba.clear();
    } else {

      QTextStream t(&f);
      
      t.setCodec(QTextCodec::codecForName(sCodec.toLatin1().data()));
      t.setAutoDetectUnicode(Q7B_IDbool(AutoDetectUnicode));
      t.setGenerateByteOrderMark(Q7B_IDbool(GenerateByteOrderMark));

      s = t.readAll();
    }
    f.close();
    return Q7B_ID(s);
  }

  return Q7B_ID("");
}

Q7B Q7B_READLINES(Q7B FileName, Q7B Codec)
{  
  return Q7B_FILE_READLINES(Q7B_ID(), FileName, Codec, Q7B_ID(true), Q7B_ID(true));
}

Q7B Q7B_WRITELINES(Q7B theLines, Q7B FileName, Q7B Codec)
{
  if (Q7B_nil(Q7B_LIST(theLines))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QStringList l = Q7B_IDQ7B_List(theLines)->toStringList();
  QString s;
  for (int i = 0; i < l.count(); i++){
    s.append(l.at(i) + "\n");
  }  

  return Q7B_FILE_WRITESTRING(Q7B_ID(), Q7B_ID(s), FileName, Q7B_ID(false), Codec, Q7B_ID(true), Q7B_ID(true));
}

Q7B Q7B_FILE_READLINES(Q7B dummy, Q7B FileName, Q7B Codec, Q7B AutoDetectUnicode, Q7B GenerateByteOrderMark)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Codec))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(AutoDetectUnicode))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(GenerateByteOrderMark))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QString sFileName = Q7B_IDQString(FileName);
  QFile f(sFileName);
  bool b = false;

  if (sFileName.compare("stderr", Qt::CaseInsensitive) == 0) b = f.open(stderr, QIODevice::ReadOnly);
  else if (sFileName.compare("stdin", Qt::CaseInsensitive) == 0) b = f.open(stdin, QIODevice::ReadOnly);
  else if (sFileName.compare("stdout", Qt::CaseInsensitive) == 0) b = f.open(stdout, QIODevice::ReadOnly);
  else b = f.open(QIODevice::ReadOnly);

  QString sCodec = Q7B_IDQString(Codec);
  if (sCodec == ""){
    sCodec = "UTF-8";
  }

  QString s;
  if (b){
    //int nSize = f.size();
    if (f.size() > 100000000){ // avoid Qt crash on large files
      QByteArray ba = f.readAll();

      if (sCodec == "Local8Bit"){
        s = QString(QString::fromLocal8Bit(ba.constData()));
      } else {
        s = QString(QString::fromUtf8(ba.constData()));
      }
      
      ba.clear();
    } else {

      QTextStream t(&f);
      
      t.setCodec(QTextCodec::codecForName(sCodec.toLatin1().data()));
      t.setAutoDetectUnicode(Q7B_IDbool(AutoDetectUnicode));
      t.setGenerateByteOrderMark(Q7B_IDbool(GenerateByteOrderMark));

      s = t.readAll();
    }
    f.close();

    Q7B_List *a = new Q7B_List();
    Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

    QStringList l = s.split("\n");
    for (int i = 0; i < l.size(); i++){
      QString k = l.at(i);
      k = k.replace("\r", "");
       a->append( Q7B_ID( k ) );
    }

    return q;    
  }

  return Q7B_ID(Q7B_idnil);
}

Q7B Q7B_FILE_WRITESTRING(Q7B dummy, Q7B Text, Q7B FileName, Q7B Append, Q7B Codec, Q7B AutoDetectUnicode, Q7B GenerateByteOrderMark)
{  
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Append))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Codec))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(AutoDetectUnicode))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(GenerateByteOrderMark))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QString sFileName = Q7B_IDQString(FileName);
  QFile f(sFileName);
  bool b = false;

  if (sFileName.compare("stderr", Qt::CaseInsensitive) == 0) b = f.open(stderr, QIODevice::ReadOnly);
  else if (sFileName.compare("stdin", Qt::CaseInsensitive) == 0) b = f.open(stdin, QIODevice::ReadOnly);
  else if (sFileName.compare("stdout", Qt::CaseInsensitive) == 0) b = f.open(stdout, QIODevice::ReadOnly);
  else b = f.open(QIODevice::WriteOnly | (Q7B_IDbool(Append) ? QIODevice::Append : QIODevice::Truncate));

  if (b){
    QTextStream t(&f);

    QString sCodec = Q7B_IDQString(Codec);

    if (sCodec == "Local8Bit"){
    } else if (sCodec == ""){
      t.setCodec("UTF-8");
    } else {
      t.setCodec(sCodec.toAscii());
    }

    //t.setCodec(QTextCodec::codecForName(sCodec.toLatin1().data()));
    t.setAutoDetectUnicode(Q7B_IDbool(AutoDetectUnicode));
    t.setGenerateByteOrderMark(Q7B_IDbool(GenerateByteOrderMark));

    t << Q7B_IDQString(Text);
    f.close();

    return Q7B_ID( true );
  }

  return Q7B_ID( false );
}

Q7B Q7B_FILE_LINK(Q7B dummy, Q7B SourceFileName, Q7B DestinationFileName)
{  
  if (Q7B_nil(Q7B_QSTRING(SourceFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B_qfile.setFileName(Q7B_IDQString(SourceFileName));
  if (QFile::exists(Q7B_IDQString(SourceFileName))) return Q7B_ID( Q7B_qfile.link(Q7B_IDQString(DestinationFileName)) );
  return Q7B_ID( false );
}

Q7B Q7B_FILE_CREATE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (QFile::exists(Q7B_IDQString(FileName))) return Q7B_ID( true );

  QFile f(Q7B_IDQString(FileName));
  if (f.open(QIODevice::WriteOnly)){
    f.close();
    return Q7B_ID( true );
  }
  
  return Q7B_ID( false );
}

Q7B Q7B_FILE_REMOVE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (QFile::exists(Q7B_IDQString(FileName))) return Q7B_ID( QFile::remove(Q7B_IDQString(FileName)) );
  
  return Q7B_ID( false );
}

Q7B Q7B_FILE_COPY(Q7B dummy, Q7B SourceFileName, Q7B DestinationFileName, Q7B Overwrite)
{  
  if (Q7B_nil(Q7B_QSTRING(SourceFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Overwrite))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_IDbool(Overwrite)){
    return Q7B_ID( Q7B_copyFile(Q7B_IDQString(SourceFileName), Q7B_IDQString(DestinationFileName)) );
  } else {
    return Q7B_ID( QFile::copy(Q7B_IDQString(SourceFileName), Q7B_IDQString(DestinationFileName)) );
  }
}

Q7B Q7B_FILE_MOVE(Q7B dummy, Q7B SourceFileName, Q7B DestinationFileName, Q7B Overwrite)
{  
  if (Q7B_nil(Q7B_QSTRING(SourceFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Overwrite))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_IDbool(Overwrite)){
    if (Q7B_copyFile(Q7B_IDQString(SourceFileName), Q7B_IDQString(DestinationFileName))){
      QFile::remove(Q7B_IDQString(SourceFileName));
      return Q7B_ID( true );
    }
  } else {
    if (QFile::copy(Q7B_IDQString(SourceFileName), Q7B_IDQString(DestinationFileName))){
      QFile::remove(Q7B_IDQString(SourceFileName));
      return Q7B_ID( true );
    }
  }
  return Q7B_ID( false );
}

Q7B Q7B_FILE_RENAME(Q7B dummy, Q7B SourceFileName, Q7B DestinationFileName, Q7B Overwrite)
{  
  if (Q7B_nil(Q7B_QSTRING(SourceFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Overwrite))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_IDbool(Overwrite) && QFile::exists(Q7B_IDQString(DestinationFileName))){
    QFile::remove(Q7B_IDQString(DestinationFileName));
  }
  return Q7B_ID( QFile::rename(Q7B_IDQString(SourceFileName), Q7B_IDQString(DestinationFileName)) );
}

Q7B Q7B_FILE_EXISTS(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QFile::exists(Q7B_IDQString(FileName)) );
}

Q7B Q7B_FILE_DATETIMECREATED(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.created().toString("yyyy-MM-dd hh:mm:ss") );      
  return Q7B_ID( "" );
}

Q7B Q7B_FILE_DATETIMEUPDATED(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.lastModified().toString("yyyy-MM-dd hh:mm:ss") );      
  return Q7B_ID( "" );
}

Q7B Q7B_FILE_DATETIMEREAD(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.lastRead().toString("yyyy-MM-dd hh:mm:ss") );      
  return Q7B_ID( "" );
}

Q7B Q7B_FILE_WITHNATIVESEPARATORS(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QDir::toNativeSeparators(Q7B_IDQString(FileName)) );
}

Q7B Q7B_FILE_WITHOUTNATIVESEPARATORS(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QDir::fromNativeSeparators(Q7B_IDQString(FileName)) );
}

Q7B Q7B_FILE_OWNER(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.owner() );      
  return Q7B_ID( "" );
}

Q7B Q7B_FILE_GROUP(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.group() );      
  return Q7B_ID( "" );
}

Q7B Q7B_FILE_SYMLINKTARGET(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.symLinkTarget() );      
  return Q7B_ID( false );
}

Q7B Q7B_FILE_ISRELATIVE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.isRelative() );      
  return Q7B_ID( false );
}

Q7B Q7B_FILE_ISSYMLINK(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.isSymLink() );      
  return Q7B_ID( false );
}

Q7B Q7B_FILE_ISREADABLE(Q7B dummy, Q7B FileName, Q7B Who)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Who))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWho = Q7B_IDQString(Who);
  if (sWho.isEmpty() || sWho.contains("User", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.isReadable() );      
  } else if (sWho.contains("Owner", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::ReadOwner) );   
  } else if (sWho.contains("Group", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::ReadGroup) );   
  } else if (sWho.contains("Other", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::ReadOther) );   
  }
  return Q7B_ID( false );
}

Q7B Q7B_FILE_ISWRITABLE(Q7B dummy, Q7B FileName, Q7B Who)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Who))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWho = Q7B_IDQString(Who);
  if (sWho.isEmpty() || sWho.contains("User", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.isWritable() );      
  } else if (sWho.contains("Owner", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::WriteOwner) );   
  } else if (sWho.contains("Group", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::WriteGroup) );   
  } else if (sWho.contains("Other", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::WriteOther) );   
  }
  return Q7B_ID( false );
}

Q7B Q7B_FILE_ISEXECUTABLE(Q7B dummy, Q7B FileName, Q7B Who)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Who))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWho = Q7B_IDQString(Who);
  if (sWho.isEmpty() || sWho.contains("User", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.isExecutable() );      
  } else if (sWho.contains("Owner", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::ExeOwner) );   
  } else if (sWho.contains("Group", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::ExeGroup) );   
  } else if (sWho.contains("Other", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::ExeOther) );   
  }
  return Q7B_ID( false );
}

Q7B Q7B_FILE_ISHIDDEN(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.isHidden() );      
  return Q7B_ID( false );
}

Q7B Q7B_FILE_ISFILE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.isFile() );      
  return Q7B_ID( false );
}

Q7B Q7B_FILE_ISDIR(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( !f.isFile() );      
  return Q7B_ID( false );
}

// *** CMATH ***********************************************************************************

Q7B Q7B_idCMATH = Q7B_idnil;
Q7B Q7B_CMath_Object(){ return Q7B_idCMATH; }

Q7B Q7B_CMATH_SIN(Q7B dummy, Q7B v)
{  
  return Q7B_ID( sin(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_COS(Q7B dummy, Q7B v)
{  
  return Q7B_ID( cos(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_TAN(Q7B dummy, Q7B v)
{  
  return Q7B_ID( tan(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_ASIN(Q7B dummy, Q7B v)
{  
  return Q7B_ID( asin(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_ACOS(Q7B dummy, Q7B v)
{  
  return Q7B_ID( acos(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_ATAN(Q7B dummy, Q7B v)
{  
  return Q7B_ID( atan(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_ATAN2(Q7B dummy, Q7B v, Q7B v2)
{  
  return Q7B_ID( atan2(Q7B_toFloat2(v), Q7B_toFloat2(v2)) );
}

Q7B Q7B_CMATH_SINH(Q7B dummy, Q7B v)
{  
  return Q7B_ID( sinh(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_COSH(Q7B dummy, Q7B v)
{  
  return Q7B_ID( cosh(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_TANH(Q7B dummy, Q7B v)
{  
  return Q7B_ID( tanh(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_EXP(Q7B dummy, Q7B v)
{  
  return Q7B_ID( exp(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_LOG(Q7B dummy, Q7B v)
{  
  return Q7B_ID( log(Q7B_toFloat2(v)) );
}

    ///* PROCED URE */ procedures1["log2"] = "Float"; /* ARGUMENT Argument As Float */ /* COMMENT */ /* VERSION 1.0 */
   /* if (*sPropertyOrMethod == "log2"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
	    if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(log2(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

Q7B Q7B_CMATH_LOG10(Q7B dummy, Q7B v)
{  
  return Q7B_ID( log10(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_SQRT(Q7B dummy, Q7B v)
{  
  return Q7B_ID( sqrt(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_CEIL(Q7B dummy, Q7B v)
{  
  return Q7B_ID( ceil(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_FLOOR(Q7B dummy, Q7B v)
{  
  return Q7B_ID( floor(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_FABS(Q7B dummy, Q7B v)
{  
  return Q7B_ID( fabs(Q7B_toFloat2(v)) );
}

Q7B Q7B_CMATH_FMOD(Q7B dummy, Q7B v, Q7B v2)
{  
  return Q7B_ID( fmod(Q7B_toFloat2(v), Q7B_toFloat2(v2)) );
}

Q7B Q7B_CMATH_POW(Q7B dummy, Q7B v, Q7B v2)
{  
  return Q7B_ID( pow(Q7B_toFloat2(v), Q7B_toFloat2(v2)) );
}

    ///* PROCED URE */ procedures1["hypot"] = "Float"; /* ARGUMENT Argument As Float, 2ndArgument As Float */ /* COMMENT Determines the square root of the sum of the squares of its arguments */ /* VERSION 1.0 */
   /* if (sPropertyOrMethod == "hypot"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(",")){ error(", expected"); _END_ }
      QString sExpression2;        
      if (!parseExpression(&sExpression2)){ error(""); return false; }
	    if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(hypot(Q7B_CFLOAT(" + sExpression + "), Q7B_CFLOAT(" + sExpression2 + ")))";
      goto re;
    }
*/
   // ///* PROC EDURE */ procedures1["round"] = "Float"; /* ARGUMENT Argument As Float */ /* COMMENT */ /* VERSION 1.0 */
   /* if (*sPropertyOrMethod == "round"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(round(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PROCE DURE */ procedures1["acosh"] = "Float"; /* ARGUMENT Argument As Float */ /* COMMENT */ /* VERSION 1.0 */
  /*  if (*sPropertyOrMethod == "acosh"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(acosh(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }
*/
   // ///* PROCEDU RE */ procedures1["asinh"] = "Float"; /* ARGUMENT Argument As Float */ /* COMMENT */ /* VERSION 1.0 */
   /* if (*sPropertyOrMethod == "asinh"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(asinh(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PRO CEDURE */ procedures1["atanh"] = "Float"; /* ARGUMENT Argument As Float */ /* COMMENT */ /* VERSION 1.0 */
  /*  if (*sPropertyOrMethod == "atanh"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(atanh(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

   // ///* PROCE DURE */ procedures1["expm1"] = "Float"; /* ARGUMENT Argument As Float */ /* COMMENT expm1(x) is more accurate than exp(x) - 1 */ /* VERSION 1.0 */
  /*  if (*sPropertyOrMethod == "expm1"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(expm1(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

  //  ///* PROCED URE */ procedures1["log1p"] = "Float"; /* ARGUMENT Argument As Float */ /* COMMENT log1p = log(1 + x). However, for small enough arguments, log1p is more accurate than log(1 + x)) */ /* VERSION 1.0 */
  /*  if (*sPropertyOrMethod == "log1p"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(log1p(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

   // ///* PROCE DURE */ procedures1["logb"] = "Float"; /* ARGUMENT Argument As Float */ /* COMMENT Gets the exponent of its argument, as a signed integral value */ /* VERSION 1.0 */
 /*   if (*sPropertyOrMethod == "logb"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(logb(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

  //  ///* PROCED URE */ procedures1["erf"] = "Float"; /* ARGUMENT Argument As Float */ /* COMMENT The error function */ /* VERSION 1.0 */
  /*  if (*sPropertyOrMethod == "erf"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(erf(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

   // ///* PROC EDURE */ procedures1["erfc"] = "Float"; /* ARGUMENT Argument As Float */ /* COMMENT Complementary error function */ /* VERSION 1.0 */
   /* if (*sPropertyOrMethod == "erfc"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(erfc(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PROCEDURE */ procedures["lgamma"] = "Float"; /* ARGUMENT x As Float */ /* COMMENT Determines the base-e logarithm of the absolute value of gamma of its argument x, for x > 0 */ /* VERSION 1.0 */
   /* if (*sPropertyOrMethod == "lgamma"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(lgamma(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PROCE DURE */ procedures1["rint"] = "Float"; /* ARGUMENT x As Float */ /* COMMENT Rounds its argument to an integral value in floating point format, using the current rounding direction */ /* VERSION 1.0 */
 /*   if (*sPropertyOrMethod == "rint"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(rint(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PROCE DURE */ procedures1["nearbyint"] = "Float"; /* ARGUMENT x As Float */ /* COMMENT Does not raise the inexact exception */ /* VERSION 1.0 */
   /* if (*sPropertyOrMethod == "nearbyint"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(nearbyint(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PROCE DURE */ procedures1["rinttol"] = "Integer"; /* ARGUMENT x As Float */ /* COMMENT Rounds its argument to the nearest Integer using the current rounding direction */ /* VERSION 1.0 */
  /*  if (*sPropertyOrMethod == "lrint"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(llrint(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PROC EDURE */ procedures1["trunc"] = "Float"; /* ARGUMENT x As Float */ /* COMMENT Determines the integral value, in floating format */ /* VERSION 1.0 */
 /*   if (*sPropertyOrMethod == "trunc"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(trunc(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PROCE DURE */ procedures1["remainder"] = "Float"; /* ARGUMENT x As Float, y As Float */ /* COMMENT Determines x * 2^n fast */ /* VERSION 1.0 */
   /* if (*sPropertyOrMethod == "remainder"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(",")){ error(", expected"); _END_ }
      QString sExpression2;        
      if (!parseExpression(&sExpression2)){ error(""); return false; }
	    if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(remainder(Q7B_CFLOAT(" + sExpression + "), Q7B_CFLOAT(" + sExpression2 + ")))";
      goto re;
    }*/

    ///* PROCED URE */ procedures1["pi"] = "Float"; /* ARGUMENT */ /* COMMENT */ /* VERSION 1.0 */
   /* if (*sPropertyOrMethod == "pi"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
	    if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(pi)";
      goto re;
    }*/

    ///* PROC EDURE */ procedures1["isnormal"] = "Integer"; /* ARGUMENT x As Float */ /* COMMENT Non-zero if and only if the argument x is normalized */ /* VERSION 1.0 */
  /*  if (*sPropertyOrMethod == "isnormal"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(isnormal(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PROCED URE */ procedures1["isfinite"] = "Integer"; /* ARGUMENT x As Float */ /* COMMENT Non-zero if and only if the argument x is finite */ /* VERSION 1.0 */
   /* if (*sPropertyOrMethod == "isfinite"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(isfinite(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PROCED URE */ procedures1["isnan"] = "Integer"; /* ARGUMENT x As Float */ /* COMMENT Non-zero if and only if the argument x is a NaN */ /* VERSION 1.0 */
   /* if (*sPropertyOrMethod == "isnan"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(isnan(Q7B_CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PROCED URE */ procedures1["inf"] = "Float"; /* ARGUMENT x As Float */ /* COMMENT */
     /*
    if (*sPropertyOrMethod == "inf"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
	    if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "QOBJECT(inf())";
      goto re;
    }*/

    ///* PROCE DURE */ procedures1["fdim"] = "Float"; /* ARGUMENT x As Float, y As Float */ /* COMMENT Computes the 'positive difference' between its arguments */ /* VERSION 1.0 */
  /*  if (*sPropertyOrMethod == "fdim"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(",")){ error(", expected"); _END_ }
      QString sExpression2;        
      if (!parseExpression(&sExpression2)){ error(""); return false; }
	    if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "Q7B_QOBJECT(fdim(Q7B_CFLOAT(" + sExpression + "), Q7B_CFLOAT(" + sExpression2 + ")))";
      goto re;
    }*/

    ///* PROC EDURE */ procedures1["randomx"] = "Float"; /* ARGUMENT x As Float */ /* COMMENT A pseudorandom number generator */
    /*if (*sPropertyOrMethod == "randomx"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "QOBJECT(randomx(CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

 
    ///* PROC EDURE */ procedures1["ldexp"] = "Float"; /* ARGUMENT x As Float, n As Integer */ /* COMMENT The ldexp functions multiply x by 2 to the power of n */ /* VERSION 1.0 */
   /* if (*sPropertyOrMethod == "ldexp"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(",")){ error(", expected"); _END_ }
      QString sExpression2;        
      if (!parseExpression(&sExpression2)){ error(""); return false; }
	    if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "QOBJECT(ldexp (CFLOAT(" + sExpression + "), INTEGER(" + sExpression2 + ")))";
      goto re;
    }*/

    ///* PROCE DURE */ procedures1["modf_integral"] = "Integer"; /* ARGUMENT x As Float */ /* COMMENT The modf_integral function returns the integral part of the argument */ /* VERSION 1.0 */
   /* if (*sPropertyOrMethod == "modf_integral"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "QOBJECT(MODF_INTEGRAL(CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PROCE DURE */ procedures1["modf_fractional"] = "Integer"; /* ARGUMENT x As Float */ /* COMMENT The modf_fractional function returns the fractional part of the argument */ /* VERSION 1.0 */
  /*  if (*sPropertyOrMethod == "modf_fractional"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "QOBJECT(MODF_FRACTIONAL(CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PROCE DURE */ procedures1["frexp_normalized"] = "Integer"; /* ARGUMENT x As Float */ /* COMMENT The frexp_normalized function returns the normalized fraction of the argument */ /* VERSION 1.0 */
   /* if (*sPropertyOrMethod == "frexp_normalized"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "QOBJECT(FREXP_NORMALIZED(CFLOAT(" + sExpression + ")))";
      goto re;
    }*/

    ///* PROCE DURE */ procedures1["frexp_integral"] = "Integer"; /* ARGUMENT x As Float */ /* COMMENT The frexp_integral function returns the integral power of 2 of the argument */ /* VERSION 1.0 */
 /*   if (*sPropertyOrMethod == "frexp_integral"){
      if (!parseTerm("(")){ error("( expected"); _END_ }
      QString sExpression;        
      if (!parseExpression(&sExpression)){ error(""); return false; }
      if (!parseTerm(")")){ error(") expected"); _END_ }
      / *CODE* / *sMethodCallExpression += "QOBJECT(FREXP_INTEGRAL(CFLOAT(" + sExpression + ")))";
      goto re;
    }  */

// *** PREFERENCES ***********************************************************************************

// saved on Windows at HKEY_CURRENT_USER/appname/OrganiziatonDefaults

Q7B Q7B_idPREFERENCES = Q7B_idnil;
Q7B Q7B_Preferences_Object(){ return Q7B_idPREFERENCES; }

Q7B Q7B_PREFERENCES_IDS(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }

  Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(((QSettings *) Q7B_idPREFERENCES->ref)->allKeys()))); 
  return q;

  //return Q7B_ID( ((QSettings *) Q7B_idPREFERENCES->ref)->allKeys() );
}

void Q7B_PREFERENCES_REMOVEALL(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }

  ((QSettings *) Q7B_idPREFERENCES->ref)->clear();
}

Q7B Q7B_PREFERENCES_EXISTS(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QStringList l = ((QSettings *) Q7B_idPREFERENCES->ref)->allKeys();
  return Q7B_ID( l.indexOf( *((QString *) PreferenceId->ref) ) >= 0 );
}

void Q7B_PREFERENCES_REMOVE(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->remove( *((QString *) PreferenceId->ref) );
}

Q7B Q7B_PREFERENCES_BOOLEAN(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((QSettings *) Q7B_idPREFERENCES->ref)->value( *((QString *) PreferenceId->ref) ).toBool());  
}

Q7B Q7B_PREFERENCES_INTEGER(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

//  return Q7B_ID( ID(QSettings, Q7B_idPREFERENCES)->value( *((QString *) PreferenceId->ref) ).toLongLong());  // same as qint64  
  return Q7B_ID( ((QSettings *) Q7B_idPREFERENCES->ref)->value( *((QString *) PreferenceId->ref) ).toLongLong());  // same as qint64  
}

Q7B Q7B_PREFERENCES_STRING(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((QSettings *) Q7B_idPREFERENCES->ref)->value( *((QString *) PreferenceId->ref) ).toString());  
}

Q7B Q7B_PREFERENCES_QSTRINGLIST(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((QSettings *) Q7B_idPREFERENCES->ref)->value( *((QString *) PreferenceId->ref) ).toStringList());  
}

Q7B Q7B_PREFERENCES_FLOAT(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((QSettings *) Q7B_idPREFERENCES->ref)->value( *((QString *) PreferenceId->ref) ).toDouble());  
}

Q7B Q7B_PREFERENCES_QBYTEARRAY(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((QSettings *) Q7B_idPREFERENCES->ref)->value( *((QString *) PreferenceId->ref) ).toByteArray());  
}

// TODO2 setdatetime

/*
Q7B Q7B_PREFERENCES_DECIMAL(Q7B dummy, Q7B PreferenceId) 
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((QSettings *) Q7B_idPREFERENCES->ref)->value( *((QString *) PreferenceId->ref) ).toDouble());
}*/

void Q7B_PREFERENCES_SETBOOLEAN(Q7B dummy, Q7B PreferenceId, Q7B Value)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->setValue( *((QString *) PreferenceId->ref), *((bool *) Value->ref) );
}

void Q7B_PREFERENCES_SETINTEGER(Q7B dummy, Q7B PreferenceId, Q7B Value)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->setValue( *((QString *) PreferenceId->ref), *((qint64 *) Value->ref) );
}

void Q7B_PREFERENCES_SETSTRING(Q7B dummy, Q7B PreferenceId, Q7B Value)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->setValue( *((QString *) PreferenceId->ref), *((QString *) Value->ref) );
}

void Q7B_PREFERENCES_SETQSTRINGLIST(Q7B dummy, Q7B PreferenceId, Q7B Value)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->setValue( *((QString *) PreferenceId->ref), *((QStringList *) Value->ref) );
}

void Q7B_PREFERENCES_SETFLOAT(Q7B dummy, Q7B PreferenceId, Q7B Value)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->setValue( *((QString *) PreferenceId->ref), *((qreal *) Value->ref) );
}

void Q7B_PREFERENCES_SETQBYTEARRAY(Q7B dummy, Q7B PreferenceId, Q7B Value)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->setValue( *((QString *) PreferenceId->ref), *((QByteArray *) Value->ref) );
}
// TODO2 setdatetime
/*
void Q7B_PREFERENCES_SETDECIMAL(Q7B dummy, Q7B PreferenceId, Q7B Value)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->setValue( *((QString *) PreferenceId->ref), *((qreal *) Value->ref) );
}*/

// *** DEBUG ***********************************************************************************

Q7B Q7B_idDEBUG = Q7B_idnil;
Q7B Q7B_Debug_Object(){ return Q7B_idDEBUG; }

Q7B Q7B_DEBUG_LINE(Q7B dummy)
{  
  return Q7B_ID( 0 );
}
/*
  
  // properties["Line"] = "Integer"; 
     if (*sPropertyOrMethod == "Line"){
     *sMethodCallExpression +=  QString("%1").arg(nCurrentLine);
  // properties["ClassName"] = "String"; 
     } else if (*sPropertyOrMethod == "ClassName"){
     *sMethodCallExpression += "\"" + sClassName[sCurrentFileName] + "\"";
  // properties["SuperName"] = "String"; 
     } else if (*sPropertyOrMethod == "SuperClassName"){
     *sMethodCallExpression += "\"" + cocoaType2objb(sSuperClass[sCurrentFileName]) + "\"";
  // properties["File"] = "String"; 
     } else if (*sPropertyOrMethod == "File"){
     *sMethodCallExpression += "\"" + sCurrentFileName + "\"";
  // properties["Scope"] = "String"; 
     } else if (*sPropertyOrMethod == "Scope"){
     *sMethodCallExpression += "\"" + sCurrentSub.left(sCurrentSub.length() - 0) + "\"";
  // properties["Info"] = "String"; 
     } else if (*sPropertyOrMethod == "Info"){
      QString s;
      s += "\"File: " + sCurrentFileName;
      s +=  "\\nLine: " + QString("%1").arg(nCurrentLine);
      s +=  "\\nClassName: " + sClassName[sCurrentFileName];
      s +=  "\\nScope: " + sCurrentSub.left(sCurrentSub.length() - 0);
      s +=  "\\nSuperClassName: " + cocoaType2objb(sSuperClass[sCurrentFileName]) + "\"";
      
       *sMethodCallExpression += s;
  } else { _END_ }
  */

// *** DESKTOP ***********************************************************************************

Q7B Q7B_idDESKTOP = Q7B_idnil;
Q7B Q7B_Desktop_Object(){ return Q7B_idDESKTOP; }

Q7B Q7B_DESKTOP_DESKTOPLOCATION(Q7B dummy)
{  
  return Q7B_ID( QDesktopServices::storageLocation(QDesktopServices::DesktopLocation) );
}

// *** DIR ***********************************************************************************

Q7B Q7B_idDIR = Q7B_idnil;
Q7B Q7B_Dir_Object(){ return Q7B_idDIR; }

Q7B Q7B_DIR_ROOTPATH(Q7B Path)
{  
  return Q7B_ID( QDir::rootPath() );
}

Q7B Q7B_DIR_TEMPPATH(Q7B Path)
{  
  return Q7B_ID( QDir::tempPath() );
}

Q7B Q7B_DIR_APPLICATIONSPATH(Q7B dummy)
{  
  return Q7B_ID( QDesktopServices::storageLocation(QDesktopServices::ApplicationsLocation) );
}

Q7B Q7B_DIR_HOMEPATH(Q7B dummy)
{  
  return Q7B_ID( QDesktopServices::storageLocation(QDesktopServices::HomeLocation) );
}

Q7B Q7B_DIR_DESKTOPPATH(Q7B dummy)
{  
  return Q7B_ID( QDesktopServices::storageLocation(QDesktopServices::DesktopLocation) );
}

Q7B Q7B_DIR_CREATE(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QDir().mkdir(*((QString *) Path->ref)) );
}

Q7B Q7B_DIR_RECURSIVECREATE(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QDir().mkpath(*((QString *) Path->ref)) );
}

Q7B Q7B_DIR_REMOVE(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QDir().rmdir(*((QString *) Path->ref)) );
}

bool Q7B_RemoveDirectory(QDir aDir)
{
  bool has_err = false;
  if (aDir.exists())
  {
    QFileInfoList entries = aDir.entryInfoList(QDir::NoDotAndDotDot | QDir::Dirs | QDir::Files);
    int count = entries.size();
    for (int idx = 0; ((idx < count) && (true != has_err)); idx++)
    {
      QFileInfo entryInfo = entries[idx];
      QString path = entryInfo.absoluteFilePath();
    //  QMessageBox::information(0, "RemoveDirectory", path+ "\n" + aDir.absolutePath());
      if (entryInfo.isDir())
      {
        has_err = Q7B_RemoveDirectory(QDir(path));
       // QMessageBox::information(0, "1 err", path);
      }
      else if (entryInfo.isSymLink())
      {
        if (QFileInfo(entryInfo.symLinkTarget()).isDir()){
          has_err = Q7B_RemoveDirectory(QDir(path));
       //   QMessageBox::information(0, "1 err", path);
        }
        else {
          QFile file(path);
          if (!file.remove()){
            has_err = true;
        //    QMessageBox::information(0, "2 err", path);
          }
        }
      }
        else
      {

        //if (path.endsWith("/plugins")) QMessageBox::information(0, "RemoveDirectory", "1"+path);

        QFile file(path);
        if (!file.remove()){
        //  QMessageBox::information(0, "QFile err", path);
          has_err = true;
        }
        //if (QFile::exists(path))QMessageBox::information(0, "RemoveDirectory", "1"+path);


      }
    }
    
    if (!aDir.rmdir(aDir.absolutePath())){
       // QMessageBox::information(0, "aDir err", aDir.absolutePath());

      has_err = true;
    }

    //QMessageBox::information(0, "RemoveDirectory", "2"+aDir.absolutePath());

  }
 // if (has_err){
   // QMessageBox::information(0, "___err", aDir.absolutePath ());
 // }

  return(has_err);
}

Q7B Q7B_DIR_EXISTS(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QDir d( *((QString *) Path->ref) );
  return Q7B_ID( d.exists() && QFileInfo( *((QString *) Path->ref)).isDir() );
}

Q7B Q7B_DIR_RECURSIVEREMOVE(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

 // if (!QFile::remove("/Users/berndnoetscher/Desktop/q7basic_examples/Application/MDI/gcc/Build/MDI.app/Contents/MacOS/plugins")) QMessageBox::information(0, "RemoveDirectory", "1ddddddddddds");

  QDir d( *((QString *) Path->ref) );
  return Q7B_ID( ! Q7B_RemoveDirectory( d ));
}

QStringList Q7B_FindFile(QString Path, QStringList NameFilter, qint64 Filter, qint64 Sorting, bool bRecursive, bool bRecursiveCall, bool bbb)
{  
 // bool b = bbb;
//  if (bRecursive && !(Filter & QDir::AllDirs)){
  //  b = true;
   // Filter |= QDir::AllDirs | QDir::Files;
  //}
  
  QFileInfoList l;
  QDir dir;

  if (bRecursiveCall){    

    dir.setPath(Path);
    
    //if (NameFilter.isEmpty()){
    //  l = dir.entryInfoList(NameFilter2, (QDir::Filters) Q7B_IDqint64(Filter), (QDir::SortFlags) Q7B_IDqint64(Sorting));
    //} else {
      l = dir.entryInfoList(NameFilter, (QDir::Filters) Filter, (QDir::SortFlags) Sorting);
   // }

  } else {

    dir.setPath(Path);
    
   // if (NameFilter.isEmpty()){
   //   l = dir.entryInfoList(NameFilter2, (QDir::Filters) Q7B_IDqint64(Filter), (QDir::SortFlags) Q7B_IDqint64(Sorting));
   // } else {
      l = dir.entryInfoList(NameFilter, (QDir::Filters) Filter, (QDir::SortFlags) Sorting);
   // }

  }

  QStringList ll;
  //int size = l.size();

  foreach(QFileInfo f, l){

  //  bool bb = bRecursive && f.isDir();

   // if (!bb || (bb && b == false)){
    //  ll << f.absoluteFilePath();
  //  }

//    if (bb)
    {

		  if (f.fileName() == "." || f.fileName() == ".."){
		      ; // nothing
		  } else {

        ll << f.absoluteFilePath();

        if (bRecursive && f.isDir()){
          QStringList ll2 = Q7B_FindFile(f.absoluteFilePath(), NameFilter, Filter, Sorting, bRecursive, true, false/*b*/);
          //int n = ll2.size();
          ll << ll2;        
        }
      }
    }

  }
  return ll;
}

Q7B Q7B_DIR_FINDFILE(Q7B dummy, Q7B Path, Q7B NameFilter, Q7B Filter, Q7B Sorting)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_LIST(NameFilter))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Filter))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Sorting))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

//  return Q7B_ID( Q7B_FindFile( Q7B_IDQString(Path), ((Q7B_List*)NameFilter->ref)->toStringList(), Q7B_IDqint64(Filter), Q7B_IDqint64(Sorting), false, false, false) );
  
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(Q7B_FindFile( Q7B_IDQString(Path), ((Q7B_List*)NameFilter->ref)->toStringList(), Q7B_IDqint64(Filter), Q7B_IDqint64(Sorting), false, false, false)))); 
  return q;
}

Q7B Q7B_DIR_RECURSIVEFINDFILE(Q7B dummy, Q7B Path, Q7B NameFilter, Q7B Filter, Q7B Sorting)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_LIST(NameFilter))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Filter))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Sorting))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(Q7B_FindFile( Q7B_IDQString(Path), ((Q7B_List*)NameFilter->ref)->toStringList(), Q7B_IDqint64(Filter), Q7B_IDqint64(Sorting), true, false, false)))); 
  return q;
  //return Q7B_ID( Q7B_FindFile( Q7B_IDQString(Path), ((Q7B_List*)NameFilter->ref)->toStringList(), Q7B_IDqint64(Filter), Q7B_IDqint64(Sorting), true, false, false) );
}

Q7B Q7B_DIR_LIST(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QDir dir;

  dir.setPath(*((QString *) Path->ref));
    
  QFileInfoList l = dir.entryInfoList();
  QStringList ll;  

  foreach(QFileInfo f, l){

    if (f.fileName() == "." || f.fileName() == ".."){
		      ; // nothing
		} else {
      ll << f.absoluteFilePath();
    }
  }

  Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(ll))); 
  return q;

  //return Q7B_ID( ll );
}

Q7B Q7B_DIR_RECURSIVELIST(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_FindFile( Q7B_IDQString(Path), QStringList(), QDir::NoFilter, QDir::NoSort, true, false, false) );
}


Q7B Q7B_DIR_COPY(Q7B SourceFilePath, Q7B DestinationFilePath)
{
  if (Q7B_nil(Q7B_QSTRING(SourceFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo fi(*((QString *) SourceFilePath->ref));  

  if (fi.isDir()){
    return Q7B_ID( Q7B_copyDir(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref), true) );
  }

  return Q7B_ID( false );
}    

Q7B Q7B_DIR_MOVE(Q7B SourceFilePath, Q7B DestinationFilePath)
{
  if (Q7B_nil(Q7B_QSTRING(SourceFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo fi(*((QString *) SourceFilePath->ref));  

  if (fi.isDir()){
    QDir d;
    return Q7B_ID( d.rename(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref)) );
  }

  return Q7B_ID( false );
}    

Q7B Q7B_DIR_ISDIR(Q7B FilePath)
{
  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_ID( QFileInfo( *((QString *) FilePath->ref)).isDir() );
}    

Q7B Q7B_DIR_DATETIMECREATED(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.created().toString("yyyy-MM-dd hh:mm:ss") );      
  return Q7B_ID( "" );
}

Q7B Q7B_DIR_DATETIMEUPDATED(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.lastModified().toString("yyyy-MM-dd hh:mm:ss") );      
  return Q7B_ID( "" );
}

Q7B Q7B_DIR_DATETIMEREAD(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.lastRead().toString("yyyy-MM-dd hh:mm:ss") );      
  return Q7B_ID( "" );
}

Q7B Q7B_DIR_WITHNATIVESEPARATORS(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QDir::toNativeSeparators(Q7B_IDQString(FileName)) );
}

Q7B Q7B_DIR_WITHOUTNATIVESEPARATORS(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QDir::fromNativeSeparators(Q7B_IDQString(FileName)) );
}

Q7B Q7B_DIR_OWNER(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.owner() );      
  return Q7B_ID( "" );
}

Q7B Q7B_DIR_GROUP(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.group() );      
  return Q7B_ID( "" );
}

Q7B Q7B_DIR_SYMLINKTARGET(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.symLinkTarget() );      
  return Q7B_ID( false );
}

Q7B Q7B_DIR_ISRELATIVE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.isRelative() );      
  return Q7B_ID( false );
}

Q7B Q7B_DIR_ISSYMLINK(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.isSymLink() );      
  return Q7B_ID( false );
}

Q7B Q7B_DIR_ISREADABLE(Q7B dummy, Q7B FileName, Q7B Who)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Who))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWho = Q7B_IDQString(Who);
  if (sWho.isEmpty() || sWho.contains("User", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.isReadable() );      
  } else if (sWho.contains("Owner", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::ReadOwner) );   
  } else if (sWho.contains("Group", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::ReadGroup) );   
  } else if (sWho.contains("Other", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::ReadOther) );   
  }
  return Q7B_ID( false );
}

Q7B Q7B_DIR_ISWRITABLE(Q7B dummy, Q7B FileName, Q7B Who)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Who))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWho = Q7B_IDQString(Who);
  if (sWho.isEmpty() || sWho.contains("User", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.isWritable() );      
  } else if (sWho.contains("Owner", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::WriteOwner) );   
  } else if (sWho.contains("Group", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::WriteGroup) );   
  } else if (sWho.contains("Other", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::WriteOther) );   
  }
  return Q7B_ID( false );
}

Q7B Q7B_DIR_ISEXECUTABLE(Q7B dummy, Q7B FileName, Q7B Who)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Who))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWho = Q7B_IDQString(Who);
  if (sWho.isEmpty() || sWho.contains("User", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.isExecutable() );      
  } else if (sWho.contains("Owner", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::ExeOwner) );   
  } else if (sWho.contains("Group", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::ExeGroup) );   
  } else if (sWho.contains("Other", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_ID( f.permission(QFile::ExeOther) );   
  }
  return Q7B_ID( false );
}

Q7B Q7B_DIR_ISHIDDEN(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.isHidden() );      
  return Q7B_ID( false );
}

Q7B Q7B_DIR_DRIVES()
{
  QFileInfoList l = QDir::drives();

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

  for (int i = 0; i < l.size(); i++){
     a->append(Q7B_ID( l.at(i).absoluteFilePath()));
  }

  return q;
}     

Q7B Q7B_DIR_BUNDLENAME(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.bundleName() );      
  return Q7B_ID( false );
}

Q7B Q7B_DIR_ISROOT(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.isRoot() );      
  return Q7B_ID( false );
}

Q7B Q7B_DIR_ISBUNDLE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_ID( f.isBundle() );      
  return Q7B_ID( false );
}

// *** OPENFILEDIALOG ***********************************************************************************

Q7B Q7B_idOPENFILEDIALOG = Q7B_idnil;
Q7B Q7B_OpenFileDialog_Object(){ return Q7B_idOPENFILEDIALOG; }

Q7B Q7B_OPENFILEDIALOG_GETFILE(Q7B dummy)
{  
  return Q7B_ID( QFileDialog::getOpenFileName(qApp->focusWidget()) );
}

Q7B Q7B_OPENFILEDIALOG_GETFILE2(Q7B dummy, Q7B WindowTitle, Q7B Directory, Q7B Filter)
{  
  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Directory))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Filter))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QFileDialog::getOpenFileName(qApp->focusWidget(), *((QString *) WindowTitle->ref), *((QString *) Directory->ref), *((QString *) Filter->ref)) );
}

Q7B Q7B_OPEFILENDIALOG_GETFILES(Q7B dummy)
{  
  return Q7B_ID( QFileDialog::getOpenFileNames(qApp->focusWidget()) );
}

Q7B Q7B_OPENFILEDIALOG_GETFILES2(Q7B dummy, Q7B WindowTitle, Q7B Directory, Q7B Filter)
{  
  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Directory))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Filter))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QFileDialog::getOpenFileNames(qApp->focusWidget(), *((QString *) WindowTitle->ref), *((QString *) Directory->ref), *((QString *) Filter->ref)) );
}

Q7B Q7B_OPENFILEDIALOG_GETDIRECTORY(Q7B dummy)
{  
  return Q7B_ID( QFileDialog::getExistingDirectory(qApp->focusWidget()) );
}

Q7B Q7B_OPENFILEDIALOG_GETDIRECTORY2(Q7B dummy, Q7B WindowTitle, Q7B Directory)
{  
  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Directory))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QFileDialog::getExistingDirectory(qApp->focusWidget(), *((QString *) WindowTitle->ref), *((QString *) Directory->ref)) );
}


// *** SAVEFILEDIALOG ***********************************************************************************

Q7B Q7B_idSAVEFILEDIALOG = Q7B_idnil;
Q7B Q7B_SaveFileDialog_Object(){ return Q7B_idSAVEFILEDIALOG; }

Q7B Q7B_SAVEFILEDIALOG_GETFILE(Q7B dummy)
{  
  return Q7B_ID( QFileDialog::getSaveFileName(qApp->focusWidget()) );
}

Q7B Q7B_SAVEFILEDIALOG_GETFILE2(Q7B dummy, Q7B WindowTitle, Q7B Directory, Q7B Filter)
{  
  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Directory))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Filter))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QFileDialog::getSaveFileName(qApp->focusWidget(), *((QString *) WindowTitle->ref), *((QString *) Directory->ref), *((QString *) Filter->ref)) );
}

Q7B Q7B_SAVEFILEDIALOG_GETDIRECTORY(Q7B dummy)
{  
  return Q7B_ID( QFileDialog::getExistingDirectory(qApp->focusWidget()) );
}

Q7B Q7B_SAVEFILEDIALOG_GETDIRECTORY2(Q7B dummy, Q7B WindowTitle, Q7B Directory)
{  
  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Directory))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QFileDialog::getExistingDirectory(qApp->focusWidget(), *((QString *) WindowTitle->ref), *((QString *) Directory->ref)) );
}


// *** COLORDIALOG ***********************************************************************************

Q7B Q7B_idCOLORDIALOG = Q7B_idnil;
Q7B Q7B_ColorDialog_Object(){ return Q7B_idCOLORDIALOG; }

Q7B Q7B_COLORDIALOG_GETCOLOR(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idCOLORDIALOG)){ Q7B_idCOLORDIALOG = Q7B(new Q7B_id(typeid(Q7B_ColorDialog).name(), new Q7B_ColorDialog())); }

  return Q7B_ID( ((Q7B_ColorDialog *) Q7B_idCOLORDIALOG->ref)->GetColor() );
}

Q7B Q7B_COLORDIALOG_RED(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idCOLORDIALOG)){ Q7B_idCOLORDIALOG = Q7B(new Q7B_id(typeid(Q7B_ColorDialog).name(), new Q7B_ColorDialog())); }

  return Q7B_ID( ((Q7B_ColorDialog *) Q7B_idCOLORDIALOG->ref)->Red() );
}

Q7B Q7B_COLORDIALOG_GREEN(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idCOLORDIALOG)){ Q7B_idCOLORDIALOG = Q7B(new Q7B_id(typeid(Q7B_ColorDialog).name(), new Q7B_ColorDialog())); }

  return Q7B_ID( ((Q7B_ColorDialog *) Q7B_idCOLORDIALOG->ref)->Green() );
}

Q7B Q7B_COLORDIALOG_BLUE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idCOLORDIALOG)){ Q7B_idCOLORDIALOG = Q7B(new Q7B_id(typeid(Q7B_ColorDialog).name(), new Q7B_ColorDialog())); }

  return Q7B_ID( ((Q7B_ColorDialog *) Q7B_idCOLORDIALOG->ref)->Blue() );
}

Q7B Q7B_COLORDIALOG_ALPHA(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idCOLORDIALOG)){ Q7B_idCOLORDIALOG = Q7B(new Q7B_id(typeid(Q7B_ColorDialog).name(), new Q7B_ColorDialog())); }

  return Q7B_ID( ((Q7B_ColorDialog *) Q7B_idCOLORDIALOG->ref)->Alpha() );
}

Q7B Q7B_COLORDIALOG_GETCOLOR2(Q7B dummy, Q7B Red, Q7B Green, Q7B Blue, Q7B Alpha)
{  
  if (Q7B_nil(Q7B_idCOLORDIALOG)){ Q7B_idCOLORDIALOG = Q7B(new Q7B_id(typeid(Q7B_ColorDialog).name(), new Q7B_ColorDialog())); }

  if (Q7B_nil(Q7B_INTEGER(Red))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Green))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Blue))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Alpha))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ColorDialog *) Q7B_idCOLORDIALOG->ref)->GetColorLike( Q7B_IDqint64(Red), Q7B_IDqint64(Green), Q7B_IDqint64(Blue), Q7B_IDqint64(Alpha) ) );
}
// *** FONTDIALOG ***********************************************************************************

Q7B Q7B_idFONTDIALOG = Q7B_idnil;
Q7B Q7B_FontDialog_Object(){ return Q7B_idFONTDIALOG; }

Q7B Q7B_FONTDIALOG_GETFONT(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  return Q7B_ID( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->GetFont() );
}

Q7B Q7B_FONTDIALOG_NAME(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  return Q7B_ID( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->Name() );
}

Q7B Q7B_FONTDIALOG_SIZE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  return Q7B_ID( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->Size() );
}

Q7B Q7B_FONTDIALOG_ITALIC(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  return Q7B_ID( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->Italic() );
}

Q7B Q7B_FONTDIALOG_BOLD(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  return Q7B_ID( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->Bold() );
}

Q7B Q7B_FONTDIALOG_UNDERLINE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  return Q7B_ID( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->Underline() );
}

Q7B Q7B_FONTDIALOG_GETFONT2(Q7B dummy, Q7B Name, Q7B Size, Q7B Italic, Q7B Bold, Q7B Underline)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Size))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Italic))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Bold))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Underline))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->GetFontLike( Q7B_IDQString(Name), Q7B_IDqint64(Size), Q7B_IDbool(Italic), Q7B_IDbool(Bold), Q7B_IDbool(Underline) ) );
}

// *** PROGRESSDIALOG ***********************************************************************************

Q7B Q7B_idPROGRESSDIALOG = Q7B_idnil;
Q7B Q7B_ProgressDialog_Object(){ return Q7B_idPROGRESSDIALOG; }

void Q7B_PROGRESSDIALOG_SHOW(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Show();
}

void Q7B_PROGRESSDIALOG_HIDE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Hide();
}

void Q7B_PROGRESSDIALOG_SHOW2(Q7B dummy, Q7B WindowTitle, Q7B CancelText)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->ShowWith( Q7B_IDQString(WindowTitle), Q7B_IDQString(CancelText) );
}

Q7B Q7B_PROGRESSDIALOG_CANCELED(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_ID( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Canceled() );
}

void Q7B_PROGRESSDIALOG_WINDOWTITLE(Q7B dummy, Q7B _WindowTitle)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  if (Q7B_nil(Q7B_QSTRING(_WindowTitle))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->WindowTitle = Q7B_IDQString(_WindowTitle);
}

Q7B Q7B_PROGRESSDIALOG_WINDOWTITLE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_ID( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->WindowTitle );
}

void Q7B_PROGRESSDIALOG_CANCELTEXT(Q7B dummy, Q7B _CancelText)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  if (Q7B_nil(Q7B_QSTRING(_CancelText))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->CancelText = Q7B_IDQString(_CancelText);
}

Q7B Q7B_PROGRESSDIALOG_CANCELTEXT(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_ID( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->CancelText );
}

void Q7B_PROGRESSDIALOG_VALUE(Q7B dummy, Q7B _Value)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  if (Q7B_nil(Q7B_INTEGER(_Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Value = Q7B_IDqint64(_Value);
}

Q7B Q7B_PROGRESSDIALOG_VALUE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_ID( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Value );
}

void Q7B_PROGRESSDIALOG_MINIMUM(Q7B dummy, Q7B _Minimum)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  if (Q7B_nil(Q7B_INTEGER(_Minimum))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Minimum = Q7B_IDqint64(_Minimum);
}

Q7B Q7B_PROGRESSDIALOG_MINIMUM(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_ID( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Minimum );
}

void Q7B_PROGRESSDIALOG_MAXIMUM(Q7B dummy, Q7B _Maximum)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  if (Q7B_nil(Q7B_INTEGER(_Maximum))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Maximum = Q7B_IDqint64(_Maximum);
}

Q7B Q7B_PROGRESSDIALOG_MAXIMUM(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_ID( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Maximum );
}

void Q7B_PROGRESSDIALOG_WAIT(Q7B dummy, Q7B _Wait)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  if (Q7B_nil(Q7B_INTEGER(_Wait))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Wait = Q7B_IDqint64(_Wait);
}

Q7B Q7B_PROGRESSDIALOG_WAIT(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_ID( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Wait );
}


// *** INPUTDIALOG ***********************************************************************************

Q7B Q7B_idINPUTDIALOG = Q7B_idnil;
Q7B Q7B_InputDialog_Object(){ return Q7B_idINPUTDIALOG; }


Q7B Q7B_INPUTDIALOG_GETFLOAT(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Value, Q7B Minimum, Q7B Maximum, Q7B Decimals)
{  
  if (Q7B_nil(Q7B_idINPUTDIALOG)){ Q7B_idINPUTDIALOG = Q7B(new Q7B_id(typeid(Q7B_InputDialog).name(), new Q7B_InputDialog())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_FLOAT(Value))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_FLOAT(Minimum))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_FLOAT(Maximum))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Decimals))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_InputDialog *) Q7B_idINPUTDIALOG->ref)->GetFloat( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDqreal(Value), Q7B_IDqreal(Minimum), Q7B_IDqreal(Maximum), Q7B_IDqint64(Decimals) ) );
}

Q7B Q7B_INPUTDIALOG_GETINTEGER(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Value, Q7B Minimum, Q7B Maximum, Q7B Step)
{  
  if (Q7B_nil(Q7B_idINPUTDIALOG)){ Q7B_idINPUTDIALOG = Q7B(new Q7B_id(typeid(Q7B_InputDialog).name(), new Q7B_InputDialog())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Minimum))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Maximum))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Step))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_InputDialog *) Q7B_idINPUTDIALOG->ref)->GetInteger( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDqreal(Value), Q7B_IDqreal(Minimum), Q7B_IDqreal(Maximum), Q7B_IDqint64(Step) ) );
}

Q7B Q7B_INPUTDIALOG_GETSTRING(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Value, Q7B EchoMode)
{  
  if (Q7B_nil(Q7B_idINPUTDIALOG)){ Q7B_idINPUTDIALOG = Q7B(new Q7B_id(typeid(Q7B_InputDialog).name(), new Q7B_InputDialog())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(EchoMode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_InputDialog *) Q7B_idINPUTDIALOG->ref)->GetString( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDQString(Value), Q7B_IDqint64(EchoMode) ) );
}

Q7B Q7B_INPUTDIALOG_OK(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idINPUTDIALOG)){ Q7B_idINPUTDIALOG = Q7B(new Q7B_id(typeid(Q7B_InputDialog).name(), new Q7B_InputDialog())); }

  return Q7B_ID( ((Q7B_InputDialog *) Q7B_idINPUTDIALOG->ref)->Ok() );
}

// *** DATABASE ***********************************************************************************

Q7B Q7B_idDATABASE = Q7B_idnil;
Q7B Q7B_Database_Object(){ return Q7B_idDATABASE; }


Q7B Q7B_DATABASE_MYSQL(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->MySQL() );
}

Q7B Q7B_DATABASE_POSTGRESQL(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->PostgreSQL() );
}

Q7B Q7B_DATABASE_SQLITE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->SQLite() );
}

Q7B Q7B_DATABASE_LOCALHOST(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->LocalHost() );
}

Q7B Q7B_DATABASE_DEFAULTPORT(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->DefaultPort() );
}

Q7B Q7B_DATABASE_DEFAULTOPTIONS(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->DefaultOptions() );
}

Q7B Q7B_DATABASE_SETCURRENTDATABASE(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->SetCurrentDatabase( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_SETCURRENTDATABASE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->CurrentDatabase( ) );
}

Q7B Q7B_DATABASE_EXISTS(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Driver))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Options))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Port))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->Exists( Q7B_IDQString(Driver), Q7B_IDQString(Name), Q7B_IDQString(User), Q7B_IDQString(Password), Q7B_IDQString(Host), Q7B_IDQString(Options), Q7B_IDQString(Port)) );
}

Q7B Q7B_DATABASE_CREATE(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Driver))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Options))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Port))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->Create( Q7B_IDQString(Driver), Q7B_IDQString(Name), Q7B_IDQString(User), Q7B_IDQString(Password), Q7B_IDQString(Host), Q7B_IDQString(Options), Q7B_IDQString(Port)) );
}

Q7B Q7B_DATABASE_TESTCONNECTION(Q7B dummy, Q7B Driver, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Driver))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Options))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Port))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->TestConnection( Q7B_IDQString(Driver), Q7B_IDQString(User), Q7B_IDQString(Password), Q7B_IDQString(Host), Q7B_IDQString(Options), Q7B_IDQString(Port)) );
}

Q7B Q7B_DATABASE_EMPTY(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Driver))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Options))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Port))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->Empty( Q7B_IDQString(Driver), Q7B_IDQString(Name), Q7B_IDQString(User), Q7B_IDQString(Password), Q7B_IDQString(Host), Q7B_IDQString(Options), Q7B_IDQString(Port)) );
}

Q7B Q7B_DATABASE_DROP(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Driver))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Options))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Port))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->Drop( Q7B_IDQString(Driver), Q7B_IDQString(Name), Q7B_IDQString(User), Q7B_IDQString(Password), Q7B_IDQString(Host), Q7B_IDQString(Options), Q7B_IDQString(Port)) );
}

Q7B Q7B_DATABASE_OPENSQLITE(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->OpenSQLite( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_OPEN(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Driver))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Options))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Port))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->Open( Q7B_IDQString(Driver), Q7B_IDQString(Name), Q7B_IDQString(User), Q7B_IDQString(Password), Q7B_IDQString(Host), Q7B_IDQString(Options), Q7B_IDQString(Port)) );
}

Q7B Q7B_DATABASE_CLOSE(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->Close( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_ISOPEN(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->IsOpen( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_LASTSQLERROR(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->LastSQLError( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_LASTSQLCOMMANDS(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->LastSQLCommands( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_LASTSQLCOMMANDFAILED(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->LastSQLCommandFailed( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_ISTRANSACTIONSUPPORTED(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->IsTransactionSupported( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_TRANSACTION(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->Transaction( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_COMMIT(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->Commit( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_ROLLBACK(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->Rollback( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_TABLES(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->Tables( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_DRIVERS(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_ID( ((Q7B_Database *) Q7B_idDATABASE->ref)->Drivers( ) );
}
// *** TABLE ***********************************************************************************

Q7B Q7B_idTABLE = Q7B_idnil;
Q7B Q7B_Table_Object(){ return Q7B_idTABLE; }


Q7B Q7B_TABLE_EXISTS(Q7B dummy, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Exists( Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_EXISTS2(Q7B dummy, Q7B Database, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Exists( Q7B_IDQString(Database), Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_CREATE(Q7B dummy, Q7B Table, Q7B Fields)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Fields))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Create( Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Fields) ) );
}

Q7B Q7B_TABLE_CREATE2(Q7B dummy, Q7B Database, Q7B Table, Q7B Fields)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Fields))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Create( Q7B_IDQString(Database), Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Fields) ) );
}

Q7B Q7B_TABLE_EMPTY(Q7B dummy, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Empty( Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_EMPTY2(Q7B dummy, Q7B Database, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Empty( Q7B_IDQString(Database), Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_DROP(Q7B dummy, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Drop( Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_DROP2(Q7B dummy, Q7B Database, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Drop( Q7B_IDQString(Database), Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_DELETE(Q7B dummy, Q7B Table, Q7B Where)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  
  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Delete( Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Where) ) );
}

Q7B Q7B_TABLE_DELETE2(Q7B dummy, Q7B Database, Q7B Table, Q7B Where)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Delete( Q7B_IDQString(Database), Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Where) ) );
}

Q7B Q7B_TABLE_UPDATE(Q7B dummy, Q7B Table, Q7B Update, Q7B Where)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Update))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Update( Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Update), Q7B_IDQ7B_Dictionary(Where) ) );
}

Q7B Q7B_TABLE_UPDATE2(Q7B dummy, Q7B Database, Q7B Table, Q7B Update, Q7B Where)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Update))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Update( Q7B_IDQString(Database), Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Update), Q7B_IDQ7B_Dictionary(Where) ) );
}

Q7B Q7B_TABLE_INSERT(Q7B dummy, Q7B Table, Q7B Insert)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Insert))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Insert( Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Insert) ) );
}

Q7B Q7B_TABLE_INSERT2(Q7B dummy, Q7B Database, Q7B Table, Q7B Insert)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Insert))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->Insert( Q7B_IDQString(Database), Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Insert) ) );
}

Q7B Q7B_TABLE_FIELDNAMES(Q7B dummy, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->FieldNames( Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_FIELDNAMES2(Q7B dummy, Q7B Database, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->FieldNames( Q7B_IDQString(Database), Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_PRIMARYKEYNAME(Q7B dummy, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->PrimaryKeyName( Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_PRIMARYKEYNAME2(Q7B dummy, Q7B Database, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Table *) Q7B_idTABLE->ref)->PrimaryKeyName( Q7B_IDQString(Database), Q7B_IDQString(Table) ) );
}

// *** RECORDS ***********************************************************************************

Q7B Q7B_idRECORDS = Q7B_idnil;
Q7B Q7B_Records_Object(){ return Q7B_idRECORDS; }


Q7B Q7B_RECORDS_OPEN(Q7B dummy, Q7B TableOrSql)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(TableOrSql))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Open( Q7B_IDQString(TableOrSql) ) );
}

Q7B Q7B_RECORDS_OPEN2(Q7B dummy, Q7B Database, Q7B TableOrSql)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(TableOrSql))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Open( Q7B_IDQString(Database), Q7B_IDQString(TableOrSql) ) );
}

Q7B Q7B_RECORDS_OPEN3(Q7B dummy, Q7B TableOrSql, Q7B Where)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(TableOrSql))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Open( Q7B_IDQString(TableOrSql), Q7B_IDQ7B_Dictionary(Where) ) );
}

Q7B Q7B_RECORDS_OPEN4(Q7B dummy, Q7B Database, Q7B TableOrSql, Q7B Where)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(TableOrSql))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Open( Q7B_IDQString(Database), Q7B_IDQString(TableOrSql), Q7B_IDQ7B_Dictionary(Where) ) );
}

Q7B Q7B_RECORDS_OPEN5(Q7B dummy, Q7B Table, Q7B Where, Q7B OrderBy)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(OrderBy))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Open( Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Where), Q7B_IDQ7B_Dictionary(OrderBy) ) );
}

Q7B Q7B_RECORDS_OPEN6(Q7B dummy, Q7B Database, Q7B Table, Q7B Where, Q7B OrderBy)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(OrderBy))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Open( Q7B_IDQString(Database), Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Where), Q7B_IDQ7B_Dictionary(OrderBy) ) );
}

Q7B Q7B_RECORDS_CLOSE(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Close( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_REQUERY(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Requery( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_FIRST(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->First( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_NEXT(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Next( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_PREVIOUS(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Previous( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_LAST(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Last( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_GOTO(Q7B dummy, Q7B RecordsId, Q7B Position)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->GoTo( Q7B_IDQString(RecordsId), Q7B_IDqint64(Position) ) );
}

Q7B Q7B_RECORDS_LENGTH(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Length( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_POSITION(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Position( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_FIELDNAMES(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->FieldNames( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_VALUE(Q7B dummy, Q7B RecordsId, Q7B Field)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Field))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Records *) Q7B_idRECORDS->ref)->Value( Q7B_IDQString(RecordsId), Q7B_IDQString(Field) ) );
}

// *** QUERY ***********************************************************************************

Q7B Q7B_idQUERY = Q7B_idnil;
Q7B Q7B_Query_Object(){ return Q7B_idQUERY; }


Q7B Q7B_QUERY_RUN(Q7B dummy, Q7B QueryNameOrSql)
{  
  if (Q7B_nil(Q7B_idQUERY)){ Q7B_idQUERY = Q7B(new Q7B_id(typeid(Q7B_Query).name(), new Q7B_Query())); }

  if (Q7B_nil(Q7B_QSTRING(QueryNameOrSql))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Query *) Q7B_idQUERY->ref)->Run( Q7B_IDQString(QueryNameOrSql) ) );
}

Q7B Q7B_QUERY_RUN2(Q7B dummy, Q7B Database, Q7B QueryNameOrSql)
{  
  if (Q7B_nil(Q7B_idQUERY)){ Q7B_idQUERY = Q7B(new Q7B_id(typeid(Q7B_Query).name(), new Q7B_Query())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(QueryNameOrSql))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Query *) Q7B_idQUERY->ref)->Run( Q7B_IDQString(Database), Q7B_IDQString(QueryNameOrSql) ) );
}

Q7B Q7B_QUERY_COMMAND(Q7B dummy, Q7B Command)
{  
  if (Q7B_nil(Q7B_idQUERY)){ Q7B_idQUERY = Q7B(new Q7B_id(typeid(Q7B_Query).name(), new Q7B_Query())); }

  if (Q7B_nil(Q7B_QSTRING(Command))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Query *) Q7B_idQUERY->ref)->Command( Q7B_IDQString(Command) ) );
}

Q7B Q7B_QUERY_COMMAND2(Q7B dummy, Q7B Database, Q7B Command)
{  
  if (Q7B_nil(Q7B_idQUERY)){ Q7B_idQUERY = Q7B(new Q7B_id(typeid(Q7B_Query).name(), new Q7B_Query())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Command))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Query *) Q7B_idQUERY->ref)->Command( Q7B_IDQString(Database), Q7B_IDQString(Command) ) );
}

// *** MESSAGEBOX ***********************************************************************************

Q7B Q7B_idMESSAGEBOX = Q7B_idnil;
Q7B Q7B_MessageBox_Object(){ return Q7B_idMESSAGEBOX; }


Q7B Q7B_MESSAGEBOX_CRITICAL(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Buttons, Q7B DefaultButton)
{  
  if (Q7B_nil(Q7B_idMESSAGEBOX)){ Q7B_idMESSAGEBOX = Q7B(new Q7B_id(typeid(Q7B_MessageBox).name(), new Q7B_MessageBox())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Buttons))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(DefaultButton))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_MessageBox *) Q7B_idMESSAGEBOX->ref)->Critical( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDqint64(Buttons), Q7B_IDqint64(DefaultButton) ) );
}

Q7B Q7B_MESSAGEBOX_INFORMATION(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Buttons, Q7B DefaultButton)
{  
  if (Q7B_nil(Q7B_idMESSAGEBOX)){ Q7B_idMESSAGEBOX = Q7B(new Q7B_id(typeid(Q7B_MessageBox).name(), new Q7B_MessageBox())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Buttons))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(DefaultButton))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_MessageBox *) Q7B_idMESSAGEBOX->ref)->Information( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDqint64(Buttons), Q7B_IDqint64(DefaultButton) ) );
}

Q7B Q7B_MESSAGEBOX_QUESTION(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Buttons, Q7B DefaultButton)
{  
  if (Q7B_nil(Q7B_idMESSAGEBOX)){ Q7B_idMESSAGEBOX = Q7B(new Q7B_id(typeid(Q7B_MessageBox).name(), new Q7B_MessageBox())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Buttons))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(DefaultButton))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_MessageBox *) Q7B_idMESSAGEBOX->ref)->Question( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDqint64(Buttons), Q7B_IDqint64(DefaultButton) ) );
}

Q7B Q7B_MESSAGEBOX_WARNING(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Buttons, Q7B DefaultButton)
{  
  if (Q7B_nil(Q7B_idMESSAGEBOX)){ Q7B_idMESSAGEBOX = Q7B(new Q7B_id(typeid(Q7B_MessageBox).name(), new Q7B_MessageBox())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Buttons))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(DefaultButton))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_MessageBox *) Q7B_idMESSAGEBOX->ref)->Warning( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDqint64(Buttons), Q7B_IDqint64(DefaultButton) ) );
}

// *** SYSTEMTRAYICON ***********************************************************************************

Q7B Q7B_idSYSTEMTRAYICON = Q7B_idnil;

void Q7B_SYSTEMTRAYICON_CONTEXTMENU(Q7B qsystemtray, Q7B v)
{
  if (Q7B_nil(Q7B_QMENU(v))){ Q7B_EXCEPTION("QMenu expected"); return; }

  //Q7B_idSYSTEMTRAY = qsystemtray;

  ((QSystemTrayIcon *) qsystemtray->ref)->setContextMenu( ((QMenu *) v->ref) );
}

Q7B Q7B_SYSTEMTRAYICON_CONTEXTMENU(Q7B qsystemtray)
{
  //Q7B_idSYSTEMTRAY = qsystemtray;

  return Q7B_ID( ((QSystemTrayIcon *) qsystemtray->ref)->contextMenu() );
}

void Q7B_SYSTEMTRAYICON_ICON(Q7B qsystemtray, Q7B v)
{
  if (Q7B_nil(Q7B_QICON(v))){ Q7B_EXCEPTION("QIcon expected"); return; }

  //Q7B_idSYSTEMTRAY = qsystemtray;

   QIcon icon;
  icon = *((QIcon *) v->ref);
  ((QSystemTrayIcon *) qsystemtray->ref)->setIcon( icon );
}

Q7B Q7B_SYSTEMTRAYICON_ICON(Q7B qsystemtray)
{  
  //Q7B_idSYSTEMTRAY = qsystemtray;

  return Q7B_ID( ((QSystemTrayIcon *) qsystemtray->ref)->icon() );
}

void Q7B_SYSTEMTRAYICON_TOOLTIP(Q7B qsystemtray, Q7B v)
{
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  //Q7B_idSYSTEMTRAY = qsystemtray;

  ((QSystemTrayIcon *) qsystemtray->ref)->setToolTip( *((QString *) v->ref) );
}

Q7B Q7B_SYSTEMTRAYICON_TOOLTIP(Q7B qsystemtray)
{  
  //Q7B_idSYSTEMTRAY = qsystemtray;

  return Q7B_ID( ((QSystemTrayIcon *) qsystemtray->ref)->toolTip() );
}

void Q7B_SYSTEMTRAYICON_VISIBLE(Q7B qsystemtray, Q7B v)
{
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  //Q7B_idSYSTEMTRAY = qsystemtray;

  ((QSystemTrayIcon *) qsystemtray->ref)->setVisible( *((bool *) v->ref) );
}

Q7B Q7B_SYSTEMTRAYICON_VISIBLE(Q7B qsystemtray)
{  
  //Q7B_idSYSTEMTRAY = qsystemtray;

  return Q7B_ID( ((QSystemTrayIcon *) qsystemtray->ref)->isVisible() );
}

Q7B Q7B_SYSTEMTRAYICON_ISSYSTEMTRAYAVAILABLE(Q7B qsystemtray)
{  
  //Q7B_idSYSTEMTRAY = qsystemtray;

  return Q7B_ID( QSystemTrayIcon::isSystemTrayAvailable() );
}

Q7B Q7B_SYSTEMTRAYICON_ISMESSAGEBOXSUPPORTED(Q7B qsystemtray)
{  
  //Q7B_idSYSTEMTRAY = qsystemtray;

  return Q7B_ID( QSystemTrayIcon::supportsMessages() );
}

void Q7B_SYSTEMTRAYICON_SHOW(Q7B qsystemtray)
{
  //Q7B_idSYSTEMTRAY = qsystemtray;

  ((QSystemTrayIcon *) qsystemtray->ref)->show();
}

void Q7B_SYSTEMTRAYICON_HIDE(Q7B qsystemtray)
{
  //Q7B_idSYSTEMTRAY = qsystemtray;

  ((QSystemTrayIcon *) qsystemtray->ref)->hide();
}

void Q7B_SYSTEMTRAYICON_SHOWORHIDE(Q7B qsystemtray)
{
  //Q7B_idSYSTEMTRAY = qsystemtray;

  ((QSystemTrayIcon *) qsystemtray->ref)->setVisible(((QSystemTrayIcon *) qsystemtray->ref)->isVisible());
}

void Q7B_SYSTEMTRAYICON_MESSAGEBOX(Q7B qsystemtray, Q7B Text)
{
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  //Q7B_idSYSTEMTRAY = qsystemtray;

  if (((QSystemTrayIcon *) qsystemtray->ref)->icon().isNull()){
    ((QSystemTrayIcon *) qsystemtray->ref)->setIcon(qApp->windowIcon());
  }
  ((QSystemTrayIcon *) qsystemtray->ref)->show();
  ((QSystemTrayIcon *) qsystemtray->ref)->showMessage(qApp->applicationName(), *((QString *) Text->ref) );
}

void Q7B_SYSTEMTRAYICON_MESSAGEBOX2(Q7B qsystemtray, Q7B Title, Q7B Text)
{
  if (Q7B_nil(Q7B_QSTRING(Title))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  //Q7B_idSYSTEMTRAY = qsystemtray;

  if (((QSystemTrayIcon *) qsystemtray->ref)->icon().isNull()){
    ((QSystemTrayIcon *) qsystemtray->ref)->setIcon(qApp->windowIcon());
  }
  ((QSystemTrayIcon *) qsystemtray->ref)->show();
  ((QSystemTrayIcon *) qsystemtray->ref)->showMessage( *((QString *) Title->ref), *((QString *) Text->ref) );
}

void Q7B_SYSTEMTRAYICON_MESSAGEBOX3(Q7B qsystemtray, Q7B Title, Q7B Text, Q7B MessageBoxIcon)
{
  if (Q7B_nil(Q7B_QSTRING(Title))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(MessageBoxIcon))){ Q7B_EXCEPTION("Integer expected"); return; }

  //Q7B_idSYSTEMTRAY = qsystemtray;

  if (((QSystemTrayIcon *) qsystemtray->ref)->icon().isNull()){
    ((QSystemTrayIcon *) qsystemtray->ref)->setIcon(qApp->windowIcon());
  }
  ((QSystemTrayIcon *) qsystemtray->ref)->show();
  ((QSystemTrayIcon *) qsystemtray->ref)->showMessage( *((QString *) Title->ref), *((QString *) Text->ref), (QSystemTrayIcon::MessageIcon) *((qint64 *) MessageBoxIcon->ref) );
}

void Q7B_SYSTEMTRAYICON_MESSAGEBOX4(Q7B qsystemtray, Q7B Title, Q7B Text, Q7B MessageBoxIcon, Q7B TimeOut)
{
  if (Q7B_nil(Q7B_QSTRING(Title))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(MessageBoxIcon))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(TimeOut))){ Q7B_EXCEPTION("Integer expected"); return; }
 
  //Q7B_idSYSTEMTRAY = qsystemtray;

  if (((QSystemTrayIcon *) qsystemtray->ref)->icon().isNull()){
    ((QSystemTrayIcon *) qsystemtray->ref)->setIcon(qApp->windowIcon());
  }
  ((QSystemTrayIcon *) qsystemtray->ref)->show();
  ((QSystemTrayIcon *) qsystemtray->ref)->showMessage( *((QString *) Title->ref), *((QString *) Text->ref), (QSystemTrayIcon::MessageIcon) *((qint64 *) MessageBoxIcon->ref), *((qint64 *) TimeOut->ref) );
}


// *** TOOLBAR ***********************************************************************************

QToolBar *Q7B_getDefaultToolBar()
{
  QWidget *cw = ((QMainWindow *) q7b_MainWindow_Object_Q7B->ref);
  if (cw){
    QObjectList ol = cw->children();  // findChild von qobject benutzen auch f?r andere stellencode hier
  
    for (int q = 0; q < ol.size(); q++){

      QToolBar *tb = qobject_cast<QToolBar *>(ol.at(q));
      if (tb){
        return tb;
      }
    }
  }
  return 0;
}
/*
QAction *Q7B_getQActionForString(QMainWindow *mw, QString sActionName)
{
  QObjectList ol = mw->children();

  for (int q = 0; q < ol.size(); q++){

    QAction *a = qobject_cast<QAction *>(ol.at(q));
    if (a){
      return a;
      //QMessageBox::information(0, "Q7B_getQActionForString", a->objectName());
      if (a->objectName() == sActionName){
        return a;
      }
    }
  }

  return 0;
}
*/
Q7B Q7B_idTOOLBAR = Q7B_idnil;
Q7B Q7B_ToolBar_Object(){ return Q7B_idTOOLBAR; }

void Q7B_TOOLBAR_ADDPERMANENTWIDGET(Q7B qstatusbar, Q7B Widget, Q7B Action)
{
  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_QACTION(Action))){ Q7B_EXCEPTION("QAction expected"); return; }

  QMainWindow *mw = ((QMainWindow *) q7b_MainWindow_Object_Q7B->ref);


  if (mw){
    //QMessageBox::information(0, "TOOLBAR_ADDPERMANENTWIDGET", "1");
    QToolBar *tb = Q7B_getDefaultToolBar();
    if (tb){
      //QMessageBox::information(0, "TOOLBAR_ADDPERMANENTWIDGET", "2");
      QAction *a = ((QAction *) Action->ref);//Q7B_getQActionForString(mw, *((QString *) Widget->ref));

      if (a){
     //   QMessageBox::information(0, "TOOLBAR_ADDPERMANENTWIDGET", "3");
        QWidget *w = ((QWidget *) Widget->ref);
       // w->setParent(tb);
        tb->insertWidget(a, w);
       // a->setVisible(true);
        //((QWidget *) Widget->ref)->show();
      }
    }
  }

}

// *** SOUNDS ***********************************************************************************

Q7B Q7B_idSOUNDS = Q7B_idnil;
Q7B Q7B_Sounds_Object(){ return Q7B_idSOUNDS; }


Q7B Q7B_SOUNDS_PLAY(Q7B dummy, Q7B SoundId)
{
  if (Q7B_nil(Q7B_idSOUNDS)){ Q7B_idSOUNDS = Q7B(new Q7B_id(typeid(Q7B_Sounds).name(), new Q7B_Sounds())); }

  if (Q7B_nil(Q7B_QSTRING(SoundId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Sounds *) Q7B_idSOUNDS->ref)->Play( *((QString *) SoundId->ref) ) );
}

Q7B Q7B_SOUNDS_LOAD(Q7B dummy, Q7B SoundId, Q7B FileName)
{
  if (Q7B_nil(Q7B_idSOUNDS)){ Q7B_idSOUNDS = Q7B(new Q7B_id(typeid(Q7B_Sounds).name(), new Q7B_Sounds())); }

  if (Q7B_nil(Q7B_QSTRING(SoundId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Sounds *) Q7B_idSOUNDS->ref)->Load( *((QString *) SoundId->ref), *((QString *) FileName->ref) ) );
}

// *** PIXMAPS ***********************************************************************************

Q7B Q7B_idPIXMAPS = Q7B_idnil;
Q7B Q7B_Pixmaps_Object(){ return Q7B_idPIXMAPS; }


Q7B Q7B_PIXMAPS_LOAD(Q7B dummy, Q7B PixmapId, Q7B FileName)
{
  if (Q7B_nil(Q7B_idPIXMAPS)){ Q7B_idPIXMAPS = Q7B(new Q7B_id(typeid(Q7B_Pixmaps).name(), new Q7B_Pixmaps())); }

  if (Q7B_nil(Q7B_QSTRING(PixmapId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Pixmaps *) Q7B_idPIXMAPS->ref)->Load( *((QString *) PixmapId->ref), *((QString *) FileName->ref) ) );
}

// *** COLORS ***********************************************************************************

Q7B Q7B_idCOLORS = Q7B_idnil;
Q7B Q7B_Colors_Object(){ return Q7B_idCOLORS; }


Q7B Q7B_COLORS_SET(Q7B dummy, Q7B ColorId, Q7B R, Q7B G, Q7B B, Q7B A)
{
  if (Q7B_nil(Q7B_idCOLORS)){ Q7B_idCOLORS = Q7B(new Q7B_id(typeid(Q7B_Colors).name(), new Q7B_Colors())); }

  if (Q7B_nil(Q7B_QSTRING(ColorId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(R))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(G))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(B))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(A))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Colors *) Q7B_idCOLORS->ref)->Set( *((QString *) ColorId->ref), Q7B_IDqint64(R), Q7B_IDqint64(G), Q7B_IDqint64(B), Q7B_IDqint64(A) ) );
}

// *** FONTS ***********************************************************************************

Q7B Q7B_idFONTS = Q7B_idnil;
Q7B Q7B_Fonts_Object(){ return Q7B_idFONTS; }


Q7B Q7B_FONTS_SET(Q7B dummy, Q7B ColorId, Q7B R, Q7B G, Q7B B, Q7B A)
{
  if (Q7B_nil(Q7B_idCOLORS)){ Q7B_idCOLORS = Q7B(new Q7B_id(typeid(Q7B_Colors).name(), new Q7B_Colors())); }

  if (Q7B_nil(Q7B_QSTRING(ColorId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(R))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(G))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(B))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(A))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Colors *) Q7B_idCOLORS->ref)->Set( *((QString *) ColorId->ref), Q7B_IDqint64(R), Q7B_IDqint64(G), Q7B_IDqint64(B), Q7B_IDqint64(A) ) );
}

// *** STATUSBAR ***********************************************************************************

Q7B Q7B_idSTATUSBAR = Q7B_idnil;
Q7B Q7B_StatusBar_Object(){ return Q7B_idSTATUSBAR; }


void Q7B_STATUSBAR_CLEARMESSAGE(Q7B qstatusbar)
{
  ((QMainWindow *) q7b_MainWindow_Object_Q7B->ref)->statusBar()->clearMessage( );
}

void Q7B_STATUSBAR_SHOWMESSAGE(Q7B qstatusbar, Q7B Message)
{
  if (Q7B_nil(Q7B_QSTRING(Message))){ Q7B_EXCEPTION("String expected"); return; }

  ((QMainWindow *) q7b_MainWindow_Object_Q7B->ref)->statusBar()->showMessage( *((QString *) Message->ref) );
}

void Q7B_STATUSBAR_SHOWMESSAGE(Q7B qstatusbar, Q7B Message, Q7B TimeOutInMilliSeconds)
{
  if (Q7B_nil(Q7B_QSTRING(Message))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(TimeOutInMilliSeconds))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QMainWindow *) q7b_MainWindow_Object_Q7B->ref)->statusBar()->showMessage( *((QString *) Message->ref), *((qint64 *) TimeOutInMilliSeconds->ref) );
}

void Q7B_STATUSBAR_ADDPERMANENTWIDGET(Q7B qstatusbar, Q7B Widget)
{
  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QMainWindow *) q7b_MainWindow_Object_Q7B->ref)->statusBar()->addPermanentWidget( ((QWidget *) Widget->ref));
}

// *** APPLICATION ***********************************************************************************

Q7B Q7B_idAPPLICATION = Q7B_idnil;
//Q7B Q7B_Application_Object(){ return Q7B_idAPPLICATION; }

void Q7B_APPLICATION_PATH(Q7B qapplication, Q7B v)
{
}

Q7B Q7B_APPLICATION_PATH(Q7B qapplication)
{
  return Q7B_ID( qApp->applicationDirPath() );
}

void Q7B_APPLICATION_FILENAME(Q7B qapplication, Q7B v)
{
}

Q7B Q7B_APPLICATION_FILENAME(Q7B qapplication)
{
  return Q7B_ID( qApp->applicationFilePath() );
}

void Q7B_APPLICATION_PID(Q7B qapplication, Q7B v)
{
}

Q7B Q7B_APPLICATION_PID(Q7B qapplication)
{
  return Q7B_ID( qApp->applicationPid() );
}

void Q7B_APPLICATION_ARGUMENTS(Q7B qapplication, Q7B v)
{
}

Q7B Q7B_APPLICATION_ARGUMENTS(Q7B qapplication)
{
  return Q7B_ID( qApp->arguments() );
}

void Q7B_APPLICATION_APPLICATIONNAME(Q7B qapplication, Q7B v)
{
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  qApp->setApplicationName( *((QString *) v->ref) );
}

Q7B Q7B_APPLICATION_APPLICATIONNAME(Q7B qapplication)
{
  return Q7B_ID( qApp->applicationName() );
}

void Q7B_APPLICATION_APPLICATIONVERSION(Q7B qapplication, Q7B v)
{
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  qApp->setApplicationVersion( *((QString *) v->ref) );
}

Q7B Q7B_APPLICATION_APPLICATIONVERSION(Q7B qapplication)
{
  return Q7B_ID( qApp->applicationVersion() );
}

void Q7B_APPLICATION_ORGANIZATIONDOMAIN(Q7B qapplication, Q7B v)
{
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  qApp->setOrganizationDomain( *((QString *) v->ref) );
}

Q7B Q7B_APPLICATION_ORGANIZATIONDOMAIN(Q7B qapplication)
{
  return Q7B_ID( qApp->organizationDomain() );
}

void Q7B_APPLICATION_ORGANIZATIONNAME(Q7B qapplication, Q7B v)
{
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  qApp->setOrganizationName( *((QString *) v->ref) );
}

Q7B Q7B_APPLICATION_ORGANIZATIONNAME(Q7B qapplication)
{
  return Q7B_ID( qApp->organizationName() );
}

void Q7B_APPLICATION_QUIT(Q7B qapplication)
{
  //QMessageBox::information(0, "APPLICATION_STOP", "APPLICATION_STOP");
  qApp->quit();
}

void Q7B_APPLICATION_CURSORSETWAIT(Q7B qapplication)
{
  qApp->setOverrideCursor(QCursor(Qt::WaitCursor));
}

void Q7B_APPLICATION_CURSORUNSETWAIT(Q7B qapplication)
{
  qApp->restoreOverrideCursor();
}

Q7B Q7B_APPLICATION_CLIPBOARDTEXT(Q7B qapplication)
{
  QClipboard *p = qApp->clipboard();
  return Q7B_ID( p->text() );
}

Q7B Q7B_APPLICATION_QTVERSION(Q7B qapplication)
{
  return Q7B_ID( qVersion() );
}

Q7B Q7B_APPLICATION_OPERATINGSYSTEMNAME(Q7B qapplication)
{
#ifdef Q_OS_WIN32
  return Q7B_ID( "Windows" );
#endif

#ifdef Q_WS_MAC
  return Q7B_ID( "Mac OS X" );
#endif

#ifdef Q_WS_X11
  return Q7B_ID( "X11" );
#endif  

  return Q7B_ID( "Unspecified" );
}

void Q7B_APPLICATION_SETDEFAULTWINDOWICON(Q7B qapplication, Q7B Icon)
{ 
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return; }
  
  qApp->setWindowIcon( *((QIcon *) Icon->ref) );
  /*
  // TODO2
  if (Icon->type == typeid(Data).name()){
  //  QPixmap p; p.loadFromData(n.toLatin1());
  //  qApp->setWindowIcon(p);
  } else {
  //  qApp->setWindowIcon(QIcon(interpreter_loadPixmap(n)));
  }*/
}

void Q7B_APPLICATION_CLOSEALLWINDOWS(Q7B qapplication)
{
  qApp->closeAllWindows();
}

Q7B Q7B_APPLICATION_ISRIGHTTOLEFTLAYOUTDIRECTION(Q7B qapplication)
{
  return Q7B_ID( qApp->layoutDirection() == Qt::RightToLeft );
}
/*
Q7B Q7B_APPLICATION_FOCUSDIALOG(Q7B qapplication)
{
  return Q7B_ID( qApp->activeModalWidget() );
}*/

Q7B Q7B_APPLICATION_FOCUSWINDOW(Q7B qapplication)
{
  return Q7B_ID( qApp->activeWindow() );
}

Q7B Q7B_APPLICATION_FOCUS(Q7B qapplication)
{
  return Q7B_ID( qApp->focusWidget() );
}

Q7B Q7B_APPLICATION_AVAILABLEMIMETYPES(Q7B qapplication)
{ // TODO2
  return Q7B_ID( "" );
}

Q7B Q7B_APPLICATION_AVAILABLELANGUAGES(Q7B qapplication)
{ // TODO2
  return Q7B_ID( "" );
}

void Q7B_APPLICATION_ABOUTQT(Q7B qapplication)
{
  qApp->aboutQt();
}

void Q7B_APPLICATION_SETQUITONLASTWINDOWCLOSED(Q7B qapplication, Q7B Quit)
{
  if (Q7B_nil(Q7B_BOOLEAN(Quit))){ Q7B_EXCEPTION("Boolean expected"); return; }

  qApp->setQuitOnLastWindowClosed( *((bool *) Quit->ref) );
}

void Q7B_APPLICATION_SETSTYLE(Q7B qapplication, Q7B Quit)
{ 
  /*
  // TODO2
  if (k.contains("Motif", Qt::CaseInsensitive)) QApplication::setStyle(new QMotifStyle);
  else if (k.contains("CDE", Qt::CaseInsensitive)) QApplication::setStyle(new QCDEStyle);  
  else if (k.contains("Plastique", Qt::CaseInsensitive)) QApplication::setStyle(new QPlastiqueStyle);
  //else if (k.contains("GTK", Qt::CaseInsensitive)) QApplication::setStyle(new QGtkStyle);   
#ifdef Q_WS_MAC
  else if (k.contains("Mac", Qt::CaseInsensitive)) QApplication::setStyle(new QMacStyle); // HIDE
#endif
  else if (k.contains("Cleanlooks", Qt::CaseInsensitive)) QApplication::setStyle(new QCleanlooksStyle);
#ifdef Q_OS_WIN32
  else if (k.contains("WindowsXP", Qt::CaseInsensitive)) QApplication::setStyle(new QWindowsXPStyle); // HIDE
  else if (k.contains("WindowsVista", Qt::CaseInsensitive)) QApplication::setStyle(new QWindowsVistaStyle); // HIDE
  else if (k.contains("DotNetStandard", Qt::CaseInsensitive)) QApplication::setStyle(new QtDotNetStyle(QtDotNetStyle::Standard)); // HIDE
  else if (k.contains("DotNetOffice", Qt::CaseInsensitive)) QApplication::setStyle(new QtDotNetStyle(QtDotNetStyle::Office)); // HIDE
#endif
  // must be the last
  else if (k.contains("Windows", Qt::CaseInsensitive)) QApplication::setStyle(new QWindowsStyle);
*/
}

void Q7B_APPLICATION_SETSTYLESHEET(Q7B qapplication, Q7B Quit)
{ // TODO2
//  QString styleSheet = QString::fromUtf8(EXTERN_myInterpreter->loadProjectFile(k));
//  qApp->setStyleSheet(styleSheet);
}

void Q7B_APPLICATION_SETRIGHTTOLEFTLAYOUTDIRECTION(Q7B qapplication, Q7B Quit)
{
  if (Q7B_nil(Q7B_BOOLEAN(Quit))){ Q7B_EXCEPTION("Boolean expected"); return; }

  qApp->setLayoutDirection( *((bool *) Quit->ref) ? Qt::RightToLeft : Qt::LeftToRight );
}

Q7B Q7B_APPLICATION_LOADPROJECTFILEASSTRING(Q7B qapplication, Q7B FileName)
{ // TODO2
  return Q7B_ID( "" );
}

Q7B Q7B_APPLICATION_LOADPROJECTFILEASDATA(Q7B qapplication, Q7B FileName)
{ // TODO2
  return Q7B_ID( "" );
}

Q7B Q7B_APPLICATION_LOADURLASSTRING(Q7B qapplication, Q7B FileName)
{ // TODO2
  return Q7B_ID( "" );
}

Q7B Q7B_APPLICATION_LOADURLASDATA(Q7B qapplication, Q7B FileName)
{ // TODO2
  return Q7B_ID( "" );
}

void Q7B_APPLICATION_SETCLIPBOARDTEXT(Q7B qapplication, Q7B Text)
{ 
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  static QString sBuffer;
  sBuffer = *((QString *) Text->ref);
  QClipboard *p = qApp->clipboard();
  p->setText(sBuffer);
}

Q7B Q7B_APPLICATION_ISMIMETYPEAVAILABLE(Q7B qapplication, Q7B MimeTyp)
{ // TODO2
  return Q7B_ID( "" );
}

void Q7B_APPLICATION_SETLANGUAGE(Q7B qapplication, Q7B Language)
{ 
  // TODO2 language constanten etc.
}

void Q7B_APPLICATION_SETCOUNTRY(Q7B qapplication, Q7B Language)
{ 
  // TODO2 SetCountry constanten etc.
}

Q7B Q7B_APPLICATION_TAKESCREENSHOT(Q7B qapplication)
{ // TODO2
  /*
  QPixmap p = QPixmap::grabWindow(QApplication::desktop()->winId());

  QByteArray bytes;
  QBuffer buffer(&bytes);
  buffer.open(QIODevice::WriteOnly);
  p.save(&buffer, "PNG"); // writes pixmap into bytes in PNG format

  static QString s;
  s = QString::fromLatin1((const char *) bytes.data(), bytes.size());
  return s;  
  */
  return Q7B_ID( "" );
}

Q7B Q7B_APPLICATION_STANDARDOPERATINGSYSTEMICON(Q7B qapplication)
{ // TODO2
  return Q7B_ID( "" );
}

Q7B Q7B_APPLICATION_AVAILABLEFONTNAMES(Q7B qapplication)
{ // TODO2
  return Q7B_ID( "" );
}

void Q7B_APPLICATION_PRINTHTML(Q7B qapplication, Q7B Html)
{ 
  if (Q7B_nil(Q7B_QSTRING(Html))){ Q7B_EXCEPTION("String expected"); return; }

  QTextDocument *document = new QTextDocument();
  document->setHtml( *((QString *) Html->ref) );
  QPrinter printer;
  QPrintDialog *dialog = new QPrintDialog(&printer, qApp->activeWindow());
  if (dialog->exec() != QDialog::Accepted){
     delete document;     
     return;
  }
  document->print(&printer);
  delete document;     
}

void Q7B_APPLICATION_PRINTHTMLASPDF(Q7B qapplication, Q7B Html, Q7B PDFFilePath)
{ 
  if (Q7B_nil(Q7B_QSTRING(Html))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(PDFFilePath))){ Q7B_EXCEPTION("String expected"); return; }

  QTextDocument *document = new QTextDocument();
  document->setHtml( *((QString *) Html->ref) );
  QPrinter printer;
  printer.setOutputFormat(QPrinter::PdfFormat);
  printer.setOutputFileName( *((QString *) PDFFilePath->ref) );

  QPrintDialog *dialog = new QPrintDialog(&printer, qApp->activeWindow());
  if (dialog->exec() != QDialog::Accepted){
     delete document;     
     return;
  }
  document->print(&printer);
  delete document;     
}

Q7B Q7B_APPLICATION_DOWNLOADURLASFILE(Q7B qapplication, Q7B URL, Q7B DestinationPath)
{ 
  if (Q7B_nil(Q7B_QSTRING(URL))){ Q7B_EXCEPTION("String expected"); return Q7B_ID( false ); }
  if (Q7B_nil(Q7B_QSTRING(DestinationPath))){ Q7B_EXCEPTION("String expected"); return Q7B_ID( false ); }
  
  // TODO2

  return Q7B_ID( false );
}

void Q7B_APPLICATION_ALERT(Q7B qapplication, Q7B Widget, Q7B MSec)
{ 
  // TODO2
}

Q7B Q7B_APPLICATION_WIDGETAT(Q7B qapplication, Q7B X, Q7B Y)
{ 
  // TODO2
  return Q7B_ID( "" );
}

// TODO2 on_focusChanged und on_lastWindowClosed testen


// *** QBUTTONGROUP ***********************************************************************************

Q7B Q7B_QBUTTONGROUP_INIT(QObject *parent, const char *objectName)
{
  QButtonGroup *o = new QButtonGroup( parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QButtonGroup).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QBUTTONGROUP_EXCLUSIVE(Q7B qbuttongroup, Q7B v)
{
  if (Q7B_nil(qbuttongroup)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QBUTTONGROUP(qbuttongroup))){ Q7B_EXCEPTION("QButtonGroup expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QButtonGroup *) qbuttongroup->ref)->setExclusive( *((bool *) v->ref) );
}

Q7B Q7B_QBUTTONGROUP_EXCLUSIVE(Q7B qbuttongroup)
{
  if (Q7B_nil(qbuttongroup)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBUTTONGROUP(qbuttongroup))){ Q7B_EXCEPTION("QButtonGroup expected"); return Q7B_idnil; }

  return Q7B_ID( ((QButtonGroup *) qbuttongroup->ref)->exclusive() );
}

void Q7B_QBUTTONGROUP_ADDBUTTON(Q7B qbuttongroup, Q7B v)
{
  if (Q7B_nil(qbuttongroup)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QBUTTONGROUP(qbuttongroup))){ Q7B_EXCEPTION("QButtonGroup expected"); return; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(v))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }

  ((QButtonGroup *) qbuttongroup->ref)->addButton( ((QAbstractButton *) v->ref) );
}

// *** QABSTRACTBUTTON ***********************************************************************************

// gibt keine Init function

void Q7B_QABSTRACTBUTTON_TEXT(Q7B qabstractbutton, Q7B v)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

 // QMessageBox::information(0, QString("%1").arg(qpushbutton.type), QString("%1").arg((int)qpushbutton->ref));

  ((QAbstractButton *) qabstractbutton->ref)->setText( *((QString *) v->ref) );
}

Q7B Q7B_QABSTRACTBUTTON_TEXT(Q7B qabstractbutton)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((QAbstractButton *) qabstractbutton->ref)->text() );
}

void Q7B_COMMANDBUTTON_CAPTION(Q7B qabstractbutton, Q7B v)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

 // QMessageBox::information(0, QString("%1").arg(qpushbutton.type), QString("%1").arg((int)qpushbutton->ref));

  ((QAbstractButton *) qabstractbutton->ref)->setText( *((QString *) v->ref) );
}

Q7B Q7B_COMMANDBUTTON_CAPTION(Q7B qabstractbutton)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((QAbstractButton *) qabstractbutton->ref)->text() );
}

void Q7B_QABSTRACTBUTTON_ICON(Q7B qabstractbutton, Q7B v)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }
  if (Q7B_nil(Q7B_QICON(v))){ Q7B_EXCEPTION("QIcon expected"); return; }

  QIcon icon;
  icon = *((QIcon *) v->ref);

   //QMessageBox::information(0, "QABSTRACTBUTTON_ICON", QString("%1").arg(icon.isNull()));
   // TODO2 setIcon mit amovie wie bei imagebutton
  ((QAbstractButton *) qabstractbutton->ref)->setIcon( icon );
}

Q7B Q7B_QABSTRACTBUTTON_ICON(Q7B qabstractbutton)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((QAbstractButton *) qabstractbutton->ref)->icon() );
}

void Q7B_QABSTRACTBUTTON_CHECKED(Q7B qabstractbutton, Q7B v)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QAbstractButton *) qabstractbutton->ref)->setChecked( *((bool *) v->ref) );
}

Q7B Q7B_QABSTRACTBUTTON_CHECKED(Q7B qabstractbutton)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((QAbstractButton *) qabstractbutton->ref)->isChecked() );
}

void Q7B_QABSTRACTBUTTON_CHECKABLE(Q7B qabstractbutton, Q7B v)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QAbstractButton *) qabstractbutton->ref)->setCheckable( *((bool *) v->ref) );
}

Q7B Q7B_QABSTRACTBUTTON_CHECKABLE(Q7B qabstractbutton)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((QAbstractButton *) qabstractbutton->ref)->isCheckable() );
}

void Q7B_QABSTRACTBUTTON_KEY(Q7B qabstractbutton, Q7B v)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QAbstractButton *ab = ((QAbstractButton *) qabstractbutton->ref);

  QString n = *((QString *) v->ref);

  if (n.compare("HelpContents", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::HelpContents);
  else if (n.compare("WhatsThis", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::WhatsThis);
  else if (n.compare("Open", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Open);
  else if (n.compare("Close", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Close);
  else if (n.compare("Save", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Save);
  else if (n.compare("New", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::New);
  else if (n.compare("Delete", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Delete);
  else if (n.compare("Cut", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Cut);
  else if (n.compare("Copy", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Copy);
  else if (n.compare("Paste", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Paste);
  else if (n.compare("Undo", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Undo);
  else if (n.compare("Redo", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Redo);
  else if (n.compare("Back", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Back);
  else if (n.compare("Forward", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Forward);
  else if (n.compare("Refresh", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Refresh);
  else if (n.compare("ZoomIn", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::ZoomIn);
  else if (n.compare("ZoomOut", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::ZoomOut);
  else if (n.compare("Print", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Print);
  else if (n.compare("AddTab", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::AddTab);
  else if (n.compare("NextChild", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::NextChild);
  else if (n.compare("PreviousChild", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::PreviousChild);
  else if (n.compare("Find", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Find);
  else if (n.compare("FindNext", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::FindNext);
  else if (n.compare("FindPrevious", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::FindPrevious);
  else if (n.compare("Replace", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Replace);
  else if (n.compare("SelectAll", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectAll);
  else if (n.compare("Bold", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Bold);
  else if (n.compare("Italic", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Italic);
  else if (n.compare("Underline", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Underline);
  else if (n.compare("MoveToNextChar", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToNextChar);
  else if (n.compare("MoveToPreviousChar", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToPreviousChar);
  else if (n.compare("MoveToNextWord", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToNextWord);
  else if (n.compare("MoveToPreviousWord", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToPreviousWord);
  else if (n.compare("MoveToNextLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToNextLine);
  else if (n.compare("MoveToPreviousLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToPreviousLine);
  else if (n.compare("MoveToNextPage", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToNextPage);
  else if (n.compare("MoveToPreviousPage", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToPreviousPage);
  else if (n.compare("MoveToStartOfLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToStartOfLine);
  else if (n.compare("MoveToEndOfLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToEndOfLine);
  else if (n.compare("MoveToStartOfBlock", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToStartOfBlock);
  else if (n.compare("MoveToEndOfBlock", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToEndOfBlock);
  else if (n.compare("MoveToStartOfDocument", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToStartOfDocument);
  else if (n.compare("MoveToEndOfDocument", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToEndOfDocument);
  else if (n.compare("SelectNextChar", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectNextChar);
  else if (n.compare("SelectPreviousChar", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectPreviousChar);
  else if (n.compare("SelectNextWord", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectNextWord);
  else if (n.compare("SelectPreviousWord", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectPreviousWord);
  else if (n.compare("SelectNextLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectNextLine);
  else if (n.compare("SelectPreviousLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectPreviousLine);
  else if (n.compare("SelectNextPage", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectNextPage);
  else if (n.compare("SelectPreviousPage", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectPreviousPage);
  else if (n.compare("SelectStartOfLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectStartOfLine);
  else if (n.compare("SelectEndOfLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectEndOfLine);
  else if (n.compare("SelectStartOfBlock", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectStartOfBlock);
  else if (n.compare("SelectEndOfBlock", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectEndOfBlock);
  else if (n.compare("SelectStartOfDocument", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectStartOfDocument);
  else if (n.compare("SelectEndOfBlock", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectEndOfBlock);
  else if (n.compare("SelectStartOfDocument", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectStartOfDocument);
  else if (n.compare("SelectEndOfDocument", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectEndOfDocument);
  else if (n.compare("DeleteStartOfWord", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::DeleteStartOfWord);
  else if (n.compare("DeleteEndOfWord", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::DeleteEndOfWord);
  else if (n.compare("DeleteEndOfLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::DeleteEndOfLine);
  
  else ab->setShortcut(QKeySequence(n));  
}

Q7B Q7B_QABSTRACTBUTTON_KEY(Q7B qabstractbutton)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((QAbstractButton *) qabstractbutton->ref)->shortcut().toString() );
}

// *** QDECLARATIVEVIEW ***********************************************************************************

Q7B Q7B_QDECLARATIVEVIEW_INIT(QObject *parent, const char *objectName)
{
  /*
 #if QT_VERSION >= 0x040700
    QDeclarativeView* o = new QDeclarativeView( );
    o->setProperty("Parent", (qint64) parent);
    o->setObjectName(objectName);

    Q7B_connectSlotsByName((QObject *) o, parent);

    Q7B q (new Q7B_id(typeid(QDeclarativeView).name(), o, !parent->isWidgetType()));  
    return q;
 #else*/
    QWidget* o = new QWidget( parent->isWidgetType() ? (QWidget *) parent : 0 );
    o->setProperty("Parent", (qint64) parent);
    o->setObjectName(objectName);

    Q7B_connectSlotsByName((QObject *) o, parent);

    Q7B q (new Q7B_id(typeid(QWidget).name(), o, !parent->isWidgetType()));  
    return q;
 //#endif
}

// *** QDIAL ***********************************************************************************

Q7B Q7B_QDIAL_INIT(QObject *parent, const char *objectName)
{
  QDial* o = new QDial(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QDial).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QFONTCOMBOBOX ***********************************************************************************

Q7B Q7B_QFONTCOMBOBOX_INIT(QObject *parent, const char *objectName)
{
  QFontComboBox* o = new QFontComboBox( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QFontComboBox).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QFRAME ***********************************************************************************

Q7B Q7B_QFRAME_INIT(QObject *parent, const char *objectName)
{
  QFrame* o = new QFrame( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QFrame).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QTOOLBOX ***********************************************************************************

Q7B Q7B_QTOOLBOX_INIT(QObject *parent, const char *objectName)
{
  QToolBox* o = new QToolBox( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QToolBox).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QSCROLLAREA ***********************************************************************************

Q7B Q7B_QSCROLLAREA_INIT(QObject *parent, const char *objectName)
{
  QScrollArea* o = new QScrollArea(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QScrollArea).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QGROUPBOX ***********************************************************************************

Q7B Q7B_QGROUPBOX_INIT(QObject *parent, const char *objectName)
{
  QGroupBox* o = new QGroupBox(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QGroupBox).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QGROUPBOX_TEXT(Q7B qgroupbox, Q7B v)
{
  if (Q7B_nil(qgroupbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QGROUPBOX(qgroupbox))){ Q7B_EXCEPTION("QGroupBox expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((QGroupBox *) qgroupbox->ref)->setTitle( *((QString *) v->ref) );
}

Q7B Q7B_QGROUPBOX_TEXT(Q7B qgroupbox)
{
  if (Q7B_nil(qgroupbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QGROUPBOX(qgroupbox))){ Q7B_EXCEPTION("QGroupBox expected"); return Q7B_idnil; }

  return Q7B_ID( ((QGroupBox *) qgroupbox->ref)->title() );
}

void Q7B_QGROUPBOX_CAPTION(Q7B qgroupbox, Q7B v)
{
  if (Q7B_nil(qgroupbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QGROUPBOX(qgroupbox))){ Q7B_EXCEPTION("QGroupBox expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((QGroupBox *) qgroupbox->ref)->setTitle( *((QString *) v->ref) );
}

Q7B Q7B_QGROUPBOX_CAPTION(Q7B qgroupbox)
{
  if (Q7B_nil(qgroupbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QGROUPBOX(qgroupbox))){ Q7B_EXCEPTION("QGroupBox expected"); return Q7B_idnil; }

  return Q7B_ID( ((QGroupBox *) qgroupbox->ref)->title() );
}

// *** QLCDNUMBER ***********************************************************************************

Q7B Q7B_QLCDNUMBER_INIT(QObject *parent, const char *objectName)
{
  QLCDNumber* o = new QLCDNumber( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QLCDNumber).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QCALENDARWIDGET ***********************************************************************************

Q7B Q7B_QCALENDARWIDGET_INIT(QObject *parent, const char *objectName)
{
  QCalendarWidget* o = new QCalendarWidget(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QCalendarWidget).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QGRAPHICSVIEW ***********************************************************************************

Q7B Q7B_QGRAPHICSVIEW_INIT(QObject *parent, const char *objectName)
{
  QGraphicsView* o = new QGraphicsView(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QGraphicsView).name(), o, !parent->isWidgetType()));  
  return q;
}


// *** QTABLEWIDGET ***********************************************************************************

Q7B Q7B_QTABLEWIDGET_INIT(QObject *parent, const char *objectName)
{
  QTableWidget* o = new QTableWidget( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);  

  Q7B q (new Q7B_id(typeid(QTableWidget).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QTABLEWIDGET_CLEARCONTENTS(Q7B qtablewidget)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }

  ((QTableWidget *) qtablewidget->ref)->clearContents();
}

void Q7B_QTABLEWIDGET_SETHORIZONTALHEADERAUTORESIZE(Q7B qtablewidget)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }

  ((QTableWidget *) qtablewidget->ref)->horizontalHeader()->setResizeMode(QHeaderView::ResizeToContents);
  ((QTableWidget *) qtablewidget->ref)->setAlternatingRowColors(true); 
}

void Q7B_QTABLEWIDGET_ROWCOUNT(Q7B qtablewidget, Q7B v)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  ((QTableWidget *) qtablewidget->ref)->setRowCount( *((qint64 *) v->ref) );
}

Q7B Q7B_QTABLEWIDGET_ROWCOUNT(Q7B qtablewidget)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QTableWidget *) qtablewidget->ref)->rowCount() );
}

void Q7B_QTABLEWIDGET_COLUMNCOUNT(Q7B qtablewidget, Q7B v)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  ((QTableWidget *) qtablewidget->ref)->setColumnCount( *((qint64 *) v->ref) );
}

Q7B Q7B_QTABLEWIDGET_COLUMNCOUNT(Q7B qtablewidget)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QTableWidget *) qtablewidget->ref)->columnCount() );
}

Q7B Q7B_QTABLEWIDGET_CURRENTROW(Q7B qtablewidget)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_ID( ((QTableWidget *) qtablewidget->ref)->currentRow() );
}

void Q7B_QTABLEWIDGET_SORTITEMS(Q7B qtablewidget, Q7B Column)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTableWidget *) qtablewidget->ref)->sortItems( *((qint64 *) Column->ref), Qt::DescendingOrder );
  ((QTableWidget *) qtablewidget->ref)->setColumnHidden(0, true); // TODO2 und andere von qtablewidget   
}

void Q7B_QTABLEWIDGET_REMOVEROW(Q7B qtablewidget, Q7B Row)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTableWidget *) qtablewidget->ref)->removeRow( *((qint64 *) Row->ref) );
}

Q7B Q7B_QTABLEWIDGET_ITEMTEXT(Q7B qtablewidget, Q7B Row, Q7B Column)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  return Q7B_ID( twi->text() );
}

void Q7B_QTABLEWIDGET_SETCURRENTCELL(Q7B qtablewidget, Q7B Row, Q7B Column)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTableWidget *) qtablewidget->ref)->setFocus();
  ((QTableWidget *) qtablewidget->ref)->setCurrentCell( *((qint64 *) Row->ref), *((qint64 *) Column->ref));
}

void Q7B_QTABLEWIDGET_SETITEMFONTBOLD(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B Yes)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Yes))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  QFont f = twi->font();
  f.setBold( Q7B_IDbool(Yes) );
  twi->setFont( f );
}

void Q7B_QTABLEWIDGET_SETITEMTEXT(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B Text)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }
  
  ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem( Q7B_IDQString(Text) ) );
}

void Q7B_QTABLEWIDGET_SETITEMSTEXT(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B aList)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return; }
  
  int r = *((qint64 *) Row->ref);
  int c = *((qint64 *) Column->ref);

  for (int i = 0; i < ((Q7B_List *) aList->ref)->count(); i++){    
    ((QTableWidget *) qtablewidget->ref)->setItem( r, c + i, new QTableWidgetItem( Q7B_IDQString(((Q7B_List *) aList->ref)->getObject(i)) ) );
  }
}

Q7B Q7B_QTABLEWIDGET_ITEMSELECTED(Q7B qtablewidget, Q7B Row, Q7B Column)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  return Q7B_ID( twi->isSelected() );
}

void Q7B_QTABLEWIDGET_SETITEMSELECTED(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B Yes)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Yes))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  twi->setSelected( (Qt::ItemFlag) Q7B_IDbool(Yes) );
}

Q7B Q7B_QTABLEWIDGET_FINDITEMINCOLUMN(Q7B qtablewidget, Q7B Text, Q7B Column, Q7B StartRow, Q7B MatchFlags)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(StartRow))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(MatchFlags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QList<QTableWidgetItem *> l = ((QTableWidget *) qtablewidget->ref)->findItems( Q7B_IDQString(Text), (Qt::MatchFlags) Q7B_IDqint64(MatchFlags) );

  if (l.count()){
    for (int i = 0; i < l.count(); i++){
      QTableWidgetItem *twi = l.at(i);

      if (twi->column() == Q7B_IDqint64(Column) && twi->row() >= Q7B_IDqint64(StartRow)){
        return Q7B_ID( (qint64) twi->row() );
      }
    }
  }

  return Q7B_ID( (qint64) -1 );
}

Q7B Q7B_QTABLEWIDGET_FINDITEMINROW(Q7B qtablewidget, Q7B Text, Q7B Row, Q7B StartColumn, Q7B MatchFlags)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(StartColumn))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(MatchFlags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QList<QTableWidgetItem *> l = ((QTableWidget *) qtablewidget->ref)->findItems( Q7B_IDQString(Text), (Qt::MatchFlags) Q7B_IDqint64(MatchFlags) );

  if (l.count()){
    for (int i = 0; i < l.count(); i++){
      QTableWidgetItem *twi = l.at(i);

      if (twi->row() == Q7B_IDqint64(Row) && twi->column() >= Q7B_IDqint64(StartColumn)){
        return Q7B_ID( (qint64) twi->column() );
      }
    }
  }

  return Q7B_ID( (qint64) -1 );
}

Q7B Q7B_QTABLEWIDGET_ITEMCHECKSTATE(Q7B qtablewidget, Q7B Row, Q7B Column)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  return Q7B_ID( (qint64) twi->checkState() );
}

void Q7B_QTABLEWIDGET_SETITEMCHECKSTATE(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B CheckState)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(CheckState))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  twi->setCheckState( (Qt::CheckState) Q7B_IDqint64(CheckState) );
}

void Q7B_QTABLEWIDGET_SETITEMFLAGS(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B Flags)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Flags))){ Q7B_EXCEPTION("String expected"); return; }
  
  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  twi->setFlags( (Qt::ItemFlag) Q7B_IDqint64(Flags) );
}

// *** QCOLUMNVIEW ***********************************************************************************

Q7B Q7B_QCOLUMNVIEW_INIT(QObject *parent, const char *objectName)
{
  QColumnView* o = new QColumnView( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QColumnView).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QTABLEVIEW ***********************************************************************************

Q7B Q7B_QTABLEVIEW_INIT(QObject *parent, const char *objectName)
{
  QTableView* o = new QTableView( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QTableView).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QTABLEVIEW_SETCOLUMNWIDTH(Q7B qtableview, Q7B Column, Q7B Width)
{
  if (Q7B_nil(qtableview)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEVIEW(qtableview))){ Q7B_EXCEPTION("QTableView expected"); return; }

  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Width))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTableView *) qtableview->ref)->setColumnWidth( *((qint64 *) Column->ref), *((qint64 *) Width->ref) );
}
// *** QTREEVIEW ***********************************************************************************

Q7B Q7B_QTREEVIEW_INIT(QObject *parent, const char *objectName)
{
  QTreeView* o = new QTreeView( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QTreeView).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QLISTVIEW ***********************************************************************************

Q7B Q7B_QLISTVIEW_INIT(QObject *parent, const char *objectName)
{
  QListView* o = new QListView( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QListView).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QDIALOGBUTTONBOX ***********************************************************************************

Q7B Q7B_QDIALOGBUTTONBOX_INIT(QObject *parent, const char *objectName)
{
  QDialogButtonBox* o = new QDialogButtonBox( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QDialogButtonBox).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QVBOXLAYOUT ***********************************************************************************

Q7B Q7B_QVBOXLAYOUT_INIT(QObject *parent, const char *objectName)
{
  QVBoxLayout* o = new QVBoxLayout( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  //Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QVBoxLayout).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QHBOXLAYOUT ***********************************************************************************

Q7B Q7B_QHBOXLAYOUT_INIT(QObject *parent, const char *objectName)
{
  QHBoxLayout* o = new QHBoxLayout( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  //Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QHBoxLayout).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QGRIDLAYOUT ***********************************************************************************

Q7B Q7B_QGRIDLAYOUT_INIT(QObject *parent, const char *objectName)
{
  QGridLayout* o = new QGridLayout( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  //Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QGridLayout).name(), o, !parent->isWidgetType()));  
  return q;
}



// *** QFORMLAYOUT ***********************************************************************************

Q7B Q7B_QFORMLAYOUT_INIT(QObject *parent, const char *objectName)
{
  QFormLayout* o = new QFormLayout( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  //Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QFormLayout).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QWEBVIEW ***********************************************************************************

Q7B Q7B_QWEBVIEW_INIT(QObject *parent, const char *objectName)
{
  QWebView* o = new QWebView( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QWebView).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QWEBVIEW_LOAD(Q7B qwebview, Q7B URL)
{
  if (Q7B_nil(qwebview)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QWEBVIEW(qwebview))){ Q7B_EXCEPTION("QWebView expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(URL))){ Q7B_EXCEPTION("String expected"); return; }

  ((QWebView *) qwebview->ref)->load( QUrl(Q7B_IDQString(URL)) );
}

void Q7B_QWEBVIEW_SETHTML(Q7B qwebview, Q7B URL)
{
  if (Q7B_nil(qwebview)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QWEBVIEW(qwebview))){ Q7B_EXCEPTION("QWebView expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(URL))){ Q7B_EXCEPTION("String expected"); return; }

  ((QWebView *) qwebview->ref)->setHtml( Q7B_IDQString(URL) );
}


// *** QDIALOG ***********************************************************************************

Q7B Q7B_QDIALOG_INIT(QObject *parent, const char *objectName)
{
  QDialog *o = new QDialog( /*parent->isWidgetType() ? (QWidget *) parent : 0*/);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QDialog).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QDIALOG_ACCEPT(Q7B qdialog)
{
  if (Q7B_nil(qdialog)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QDIALOG(qdialog))){ Q7B_EXCEPTION("QDialog expected"); return; }

  ((QDialog *) qdialog->ref)->accept();
}

void Q7B_QDIALOG_REJECT(Q7B qdialog)
{
  if (Q7B_nil(qdialog)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QDIALOG(qdialog))){ Q7B_EXCEPTION("QDialog expected"); return; }

  ((QDialog *) qdialog->ref)->reject();
}


// *** QTOOLBOX ***********************************************************************************

void Q7B_QTOOLBOX_CURRENTINDEX(Q7B qtoolbox, Q7B v)
{
  if (Q7B_nil(qtoolbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QTOOLBOX(qtoolbox))){ Q7B_EXCEPTION("QToolBox expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QToolBox *) qtoolbox->ref)->setCurrentIndex( Q7B_IDqint64(v) );
}

Q7B Q7B_QTOOLBOX_CURRENTINDEX(Q7B qtoolbox)
{
  if (Q7B_nil(qtoolbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QTOOLBOX(qtoolbox))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  return Q7B_ID( ((QToolBox *) qtoolbox->ref)->currentIndex() );
}


// *** QTABWIDGET ***********************************************************************************

Q7B Q7B_QTABWIDGET_INIT(QObject *parent, const char *objectName)
{
  QTabWidget* o = new QTabWidget( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QTabWidget).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QTABWIDGET_CURRENTINDEX(Q7B qtabwidget, Q7B v)
{
  if (Q7B_nil(qtabwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QTABWIDGET(qtabwidget))){ Q7B_EXCEPTION("QTabWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTabWidget *) qtabwidget->ref)->setCurrentIndex( Q7B_IDqint64(v) );
}

Q7B Q7B_QTABWIDGET_CURRENTINDEX(Q7B qtabwidget)
{
  if (Q7B_nil(qtabwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QTABWIDGET(qtabwidget))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QTabWidget *) qtabwidget->ref)->currentIndex() );
}

Q7B Q7B_QTABWIDGET_COUNT(Q7B qtabwidget)
{
  if (Q7B_nil(qtabwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QTABWIDGET(qtabwidget))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QTabWidget *) qtabwidget->ref)->count() );
}

Q7B Q7B_QTABWIDGET_WIDGET(Q7B qtabwidget, Q7B Index)
{
  if (Q7B_nil(qtabwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QTABWIDGET(qtabwidget))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QTabWidget *) qtabwidget->ref)->widget( Q7B_IDqint64(Index) ) );
}


// *** QSTACKEDWIDGET ***********************************************************************************

Q7B Q7B_QSTACKEDWIDGET_INIT(QObject *parent, const char *objectName)
{
  QStackedWidget* o = new QStackedWidget( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QStackedWidget).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QSTACKEDWIDGET_CURRENTINDEX(Q7B qstackedwidget, Q7B v)
{
  if (Q7B_nil(qstackedwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QSTACKEDWIDGET(qstackedwidget))){ Q7B_EXCEPTION("QStackWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QStackedWidget *) qstackedwidget->ref)->setCurrentIndex( Q7B_IDqint64(v) );
}

Q7B Q7B_QSTACKEDWIDGET_CURRENTINDEX(Q7B qstackedwidget)
{
  if (Q7B_nil(qstackedwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QSTACKEDWIDGET(qstackedwidget))){ Q7B_EXCEPTION("QStackWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QStackedWidget *) qstackedwidget->ref)->currentIndex() );
}


// *** QMAINWINDOW ***********************************************************************************

Q7B Q7B_QMAINWINDOW_INIT(QObject *parent, const char *objectName)
{
  QMainWindow *o = new QMainWindow( /*parent->isWidgetType() ? (QWidget *) parent : 0*/);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QMainWindow).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QCOMMANDLINKBUTTON ***********************************************************************************

Q7B Q7B_QCOMMANDLINKBUTTON_INIT(QObject *parent, const char *objectName)
{
  QCommandLinkButton *o = new QCommandLinkButton( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QCommandLinkButton).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QCOMMANDLINKBUTTON_DESCRIPTION(Q7B qcommandlinkbutton, Q7B v)
{
  if (Q7B_nil(qcommandlinkbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QCOMMANDLINKBUTTON(qcommandlinkbutton))){ Q7B_EXCEPTION("QCommandLinkButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((QCommandLinkButton *) qcommandlinkbutton->ref)->setDescription( *((QString *) v->ref) );
}

Q7B Q7B_QCOMMANDLINKBUTTON_DESCRIPTION(Q7B qcommandlinkbutton)
{
  if (Q7B_nil(qcommandlinkbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCOMMANDLINKBUTTON(qcommandlinkbutton))){ Q7B_EXCEPTION("QCommandLinkButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((QCommandLinkButton *) qcommandlinkbutton->ref)->description() );
}

// *** QCHECKBOX ***********************************************************************************

Q7B Q7B_QCHECKBOX_INIT(QObject *parent, const char *objectName)
{
  QCheckBox *o = new QCheckBox(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QCheckBox).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QRADIOBUTTON ***********************************************************************************

Q7B Q7B_QRADIOBUTTON_INIT(QObject *parent, const char *objectName)
{
  QRadioButton *o = new QRadioButton( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QRadioButton).name(), o, !parent->isWidgetType()));  
  return q;
}


// *** QPUSHBUTTON ***********************************************************************************

Q7B Q7B_QPUSHBUTTON_INIT(QObject *parent, const char *objectName)
{
  QPushButton *o = new QPushButton(parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QPushButton).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QPUSHBUTTON_MENU(Q7B qpushbutton, Q7B v)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return; }
  if (Q7B_nil(Q7B_QMENU(v))){ Q7B_EXCEPTION("QMenu expected"); return; }

  ((QPushButton *) qpushbutton->ref)->setMenu( ((QMenu *) v->ref) );
}

Q7B Q7B_QPUSHBUTTON_MENU(Q7B qpushbutton)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((QPushButton *) qpushbutton->ref)->menu() );
}

void Q7B_QPUSHBUTTON_AUTODEFAULT(Q7B qpushbutton, Q7B v)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QPushButton *) qpushbutton->ref)->setAutoDefault( ((bool *) v->ref) );
}

Q7B Q7B_QPUSHBUTTON_AUTODEFAULT(Q7B qpushbutton)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((QPushButton *) qpushbutton->ref)->autoDefault() );
}

void Q7B_QPUSHBUTTON_DEFAULT(Q7B qpushbutton, Q7B v)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QPushButton *) qpushbutton->ref)->setDefault( ((bool *) v->ref) );
}

Q7B Q7B_QPUSHBUTTON_DEFAULT(Q7B qpushbutton)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((QPushButton *) qpushbutton->ref)->isDefault() );
}

void Q7B_QPUSHBUTTON_FLAT(Q7B qpushbutton, Q7B v)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QPushButton *) qpushbutton->ref)->setFlat( ((bool *) v->ref) );
}

Q7B Q7B_QPUSHBUTTON_FLAT(Q7B qpushbutton)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((QPushButton *) qpushbutton->ref)->isFlat() );
}

// *** QOBJECT ***********************************************************************************

Q7B Q7B_QOBJECT_INIT(QObject *parent, const char *objectName)
{
  QObject *o = new QObject( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QObject).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QOBJECT_OBJECTNAME(Q7B qobject, Q7B v)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_ID(qobject))){ Q7B_EXCEPTION("QObject expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((QObject *) qobject->ref)->setObjectName( Q7B_IDQString(v) );
}

Q7B Q7B_QOBJECT_OBJECTNAME(Q7B qobject)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_ID(qobject))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }

  return Q7B_ID( ((QObject *) qobject->ref)->objectName() );
}

Q7B Q7B_QOBJECT_SENDER(Q7B qobject)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_ID(qobject))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_QObject *) qobject->ref)->Sender() ); // fake QObject into Q7B_QObject to gain access to protected function sender of QObject
}

Q7B Q7B_QOBJECT_CHILD(Q7B qobject, Q7B Q7B_ObjectName)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_ID(qobject))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Q7B_ObjectName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s = *((QString *) Q7B_ObjectName->ref);

  QObjectList ol = ((QObject *) qobject->ref)->children();

  for (int q = 0; q < ol.size(); q++){
     // QMessageBox::information(0, "QWIDGET_CHILD22", ol.at(q)->objectName());

      if (ol.at(q)->objectName() == s){

   //   QMessageBox::information(0, "QWIDGET_CHILD", "");
        Q7B qq = Q7B_ID( (QObject *) ol.at(q) ) ;
        qq->gc_enabled = false;
        return qq;
      }    
  }

  return Q7B_idnil;

//  return Q7B_ID( (QWidget *) (((QObject *) qwidget->ref)->findChild( s ) ));
}

Q7B Q7B_QOBJECT_CHILDREN(Q7B qobject)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_ID(qobject))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }

  QObjectList ol = ((QObject *) qobject->ref)->children();

  Q7B_List *a = new Q7B_List();
  Q7B qq (new Q7B_id(typeid(Q7B_List).name(), a)); 

  for (int i = 0; i < ol.size(); i++){     

  //  QMessageBox::information(0, "Q7B_QOBJECT_CHILDREN", ol.at(i)->objectName());

    Q7B q (new Q7B_id(typeid(QObject).name(), ol.at(i), false )); 
    a->me << q;    
    
  }

  return qq;
}

Q7B Q7B_Variant2id(QVariant v, bool bSQL, bool bSQLQByteArrayEncodeBase64)
{
  if (v.isValid()){
    switch(v.type()){
      case QVariant::String:
        return Q7B_ID( v.toString() );
        break;
      case QVariant::Int:
      case QVariant::LongLong:
      case QVariant::UInt:
      case QVariant::ULongLong:
        return Q7B_ID( v.toLongLong() );
        break;      
      case QVariant::Double:
        return Q7B_ID( v.toDouble() );
        break;
      case QVariant::DateTime:
        return Q7B_ID( v.toDateTime() );
        break;
      case QVariant::Bool:
        return Q7B_ID( v.toBool() );
        break;

        // TODO2 qint64 type, qbytearray mit wegschreiben ??????
      case QVariant::ByteArray:
        {
          QByteArray ba = bSQLQByteArrayEncodeBase64 ? QByteArray::fromBase64(v.toByteArray()) : v.toByteArray();

          if (bSQL){
            int n = ba.indexOf((char ) 0);
            if (n >= 0){
              QByteArray bba = ba.left(n);
              QString s(bba);
              ba = ba.mid(n);
              if (s == "QIcon"){
                return Q7B_ID(Q7B_QByteArray2QIcon(ba));
              }
              
            }
          }

          return Q7B_ID( ba );
        }
        break;      

      default:
        //return Q7B_ID( v.toLongLong() );

      //  return Q7B_ID( v.toLongLong() );
        break;
    }
  }

  return Q7B_idnil;
}

QVariant Q7B_id2Variant(Q7B Q7B_Object, bool bSQL, bool bSQLQByteArrayEncodeBase64)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return QVariant(); }  

  // TODO2 test for if qobject child class ?????????
  // TODO2 List,Data, Dictionary, decimal, qsize, qrect...

  if (Q7B_Object->type == typeid(qint64).name()){
    return QVariant( *((qint64 *) Q7B_Object->ref) );

  } else if (Q7B_Object->type == typeid(qreal).name()){
    return QVariant( *((qreal *) Q7B_Object->ref) );

  } else if (Q7B_Object->type == typeid(bool).name()){
    return QVariant( *((bool *) Q7B_Object->ref) );

  } else if (Q7B_Object->type == typeid(QDateTime).name()){
    return QVariant( *((QDateTime *) Q7B_Object->ref) );

  } else if (Q7B_Object->type == typeid(QString).name()){    
    return QVariant( *((QString *) Q7B_Object->ref) );

  } else if (Q7B_Object->type == typeid(QByteArray).name()){    
    QByteArray ba = *((QByteArray *) Q7B_Object->ref);

    if (bSQL) ba.prepend("QByteArray");        
    return QVariant( bSQLQByteArrayEncodeBase64 ? ba.toBase64() : ba );

  } else if (Q7B_Object->type == typeid(QIcon).name()){ 
    QByteArray ba = Q7B_QIcon2QByteArray(*((QIcon *) Q7B_Object->ref));

    if (bSQL) ba.prepend("QIcon");            
    return QVariant( bSQLQByteArrayEncodeBase64 ? ba.toBase64() : ba );
  }

  return QVariant();  
}

void Q7B_PROPERTY(Q7B qobject, Q7B PropertyName, Q7B Q7B_Object)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  QVariant v = Q7B_id2Variant(Q7B_Object, false, false);
  if (qobject->isQObjectBased()){
    ((QObject *) qobject->ref)->setProperty(((QString *)PropertyName->ref)->toAscii().constData(), v);
  } else {
    qobject->setProperty(*((QString *)PropertyName->ref), v);
  }
}

Q7B Q7B_PROPERTY(Q7B qobject, Q7B PropertyName)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  QVariant v;
  if (qobject->isQObjectBased()){
    v = ((QObject *) qobject->ref)->property(((QString *)PropertyName->ref)->toAscii().constData());
  } else {
    v = qobject->property(*((QString *)PropertyName->ref));
  }
  if (v.isNull()){
    return Q7B_idnil; 
  }
  return Q7B_Variant2id(v, false, false);

}

// *** LIST ***********************************************************************************

// wird keine init function ben?tigt

void Q7B_LIST_REMOVEALL(Q7B aList)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return; }

  ((Q7B_List *) aList->ref)->removeAll();
}

Q7B Q7B_LIST_TOQSTRINGLIST(Q7B aList)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }

  QStringList *ll = new QStringList();
  *ll << ((Q7B_List *) aList->ref)->toStringList();
  Q7B q (new Q7B_id(typeid(QStringList).name(), ll));
  return q;
}

void Q7B_LIST_FROMQSTRINGLIST(Q7B aList, Q7B qstringlist)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return; }
  if (Q7B_nil(Q7B_QSTRINGLIST(qstringlist))){ Q7B_EXCEPTION("QStringList expected"); return; }

  ((Q7B_List *) aList->ref)->removeAll();

  QStringList ll = *((QStringList *) qstringlist->ref);

    for (int i = 0; i < ll.size(); i++)
    {
      Q7B q (new Q7B_id(typeid(QString).name(), new QString( ll.at(i) ))); 
      ((Q7B_List *) aList->ref)->me << q;
    }
}

Q7B Q7B_LIST_LENGTH(Q7B aList)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_List *) aList->ref)->count() );
}

Q7B Q7B_LIST_OBJECT(Q7B aList, Q7B Index)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_List *) aList->ref)->getObject( *((qint64 *) Index->ref) ) );
}

void Q7B_LIST_INSERT(Q7B aList, Q7B Index, Q7B Q7B_Object)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_List *) aList->ref)->insert( Q7B_Object, *((qint64 *) Index->ref) );
}

void Q7B_LIST_SETOBJECT(Q7B aList, Q7B Index, Q7B Q7B_Object)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_List *) aList->ref)->replace( Q7B_Object, *((qint64 *) Index->ref) );
}

void Q7B_LIST_REMOVE(Q7B aList, Q7B Index)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_List *) aList->ref)->remove( *((qint64 *) Index->ref) );
}

void Q7B_LIST_APPEND(Q7B aList, Q7B Q7B_Object)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return; }

  ((Q7B_List *) aList->ref)->append(Q7B_Object);
}

// *** DICTIONARY ***********************************************************************************

// wird keine init function ben?tigt

Q7B Q7B_DICTIONARY_LENGTH(Q7B aDictionary)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Dictionary *) aDictionary->ref)->count() );
}

void Q7B_DICTIONARY_REMOVEALL(Q7B aDictionary)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return; }

  ((Q7B_Dictionary *) aDictionary->ref)->removeAll();
}

Q7B Q7B_DICTIONARY_KEYS(Q7B aDictionary)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Dictionary *) aDictionary->ref)->keys() );
}

Q7B Q7B_DICTIONARY_VALUES(Q7B aDictionary)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Dictionary *) aDictionary->ref)->values() );
}

void Q7B_DICTIONARY_REMOVE(Q7B aDictionary, Q7B Key)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Key))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_Dictionary *) aDictionary->ref)->remove( Q7B_IDQString(Key) );
}

Q7B Q7B_DICTIONARY_CONTAINS(Q7B aDictionary, Q7B Key)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Key))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Dictionary *) aDictionary->ref)->contains( Q7B_IDQString(Key) ) );
}

Q7B Q7B_DICTIONARY_OBJECT(Q7B aDictionary, Q7B Key)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Key))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Dictionary *) aDictionary->ref)->getObject( Q7B_IDQString(Key) ) );
}

void Q7B_DICTIONARY_SETOBJECT(Q7B aDictionary, Q7B Key, Q7B Value)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Key))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_Dictionary *) aDictionary->ref)->setObject( Q7B_IDQString(Key), Value );
}

// *** QWIDGET ***********************************************************************************

Q7B Q7B_QWIDGET_INIT(QObject *parent, const char *objectName)
{
  QWidget *o = new QWidget( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QWidget).name(), o, !parent->isWidgetType()));  
  return q;
}

Q7B Q7B_QWIDGET_WIDGET(Q7B qobject, Q7B Q7B_ObjectName)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_ID(qobject))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Q7B_ObjectName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s = *((QString *) Q7B_ObjectName->ref);

  QObjectList ol = ((QObject *) qobject->ref)->children();

  for (int q = 0; q < ol.size(); q++){
     // QMessageBox::information(0, "QWIDGET_CHILD22", ol.at(q)->objectName());

      if (ol.at(q)->objectName() == s){

   //   QMessageBox::information(0, "QWIDGET_CHILD", "");
      // TODO2 folgendes m?sste f?r alle sub classes von qwidget gemacht werden
      QString sClass =  ol.at(q)->metaObject()->className();
      if (sClass == "QTabWidget"){
        return Q7B_ID((QTabWidget *) ol.at(q) );
      }
      return Q7B_ID((QWidget *) ol.at(q));
    }
  }

  return Q7B_idnil;

//  return Q7B_ID( (QWidget *) (((QObject *) qwidget->ref)->findChild( s ) ));
}

void Q7B_QWIDGET_SHOWMAXIMIZED(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) qwidget->ref)->showMaximized();
}

void Q7B_QWIDGET_SHOWFULLSCREEN(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) qwidget->ref)->showFullScreen();
}

void Q7B_QWIDGET_SHOWMINIMIZED(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) qwidget->ref)->showMinimized();
}

void Q7B_QWIDGET_TOGGLEVISIBLE(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  QWidget *w = ((QWidget *) qwidget->ref);
  w->setVisible(!w->isVisible());
}

void Q7B_QWIDGET_SETATTRIBUTE(Q7B qwidget, Q7B Attribute, Q7B On)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Attribute))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(On))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QWidget *) qwidget->ref)->setAttribute( (Qt::WidgetAttribute) *((qint64 *) Attribute->ref), *((bool *) On->ref));
}


void Q7B_QWIDGET_SETPARENT(Q7B qwidget, Q7B w)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_QWIDGET(w))){ 
   // Q7B_EXCEPTION("QWidget expected"); return; 
 
   // QMessageBox::information(0, "setParent", "0");

    ((QWidget *) qwidget->ref)->setParent(0);
    return;
  }

  ((QWidget *) qwidget->ref)->setParent( ((QWidget *) w->ref));
}

void Q7B_QWIDGET_SHOWNORMAL(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) qwidget->ref)->showNormal();
}

void Q7B_QWIDGET_SHOW(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) qwidget->ref)->show();
}

void Q7B_QWIDGET_HIDE(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) qwidget->ref)->hide();
}

void Q7B_QWIDGET_ENABLED(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QWidget *) qwidget->ref)->setEnabled( *((bool *) v->ref) );
}

Q7B Q7B_QWIDGET_ACTIONS(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

  QList<QAction *> l = ((QWidget *) qwidget->ref)->actions();

 // QMessageBox::information(0, "Q7B_QWIDGET_ACTIONS", QString("%1").arg(l.count()));

  for (int i = 0; i < l.size(); i++){
     a->append( Q7B_ID( l.at(i) ) );
  }

//  QMessageBox::information(0, "222Q7B_QWIDGET_ACTIONS", QString("%1").arg(l.count()));

  return q;
}

Q7B Q7B_QWIDGET_ENABLED(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QWidget *) qwidget->ref)->isEnabled() );
}

void Q7B_QWIDGET_VISIBLE(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QWidget *) qwidget->ref)->setVisible( *((bool *) v->ref) );
}
/*
Q7B QWIDGET_REPLACEWIDGET(Q7B qwidget, Q7B Old, Q7B New)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_QWIDGET(Old))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_QWIDGET(New))){ Q7B_EXCEPTION("QWidget expected"); return; }
  layout
  int n = ((QWidget *) qwidget->ref)->indexOf( ((QWidget *) Old->ref) );
  if (n != 1){
    ((QWidget *) qwidget->ref)->removeWidget( ((QWidget *) Old->ref) );
    ((QWidget *) qwidget->ref)->insertWidget( ((QWidget *) New->ref) );
  }

  return Q7B_ID( false );  
}*/


Q7B Q7B_QWIDGET_VISIBLE(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QWidget *) qwidget->ref)->isVisible() );
}
/*
void QWIDGET_LAYOUT(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(QLAYOUT(v))){ Q7B_EXCEPTION("QLayout expected"); return; }
  
  ((QWidget *) qwidget->ref)->setLayout( ((QLayout *) v->ref) );
}

Q7B QWIDGET_LAYOUT(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }
  return Q7B_ID( ((QWidget *) qwidget->ref)->layout() );
}*/

void Q7B_QWIDGET_MINIMUMWIDTH(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  ((QWidget *) qwidget->ref)->setMinimumWidth( *((qint64 *) v->ref) );
}

Q7B Q7B_QWIDGET_MINIMUMWIDTH(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }
  return Q7B_ID( ((QWidget *) qwidget->ref)->minimumWidth() );
}

void Q7B_QWIDGET_MAXIMUMWIDTH(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  ((QWidget *) qwidget->ref)->setMaximumWidth( *((qint64 *) v->ref) );
}

Q7B Q7B_QWIDGET_MAXIMUMWIDTH(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QWidget *) qwidget->ref)->maximumWidth() );
}

void Q7B_QWIDGET_WINDOWTITLE(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }
  
  ((QWidget *) qwidget->ref)->setWindowTitle( *((QString *) v->ref) );
}

Q7B Q7B_QWIDGET_WINDOWTITLE(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QWidget *) qwidget->ref)->windowTitle() );
}

void Q7B_QWIDGET_WINDOWICON(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_QICON(v))){ Q7B_EXCEPTION("QIcon expected"); return; }
  
  ((QWidget *) qwidget->ref)->setWindowIcon( *((QIcon *) v->ref) );
}

Q7B Q7B_QWIDGET_WINDOWICON(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QWidget *) qwidget->ref)->windowIcon() );
}

void Q7B_QWIDGET_WINDOWFLAGS(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  ((QWidget *) qwidget->ref)->setWindowFlags( (Qt::WindowFlags) *((qint64 *) v->ref) );
}

Q7B Q7B_QWIDGET_WINDOWFLAGS(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QWidget *) qwidget->ref)->windowFlags() );
}

void Q7B_QWIDGET_CONTEXTMENUPOLICY(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  ((QWidget *) qwidget->ref)->setContextMenuPolicy( (Qt::ContextMenuPolicy) *((qint64 *) v->ref) );
}

Q7B Q7B_QWIDGET_CONTEXTMENUPOLICY(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QWidget *) qwidget->ref)->contextMenuPolicy() );
}
// *** QICON ***********************************************************************************

Q7B Q7B_QICON_INIT(QObject *parent, const char *objectName, Q7B v)
{
  if (v->type == typeid(QString).name()){
    return Q7B_ID( QIcon(*((QString *) v->ref)) );

  } else if (v->type == typeid(QByteArray).name()){
    return Q7B_ID( Q7B_QByteArray2QIcon(*((QByteArray *) v->ref)) );
  } else if (v->type == typeid(QIcon).name()){
    return Q7B_ID( QIcon(*((QIcon *) v->ref)) );
  } else {
    return Q7B_idnil; // TODO2 exception here
  }
}
// *** QDOUBLESPINBOX ***********************************************************************************

Q7B Q7B_QDOUBLESPINBOX_INIT(QObject *parent, const char *objectName)
{
  QDoubleSpinBox* o = new QDoubleSpinBox(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QDoubleSpinBox).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QDOUBLESPINBOX_MINIMUM(Q7B qdoublespinbox, Q7B Value)
{
  if (Q7B_nil(qdoublespinbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QDOUBLESPINBOX(qdoublespinbox))){ Q7B_EXCEPTION("QDoubleSpinBox expected"); return; }
  if (Q7B_nil(Q7B_FLOAT(Value))){ Q7B_EXCEPTION("Float expected"); return; }

  ((QDoubleSpinBox *) qdoublespinbox->ref)->setMinimum( *((qreal *) Value->ref) );
}

Q7B Q7B_QDOUBLESPINBOX_MINIMUM(Q7B qdoublespinbox)
{
  if (Q7B_nil(qdoublespinbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDOUBLESPINBOX(qdoublespinbox))){ Q7B_EXCEPTION("QDoubleSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDoubleSpinBox *) qdoublespinbox->ref)->minimum() );
}

void Q7B_QDOUBLESPINBOX_MAXIMUM(Q7B qdoublespinbox, Q7B Value)
{
  if (Q7B_nil(qdoublespinbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QDOUBLESPINBOX(qdoublespinbox))){ Q7B_EXCEPTION("QDoubleSpinBox expected"); return; }
  if (Q7B_nil(Q7B_FLOAT(Value))){ Q7B_EXCEPTION("Float expected"); return; }

  ((QDoubleSpinBox *) qdoublespinbox->ref)->setMaximum( *((qreal *) Value->ref) );
}

Q7B Q7B_QDOUBLESPINBOX_MAXIMUM(Q7B qdoublespinbox)
{
  if (Q7B_nil(qdoublespinbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDOUBLESPINBOX(qdoublespinbox))){ Q7B_EXCEPTION("QDoubleSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDoubleSpinBox *) qdoublespinbox->ref)->maximum() );
}

void Q7B_QDOUBLESPINBOX_VALUE(Q7B qdoublespinbox, Q7B Value)
{
  if (Q7B_nil(qdoublespinbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QDOUBLESPINBOX(qdoublespinbox))){ Q7B_EXCEPTION("QDoubleSpinBox expected"); return; }
  if (Q7B_nil(Q7B_FLOAT(Value))){ Q7B_EXCEPTION("Float expected"); return; }

  ((QDoubleSpinBox *) qdoublespinbox->ref)->setValue( *((qreal *) Value->ref) );
}

Q7B Q7B_QDOUBLESPINBOX_VALUE(Q7B qdoublespinbox)
{
  if (Q7B_nil(qdoublespinbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDOUBLESPINBOX(qdoublespinbox))){ Q7B_EXCEPTION("QDoubleSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDoubleSpinBox *) qdoublespinbox->ref)->value() );
}

// *** QTEXTBROWSER ***********************************************************************************

Q7B Q7B_QTEXTBROWSER_INIT(QObject *parent, const char *objectName)
{
  QTextBrowser* o = new QTextBrowser( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QTextBrowser).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QSLIDER ***********************************************************************************

Q7B Q7B_QSLIDER_INIT(QObject *parent, const char *objectName)
{
  QSlider* o = new QSlider(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QSlider).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QSCROLLBAR ***********************************************************************************

Q7B Q7B_QSCROLLBAR_INIT(QObject *parent, const char *objectName)
{
  QScrollBar* o = new QScrollBar(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QScrollBar).name(), o, !parent->isWidgetType()));  
  return q;
}


// *** QDATEEDIT ***********************************************************************************

Q7B Q7B_QDATEEDIT_INIT(QObject *parent, const char *objectName)
{
  QDateEdit* o = new QDateEdit(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QDateEdit).name(), o, !parent->isWidgetType()));  
  return q;
}


// *** QTIMEEDIT ***********************************************************************************

Q7B Q7B_QTIMEEDIT_INIT(QObject *parent, const char *objectName)
{
  QTimeEdit* o = new QTimeEdit( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QTimeEdit).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** PHONONVOLUMESLIDER ***********************************************************************************

Q7B Q7B_PHONONVOLUMESLIDER_INIT(QObject *parent, const char *objectName)
{  
  Phonon::VolumeSlider* o = new Phonon::VolumeSlider(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Phonon::VolumeSlider).name(), o, !parent->isWidgetType()));  
  return q; 
}

// *** PHONONSEEKSLIDER ***********************************************************************************

Q7B Q7B_PHONONSEEKSLIDER_INIT(QObject *parent, const char *objectName)
{
  Phonon::SeekSlider* o = new Phonon::SeekSlider(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Phonon::SeekSlider).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** PHONONVIDEOPLAYER ***********************************************************************************

Q7B Q7B_PHONONVIDEOPLAYER_INIT(QObject *parent, const char *objectName)
{
  Phonon::VideoPlayer* o = new Phonon::VideoPlayer( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Phonon::VideoPlayer).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_PHONONVIDEOPLAYER_PLAY(Q7B phononvideoplayer, Q7B Value)
{
  if (Q7B_nil(phononvideoplayer)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_PHONONVIDEOPLAYER(phononvideoplayer))){ Q7B_EXCEPTION("PhononVideoPlayer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  static Phonon::MediaSource ms;
  ms = Phonon::MediaSource( Q7B_IDQString(Value) );
  ((Phonon::VideoPlayer *) phononvideoplayer->ref)->play( ms );  
}

// *** QSPINBOX ***********************************************************************************

Q7B Q7B_QSPINBOX_INIT(QObject *parent, const char *objectName)
{
  QSpinBox* o = new QSpinBox(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QSpinBox).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QSPINBOX_MINIMUM(Q7B qspinbox, Q7B Value)
{
  if (Q7B_nil(qspinbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSPINBOX(qspinbox))){ Q7B_EXCEPTION("QSpinBox expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QSpinBox *) qspinbox->ref)->setMinimum( *((qint64 *) Value->ref) );
}

Q7B Q7B_QSPINBOX_MINIMUM(Q7B qspinbox)
{
  if (Q7B_nil(qspinbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSPINBOX(qspinbox))){ Q7B_EXCEPTION("QSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( ((QSpinBox *) qspinbox->ref)->minimum() );
}

void Q7B_QSPINBOX_MAXIMUM(Q7B qspinbox, Q7B Value)
{
  if (Q7B_nil(qspinbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSPINBOX(qspinbox))){ Q7B_EXCEPTION("QSpinBox expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QSpinBox *) qspinbox->ref)->setMaximum( *((qint64 *) Value->ref) );
}

Q7B Q7B_QSPINBOX_MAXIMUM(Q7B qspinbox)
{
  if (Q7B_nil(qspinbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSPINBOX(qspinbox))){ Q7B_EXCEPTION("QSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( ((QSpinBox *) qspinbox->ref)->maximum() );
}

void Q7B_QSPINBOX_VALUE(Q7B qspinbox, Q7B Value)
{
  if (Q7B_nil(qspinbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSPINBOX(qspinbox))){ Q7B_EXCEPTION("QSpinBox expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QSpinBox *) qspinbox->ref)->setValue( *((qint64 *) Value->ref) );
}

Q7B Q7B_QSPINBOX_VALUE(Q7B qspinbox)
{
  if (Q7B_nil(qspinbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSPINBOX(qspinbox))){ Q7B_EXCEPTION("QSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( ((QSpinBox *) qspinbox->ref)->value() );
}

// *** QPROGRESSBAR ***********************************************************************************
/*
void Q7B_QPROGRESSBAR_CONNECT_SLOTS(QObject *parent, QProgressBar* o, QString sName)
{
  QString s;
  
  // Be careful! Don't use whitespaces here.
  //s = QString("1on_") + sName + "_" + "subWindowActivated(QAction*)"; if (parent->metaObject()->indexOfSlot(s.mid(1).toAscii()) != -1) QObject::connect(o, SIGNAL(triggered(QAction *)), parent, s.toAscii());  
  //s = QString("1on_") + sName + "_" + "aboutToShow()"; if (parent->metaObject()->indexOfSlot(s.mid(1).toAscii()) != -1) QObject::connect(o, SIGNAL(aboutToShow()), parent, s.toAscii());    
}*/

Q7B Q7B_QPROGRESSBAR_INIT(QObject *parent, const char *objectName)
{
  QProgressBar* o;
  if (parent){
   o = new QProgressBar(parent->isWidgetType() ? (QWidget *) parent : 0 );
  } else {
   o = new QProgressBar( );
  }
  
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  if (parent) Q7B_connectSlotsByName((QObject *) o, parent);
  //Q7B_QPROGRESSBAR_CONNECT_SLOTS(parent, o, objectName);

  Q7B q (new Q7B_id(typeid(QProgressBar).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QPROGRESSBAR_MINIMUM(Q7B qprogressbar, Q7B Value)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QProgressBar *) qprogressbar->ref)->setMinimum( *((qint64 *) Value->ref) );
}

Q7B Q7B_QPROGRESSBAR_MINIMUM(Q7B qprogressbar)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_ID( ((QProgressBar *) qprogressbar->ref)->minimum() );
}

void Q7B_QPROGRESSBAR_MAXIMUM(Q7B qprogressbar, Q7B Value)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QProgressBar *) qprogressbar->ref)->setMaximum( *((qint64 *) Value->ref) );
}

Q7B Q7B_QPROGRESSBAR_MAXIMUM(Q7B qprogressbar)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_ID( ((QProgressBar *) qprogressbar->ref)->maximum() );
}

void Q7B_QPROGRESSBAR_VALUE(Q7B qprogressbar, Q7B Value)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QProgressBar *) qprogressbar->ref)->setValue( *((qint64 *) Value->ref) );
}

Q7B Q7B_QPROGRESSBAR_VALUE(Q7B qprogressbar)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_ID( ((QProgressBar *) qprogressbar->ref)->value() );
}

void Q7B_QPROGRESSBAR_TEXTVISIBLE(Q7B qprogressbar, Q7B v)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QProgressBar *) qprogressbar->ref)->setTextVisible( *((bool *) v->ref) );
}

Q7B Q7B_QPROGRESSBAR_TEXTVISIBLE(Q7B qprogressbar)
{  
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_ID( ((QProgressBar *) qprogressbar->ref)->isTextVisible() );
}

// *** QMDIAREA ***********************************************************************************
/*
void Q7B_QMDIAREA_CONNECT_SLOTS(QObject *parent, QMdiArea* o, QString sName)
{
  QString s;
  
  // Be careful! Don't use whitespaces here.
  //s = QString("1on_") + sName + "_" + "subWindowActivated(QAction*)"; if (parent->metaObject()->indexOfSlot(s.mid(1).toAscii()) != -1) QObject::connect(o, SIGNAL(triggered(QAction *)), parent, s.toAscii());  
  //s = QString("1on_") + sName + "_" + "aboutToShow()"; if (parent->metaObject()->indexOfSlot(s.mid(1).toAscii()) != -1) QObject::connect(o, SIGNAL(aboutToShow()), parent, s.toAscii());    
}*/

Q7B Q7B_QMDIAREA_INIT(QObject *parent, const char *objectName)
{
  QMdiArea* o = new QMdiArea( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  //Q7B_QMDIAREA_CONNECT_SLOTS(parent, o, objectName);

  Q7B q (new Q7B_id(typeid(QMdiArea).name(), o, !parent->isWidgetType()));  
  return q;
}

void Q7B_QMDIAREA_ADDSUBWINDOW(Q7B qmdiarea, Q7B Widget)
{
  if (Q7B_nil(qmdiarea)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QMDIAREA(qmdiarea))){ Q7B_EXCEPTION("QMdiArea expected"); return; }
  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  
 QMdiSubWindow  *sw = ((QMdiArea *) qmdiarea->ref)->addSubWindow( ((QWidget *) Widget->ref) );    
 sw->showNormal();

}

void Q7B_QMDIAREA_VIEWMODE(Q7B qmdiarea, Q7B Value)
{
  if (Q7B_nil(qmdiarea)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QMDIAREA(qmdiarea))){ Q7B_EXCEPTION("QMdiArea expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QMdiArea *) qmdiarea->ref)->setViewMode( (QMdiArea::ViewMode) *((qint64 *) Value->ref) );
}

Q7B Q7B_QMDIAREA_VIEWMODE(Q7B qmdiarea)
{
  if (Q7B_nil(qmdiarea)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMDIAREA(qmdiarea))){ Q7B_EXCEPTION("QMdiArea expected"); return Q7B_idnil; }

  return Q7B_ID( ((QMdiArea *) qmdiarea->ref)->viewMode() );
}

// *** QMENUBAR ***********************************************************************************

Q7B Q7B__QMENUBAR_INIT(QObject *parent, const char *objectName)
{
  QMenuBar* o = new QMenuBar( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QMenuBar).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QTOOLBAR ***********************************************************************************

Q7B Q7B__QTOOLBAR_INIT(QObject *parent, const char *objectName)
{
  QToolBar* o = new QToolBar( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QToolBar).name(), o, !parent->isWidgetType()));  
  return q;
}

// *** QSTATUSBAR ***********************************************************************************

Q7B Q7B__QSTATUSBAR_INIT(QObject *parent, const char *objectName)
{
  QStatusBar* o = new QStatusBar(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QStatusBar).name(), o, !parent->isWidgetType()));  
  return q;
}


// *** QMENU ***********************************************************************************
/*
void Q7B_QMENU_CONNECT_SLOTS(QObject *parent, QMenu* o, QString sName)
{
  QString s;
  // Be careful! Don't use whitespaces here.
  //s = QString("1on_") + sName + "_" + "triggered(QAction*)"; if (parent->metaObject()->indexOfSlot(s.mid(1).toAscii()) != -1) QObject::connect(o, SIGNAL(triggered(QAction *)), parent, s.toAscii());  
  QObject *k = ((QObject *) o)->parent();
  ((QObject *) o)->setParent(parent);
  QMetaObject::connectSlotsByName(parent);
  ((QObject *) o)->setParent(k);
 // s = QString("1on_") + sName + "_" + "aboutToShow()"; if (parent->metaObject()->indexOfSlot(s.mid(1).toAscii()) != -1) QObject::connect(o, SIGNAL(aboutToShow()), parent, s.toAscii());    
}*/

Q7B Q7B__QMENU_INIT(QObject *parent, const char *objectName, Q7B v)
{
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QMenu* o = new QMenu( *((QString *) v->ref) );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  //Q7B_QMENU_CONNECT_SLOTS(parent, o, objectName);

  Q7B q (new Q7B_id(typeid(QMenu).name(), o, parent == 0)); 
  return q;
}

Q7B Q7B_QMENU_INIT(QObject *parent, const char *objectName)
{
  QMenu* o = new QMenu( "" );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  //Q7B_QMENU_CONNECT_SLOTS(parent, o, objectName);

  Q7B q (new Q7B_id(typeid(QMenu).name(), o, parent == 0)); 
  return q;
}

Q7B Q7B_QMENU_ADDACTION(Q7B qmenu, Q7B Text)
{
  if (Q7B_nil(qmenu)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMENU(qmenu))){ Q7B_EXCEPTION("QMenu expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }  

  static QString s;
  s = *((QString *) Text->ref);

  QAction *a = ((QMenu *) qmenu->ref)->addAction( s );
  Q7B q (new Q7B_id(typeid(QAction).name(), a, false)); // QAction is not owned by gc but by the menu

  return q;
}

void Q7B_QMENU_ADDACTION2(Q7B qmenu, Q7B theAction)
{
  if (Q7B_nil(qmenu)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QMENU(qmenu))){ Q7B_EXCEPTION("QMenu expected"); return; }
  if (Q7B_nil(Q7B_QACTION(theAction))){ Q7B_EXCEPTION("QAction expected"); return; }  

  ((QMenu *) qmenu->ref)->addAction( ((QAction *) theAction->ref) );
}

Q7B Q7B_QMENU_ADDMENU(Q7B qmenu, Q7B Text)
{
  if (Q7B_nil(qmenu)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  
  if (Q7B_nil(Q7B_QMENU(qmenu))){ Q7B_EXCEPTION("QMenu expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  static QString s;
  s = *((QString *) Text->ref);

  QMenu *a = ((QMenu *) qmenu->ref)->addMenu( s );
  Q7B q (new Q7B_id(typeid(QMenu).name(), a, false)); // QMenu is not owned by gc but by the menu

  return q;
}

Q7B Q7B_QMENU_ADDSEPARATOR(Q7B qmenu)
{
  if (Q7B_nil(qmenu)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMENU(qmenu))){ Q7B_EXCEPTION("QMenu expected"); return Q7B_idnil; }

  return Q7B_ID( ((QMenu *) qmenu->ref)->addSeparator( ) );
}

void Q7B_QMENU_CLEAR(Q7B qmenu)
{
  if (Q7B_nil(qmenu)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QMENU(qmenu))){ Q7B_EXCEPTION("QMenu expected"); return; }

  ((QMenu *) qmenu->ref)->clear( );
}

// *** QLABEL ***********************************************************************************
/*
class Label : public QLabel
{
  Q_OBJECT
public:
Label(QWidget *parent = 0) : QLabel (parent)
{  
}
};*/

/*
void Q7B_QLABEL_CONNECT_SLOTS(QObject *parent, QLabel* o, QString sName)
{
  QString s;
  //s = QString("1on_") + sName + "_" + "returnPressed()"; 
  //if (parent->metaObject()->indexOfSlot(s.mid(1).toAscii()) != -1) QObject::connect(o, SIGNAL(returnPressed()), parent, s.toAscii());  
}*/

Q7B Q7B_QLABEL_INIT(QObject *parent, const char *objectName) // QWidget *parent = 0
{
  QLabel* o = new QLabel(parent->isWidgetType() ? (QWidget *) parent : 0);

  o->setProperty("Parent", (qlonglong) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  //Q7B_QLABEL_CONNECT_SLOTS(parent, o, objectName);

  Q7B q (new Q7B_id(typeid(QLabel).name(), o, !parent->isWidgetType()));  

  return q;
}

void Q7B_QLABEL_TEXT(Q7B qlabel, Q7B Value)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((QLabel *) qlabel->ref)->setText( *((QString *) Value->ref) );
}

Q7B Q7B_QLABEL_TEXT(Q7B qlabel)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( ((QLabel *) qlabel->ref)->text() );
}

void Q7B_QLABEL_OPENEXTERNALLINKS(Q7B qlabel, Q7B Value)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Value))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QLabel *) qlabel->ref)->setOpenExternalLinks( Q7B_IDbool(Value) );
}

Q7B Q7B_QLABEL_OPENEXTERNALLINKS(Q7B qlabel)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( ((QLabel *) qlabel->ref)->openExternalLinks() );
}

void Q7B_QLABEL_WORDWRAP(Q7B qlabel, Q7B Value)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Value))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QLabel *) qlabel->ref)->setWordWrap( Q7B_IDbool(Value) );
}

Q7B Q7B_QLABEL_WORDWRAP(Q7B qlabel)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( ((QLabel *) qlabel->ref)->wordWrap() );
}

void Q7B_QLABEL_SCALEDCONTENTS(Q7B qlabel, Q7B Value)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Value))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QLabel *) qlabel->ref)->setScaledContents( Q7B_IDbool(Value) );
}

Q7B Q7B_QLABEL_SCALEDCONTENTS(Q7B qlabel)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( ((QLabel *) qlabel->ref)->hasScaledContents() );
}

void Q7B_QLABEL_ALIGNMENT(Q7B qlabel, Q7B Value)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QLabel *) qlabel->ref)->setAlignment( (Qt::Alignment) Q7B_IDqint64(Value) );
}

Q7B Q7B_QLABEL_ALIGNMENT(Q7B qlabel)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) ((QLabel *) qlabel->ref)->alignment() );
}

void Q7B_QLABEL_TEXTINTERACTIONFLAGS(Q7B qlabel, Q7B Value)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QLabel *) qlabel->ref)->setTextInteractionFlags( (Qt::TextInteractionFlags) Q7B_IDqint64(Value) );
}

Q7B Q7B_QLABEL_TEXTINTERACTIONFLAGS(Q7B qlabel)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) ((QLabel *) qlabel->ref)->textInteractionFlags() );
}

// *** QLINEEDIT ***********************************************************************************

Q7B Q7B_QLINEEDIT_INIT(QObject *parent, const char *objectName)
{
  QLineEdit* o = new QLineEdit(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QLineEdit).name(), o, !parent->isWidgetType()));   
  return q;
}

void Q7B_QLINEEDIT_ALIGNMENT(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QLineEdit *) qlineedit->ref)->setAlignment( (Qt::Alignment) Q7B_IDqint64(Value) );
}

Q7B Q7B_QLINEEDIT_ALIGNMENT(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) ((QLineEdit *) qlineedit->ref)->alignment() );
}

void Q7B_QLINEEDIT_ECHOMODE(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QLineEdit *) qlineedit->ref)->setEchoMode( (QLineEdit::EchoMode) Q7B_IDqint64(Value) );
}

Q7B Q7B_QLINEEDIT_ECHOMODE(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( ((QLineEdit *) qlineedit->ref)->echoMode() );
}

void Q7B_QLINEEDIT_INPUTMASK(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((QLineEdit *) qlineedit->ref)->setInputMask( *((QString *) Value->ref) );
}

Q7B Q7B_QLINEEDIT_INPUTMASK(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( ((QLineEdit *) qlineedit->ref)->inputMask() );
}

void Q7B_QLINEEDIT_READONLY(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Value))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QLineEdit *) qlineedit->ref)->setReadOnly( Q7B_IDbool(Value) );
}

Q7B Q7B_QLINEEDIT_READONLY(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( ((QLineEdit *) qlineedit->ref)->isReadOnly() );
}

void Q7B_QLINEEDIT_VALIDATORFLOAT(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Value))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QLineEdit *) qlineedit->ref)->setProperty("ValidatorFloat", true);
  ((QLineEdit *) qlineedit->ref)->setValidator(Q7B_IDbool(Value) ? new QDoubleValidator(((QLineEdit *) qlineedit->ref)) : 0);
}

Q7B Q7B_QLINEEDIT_VALIDATORFLOAT(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( ((QLineEdit *) qlineedit->ref)->property("ValidatorFloat").toBool() );
}

void Q7B_QLINEEDIT_VALIDATORINTEGER(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Value))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QLineEdit *) qlineedit->ref)->setProperty("ValidatorInteger", true);
  ((QLineEdit *) qlineedit->ref)->setValidator(Q7B_IDbool(Value) ? new QIntValidator(((QLineEdit *) qlineedit->ref)) : 0);
}

Q7B Q7B_QLINEEDIT_VALIDATORINTEGER(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( ((QLineEdit *) qlineedit->ref)->property("ValidatorInteger").toBool() );
}

void Q7B_QLINEEDIT_MAXIMUM(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QLineEdit *) qlineedit->ref)->setMaxLength( Q7B_IDqint64(Value) );
}

Q7B Q7B_QLINEEDIT_MAXIMUM(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( ((QLineEdit *) qlineedit->ref)->maxLength () );
}

void Q7B_QLINEEDIT_COMPLETER(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_LIST(Value))){ Q7B_EXCEPTION("List expected"); return; }

  QLineEdit *le = ((QLineEdit *) qlineedit->ref);

  le->setCompleter( new QCompleter( Q7B_IDQ7B_List(Value)->toStringList(), le) );
}

Q7B Q7B_QLINEEDIT_COMPLETER(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_idnil; // no values returned
}

void Q7B_QLINEEDIT_TEXT(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((QLineEdit *) qlineedit->ref)->setText( *((QString *) Value->ref) );
}

Q7B Q7B_QLINEEDIT_TEXT(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( ((QLineEdit *) qlineedit->ref)->text() );
}

Q7B Q7B_QLINEEDIT_ISVALID(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( ((QLineEdit *) qlineedit->ref)->hasAcceptableInput() );
}

void Q7B_QLINEEDIT_SELECTALL(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }

  ((QLineEdit *) qlineedit->ref)->selectAll();
}

// *** QTEXTEDIT ***********************************************************************************

Q7B Q7B_QTEXTEDIT_INIT(QObject *parent, const char *objectName)
{
  QTextEdit* o = new QTextEdit(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QTextEdit).name(), o, !parent->isWidgetType()));    
  return q;
}

void Q7B_QTEXTEDIT_PRINT(Q7B qtextedit)
{
  if (Q7B_nil(qtextedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTEXTEDIT(qtextedit))){ Q7B_EXCEPTION("QTextEdit expected"); return; }

  QTextEdit *code = ((QTextEdit *) qtextedit->ref);
  QPrinter printer;

  QPrintDialog *dialog = new QPrintDialog(&printer);
  //dialog->setWindowTitle("Print Document");
  if (code->textCursor().hasSelection())
      dialog->addEnabledOption(QAbstractPrintDialog::PrintSelection);
  if (dialog->exec() != QDialog::Accepted)
      return;

  code->print(&printer);
}

void Q7B_QTEXTEDIT_PRINTTOPDF(Q7B qtextedit, Q7B FileName)
{
  if (Q7B_nil(qtextedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTEXTEDIT(qtextedit))){ Q7B_EXCEPTION("QTextEdit expected"); return; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return; }

  QTextEdit *code = ((QTextEdit *) qtextedit->ref);
  QPrinter printer;

  printer.setOutputFileName(Q7B_IDQString(FileName));
  printer.setOutputFormat(QPrinter::PdfFormat);

  code->print(&printer);
}

void Q7B_QTEXTEDIT_HTML(Q7B qtextedit, Q7B Value)
{
  if (Q7B_nil(qtextedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTEXTEDIT(qtextedit))){ Q7B_EXCEPTION("QTextEdit expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((QTextEdit *) qtextedit->ref)->setHtml( *((QString *) Value->ref) );
}

Q7B Q7B_QTEXTEDIT_HTML(Q7B qtextedit)
{
  if (Q7B_nil(qtextedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTEXTEDIT(qtextedit))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( ((QTextEdit *) qtextedit->ref)->toHtml() );
}

Q7B Q7B_QPLAINTEXTEDIT_INIT(QObject *parent, const char *objectName)
{
  QPlainTextEdit* o = new QPlainTextEdit( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QPlainTextEdit).name(), o, !parent->isWidgetType()));    
  return q;
}

void Q7B_QPLAINTEXTEDIT_PRINT(Q7B qplaintextedit)
{
  if (Q7B_nil(qplaintextedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(qplaintextedit))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return; }

  QPlainTextEdit *code = ((QPlainTextEdit *) qplaintextedit->ref);
  QPrinter printer;

  QPrintDialog *dialog = new QPrintDialog(&printer);
  //dialog->setWindowTitle("Print Document");
  if (code->textCursor().hasSelection())
      dialog->addEnabledOption(QAbstractPrintDialog::PrintSelection);
  if (dialog->exec() != QDialog::Accepted)
      return;

  code->print(&printer);
}

void Q7B_QPLAINTEXTEDIT_PRINTTOPDF(Q7B qplaintextedit, Q7B FileName)
{
  if (Q7B_nil(qplaintextedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(qplaintextedit))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return; }

  QPlainTextEdit *code = ((QPlainTextEdit *) qplaintextedit->ref);
  QPrinter printer;

  printer.setOutputFileName(Q7B_IDQString(FileName));
  printer.setOutputFormat(QPrinter::PdfFormat);

  code->print(&printer);
}

void Q7B_QPLAINTEXTEDIT_PLAINTEXT(Q7B qplaintextedit, Q7B Value)
{
  if (Q7B_nil(qplaintextedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(qplaintextedit))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((QPlainTextEdit *) qplaintextedit->ref)->setPlainText( *((QString *) Value->ref) );
}

Q7B Q7B_QPLAINTEXTEDIT_PLAINTEXT(Q7B qplaintextedit)
{
  if (Q7B_nil(qplaintextedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(qplaintextedit))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( ((QPlainTextEdit *) qplaintextedit->ref)->toPlainText() );
}

void Q7B_QPLAINTEXTEDIT_READONLY(Q7B qplaintextedit, Q7B v)
{
  if (Q7B_nil(qplaintextedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(qplaintextedit))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return; }

  ((QPlainTextEdit *) qplaintextedit->ref)->setReadOnly( *((bool *) v->ref) );
}

Q7B Q7B_QPLAINTEXTEDIT_READONLY(Q7B qplaintextedit)
{  
  if (Q7B_nil(qplaintextedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(qplaintextedit))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( ((QPlainTextEdit *) qplaintextedit->ref)->isReadOnly() );
}

void Q7B_QPLAINTEXTEDIT_APPENDPLAINTEXT(Q7B qplaintextedit, Q7B v)
{
  if (Q7B_nil(qplaintextedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(qplaintextedit))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }  

  ((QPlainTextEdit *) qplaintextedit->ref)->appendPlainText( *((QString *) v->ref) );
}

// *** QCOMBOBOX ***********************************************************************************
/*
void Q7B_QCOMBOBOX_CONNECT_SLOTS(QObject *parent, QComboBox* o, QString sName)
{
  QString s;
  //s = QString("1on_") + sName + "_" + "triggered(QAction *)"; if (parent->metaObject()->indexOfSlot(s.mid(1).toAscii()) != -1) QObject::connect(o, SIGNAL(released()), parent, s.toAscii());  
}*/

Q7B Q7B_QCOMBOBOX_INIT(QObject *parent, const char *objectName)
{
  QComboBox* o = new QComboBox( parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  //Q7B_QCOMBOBOX_CONNECT_SLOTS(parent, o, objectName);

  Q7B q (new Q7B_id(typeid(QComboBox).name(), o, !parent->isWidgetType()));    
  return q;
}

void Q7B_QCOMBOBOX_REMOVEALL(Q7B qcombobox)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return; }

  ((QComboBox *) qcombobox->ref)->clear();
}

void Q7B_QCOMBOBOX_SETNOCOMPLETER(Q7B qcombobox)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return; }

  ((QComboBox *) qcombobox->ref)->setCompleter(0);
}

Q7B Q7B_QCOMBOBOX_TEXT(Q7B qcombobox)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( ((QComboBox *) qcombobox->ref)->currentText() );
}

void Q7B_QCOMBOBOX_APPEND(Q7B qcombobox, Q7B v)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }
  
  ((QComboBox *) qcombobox->ref)->addItem( *((QString *) v->ref) );
}

Q7B Q7B_QCOMBOBOX_OBJECT(Q7B qcombobox, Q7B v)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QComboBox *) qcombobox->ref)->itemText( Q7B_IDqint64(v) ) );
}

void Q7B_QCOMBOBOX_CURRENTINDEX(Q7B qcombobox, Q7B v)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QComboBox *) qcombobox->ref)->setCurrentIndex( Q7B_IDqint64(v) );
}

Q7B Q7B_QCOMBOBOX_LENGTH(Q7B qcombobox)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( ((QComboBox *) qcombobox->ref)->count() );
}

Q7B Q7B_QCOMBOBOX_CURRENTINDEX(Q7B qcombobox)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( ((QComboBox *) qcombobox->ref)->currentIndex() );
}

void Q7B_QCOMBOBOX_APPEND2(Q7B qcombobox, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }
  
  QIcon icon;
  icon = *((QIcon *) Icon->ref);

  ((QComboBox *) qcombobox->ref)->addItem(icon, Q7B_IDQString(Text));
}


// *** QTREEWIDGET ***********************************************************************************
/*
void Q7B_QTREEWIDGET_CONNECT_SLOTS(QObject *parent, QTreeWidget* o, QString sName)
{
  QString s;
  //s = QString("1on_") + sName + "_" + "triggered(QAction *)"; if (parent->metaObject()->indexOfSlot(s.mid(1).toAscii()) != -1) QObject::connect(o, SIGNAL(released()), parent, s.toAscii());  
}*/

Q7B Q7B_QTREEWIDGET_INIT(QObject *parent, const char *objectName)
{
  QTreeWidget* o = new QTreeWidget(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  //Q7B_QTREEWIDGET_CONNECT_SLOTS(parent, o, objectName);

  Q7B q (new Q7B_id(typeid(QTreeWidget).name(), o, !parent->isWidgetType()));    
  return q;
}

Q7B Q7B_QTREEWIDGET_COLUMNCOUNT(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QTreeWidget *) qtreewidget->ref)->columnCount() );
}

Q7B Q7B_QTREEWIDGET_CURRENTCOLUMN(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QTreeWidget *) qtreewidget->ref)->currentColumn() );
}

Q7B Q7B_QTREEWIDGET_CURRENTITEM(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) ((QTreeWidget *) qtreewidget->ref)->currentItem() );
}

Q7B Q7B_QTREEWIDGET_HEADERITEM(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) ((QTreeWidget *) qtreewidget->ref)->headerItem() );
}

Q7B Q7B_QTREEWIDGET_INVISIBLEROOTITEM(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) ((QTreeWidget *) qtreewidget->ref)->invisibleRootItem() );
}

Q7B Q7B_QTREEWIDGET_SELECTEDITEMS(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  QList<QTreeWidgetItem *>l =((QTreeWidget *) qtreewidget->ref)->selectedItems();

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

  for (int i = 0; i < l.size(); i++){
     a->append(Q7B_ID( (qint64) l.at(i)));
  }

  return q;
}

Q7B Q7B_QTREEWIDGET_SORTCOLUMN(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) ((QTreeWidget *) qtreewidget->ref)->sortColumn() );
}

Q7B Q7B_QTREEWIDGET_TOPLEVELITEMCOUNT(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) ((QTreeWidget *) qtreewidget->ref)->topLevelItemCount() );
}

void Q7B_QTREEWIDGET_COLLAPSEALL(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->collapseAll() ;
}

void Q7B_QTREEWIDGET_EXPANDALL(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->expandAll() ;
}

void Q7B_QTREEWIDGET_SELECTALL(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->selectAll() ;
}

void Q7B_QTREEWIDGET_SCROLLTOBOTTOM(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->scrollToBottom() ;
}

void Q7B_QTREEWIDGET_SCROLLTOTOP(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->scrollToTop() ;
}

Q7B Q7B_QTREEWIDGET_APPENDCHILD(Q7B qtreewidget, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = new QTreeWidgetItem(((QTreeWidget *) qtreewidget->ref));
  l->setText(0, Q7B_IDQString(Text));

  return Q7B_ID( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_CHILDCOUNT(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( l->childCount() );
}

Q7B Q7B_QTREEWIDGET_ISEXPANDED(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( l->isExpanded() );
}

Q7B Q7B_QTREEWIDGET_ISHIDDEN(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( l->isHidden() );
}

Q7B Q7B_QTREEWIDGET_ISSELECTED(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( l->isSelected() );
}

Q7B Q7B_QTREEWIDGET_COLUMNCOUNT2(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( l->columnCount() );
}

Q7B Q7B_QTREEWIDGET_APPEND(Q7B qtreewidget, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = new QTreeWidgetItem();
  l->setText(0, Q7B_IDQString(Text));
  ((QTreeWidget *) qtreewidget->ref)->addTopLevelItem(l);
  return Q7B_ID( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_INDEXOFTOPLEVELITEM(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( ((QTreeWidget *) qtreewidget->ref)->indexOfTopLevelItem(l) );
}
  
void Q7B_QTREEWIDGET_SETCOLUMNCOUNT(Q7B qtreewidget, Q7B Count)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Count))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->setColumnCount( Q7B_IDqint64(Count) ) ;
}

void Q7B_QTREEWIDGET_SETCURRENTITEM(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->setCurrentItem( l ) ;
}

void Q7B_QTREEWIDGET_SETHEADERLABEL(Q7B qtreewidget, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->setHeaderLabel( Q7B_IDQString(Text) );
  ((QTreeWidget *) qtreewidget->ref)->headerItem()->setHidden(false);
}

void Q7B_QTREEWIDGET_REMOVETOPLEVELITEM(Q7B qtreewidget, Q7B Index)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->takeTopLevelItem( Q7B_IDqint64(Index) );
}

Q7B Q7B_QTREEWIDGET_TOPLEVELITEM(Q7B qtreewidget, Q7B Index)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) ((QTreeWidget *) qtreewidget->ref)->topLevelItem( Q7B_IDqint64(Index) ) );
}

Q7B Q7B_QTREEWIDGET_ISCOLUMNHIDDEN(Q7B qtreewidget, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QTreeWidget *) qtreewidget->ref)->isColumnHidden( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_COLUMNWIDTH(Q7B qtreewidget, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QTreeWidget *) qtreewidget->ref)->columnWidth( Q7B_IDqint64(Column) ) );
}

void Q7B_QTREEWIDGET_SHOWCOLUMN(Q7B qtreewidget, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->showColumn( Q7B_IDqint64(Column) ) ;
}

void Q7B_QTREEWIDGET_COLLAPSEITEM(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->collapseItem( l ) ;
}

void Q7B_QTREEWIDGET_EXPANDITEM(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->expandItem( l ) ;
}

void Q7B_QTREEWIDGET_SCROLLTOITEM(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->scrollToItem( l ) ;
}

Q7B Q7B_QTREEWIDGET_FLAGS(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( (qint64) l->flags ( ) );
}

Q7B Q7B_QTREEWIDGET_APPENDCHILD2(Q7B qtreewidget, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = new QTreeWidgetItem(((QTreeWidget *) qtreewidget->ref));
  l->setText(0, Q7B_IDQString(Text));

   QIcon icon;
  icon = *((QIcon *) Icon->ref);
  l->setIcon(0, icon);

  return Q7B_ID( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_APPENDCHILDTOID(Q7B qtreewidget, Q7B ItemId, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *ll = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  QTreeWidgetItem *l = new QTreeWidgetItem(ll);
  l->setText(0, Q7B_IDQString(Text));
  return Q7B_ID( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_CHILD(Q7B qtreewidget, Q7B ItemId, Q7B Index)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( (qint64) l->child( Q7B_IDqint64(Index) ) );
}

Q7B Q7B_QTREEWIDGET_CHECKSTATE(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);  
  return Q7B_ID( (qint64) l->checkState ( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_DATA(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_Variant2id( l->data ( Q7B_IDqint64(Column), Qt::UserRole ), false, false );
}

void Q7B_QTREEWIDGET_SETFLAGS(Q7B qtreewidget, Q7B ItemId, Q7B Flags)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Flags))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setFlags( (Qt::ItemFlags) Q7B_IDqint64(Flags) );
}

Q7B Q7B_QTREEWIDGET_TEXT(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( l->text ( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_ICON(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( l->icon ( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_INDEXOFCHILD(Q7B qtreewidget, Q7B ItemId, Q7B ChildId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ChildId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( l->indexOfChild ( (QTreeWidgetItem *) Q7B_IDqint64(ChildId) ) );
}

void Q7B_QTREEWIDGET_SETDISABLED(Q7B qtreewidget, Q7B ItemId, Q7B IsDisabled)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsDisabled))){ Q7B_EXCEPTION("Boolean expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setDisabled( Q7B_IDbool(IsDisabled) );
}

void Q7B_QTREEWIDGET_SETEXPANDED(Q7B qtreewidget, Q7B ItemId, Q7B IsExpanded)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsExpanded))){ Q7B_EXCEPTION("Boolean expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setExpanded( Q7B_IDbool(IsExpanded) );
}

void Q7B_QTREEWIDGET_SETHIDDEN(Q7B qtreewidget, Q7B ItemId, Q7B IsHidden)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsHidden))){ Q7B_EXCEPTION("Boolean expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setHidden( Q7B_IDbool(IsHidden) );
}

void Q7B_QTREEWIDGET_SETSELECTED(Q7B qtreewidget, Q7B ItemId, Q7B IsSelected)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsSelected))){ Q7B_EXCEPTION("Boolean expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setSelected( Q7B_IDbool(IsSelected) );
}

Q7B Q7B_QTREEWIDGET_STATUSTIP(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( l->statusTip ( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_WHATSTHIS(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( l->whatsThis ( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_TOOLTIP(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( l->toolTip ( Q7B_IDqint64(Column) ) );
}

void Q7B_QTREEWIDGET_REMOVECHILD(Q7B qtreewidget, Q7B ItemId, Q7B Index)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->takeChild( Q7B_IDqint64(Index) );
}

Q7B Q7B_QTREEWIDGET_TEXTALIGNMENT(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_ID( (qint64) l->textAlignment ( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_APPEND2(Q7B qtreewidget, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = new QTreeWidgetItem();
  l->setText(0, Q7B_IDQString(Text));

   QIcon icon;
  icon = *((QIcon *) Icon->ref);
  l->setIcon(0, icon);

  ((QTreeWidget *) qtreewidget->ref)->addTopLevelItem(l);
  return Q7B_ID( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_INSERT2(Q7B qtreewidget, Q7B Index, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = new QTreeWidgetItem();
  l->setText(0, Q7B_IDQString(Text));

  ((QTreeWidget *) qtreewidget->ref)->insertTopLevelItem(Q7B_IDqint64(Index), l);
  return Q7B_ID( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_ITEMAT(Q7B qtreewidget, Q7B X, Q7B Y)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) ((QTreeWidget *) qtreewidget->ref)->itemAt( Q7B_IDqint64(X), Q7B_IDqint64(Y) ) );
}

void Q7B_QTREEWIDGET_SETCURRENTITEM2(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->setCurrentItem ( l, Q7B_IDqint64(Column) ) ;
}

void Q7B_QTREEWIDGET_SETHEADERLABEL2(Q7B qtreewidget, Q7B Column, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QTreeWidgetItem *l = ((QTreeWidget *) qtreewidget->ref)->headerItem();
  l->setText( Q7B_IDqint64(Column), Q7B_IDQString(Text) );
  l->setHidden(false);  
}

void Q7B_QTREEWIDGET_SORTITEMS(Q7B qtreewidget, Q7B Column, Q7B Descending)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Descending))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->sortItems( Q7B_IDqint64(Column), Q7B_IDbool(Descending) ? Qt::DescendingOrder : Qt::AscendingOrder );
}

void Q7B_QTREEWIDGET_SETCOLUMNHIDDEN(Q7B qtreewidget, Q7B Column, Q7B IsColumnHidden)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsColumnHidden))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->setColumnHidden( Q7B_IDqint64(Column), Q7B_IDbool(IsColumnHidden) );
}

void Q7B_QTREEWIDGET_SETCOLUMNWIDTH(Q7B qtreewidget, Q7B Column, Q7B Width)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Width))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->setColumnWidth( Q7B_IDqint64(Column), Q7B_IDqint64(Width) );
}

void Q7B_QTREEWIDGET_CLOSEPERSISTENTEDITOR(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->closePersistentEditor(l, Q7B_IDqint64(Column));
}

void Q7B_QTREEWIDGET_OPENPERSISTENTEDITOR(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->openPersistentEditor(l, Q7B_IDqint64(Column));
}

void Q7B_QTREEWIDGET_EDITITEM(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->editItem(l, Q7B_IDqint64(Column));
}

Q7B Q7B_QTREEWIDGET_APPENDCHILDTOID2(Q7B qtreewidget, Q7B ItemId, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *ll = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  QTreeWidgetItem *l = new QTreeWidgetItem(ll);
  l->setText(0, Q7B_IDQString(Text));

   QIcon icon;
  icon = *((QIcon *) Icon->ref);
  l->setIcon(0, icon);

  return Q7B_ID( (qint64) l );
}

void Q7B_QTREEWIDGET_SETCHECKSTATE(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B CheckState)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(CheckState))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setCheckState( Q7B_IDqint64(Column), (Qt::CheckState) Q7B_IDqint64(CheckState) );
}

void Q7B_QTREEWIDGET_SETTEXT(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setText( Q7B_IDqint64(Column), Q7B_IDQString(Text) );
}

void Q7B_QTREEWIDGET_SETICON(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B Icon)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);

   QIcon icon;
  icon = *((QIcon *) Icon->ref);
  l->setIcon( Q7B_IDqint64(Column), icon);
}

Q7B Q7B_QTREEWIDGET_INSERTCHILD(Q7B qtreewidget, Q7B ItemId, Q7B Index, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *ll = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  QTreeWidgetItem *l = new QTreeWidgetItem(ll);
  l->setText(0, Q7B_IDQString(Text));
  ll->insertChild( Q7B_IDqint64(Index), l);

  return Q7B_ID( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_INSERTCHILD2(Q7B qtreewidget, Q7B ItemId, Q7B Index, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *ll = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  QTreeWidgetItem *l = new QTreeWidgetItem(ll);
  l->setText(0, Q7B_IDQString(Text));

   QIcon icon;
  icon = *((QIcon *) Icon->ref);
  l->setIcon(0, icon);

  ll->insertChild( Q7B_IDqint64(Index), l);

  return Q7B_ID( (qint64) l );
}
 
void Q7B_QTREEWIDGET_SETSTATUSTIP(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B StatusTip)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(StatusTip))){ Q7B_EXCEPTION("String expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setStatusTip( Q7B_IDqint64(Column), Q7B_IDQString(StatusTip));
}

void Q7B_QTREEWIDGET_SETWHATSTHIS(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B WhatsThis)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(WhatsThis))){ Q7B_EXCEPTION("String expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setWhatsThis( Q7B_IDqint64(Column), Q7B_IDQString(WhatsThis));
}

void Q7B_QTREEWIDGET_SETTOOLTIP(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B ToolTip)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(ToolTip))){ Q7B_EXCEPTION("String expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setToolTip( Q7B_IDqint64(Column), Q7B_IDQString(ToolTip));
}

void Q7B_QTREEWIDGET_SETTEXTALIGNMENT(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B TextAlignment)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(TextAlignment))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setTextAlignment( Q7B_IDqint64(Column), (Qt::AlignmentFlag) Q7B_IDqint64(TextAlignment) );
}
/*
Q7B Q7B_QTREEWIDGET_FINDITEMS(Q7B qtreewidget, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(TextAlignment))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QList<QListWidgetItem *>l = ((QListWidget *) qtreewidget->ref)->findItems (Q7B_IDQString(Text), Qt::MatchExactly);

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

  for (int i = 0; i < l.size(); i++){
     a->append(Q7B_ID( (qint64) l.at(i)));
  }

  return q;
}*/

Q7B Q7B_QTREEWIDGET_INSERT3(Q7B qtreewidget, Q7B Index, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = new QTreeWidgetItem();
  l->setText(0, Q7B_IDQString(Text));

   QIcon icon;
  icon = *((QIcon *) Icon->ref);
  l->setIcon(0, icon);

  ((QTreeWidget *) qtreewidget->ref)->insertTopLevelItem(Q7B_IDqint64(Index), l);
  return Q7B_ID( (qint64) l );
}


// *** QDOCKWIDGET ***********************************************************************************

Q7B Q7B_QDOCKWIDGET_INIT(QObject *parent, const char *objectName)
{
  QDockWidget* o = new QDockWidget(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QDockWidget).name(), o, !parent->isWidgetType()));    
  return q;
}

Q7B Q7B_QDOCKWIDGET_WIDGET(Q7B qdockwidget)
{
  if (Q7B_nil(qdockwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDOCKWIDGET(qdockwidget))){ Q7B_EXCEPTION("QDockWidget expected"); return Q7B_idnil; }
  
  return Q7B_ID( ((QDockWidget *) qdockwidget->ref)->widget() );
}

// *** QLISTWIDGET ***********************************************************************************
/*
void Q7B_QLISTWIDGET_CONNECT_SLOTS(QObject *parent, QListWidget* o, QString sName)
{
  QString s;
  //s = QString("1on_") + sName + "_" + "triggered(QAction *)"; if (parent->metaObject()->indexOfSlot(s.mid(1).toAscii()) != -1) QObject::connect(o, SIGNAL(released()), parent, s.toAscii());  
}*/

Q7B Q7B_QLISTWIDGET_INIT(QObject *parent, const char *objectName)
{
  QListWidget* o = new QListWidget( parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  //Q7B_QLISTWIDGET_CONNECT_SLOTS(parent, o, objectName);

  Q7B q (new Q7B_id(typeid(QListWidget).name(), o, !parent->isWidgetType()));    
  return q;
}

Q7B Q7B_QLISTWIDGET_LENGTH(Q7B qlistwidget)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QListWidget *) qlistwidget->ref)->count() );
}

void Q7B_QLISTWIDGET_REMOVEALL(Q7B qlistwidget)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }

  ((QListWidget *) qlistwidget->ref)->clear();
}

Q7B Q7B_QLISTWIDGET_SELECTED(Q7B qlistwidget)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QListWidget *) qlistwidget->ref)->currentRow() );
}

Q7B Q7B_QLISTWIDGET_SELECTEDTEXT(Q7B qlistwidget)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->currentItem();
  return Q7B_ID( l->text() );
}

void Q7B_QLISTWIDGET_SORT(Q7B qlistwidget, Q7B Descending)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Descending))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QListWidget *) qlistwidget->ref)->sortItems ( Q7B_IDbool(Descending) ? Qt::DescendingOrder : Qt::AscendingOrder );
}

void Q7B_QLISTWIDGET_APPEND(Q7B qlistwidget, Q7B Text)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  ((QListWidget *) qlistwidget->ref)->addItem  ( Q7B_IDQString(Text) );
}

void Q7B_QLISTWIDGET_REMOVE(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) ((QListWidget *) qlistwidget->ref)->removeItemWidget ( l ) ;
}

void Q7B_QLISTWIDGET_SELECT(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) ((QListWidget *) qlistwidget->ref)->setCurrentRow ( Q7B_IDqint64(Index) );
}

void Q7B_QLISTWIDGET_SELECTTEXT(Q7B qlistwidget, Q7B Text)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QList<QListWidgetItem *>l = ((QListWidget *) qlistwidget->ref)->findItems (Q7B_IDQString(Text), Qt::MatchExactly);
  if (l.count()) ((QListWidget *) qlistwidget->ref)->setCurrentItem (l.at(0));
}

Q7B Q7B_QLISTWIDGET_TEXT(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_ID( l->text() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_DATA(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_Variant2id( l->data(Qt::UserRole), false, false );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_ICON(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_ID( l->icon() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_CHECKSTATE(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_ID( l->checkState() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_FLAGS(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_ID( l->flags() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_ISHIDDEN(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_ID( l->isHidden() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_ISSELECTED(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_ID( l->isSelected() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_STATUSTIP(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_ID( l->statusTip() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_WHATSTHIS(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_ID( l->whatsThis() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_TOOLTIP(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_ID( l->toolTip() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_TEXTALIGNMENT(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_ID( l->textAlignment() );

  return Q7B_idnil;
}

void Q7B_QLISTWIDGET_SETTEXT(Q7B qlistwidget, Q7B Index, Q7B Text)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setText( Q7B_IDQString(Text) );
}

void Q7B_QLISTWIDGET_SETICON(Q7B qlistwidget, Q7B Index, Q7B Icon)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l){
     QIcon icon;
    icon = *((QIcon *) Icon->ref);
    l->setIcon( icon );
  }
}

void Q7B_QLISTWIDGET_SETDATA(Q7B qlistwidget, Q7B Index, Q7B d)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }  

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l){
    QVariant v = Q7B_id2Variant(d, false, false);
    l->setData(Qt::UserRole, v);
  }
}

void Q7B_QLISTWIDGET_SETCHECKSTATE(Q7B qlistwidget, Q7B Index, Q7B CheckState)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(CheckState))){ Q7B_EXCEPTION("Integer expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setCheckState( (Qt::CheckState) Q7B_IDqint64(CheckState) );  
}

void Q7B_QLISTWIDGET_SETFLAGS(Q7B qlistwidget, Q7B Index, Q7B Flag)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Flag))){ Q7B_EXCEPTION("Integer expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setFlags( (Qt::ItemFlags) Q7B_IDqint64(Flag) );  
}

void Q7B_QLISTWIDGET_SETHIDDEN(Q7B qlistwidget, Q7B Index, Q7B IsHidden)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsHidden))){ Q7B_EXCEPTION("Boolean expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setHidden( Q7B_IDbool(IsHidden) );  
}

void Q7B_QLISTWIDGET_SETSELECTED(Q7B qlistwidget, Q7B Index, Q7B IsSelected)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsSelected))){ Q7B_EXCEPTION("Boolean expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setSelected( Q7B_IDbool(IsSelected) );  
}

void Q7B_QLISTWIDGET_SETSTATUSTIP(Q7B qlistwidget, Q7B Index, Q7B StatusTip)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(StatusTip))){ Q7B_EXCEPTION("String expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setStatusTip( Q7B_IDQString(StatusTip) );  
}

void Q7B_QLISTWIDGET_SETWHATSTHIS(Q7B qlistwidget, Q7B Index, Q7B WhatsThis)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(WhatsThis))){ Q7B_EXCEPTION("String expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setWhatsThis( Q7B_IDQString(WhatsThis) );  
}

void Q7B_QLISTWIDGET_SETTOOLTIP(Q7B qlistwidget, Q7B Index, Q7B ToolTip)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(ToolTip))){ Q7B_EXCEPTION("String expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setToolTip( Q7B_IDQString(ToolTip) );  
}

void Q7B_QLISTWIDGET_SETTEXTALIGNMENT(Q7B qlistwidget, Q7B Index, Q7B TextAlignment)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(TextAlignment))){ Q7B_EXCEPTION("Integer expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setTextAlignment( (Qt::Alignment) Q7B_IDqint64(TextAlignment) );  
}

void Q7B_QLISTWIDGET_INSERT(Q7B qlistwidget, Q7B Index, Q7B Text)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  ((QListWidget *) qlistwidget->ref)->insertItem ( Q7B_IDqint64(Index), Q7B_IDQString(Text) );
}

void Q7B_QLISTWIDGET_APPEND2(Q7B qlistwidget, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QIcon icon;
  icon = *((QIcon *) Icon->ref);
  QListWidgetItem *l = new QListWidgetItem(icon, Q7B_IDQString(Text));
  ((QListWidget *) qlistwidget->ref)->addItem( l );
}

void Q7B_QLISTWIDGET_INSERT2(Q7B qlistwidget, Q7B Index, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QIcon icon;
  icon = *((QIcon *) Icon->ref);
  QListWidgetItem *l = new QListWidgetItem(icon, Q7B_IDQString(Text));
  ((QListWidget *) qlistwidget->ref)->insertItem ( Q7B_IDqint64(Index), l );

}

// *** QTOOLBUTTON ***********************************************************************************

Q7B Q7B_QTOOLBUTTON_INIT(QObject *parent, const char *objectName)
{
  QToolButton* o = new QToolButton( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QToolButton).name(), o, !parent->isWidgetType()));    
  return q;
}

void Q7B_QTOOLBUTTON_MENU(Q7B qtoolbutton, Q7B v)
{
  if (Q7B_nil(qtoolbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTOOLBUTTON(qtoolbutton))){ Q7B_EXCEPTION("QToolButton expected"); return; }
  //if (Q7B_nil(Q7B_QMENU(v))){ Q7B_EXCEPTION("QMenu expected"); return; } // null zuweisung kann gewollt sein

  ((QToolButton *) qtoolbutton->ref)->setMenu( ((QMenu *) v->ref) );
}

Q7B Q7B_QTOOLBUTTON_MENU(Q7B qtoolbutton)
{
  if (Q7B_nil(qtoolbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTOOLBUTTON(qtoolbutton))){ Q7B_EXCEPTION("QToolButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((QToolButton *) qtoolbutton->ref)->menu() );
}

// *** QACTION ***********************************************************************************
/*
void Q7B_QACTION_CONNECT_SLOTS(QObject *parent, QAction* o, QString sName)
{
  QString s;
  //s = QString("1on_") + sName + "_" + "triggered(QAction *)"; if (parent->metaObject()->indexOfSlot(s.mid(1).toAscii()) != -1) QObject::connect(o, SIGNAL(released()), parent, s.toAscii());  
}*/

Q7B Q7B_QACTION_INIT(QObject *parent, const char *objectName)
{
  QAction* o = new QAction( 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  //Q7B_QACTION_CONNECT_SLOTS(parent, o, objectName);

  Q7B q (new Q7B_id(typeid(QAction).name(), o, true)); 
  return q;
}

void Q7B_QACTION_TEXT(Q7B qaction, Q7B v)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }
  
  ((QAction *) qaction->ref)->setText( *((QString *) v->ref) );
}

Q7B Q7B_QACTION_TEXT(Q7B qaction)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  //QMessageBox::information(0, "QACTION_TEXT", ((QAction *) qaction->ref)->text());
  return Q7B_ID( ((QAction *) qaction->ref)->text() );
}

void Q7B_QACTION_TAG(Q7B qaction, Q7B v) // TODO2 in DATA ?ndern und qvariant speichern siehe qvariantbenutzung oben
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }
  
  ((QAction *) qaction->ref)->setProperty("Tag", *((QString *) v->ref) );
}

Q7B Q7B_QACTION_TAG(Q7B qaction)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( ((QAction *) qaction->ref)->property("Tag").toString() );
}

void Q7B_QACTION_VISIBLE(Q7B qaction, Q7B v)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QAction *) qaction->ref)->setVisible( *((bool *) v->ref) );
}

Q7B Q7B_QACTION_VISIBLE(Q7B qaction)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( ((QAction *) qaction->ref)->isVisible() );
}

void Q7B_QACTION_ENABLED(Q7B qaction, Q7B v)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QAction *) qaction->ref)->setEnabled( *((bool *) v->ref) );
}

Q7B Q7B_QACTION_ENABLED(Q7B qaction)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( ((QAction *) qaction->ref)->isEnabled() );
}

void Q7B_QACTION_CHECKABLE(Q7B qaction, Q7B v)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QAction *) qaction->ref)->setCheckable( *((bool *) v->ref) );
}

Q7B Q7B_QACTION_CHECKABLE(Q7B qaction)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( ((QAction *) qaction->ref)->isCheckable() );
}

void Q7B_QACTION_CHECKED(Q7B qaction, Q7B v)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QAction *) qaction->ref)->setChecked( *((bool *) v->ref) );
}

Q7B Q7B_QACTION_CHECKED(Q7B qaction)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( ((QAction *) qaction->ref)->isChecked() );
}

void Q7B_QACTION_ICON(Q7B qaction, Q7B v)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_QICON(v))){ Q7B_EXCEPTION("QIcon expected"); return; }

   QIcon icon;
  icon = *((QIcon *) v->ref);
  ((QAction *) qaction->ref)->setIcon( icon );
}

Q7B Q7B_QACTION_ICON(Q7B qaction)
{  
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( ((QAction *) qaction->ref)->icon() );
}

// *** DATETIME ***********************************************************************************

// keine init function ben?tigt

Q7B Q7B_ADDDAYS(Q7B Q7B_Object, Q7B Days)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Days))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->addDays( *((qint64 *) Days->ref ) ) );
}

Q7B Q7B_ADDHOURS(Q7B Q7B_Object, Q7B Hours)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Hours))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->addSecs(60 * 60 * *((qint64 *) Hours->ref ) ) );
}

Q7B Q7B_ADDMINUTES(Q7B Q7B_Object, Q7B Minutes)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Minutes))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->addSecs(60 * *((qint64 *) Minutes->ref ) ) );
}

Q7B Q7B_ADDMONTHS(Q7B Q7B_Object, Q7B Months)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Months))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->addMonths( *((qint64 *) Months->ref ) ) );
}

Q7B Q7B_ADDSECONDS(Q7B Q7B_Object, Q7B Seconds)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Seconds))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->addSecs( *((qint64 *) Seconds->ref ) ) );
}

Q7B Q7B_SUBDAYS(Q7B Q7B_Object, Q7B Days)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Days))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->addDays(- *((qint64 *) Days->ref ) ) );
}

Q7B Q7B_SUBHOURS(Q7B Q7B_Object, Q7B Hours)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Hours))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->addSecs(- 60 * 60 * *((qint64 *) Hours->ref ) ) );
}

Q7B Q7B_SUBMINUTES(Q7B Q7B_Object, Q7B Minutes)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Minutes))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->addSecs(- 60 * *((qint64 *) Minutes->ref ) ) );
}

Q7B Q7B_SUBMONTHS(Q7B Q7B_Object, Q7B Months)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Months))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->addMonths(- *((qint64 *) Months->ref ) ) );
}

Q7B Q7B_SUBSECONDS(Q7B Q7B_Object, Q7B Seconds)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Seconds))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->addSecs(- *((qint64 *) Seconds->ref ) ) );
}

Q7B Q7B_TIMEVALUE(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Q7B_Object);
  QDateTime dt = QDateTime::fromString(s, "hh:mm:ss");

  return Q7B_ID( dt );
}

Q7B Q7B_TIMESERIAL(Q7B Q7B_Object, Q7B Hour, Q7B Minute, Q7B Second)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Hour))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Minute))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Second))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QDateTime dt = QDateTime::currentDateTime();

  dt.setTime( QTime ( Q7B_IDqint64(Hour), Q7B_IDqint64(Minute), Q7B_IDqint64(Second) ) );

  return Q7B_ID( dt );
}

Q7B Q7B_DATESERIAL(Q7B Q7B_Object, Q7B Year, Q7B Month, Q7B Day)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Year))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Month))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Day))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QDateTime dt;

  dt.setDate( QDate ( Q7B_IDqint64(Year), Q7B_IDqint64(Month), Q7B_IDqint64(Day) ) );

  return Q7B_ID( dt );
}

Q7B Q7B_FORMATDATETIME(Q7B Q7B_Object, Q7B Format)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->toString( Q7B_IDQString(Format) ) );
}

Q7B Q7B_DATEVALUE(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Q7B_Object);
  QDateTime dt = QDateTime::fromString(s, "yyyy-MM-dd hh:mm:ss");
  if (!dt.isValid()){
    dt = QDateTime::fromString(s, "yyyy-MM-dd");      
    if (!dt.isValid()){   
      dt = QDateTime::fromString(s, "hh:mm:ss");
    }
  }

  return Q7B_ID( dt );
}

Q7B Q7B_DATEPART(Q7B Q7B_Object, Q7B Interval)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Interval))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  QDateTime t = *((QDateTime *) Q7B_Object->ref);

  QString sMode = Q7B_IDQString(Interval);
  
  qint64 y = 0;

  if (sMode == "yyyy"){ // yyyy	Jahr
    y = t.date().year();
  } else if (sMode == "w"){ // w	Wochentag   
    y = t.date().dayOfWeek();
    /*
    switch(y){
      case 1: return 2;
      case 2: return 3;
      case 3: return 4;
      case 4: return 5;
      case 5: return 6;
      case 6: return 7;
      case 7: return 1;
    }
    return 0;*/
  } else if (sMode == "q"){ // q	Quartal
    y = t.date().month() / 4 + 1;  
  } else if (sMode == "ww"){ // ww	Woche
    y = t.date().weekNumber();  
  } else if (sMode == "m"){ //m	Monat	 	
    y = t.date().month();  
  } else if (sMode == "h"){ // h	Stunde
    y = t.time().hour();        
  } else if (sMode == "y"){ // y	Tag des Jahres	 	
    y = t.date().dayOfYear();  
  } else if (sMode == "n"){ // n	Minute
    y = t.time().minute();        
  } else if (sMode == "d"){ // d	Tag	 	
    y = t.date().day();  
  } else if (sMode == "s"){ // s	Sekunde
    y = t.time().second();        
  }

  return Q7B_ID( y );
}

Q7B Q7B_DATEDIFF(Q7B Q7B_Object, Q7B dt, Q7B Interval)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DATETIME(dt))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Interval))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  QDateTime t = *((QDateTime *) Q7B_Object->ref);
  QDateTime t2 = *((QDateTime *) dt->ref);
  QString sMode = Q7B_IDQString(Interval);
  
  qint64 y = 0;

  if (sMode == "yyyy"){ // yyyy	Jahr
    y = t2.daysTo(t) / 365;
  } else if (sMode == "w"){ // w	Wochentag   
     Q7B_EXCEPTION("Sorry! \"w\" not supported yet. Try to change the data calculation.");
  } else if (sMode == "q"){ // q	Quartal
    y = t2.daysTo(t) / (3 * 30);        
  } else if (sMode == "ww"){ // ww	Woche
     Q7B_EXCEPTION("Sorry! \"ww\" not supported yet. Try to change the data calculation.");    
  } else if (sMode == "m"){ //m	Monat	 	
    y = t2.daysTo(t) / 30;    
  } else if (sMode == "h"){ // h	Stunde
    y = t2.secsTo(t) * 3600;            
  } else if (sMode == "y"){ // y	Tag des Jahres	 	
     Q7B_EXCEPTION("Sorry! \"y\" not supported yet. Try to change the data calculation.");        
  } else if (sMode == "n"){ // n	Minute
    y = t2.secsTo(t) * 60;        
  } else if (sMode == "d"){ // d	Tag	 	
    y = t2.daysTo(t);
  } else if (sMode == "s"){ // s	Sekunde
    y = t2.secsTo(t);    
  }

  return Q7B_ID( y );
}

Q7B Q7B_DATEADD(Q7B Q7B_Object, Q7B Interval, Q7B Number)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Interval))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Number))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  
  QDateTime t = *((QDateTime *) Q7B_Object->ref);
  QString sMode = Q7B_IDQString(Interval);
  qint64 n = Q7B_IDqint64(Number);

  QDateTime k;

  if (sMode == "yyyy"){ // yyyy	Jahr
    k = t.addMonths(n * 12);
  } else if (sMode == "w"){ // w	Wochentag   
    k = t.addDays(n);
  } else if (sMode == "q"){ // q	Quartal
    k = t.addMonths(n * 4);
  } else if (sMode == "ww"){ // ww	Woche
    k = t.addDays(n * 7);
  } else if (sMode == "m"){ //m	Monat	 	
    k = t.addMonths(n);
  } else if (sMode == "h"){ // h	Stunde
    k = t.addSecs(n * 3600);
  } else if (sMode == "y"){ // y	Tag des Jahres	 	
    k = t.addDays(n);
  } else if (sMode == "n"){ // n	Minute
    k = t.addSecs(n * 60);
  } else if (sMode == "d"){ // d	Tag	 	
    k = t.addDays(n);
  } else if (sMode == "s"){ // s	Sekunde
    k = t.addSecs(n);     
  }

  return Q7B_ID( k );
}

Q7B Q7B_DIFFSECONDS(Q7B Q7B_Object, Q7B dt)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DATETIME(dt))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  
  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->secsTo( *((QDateTime *) dt->ref) ) );
}

Q7B Q7B_DIFFDAYS(Q7B Q7B_Object, Q7B dt)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DATETIME(dt))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  
  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->daysTo( *((QDateTime *) dt->ref) ) );
}

Q7B Q7B_WEEKNUMBER(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->date().weekNumber() );
}   

Q7B Q7B_MONTHNAME(Q7B Q7B_Object, Q7B LongMonthName)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  qint64 nMonth;

   // k?nnte auch integer sein, dann monatsnr 1..12
  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ 
    if (Q7B_nil(Q7B_INTEGER(Q7B_Object))){ 
      Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; 
    } else {
      nMonth = Q7B_IDqint64(Q7B_Object);
    }
  } else {
    nMonth = ((QDateTime *) Q7B_Object->ref)->date().month();
  }

  if (Q7B_nil(Q7B_BOOLEAN(LongMonthName))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_IDbool(LongMonthName)){
    return Q7B_ID( QDate::longMonthName ( nMonth ) );
  } else {
    return Q7B_ID( QDate::shortMonthName( nMonth ) );
  }
}

Q7B Q7B_DATETIME_INIT(Q7B Year, Q7B Month, Q7B Day, Q7B Hour, Q7B Minute, Q7B Second, Q7B MSecond)
{
  QDateTime* o;

  if (Q7B_IDqint64(MSecond) != -1){
    o = new QDateTime( QDate( Q7B_IDqint64(Year), Q7B_IDqint64(Month), Q7B_IDqint64(Day) ), QTime( Q7B_IDqint64(Hour), Q7B_IDqint64(Minute), Q7B_IDqint64(Second), Q7B_IDqint64(MSecond) ) );
  } else  if (Q7B_IDqint64(Hour) != -1){
    o = new QDateTime( QDate::currentDate(), QTime( Q7B_IDqint64(Hour), Q7B_IDqint64(Minute), Q7B_IDqint64(Second), Q7B_IDqint64(MSecond) ) );
  } else {
    o = new QDateTime( QDate( Q7B_IDqint64(Year), Q7B_IDqint64(Month), Q7B_IDqint64(Day) ) );
  }

  Q7B q (new Q7B_id(typeid(QDateTime).name(), o, true));   
  return q;
}

Q7B Q7B_DAYSINYEAR(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->date().daysInYear() );
}   

Q7B Q7B_DAYSINMONTH(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->date().daysInMonth() );
}   

Q7B Q7B_DAYOFYEAR(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->date().dayOfYear() );
}   

Q7B Q7B_DAYOFWEEK(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->date().dayOfWeek() );
}   

Q7B Q7B_DAYNAME(Q7B Q7B_Object, Q7B LongDayName)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(LongDayName))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_IDbool(LongDayName)){
    return Q7B_ID( QDate::longDayName( ((QDateTime *) Q7B_Object->ref)->date().dayOfWeek() ) );
  } else {
    return Q7B_ID( QDate::shortDayName( ((QDateTime *) Q7B_Object->ref)->date().dayOfWeek() ) );
  }
}

Q7B Q7B_SECOND(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->time().second() );
}   

Q7B Q7B_MINUTE(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->time().minute() );
}   

Q7B Q7B_HOUR(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->time().hour() );
}   

Q7B Q7B_MONTH(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->date().month() );
}   

Q7B Q7B_YEAR(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->date().year() );
}   

Q7B Q7B_DAY(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->date().day() );
}   

Q7B Q7B_ISLEAPYEAR(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( QDate::isLeapYear( ((QDateTime *) Q7B_Object->ref)->date().day() ) );
}   

Q7B Q7B_ISDATETIMEVALID(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->isValid() );
}   

Q7B Q7B_ISDATEVALID(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->date().isValid() );
}    

Q7B Q7B_ISTIMEVALID(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( ((QDateTime *) Q7B_Object->ref)->time().isValid() );
}    

// *** STRING ***********************************************************************************

Q7B Q7B_STRREVERSE(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString t;
  for (qint64 i = 0; i < ((QString *) Q7B_Object->ref)->length(); i++){
    t = ((QString *) Q7B_Object->ref)->at(i) + t;
  }
  return Q7B_ID(t);
}

Q7B Q7B_FILL(Q7B Q7B_Object, Q7B Character, Q7B Size)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Character))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Size))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Q7B_Object); // WORKAROUND   force deep copy
  return Q7B_ID(s.fill(((QString *) Character->ref)->at(0), Q7B_IDqint64(Size)));
}

Q7B Q7B_INSERT(Q7B Q7B_Object, Q7B Position, Q7B Str)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Q7B_Object); // WORKAROUND   force deep copy
  return Q7B_ID(s.insert(Q7B_IDqint64(Position), *((QString *) Str->ref)));
}

Q7B Q7B_NZ(Q7B Q7B_Object, Q7B ReturnValue)
{
  if (Q7B_nil(Q7B_Object)){ 
    return ReturnValue;
  }

  return Q7B_Object;
}

void Q7B_MIDASSIGNMENT(Q7B *l, Q7B Position, Q7B Length, Q7B r)
{  
  if (Q7B_nil(*l)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSTRING(*l))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Length))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(r))){ Q7B_EXCEPTION("String expected"); return; }

  QString rr = Q7B_IDQString(r);
  Q7B a = *l;
  ((QString *) a->ref)->replace(Q7B_IDqint64(Position), Q7B_IDqint64(Length), rr.left(Q7B_IDqint64(Length)));
}

Q7B Q7B_LEFT(Q7B Q7B_Object, Q7B Position)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->left( *((qint64 *) Position->ref ) ) );
}

Q7B Q7B_TRUNCATE(Q7B Q7B_Object, Q7B Position)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  ((QString *) Q7B_Object->ref)->truncate( *((qint64 *) Position->ref ) );
  return Q7B_ID( Q7B_Object );
}

Q7B Q7B_SECTION(Q7B Q7B_Object, Q7B Separator, Q7B Start, Q7B End, Q7B SectionFlags)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Separator))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Start))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(End))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(SectionFlags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->section( Q7B_IDQString(Separator), Q7B_IDqint64(Start), Q7B_IDqint64(End), (QString::SectionFlags) Q7B_IDqint64(SectionFlags) ) );
}

Q7B Q7B_LEFTJUSTIFIED(Q7B Q7B_Object, Q7B Width, Q7B Fill, Q7B Truncate)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Fill))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Truncate))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QChar c = ' ';
  QString s = Q7B_IDQString(Fill);
  if (!s.isEmpty()) c = s[0];
  return Q7B_ID( ((QString *) Q7B_Object->ref)->leftJustified( Q7B_IDqint64(Width), c, Q7B_IDbool(Truncate) ) );
}

Q7B Q7B_RIGHTJUSTIFIED(Q7B Q7B_Object, Q7B Width, Q7B Fill, Q7B Truncate)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Fill))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Truncate))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QChar c = ' ';
  QString s = Q7B_IDQString(Fill);
  if (!s.isEmpty()) c = s[0];
  return Q7B_ID( ((QString *) Q7B_Object->ref)->rightJustified( Q7B_IDqint64(Width), c, Q7B_IDbool(Truncate) ) );
}

QString Q7B_LoadString(Q7B Q7B_Object, QString sEncoding)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return ""; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return ""; }

  QString sWhere = *((QString *) Q7B_Object->ref);
  if (sWhere.startsWith("www.")){
    sWhere = "http://" + sWhere;
  }
  QString s;

  if (sWhere.startsWith("file:///")){
    sWhere = sWhere.mid(QString("file:///").length());
  }

  QUrl url(sWhere); 
  if (url.isValid() && !Q7B_fileExists(sWhere)){

    QHttp http;
    http.setHost(url.host());     

    QString q = url.encodedQuery();
    if (!q.isEmpty()){
      q = q.prepend("?");
    }
    QString z = QString(url.encodedPath()) + q;
    http.get(z);

    while(http.currentId() > 0 && http.error() == QHttp::NoError){
      qApp->processEvents();
    }
    if (http.error() != QHttp::NoError){
    } else {
      if (http.bytesAvailable()){
        QByteArray a = http.readAll();
        s = QString::fromUtf8(a.data(), a.size());
      }
    }

  } else {
    //QDir::setCurrent(qApp->applicationDirPath());
    
    QFile f;

    //QMessageBox::information(0, "1", qApp->applicationDirPath() + "/" + sWhere);

    if (QFile::exists(qApp->applicationDirPath() + "/" + sWhere)){ // important first check applicationDirPath
      f.setFileName(qApp->applicationDirPath() + "/" + sWhere);
    } else {
      f.setFileName(sWhere);
    }

    //QFile f(sWhere);
    if (!f.open(QIODevice::ReadOnly)){
    } else {
     // QMessageBox::information(0, "", "11 Q7B_LoadString");
      //int nSize = f.size();
      if (f.size() > 100000000){ // avoid Qt crash on large files

        //QMessageBox::information(0, "", "aa Q7B_LoadString");

        QByteArray ba = f.readAll();

        // QMessageBox::information(0, "", "bb Q7B_LoadString");

        if (sEncoding == "Local8Bit"){
          s = QString(QString::fromLocal8Bit(ba.constData()));
        } else {
          s = QString(QString::fromUtf8(ba.constData()));
        }
        
        ba.clear();
        //QMessageBox::information(0, "", "22 Q7B_LoadString");
      } else {

        QTextStream t(&f);
        if (sEncoding == "Local8Bit"){
        } else if (sEncoding == ""){
          t.setCodec("UTF-8");
        } else {
          t.setCodec(sEncoding.toAscii());
        }
        t.setAutoDetectUnicode(true);
        t.setGenerateByteOrderMark(true);

     //   QMessageBox::information(0, "", "1 Q7B_LoadString");
        s = t.readAll();      
       // QMessageBox::information(0, "", "2 Q7B_LoadString");
        f.close();
      }
    }
  }

  return s;
}

Q7B Q7B_READSTRING(Q7B Q7B_Object, Q7B Encoding)
{
  if (Q7B_nil(Q7B_QSTRING(Encoding))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_LoadString(Q7B_Object, Q7B_IDQString(Encoding) ) );
}

Q7B Q7B_READCSTRING(Q7B Q7B_Object)
{
  return Q7B_ID( Q7B_LoadString(Q7B_Object, "ISO 8859-1" ) );
}

Q7B Q7B_WRITECSTRING(Q7B Q7B_Object, Q7B FilePathOrURL)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FilePathOrURL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWhere = *((QString *) FilePathOrURL->ref);
 
  if (sWhere.startsWith("file:///")){
    sWhere = sWhere.mid(QString("file:///").length());
  }  
  
  QFile f(sWhere);
  if (!f.open(QIODevice::Truncate | QIODevice::WriteOnly)){
  } else {
    QTextStream t(&f);
    t.setCodec("ISO 8859-1");
   // t.setAutoDetectUnicode(true);
   // t.setGenerateByteOrderMark(true);
    t << *((QString *) Q7B_Object->ref);      
    f.close();

    return Q7B_ID( true );
  }
  
  return Q7B_ID( false );
}

Q7B Q7B_WRITESTRING(Q7B Q7B_Object, Q7B FilePathOrURL, Q7B Encoding)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FilePathOrURL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Encoding))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sEncoding = Q7B_IDQString(Encoding);

  QString sWhere = *((QString *) FilePathOrURL->ref);
 
  if (sWhere.startsWith("file:///")){
    sWhere = sWhere.mid(QString("file:///").length());
  }  
  
  QFile f(sWhere);
  if (!f.open(QIODevice::Truncate | QIODevice::WriteOnly)){
  } else {
    QTextStream t(&f);

    if (sEncoding == "Local8Bit"){
    } else if (sEncoding == ""){
      t.setCodec("UTF-8");
    } else {
      t.setCodec(sEncoding.toAscii());
    }

    t.setAutoDetectUnicode(true);
    t.setGenerateByteOrderMark(true);
    t << *((QString *) Q7B_Object->ref);      
    f.close();

    return Q7B_ID( true );
  }
  
  return Q7B_ID( false );
}

Q7B Q7B_ISEMPTY(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->isEmpty() );
}

Q7B Q7B_LEN(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->length() );
}

Q7B Q7B_LTRIM(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (((QString *) Q7B_Object->ref)->isEmpty()) return Q7B_Object;

  int i = 0;
  while (i < ((QString *) Q7B_Object->ref)->length() && ((QString *) Q7B_Object->ref)->at(i).isSpace()) i++;

  return Q7B_ID( ((QString *) Q7B_Object->ref)->mid(i) );
}

Q7B Q7B_REVERSED(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s;

  for (int i = ((QString *) Q7B_Object->ref)->length() - 1; i >= 0; i--){
    s += ((QString *) Q7B_Object->ref)->at(i);
  }

  return Q7B_ID( s );
}

Q7B Q7B_RTRIM(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (((QString *) Q7B_Object->ref)->isEmpty()) return Q7B_Object;

  int i = ((QString *) Q7B_Object->ref)->length();
  while (((QString *) Q7B_Object->ref)->at(i - 1).isSpace()) i--;

  return Q7B_ID( ((QString *) Q7B_Object->ref)->left(i) );
}

Q7B Q7B_FILENAME(Q7B FilePath)
{
  if (Q7B_nil(FilePath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_ID( QFileInfo( *((QString *) FilePath->ref)).fileName()  );
}

Q7B Q7B_FILEBASENAME(Q7B FilePath)
{
  if (Q7B_nil(FilePath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_ID( QFileInfo( *((QString *) FilePath->ref)).baseName()  );
}

Q7B Q7B_FILEEXTENSION(Q7B FilePath)
{
  if (Q7B_nil(FilePath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_ID( QFileInfo( *((QString *) FilePath->ref)).completeSuffix()  );
}

Q7B Q7B_FILEPATH(Q7B FilePath)
{
  if (Q7B_nil(FilePath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_ID( QFileInfo( *((QString *) FilePath->ref)).absolutePath()  );
}

Q7B Q7B_STRING(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_ID(Q7B_toString2(Q7B_Object));  
}

Q7B Q7B_AT(Q7B Q7B_Object, Q7B Index)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  
  return Q7B_ID( ((QString *) Q7B_Object->ref)->at( *((qint64 *) Index->ref ) ) );
}

Q7B Q7B_UNICODE(Q7B Q7B_Object, Q7B Index)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  
  QChar c = ((QString *) Q7B_Object->ref)->at( *((qint64 *) Index->ref ) );
  return Q7B_ID( c.unicode() );
}

Q7B Q7B_MID(Q7B Q7B_Object, Q7B Index, Q7B Length)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Length))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  
  return Q7B_ID( ((QString *) Q7B_Object->ref)->mid( *((qint64 *) Index->ref ), *((qint64 *) Length->ref ) ) );
}

Q7B Q7B_RIGHT(Q7B Q7B_Object, Q7B Position)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->right( *((qint64 *) Position->ref ) ) );
}

Q7B Q7B_SPLIT(Q7B Q7B_Object, Q7B Separator, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Separator))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QStringList l = ((QString *) Q7B_Object->ref)->split( *((QString *) Separator->ref), QString::KeepEmptyParts, (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) );

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

  for (int i = 0; i < l.size(); i++){

     a->append(Q7B_ID(l.at(i)));
  }

  return q;

//  return Q7B_ID( ((QString *) Q7B_Object->ref)->split( *((QString *) Separator->ref), QString::KeepEmptyParts, (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_SPACE(Q7B Count, Q7B FillWith)
{
  //if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  //if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Count))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FillWith))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sResult = Q7B_IDQString(FillWith); sResult = sResult.repeated( Q7B_IDqint64(Count) );
  
  return Q7B_ID( sResult );
}

Q7B Q7B_JOIN(Q7B Q7B_Object, Q7B Separator)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_LIST(Q7B_Object))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Separator))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_List *) Q7B_Object->ref)->join( *((QString *) Separator->ref) ) );
}

Q7B Q7B_SIMPLIFIED(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->simplified() );
}

Q7B Q7B_TRIM(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->trimmed() );
}

Q7B Q7B_INSTR(Q7B Q7B_Object, Q7B Search, Q7B Index, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->indexOf( *((QString *) Search->ref), *((qint64 *) Index->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_INSTRREV(Q7B Q7B_Object, Q7B Search, Q7B Index, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->lastIndexOf( *((QString *) Search->ref), *((qint64 *) Index->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_CONTAINS(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->contains( *((QString *) Search->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_APPEND(Q7B Q7B_Object, Q7B Append)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Append))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Q7B_Object); // WORKAROUND   force deep copy
  return Q7B_ID( s.append( *((QString *) Append->ref) ) );
}

Q7B Q7B_PREPEND(Q7B Q7B_Object, Q7B Prepend)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Prepend))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Q7B_Object); // WORKAROUND   force deep copy
  return Q7B_ID( s.prepend( *((QString *) Prepend->ref) ) );
}

Q7B Q7B_LCASE(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->toLower() );
}

Q7B Q7B_UCASE(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->toUpper() );
}

Q7B Q7B_COMPARE(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->compare( *((QString *) Search->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_STRCOMP(Q7B Q7B_Object, Q7B Search, Q7B ComparisionMode)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ComparisionMode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  
  if (Q7B_IDqint64(ComparisionMode)){ // binary
    return Q7B_ID( ((QString *) Q7B_Object->ref)->compare( *((QString *) Search->ref)) );
    
  } else { // text
    qint64 n = ((QString *) Q7B_Object->ref)->localeAwareCompare( *((QString *) Search->ref));
    if (n < 0) return Q7B_ID( -1 );
    if (n > 0)return Q7B_ID( 1 );
    return Q7B_ID( n );
  }
}

Q7B Q7B_REPLACE(Q7B Q7B_Object, Q7B Search, Q7B Replace, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Replace))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Q7B_Object); // WORKAROUND   force deep copy
  return Q7B_ID( s.replace( *((QString *) Search->ref), *((QString *) Replace->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_REMOVE(Q7B Q7B_Object, Q7B Position, Q7B Length)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Length))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Q7B_Object); // WORKAROUND   force deep copy
  return Q7B_ID( s.remove( Q7B_IDqint64(Position), Q7B_IDqint64(Length) ) );
}

Q7B Q7B_COUNT(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->count( *((QString *) Search->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_STARTSWITH(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->startsWith( *((QString *) Search->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_ENDSWITH(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( ((QString *) Q7B_Object->ref)->endsWith( *((QString *) Search->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_CHARACTER(Q7B Unicode)
{
  if (Q7B_nil(Unicode)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Unicode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QChar c( (int) *((qint64 *) Unicode->ref) );

  return Q7B_ID( QString(c) );
}

Q7B Q7B_VALUE(Q7B Str)
{
  if (Q7B_nil(Str)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  bool ok;
  qreal r = ((QString *) Str->ref)->toDouble(&ok);
  
  if (ok) return Q7B_ID(r);

  return Q7B_idnil;
}

Q7B Q7B_ADDRESSOF(Q7B o)
{
  return Q7B_ID( (qint64) o->ref );
}

Q7B Q7B_OCT(Q7B Number)
{
  if (Q7B_nil(Number)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Number))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( QString::number(*((qint64 *) Number->ref), 8) );
}

Q7B Q7B_BIN(Q7B Number)
{
  if (Q7B_nil(Number)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Number))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( QString::number(*((qint64 *) Number->ref), 2) );
}

Q7B Q7B_HEX(Q7B Number)
{
  if (Q7B_nil(Number)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Number))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( QString::number(*((qint64 *) Number->ref), 16) );
}

Q7B Q7B_FORMAT(Q7B Number, Q7B Local8Bit)
{
  if (Q7B_nil(Number)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOLEAN(Local8Bit))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_toString2(Number) );
}

Q7B Q7B_FORMATFLOAT(Q7B Number, Q7B Local8Bit, Q7B DecimalPlaceLength)
{
  if (Q7B_nil(Number)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_FLOAT(Number))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Local8Bit))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(DecimalPlaceLength))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_toString2(Number) );
}

Q7B Q7B_FORMATDECIMAL(Q7B Number, Q7B Local8Bit, Q7B DecimalPlaceLength)
{
  if (Q7B_nil(Number)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DECIMAL(Number))){ Q7B_EXCEPTION("Decimal expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Local8Bit))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(DecimalPlaceLength))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_toString2(Number) );
}

// *** UI ***********************************************************************************

QMap<QString, Q7B>q7b_ui;

QWidget* Q7B_CREATE_FROM_UI_FILE(QString uiName, QWidget *parentWidget)
{

#ifndef Q_WS_MAC
   QUiLoader loader;

   loader.clearPluginPaths(); // f?r Mac OS wird designer plugin aus system geladen -> absturz

   QFile file(uiName);
   if (file.open(QFile::ReadOnly)){
     QWidget *formWidget = loader.load(&file, parentWidget);
     file.close();
     return formWidget;
   }
#endif

   return 0;
}

extern Q7B Q7B_GLOBAL_LOADUI(QString uiName);

void Q7B_OPENTEXTWINDOW(Q7B Text)
{
  if (Q7B_nil(Text)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QString s = *((QString *) Text->ref);
  s = s.replace("\n", "<br>");
	QTextEdit *e = new QTextEdit( s ); 

  e->setAttribute(Qt::WA_DeleteOnClose);
  e->setReadOnly(true);
  e->showMaximized();
}

void Q7B_OPENHTMLWINDOW(Q7B Text)
{
  if (Q7B_nil(Text)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

	QTextEdit *e = new QTextEdit( *((QString *) Text->ref) ); 
  e->setAttribute(Qt::WA_DeleteOnClose);
  e->setReadOnly(true);
  e->showMaximized();
}

void Q7B_OPENWEBWINDOW(Q7B Text)
{
  if (Q7B_nil(Text)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

	QWebView *e = new QWebView( ); 
  e->setAttribute(Qt::WA_DeleteOnClose);
  e->setHtml( *((QString *) Text->ref) );
  e->showMaximized();
}

Q7B Q7B_LOADUI(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

	return Q7B_ID( Q7B_GLOBAL_LOADUI( *((QString *) uiName->ref) ) );
}

Q7B Q7B_UNLOADUI(Q7B uiWidget)
{
  if (Q7B_nil(uiWidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(uiWidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QWidget *) uiWidget->ref)->close() );
}

extern Q7B Q7B_GLOBAL_OPENWINDOW(QString uiName);

Q7B Q7B_OPENWINDOW(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

	return Q7B_ID( Q7B_GLOBAL_OPENWINDOW( *((QString *) uiName->ref) ) );
}

extern Q7B Q7B_GLOBAL_OPENTOOLWINDOW(QString uiName);

Q7B Q7B_OPENTOOLWINDOW(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_GLOBAL_OPENTOOLWINDOW( *((QString *) uiName->ref) ) );
/*
  QWidget *w = GLOBAL_OPENTOOLWINDOW( *((QString *) uiName->ref) );
  if (w){
    int n = w->windowFlags();
    w->setWindowFlags(((Qt::WindowFlags) w->windowFlags()) | Qt::Tool);
    //w->setParent( ((QMainWindow *) q7b_MainWindow_Object_Q7B->ref) );
    w->showNormal();
    w->activateWindow();
	  return Q7B_ID( w );
  }

  return Q7B_idnil;*/
}

Q7B Q7B_OPENDOCKWIDGET(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (q7b_ui.contains(*((QString *) uiName->ref))){

//QMessageBox::information(0, "aj", *((QString *) uiName->ref)  );

    QDockWidget *dw = qobject_cast<QDockWidget *>((QDockWidget *) q7b_ui[*((QString *) uiName->ref)]->ref);
    dw->show();
 //   int n = dw->allowedAreas();
 //   if (n > 0x8) n = Qt::LeftDockWidgetArea;
 //  ((QMainWindow *) q7b_MainWindow_Object_Q7B->ref)->addDockWidget((Qt::DockWidgetArea) ((n & Qt::LeftDockWidgetArea) | (n & Qt::RightDockWidgetArea) | (n & Qt::TopDockWidgetArea) | (n & Qt::BottomDockWidgetArea)), dw);

    return q7b_ui[*((QString *) uiName->ref)];
  } else {

    Q7B q7b_this = Q7B_GLOBAL_LOADUI( *((QString *) uiName->ref) );
    QWidget *w = ((QWidget *) q7b_this->ref);

    if (w){
      QDockWidget *dw = qobject_cast<QDockWidget *>(w);
      if (dw){
        //dw->setAttribute(Qt::WA_DeleteOnClose);           
        int n = dw->allowedAreas();
        if (n > 0x8) n = Qt::LeftDockWidgetArea;
        ((QMainWindow *) q7b_MainWindow_Object_Q7B->ref)->addDockWidget((Qt::DockWidgetArea) ((n & Qt::LeftDockWidgetArea) | (n & Qt::RightDockWidgetArea) | (n & Qt::TopDockWidgetArea) | (n & Qt::BottomDockWidgetArea)), dw);


        q7b_ui[*((QString *) uiName->ref)] = q7b_this;

        return q7b_this;
      }
    }
  }


  return Q7B_idnil;
}

QMdiArea *Q7B_getDefaultMDI()
{
  QWidget *cw = ((QMainWindow *) q7b_MainWindow_Object_Q7B->ref)->centralWidget();
  if (cw){
    QObjectList ol = cw->children();
  
    for (int q = 0; q < ol.size(); q++){

      QMdiArea *mdi = qobject_cast<QMdiArea *>(ol.at(q));
      if (mdi){
        return mdi;
      }
    }
  }
  return 0;
}

Q7B Q7B_OPENMDI(Q7B uiName) // TODO2 neues argument for subwindow  features Qt::Window | Qt::CustomizeWindowHint etc.
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B q7b_this = Q7B_GLOBAL_LOADUI( *((QString *) uiName->ref) );

   //QMessageBox::information(0, "q7b_this", Q7B_toString2(q7b_this)  );
  QWidget *w = ((QWidget *) q7b_this->ref);

  if (w){
    QMdiArea *mdi = Q7B_getDefaultMDI();

    if (mdi){
       QMdiSubWindow  *sw = mdi->addSubWindow(w, Qt::Window | Qt::CustomizeWindowHint | Qt::WindowTitleHint);    
 
     //  QMessageBox::information(0, "q7b_this1", Q7B_toString2(q7b_this)  );
   //    sw->setWindowFlags(Qt::SubWindow | Qt::CustomizeWindowHint);
   //    sw->showMaximized();
       sw->showNormal();
//       return Q7B_ID( w );

     //   QMessageBox::information(0, "q7b_this2", Q7B_toString2(q7b_this)  );

       return q7b_this;
    }   
  }

  return Q7B_idnil;
}

Q7B Q7B_OPENSDI(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B q7b_this = Q7B_GLOBAL_LOADUI( *((QString *) uiName->ref) );
  QWidget *w = ((QWidget *) q7b_this->ref);

  if (w){
    QWidget *cw = ((QMainWindow *) q7b_MainWindow_Object_Q7B->ref)->centralWidget();
    if (cw){
      cw->hide();
    }
    ((QMainWindow *) q7b_MainWindow_Object_Q7B->ref)->setCentralWidget( w );
//    return Q7B_ID( w );
    return q7b_this;

  }

  return Q7B_idnil;
}

extern Q7B Q7B_GLOBAL_OPENDIALOG(QString uiName);

Q7B Q7B_OPENDIALOG(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B q7b_this = Q7B_GLOBAL_OPENDIALOG( *((QString *) uiName->ref) );
	QWidget *w = ((QWidget *) q7b_this->ref);

  QDialog *d = qobject_cast<QDialog *>(w);
  if (d){

    int n = d->windowFlags();
    d->setParent(((QMainWindow *) q7b_MainWindow_Object_Q7B->ref));
    d->setWindowFlags((Qt::WindowFlags) n);

    bool b = d->testAttribute(Qt::WA_DeleteOnClose);

    int dd = d->exec();

    q7b_ui.remove( *((QString *) uiName->ref) );
  //  QMessageBox::information(0, "","1");

    q7b_this->ref = 0;
   // QMessageBox::information(0, "","2");

    if (!b){
      d->deleteLater();
     // QMessageBox::information(0, "","deleteLater");
    }
    // delete d;  already deleted -> deleteonclose
   // QMessageBox::information(0, "","3");

    q7b_this = Q7B_IDNIL();
    //QMessageBox::information(0, "","4");
    return Q7B_ID( dd );
  }

  { Q7B_EXCEPTION("QDialog expected (= Null)"); return Q7B_idnil; }

 // return Q7B_ID( false ); // TODO2 new error object(reason, ) f?r alle functionen statt false zur?ckliefern  iserror()
}

extern bool Q7B_GLOBAL_CLOSEWINDOW(QString uiName);

Q7B Q7B_CLOSEDOCKWIDGET(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
 // QMessageBox::information(0, "a", *((QString *) uiName->ref));

  if (q7b_ui.contains(*((QString *) uiName->ref))){

    //QMessageBox::information(0, "b", q7b_ui[*((QString *) uiName->ref)]->type);

    if (q7b_ui[*((QString *) uiName->ref)]->type == typeid(QDockWidget).name()){

  //    QMessageBox::information(0, "c", "");
      ((QMainWindow *) q7b_MainWindow_Object_Q7B->ref)->removeDockWidget(((QDockWidget *) q7b_ui[*((QString *) uiName->ref)]->ref));
    }
  }   

	return Q7B_ID( Q7B_GLOBAL_CLOSEWINDOW( *((QString *) uiName->ref) ) );
}

Q7B Q7B_CLOSETOOLWINDOW(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

	return Q7B_ID( Q7B_GLOBAL_CLOSEWINDOW( *((QString *) uiName->ref) ) );
}

Q7B Q7B_CLOSEWINDOW(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

	return Q7B_ID( Q7B_GLOBAL_CLOSEWINDOW( *((QString *) uiName->ref) ) );
}

Q7B Q7B_CLOSEMDI(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  QMdiArea *mdi = Q7B_getDefaultMDI(); 
  QList<QMdiSubWindow *>l = mdi->subWindowList();

  for (int i = 0; i < l.size(); i++){
    if (l.at(i) == ((QWidget *) Widget->ref)->parentWidget()){
      ((QWidget *) Widget->ref)->parentWidget()->close();
      return Q7B_ID( true );
    }
  }

	return Q7B_ID( false );
}

Q7B Q7B_CLOSEALLMDI()
{
  QMdiArea *mdi = Q7B_getDefaultMDI(); 
  mdi->closeAllSubWindows();

  QList<QMdiSubWindow *>l = mdi->subWindowList();
	return Q7B_ID( l.size() == 0 );
}

Q7B Q7B_CLOSEWIDGET(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( ((QWidget *) Widget->ref)->close() );
}

Q7B Q7B_FOCUSWINDOW()
{
  return Q7B_ID( qApp->activeWindow() );
}

Q7B Q7B_FOCUS()
{
  return Q7B_ID( qApp->focusWidget() );
}

Q7B Q7B_LISTMDI()
{
  QMdiArea *mdi = Q7B_getDefaultMDI();  
  QList<QMdiSubWindow *>l = mdi->subWindowList();

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

  for (int i = 0; i < l.size(); i++){

    // QMessageBox::information(0, "objectName", ol.at(0)->objectName());

     a->append(Q7B_ID(l.at(i)->widget()));
  }

  return q;
}

  //  ' TODO2 As QWidget, ListMDI() As List, ListWindow As List

void Q7B_SETFOCUSMDI(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  QMdiArea *mdi = Q7B_getDefaultMDI();  
  QMdiSubWindow *sw = qobject_cast<QMdiSubWindow *>( ((QWidget *) Widget->ref)->parentWidget() );

  if (mdi && sw){
    mdi->setActiveSubWindow(sw);
    ((QWidget *) Widget->ref)->setFocus(Qt::ActiveWindowFocusReason);
  }
}

Q7B Q7B_FOCUSMDI()
{
  QMdiArea *mdi = Q7B_getDefaultMDI();  

  if (mdi){
    QMdiSubWindow *sw = mdi->currentSubWindow();
    
    if (sw){
      return Q7B_ID( sw->widget() );
      /*

      QObjectList ol = sw->children();

      if (ol.size() > 0){
        QWidget *w = qobject_cast<QWidget *>( ol.at(0) );

        //QMessageBox::information(0, "Q7B_FOCUSMDI", "");

        if (w) return Q7B_ID( w );
      }*/
          
    }
  }
  return Q7B_idnil;
}

/*
Q7B Q7B_LISTMDI()
{
  QMdiArea *mdi = Q7B_getDefaultMDI();  

  if (mdi){
    QList<QMdiSubWindow *> l = mdi->subWindowList();
                  
  }
  return Q7B_idnil;
}
*/

void Q7B_SETFOCUSWINDOW(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->show();
  ((QWidget *) Widget->ref)->activateWindow();
  ((QWidget *) Widget->ref)->setFocus(Qt::ActiveWindowFocusReason);
}

void Q7B_SETFOCUS(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->show();
  ((QWidget *) Widget->ref)->setFocus(Qt::OtherFocusReason);
}

void Q7B_HIDE(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->hide();
}

void Q7B_SHOW(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->show();
}

void Q7B_SHOWNORMAL(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->showNormal();
}

void Q7B_SHOWMAXIMIZED(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->showMaximized();
}

void Q7B_SHOWMINIMIZED(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->showMinimized();
}

void Q7B_SHOWORHIDE(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->setVisible(((QWidget *) Widget->ref)->isVisible());
}


// *** MATH ***********************************************************************************

#include <cmath>
#include <math.h>

#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <ctype.h>

qint64 Q7B_lStartValue = 0;
qreal Q7B_dLastRND = 0;
  
void Q7B_RANDOMIZE()
{	
  Q7B_lStartValue = 0;

  static /**/ struct tm *timep;
  static /**/ time_t atime;

  time(&atime); timep=localtime(&atime);

  Q7B_lStartValue = timep->tm_sec + (qint64) timep;

  // in order to get different first number every time
  Q7B_lStartValue = 16807L * (Q7B_lStartValue % 127773L) - 2836L * (Q7B_lStartValue / 127773L);
  if (Q7B_lStartValue <= 0) Q7B_lStartValue += 2147483647;
  Q7B_dLastRND = (qreal) Q7B_lStartValue / 2147483648.0;

  Q7B_lStartValue = 16807L * (Q7B_lStartValue % 127773L) - 2836L * (Q7B_lStartValue / 127773L);
  if (Q7B_lStartValue <= 0) Q7B_lStartValue += 2147483647;
  Q7B_dLastRND = (qreal) Q7B_lStartValue / 2147483648.0;

}

Q7B Q7B_RANDOM(Q7B dValue)
{
  if (Q7B_nil(Q7B_FLOAT(dValue))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }

  qreal dVALUE = 0;

  if (*((qint64 *) dValue->ref) != 0){
    dVALUE = *((qint64 *) dValue->ref);
  }

  if (Q7B_dLastRND == 0){ // if Randomize Timer hasn't be called before, make automatically
     Q7B_RANDOMIZE();
  }

	if (*((qint64 *) dValue->ref) != 0){
    if (dVALUE == 0) return Q7B_ID( Q7B_dLastRND );

    if (dVALUE < 0){
      Q7B_lStartValue = dVALUE * 10000;

      Q7B_lStartValue = 16807L * (Q7B_lStartValue % 127773L) - 2836L * (Q7B_lStartValue / 127773L);
      if (Q7B_lStartValue <= 0) Q7B_lStartValue += 2147483647;
      Q7B_dLastRND = (qreal) Q7B_lStartValue / 2147483648.0;

      return Q7B_ID( Q7B_dLastRND );
    }
	}

  Q7B_lStartValue = 16807L * (Q7B_lStartValue % 127773L) - 2836L * (Q7B_lStartValue / 127773L);
  if (Q7B_lStartValue <= 0) Q7B_lStartValue += 2147483647;
  Q7B_dLastRND = (qreal) Q7B_lStartValue / 2147483648.0;

  if (*((qint64 *) dValue->ref) != 0 && dVALUE > 0){
    Q7B_dLastRND *= dVALUE;
  }

	return Q7B_ID( Q7B_dLastRND );
}

/*
Q7B Q7B___RANDOM(bool bExpression, Q7B dValue)
{
  if (Q7B_nil(dValue)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_FLOAT(dValue))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }

  qreal dVALUE = 0;

  if (bExpression && dValue->ref != 0){
    dVALUE = *((qint64 *) dValue->ref);
  }

  if (Q7B_dLastRND == 0){ // if Randomize Timer hasn't be called before, make automatically
     Q7B_RANDOMIZE();
  }

	if (bExpression){
    if (dVALUE == 0) return Q7B_ID( Q7B_dLastRND );

    if (dVALUE < 0){
      Q7B_lStartValue = dVALUE * 10000;

      Q7B_lStartValue = 16807L * (Q7B_lStartValue % 127773L) - 2836L * (Q7B_lStartValue / 127773L);
      if (Q7B_lStartValue <= 0) Q7B_lStartValue += 2147483647;
      Q7B_dLastRND = (qreal) Q7B_lStartValue / 2147483648.0;

      return Q7B_ID( Q7B_dLastRND );
    }
	}

  Q7B_lStartValue = 16807L * (Q7B_lStartValue % 127773L) - 2836L * (Q7B_lStartValue / 127773L);
  if (Q7B_lStartValue <= 0) Q7B_lStartValue += 2147483647;
  Q7B_dLastRND = (qreal) Q7B_lStartValue / 2147483648.0;

  if (bExpression && dVALUE > 0){
    Q7B_dLastRND *= dVALUE;
  }

	return Q7B_ID( Q7B_dLastRND );

}

Q7B Q7B__RANDOM()
{
  return  Q7B___RANDOM(false, Q7B_idnil);
}

Q7B Q7B_RANDOM(Q7B dValue)
{
  if (Q7B_nil(dValue)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_FLOAT(dValue))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }

  return  Q7B___RANDOM(true, dValue);
}
*/

Q7B Q7B_BITCLR(Q7B Value, Q7B Position)
{
  if (Q7B_nil(Value)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  qint64 n = *((qint64 *) Value->ref);
  qint64 b = ~(1 << *((qint64 *) Position->ref));
  n &= b; 

	return Q7B_ID(n);
}

Q7B Q7B_BITSET(Q7B Value, Q7B Position)
{
  if (Q7B_nil(Value)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  qint64 n = *((qint64 *) Value->ref);
  qint64 b = 1 << *((qint64 *) Position->ref);
  n |= b; 

	return Q7B_ID(n);
}

Q7B Q7B_BITTST(Q7B Value, Q7B Position)
{
  if (Q7B_nil(Value)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  qint64 n = (*((qint64 *) Value->ref)) >> (*((qint64 *) Position->ref));
  qint64 b = 1;
  n &= b; 

  return Q7B_ID(n != 0);
}

Q7B Q7B_ABS(Q7B v)
{  
  return Q7B_ID( fabs(Q7B_toFloat2(v)) );
}

Q7B Q7B_ATN(Q7B v)
{  
  return Q7B_ID( atan(Q7B_toFloat2(v)) );
}

Q7B Q7B_COS(Q7B v)
{  
  return Q7B_ID( cos(Q7B_toFloat2(v)) );
}

Q7B Q7B_SIN(Q7B v)
{  
  return Q7B_ID( sin(Q7B_toFloat2(v)) );
}

Q7B Q7B_EXP(Q7B v)
{  
  return Q7B_ID( exp(Q7B_toFloat2(v)) );
}

Q7B Q7B_LN(Q7B v)
{  
  return Q7B_ID( log(Q7B_toFloat2(v)) );
}

Q7B Q7B_LOG10(Q7B v)
{  
  return Q7B_ID( log10(Q7B_toFloat2(v)) );
}

Q7B Q7B_FIX(Q7B v)
{  
  return Q7B_ID( Q7B_toInteger2(v) );
}
  
Q7B Q7B_INT(Q7B v)
{  
  return Q7B_ID( floor(Q7B_toFloat2(v)) );
}

Q7B Q7B_SQR(Q7B v)
{  
  return Q7B_ID( sqrt(Q7B_toFloat2(v)) );
}

Q7B Q7B_TAN(Q7B v)
{  
  return Q7B_ID( tan(Q7B_toFloat2(v)) );
}

Q7B Q7B_MIN(Q7B l, Q7B r)
{
  qreal _l = Q7B_toFloat2(l); if (Q7B_bException){ return Q7B_idnil; }
  qreal _r = Q7B_toFloat2(r); if (Q7B_bException){ return Q7B_idnil; }

	return Q7B_ID((_l <= _r)? _l : _r);
}

Q7B Q7B_MAX(Q7B l, Q7B r)
{
  qreal _l = Q7B_toFloat2(l); if (Q7B_bException){ return Q7B_idnil; }
  qreal _r = Q7B_toFloat2(r); if (Q7B_bException){ return Q7B_idnil; }

  return Q7B_ID((_l >= _r)? _l : _r);
}

Q7B Q7B_FACT(Q7B m)
{
  qreal _m = Q7B_toFloat2(m); if (Q7B_bException){ return Q7B_idnil; }
//  if (Q7B_nil(m)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
//  if (Q7B_nil(Q7B_FLOAT(m))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }

  //qreal n = *((qreal *) m->ref);
  qreal x;
  qreal y;
  y = 1;
  for (x = 1; x <= _m; x++){
       y = y * x;
  }  
	return Q7B_ID(y);
}

Q7B Q7B_ROUND(Q7B l, Q7B r)
{
  qreal _l = Q7B_toFloat2(l); if (Q7B_bException){ return Q7B_idnil; }
  qreal _r = Q7B_toFloat2(r); if (Q7B_bException){ return Q7B_idnil; }

  //if (Q7B_nil(l)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 // if (Q7B_nil(Q7B_FLOAT(l))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }
 // if (Q7B_nil(Q7B_INTEGER(r))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  //qint64 nCount = *((qint64 *) r->ref);
  
  qreal m = 1;
  for (qint64 i = 0; i < _r; i++){
    m = m * 10;
  }

  //qreal d = *((qreal *) l->ref);
  bool b = _l < 0;
  if (b) _l = -_l;
  _l = (_l * m + 0.5) / m;
  if (b) _l = -_l;
  qint64 g = _l * m;
  _l = g / m;

  return Q7B_ID(_l);
}


// *** misc. ***********************************************************************************

void Q7B_STDOUT(Q7B m)
{
  
QString s = (QDateTime::currentDateTime().toString(Qt::ISODate) + " " + Q7B_toString2(m) + QString("\n"));
{
  QFile file;
  if (file.open(stdout, QIODevice::WriteOnly)){    
    file.write(s.toLocal8Bit());
    file.flush();
  }
  
  return ;
}
/*
 // qDebug() << (QDateTime::currentDateTime().toString(Qt::ISODate) + " " + Q7B_toString2(m) + QString("\n"));

 // return;

 // qDebug() << toString2(m);//.toLocal8Bit().constData();
  
  QFile file;
  if (file.open(stdout, QIODevice::WriteOnly)){

    QString sss = (QDateTime::currentDateTime().toString(Qt::ISODate) + " " + Q7B_toString2(m) + QString("\n"));
   QMessageBox::information(0, "Q7B_STDOUT", sss );
    const char *ac = sss.toLocal8Bit().constData();
    file.write(ac, qstrlen(ac)); 
    file.flush();
    file.close();
  }*/
}

void Q7B_STDERR(Q7B m)
{

QString s = (QDateTime::currentDateTime().toString(Qt::ISODate) + " " + Q7B_toString2(m) + QString("\n"));
{
  QFile file;
  if (file.open(stderr, QIODevice::WriteOnly)){    
    file.write(s.toLocal8Bit());
    file.flush();
  }
  
  return ;
}
/*
//  qCritical() << toString2(m);//.toLocal8Bit().constData();

  QFile file;
  if (file.open(stderr, QIODevice::WriteOnly)){
    const char *ac = (QDateTime::currentDateTime().toString(Qt::ISODate) + " " + Q7B_toString2(m) + QString("\n")).toLocal8Bit().constData();
    file.write(ac, qstrlen(ac)); 
    file.flush();
    file.close();
  }*/
  
}

Q7B Q7B_READREGISTRY(Q7B RegistryPath, Q7B RegistryKey)
{
  if (Q7B_nil(RegistryPath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(RegistryPath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(RegistryKey))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QSettings settings(*((QString *) RegistryPath->ref), QSettings::NativeFormat);

  return Q7B_ID( settings.value(*((QString *) RegistryKey->ref)).toString()); 
}

/*
Q7B PRINT(Q7B PathOrURL)
{
  if (Q7B_nil(PathOrURL)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }


  if (Q7B_nil(Q7B_QSTRING(PathOrURL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }


  QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
  QTextDocument *document = ;
  QPrinter printer;

  QPrintDialog *dialog = new QPrintDialog(&printer, qApp->activeWindow());
  //dialog->setWindowTitle(tr("Print Document"));
  QApplication::restoreOverrideCursor();
  if (dialog->exec() != QDialog::Accepted){
    return Q7B_ID(false);
  }

  document->print(&printer);

  return Q7B_ID(true);
}*/

Q7B Q7B_OPENURL(Q7B PathOrURL)
{
  if (Q7B_nil(PathOrURL)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(PathOrURL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString k = *((QString *) PathOrURL->ref);
  
  if (QFile::exists(qApp->applicationDirPath() + "/" + k)){ // important first check applicationDirPath
    return Q7B_ID( QDesktopServices::openUrl( QUrl("file:///" + qApp->applicationDirPath() + "/" + k) ) );
  }

  if (QFile::exists(k)){
    return Q7B_ID( QDesktopServices::openUrl( QUrl("file:///" + k) ) );
  }

//QMessageBox::information(0, "2", qApp->applicationDirPath() + "/" + k);

  if (QFile::exists(qApp->applicationDirPath() + "/" + k)){
    return Q7B_ID( QDesktopServices::openUrl( QUrl("file:///" + qApp->applicationDirPath() + "/" + k) ) );
  }

  return Q7B_ID( QDesktopServices::openUrl( QUrl(k) ) );  	
}

Q7B Q7B_OPENEMAIL(Q7B SenderEmail, Q7B Subject, Q7B Body)
{
  if (Q7B_nil(SenderEmail)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(SenderEmail))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Subject))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Body))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QDesktopServices::openUrl( QUrl( QString("mailto:") + *((QString *) SenderEmail->ref) + "?subject=" + *((QString *) Subject->ref) + "&body=" + *((QString *) Body->ref)) ) );  	
}

Q7B Q7B_FLOAT(Q7B Expression, Q7B Local8Bit)
{
  //checker();

  if (Q7B_nil(Expression)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  //if (Q7B_nil(Q7B_QSTRING(Expression))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Local8Bit))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  //QMessageBox::information(0, "Q7B_FLOAT", QString("") + Expression->type);

  if (Expression->type == typeid(qreal).name()){
    return Expression;
  }

  if (Expression->type == typeid(qint64).name()){
    return Q7B_ID( (qreal) (*((qint64 *) Expression->ref)) );  
  }

  if (Expression->type == typeid(Q7B_Decimal).name()){
    return Q7B_ID( (qreal) (((Q7B_Decimal *) Expression->ref)->toFloat()) );  
  }

  if (Expression->type == typeid(QString).name()){
    bool ok;
    qreal f = ((QString *) Expression->ref)->toDouble(&ok); 
    if (ok) return Q7B_ID( f );
  }

  //QMessageBox::information(0, "Q7B_FLOAT", QString("") + Expression->type);

  return Q7B_idnil;  
}

Q7B Q7B_BOOLEAN(Q7B Expression, Q7B Local8Bit)
{
  if (Q7B_nil(Expression)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  //if (Q7B_nil(Q7B_QSTRING(Expression))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Local8Bit))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  //QMessageBox::information(0, "Q7B_FLOAT", QString("") + Expression->type);

  if (Expression->type == typeid(bool).name()){
    return Expression;
  }

  if (Expression->type == typeid(qreal).name()){
    return Q7B_ID( (bool) (*((qreal *) Expression->ref)) );  
  }
  
  if (Expression->type == typeid(qint64).name()){
    return Q7B_ID( (bool) (*((qint64 *) Expression->ref)) );  
  }

  if (Expression->type == typeid(Q7B_Decimal).name()){
    return Q7B_ID( (bool) (((Q7B_Decimal *) Expression->ref)->toFloat()) );  
  }

  bool ok;
  if (Expression->type == typeid(QString).name()){    
    bool b = ((QString *) Expression->ref)->toInt(&ok) != 0; 
    if (ok) return Q7B_ID( b );
  }

  bool b = Q7B_toString2( Expression ).toInt(&ok) != 0; 
  if (ok) return Q7B_ID( b );

  return Q7B_idnil;  
}

Q7B Q7B_QSTRINGLIST(Q7B Q7B_Object, Q7B Local8Bit)
{
  if (Q7B_Object->type == typeid(QStringList).name()) return Q7B_Object;
  if (Q7B_nil(Q7B_Object)){
    return Q7B_Object;
  }
  if (Q7B_Object->type == typeid(Q7B_List).name()) return Q7B_ID(Q7B_IDQ7B_List(Q7B_Object)->toStringList());

  Q7B_CASTEXCEPTION("'QStringList' for assignment expected. Tried '" + QString(Q7B_Object->type) + "'");
  return Q7B_idnil;
}

Q7B Q7B_STRING(Q7B Expression, Q7B Local8Bit)
{
  if (Q7B_nil(Expression)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOLEAN(Local8Bit))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Expression->type == typeid(QString).name()){
    return Expression;
  }

  return Q7B_ID( Q7B_toString2( Expression ) );
}

Q7B Q7B_DECIMAL(Q7B Expression, Q7B Local8Bit)
{
  if (Q7B_nil(Expression)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  //if (Q7B_nil(Q7B_QSTRING(Expression))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Local8Bit))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }


  if (Expression->type == typeid(qint64).name()){
    return Q7B_ID( Q7B_Decimal( (*((qint64 *) Expression->ref) )));
  }

  if (Expression->type == typeid(qreal).name()){
    return Q7B_ID( Q7B_Decimal( (*((qreal *) Expression->ref) )));    
  }

  if (Expression->type == typeid(QString).name()){
    return Q7B_ID( Q7B_Decimal( (*((QString *) Expression->ref) )));    
  }

  if (Expression->type == typeid(Q7B_Decimal).name()){
    Q7B_Decimal d;
    d.setValue( ((Q7B_Decimal *) Expression->ref)->value() );
    
    return Q7B_ID( d );  
  }
  
  return Q7B_idnil;//Q7B_ID( Q7B_Decimal( Q7B_toString2( Expression ) ) );
}

Q7B Q7B_DATETIME(Q7B Expression, Q7B Local8Bit)
{
  if (Q7B_nil(Expression)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  //if (Q7B_nil(Q7B_QSTRING(Expression))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Local8Bit))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( QDateTime::fromString( Q7B_toString2( Expression ), "yyyy-MM-dd hh:mm:ss" ) );
}

Q7B Q7B_INTEGER(Q7B Expression, Q7B Local8Bit)
{
  if (Q7B_nil(Expression)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  //if (Q7B_nil(Q7B_QSTRING(Expression))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Local8Bit))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Expression->type == typeid(qint64).name()){
    return Expression;
  }

  if (Expression->type == typeid(qreal).name()){
    return Q7B_ID( (qint64) (*((qreal *) Expression->ref)) );  
  }

  if (Expression->type == typeid(Q7B_Decimal).name()){
    return Q7B_ID( (qint64) (((Q7B_Decimal *) Expression->ref)->toInteger()) );  
  }

  if (Expression->type == typeid(QString).name()){
    bool ok;
    qint64 n = ((QString *) Expression->ref)->toInt(&ok); 
    if (ok) return Q7B_ID( n );
  }

  return Q7B_idnil;//Q7B_ID((qint64) 0);  
}

void Q7B_WAIT(Q7B MSec)
{
  if (Q7B_nil(MSec)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_INTEGER(MSec))){ Q7B_EXCEPTION("Integer expected"); return; }

  QThread::currentThread()->wait( Q7B_IDqint64(MSec) );
}

void Q7B_QUIT()
{
  qApp->quit();
}

void Q7B_BEEP()
{
  qApp->beep();
}

Q7B Q7B_DATE()
{
  return Q7B_ID(QDateTime::currentDateTime().toString("yyyy-MM-dd"));
}

Q7B Q7B_TIME()
{
  return Q7B_ID(QDateTime::currentDateTime().toString("hh:mm:ss"));
}

Q7B Q7B_NOW()
{
  return Q7B_ID(QDateTime::currentDateTime());
}

// *** VB6 & QBasic ********************************************************************************************************************************

const int Q7B_MAX_FILEHANDLE = 512;

const qint64 Q7B_pcode__INPUT = 1;
const qint64 Q7B_pcode__BINARY = 2;
const qint64 Q7B_pcode__RANDOM = 3;
const qint64 Q7B_pcode__OUTPUT = 4;
const qint64 Q7B_pcode__APPEND = 5;


struct Q7B_t_file2
{
  QFile f;
  qint64 nMode;
  qint64 nAccess;  
  qint64 nRecordLen;
  qint64 nRecordPos;
};

Q7B_t_file2 Q7B_file[Q7B_MAX_FILEHANDLE];

Q7B Q7B_FREEFILE(Q7B Range)
{
  if (Q7B_nil(Range)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Range))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  int i;
  i = 0;
  if (Q7B_IDqint64(Range) == 0){
    i = 1;
  } else {
    i = 256;
  }

  for (; i < Q7B_MAX_FILEHANDLE; i++){
    if (!Q7B_file[i].f.isOpen()){
      return Q7B_ID((qint64) i);        
    }
  }

  return Q7B_ID((qint64) 0);  
}

Q7B Q7B_EOF(Q7B FILEHANDLE)
{
  if (Q7B_nil(FILEHANDLE)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(FILEHANDLE))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  qint64 nFILEHANDLE = Q7B_IDqint64(FILEHANDLE);

  if (!Q7B_file[nFILEHANDLE].f.isOpen()){  Q7B_EXCEPTION(QString("%1 (file) is not open").arg(nFILEHANDLE)); return Q7B_idnil; }
  
  return Q7B_ID( Q7B_file[nFILEHANDLE].f.atEnd() );
}

void Q7B_LINEINPUT(Q7B FILEHANDLE, Q7B *Var)
{
  if (Q7B_nil(FILEHANDLE)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_INTEGER(FILEHANDLE))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(*Var)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  qint64 nFILEHANDLE = Q7B_IDqint64(FILEHANDLE);

  if (!(nFILEHANDLE > 0 && nFILEHANDLE < Q7B_MAX_FILEHANDLE)){ Q7B_EXCEPTION(QString("%1 (file handle) is too big or too small").arg(nFILEHANDLE)); return; }  

  char ac[0xffff];

  if (Q7B_file[nFILEHANDLE].f.isOpen()){
    switch(Q7B_file[nFILEHANDLE].nMode){
   	  case Q7B_pcode__INPUT:
		  case Q7B_pcode__BINARY:
		  case Q7B_pcode__RANDOM:
        break;
      default:
        { Q7B_EXCEPTION(QString("%1 (file) is not open in the correct mode").arg(nFILEHANDLE)); return; }
    }

    int n = Q7B_file[nFILEHANDLE].f.readLine((char *) &ac, 0xffff - 1);			

    if (n == -1){ Q7B_EXCEPTION(QString("%1 (file) could not be read").arg(nFILEHANDLE)); return; }
    

    // get rid of the readed return character
    if (n > 0){
      if (ac[n - 2] == 0xd) ac[n - 2] = 0; // LINUX anderes return zeichen nur 1byte gro?
      else ac[n - 1] = 0;
    }

  } else { Q7B_EXCEPTION(QString("%1 (file) not open").arg(nFILEHANDLE)); return; }  

  QString s = QString::fromLocal8Bit(ac);

  //QMessageBox::information(0,"Q7B_LINEINPUT", s); 


  *Var = Q7B_ID( s ); 
  //Var->ByRefAssignment(Q7B_ID( s ));  
  //Var = Q7B_ID( s );
}	

void Q7B_CLOSEFILE(Q7B FILEHANDLE)
{
  if (Q7B_nil(FILEHANDLE)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_INTEGER(FILEHANDLE))){ Q7B_EXCEPTION("Integer expected"); return; }

  qint64 nFILEHANDLE = Q7B_IDqint64(FILEHANDLE);

  if (!(nFILEHANDLE > 0 && nFILEHANDLE < Q7B_MAX_FILEHANDLE)){ Q7B_EXCEPTION(QString("%1 (file handle) too big or too small").arg(nFILEHANDLE)); return; }  

  if (Q7B_file[nFILEHANDLE].f.isOpen()){
    Q7B_file[nFILEHANDLE].f.close();		
  }
}	

void Q7B_CLOSEALLFILES()
{
	for (int i = 1; i < Q7B_MAX_FILEHANDLE; i++){
 		if (Q7B_file[i].f.isOpen()) Q7B_file[i].f.close();		
	}
}

void Q7B_OPEN(Q7B FileName, Q7B Mode, Q7B FILEHANDLE, Q7B Len)
{  
  if (Q7B_nil(FileName)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(FILEHANDLE))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Len))){ Q7B_EXCEPTION("Integer expected"); return; }

  qint64 nFILEHANDLE = Q7B_IDqint64(FILEHANDLE);

  if (!(nFILEHANDLE > 0 && nFILEHANDLE < Q7B_MAX_FILEHANDLE)){ Q7B_EXCEPTION(QString("%1 (file handle) too big or too small").arg(nFILEHANDLE)); return; }  

  int nMode = 0;
  QString sMode = Q7B_IDQString(Mode);

  if (sMode == "Input") nMode = Q7B_pcode__INPUT;
  else if (sMode == "Output") nMode = Q7B_pcode__OUTPUT;
  else if (sMode == "Append") nMode = Q7B_pcode__APPEND;
  else if (sMode == "Binary") nMode = Q7B_pcode__BINARY;
  else if (sMode == "Random") nMode = Q7B_pcode__RANDOM;

  Q7B_file[nFILEHANDLE].nMode = nMode; 
  Q7B_file[nFILEHANDLE].nRecordPos = 1;

  QIODevice::OpenMode n;
  n = 0;
	switch(nMode){
		case Q7B_pcode__OUTPUT:
			n = QFile::WriteOnly;
      Q7B_file[nFILEHANDLE].nRecordLen = 512;
			break;				
 		case Q7B_pcode__INPUT:
			n = QFile::ReadOnly;
      Q7B_file[nFILEHANDLE].nRecordLen = 512;
			break;
		case Q7B_pcode__APPEND:
			n = QFile::Append | QFile::WriteOnly; 
      Q7B_file[nFILEHANDLE].nRecordLen = 512;
			break;
		case Q7B_pcode__BINARY:
			n = QFile::ReadWrite;
      Q7B_file[nFILEHANDLE].nRecordLen = 512;
			break;
		case Q7B_pcode__RANDOM:
			n = QFile::ReadWrite;
      Q7B_file[nFILEHANDLE].nRecordLen = 128;
			break;
   default:
     { Q7B_EXCEPTION(QString("%1 (file handle) OPEN: wrong file mode").arg(nFILEHANDLE)); return; }
     break;
	}

  if (Q7B_IDqint64(Len) >= 0) Q7B_file[nFILEHANDLE].nRecordLen = Q7B_IDqint64(Len);

  QString s2 = Q7B_IDQString(FileName);
  if (!s2.contains("/") && !s2.contains("\\")){
    QString s = Q7B_IDQString(FileName);
    s2 = qApp->applicationDirPath();
    s2 += "/";
    s2 += s;
  }

  Q7B_file[nFILEHANDLE].f.setFileName(s2);
  bool b = Q7B_file[nFILEHANDLE].f.open(n);

  //QFile::FileError er = Q7B_file[nFILEHANDLE].f.error();

  if (!b){ Q7B_EXCEPTION(QString("%1 (file) could not be open").arg(nFILEHANDLE)); return; }  

  if (nMode == Q7B_pcode__APPEND){
    qint64 u;
    u = Q7B_file[nFILEHANDLE].f.size();
    Q7B_file[nFILEHANDLE].f.seek( u ); 
  } 

}

// ***********************************************************************************************************************************

Q7B Q7B_RUN(Q7B FilePath, Q7B Arguments)
{
  if (Q7B_nil(FilePath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_LIST(Arguments))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }

  QStringList l = ((Q7B_List *) Arguments->ref)->toStringList();
  QProcess p;
  p.start(*((QString *) FilePath->ref), l);

  p.waitForFinished(-1);

  QString s = p.readAllStandardError();
  s += p.readAllStandardOutput();

  return Q7B_ID( s );
}

Q7B Q7B_LAUNCH(Q7B FilePath, Q7B Arguments, Q7B WorkingDirectory, Q7B Wait)
{
  if (Q7B_nil(FilePath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_LIST(Arguments))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(WorkingDirectory))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Wait))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QString workingDirectory = *((QString *) WorkingDirectory->ref);
  qint64 pid = 0;
  QStringList l = ((Q7B_List *) Arguments->ref)->toStringList();

  if (Q7B_IDbool(Wait)){
    return Q7B_ID( QProcess::execute(*((QString *) FilePath->ref), l) );
  } else {
    if (QProcess::startDetached(*((QString *) FilePath->ref), l, workingDirectory, &pid)){
      return Q7B_ID(pid);
    }
    return Q7B_ID((qint64)0);
  }
}

Q7B Q7B_SHELL(Q7B Command)
{
  if (Q7B_nil(Command)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Command))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Command);
  
  return Q7B_ID( system(s.toLocal8Bit().data()) );
}

QString Q7B_PlaySound(QString sFilePath)
{
  if (!sFilePath.contains("/") && !sFilePath.contains("\\")){
    sFilePath = qApp->applicationDirPath() + "/" + sFilePath; // otherwise the sqlite db file is expected in the q7basic ide directory
  }  

  static Phonon::MediaObject *mediaObject = 0; 
  static Phonon::AudioOutput *audioOutput = 0; 

  if (mediaObject) delete mediaObject; // TODO2 letztes gespieltes object wird nicht freigegeben, besser global deklarieren
  if (audioOutput) delete audioOutput; // TODO2 letztes gespieltes object wird nicht freigegeben, besser global deklarieren

  mediaObject = new Phonon::MediaObject();
  audioOutput = new Phonon::AudioOutput(Phonon::MusicCategory);

  mediaObject->setCurrentSource(Phonon::MediaSource( sFilePath ));   
  Phonon::createPath(mediaObject, audioOutput);
  mediaObject->seek(0);
  mediaObject->play();

  //QMessageBox::information(0,"Q7B_PlaySound", "Q7B_PlaySound"); 
  
  return ( mediaObject->state() == Phonon::ErrorState ? mediaObject->errorString() : "" );
}

Q7B Q7B_PLAYSOUND(Q7B FileName)
{
  if (Q7B_nil(FileName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
   
  return Q7B_ID( Q7B_PlaySound(Q7B_IDQString(FileName)) );
}

Q7B Q7B_PLAYMOVIE(Q7B FileName)
{
  //return Q7B_ID("Sorry. Qt Bug in Qt 4.7.0 prevents this function working with Q7Basic yet.");

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
    //QMessageBox::information(0, "1", "");

  Q7BMovie *my_movie = new Q7BMovie(0);
  //QWidget *my_movie = new Q7BMovie(0);
  my_movie->setWindowFlags(Qt::Window);// | Qt::CustomizeWindowHint | Qt::WindowSystemMenuHint | Qt::WindowTitleHint | Qt::WindowMinimizeButtonHint);

  my_movie->setWindowFlags(Qt::Window);// | Qt::CustomizeWindowHint | Qt::FramelessWindowHint);

  QPixmap p(1, 1);
  p.fill(QColor(0, 0, 0, 0));
  my_movie->setCursor(p);
  //my_movie->enterFullScreen();
 // my_movie->setFullScreen(true);
  my_movie->showFullScreen();

  Phonon::MediaObject *mediaObject = new Phonon::MediaObject(my_movie);
  Phonon::createPath(mediaObject, my_movie);
  Phonon::AudioOutput *audioOutput = new Phonon::AudioOutput(Phonon::VideoCategory, my_movie);
  Phonon::createPath(mediaObject, audioOutput);
  mediaObject->setCurrentSource( Q7B_IDQString(FileName) );
  mediaObject->play();

  QString s;
  do {
    qApp->processEvents();
  } while (mediaObject->state() == Phonon::LoadingState || mediaObject->state() == Phonon::BufferingState || mediaObject->state() == Phonon::PlayingState);

  if (mediaObject->state() == Phonon::ErrorState){
    s = mediaObject->errorString();
  }

  //QMessageBox::information(0, "4", "");

  my_movie->close();
  delete audioOutput;
  delete mediaObject;
  delete my_movie;  

 return Q7B_ID(s);

/*
  Phonon::MediaObject *mediaObject = new Phonon::MediaObject(my_movie);
  Phonon::createPath(mediaObject, my_movie);
  Phonon::AudioOutput *audioOutput = new Phonon::AudioOutput(Phonon::VideoCategory, my_movie);
  Phonon::createPath(mediaObject, audioOutput);
  mediaObject->setCurrentSource( Q7B_IDQString(FileName) );

    //QMessageBox::information(0, "2", "");

  QPixmap p(1, 1);
  p.fill(QColor(0, 0, 0, 0));
  my_movie->setCursor(p);
  //my_movie->enterFullScreen();
  my_movie->showMaximized();
  mediaObject->play();

     // QMessageBox::information(0, "3", "");

  QString s;
  do {
    qApp->processEvents();
  } while (mediaObject->state() == Phonon::LoadingState || mediaObject->state() == Phonon::BufferingState || mediaObject->state() == Phonon::PlayingState);

  if (mediaObject->state() == Phonon::ErrorState){
    s = mediaObject->errorString();
  }

  //QMessageBox::information(0, "4", "");

  my_movie->close();
  delete audioOutput;
  delete mediaObject;
  delete my_movie;
  
  return Q7B_ID( s );*/
}

void Q7B_fromXMLDictionary(QXmlStreamReader * xmlReader, Q7B_Dictionary *d, Q7B theArray2, Q7B theType2)
{
   QString sKey;

   while(!xmlReader->atEnd()){

      // QMessageBox::information(0, "array2", xmlReader->name().toString());

     if (xmlReader->isStartElement()){

        if (xmlReader->name() == "key")       
        {
          sKey = xmlReader->readElementText(); 
        }
        else if (xmlReader->name() == "integer")       
        {

          if (theArray2.isNull() && theType2.isNull()){
            d->me[sKey] = Q7B_ID( xmlReader->readElementText().toInt() );   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID( xmlReader->readElementText().toInt() ));
          } else {
            theType2->q7b_type->append(Q7B_ID( xmlReader->readElementText().toInt() ));
          }      

/*
          if (theArray2.isNull()){
            d->me[sKey] = Q7B_ID( xmlReader->readElementText().toInt() );   
          } else {
            theArray2->q7b_array->append(Q7B_ID( xmlReader->readElementText().toInt() ));
          }            
          */
        }
        else if (xmlReader->name() == "float")
        {

          if (theArray2.isNull() && theType2.isNull()){
            d->me[sKey] = Q7B_ID( xmlReader->readElementText().toDouble() );   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID( xmlReader->readElementText().toDouble() ));
          } else {
            theType2->q7b_type->append(Q7B_ID( xmlReader->readElementText().toDouble() ));
          }      

        }
        else if (xmlReader->name() == "boolean")
        {

          if (theArray2.isNull() && theType2.isNull()){
            d->me[sKey] = Q7B_ID( xmlReader->readElementText() == "0" ? false : true );   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID( xmlReader->readElementText() == "0" ? false : true ));
          } else {
            theType2->q7b_type->append(Q7B_ID( xmlReader->readElementText() == "0" ? false : true ));
          }      

        }
        else if (xmlReader->name() == "string")
        {

          if (theArray2.isNull() && theType2.isNull()){
            d->me[sKey] = Q7B_ID( xmlReader->readElementText() );   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID( xmlReader->readElementText() ));
          } else {
            theType2->q7b_type->append(Q7B_ID( xmlReader->readElementText() ));
          }       
/*
          if (theArray2.isNull()){
            d->me[sKey] = Q7B_ID( xmlReader->readElementText() );   
          } else {
            theArray2->q7b_array->append(Q7B_ID( xmlReader->readElementText() ));
          }   
          */
        }
        else if (xmlReader->name() == "datetime")
        {

          if (theArray2.isNull() && theType2.isNull()){
            d->me[sKey] = Q7B_ID( QDateTime::fromString(xmlReader->readElementText(), "yyyy-MM-dd hh:mm:ss") );   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID( QDateTime::fromString(xmlReader->readElementText(), "yyyy-MM-dd hh:mm:ss") ));
          } else {
            theType2->q7b_type->append(Q7B_ID( QDateTime::fromString(xmlReader->readElementText(), "yyyy-MM-dd hh:mm:ss") ));
          }      

        }
        else if (xmlReader->name() == "decimal")
        {

          if (theArray2.isNull() && theType2.isNull()){
            d->me[sKey] = Q7B_ID( Q7B_Decimal(xmlReader->readElementText()) );   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID( Q7B_Decimal(xmlReader->readElementText()) ));
          } else {
            theType2->q7b_type->append(Q7B_ID( Q7B_Decimal(xmlReader->readElementText()) ));            
          }      

        }
        else if (xmlReader->name() == "null")
        {
          xmlReader->readElementText();

          if (theArray2.isNull() && theType2.isNull()){
            d->me[sKey] = Q7B_idnil;   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_idnil);
          } else {
            theType2->q7b_type->append(Q7B_idnil);            
          }      

        }
        else if (xmlReader->name() == "QByteArray")
        {
          QByteArray ba = QByteArray::fromBase64(xmlReader->readElementText().toAscii());

          if (theArray2.isNull() && theType2.isNull()){
            d->me[sKey] = Q7B_ID(ba); 
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID(ba));
          } else {
            theType2->q7b_type->append(Q7B_ID(ba));            
          }      

        }
        else if (xmlReader->name() == "QIcon")
        {

          QByteArray ba = QByteArray::fromBase64(xmlReader->readElementText().toAscii());

          if (theArray2.isNull() && theType2.isNull()){
            d->me[sKey] = Q7B_ID(Q7B_QByteArray2QIcon(ba)); 
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID(Q7B_QByteArray2QIcon(ba)));
          } else {
            theType2->q7b_type->append(Q7B_ID(Q7B_QByteArray2QIcon(ba)));            
          }      
          
        }
        else if (xmlReader->name() == "list" || xmlReader->name() == "array") // array provided for compatibility for IDS
        {
          Q7B_List *aa = new Q7B_List();
          Q7B q (new Q7B_id(typeid(Q7B_List).name(), aa));   

          if (theArray2.isNull() && theType2.isNull()){
            d->me[sKey] = q; 
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(q);
          } else {
            theType2->q7b_type->append(q);            
          }       

          xmlReader->readNext();

          Q7B theArray;
          Q7B theType;
          Q7B_fromXMLList(xmlReader, aa, theArray, theType);

          xmlReader->readNext();

          //  QMessageBox::information(0, "", "array2");

        }
        else if (xmlReader->name() == "dictionary")
        {
          if (d == 0) return;

          Q7B_Dictionary *dd = new Q7B_Dictionary();
          Q7B q (new Q7B_id(typeid(Q7B_Dictionary).name(), dd));   

          if (theArray2.isNull() && theType2.isNull()){
            d->me[sKey] = q; 
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(q);
          } else {
            theType2->q7b_type->append(q);            
          }       

          xmlReader->readNext();

          Q7B theArray;
          Q7B theType;
          Q7B_fromXMLDictionary(xmlReader, dd, theArray, theType);

          xmlReader->readNext();
        
        }
        else if (xmlReader->name() == "array2")
        {

          Q7B q (new Q7B_id());   

          
          if (theArray2.isNull() && theType2.isNull()){
            d->me[sKey] = q; 
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(q);
          } else {
            theType2->q7b_type->append(q);
          }       
          /*
          if (theArray2.isNull()){
            d->me[sKey] = q; 
          } else {
            theArray2->q7b_array->append(q);
          }      */             

          xmlReader->readNext();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "count")) return;
          q->q7b_array_count = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index0")) return;
          q->array_indexes[0] = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index1")) return;
          q->array_indexes[1] = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index2")) return;
          q->array_indexes[2] = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index3")) return;
          q->array_indexes[3] = xmlReader->readElementText().toInt();

          q->q7b_array = new QVector<Q7B>;

          xmlReader->readNext();

          Q7B theType;
          Q7B_fromXMLDictionary(xmlReader, d, q, theType);

          xmlReader->readNext();

        }
        else if (xmlReader->name() == "type")
        {

          Q7B q (new Q7B_id());   

          if (theArray2.isNull() && theType2.isNull()){
            d->me[sKey] = q; 
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(q);
          } else {
            theType2->q7b_type->append(q);
          }       
          
          xmlReader->readNext();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "count")) return;
          int n = xmlReader->readElementText().toInt();

          q->q7b_type = new QVector<Q7B>;

          xmlReader->readNext();
                    
          Q7B theArray;
          
          for (int wq = 0; wq < n; wq++){
            Q7B_fromXMLDictionary(xmlReader, d, theArray, q);
          }

          xmlReader->readNext();

        }
        else
        {                            
          xmlReader->raiseError();
          return;
        }

     } else if (xmlReader->isEndElement()){

       if (theArray2.isNull() && xmlReader->name() == "dictionary"){
         return;
       } else if (!theArray2.isNull() && xmlReader->name() == "array2"){
         return;
       } else if (!theType2.isNull() && xmlReader->name() == "type"){
         return;
       } else {
         xmlReader->readNext();
       }
     } else {
       xmlReader->readNext();
     }

   }
}

void Q7B_fromXMLList(QXmlStreamReader * xmlReader, Q7B_List *a, Q7B theArray2, Q7B theType2)
{
   while(!xmlReader->atEnd()){      

     if (xmlReader->isStartElement()){

        if (xmlReader->name() == "integer")       
        {

          if (theArray2.isNull() && theType2.isNull()){
            a->me << Q7B_ID( xmlReader->readElementText().toInt() );   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID( xmlReader->readElementText().toInt() ));
          } else {
            theType2->q7b_type->append(Q7B_ID( xmlReader->readElementText().toInt() ));
          }          
        }
        else if (xmlReader->name() == "float")
        {

          if (theArray2.isNull() && theType2.isNull()){
            a->me << Q7B_ID( xmlReader->readElementText().toDouble() );   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID( xmlReader->readElementText().toDouble() ));
          } else {
            theType2->q7b_type->append(Q7B_ID( xmlReader->readElementText().toDouble() ));            
          }          

        }
        else if (xmlReader->name() == "boolean")
        {

          if (theArray2.isNull() && theType2.isNull()){
            a->me << Q7B_ID( xmlReader->readElementText() == "0" ? false : true );   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID( xmlReader->readElementText() == "0" ? false : true ));
          } else {
            theType2->q7b_type->append(Q7B_ID( xmlReader->readElementText() == "0" ? false : true ));            
          }          

        }
        else if (xmlReader->name() == "string")
        {

          if (theArray2.isNull() && theType2.isNull()){
            a->me << Q7B_ID( xmlReader->readElementText( )); 
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID( xmlReader->readElementText( )));
          } else {
            theType2->q7b_type->append(Q7B_ID( xmlReader->readElementText( )));            
          }          

        }
        else if (xmlReader->name() == "datetime")
        {

          if (theArray2.isNull() && theType2.isNull()){
            a->me << Q7B_ID( QDateTime::fromString(xmlReader->readElementText(), "yyyy-MM-dd hh:mm:ss") ); 
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID( QDateTime::fromString(xmlReader->readElementText(), "yyyy-MM-dd hh:mm:ss") ));
          } else {
            theType2->q7b_type->append(Q7B_ID( QDateTime::fromString(xmlReader->readElementText(), "yyyy-MM-dd hh:mm:ss") ));            
          }          

        }
        else if (xmlReader->name() == "decimal")
        {

          if (theArray2.isNull() && theType2.isNull()){
            a->me << Q7B_ID( Q7B_Decimal(xmlReader->readElementText()) ); 
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID( Q7B_Decimal(xmlReader->readElementText()) ));
          } else {
            theType2->q7b_type->append(Q7B_ID( Q7B_Decimal(xmlReader->readElementText()) ));            
          }          
        }
        else if (xmlReader->name() == "null")
        {
          xmlReader->readElementText();

          if (theArray2.isNull() && theType2.isNull()){
            a->me << Q7B_idnil; 
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_idnil);
          } else {
            theType2->q7b_type->append(Q7B_idnil);            
          }          

        }
        else if (xmlReader->name() == "QByteArray")
        {
          QByteArray ba = QByteArray::fromBase64(xmlReader->readElementText().toAscii());

          if (theArray2.isNull() && theType2.isNull()){
            a->me << Q7B_ID(ba); 
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID(ba));
          } else {
            theType2->q7b_type->append(Q7B_ID(ba));            
          }          
 
        }
        else if (xmlReader->name() == "QIcon")
        {
          QByteArray ba = QByteArray::fromBase64(xmlReader->readElementText().toAscii());

          if (theArray2.isNull() && theType2.isNull()){
            a->me << Q7B_ID(Q7B_QByteArray2QIcon(ba)); 
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(Q7B_ID(Q7B_QByteArray2QIcon(ba)));
          } else {
            theType2->q7b_type->append(Q7B_ID(Q7B_QByteArray2QIcon(ba)));            
          }          

        }
        else if (xmlReader->name() == "list" || xmlReader->name() == "array") // array provided for compatibility for IDS
        {
          Q7B_List *aa = new Q7B_List();
          Q7B q (new Q7B_id(typeid(Q7B_List).name(), aa));   

          if (theArray2.isNull() && theType2.isNull()){
            a->me << q;   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(q);
          } else {
            theType2->q7b_type->append(q);            
          }          

          xmlReader->readNext();

          Q7B theArray;
          Q7B theType;
          Q7B_fromXMLList(xmlReader, aa, theArray, theType);

          xmlReader->readNext();

        }
        else if (xmlReader->name() == "dictionary")
        {
          Q7B_Dictionary *dd = new Q7B_Dictionary();
          Q7B q (new Q7B_id(typeid(Q7B_Dictionary).name(), dd));   

          if (theArray2.isNull() && theType2.isNull()){
            a->me << q;   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(q);
          } else {
            theType2->q7b_type->append(q);            
          }       

          xmlReader->readNext();

          Q7B theArray;
          Q7B theType;
          Q7B_fromXMLDictionary(xmlReader, dd, theArray, theType);

          xmlReader->readNext();
        
        }
        else if (xmlReader->name() == "array2")
        {

          Q7B q (new Q7B_id());   

          if (theArray2.isNull() && theType2.isNull()){
            a->me << q;   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(q);
          } else {
            theType2->q7b_type->append(q);            
          }             

          xmlReader->readNext();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "count")) return;
          q->q7b_array_count = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index0")) return;
          q->array_indexes[0] = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index1")) return;
          q->array_indexes[1] = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index2")) return;
          q->array_indexes[2] = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index3")) return;
          q->array_indexes[3] = xmlReader->readElementText().toInt();

          q->q7b_array = new QVector<Q7B>;

          xmlReader->readNext();

          Q7B theType;
          Q7B_fromXMLList(xmlReader, a, q, theType);

          xmlReader->readNext();

        }
        else if (xmlReader->name() == "type")
        {

          Q7B q (new Q7B_id());   

          if (theArray2.isNull() && theType2.isNull()){
            a->me << q;   
          } else if (theType2.isNull()){
            theArray2->q7b_array->append(q);
          } else {
            theType2->q7b_type->append(q);            
          }         
          
          xmlReader->readNext();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "count")) return;
          int n = xmlReader->readElementText().toInt();

          q->q7b_type = new QVector<Q7B>;

          xmlReader->readNext();
                    
          Q7B theArray;
          
          for (int wq = 0; wq < n; wq++){
            Q7B_fromXMLList(xmlReader, a, theArray, q);
          }

          xmlReader->readNext();

        }
        else
        {                            
          xmlReader->raiseError();
          return;
        }

     } else if (xmlReader->isEndElement()){

       if (theArray2.isNull() && (xmlReader->name() == "list" || xmlReader->name() == "array")){ // xmlReader.name() == "array" provided for compatibility for IDS
         return;
       } else if (!theArray2.isNull() && xmlReader->name() == "array2"){
         return;
       } else if (!theType2.isNull() && xmlReader->name() == "type"){
         return;
       } else {
         xmlReader->readNext();
       }
     } else {
       xmlReader->readNext();
     }

   }
}

Q7B Q7B_READLIST(Q7B Q7B_Object)
{
  QString s = Q7B_LoadString(Q7B_Object, "");

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a));  

  QXmlStreamReader xmlReader(s.toUtf8());
  xmlReader.readNext(); // skip <?xml...
  xmlReader.readNext(); // V1.0

  while(!xmlReader.atEnd()){
//QString kkk = xmlReader.name().toString();
      
    if (xmlReader.isStartElement() && xmlReader.name() == "V1.0"){ xmlReader.readNext(); while(!xmlReader.atEnd() && !xmlReader.isStartElement()){ xmlReader.readNext(); }
     
      // xmlReader.name() == "array" provided for compatibility for IDS
      if (xmlReader.isStartElement() && (xmlReader.name() == "list" || xmlReader.name() == "array")){ xmlReader.readNext(); while(!xmlReader.atEnd() && !xmlReader.isStartElement()){ xmlReader.readNext(); }

        Q7B theArray;
        Q7B theType;
        Q7B_fromXMLList(&xmlReader, a, theArray, theType);

      }
      
    } 

    if (!xmlReader.atEnd()) xmlReader.readNext();
  }

  if (xmlReader.hasError()) return Q7B_idnil;
   
 // QMessageBox::information(0, "", xmlReader.errorString());

  return Q7B_ID( q );
}

Q7B Q7B_WRITELIST(Q7B Q7B_Object, Q7B FilePathOrURL)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_LIST(Q7B_Object))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FilePathOrURL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWhere = *((QString *) FilePathOrURL->ref);
 
  if (sWhere.startsWith("file:///")){
    sWhere = sWhere.mid(QString("file:///").length());
  }  
  
  QFile f(sWhere);
  if (!f.open(QIODevice::Truncate | QIODevice::WriteOnly)){
  } else {

    QXmlStreamWriter xmlWriter(&f);
    xmlWriter.setAutoFormatting(true);

    xmlWriter.writeStartDocument();

      xmlWriter.writeStartElement("V1.0");

        xmlWriter.writeStartElement("list");

        QList<Q7B>l = ((Q7B_List *) Q7B_Object->ref)->values();
        for (int i = 0; i < l.size(); i++){
          Q7B q = l.at(i);
          Q7B_toXML2(xmlWriter, q);
        }        

      xmlWriter.writeEndElement();

    xmlWriter.writeEndDocument();

    f.close();

    return Q7B_ID( true );
  }
  
  return Q7B_ID( false );
}

Q7B Q7B_READDICTIONARY(Q7B Q7B_Object)
{
  QString s = Q7B_LoadString(Q7B_Object, "");

  Q7B_Dictionary *d = new Q7B_Dictionary();
  Q7B q (new Q7B_id(typeid(Q7B_Dictionary).name(), d));  

  QXmlStreamReader xmlReader(s.toUtf8());
  xmlReader.readNext(); // skip <?xml...
  xmlReader.readNext(); // V1.0

  while(!xmlReader.atEnd()){
      
    if (xmlReader.isStartElement() && xmlReader.name() == "V1.0"){ xmlReader.readNext(); while(!xmlReader.atEnd() && !xmlReader.isStartElement()){ xmlReader.readNext(); }
     
      if (xmlReader.isStartElement() && xmlReader.name() == "dictionary"){ xmlReader.readNext(); while(!xmlReader.atEnd() && !xmlReader.isStartElement()){ xmlReader.readNext(); }

        Q7B theArray;
        Q7B theType;
        Q7B_fromXMLDictionary(&xmlReader, d, theArray, theType);

      }

    }

    if (!xmlReader.atEnd()) xmlReader.readNext();
  }

  if (xmlReader.hasError()) return Q7B_idnil;
   
  return Q7B_ID( q );
}

Q7B Q7B_WRITEDICTIONARY(Q7B Q7B_Object, Q7B FilePathOrURL)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DICTIONARY(Q7B_Object))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FilePathOrURL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWhere = *((QString *) FilePathOrURL->ref);
 
  if (sWhere.startsWith("file:///")){
    sWhere = sWhere.mid(QString("file:///").length());
  }  
  
  QFile f(sWhere);
  if (!f.open(QIODevice::Truncate | QIODevice::WriteOnly)){
  } else {

    QXmlStreamWriter xmlWriter(&f);
    xmlWriter.setAutoFormatting(true);

    xmlWriter.writeStartDocument();

      xmlWriter.writeStartElement("V1.0");

        xmlWriter.writeStartElement("dictionary");

        QMap<QString, Q7B>m = ((Q7B_Dictionary *) Q7B_Object->ref)->keysvalues();

        QMapIterator<QString, Q7B> i(m);
        while (i.hasNext()) {
           i.next();
           
           xmlWriter.writeTextElement("key", i.key());
           Q7B_toXML2(xmlWriter, i.value());
        }

      xmlWriter.writeEndElement();

    xmlWriter.writeEndDocument();

    f.close();

    return Q7B_ID( true );
  }
  
  return Q7B_ID( false );
}

Q7B Q7B_ISLIST(Q7B aList)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_ID( aList->type == typeid(Q7B_List).name() );
}    

Q7B Q7B_ISFLOAT(Q7B v)
{
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_ID( v->type == typeid(qreal).name() );
}    

Q7B Q7B_ISINTEGER(Q7B v)
{
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_ID( v->type == typeid(qint64).name() );
}    

Q7B Q7B_ISBOOLEAN(Q7B v)
{
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_ID( v->type == typeid(bool).name() );
}    

Q7B Q7B_ISSTRING(Q7B v)
{
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_ID( v->type == typeid(QString).name() );
}    

Q7B Q7B_ISDATETIME(Q7B v)
{
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_ID( v->type == typeid(QDateTime).name() );
}    

Q7B Q7B_ISDECIMAL(Q7B v)
{
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_ID( v->type == typeid(Q7B_Decimal).name() );
}    

// *** SQL ***********************************************************************************
/*
class SQLFormView : public QFrame
{
public:
  SQLFormView(QWidget *parent = 0) : QFrame(parent)
  {
  }

};*/

QSqlDatabase *Q7B_psqldb = 0;

Q7B Q7B_PSQLCONNECT(Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B ConnectOptions, Q7B Port)
{
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(ConnectOptions))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Port))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (!QSqlDatabase::contains("default.psql")){
    Q7B_psqldb = new QSqlDatabase(QSqlDatabase::addDatabase("QPSQL", "default.psql"));
  }
  if (Q7B_psqldb->isOpen()) Q7B_psqldb->close();

  Q7B_psqldb->setDatabaseName( Q7B_IDQString(Name) );
  Q7B_psqldb->setUserName( Q7B_IDQString(User) );
  Q7B_psqldb->setPassword( Q7B_IDQString(Password) );

  QString sHost = Q7B_IDQString(Host);
  if (!sHost.isEmpty()) Q7B_psqldb->setHostName( sHost );

  QString sConnectOptions = Q7B_IDQString(ConnectOptions);
  if (!sConnectOptions.isEmpty()) Q7B_psqldb->setConnectOptions( sConnectOptions ); 
  //else Q7B_psqldb->setConnectOptions("client_min_messages=WARNING");

  qint64 nPort = Q7B_IDqint64(Port);
  if (nPort > 0) Q7B_psqldb->setPort( nPort );      

  if (!Q7B_psqldb->open()){
    return Q7B_ID( Q7B_psqldb->lastError().text() ); 
  }
  return Q7B_ID( true );
}

void Q7B_PSQLDISCONNECT()
{
  if (Q7B_psqldb){
    Q7B_psqldb->close();
    delete Q7B_psqldb;
    Q7B_psqldb = 0;
    QSqlDatabase::removeDatabase("default.psql"); 
  }    
}

QSqlQuery Q7B_psqldbq; 
//qint64 nPSQLLastInsertQ7B = 0;

Q7B Q7B_PSQLLASTINSERTID(Q7B Table)
{  
  if (Q7B_nil(Table)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QSqlIndex i = Q7B_psqldb->driver()->primaryIndex(Q7B_IDQString(Table));
  if (i.count()){    
    qint64 oid = Q7B_psqldbq.lastInsertId().toLongLong();

    QSqlQuery q(*Q7B_psqldb);
//    QMessageBox::information(0, "Q7B_PSQLLASTINSERTID", "SELECT * FROM " + Q7B_IDQString(Table) + " WHERE oid = " + QString("%1").arg(oid));
    if (q.exec("SELECT * FROM " + Q7B_IDQString(Table) + " WHERE oid = " + QString("%1").arg(oid)) && q.first()){  
      QSqlRecord a = q.record();
      qint64 n = a.indexOf(i.fieldName(0));
      if (n >= 0) return Q7B_ID( Q7B_Variant2id(a.value(n), true, true));
    }
  }
  return Q7B_ID(0);


  /*
  if (Q7B_psqldbq.exec("SELECT currval('first_id_seq')")){
    QMessageBox::information(0, "Q7B_MYSQLCONNECT", "1");
    if (Q7B_psqldbq.first()){
      QMessageBox::information(0, "Q7B_MYSQLCONNECT", "2");
      QSqlRecord a = Q7B_psqldbq.record();   
      return Q7B_ID( Q7B_Variant2id(a.value(0)) );
    }
  }

  return Q7B_ID(0);
  */

  
  //return Q7B_ID( nPSQLLastInsertQ7B );
}

Q7B Q7B_MD5(Q7B Argument)
{  
  if (Q7B_nil(Argument)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Argument))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Argument);
  return Q7B_ID(QCryptographicHash::hash(s.toUtf8(), QCryptographicHash::Md5).toHex());
}

// TODO2 sql log f?r alle error anzeigen und sql queries ausgef?hrt
Q7B Q7B_PSQL(Q7B SQL)
{
  if (Q7B_nil(SQL)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(SQL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  QString sSQL = Q7B_IDQString(SQL);
  
  if (!Q7B_psqldb->isOpen()){   
    if (!Q7B_psqldb->open()){   
      return Q7B_ID( Q7B_psqldb->lastError().text() ); 
    }
  }

  Q7B_psqldbq = QSqlQuery(*Q7B_psqldb);

  bool b = false;

  if (Q7B_binds.count()){
    Q7B_psqldbq.prepare( sSQL );
    for (int i = 0; i < Q7B_binds.count(); i++){
      Q7B_psqldbq.bindValue(QString(":BIND%1").arg(i + 1), Q7B_id2Variant(Q7B_binds.at(i), true, true));
    }
    Q7B_binds.clear();

    b = Q7B_psqldbq.exec();
  } else {
    b = Q7B_psqldbq.exec(sSQL);
  }

  if (b){

    QMap<int, QString> fieldnames;

    if (Q7B_psqldbq.first()){      

      Q7B_List *aa = new Q7B_List();
      Q7B qa (new Q7B_id(typeid(Q7B_List).name(), aa)); // gc << qa;

      QSqlRecord a = Q7B_psqldbq.record();
      for (int i = 0; i < a.count(); i++){
        fieldnames[i] = a.fieldName(i);
      }        

      do {
        Q7B_Dictionary *d = new Q7B_Dictionary();
        Q7B qq (new Q7B_id(typeid(Q7B_Dictionary).name(), d));

        a = Q7B_psqldbq.record();
        for (int i = 0; i < a.count(); i++){
          d->me[fieldnames[i]] = Q7B_ID( Q7B_Variant2id(a.value(i), true, true) );
        }

        aa->append(qq);

      } while (Q7B_psqldbq.next());

      return Q7B_ID(qa);
      
    }

    if (!sSQL.startsWith("SELECT ", Qt::CaseInsensitive)){
      return Q7B_ID(true);
    } else {
      Q7B_List *aa = new Q7B_List();
      Q7B qa (new Q7B_id(typeid(Q7B_List).name(), aa)); // gc << qa;

      return Q7B_ID(qa);
    }
  }

  return Q7B_ID( Q7B_psqldbq.lastError().text() );
}


QSqlDatabase *Q7B_mysqldb = 0;

Q7B Q7B_MYSQLCONNECT(Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B ConnectOptions, Q7B Port)
{
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(ConnectOptions))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Port))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (!QSqlDatabase::contains("default.mysql") && Q7B_mysqldb == 0){
    //QMessageBox::information(0, "Q7B_MYSQLCONNECT", "1");
    Q7B_mysqldb = new QSqlDatabase(QSqlDatabase::addDatabase("QMYSQL", "default.mysql"));
  }
  if (Q7B_mysqldb->isOpen()) Q7B_mysqldb->close();

 // QMessageBox::information(0, "Q7B_MYSQLCONNECT", "2");

  Q7B_mysqldb->setDatabaseName( Q7B_IDQString(Name) );
  Q7B_mysqldb->setUserName( Q7B_IDQString(User) );
  Q7B_mysqldb->setPassword( Q7B_IDQString(Password) );

  //QMessageBox::information(0, "Q7B_MYSQLCONNECT", "3");

  QString sHost = Q7B_IDQString(Host);
  if (!sHost.isEmpty()) Q7B_mysqldb->setHostName( sHost );

 // QMessageBox::information(0, "Q7B_MYSQLCONNECT", "4");

  QString sConnectOptions = Q7B_IDQString(ConnectOptions);
  if (!sConnectOptions.isEmpty()) Q7B_mysqldb->setConnectOptions( sConnectOptions ); 

  qint64 nPort = Q7B_IDqint64(Port);
  if (nPort > 0) Q7B_mysqldb->setPort( nPort );    

  //QMessageBox::information(0, "Q7B_MYSQLCONNECT", "5");

  if (!Q7B_mysqldb->open()){
    return Q7B_ID( Q7B_mysqldb->lastError().text() ); 
  }
  return Q7B_ID( true );
}

void Q7B_MYSQLDISCONNECT()
{
  if (Q7B_mysqldb){
    Q7B_mysqldb->close();
    delete Q7B_mysqldb;
    Q7B_mysqldb = 0;
    QSqlDatabase::removeDatabase("default.mysql"); 
  }  
}

QSqlQuery Q7B_mysqldbq;

Q7B Q7B_MYSQLLASTINSERTID()
{
  return Q7B_ID( Q7B_mysqldbq.lastInsertId().toLongLong() );
}

Q7B Q7B_MYSQL(Q7B SQL)
{
  if (Q7B_nil(SQL)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(SQL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sSQL = Q7B_IDQString(SQL);
  
  if (!Q7B_mysqldb->isOpen()){   
    if (!Q7B_mysqldb->open()){   
      return Q7B_ID( Q7B_mysqldb->lastError().text() ); 
    }
  }

  Q7B_mysqldbq = QSqlQuery(*Q7B_mysqldb);


  bool b = false;

  if (Q7B_binds.count()){
    Q7B_mysqldbq.prepare( sSQL );
    for (int i = 0; i < Q7B_binds.count(); i++){
      Q7B_mysqldbq.bindValue(QString(":BIND%1").arg(i + 1), Q7B_id2Variant(Q7B_binds.at(i), true, true));
    }
    Q7B_binds.clear();

    b = Q7B_mysqldbq.exec();
  } else {
    b = Q7B_mysqldbq.exec(sSQL);
  }

  if (b){

    QMap<int, QString> fieldnames;

    if (Q7B_mysqldbq.first()){
      Q7B_List *aa = new Q7B_List();
      Q7B qa (new Q7B_id(typeid(Q7B_List).name(), aa)); // gc << qa;


      QSqlRecord a = Q7B_mysqldbq.record();
      for (int i = 0; i < a.count(); i++){
        fieldnames[i] = a.fieldName(i);
      }        

      do {
        Q7B_Dictionary *d = new Q7B_Dictionary();
        Q7B qq (new Q7B_id(typeid(Q7B_Dictionary).name(), d));

        a = Q7B_mysqldbq.record();
        for (int i = 0; i < a.count(); i++){
          d->me[fieldnames[i]] = Q7B_ID( Q7B_Variant2id(a.value(i), true, true) );
        }

        aa->append(qq);

      } while (Q7B_mysqldbq.next());

      return Q7B_ID(qa);
      
    }

    if (!sSQL.startsWith("SELECT ", Qt::CaseInsensitive)){
      return Q7B_ID(true);
    } else {
      Q7B_List *aa = new Q7B_List();
      Q7B qa (new Q7B_id(typeid(Q7B_List).name(), aa)); // gc << qa;

      return Q7B_ID(qa);
    }

  }

  return Q7B_ID( Q7B_mysqldbq.lastError().text() );
}

QSqlQuery Q7B_sqliteq;

Q7B Q7B_SQLITELASTINSERTID()
{
  return Q7B_ID( Q7B_sqliteq.lastInsertId().toLongLong() );
}

QMap<QString, QSqlDatabase*> Q7B_sqlite_dbs; // TODO2 close all connections on shutdown

Q7B Q7B_SQLITE(Q7B SQL, Q7B FilePath)
{
  if (Q7B_nil(SQL)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(SQL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sSQL = Q7B_IDQString(SQL);

  QString sFilePath = Q7B_IDQString(FilePath);
  if (!sFilePath.contains("/") && !sFilePath.contains("\\")){
    sFilePath = qApp->applicationDirPath() + "/" + sFilePath; // otherwise the sqlite db file is expected in the q7basic ide directory
  }  

  if (!Q7B_sqlite_dbs.contains( sFilePath )){
    QSqlDatabase *db = new QSqlDatabase(QSqlDatabase::addDatabase("QSQLITE", sFilePath + ".sqlite"));
    db->setDatabaseName( sFilePath );
    if (!db->open()){
      return Q7B_ID( db->lastError().text() ); 

    }
    Q7B_sqlite_dbs[ sFilePath ] = db;
  }

  if (!Q7B_sqlite_dbs[ sFilePath ]->isOpen()){   
    if (!Q7B_sqlite_dbs[ sFilePath ]->open()){   
      return Q7B_ID( Q7B_sqlite_dbs[ sFilePath ]->lastError().text() ); 
    }
  }

  Q7B_sqliteq = QSqlQuery(*Q7B_sqlite_dbs[ sFilePath ]);


  bool b = false;

  if (Q7B_binds.count()){
    Q7B_sqliteq.prepare( sSQL );
    for (int i = 0; i < Q7B_binds.count(); i++){

      Q7B_sqliteq.bindValue(QString(":BIND%1").arg(i + 1), Q7B_id2Variant(Q7B_binds.at(i), true, true));
    }
    Q7B_binds.clear();

    b = Q7B_sqliteq.exec();
  } else {
    b = Q7B_sqliteq.exec(sSQL);
  }

  if (b){

  //QMessageBox::information(0, "executedQuery", Q7B_sqliteq.executedQuery());
    

    QMap<int, QString> fieldnames;


    if (Q7B_sqliteq.first()){

      Q7B_List *aa = new Q7B_List();
      Q7B qa (new Q7B_id(typeid(Q7B_List).name(), aa)); // gc << qa;

      QSqlRecord a = Q7B_sqliteq.record();
      for (int i = 0; i < a.count(); i++){
        fieldnames[i] = a.fieldName(i);
      }        

      do {
        Q7B_Dictionary *d = new Q7B_Dictionary();
        Q7B qq (new Q7B_id(typeid(Q7B_Dictionary).name(), d));

        a = Q7B_sqliteq.record();
        for (int i = 0; i < a.count(); i++){
          d->me[fieldnames[i]] = Q7B_ID( Q7B_Variant2id(a.value(i), true, true) );
        }

        aa->append(qq);

      } while (Q7B_sqliteq.next());

      Q7B_sqliteq.clear();

      return Q7B_ID(qa);
      
    }

    if (!sSQL.startsWith("SELECT ", Qt::CaseInsensitive)){
      return Q7B_ID(true);
    } else {
      Q7B_List *aa = new Q7B_List();
      Q7B qa (new Q7B_id(typeid(Q7B_List).name(), aa)); // gc << qa;

      return Q7B_ID(qa);
    }
  }

  return Q7B_ID( Q7B_sqliteq.lastError().text() );
}

void Q7B_CLOSEALLDATABASES()
{
  Q7B_MYSQLDISCONNECT();
  Q7B_PSQLDISCONNECT();

  QMapIterator<QString, QSqlDatabase*> i(Q7B_sqlite_dbs);
  while (i.hasNext()) {
     i.next();
     QSqlDatabase *db = i.value();
     db->close();
     delete db;    
     QSqlDatabase::removeDatabase(i.key() + ".sqlite"); 
  }
  Q7B_sqlite_dbs.clear();

}

Q7B Q7B_SQLBLOB(Q7B v)
{  
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  Q7B_binds.append(v);  

  return Q7B_ID( QString(":BIND%1").arg(Q7B_binds.count()) );
}    

Q7B Q7B_SQLTEXT(Q7B v)
{  
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  Q7B_binds.append(v);  

  return Q7B_ID( QString(":BIND%1").arg(Q7B_binds.count()) );
}    

Q7B Q7B_SQLBOOLEAN(Q7B v)
{  
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  Q7B_binds.append(v);  

  return Q7B_ID( QString(":BIND%1").arg(Q7B_binds.count()) );
}    

Q7B Q7B_SQLINTEGER(Q7B v)
{  
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  Q7B_binds.append(v);  

  return Q7B_ID( QString(":BIND%1").arg(Q7B_binds.count()) );
}    

Q7B Q7B_SQLFLOAT(Q7B v)
{  
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  Q7B_binds.append(v);  

  return Q7B_ID( QString(":BIND%1").arg(Q7B_binds.count()) );
}    

// *** CONTROL ***********************************************************************************

void Q7B_Control_constructor(QWidget *o)
{

  /*
  bBackgroundStyle = false;

  my_form = f;

  nTimerId = 0;

  nSingleShot = 0;

  bForm = my_form ? my_form_isForm(my_form) : true;
  */  
  o->setProperty("Value", "");
  o->setProperty("OldValue", "");

  o->setProperty("Name", "");
  o->setProperty("Layout", "");
  o->setProperty("ControlType", "");

  o->setProperty("X", 0);
  o->setProperty("Y", 0);
  o->setProperty("Width", 0);
  o->setProperty("Height", 0);

  o->setProperty("LoadedX", 0);
  o->setProperty("LoadedY", 0);
  o->setProperty("LoadedWidth", 0);
  o->setProperty("LoadedHeight", 0);
  //o->setProperty("MultiPage", 0);


  o->setProperty("OldX", 0);
  o->setProperty("GlobalX", 0);
  o->setProperty("OldY", 0);
  o->setProperty("GlobalY", 0);
  o->setProperty("OldWidth", 0);
  o->setProperty("OldHeight", 0);

  /*
#ifdef _FORM
  o->setProperty("Opacity", 0);
#endif

#if defined(_CHILDCONTROL)
#elif defined(_VSPLIT)
#elif defined(_HSPLIT)
#elif defined(_VHBOX)
#elif defined(_VBOX)
#elif defined(_HBOX)
#elif defined(_TAB)
    o->setProperty("DrawOnPaint", false);
    SETPROPERTY_DrawOnPaint(true);
#elif defined(_HIDDEN)
#elif defined(_TIMER)
    o->setProperty("DrawOnPaint", false);
    SETPROPERTY_DrawOnPaint(true);
#elif defined(_UDPSOCKET)
    o->setProperty("DrawOnPaint", false);
    SETPROPERTY_DrawOnPaint(true);
#elif defined(_SERIALPORT)
    o->setProperty("DrawOnPaint", false);
    SETPROPERTY_DrawOnPaint(true);
#elif defined(_SOUND)
    o->setProperty("DrawOnPaint", false);
    SETPROPERTY_DrawOnPaint(true);
#elif defined(_HEADER)
#elif defined(_FOOTER)
#else
  if (bForm){
  */
    o->setProperty("Group", "");  
    o->setProperty("Palette", "");
    o->setProperty("Mask", "");  
    o->setProperty("MouseTracking", false);    
    o->setProperty("DrawOnPaint", true);
    /*SETPROPERTY_DrawOnPaint(true);
  }*/
/*
#endif

#if defined(_CHILDCONTROL)
#elif defined(_HIDDEN)
#elif defined(_TIMER)
#elif defined(_UDPSOCKET)
#elif defined(_SERIALPORT)
#elif defined(_SOUND)
#elif defined(_HEADER)
#elif defined(_FOOTER)
#else*/
  o->setProperty("Background", "");
  o->setProperty("BackgroundStyle", "");
/*#endif  


#if defined(_HIDDEN)
#elif defined(_TIMER)
#elif defined(_UDPSOCKET)
#elif defined(_SERIALPORT)
#elif defined(_HEADER)
#elif defined(_FOOTER)
#else
  if (bForm){*/
    o->setProperty("MinimumWidth", 0);
    o->setProperty("MinimumHeight", 0);
    o->setProperty("MaximumWidth", 0);
    o->setProperty("MaximumHeight", 0);
 /* }
#endif*/
  o->setProperty("Tag", "");

  /*
#ifdef _FRAME
#elif defined(_HIDDEN)
#elif defined(_CHILDCONTROL)
#elif defined(_VSPLIT)
#elif defined(_HSPLIT)
#elif defined(_VHBOX)
#elif defined(_VBOX)
#elif defined(_HBOX)
#elif defined(_BOX)
#elif defined(_RESIZEBOX)
#elif defined(_SCROLLBOX)
#elif defined(_TIMER)
#elif defined(_UDPSOCKET)
#elif defined(_SERIALPORT)
#elif defined(_HEADER)
#elif defined(_FOOTER)
#else
  if (bForm){*/
    o->setProperty("DragDrop", false);
    o->setProperty("FocusPolicy", "");
    o->setProperty("FocusProxy", "");
    o->setProperty("FocusOrder", 0);
 /* }
#endif  

#if defined(_MENUBARITEM)
#elif defined(_TOOLBARITEM)
#else*/
  o->setProperty("TimerInterval", 0);
/*#endif 

#if defined(_HIDDEN)
#elif defined(_HEADER)
#elif defined(_FOOTER)
#elif defined(_CHILDCONTROL)
#elif defined(_VSPLIT)
#elif defined(_HSPLIT)
#elif defined(_VHBOX)
#elif defined(_VBOX)
#elif defined(_HBOX)

#elif defined(_BOX)
*/
  o->setProperty("Visible", false);
  /*if (bForm) */o->setProperty("Cursor", "");
  /*if (bForm)*/ o->setProperty("CursorAnimation", "");
  /*
#elif defined(_RESIZEBOX)
  o->setProperty("Visible", false);
  if (bForm) o->setProperty("Cursor", "");
  if (bForm) o->setProperty("CursorAnimation", "");
#elif defined(_TIMER)
  o->setProperty("Enabled", false);
#elif defined(_UDPSOCKET)
  o->setProperty("Enabled", false);
#elif defined(_SERIALPORT)
  o->setProperty("Enabled", false);
#else

  if (bForm) o->setProperty("Cursor", "");
  if (bForm) o->setProperty("CursorAnimation", "");
  #if defined(_IMAGE)
  #elif defined(_BOX)
  #elif defined(_RESIZEBOX)
  #elif defined(_COMMANDLINKBUTTON)
  o->setProperty("FontName", "");
  o->setProperty("FontItalic", false);
  o->setProperty("FontUnderline", false);
  o->setProperty("FontColor", "");
  #else*/
  o->setProperty("FontName", "");
  o->setProperty("FontSize", 0);
  o->setProperty("FontItalic", false);
  o->setProperty("FontBold", false);
  o->setProperty("FontUnderline", false);
  o->setProperty("FontColor", "");
  /*
  #endif

  if (bForm) */
  o->setProperty("Enabled", true);
 
  //o->setProperty("Visible", false);
//#endif
  o->setProperty("ParentForm", "");
  o->setProperty("ParentControl", "");
/*
  o->setProperty("BoxIndex", 0);
  o->setProperty("BoxX", 0);
  o->setProperty("BoxY", 0);
  o->setProperty("SplitIndex", 0);
  o->setProperty("TabIndex", 0);
  o->setProperty("ParentIndex", 0);*/

  /*
#ifdef _LABEL
  if (bForm) o->setProperty("Scale", false);
#endif*//*

#if defined(_HIDDEN)
#elif defined(_CHILDCONTROL)
#elif defined(_VSPLIT)
#elif defined(_HSPLIT)
#elif defined(_VHBOX)
#elif defined(_VBOX)
#elif defined(_HBOX)
#elif defined(_TIMER)
  // CONTROL
#elif defined(_UDPSOCKET)
#elif defined(_SERIALPORT)
#elif defined(_HEADER)
#elif defined(_FOOTER)
#else
  if (bForm){*/
    o->setProperty("StatusTip", "");
    o->setProperty("ToolTip", "");
    o->setProperty("StyleSheet", "");
    o->setProperty("WhatsThis", "");
 /* }
#endif

#if defined(_LISTBOX) || defined(_COMBOBOX) || defined(_TREEVIEW)
  o->setProperty("CSV", "");
#endif
*/

   
//#if defined(_LABEL) || defined(_SOUND) || defined(_IMAGE) || defined(_MOVIE) || defined(_BROWSER) || defined(_WEB) || defined(_TEXTBOX) || defined(_COMBOBOX) || defined(_LISTBOX) || defined(_CHECKBOX) || defined(_DATEBOX) || defined(_TIMEBOX)/* || defined(_DATETIMEBOX)*/ || defined(_EDITOR)
//  o->setProperty("SQLName", "");
/*#ifdef _FORM
#else
  o->setProperty("SQLRelation", "");
  o->setProperty("TableViewCaption", "");
  o->setProperty("TableViewSort", "");
  o->setProperty("TableViewFilter", "");
  o->setProperty("TableViewWidth", 0);
  o->setProperty("TableViewVisible", false);

  SETPROPERTY_TableViewVisible(true);

  o->setProperty("TableViewOrder", 0);
#endif

#endif

#if defined(_TIMER)
#elif defined(_UDPSOCKET)
  o->setProperty("OnOpen", pt_event);
  o->setProperty("OnClose", pt_event);
#elif defined(_SERIALPORT)
#elif defined(_COMBOBOX)
  o->setProperty("OnEditTextChanged", pt_event); 
#elif defined(_VBOX)
#elif defined(_HBOX)
#elif defined(_VHBOX)
#elif defined(_VSPLIT)
#elif defined(_HSPLIT)
#elif defined(_CHILDCONTROL)
#elif defined(_HEADER)
#elif defined(_FOOTER)
#elif defined(_SCROLLBOX)
  o->setProperty("OnShow", pt_event);
  o->setProperty("OnHide", pt_event);
  o->setProperty("OnMove", pt_event);
  o->setProperty("OnResize", pt_event);
#elif defined(_HIDDEN)
  o->setProperty("OnClick", pt_event);
  o->setProperty("OnDblClick", pt_event);
  o->setProperty("OnMouseDown", pt_event);
  o->setProperty("OnMouseUp", pt_event);
  o->setProperty("OnMouseMove", pt_event);
  o->setProperty("OnEnter", pt_event);
  o->setProperty("OnExit", pt_event);
  o->setProperty("OnContextMenu", pt_event);
  o->setProperty("OnMouseWheel", pt_event);
#elif defined(_IMAGE) || defined(_FRAME) || defined(_LABEL) || defined(_TAB) || defined(_PROGRESSBAR) || defined(_BOX)
  if (bForm){
    o->setProperty("OnShow", pt_event);
    o->setProperty("OnHide", pt_event);
    o->setProperty("OnPaint", pt_event);
    o->setProperty("OnMove", pt_event);
    o->setProperty("OnResize", pt_event);
  } else {
#ifdef _BOX
    o->setProperty("OnPaint", pt_event);
#endif
  }
#else
  if (bForm){
    o->setProperty("OnClick", pt_event);
    o->setProperty("OnDblClick", pt_event);
    o->setProperty("OnMouseDown", pt_event);
    o->setProperty("OnMouseUp", pt_event);
    o->setProperty("OnMouseMove", pt_event);
    o->setProperty("OnGotFocus", pt_event);
    o->setProperty("OnLostFocus", pt_event);
    o->setProperty("OnEnter", pt_event);
    o->setProperty("OnExit", pt_event);
    o->setProperty("OnKeyDown", pt_event);
    o->setProperty("OnKeyUp", pt_event);
    o->setProperty("OnKeyPress", pt_event);
    o->setProperty("OnDragEnter", pt_event);
    o->setProperty("OnDragMove", pt_event);
    o->setProperty("OnDragExit", pt_event);
    o->setProperty("OnDrop", pt_event);
    o->setProperty("OnContextMenu", pt_event);
    o->setProperty("OnMouseWheel", pt_event);
    o->setProperty("OnShow", pt_event);
    o->setProperty("OnHide", pt_event);
    o->setProperty("OnMove", pt_event);
    o->setProperty("OnResize", pt_event);
    o->setProperty("OnSingleShot", pt_event);
    o->setProperty("OnEnabled", pt_event);
    o->setProperty("OnDisabled", pt_event);
  }
#endif

#if defined(_CHILDCONTROL)
#elif defined(_UDPSOCKET)
#elif defined(_SERIALPORT)
#else
  if (bForm){
    o->setProperty("OnEnabled", pt_event);
    o->setProperty("OnDisabled", pt_event);
    o->setProperty("OnSingleShot", pt_event);
  } else {
  }
#endif

#endif
*/
} 


void Q7B_ControlHelper::frameChanged(int)
{
  q7b_super->setMyIcon2();
}

void Q7B_Control::setMyIcon(QString n)
{  
  //QMessageBox::information(0,"setMyIcon", "1"); 
  
  if (qobject_cast<Q7B_Label *>((QWidget *) q7b_super)){
     //QMessageBox::information(0,"!!!!!!", "1"); 
    if (n.isEmpty()){
      ((Q7B_Label *) this)->setPixmap(QPixmap());
      return;
    }
  } else if (qobject_cast<Q7B_ToolButton *>((QWidget *) q7b_super)){
    if (n.isEmpty()){
      ((Q7B_ToolButton *) this)->setToolButtonStyle(Qt::ToolButtonTextOnly);
      return;
    } else {
      if (((Q7B_ToolButton *) this)->text().isEmpty()){
        ((Q7B_ToolButton *) this)->setToolButtonStyle(Qt::ToolButtonIconOnly);
      } else {
        ((Q7B_ToolButton *) this)->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
      }      
    }
  }

  //QMessageBox::information(0,"2222", "1"); 

   bool bMovie = false;

   QList<QByteArray> l = QMovie::supportedFormats();
   for (int i = 0; i < l.size(); ++i) {
      QString ss(l.at(i));
      if (n.endsWith("." + ss, Qt::CaseInsensitive)){
        bMovie = true;
        break;
      }
   }    
   //QMessageBox::information(0,"333333", "1"); 

   if (bMovie){     
     //QMessageBox::information(0,"4444444", "1"); 

     if (setMyMovie(0, &movie, &moviea, &movieb, n)){
       //QMessageBox::information(0,"beforeconn", "1"); 
       QObject::connect(movie, SIGNAL(frameChanged(int)), Q7B_ControlPrivate, SLOT(frameChanged(int)));
       movie->start();
     } else {
       qpixmap = Q7B_loadPixmap(n.contains(".") ? n : n + ".png");
     }
     
   } else {

     //QMessageBox::information(0,"555555", "1"); 

     qpixmap = Q7B_createPixmap(n);
   
   }
}

void Q7B_Control::setMyIcon2()
{
  //QMessageBox::information(0,"setMyIcon2", "????"); 
  if (qobject_cast<Q7B_CommandButton *>(q7b_super)){ ((Q7B_CommandButton *)q7b_super)->setIcon(movie->currentPixmap()); }
  else if (qobject_cast<Q7B_CommandLinkButton *>(q7b_super)){ ((Q7B_CommandLinkButton *)q7b_super)->setIcon(movie->currentPixmap()); }
  else if (qobject_cast<Q7B_ToolButton *>(q7b_super)){ ((Q7B_ToolButton *)q7b_super)->setIcon(movie->currentPixmap()); }
  else if (qobject_cast<Q7B_CheckBox *>(q7b_super)){ ((Q7B_CheckBox *)q7b_super)->setIcon(movie->currentPixmap()); }
  else if (qobject_cast<Q7B_RadioButton *>(q7b_super)){ ((Q7B_RadioButton *)q7b_super)->setIcon(movie->currentPixmap()); }
  else if (qobject_cast<Q7B_Label *>(q7b_super)){ ((Q7B_Label *)q7b_super)->setPixmap(movie->currentPixmap()); }
  
}

Q7B Q7B_CONTROL_INIT(QObject *parent, const char *objectName)
{
  QWidget* o = new QWidget(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  //Q7B_QACTION_CONNECT_SLOTS(parent, o, objectName);

  Q7B_Control_constructor(o);

  Q7B q (new Q7B_id(typeid(QWidget).name(), o, !parent->isWidgetType()));   
  return q;
}

void Q7B_CONTROL_ENABLED(Q7B q7b_control, Q7B v)
{  
  if (Q7B_nil(q7b_control)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QWidget *) q7b_control->ref)->setProperty("Enabled", Q7B_IDbool(v));

  Q7B_ImageButton *ib = qobject_cast<Q7B_ImageButton *>(((QWidget *) q7b_control->ref));
  if (ib){
    if (ib->property("Checked").toBool()){
      if (ib->property("Enabled").toBool()){
        ib->setImage(ib->property("CheckedEnabledImage").toString());
//        SETPROPERTY_CheckEnabledImage(GETPROPERTY_CheckEnabledImage());
      } else {
        ib->setImage(ib->property("CheckedDisabledImage").toString());
        //SETPROPERTY_CheckDisabledImage(GETPROPERTY_CheckDisabledImage());
      }
    } else {
      if (ib->property("Enabled").toBool()){
        ib->setImage(ib->property("EnabledImage").toString());
        //SETPROPERTY_EnabledImage(GETPROPERTY_EnabledImage());
      } else {
        ib->setImage(ib->property("DisabledImage").toString());
        //SETPROPERTY_DisabledImage(GETPROPERTY_DisabledImage());
      }
    }
  }  
}

Q7B Q7B_CONTROL_ENABLED(Q7B q7b_control)
{
  if (Q7B_nil(q7b_control)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_CONTROL(q7b_control))){ Q7B_EXCEPTION("Control expected"); return Q7B_idnil; }

  return Q7B_ID( ((QWidget *) q7b_control->ref)->property("Enabled").toBool() );
}

void Q7B_CONTROL_GROUP(Q7B q7b_control, Q7B v)
{
  if (Q7B_nil(q7b_control)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_CONTROL(q7b_control))){ Q7B_EXCEPTION("Control expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((QWidget *) q7b_control->ref)->setProperty("Group", Q7B_IDQString(v));
}

Q7B Q7B_CONTROL_GROUP(Q7B q7b_control)
{
  if (Q7B_nil(q7b_control)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_CONTROL(q7b_control))){ Q7B_EXCEPTION("Control expected"); return Q7B_idnil; }

  return Q7B_ID( ((QWidget *) q7b_control->ref)->property("Group").toString() );
}

// *** TIMER ***********************************************************************************

Q7B Q7B_TIMER_INIT(QObject *parent, const char *objectName)
{
  Q7B_Timer* o = new Q7B_Timer( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_Timer).name(), o, !parent->isWidgetType()));   
  return q;
}

void Q7B_TIMER_ENABLED(Q7B q7b_timer, Q7B v)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((Q7B_Timer *) q7b_timer->ref)->setProperty("Enabled", Q7B_IDbool(v));

  if (Q7B_IDbool(v)){
    ((Q7B_Timer *) q7b_timer->ref)->t.start();
  } else {
    ((Q7B_Timer *) q7b_timer->ref)->t.stop();
  }
}

Q7B Q7B_TIMER_ENABLED(Q7B q7b_timer)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Timer *) q7b_timer->ref)->property("Enabled") == true );
}

Q7B Q7B_TIMER_ISRUNNING(Q7B q7b_timer)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Timer *) q7b_timer->ref)->t.isActive() );
}

void Q7B_TIMER_INTERVAL(Q7B q7b_timer, Q7B v)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }

  Q7B_Timer *tr = ((Q7B_Timer *) q7b_timer->ref);
  
  qint64 n = Q7B_IDqint64(v);
  tr->t.setInterval(n);

  if (n == 0 && tr->t.isActive()) tr->t.stop();
  if (tr->t.interval() >= 0 && tr->property("Enabled") == true) tr->t.start();
}

Q7B Q7B_TIMER_INTERVAL(Q7B q7b_timer)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_Timer *) q7b_timer->ref)->t.interval() );
}

void Q7B_TIMER_START(Q7B q7b_timer)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return; }
  
  ((Q7B_Timer *) q7b_timer->ref)->t.start();
}

void Q7B_TIMER_STOP(Q7B q7b_timer)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return; }

  ((Q7B_Timer *) q7b_timer->ref)->t.stop();
}

// *** IMAGEBUTTON ***********************************************************************************

Q7B Q7B_IMAGEBUTTON_INIT(QObject *parent, const char *objectName)
{
  Q7B_ImageButton* o = new Q7B_ImageButton( parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_ImageButton).name(), o, !parent->isWidgetType()));   
  return q;
}

void Q7B_IMAGEBUTTON_CHECKABLE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("Checkable", Q7B_IDbool(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKABLE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Checkable").toBool() );
}

void Q7B_IMAGEBUTTON_CHECKABLEEXCLUSIVE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckableExclusive", Q7B_IDbool(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKABLEEXCLUSIVE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckableExclusive").toBool() );
}

void Q7B_IMAGEBUTTON_CHECKED(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  Q7B_ImageButton *ib = ((Q7B_ImageButton *) q7b_imagebutton->ref);

  ib->setChecked(Q7B_IDbool(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKED(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Checked").toBool() );
}
/*
void Q7B_IMAGEBUTTON_KEY(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  //((Q7B_ImageButton *) q7b_imagebutton->ref)->Enabled = Q7B_IDbool(v);
}

Q7B Q7B_IMAGEBUTTON_KEY(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  //return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->Enabled );
}*/

void Q7B_IMAGEBUTTON_CAPTION(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("Caption", Q7B_IDQString(v));

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->repaint();
}

Q7B Q7B_IMAGEBUTTON_CAPTION(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Caption").toString() );
}

void Q7B_IMAGEBUTTON_ENABLEDIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QString s = Q7B_IDQString(v);
  if (((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Checked") == false){
    ((Q7B_ImageButton *) q7b_imagebutton->ref)->setImage(s);
  }
  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("EnabledImage", s);
}

Q7B Q7B_IMAGEBUTTON_ENABLEDIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("EnabledImage").toString() );
}

void Q7B_IMAGEBUTTON_DISABLEDIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QString s = Q7B_IDQString(v);
  if (((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Checked") == false && ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Enabled") == false){
    ((Q7B_ImageButton *) q7b_imagebutton->ref)->setImage(s);
  }
  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("DisabledImage", s);
}

Q7B Q7B_IMAGEBUTTON_DISABLEDIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("DisabledImage").toString() );
}

void Q7B_IMAGEBUTTON_ENTERIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("EnterImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_ENTERIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("EnterImage").toString() );
}

void Q7B_IMAGEBUTTON_EXITIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("ExitImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_EXITIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("ExitImage").toString() );
}

void Q7B_IMAGEBUTTON_MOUSEDOWNIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("MouseDownImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_MOUSEDOWNIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("MouseDownImage").toString() );
}

void Q7B_IMAGEBUTTON_MOUSEUPIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("MouseUpImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_MOUSEUPIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("MouseUpImage").toString() );
}

void Q7B_IMAGEBUTTON_ENTERSOUND(Q7B q7b_imagebutton, Q7B v)
{ 
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("EnterSound", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_ENTERSOUND(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("EnterSound").toString() );
}

void Q7B_IMAGEBUTTON_EXITSOUND(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("ExitSound", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_EXITSOUND(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("ExitSound").toString() );
}

void Q7B_IMAGEBUTTON_MOUSEDOWNSOUND(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("MouseDownSound", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_MOUSEDOWNSOUND(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("MouseDownSound").toString() );
}

void Q7B_IMAGEBUTTON_MOUSEUPSOUND(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("MouseUpSound", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_MOUSEUPSOUND(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("MouseUpSound").toString() );
}

void Q7B_IMAGEBUTTON_CHECKEDENABLEDIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QString s = Q7B_IDQString(v);
  if (((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Checked").toBool()){
    ((Q7B_ImageButton *) q7b_imagebutton->ref)->setImage(s);
  }
  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckedEnabledImage", s);
}

Q7B Q7B_IMAGEBUTTON_CHECKEDENABLEDIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckedEnabledImage").toString() );
}

void Q7B_IMAGEBUTTON_CHECKEDDISABLEDIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QString s = Q7B_IDQString(v);
  if (((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Checked").toBool() && ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Enabled") == false){
    ((Q7B_ImageButton *) q7b_imagebutton->ref)->setImage(s);
  }
  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckedDisabledImage", s);
}

Q7B Q7B_IMAGEBUTTON_CHECKEDDISABLEDIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckedDisabledImage").toString() );
}

void Q7B_IMAGEBUTTON_CHECKEDENTERIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckedEnterImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKEDENTERIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckedEnterImage").toString() );
}

void Q7B_IMAGEBUTTON_CHECKEDEXITIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckedExitImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKEDEXITIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckedExitImage").toString() );
}

void Q7B_IMAGEBUTTON_CHECKEDMOUSEDOWNIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckedMouseDownImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKEDMOUSEDOWNIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckedMouseDownImage").toString() );
}

void Q7B_IMAGEBUTTON_CHECKEDMOUSEUPIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckedMouseUpImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKEDMOUSEUPIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckedMouseUpImage").toString() );
}

void Q7B_IMAGEBUTTON_SCALE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("Scale", Q7B_IDbool(v));
}

Q7B Q7B_IMAGEBUTTON_SCALE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_ID( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Scale").toBool() );
}

// *** TEXTBOX ***********************************************************************************

Q7B Q7B_TEXTBOX_INIT(QObject *parent, const char *objectName)
{
  Q7B_TextBox* o = new Q7B_TextBox( parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_TextBox).name(), o, !parent->isWidgetType()));   
  return q;
}

// *** COMMANDBUTTON ***********************************************************************************

Q7B Q7B_COMMANDBUTTON_INIT(QObject *parent, const char *objectName)
{
  Q7B_CommandButton* o = new Q7B_CommandButton( parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_CommandButton).name(), o, !parent->isWidgetType()));   
  return q;
}

void Q7B_COMMANDBUTTON_ICON(Q7B commandbutton, Q7B Value)
{
  if (Q7B_nil(commandbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_COMMANDBUTTON(commandbutton))){ Q7B_EXCEPTION("CommandButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_CommandButton *) commandbutton->ref)->setMyIcon( Q7B_IDQString(Value) );
}

Q7B Q7B_COMMANDBUTTON_ICON(Q7B commandbutton)
{
  if (Q7B_nil(commandbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_COMMANDBUTTON(commandbutton))){ Q7B_EXCEPTION("CommandButton expected"); return Q7B_idnil; }

  return Q7B_idnil; // won't be used
}

// *** COMMANDLINKBUTTON ***********************************************************************************

Q7B Q7B_COMMANDLINKBUTTON_INIT(QObject *parent, const char *objectName)
{
  Q7B_CommandLinkButton* o = new Q7B_CommandLinkButton( parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_CommandLinkButton).name(), o, !parent->isWidgetType()));   
  return q;
}

void Q7B_COMMANDLINKBUTTON_ICON(Q7B commandlinkbutton, Q7B Value)
{
  if (Q7B_nil(commandlinkbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_COMMANDLINKBUTTON(commandlinkbutton))){ Q7B_EXCEPTION("CommandLinkButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_CommandLinkButton *) commandlinkbutton->ref)->setMyIcon( Q7B_IDQString(Value) );
}

Q7B Q7B_COMMANDLINKBUTTON_ICON(Q7B commandlinkbutton)
{
  if (Q7B_nil(commandlinkbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_COMMANDLINKBUTTON(commandlinkbutton))){ Q7B_EXCEPTION("CommandLinkButton expected"); return Q7B_idnil; }

  return Q7B_idnil; // won't be used
}

// *** TOOLBUTTON ***********************************************************************************

Q7B Q7B_TOOLBUTTON_INIT(QObject *parent, const char *objectName)
{
  Q7B_ToolButton* o = new Q7B_ToolButton( parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_ToolButton).name(), o, !parent->isWidgetType()));   
  return q;
}

void Q7B_TOOLBUTTON_ICON(Q7B toolbutton, Q7B Value)
{
  if (Q7B_nil(toolbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_TOOLBUTTON(toolbutton))){ Q7B_EXCEPTION("ToolButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ToolButton *) toolbutton->ref)->setMyIcon( Q7B_IDQString(Value) );
}

Q7B Q7B_TOOLBUTTON_ICON(Q7B toolbutton)
{
  if (Q7B_nil(toolbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_TOOLBUTTON(toolbutton))){ Q7B_EXCEPTION("ToolButton expected"); return Q7B_idnil; }

  return Q7B_idnil; // won't be used
}

// *** CHECKBOX ***********************************************************************************

Q7B Q7B_CHECKBOX_INIT(QObject *parent, const char *objectName)
{
  Q7B_CheckBox* o = new Q7B_CheckBox( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_CheckBox).name(), o, !parent->isWidgetType()));   
  return q;
}

void Q7B_CHECKBOX_ICON(Q7B checkbox, Q7B Value)
{
  if (Q7B_nil(checkbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_CHECKBOX(checkbox))){ Q7B_EXCEPTION("CheckBox expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_CheckBox *) checkbox->ref)->setMyIcon( Q7B_IDQString(Value) );
}

Q7B Q7B_CHECKBOX_ICON(Q7B checkbox)
{
  if (Q7B_nil(checkbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_CHECKBOX(checkbox))){ Q7B_EXCEPTION("CheckBox expected"); return Q7B_idnil; }

  return Q7B_idnil; // won't be used
}

// *** RADIOBUTTON ***********************************************************************************

Q7B Q7B_RADIOBUTTON_INIT(QObject *parent, const char *objectName)
{
  Q7B_RadioButton* o = new Q7B_RadioButton(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_RadioButton).name(), o, !parent->isWidgetType()));   
  return q;
}

void Q7B_RADIOBUTTON_ICON(Q7B radiobutton, Q7B Value)
{
  if (Q7B_nil(radiobutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_RADIOBUTTON(radiobutton))){ Q7B_EXCEPTION("RadioButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_RadioButton *) radiobutton->ref)->setMyIcon( Q7B_IDQString(Value) );
}

Q7B Q7B_RADIOBUTTON_ICON(Q7B radiobutton)
{
  if (Q7B_nil(radiobutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_RADIOBUTTON(radiobutton))){ Q7B_EXCEPTION("RadioButton expected"); return Q7B_idnil; }

  return Q7B_idnil; // won't be used
}

// *** LABEL ***********************************************************************************

Q7B Q7B_LABEL_INIT(QObject *parent, const char *objectName)
{
  Q7B_Label* o = new Q7B_Label(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_Label).name(), o, !parent->isWidgetType()));   
  return q;
}

void Q7B_LABEL_SHAPE(Q7B q7b_label, Q7B v)
{
  if (Q7B_nil(q7b_label)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LABEL(q7b_label))){ Q7B_EXCEPTION("Label expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  if (Q7B_IDbool(v)){
    ((QLabel *) q7b_label->ref)->setFrameShape(QFrame::StyledPanel);
  } else {
    ((QLabel *) q7b_label->ref)->setFrameShape(QFrame::NoFrame);
  }
}

Q7B Q7B_LABEL_SHAPE(Q7B q7b_label)
{
  return Q7B_idnil; // won't be used
}

void Q7B_LABEL_INPUTCONTROL(Q7B q7b_label, Q7B v)
{
  //QMessageBox::information(0,"11111", ""); 
  if (Q7B_nil(q7b_label)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LABEL(q7b_label))){ Q7B_EXCEPTION("Label expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QLabel *l = ((QLabel *) q7b_label->ref);

  QWidget *w = 0;

  //QMessageBox::information(0,"2222222", ""); 
  QWidget *ss = ((QWidget *) q7b_label->ref)->parentWidget();
  if (ss == 0) return;

  //QMessageBox::information(0,"333333", ""); 

  QObjectList ol = ss->children();

  for (int q = 0; q < ol.size(); q++){
    if (ol.at(q)->objectName() == Q7B_IDQString(v)){
      w = (QWidget *) ol.at(q);
      break;
    }    
  }

  //QMessageBox::information(0,"444444", ""); 
  if (w){
    l->setTextFormat(Qt::PlainText);
  } else {
    l->setTextFormat(Qt::AutoText);
  }
  if (l->buddy() || w){
    //QMessageBox::information(0,"setBuddy", ""); 
    l->setBuddy(w);
  }
  if (w) w->show(); // needed to make buddy visible at all
}

Q7B Q7B_LABEL_INPUTCONTROL(Q7B q7b_label)
{
  if (Q7B_nil(q7b_label)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_LABEL(q7b_label))){ Q7B_EXCEPTION("Label expected"); return Q7B_idnil; }

  return Q7B_ID( ((QLabel *) q7b_label->ref)->buddy()->objectName() );
}

void Q7B_LABEL_ICON(Q7B q7b_label, Q7B Value)
{
  if (Q7B_nil(q7b_label)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LABEL(q7b_label))){ Q7B_EXCEPTION("Label expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_Label *) q7b_label->ref)->setMyIcon( Q7B_IDQString(Value) );
}

Q7B Q7B_LABEL_ICON(Q7B q7b_label)
{
  if (Q7B_nil(q7b_label)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_LABEL(q7b_label))){ Q7B_EXCEPTION("Label expected"); return Q7B_idnil; }

  return Q7B_idnil; // won't be used
}

// *** FRAME ***********************************************************************************

Q7B Q7B_FRAME_INIT(QObject *parent, const char *objectName)
{
  Q7B_Frame* o = new Q7B_Frame( parent->isWidgetType() ? (QWidget *) parent : 0);
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_Frame).name(), o, !parent->isWidgetType()));   
  return q;
}

// *** FORMCLASS ***********************************************************************************

Q7B Q7B_FORMCLASS_INIT(QObject *parent, const char *objectName)
{
  Q7B_FormClass* o = new Q7B_FormClass( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_FormClass).name(), o, !parent->isWidgetType()));   
  return q;
}

// *** UICLASS ***********************************************************************************

Q7B Q7B_UICLASS_INIT(QObject *parent, const char *objectName)
{
  Q7B_uiClass* o = new Q7B_uiClass( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_uiClass).name(), o, !parent->isWidgetType()));   
  return q;
}

// *** CLASS ***********************************************************************************

Q7B Q7B_CLASS_INIT(QObject *parent, const char *objectName)
{
  Q7B_Class* o = new Q7B_Class( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_Class).name(), o, !parent->isWidgetType()));   
  return q;
}

// *** MODULE ***********************************************************************************

Q7B Q7B_MODULE_INIT(QObject *parent, const char *objectName)
{
  Q7B_Module* o = new Q7B_Module( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_Module).name(), o, !parent->isWidgetType()));   
  return q;
}

// *** IMAGEBOX ***********************************************************************************

Q7B Q7B_IMAGEBOX_INIT(QObject *parent, const char *objectName)
{
  Q7B_ImageBox* o = new Q7B_ImageBox(parent->isWidgetType() ? (QWidget *) parent : 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_ImageBox).name(), o, !parent->isWidgetType()));   
  return q;
}

void Q7B_IMAGEBOX_VALUE(Q7B q7b_imagebox, Q7B v)
{
  if (Q7B_nil(q7b_imagebox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBOX(q7b_imagebox))){ Q7B_EXCEPTION("ImageBox expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QPixmap qpixmap = Q7B_createPixmap(Q7B_IDQString(v));

  Q7B_ImageBox *ib = ((Q7B_ImageBox *) q7b_imagebox->ref);

  QPalette p = ib->palette();
  QBrush b(qpixmap);
  p.setBrush(QPalette::Window, b);  
  ib->setPalette(p);

  ib->setProperty("OldValue", ib->property("Value"));
  ib->setProperty("Value", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBOX_VALUE(Q7B q7b_imagebox)
{
  if (Q7B_nil(q7b_imagebox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBOX(q7b_imagebox))){ Q7B_EXCEPTION("ImageBox expected"); return Q7B_idnil; }

  Q7B_ImageBox *ib = ((Q7B_ImageBox *) q7b_imagebox->ref);

  return Q7B_ID( ib->property("Value") );
}

void Q7B_IMAGEBOX_TEXT(Q7B q7b_imagebox, Q7B v)
{
  if (Q7B_nil(q7b_imagebox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBOX(q7b_imagebox))){ Q7B_EXCEPTION("ImageBox expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QPixmap qpixmap = Q7B_createPixmap(Q7B_IDQString(v));

  Q7B_ImageBox *ib = ((Q7B_ImageBox *) q7b_imagebox->ref);

  QPalette p = ib->palette();
  QBrush b(qpixmap);
  p.setBrush(QPalette::Window, b);  
  ib->setPalette(p);

  ib->setProperty("OldValue", ib->property("Value"));
  ib->setProperty("Value", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBOX_TEXT(Q7B q7b_imagebox)
{
  if (Q7B_nil(q7b_imagebox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBOX(q7b_imagebox))){ Q7B_EXCEPTION("ImageBox expected"); return Q7B_idnil; }

  Q7B_ImageBox *ib = ((Q7B_ImageBox *) q7b_imagebox->ref);

  return Q7B_ID( ib->property("Value") );
}

// *** UDPSOCKET ***********************************************************************************

Q7B Q7B_UDPSOCKET_INIT(QObject *parent, const char *objectName)
{
  Q7B_UdpSocket* o = new Q7B_UdpSocket( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_UdpSocket).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_UDPSOCKET_OPEN(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  if (udp->sHost.compare("LocalHost", Qt::CaseInsensitive) == 0) udp->a = new QHostAddress(QHostAddress::LocalHost);
  else if (udp->sHost.compare("LocalHostIPv6", Qt::CaseInsensitive) == 0) udp->a = new QHostAddress(QHostAddress::LocalHostIPv6);
  else if (udp->sHost.compare("Broadcast", Qt::CaseInsensitive) == 0) udp->a = new QHostAddress(QHostAddress::Broadcast);
  else if (udp->sHost.compare("Any", Qt::CaseInsensitive) == 0) udp->a = new QHostAddress(QHostAddress::Any);
  else if (udp->sHost.compare("AnyIPv6", Qt::CaseInsensitive) == 0) udp->a = new QHostAddress(QHostAddress::AnyIPv6);
  else udp->a = new QHostAddress(udp->sHost);

  udp->t->connectToHost(*(udp->a), udp->nPort);

  if (udp->t->waitForConnected()){
    return Q7B_ID( true );
  }
  
  return Q7B_ID( false );
}

Q7B Q7B_UDPSOCKET_BIND(Q7B q7b_udpsocket, Q7B Host, Q7B Port)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Port))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  QString sHost = Q7B_IDQString(Host);
  udp->nPort2 = Q7B_IDqint64(Port);

  if (sHost.compare("LocalHost", Qt::CaseInsensitive) == 0) udp->a2 = new QHostAddress(QHostAddress::LocalHost);
  else if (sHost.compare("LocalHostIPv6", Qt::CaseInsensitive) == 0) udp->a2 = new QHostAddress(QHostAddress::LocalHostIPv6);
  else if (sHost.compare("Broadcast", Qt::CaseInsensitive) == 0) udp->a2 = new QHostAddress(QHostAddress::Broadcast);
  else if (sHost.compare("Any", Qt::CaseInsensitive) == 0) udp->a2 = new QHostAddress(QHostAddress::Any);
  else if (sHost.compare("AnyIPv6", Qt::CaseInsensitive) == 0) udp->a2 = new QHostAddress(QHostAddress::AnyIPv6);
  else udp->a2 = new QHostAddress(sHost);

  if (udp->t->bind(*(udp->a2), udp->nPort2)){
    return Q7B_ID( true );
  }

  return Q7B_ID( false );
}

Q7B Q7B_UDPSOCKET_READDATA(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  QString s;

  while ((udp->a || udp->a2) && udp->t->hasPendingDatagrams()) {
       QByteArray datagram;
       datagram.resize(udp->t->pendingDatagramSize());
       QHostAddress sender;
       quint16 senderPort;

       udp->t->readDatagram(datagram.data(), datagram.size(), &sender, &senderPort);

       s += QString::fromLatin1((const char *) datagram.data(), datagram.size());
  }

  return Q7B_ID( s );
}

Q7B Q7B_UDPSOCKET_WRITEDATA(Q7B q7b_udpsocket, Q7B Data)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Data))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  if (udp->a == 0) return Q7B_ID( false );

  QString sData = Q7B_IDQString(Data);
  QByteArray datagram = sData.toLatin1();
  return Q7B_ID( udp->t->writeDatagram(datagram.data(), datagram.size(), *(udp->a), udp->nPort) > 0 );
}

void Q7B_UDPSOCKET_CLOSE(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  udp->t->disconnectFromHost();
  delete udp->a;
  udp->a = 0;
}

Q7B Q7B_UDPSOCKET_LASTERROR(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  QAbstractSocket::SocketError l = udp->t->error();

  QString s = "";

  if (l == QAbstractSocket::ConnectionRefusedError) s = "ConnectionRefusedError";
  else if (l == QAbstractSocket::RemoteHostClosedError) s = "RemoteHostClosedError";
  else if (l == QAbstractSocket::HostNotFoundError) s = "HostNotFoundError";
  else if (l == QAbstractSocket::SocketAccessError) s = "SocketAccessError";
  else if (l == QAbstractSocket::SocketResourceError) s = "SocketResourceError";
  else if (l == QAbstractSocket::SocketTimeoutError) s = "SocketTimeoutError";
  else if (l == QAbstractSocket::DatagramTooLargeError) s = "DatagramTooLargeError";
  else if (l == QAbstractSocket::NetworkError) s = "NetworkError";
  else if (l == QAbstractSocket::AddressInUseError) s = "AddressInUseError";
  else if (l == QAbstractSocket::SocketAddressNotAvailableError) s = "SocketAddressNotAvailableError";
  else if (l == QAbstractSocket::UnsupportedSocketOperationError) s = "UnsupportedSocketOperationError";
  else if (l == QAbstractSocket::ProxyAuthenticationRequiredError) s = "ProxyAuthenticationRequiredError";
  else if (l == QAbstractSocket::SslHandshakeFailedError) s = "SslHandshakeFailedError";
  else if (l == QAbstractSocket::UnfinishedSocketOperationError) s = "UnfinishedSocketOperationError";
#ifndef Q_WS_X11
  else if (l == QAbstractSocket::ProxyConnectionRefusedError) s = "ProxyConnectionRefusedError";
  else if (l == QAbstractSocket::ProxyConnectionClosedError) s = "ProxyConnectionClosedError";
  else if (l == QAbstractSocket::ProxyConnectionTimeoutError) s = "ProxyConnectionTimeoutError";
  else if (l == QAbstractSocket::ProxyNotFoundError) s = "ProxyNotFoundError";
  else if (l == QAbstractSocket::ProxyProtocolError) s = "ProxyProtocolError";
#endif
  else if (l == QAbstractSocket::UnknownSocketError) s = "UnknownSocketError"; 

  return Q7B_ID( s );
}

Q7B Q7B_UDPSOCKET_LASTERRORTEXT(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  return Q7B_ID( udp->t->errorString() );
}

void Q7B_UDPSOCKET_HOST(Q7B q7b_udpsocket, Q7B v)
{  
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  udp->sHost = Q7B_IDQString(v); 
}

Q7B Q7B_UDPSOCKET_HOST(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  return Q7B_ID( udp->sHost );
}

void Q7B_UDPSOCKET_PORT(Q7B q7b_udpsocket, Q7B v)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return; }  
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  udp->nPort = Q7B_IDqint64(v);
}

Q7B Q7B_UDPSOCKET_PORT(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  return Q7B_ID( udp->nPort );
}

// ******************************************************************************************

Q7B_Screen::Q7B_Screen(QWidget *_parent) : QWidget (0)
{
  nFontWidth = 10;
  nFontHeight = 19;

  PI = 3.14159265;

  getWidth = 800;
  getHeight = 570;
  getColumn = 81;
  getLine = 30;
  

  bInputted = false;
  setWindowFlags(Qt::CustomizeWindowHint | Qt::WindowTitleHint | Qt::WindowMinimizeButtonHint | Qt::WindowCloseButtonHint  | Qt::WindowSystemMenuHint );
  bHide = false;

  setFocusPolicy(Qt::StrongFocus);

  for (int i = 0; i < 256; i++){
    switch(i % 16){
      case 0:
        colors[i] = Qt::black;
        break;
      case 1:
        colors[i] = Qt::darkBlue;
        break;
      case 2:
        colors[i] = Qt::darkGreen;
        break;
      case 3:
        colors[i] = Qt::darkCyan;
        break;
      case 4:
        colors[i] = Qt::darkRed;
        break;
      case 5:
        colors[i] = Qt::darkMagenta;
        break;
      case 6:
        colors[i] = QColor(153, 102, 0);
        break;
      case 7:
        colors[i] = Qt::lightGray;
        break;
      case 8:
        colors[i] = Qt::darkGray;
        break;
      case 9:
        colors[i] = Qt::blue;
        break;
      case 10:
        colors[i] = Qt::green;
        break;
      case 11:
        colors[i] = Qt::cyan;
        break;
      case 12:
        colors[i] = Qt::red;
        break;
      case 13:
        colors[i] = Qt::magenta;
        break;
      case 14:
        colors[i] = Qt::yellow;
        break;
      case 15:
        colors[i] = Qt::white;
        break;
    }
   
    if (i / 16 > 0){
      colors[i] = colors[i].dark(100 + 50 * i / 16);
    }    


  }

  nForecolor = 15;
  nBackcolor = 0;

 
  nInput2 = nInput = 0xffff; // no key pressed

  setWindowTitle("Screen");
  setWindowIconText("Screen");

  m2 = QPixmap(getWidth, getHeight);
  m2.fill(Qt::black);


  nForecolor = 15;
  nBackcolor = 0;

  bCursor = false;
  nCursorX = 1;
  nCursorY = 1;
  font = QFont("Courier");
  font.setPixelSize(16);


	setHidden(true);
  setFixedSize(getWidth, getHeight); // WORKAROUND

  nTimerId = startTimer( 500 ); 
  
  bCTRL = false;
  bSHIFT = false;

  bWasActivated = bActivated = false;
  setHidden(true);
  
  QRect r = QApplication::desktop()->screenGeometry(QApplication::desktop()->primaryScreen());
  move((r.width() / 2) - (width() / 2), (r.height() / 2) - (height() / 2));

}

Q7B_Screen::~Q7B_Screen(void)
{  
  killTimer(nTimerId);  
  nTimerId = 0;
  
  captureScreen();
  hide();

 // QMessageBox::information(0,paintingActive() ? "paintingActive()" : "", "2222222222"); 
}

int Q7B_Screen::getCursorX()
{
  return (nCursorX-1)*nFontWidth;
}

int Q7B_Screen::getCursorY()
{
  return (nCursorY*nFontHeight)-5;
}

void Q7B_Screen::setWindowIcon2()
{ 
  //QPixmap p = interpreter_loadPixmap("VIEW_KONSOLE.png");
  //setWindowIcon(QIcon(p));
}

void Q7B_Screen::activate()
{ 
  if (bActivated == false){

    nInput2 = nInput = 0xffff; // no key pressed

    bWasActivated = bActivated = true;
    show();   
    activateWindow();
    if (bWasActivated) clearLastLine();
  } else show();

}

void Q7B_Screen::setActiveW()
{
  show();
  activateWindow();
}

void Q7B_Screen::deactivate()
{
  if (bActivated == true){
//    pressAnyKey();
    bActivated = false;

    bHide = true; hide();
  }

}

void Q7B_Screen::setActivated(bool b)
{
  bActivated = b;
}

void Q7B_Screen::pressAnyKey(bool bPrintText)
{
  if (bPrintText){

    int x = pos();
    int y = csrlin();

    int forecolor = nForecolor;
    int backcolor = nBackcolor;
  
    locate(getLine, 1);
    color(15, 0);
    print("Press ANY KEY to continue...");

    // restore
    locate(y, x);
    nForecolor = forecolor;
    nBackcolor = backcolor;
    
  }

  bActivated = false;
}

bool Q7B_Screen::isActivated()
{
  return bActivated;
}

void Q7B_Screen::paintEvent( QPaintEvent * e)
{

  QPainter p(this);

  p.drawPixmap(0, 0, m2);
  if (bCursor || bInputted){
    p.setPen( colors[nBackcolor] );      
    p.fillRect( QRect(getCursorX(), getCursorY() + 1, nFontWidth,  3), colors[nForecolor]);
  }

 // show();   
  //p.end(); 
}

void Q7B_Screen::keyPressEvent( QKeyEvent * e)
{
  /*
  int x = pos();
  int y = csrlin();

  switch(e->key()){
    case Qt::Key_Escape:
      hide();
      break;      
    case Qt::Key_Left:
      x--;
      if (x <= 0) x = getColumn;
      locate(y, x);
      break;
    case Qt::Key_Right:
      x++;
      if (x > getColumn) x = 1;
      locate(y, x);
      break;
    case Qt::Key_Up:
      y--;
      if (y <= 0) y = getLine;
      locate(y, x);
      break;
    case Qt::Key_Down:
      y++;
      if (y > getLine) y = 1;
      locate(y, x);
      break;
    case Qt::Key_Return:
      locate(34, 1);
      print("\n");
      break;

    default:
//      close();
      break;     
  }  
  
*/
  nInput = e->nativeVirtualKey();
  nInput2 = e->key();
  sInput = e->text();
  //QMessageBox::information(this, "", sInput);
  if (nInput == 0 && e->key() != 0){ // extended key pressed ?
    int b = e->key();

    if ((b == Qt::Key_Shift) || (b == Qt::Key_Alt) || (b == Qt::Key_Control) || (b == Qt::Key_Meta)) {
      nInput2 = nInput = 0xffff; // no key pressed
    } else {
      nInput = 0;//e->key();
    }
  } else {
    bInputted = true;
  }

  if (!bActivated){    
//    pressAnyKey(false);       
    bHide = true; hide();
    nInput2 = nInput = 0xffff; // no key pressed
  }

  int n = e->key();

  if (n == Qt::Key_Control){
    bCTRL = true;
  }

  if (n == Qt::Key_C && bCTRL){
  //  EXTERN_myInterpreter->stop_interpret();
  }

}
 
void Q7B_Screen::closeEvent ( QCloseEvent * e )
{
//  my_mainwindow->event_RUN_STOP();
  //pressAnyKey(false);       
  bHide = true; hide();
  e->accept();
}

void Q7B_Screen::keyReleaseEvent ( QKeyEvent * e )
{  
  switch(e->key()){
    case Qt::Key_Control:
      bCTRL = false;
      break;
    case Qt::Key_Shift:
      bSHIFT = false;
      break;
  }
}

void Q7B_Screen::focusInEvent (QFocusEvent *e)
{
  show();
}

void Q7B_Screen::focusOutEvent (QFocusEvent *e)
{
//  pressAnyKey(false);       
}

void Q7B_Screen::hideEvent (QHideEvent *e)
{
  if (bHide){
    bHide = false;
  } else {
//    pressAnyKey(false);       
  }
  QWidget::hideEvent(e);
}

void Q7B_Screen::timerEvent( QTimerEvent * )
{  
  bCursor = !bCursor;
  static QRect r2;
  
  QRect r = QRect(getCursorX(), getCursorY() + 1, nFontWidth,  3);
  update(r);
  update(r2);
  r2 = r;
  
}

void Q7B_Screen::incCursorX()
{
  nCursorX++;
  if (nCursorX >= getColumn){
    nCursorX = 1;
    incCursorY();
  }
}

void Q7B_Screen::decCursorX()
{
  nCursorX--;
  if (nCursorX < 1){
    nCursorX = getColumn;
    decCursorY();
  }
}

void Q7B_Screen::setCursorX(int n)
{
  nCursorX = n;
}

void Q7B_Screen::setCursorY(int n)
{
  nCursorY = n;
}

void Q7B_Screen::decCursorY()
{
  nCursorY--;
  if (nCursorY < 1){
    nCursorX = 1;
    nCursorY = 1;
  }
}

void Q7B_Screen::incCursorY()
{
  nCursorY++;
  if (nCursorY > getLine){

    int h = getHeight - nFontHeight;    


    p2.drawPixmap(0, 0, m2, 0, nFontHeight, getWidth, h);

    p2.fillRect(QRect(0, h, getWidth, nFontHeight), colors[nBackcolor]);
    //p.end(); 

    nCursorY = getLine;
  }
}

void Q7B_Screen::clearLastLine()
{
  int y = getHeight - (nFontHeight + 0);
  int w = getWidth;

  QPainter p( &m2 );

  QRect r = QRect(0, y, w, nFontHeight + 0);
  p.fillRect(r, colors[nBackcolor]);
  //p.end();   
  update(r);
}

int Q7B_Screen::abs(int n)
{
  if (n < 0) return n *= -1;
  return n;
}

/*
 step, stil
*/
void Q7B_Screen::line(bool step, int x1, int y1, 
                bool step2, bool expression, int x2, int y2, 
                bool bColor, int color, bool b, bool bf, bool bStyle, int style)
{
  activate();

  QPainter p2( &m2 );

  if (bColor){
    p2.setPen( colors[color] );      
  } else {
    p2.setPen( colors[nForecolor] );      
  }
  
  if (bStyle){
    p2.setPen( QPen(colors[color]) );      
  }
  if (b){     
    p2.drawRect(x1, y1, abs(x2 - x1), abs(y2 - y1)); 
  } else if (bf){
    QPixmap k( abs(x2 - x1), abs(y2 - y1));
    k.fill(colors[color]);    
    p2.drawPixmap(x1, y1, k); 
  } else {
    p2.drawLine(x1, y1, x2, y2); 
  }
  //p2.end();  

  update();
}

/*
 step, start, end, aspect
*/
void Q7B_Screen::circle(bool step, int x, int y, int radius, int color, int start, int end, int aspect)
{
  activate();

  QPainter p( &m2 );

  //p.begin( &m );   

  if (start == -1) start = 0 / (PI / 180);
  if (end == -1) end = 360 / (PI / 180);
  if (aspect == -1) aspect = 1;

  if (color == -1){
    p.setPen( colors[nForecolor] );   
  } else {
    p.setPen( colors[color] );   
  }

  p.drawArc ( x - radius, y - radius, radius * 2, radius * 2, 0 * 16, 360 * 16);
  
  
  update();
}

/*
*/
void Q7B_Screen::color(int forecolor, int backcolor)
{
  activate();

  if (forecolor < 256 && forecolor != -1) nForecolor = forecolor;
  if (backcolor < 256 && backcolor != -1) nBackcolor = backcolor;
}

/*
*/
void Q7B_Screen::paint(bool step, int x, int y, int color, char *pattern, int bordercolor, int backcolor)
{
}

/*
 no
*/
void Q7B_Screen::cls(int no)
{
  activate();

  QPainter p( &m2 );

  QPixmap k(QApplication::desktop()->width(), QApplication::desktop()->height());
  k.fill( colors[nBackcolor] );    
  

  p.drawPixmap(0, 0, k); 
  
  locate(1, 1);
  update();
}

/*

*/
void Q7B_Screen::viewprint(int no)
{
  activate();

}

/*

*/
void Q7B_Screen::viewscreen(int no)
{
  activate();

}

/*
 
*/
void Q7B_Screen::window(int no)
{
  activate();

}

/*
*/
int Q7B_Screen::csrlin()
{
  activate();

  return nCursorY;
}

/*
 
*/
void Q7B_Screen::pmap(int no)
{
  activate();

}

/*
 
*/
void Q7B_Screen::point(int no)
{
  activate();

}

/*
 
*/
void Q7B_Screen::beep()
{
  //activate();
  QApplication::beep();
}

/*
 
*/
void Q7B_Screen::draw(int no)
{
  activate();

}

/*
 
*/
void Q7B_Screen::get(int no)
{
  activate();

}

/*
 
*/
void Q7B_Screen::put(int no)
{
  activate();

}

/*

*/
void Q7B_Screen::key(int no)
{
  activate();

}

char *Q7B_Screen::inkey(int *nKeyPressed)
{
  //qApp->processEvents();
  activate();

  static char ac[1024];
/*
  if (nInput == 0){
    nInput = nInput;
  }*/

  // no key pressed
  if (nInput == 0xffff){ 
    *nKeyPressed = 1;

    ac[0] = '\0';
    return ac;
  }

  if (nInput == 0){ 
    *nKeyPressed = 2;

	  ac[0] = ' ';
    ac[1] = '\0';  

    
    return ac;
  }

  *nKeyPressed = 3;

	ac[0] = sInput.at(0).toAscii();
  ac[1] = '\0';  

  nInput = 0xffff; // no key pressed

  return ac;
}


char *Q7B_Screen::input()
{
  activate();
  
  static char ac[1024];

  int i = 0;
  while (nInput2 != Qt::Key_Enter && nInput2 != Qt::Key_Return){
    if (nInput2 != 0xffff){ // no key pressed = 0xffff

 // QMessageBox::information(this, "", QString("%1").arg(nInput2));

      if (nInput2 == Qt::Key_Backspace){
        if (i > 0){ // backspace
         i--;

         decCursorX();
         static QString ss = QString(QChar(' '));
         print(ss);
         decCursorX();
        }

        nInput2 = 0xffff; // no key pressed
        bInputted = false;
      } else if (nInput2 >= 32){

       QChar *c = sInput.data();
       ac[i] = c->toAscii();       

       print(sInput);
       nInput2 = 0xffff; // no key pressed
       bInputted = false;
       i++;
       if (i > 1023) break;
      
      } else { // ignore special keys
       nInput2 = 0xffff; // no key pressed
       bInputted = false;
      }
    }
    update();
    qApp->processEvents(QEventLoop::AllEvents, 100);
  };  

  setCursorX(1);
  incCursorY();

  nInput2 = 0xffff; // no key pressed
  bInputted = false;

	ac[i] = '\0';  

  return ac;  
}

/*
*/
/*
void Q7B_Screen::print(char s)
{
  static char ac[2];
  //char *ac = new char[2]; 

  ac[0] = s;
  ac[1] = '\0';
  
  print(QString(ac));
}*/

void Q7B_Screen::print(const char *s)
{  
  
  
  static QString ss; ss = s;
  print(ss);
  
}


void Q7B_Screen::print(const QString &j)
{
  activate();

  p2.begin(&m2);

  p2.setPen( colors[nForecolor] );   
  p2.setBackgroundMode(Qt::OpaqueMode);
  p2.setBackground ( colors[nBackcolor] );
  p2.setFont(font); 


  int i = 0;
  int i2 = 0;
  bool b = false;
  QString k;

  do {

    i2 = j.indexOf("\n", i);
    if (i2 != -1){
      k = j.mid(i, i2 - i);
      i = i2;
      b = true;
    } else {
      k = j.mid(i);
      if (k == 0) break;
      b = false;
    }

  
   do {

      int n = k.length() + nCursorX;
      if (n > getColumn){
        n = getColumn - nCursorX;
       // p.drawText(getCursorX(), getCursorY(), k.left(n));

        p2.drawText(getCursorX(), getCursorY(), k.left(n));

        k = k.mid(n);

        nCursorX = 1;
        incCursorY();

      } else {
        

        p2.drawText(getCursorX(), getCursorY(), k);

        if (b){
          i++;
          nCursorX = 1;
          incCursorY();
        } else {
          nCursorX += k.length();
        }

        break;
      }

   } while (k.length());
 
 
} while (b);

  update();

  p2.end();

}


/*
 step
*/
void Q7B_Screen::preset(bool step, int x, int y, int color)
{
  activate();

  QPainter p( this );

//  p.begin( &m );   
  if (color == -1){
    p.setPen( colors[nBackcolor] );      
  } else {
    p.setPen( colors[color] );      
  }

  p.drawPoint(x, y); 

  update();
}

/*
 step
*/
void Q7B_Screen::pset(bool step, int x, int y, bool bColor, int color)
{
  activate();

  QPainter p( &m2 );

//  p.begin( &m );   
  if (bColor){
    p.setPen( colors[color] );      
  } else {
    p.setPen( colors[nForecolor] );      
  }

  p.drawPoint(x, y); 

  //p.end();  
  update();
}

/*
*/
int Q7B_Screen::pos()
{
  activate();

  return nCursorX;
}

/*
*/
void Q7B_Screen::locate(int y, int x)
{
  activate();

  if (x > getColumn || y > getLine) return;

  if (x != -1) nCursorX = x;
  if (y != -1) nCursorY = y;
  //update();
}

/*
 
*/
void Q7B_Screen::palette(int no)
{
  activate();
}

/*
 
*/
void Q7B_Screen::sound(int no)
{
}

/*
 
*/
void Q7B_Screen::play(int no)
{
}

/*
 
*/
void Q7B_Screen::view(int no)
{
  activate();
}

void Q7B_Screen::test1()
{
/*
  line(false, 110, 40, false, 320, 200, 15, false, 0, false, false, 0);
  line(false, 110, 40, 320, 200, 15, true, false, 0);
  line(false, 110, 40, 32, 20, 15, false, true, 0);*/
  circle(false, 44, 66, 8, 8, 6, 6, 4);
  //cls(0);
  color(15, 1);
  locate(1, 1);
  print("1gy567890 1234567890 123456g890 1234567u90 1234567u90 1234567u90 1234567u90 1234567u90");

  char buffer[1024];
  sprintf(buffer, "\n\n\n     hi");
  print(buffer);
  int n = pos();
  n = csrlin();

  locate(5, 11);
  print("gut");

  locate(2, 1);
  print(".2\n");
  print(".3\n");
  print(".4\n");
  print(".5\n");
  print(".6\n");
  print(".7\n");
  print(".8\n");
  print(".9\n");
  //print("\n");
  print(".0\n");
  print(".1\n");
  print(".2\n");
  print(".3\n");
  print(".4\n");
  print(".5\n");
  print(".6\n");
  print(".7\n");
  print(".8\n");
  print(".9\n");
  
  //print("\n");
  print(".0\n");
  print(".1\n");
  print(".2\n");
  print(".3\n");
  print(".4\n");
  print(".5\n");
  print(".6\n");
  print(".7\n");
  print(".8\n");
  print(".9\n");
  print(".0\n");
  /*print("\n");
  print(".0\n");
  print(".1\n");
  print(".2\n");
  print(".3\n");
  print(".4\n");
  print(".5\n");
  print(".6\n");
  print(".7\n");
  print(".8\n");
  print(".9\n");
  
*/

  locate(2, 1);
  print("WyW");
  locate(2, 2);
  
  /*
  for (int y = 110; y < 200; y++){
    for (int x = 110; x < 200; x++){
      line(false, x, y, 320 - x, 200 + y, x+y , false, false, 0);
    }
  }
  */
  /*
  locate(34, 1);
  print("!!!\n");
  locate(35, 1);
  print("gW!");
*/
}


void Q7B_Screen::test2()
{
  color(15, 1);

  locate(1, 1);
  
  input();
  for (int i = 0; i < 35; i++){

   // if (i >= 14) 

    QString s = "1234567890 1234567890 123456g890 1234567u90 1234567890 1234567890 1234567u9!";

    QString k;
    k.sprintf("%d\n", i);

    print((s + k));
  }


  //line(false, 110, 70, 190, 120, 15, false, true, 0);
  //line(false, 0, 0, 320, 200, 3, false, false, 0xff00);

  circle(false, 320, 100, 200, 15, -1, -1, -1);

 // for (int i = 0; i < 256; i++){
 //   pset(false, 1, i, i);
    //pset(false, 2, i, 15);
//    line(false, 110, i, 320, i, i, false, false, 0);
 // }
  //line(false, 110, 40, 320, 200, 15, true, false, 0);
  //line(false, 110, 40, 32, 20, 15, false, true, 0);
  //circle(false, 44, 66, 8, 8, 6, 6, 4);
  //cls(0);
//  pressAnyKey();
  
}


void Q7B_Screen::aboutToQuit()
{
  
  if (bActivated){
  // qApp->processEvents(); // do last paint operations
    
    //m2.save(idePath("screen.png"));
  }
}

void Q7B_Screen::captureScreen()
{
  //QMessageBox::information(this, "julie", "");

  if (bActivated){
    qApp->processEvents(); // do last paint operations    
    //m2.save(idePath("screen.png"));    
  }
 
}

void Q7B_Screen::printScreen(bool bDialog)
{
  static QPrinter printer;
  //printer.setOrientation(QPrinter::Landscape);

  if (bDialog){
    QPrintDialog *dialog = new QPrintDialog(&printer, this);
    dialog->setWindowTitle(tr("Print Document"));
    if (dialog->exec() != QDialog::Accepted) return;
  }

  QPainter painter;
  painter.begin(&printer);

  painter.drawPixmap(0, 0, m2);

  painter.end();
}

Q7B_Screen *Q7B_myScreen = 0;

void Q7B_SHOWSCREEN()
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  Q7B_myScreen->activate();
}

void Q7B_HIDESCREEN()
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  Q7B_myScreen->deactivate();
}

void Q7B_CLOSESCREEN()
{
  if (Q7B_myScreen){
    delete Q7B_myScreen;
    Q7B_myScreen = 0;
  }
}

void Q7B_CLS()
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  Q7B_myScreen->cls(0);
}

void Q7B_LINE(Q7B x1, Q7B y1, Q7B x2, Q7B y2, Q7B bColor, Q7B color)
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  if (Q7B_nil(Q7B_INTEGER(x1))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(y1))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(x2))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(y2))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(bColor))){ Q7B_EXCEPTION("Boolean expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(color))){ Q7B_EXCEPTION("Integer expected"); return; }

  bool step = false;
  bool step2 = false;
  bool expression = false;
  bool b = false;
  bool bf = false;
  bool bStyle = false;
  int style = 0;

   Q7B_myScreen->line(step, Q7B_IDqint64(x1), Q7B_IDqint64(y1), 
         step2, expression, Q7B_IDqint64(x2), Q7B_IDqint64(y2), 
         Q7B_IDbool(bColor), Q7B_IDqint64(color), b, bf, bStyle, style);
}

void Q7B_PSET(Q7B x1, Q7B y1, Q7B bColor, Q7B color)
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  if (Q7B_nil(Q7B_INTEGER(x1))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(y1))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(bColor))){ Q7B_EXCEPTION("Boolean expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(color))){ Q7B_EXCEPTION("Integer expected"); return; }

  bool step = false;
   Q7B_myScreen->pset(step, Q7B_IDqint64(x1), Q7B_IDqint64(y1),Q7B_IDbool(bColor), Q7B_IDqint64(color));
}

Q7B Q7B_CSRLIN()
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  return Q7B_ID( Q7B_myScreen->csrlin() );
}

Q7B Q7B_POS()
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  return Q7B_ID( Q7B_myScreen->pos() );
}

void Q7B_COLOR(Q7B nFORE, Q7B nBACK) // if optional nFORE/nBACK= 0,  no decision possible if to ignore or to use 0
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  if (Q7B_nil(Q7B_INTEGER(nFORE))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(nBACK))){ Q7B_EXCEPTION("Integer expected"); return; }

  Q7B_myScreen->color(Q7B_IDqint64(nFORE), Q7B_IDqint64(nBACK));
}

void Q7B_PRINTSCREEN(Q7B bPrintDialog)
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  if (Q7B_nil(Q7B_BOOLEAN(bPrintDialog))){ Q7B_EXCEPTION("Boolean expected"); return; }

  Q7B_myScreen->printScreen(Q7B_IDbool(bPrintDialog));
}

void Q7B_LOCATE(Q7B Y, Q7B X) // if optional Y/X = 0,  no decision possible if to ignore or to use 0
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  if (Q7B_nil(Q7B_INTEGER(Y))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(X))){ Q7B_EXCEPTION("Integer expected"); return; }

  Q7B_myScreen->locate(Q7B_IDqint64(Y), Q7B_IDqint64(X));
}

void Q7B_PRINT(Q7B Q7B_Object)
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return; }
  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return; }

  QString s = Q7B_IDQString(Q7B_Object);
  Q7B_myScreen->print(s);
}

// ******************************************************************************************

bool Q7B_bDebugBreak = false;
bool Q7B_bDebug = true;
bool Q7B_bStepInto = false;
bool Q7B_bStepOut = false;
bool Q7B_bRunToCursor = false;
QString Q7B_sRunToCursorFile;
QString Q7B_sRunToCursorLine;
bool Q7B_bStepOver = false;

QString Q7B_sStepOverScope;
QString Q7B_sDebugScope;

void Q7BWriteDebugOutput(QString s)
{
  QFile f( QDir::tempPath() + "/Q7Basic/" + "/q7b_in" + QString("%1").arg(qApp->applicationPid()) + ".txt");
  if (f.open(QIODevice::WriteOnly | QIODevice::Truncate)){
    QTextStream t(&f);
    t << s;
    f.close();
   // QMessageBox::information(0, "Q7BWriteDebugOutput", s);
    
  }
}

QString Q7BReadDebugInput()
{
  QString s;
  if (QFile::exists(QDir::tempPath() + "/Q7Basic/" + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt")){
    QFile f( QDir::tempPath() + "/Q7Basic/" + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt");
    if (f.open(QIODevice::ReadOnly)){
      QTextStream t(&f);
      s = t.readAll();
      f.close();

      //  auch filesystem watcher hier

      //QFile::remove(QDir::tempPath() + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt");
    }
  }
  return s;
}

QMap<QString, QStringList> Q7B_breakpoints;

Q7BDebugListener Q7BDebugCommandExecuter;

/*
void Q7BE(QString sFile, QString sScope, QString sLine/ *, QString sType* /)
{
  Q7B_META_sCurrentFile = sFile;
  Q7B_META_sCurrentScope = sScope;
  Q7B_META_sCurrentLine = sLine;

  if (!Q7B_bDebug) return;
}*/

bool Q7BS(QString sFile, QString sScope, QString sLine, QString sType) // me, Local8Bit
{
/*
  static bool printerror = true;

  if (printerror && lookfor && lookfor->me.size() > 2){
    Q7B Q7B_Object = lookfor->me.at(2);

    if (Q7B_Object->type == typeid(qreal).name()){
      if ((int)((*((qreal *) Q7B_Object->ref))) != 1979){
        printerror = false;
       // lookfor = Q7B_Object;
        QMessageBox::information(0, "Q7BS", QString("!%1").arg((qreal)(*((qreal *) Q7B_Object->ref))) + "\n" + Q7B_QtBL());

        QMessageBox::information(0, "Q7B_toString2", Q7B_toString2(Q7B_Object)  );

      }
    }

  }
*/
 // QMessageBox::information(0, "Q7BS", QString("%1  %2").arg(bFirst).arg(Q7B_bDebug));

  Q7B_META_sCurrentFile = sFile;
  Q7B_META_sCurrentScope = sScope;
  Q7B_META_sCurrentLine = sLine;


/*
  QFile file(QDesktopServices::storageLocation(QDesktopServices::DesktopLocation) + "/" + "DEBUG.txt");
  if (file.open(QIODevice::WriteOnly)){
    QString ss = Q7B_META_sCurrentFile + " " + Q7B_META_sCurrentScope + " " + Q7B_META_sCurrentLine;
    const char *ac = ss.toLocal8Bit().constData();
    file.write(ac, qstrlen(ac)); 
    file.flush();
    file.close();
  }
*/


 // QMessageBox::information(0, "Q7BS", QString("%1  %2").arg(Q7B_META_sCurrentFile).arg(Q7B_META_sCurrentLine));

  if (!Q7B_bDebug) return true;

  static bool bFirst = true;
  if (bFirst){
    bFirst = false;  
    Q7BDebugCommandExecuter.init();
  }

  //bool bbb = Q7B_breakpoints[sFile].contains(sLine);
  

  bool bb = Q7B_breakpoints.contains(sFile) && Q7B_breakpoints[sFile].contains(sLine) && sType == "1"; 
/*
    if (Q7B_bStepOver && nType == 1){
       QMessageBox::information(0, "Q7BS", QString("sScope:%1\nQ7B_bStepInto:%2\nQ7B_bStepOver:%3\n%4\n%5").arg(sScope).arg((int)Q7B_bStepInto).arg((int)(Q7B_bStepOver && nType == 1 && sScope == sScope)).arg(Q7B_sDebugScope).arg(Q7B_sStepOverScope));
    }*/

  if (bb || (Q7B_bStepInto && sType == "1") || (Q7B_bStepOut && sType == "2" && sScope == Q7B_sDebugScope) || (Q7B_bStepOver && sType == "1" && sScope == Q7B_sDebugScope) || (Q7B_bRunToCursor && sType == "1" && Q7B_sRunToCursorFile == sFile && Q7B_sRunToCursorLine == sLine)){   


    Q7B_sRunToCursorFile = "";
    Q7B_sRunToCursorLine = "";

    Q7B_bStepInto = false;
    Q7B_bStepOver = false;
    Q7B_bStepOut = false;
    Q7B_bRunToCursor = false;

    Q7B_bDebugBreak = true;

    if (sType == "2"){
      /*
      if (Q7B_bStepOver && sScope == Q7B_sStepOverScope){
      QMessageBox::information(0, "Q7BS", "sScope == Q7B_sStepOverScope");

        Q7B_bStepOver = false;
      }*/
      
      Q7B_bStepInto = true;
    } else {      

      Q7BWriteDebugOutput("Breakpoint\n" + sFile + "\n" + sLine + "\n"); // emit breakpoint reached for ide
      //QMessageBox::information(0, "Q7BS", QString("%1\n%2\n%3").arg((int)Q7B_breakpoints.contains(sFile)).arg((int)bbb).arg(nType));
      
      while(Q7B_bDebugBreak && Q7B_bDebug){
        if (QFile::exists(QDir::tempPath() + "/Q7Basic/" + "/stop" + QString("%1").arg(qApp->applicationPid()) + ".txt")){
          QFile::remove(QDir::tempPath() + "/Q7Basic/" + "/stop" + QString("%1").arg(qApp->applicationPid()) + ".txt");
          Q7B_bDebugBreak = false;
        }
        
        /*
        else if (QFile::exists(QDir::tempPath() + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt")){

          // new command arrived ?
          QString s = Q7BReadDebugInput();
          if (!s.isEmpty()){

            QMessageBox::information(0, "Q7BReadDebugInput", s);
            
            // new breakpoint
            // continue, step into, step out, step over or run to cursor
            Q7B_bDebugBreak = false;

          }

        }
        */

        qApp->processEvents(QEventLoop::WaitForMoreEvents);
      }
    }

   // QMessageBox::information(0, "Stop", "!!!");
    Q7B_sDebugScope = sScope;
    return true;

  } else if (sType == "2"/* && sScope == Q7B_sDebugScope*/){
  //  QMessageBox::information(0, "ClearBreakpoint", sFile + "\n" + sLine);
    Q7BWriteDebugOutput("ClearBreakpoint\n" + sFile + "\n" + sLine + "\n"); // emit for ide

    if (Q7B_sStepOverScope == Q7B_sDebugScope){
  //    QMessageBox::information(0, "Q7BS", "ClearBreakpoint");
      Q7B_bStepOver = false;
      Q7B_bStepInto = true;

    }
  }


  if (!Q7B_bStepOver && !Q7B_bStepOut){
    Q7B_sDebugScope = sScope; // TODO2 hier muss noch datei rein
  }
  return true; // always return true for condition usage
}

void Q7BDebugListener::init()
{
  static bool bConnected = false;

  if (bConnected) return;
  if (!Q7B_bDebug) return;

  if (QFile::exists(QDir::tempPath() + "/Q7Basic/" + "/q7b_out.txt")){

    bConnected = true;

    QObject::connect(&watch, SIGNAL(fileChanged(const QString &)), this, SLOT(fileChanged(const QString &)));

    while (!QFile::exists(QDir::tempPath() + "/Q7Basic/" + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt")){ qApp->processEvents(QEventLoop::WaitForMoreEvents); }

    watch.addPath(QDir::tempPath() + "/Q7Basic/" + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt");


    QString s;

    QFile f( QDir::tempPath() + "/Q7Basic/" + "/q7b_out.txt");
    if (f.open(QIODevice::ReadOnly)){

     // QMessageBox::information(0, "q7b_out.txt", "");
      QTextStream t(&f);
      s = t.readAll();
      f.close();

      QFile::remove(QDir::tempPath() + "/Q7Basic/" + "/q7b_out.txt");
    }

    if (s.startsWith("breakpoints\n")){
      Q7B_breakpoints.clear();
      s = s.mid(12);

      QStringList l = s.split("\n");
      for (int i = 0; i < l.count() / 2; i++){
      //  QMessageBox::information(0, l.at(i * 2), l.at(i * 2 + 1));
        QStringList ll = l.at((i * 2 + 1)).split(";");
        Q7B_breakpoints[l.at(i * 2)] = ll;
      }

    }
 //QMessageBox::information(0, "!????breakpoints", s);
  }
}

  void Q7BDebugListener::fileChanged ( const QString  & path)
  {
 //   QMessageBox::information(0, "fileChanged", "");

    // new command arrived ?
    QString s;
    if (QFile::exists(QDir::tempPath() + "/Q7Basic/" + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt")){
      QFile f( QDir::tempPath() + "/Q7Basic/" + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt");
      if (f.open(QIODevice::ReadOnly)){
        QTextStream t(&f);
        s = t.readAll();
        f.close();

        //  auch filesystem watcher hier

        //QFile::remove(QDir::tempPath() + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt");
      }
    }

    //QString s = Q7BReadDebugInput();
    if (!s.isEmpty()){

      if (s.startsWith("Continue")){
        Q7B_bDebugBreak = false;
        return;
      }

      if (s.startsWith("StepInto")){
        Q7B_bStepInto = true;
        Q7B_bDebugBreak = false;
        return;
      }

      if (s.startsWith("StepOut")){
        Q7B_bStepOut = true;
        Q7B_bDebugBreak = false;
        return;
      }

      if (s.startsWith("StepOver")){
        Q7B_bStepOver = true;
        Q7B_bDebugBreak = false;        
        Q7B_sStepOverScope = Q7B_sDebugScope;
        return;
      }

      if (s.startsWith("RunToCursor\n")){

        s = s.mid(12);

        QStringList l = s.split("\n");

 // QMessageBox::information(0, "Breakpoint", QString("%1").arg(l.count()) );

        if (l.count() == 2){

          Q7B_bRunToCursor = true;
          Q7B_sRunToCursorFile = l.at(0);
          Q7B_sRunToCursorLine = l.at(1);
          Q7B_bDebugBreak = false;
        }

        return;
      }

      if (s.startsWith("Breakpoint\n")){

        s = s.mid(11);

        QStringList l = s.split("\n");

 // QMessageBox::information(0, "Breakpoint", QString("%1").arg(l.count()) );

        if (l.count() == 2){
          
          if (Q7B_breakpoints.contains(l.at(0))){

            if (Q7B_breakpoints[l.at(0)].contains(l.at(1))){

          //    QMessageBox::information(0, "", "remove");

              Q7B_breakpoints[l.at(0)].removeAll(l.at(1));
            } else {
           //   QMessageBox::information(0, "", "append1");

              Q7B_breakpoints[l.at(0)].append(l.at(1));
            }

          } else {
           //   QMessageBox::information(0, "", "append2");

              Q7B_breakpoints[l.at(0)].append(l.at(1));

          }

        }

        return;
      }


     //QMessageBox::information(0, "Q7BReadDebugInput", s);
    

    //  QMessageBox::information(0, "Q7BReadDebugInput", s);
      
      // new breakpoint
      // continue, step into, step out, step over or run to cursor
      //Q7B_bDebugBreak = false;

    }
  }
 
  //fileChanged(QDir::tempPath() + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt");

/*
  QFile f( QDir::tempPath() + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt");
  if (f.open(QIODevice::WriteOnly | QIODevice::Truncate)){
  }

  QString sDebugFile = QDir::tempPath() + "/q7b_in" + QString("%1").arg(PID) + ".txt";
  SaveFile2(sDebugFile, ""); /
  watch.addPath(sDebugFile);*/















/*
QWidget *Q7BOutletSet(QWidget *parent, QLayout *parentLayout, QWidget *Old, QWidget *New)
{
  

  QBoxLayout *q7bboxlayout = qobject_cast<QBoxLayout *>(parentLayout);
  //QFormLayout *q7bformlayout = qobject_cast<QFormLayout *>(parentLayout);
 // QGridLayout *q7bgridlayout = qobject_cast<QGridLayout *>(parentLayout);

  if (q7bboxlayout){
    QLayoutItem *it = 0;
    int i = 0; 
    for (; i < q7bboxlayout->count(); i++){
      it = q7bboxlayout->itemAt(i); 
      if (qobject_cast<QBoxLayout *>(it->layout())){
        //QMessageBox::information(0, "if (Old->layout()){", "4444");
        QWidget *w = Q7BOutletSet(parent->isWidgetType() ? (QWidget *) parent : 0, qobject_cast<QBoxLayout *>(it->layout()), Old, New);
        if (w) return w;
      }
      if (q7bboxlayout->itemAt(i)->widget() == Old){         
        q7bboxlayout->removeItem(it);
        q7bboxlayout->insertWidget(i, New);
        New->setGeometry(Old->geometry()); New->setMinimumSize(Old->minimumSize()); New->setMaximumSize(Old->maximumSize()); New->setSizePolicy(Old->sizePolicy());
        Old->close();
        return New;
      }
    }

  / *} else if (q7bformlayout){
    int rowPtr;
    QFormLayout::ItemRole rolePtr;    
    q7bformlayout->getWidgetPosition(Old, &rowPtr, &rolePtr);

    if (rowPtr != -1){
      QLayoutItem *it = q7bformlayout->itemAt(rowPtr, rolePtr);
      q7bformlayout->removeItem(it);
      Old->close();
      q7bformlayout->setWidget(rowPtr, rolePtr, New);      
    }


    QLayoutItem *it = 0;
    int i = 0; 
    for (int y = 0; y < 3; y++){
      for (; i < q7bformlayout->rowCount(); i++){
        it = q7bformlayout->itemAt(i, (QFormLayout::ItemRole) y ); 
        if (it->widget() == Old){         
    QMessageBox::information(0, "if (Old->layout()){", "005000");
          q7bformlayout->removeItem(it);
          Old->close();
          q7bformlayout->setWidget(i, (QFormLayout::ItemRole) y, New);      
          return New;
        }
      }
    }
* /
  }
  
  if (parent->parent() && (parent->isWidgetType() ? (QWidget *) parent : 0->parent())->layout()){

    //QMessageBox::information(0, "if (Old->layout()){", "3333");
    QWidget *w = Q7BOutletSet(parent->isWidgetType() ? (QWidget *) parent : 0->parent(), (parent->isWidgetType() ? (QWidget *) parent : 0->parent())->layout(), Old, New);
    if (w) return w;
    goto we;
    
  } else {
we:
    //QMessageBox::information(0, "if (Old->layout()){", "2222");

    if (Old->parentWidget() == parent->parentWidget()){
      New->setParent(parent->parentWidget());
      New->setGeometry(Old->geometry()); New->setMinimumSize(Old->minimumSize()); New->setMaximumSize(Old->maximumSize()); New->setSizePolicy(Old->sizePolicy());
      Old->close();
      return New;
    }
  }

  return 0;
}
*/



/*

' TODO2 SDI.Open   Window.Open    MDI.Open  DockWidget.Open  ToolWindow.Open  XYZ als QWidget wird gesetzt
' TODO2 MDI.List() As List DockWidget.List() As List, ToolWindow.List() As List, Window.List() As List, Windows.List() As List = alle
' TODO2 DockWidget.Close, DockWidget.Hide, DockWidget.ShowOrHide...
' TODO2 MDI.Current(), MDI.SetCurrent(QWidget)
' TODO2 Windows.Focus() As QWidget, 
' TODO2  ListMDI() As List, ListWindow As List
' TODO2 Application.AvailableDataBaseDrivers() As List
TODO2 DatabaseDialog object

' NO Open("name", SDI, MDI, Window...)  
' NO MDIWindows As List, DockWidgets As List ToolWindows As List, Windows As List, WindowWidgets As List
' NO CloseDockWidget, HideDockWidget  ShowDockWidget(name[, "normal, maximized, minimized]) OnOffDockWidget IsVisibleDockWidget  gleiche f?r window, toolboxwindow
' NO FocusWindowWidget() As QWidget, , CurrentMDIWindow() As QWidget, SetCurrentMDIWindow(QWidget)

' gibt nur eine konnektion, wer mehr braucht muss static classes/objects benutzen
' SQLConnect(Driver As String, Name As String[, User As String, [Password As String, [Host As String = Local8BitHost, [Options As String = "", [Port As Integer = DefaultPort]]]]]) As Boolean
' SQLDisconnect() As Boolean
' SQLQuery("sql") As Q7B als boolean oder List of dictionary  k?nnte auch fake sein mit internem sqlrecordset


' als helper funktion in q7basic geschrieben:
' SQLSearch(SearchFor As String, InTableDotField As String, ReturnFieldName As String) As id
  SQLGet(SQLStatement As String) As id

  sqlencode, sqldecode
  
  
 fkt info wie in objb

 todo2 winapi beispiel mithilfe von c++ bridgecode und declare aufruf von q7basic aus


NO text as alias for string  (nein, da namenskollision)
TODO2 office stylesheet aus kbasic ?ber declare einbinden
TODO2 TRACE cerr <<
TODO2ReadData mit boolean, float, integer, string jeweils len
TODO2WriteData

TODO3 trycatchfinally mit if else simulieren m?sste gehen  id hat bException und sException + Exception

TODO2 IsData

TODO2 IsRect
TODO2 IsSize
TODO2 IsRegion


 TODO2  Format wie http://www.kbasic.com/doku.php?id=lrbuiltins#string_cast und datetime



TODO2 Database object  AvailableDataBaseDrivers() As List
TODO2 Table object
TODO2 Records object
TODO2 Query object


TODO2 form sql feature
TODO2 sqlencode, sqldecode fkt escapes forbidden correctors in sql statements. 


TODO2 decimal class

TODO2 data class
TODO2 DesktopWidget object
TODO2 IsDecimal


TODO2 Desktop object
Desktop.DocumentsLocation


TODO2 Zip /Unzip
HtmlDownload(url, tofilepath)
FtpUpload(Host As String, Port As Integer, User As String, Password As String, Local8BitFileName As String) As Boolean
FtpDownload(Host As String, Port As Integer, User As String, Password As String, RemoteFileName As String, Local8BitFileName As String) As Boolean


TODO2 stringcast: Function decimal() as decimal
 
stdin


' TODO2 CloseDialog("mydialog") close and delete
' TODO2 CloseToolWindow("mytoolwindow") close and delete



*/

/*
  void Q7B_id::ByRefAssignment(Q7B c)
  {

    if (type == typeid(qreal).name()){
      if ((*(qreal *) ref) == 1979){
        QMessageBox::information(0, "ByRefAssignment", Q7B_toString2(c) + "\nin line " + Q7B_QtBL());
      }
    }

    type = c->type;
    ref = c->ref;
    q7b_array = c->q7b_array;
    q7b_type = c->q7b_type;
    q7b_array_count = c->q7b_array_count;
    array_indexes[0] = c->array_indexes[0];
    array_indexes[1] = c->array_indexes[1];
    array_indexes[2] = c->array_indexes[2];
    array_indexes[3] = c->array_indexes[3];
    gc_enabled = c->gc_enabled;

    c->gc_enabled = false; // prevent destruction deletes
  }*/
  


/*

--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------
*/



// Begin Generator h#6

Q7B Q7B_QLISTQSTRINGLIST_INIT(QObject *parent, const char *objectName) // generated
{
  QList<QStringList> *o = new QList<QStringList>();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QList<QStringList>).name(), o, !parent->isWidgetType() )); 
  return q;
}




Q7B Q7B_QDATETIMEEDIT_INIT(QObject *parent, const char *objectName) // generated
{
  QDateTimeEdit *o = new QDateTimeEdit();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QDateTimeEdit).name(), o, !parent->isWidgetType() )); 
  return q;
}

Q7B Q7B_QACCESSIBLEEVENT_INIT(QObject *parent, const char *objectName) // generated
{
//  QAccessibleEvent *o = new QAccessibleEvent();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  //Q7B q (new Q7B_id(typeid(QAccessibleEvent).name(), o, !parent->isWidgetType() )); 
  //return q;
  return Q7B_idnil;
}

Q7B Q7B_QACTIONEVENT_INIT(QObject *parent, const char *objectName) // generated
{
 // QActionEvent *o = new QActionEvent();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  //Q7B q (new Q7B_id(typeid(QActionEvent).name(), o, !parent->isWidgetType() )); 
  //return q;
  return Q7B_idnil;
}

Q7B Q7B_QCHILDEVENT_INIT(QObject *parent, const char *objectName) // generated
{
 // QChildEvent *o = new QChildEvent();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
 // Q7B q (new Q7B_id(typeid(QChildEvent).name(), o, !parent->isWidgetType() )); 
  //return q;
  return Q7B_idnil;
}

Q7B Q7B_QDECLARATIVECONTEXT_INIT(QObject *parent, const char *objectName) // generated
{
//  QDeclarativeContext *o = new QDeclarativeContext();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  //Q7B q (new Q7B_id(typeid(QDeclarativeContext).name(), o, !parent->isWidgetType() )); 
  //return q;
  return Q7B_idnil;
}

Q7B Q7B_QDRAGLEAVEEVENT_INIT(QObject *parent, const char *objectName) // generated
{
  QDragLeaveEvent *o = new QDragLeaveEvent();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QDragLeaveEvent).name(), o, !parent->isWidgetType() )); 
  return q;
}

Q7B Q7B_QDROPEVENT_INIT(QObject *parent, const char *objectName) // generated
{
//  QDropEvent *o = new QDropEvent();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
 // Q7B q (new Q7B_id(typeid(QDropEvent).name(), o, !parent->isWidgetType() )); 
 // return q;
  return Q7B_idnil;
}

Q7B Q7B_QDYNAMICPROPERTYCHANGEEVENT_INIT(QObject *parent, const char *objectName) // generated
{
//  QDynamicPropertyChangeEvent *o = new QDynamicPropertyChangeEvent();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
//  Q7B q (new Q7B_id(typeid(QDynamicPropertyChangeEvent).name(), o, !parent->isWidgetType() )); 
  //return q;
  return Q7B_idnil;
}

Q7B Q7B_QFILEOPENEVENT_INIT(QObject *parent, const char *objectName) // generated
{
//  QFileOpenEvent *o = new QFileOpenEvent();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  //Q7B q (new Q7B_id(typeid(QFileOpenEvent).name(), o, !parent->isWidgetType() )); 
  //return q;
  return Q7B_idnil;
}

Q7B Q7B_QGRAPHICSSCENEEVENT_INIT(QObject *parent, const char *objectName) // generated
{
 return Q7B_idnil;
}

Q7B Q7B_QHELPEVENT_INIT(QObject *parent, const char *objectName) // generated
{
return Q7B_idnil;
}

Q7B Q7B_QHIDEEVENT_INIT(QObject *parent, const char *objectName) // generated
{
return Q7B_idnil;
}

Q7B Q7B_QHOVEREVENT_INIT(QObject *parent, const char *objectName) // generated
{
  return Q7B_idnil;
}

Q7B Q7B_QICONDRAGEVENT_INIT(QObject *parent, const char *objectName) // generated
{
 return Q7B_idnil;
}

Q7B Q7B_QINPUTMETHODEVENT_INIT(QObject *parent, const char *objectName) // generated
{
 return Q7B_idnil;
}

Q7B Q7B_QMOVEEVENT_INIT(QObject *parent, const char *objectName) // generated
{
 return Q7B_idnil;
}

Q7B Q7B_QPRINTPREVIEWDIALOG_INIT(QObject *parent, const char *objectName) // generated
{
  QPrintPreviewDialog *o = new QPrintPreviewDialog();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QPrintPreviewDialog).name(), o, !parent->isWidgetType() )); 
  return q;
}

Q7B Q7B_QPRINTERINFO_INIT(QObject *parent, const char *objectName) // generated
{
  QPrinterInfo *o = new QPrinterInfo();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QPrinterInfo).name(), o, !parent->isWidgetType() )); 
  return q;
}

Q7B Q7B_QSHORTCUTEVENT_INIT(QObject *parent, const char *objectName) // generated
{
 return Q7B_idnil;
}

Q7B Q7B_QSHOWEVENT_INIT(QObject *parent, const char *objectName) // generated
{
 return Q7B_idnil;
}

Q7B Q7B_QSTATUSTIPEVENT_INIT(QObject *parent, const char *objectName) // generated
{
 return Q7B_idnil;
}

Q7B Q7B_QTIMEREVENT_INIT(QObject *parent, const char *objectName) // generated
{
 return Q7B_idnil;
}

Q7B Q7B_QWHATSTHISCLICKEDEVENT_INIT(QObject *parent, const char *objectName) // generated
{
 return Q7B_idnil;
}

Q7B Q7B_QWINDOWSTATECHANGEEVENT_INIT(QObject *parent, const char *objectName) // generated
{
  return Q7B_idnil;
}

Q7B Q7B_QSYSTEMTRAYICON_INIT(QObject *parent, const char *objectName) // generated
{
  QSystemTrayIcon *o = new QSystemTrayIcon();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QSystemTrayIcon).name(), o, !parent->isWidgetType() )); 
  return q;
}

Q7B Q7B_QCLIPBOARD_INIT(QObject *parent, const char *objectName) // generated
{
  QClipboard *clip = QApplication::clipboard();
  Q7B q (new Q7B_id(typeid(QClipboard).name(), clip, false));   

  clip->setObjectName(objectName);
  Q7B_connectSlotsByName((QObject *) clip, parent);

  return q;

//  QClipboard *o = new QClipboard(parent);
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  //Q7B q (new Q7B_id(typeid(QClipboard).name(), o, !parent->isWidgetType()));   
 // return q;
  //return Q7B_idnil;
}

Q7B Q7B_QDRAG_INIT(QObject *parent, const char *objectName) // generated
{
  QDrag *o = new QDrag(0);
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QDrag).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QFONTDATABASE_INIT(QObject *parent, const char *objectName) // generated
{
  QFontDatabase *o = new QFontDatabase();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QFontDatabase).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QFTP_INIT(QObject *parent, const char *objectName) // generated
{
  QFtp *o = new QFtp();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QFtp).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QHOSTADDRESS_INIT(QObject *parent, const char *objectName) // generated
{
  QHostAddress *o = new QHostAddress();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QHostAddress).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QLINE_INIT(QObject *parent, const char *objectName) // generated
{
  QLine *o = new QLine();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QLine).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QLOCALSERVER_INIT(QObject *parent, const char *objectName) // generated
{
  QLocalServer *o = new QLocalServer();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QLocalServer).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QLOCALSOCKET_INIT(QObject *parent, const char *objectName) // generated
{
  QLocalSocket *o = new QLocalSocket();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QLocalSocket).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QMIMEDATA_INIT(QObject *parent, const char *objectName) // generated
{
  QMimeData *o = new QMimeData();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QMimeData).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QNETWORKSESSION_INIT(QObject *parent, const char *objectName) // generated
{
  QNetworkConfiguration nf;
  QNetworkSession *o = new QNetworkSession(nf);
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QNetworkSession).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QREGEXPVALIDATOR_INIT(QObject *parent, const char *objectName) // generated
{
  QRegExpValidator *o = new QRegExpValidator();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QRegExpValidator).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QRESOURCE_INIT(QObject *parent, const char *objectName) // generated
{
  QResource *o = new QResource();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QResource).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QRUBBERBAND_INIT(QObject *parent, const char *objectName) // generated
{
  QRubberBand *o = new QRubberBand(QRubberBand::Line);
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QRubberBand).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSESSIONMANAGER_INIT(QObject *parent, const char *objectName) // generated
{
 // QSessionManager *o = new QSessionManager(qApp);
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
 // Q7B q (new Q7B_id(typeid(QSessionManager).name(), o, !parent->isWidgetType()));   
 // return q;
  return Q7B_idnil;
}

Q7B Q7B_QSIZEGRIP_INIT(QObject *parent, const char *objectName) // generated
{
  QSizeGrip *o = new QSizeGrip(0);
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QSizeGrip).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSIZEPOLICY_INIT(QObject *parent, const char *objectName) // generated
{
  QSizePolicy *o = new QSizePolicy();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QSizePolicy).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSOUND_INIT(QObject *parent, const char *objectName) // generated
{
  QSound *o = new QSound("");
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QSound).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSTACKEDLAYOUT_INIT(QObject *parent, const char *objectName) // generated
{
  QStackedLayout *o = new QStackedLayout();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QStackedLayout).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSYSTEMLOCALE_INIT(QObject *parent, const char *objectName) // generated
{
  QSystemLocale *o = new QSystemLocale();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QSystemLocale).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTIMELINE_INIT(QObject *parent, const char *objectName) // generated
{
  QTimeLine *o = new QTimeLine();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTimeLine).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QPEN_INIT(QObject *parent, const char *objectName) // generated
{
  QPen *o = new QPen();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QPen).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QPOLYGON_INIT(QObject *parent, const char *objectName) // generated
{
  QPolygon *o = new QPolygon();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QPolygon).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTEXTDOCUMENTFRAGMENT_INIT(QObject *parent, const char *objectName) // generated
{
  QTextDocumentFragment *o = new QTextDocumentFragment();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTextDocumentFragment).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTEXTFRAMEFORMAT_INIT(QObject *parent, const char *objectName) // generated
{
  QTextFrameFormat *o = new QTextFrameFormat();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTextFrameFormat).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QITEMSELECTIONMODEL_INIT(QObject *parent, const char *objectName) // generated
{
//  QItemSelectionModel *o = new QItemSelectionModel();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  //Q7B q (new Q7B_id(typeid(QItemSelectionModel).name(), o, !parent->isWidgetType()));   
  //return q;
  return Q7B_idnil;
}

Q7B Q7B_QLAYOUTITEM_INIT(QObject *parent, const char *objectName) // generated
{
 // QLayoutItem *o = new QLayoutItem();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
 // Q7B q (new Q7B_id(typeid(QLayoutItem).name(), o, !parent->isWidgetType()));   
 // return q;
  return Q7B_idnil;
}


Q7B Q7B_QTEXTBLOCKFORMAT_INIT(QObject *parent, const char *objectName) // generated
{
  QTextBlockFormat *o = new QTextBlockFormat();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTextBlockFormat).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTEXTCHARFORMAT_INIT(QObject *parent, const char *objectName) // generated
{
  QTextCharFormat *o = new QTextCharFormat();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTextCharFormat).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QABSTRACTPRINTDIALOG_INIT(QObject *parent, const char *objectName) // generated
{
 // QAbstractPrintDialog *o = new QAbstractPrintDialog();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
 // Q7B q (new Q7B_id(typeid(QAbstractPrintDialog).name(), o, !parent->isWidgetType()));   
  //return q;
  return Q7B_idnil;
}

Q7B Q7B_QINTVALIDATOR_INIT(QObject *parent, const char *objectName) // generated
{
  QIntValidator *o = new QIntValidator();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QIntValidator).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QPRINTDIALOG_INIT(QObject *parent, const char *objectName) // generated
{
  QPrintDialog *o = new QPrintDialog();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QPrintDialog).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QABSTRACTITEMMODEL_INIT(QObject *parent, const char *objectName) // generated
{
 // QAbstractItemModel *o = new QAbstractItemModel();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
 // Q7B q (new Q7B_id(typeid(QAbstractItemModel).name(), o, !parent->isWidgetType()));   
 // return q;
  return Q7B_idnil;
}

Q7B Q7B_QACTIONGROUP_INIT(QObject *parent, const char *objectName) // generated
{
//  QActionGroup *o = new QActionGroup();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
//  Q7B q (new Q7B_id(typeid(QActionGroup).name(), o, !parent->isWidgetType()));   
 // return q;
  return Q7B_idnil;
}

Q7B Q7B_QCOMPLETER_INIT(QObject *parent, const char *objectName) // generated
{
  QCompleter *o = new QCompleter();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QCompleter).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QCOREAPPLICATION_INIT(QObject *parent, const char *objectName) // generated
{
//  QCoreApplication *o = new QCoreApplication();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
//  Q7B q (new Q7B_id(typeid(QCoreApplication).name(), o, !parent->isWidgetType()));   
//  return q;
  return Q7B_idnil;
}

Q7B Q7B_QPRINTPREVIEWWIDGET_INIT(QObject *parent, const char *objectName) // generated
{
  QPrintPreviewWidget *o = new QPrintPreviewWidget();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QPrintPreviewWidget).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QURLINFO_INIT(QObject *parent, const char *objectName) // generated
{
  QUrlInfo *o = new QUrlInfo();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QUrlInfo).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QMODELINDEX_INIT(QObject *parent, const char *objectName) // generated
{
  QModelIndex *o = new QModelIndex();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QModelIndex).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QABSTRACTITEMVIEW_INIT(QObject *parent, const char *objectName) // generated
{
//  QAbstractItemView *o = new QAbstractItemView();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
 //Q7B q (new Q7B_id(typeid(QAbstractItemView).name(), o, !parent->isWidgetType()));   
 // return q;
  return Q7B_idnil;
}

Q7B Q7B_QHEADERVIEW_INIT(QObject *parent, const char *objectName) // generated
{
  QHeaderView *o = new QHeaderView(Qt::Horizontal);
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QHeaderView).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QINPUTDIALOG_INIT(QObject *parent, const char *objectName) // generated
{
  QInputDialog *o = new QInputDialog();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QInputDialog).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QVALIDATOR_INIT(QObject *parent, const char *objectName) // generated
{
 // QValidator *o = new QValidator();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
 // Q7B q (new Q7B_id(typeid(QValidator).name(), o, !parent->isWidgetType()));   
 // return q;
  return Q7B_idnil;
}

Q7B Q7B_QFILEINFOLIST_INIT(QObject *parent, const char *objectName) // generated
{
  QFileInfoList *o = new QFileInfoList();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QFileInfoList).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSPLITTERHANDLE_INIT(QObject *parent, const char *objectName) // generated
{
  QSplitterHandle *o = new QSplitterHandle(Qt::Horizontal, 0);
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QSplitterHandle).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTABLEWIDGETITEM_INIT(QObject *parent, const char *objectName) // generated
{
  QTableWidgetItem *o = new QTableWidgetItem();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTableWidgetItem).name(), o, !parent->isWidgetType()));   
  return q;
}
/*
Q7B Q7B_QWEBSETTINGS_INIT(QObject *parent, const char *objectName) // generated
{
  QWebSettings *o = new QWebSettings();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QWebSettings).name(), o, !parent->isWidgetType()));   
  return q;
}*/

Q7B Q7B_QNETWORKREQUEST_INIT(QObject *parent, const char *objectName) // generated
{
  QNetworkRequest *o = new QNetworkRequest();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QNetworkRequest).name(), o, !parent->isWidgetType()));   
  return q;
}



Q7B Q7B_QABSTRACTTEXTDOCUMENTLAYOUT_INIT(QObject *parent, const char *objectName) // generated
{
  return Q7B_idnil;
//  QAbstractTextDocumentLayout *o = new QAbstractTextDocumentLayout();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
 // Q7B q (new Q7B_id(typeid(QAbstractTextDocumentLayout).name(), o, !parent->isWidgetType()));   
  //return q;
}

Q7B Q7B_QPRINTER_INIT(QObject *parent, const char *objectName) // generated
{
  QPrinter *o = new QPrinter();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QPrinter).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSIZEF_INIT(QObject *parent, const char *objectName) // generated
{
  QSizeF *o = new QSizeF();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QSizeF).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTEXTFORMAT_INIT(QObject *parent, const char *objectName) // generated
{
  QTextFormat *o = new QTextFormat();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTextFormat).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTEXTCURSOR_INIT(QObject *parent, const char *objectName) // generated
{
  QTextCursor *o = new QTextCursor();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTextCursor).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTEXTOPTION_INIT(QObject *parent, const char *objectName) // generated
{
  QTextOption *o = new QTextOption();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTextOption).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QURL_INIT(QObject *parent, const char *objectName) // generated
{
  QUrl *o = new QUrl();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QUrl).name(), o, !parent->isWidgetType()));   
  return q;
}
Q7B Q7B_QBITMAP_INIT(QObject *parent, const char *objectName) // generated
{
  QBitmap *o = new QBitmap();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QBitmap).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QBOXLAYOUT_INIT(QObject *parent, const char *objectName) // generated
{
  QBoxLayout *o = new QBoxLayout(QBoxLayout::LeftToRight);
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QBoxLayout).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QBRUSH_INIT(QObject *parent, const char *objectName) // generated
{
  QBrush *o = new QBrush();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QBrush).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QBYTEARRAY_INIT(QObject *parent, const char *objectName) // generated
{
  QByteArray *o = new QByteArray();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QByteArray).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QCHAR_INIT(QObject *parent, const char *objectName) // generated
{
  QChar *o = new QChar();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QChar).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QCLOSEEVENT_INIT(QObject *parent, const char *objectName) // generated
{
  QCloseEvent *o = new QCloseEvent();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QCloseEvent).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QCOLOR_INIT(QObject *parent, const char *objectName) // generated
{
  QColor *o = new QColor();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QColor).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QCONTEXTMENUEVENT_INIT(QObject *parent, const char *objectName) // generated
{
  QContextMenuEvent *o = new QContextMenuEvent(QContextMenuEvent::Other, QPoint(0, 0));
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QContextMenuEvent).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QCURSOR_INIT(QObject *parent, const char *objectName) // generated
{
  QCursor *o = new QCursor();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QCursor).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QDATE_INIT(QObject *parent, const char *objectName) // generated
{
  QDate *o = new QDate();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QDate).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QDATETIME_INIT(QObject *parent, const char *objectName) // generated
{
  QDateTime *o = new QDateTime();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QDateTime).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QDIR_INIT(QObject *parent, const char *objectName) // generated
{
  QDir *o = new QDir();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QDir).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QELAPSEDTIMER_INIT(QObject *parent, const char *objectName) // generated
{
  QElapsedTimer *o = new QElapsedTimer();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QElapsedTimer).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QEVENT_INIT(QObject *parent, const char *objectName) // generated
{
  QEvent *o = new QEvent(QEvent::None);
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QEvent).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QFILEINFO_INIT(QObject *parent, const char *objectName) // generated
{
  QFileInfo *o = new QFileInfo();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QFileInfo).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QFILESYSTEMWATCHER_INIT(QObject *parent, const char *objectName) // generated
{
  QFileSystemWatcher *o = new QFileSystemWatcher();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QFileSystemWatcher).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QFOCUSEVENT_INIT(QObject *parent, const char *objectName) // generated
{
  QFocusEvent *o = new QFocusEvent(QEvent::None);
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QFocusEvent).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QFONT_INIT(QObject *parent, const char *objectName) // generated
{
  QFont *o = new QFont();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QFont).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QFONTINFO_INIT(QObject *parent, const char *objectName) // generated
{
  QFontInfo *o = new QFontInfo(QFont());
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QFontInfo).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QFONTMETRICS_INIT(QObject *parent, const char *objectName) // generated
{
  QFontMetrics *o = new QFontMetrics(QFont());
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QFontMetrics).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QHOSTINFO_INIT(QObject *parent, const char *objectName) // generated
{
  QHostInfo *o = new QHostInfo();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QHostInfo).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QICON_INIT(QObject *parent, const char *objectName) // generated
{
  QIcon *o = new QIcon();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QIcon).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QIMAGE_INIT(QObject *parent, const char *objectName) // generated
{
  QImage *o = new QImage();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QImage).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QINPUTEVENT_INIT(QObject *parent, const char *objectName) // generated
{
  QInputEvent *o = new QInputEvent(QEvent::None);
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QInputEvent).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QKEYSEQUENCE_INIT(QObject *parent, const char *objectName) // generated
{
  QKeySequence *o = new QKeySequence();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QKeySequence).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QLISTWIDGETITEM_INIT(QObject *parent, const char *objectName) // generated
{
  QListWidgetItem *o = new QListWidgetItem();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QListWidgetItem).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QLOCALE_INIT(QObject *parent, const char *objectName) // generated
{
  QLocale *o = new QLocale();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QLocale).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QMARGINS_INIT(QObject *parent, const char *objectName) // generated
{
  QMargins *o = new QMargins();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QMargins).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QMATRIX_INIT(QObject *parent, const char *objectName) // generated
{
  QMatrix *o = new QMatrix();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QMatrix).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QMDISUBWINDOW_INIT(QObject *parent, const char *objectName) // generated
{
  QMdiSubWindow *o = new QMdiSubWindow();
  //  o->setProperty("Parent", (qint64) parent);
  //o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QMdiSubWindow).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QMENUBAR_INIT(QObject *parent, const char *objectName) // generated
{
  QMenuBar *o = new QMenuBar();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QMenuBar).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QMOVIE_INIT(QObject *parent, const char *objectName) // generated
{
  QMovie *o = new QMovie();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QMovie).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QPAINTEVENT_INIT(QObject *parent, const char *objectName) // generated
{
  QPaintEvent *o = new QPaintEvent(QRect(0, 0, 0, 0));
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QPaintEvent).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QPALETTE_INIT(QObject *parent, const char *objectName) // generated
{
  QPalette *o = new QPalette();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QPalette).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QPICTURE_INIT(QObject *parent, const char *objectName) // generated
{
  QPicture *o = new QPicture();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QPicture).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QPIXMAP_INIT(QObject *parent, const char *objectName)
{

    QPixmap *o = new QPixmap();
    //  o->setProperty("Parent", (qint64) parent);
    //  o->setObjectName(objectName);
    Q7B q (new Q7B_id(typeid(QPixmap).name(), o, !parent->isWidgetType()));   
    return q;
 
}

Q7B Q7B_QPIXMAP_INIT(QObject *parent, const char *objectName, Q7B v)
{
  if (v->type == typeid(QString).name()){
    return Q7B_ID( QPixmap(*((QString *) v->ref)) );
/*
  } else if (v->type == typeid(QByteArray).name()){
    return Q7B_ID( Q7B_QByteArray2QPixmap(*((QByteArray *) v->ref)) );
  } else if (v->type == typeid(QPixmap).name()){
    return Q7B_ID( QIcon(*((QIcon *) v->ref)) );*/
  } else if (v.isNull()){
    QPixmap *o = new QPixmap();
    //  o->setProperty("Parent", (qint64) parent);
    //  o->setObjectName(objectName);
    Q7B q (new Q7B_id(typeid(QPixmap).name(), o, !parent->isWidgetType()));   
    return q;
  }

  return Q7B_idnil; // TODO2 exception here 
}

Q7B Q7B_QPOINT_INIT(QObject *parent, const char *objectName) // generated
{
  QPoint *o = new QPoint();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QPoint).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QPROCESS_INIT(QObject *parent, const char *objectName) // generated
{
  QProcess *o = new QProcess();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QProcess).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QPROCESSENVIRONMENT_INIT(QObject *parent, const char *objectName) // generated
{
  QProcessEnvironment *o = new QProcessEnvironment();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QProcessEnvironment).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QPROGRESSDIALOG_INIT(QObject *parent, const char *objectName) // generated
{
  QProgressDialog *o = new QProgressDialog();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QProgressDialog).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QRECT_INIT(QObject *parent, const char *objectName) // generated
{
  QRect *o = new QRect();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QRect).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QREGEXP_INIT(QObject *parent, const char *objectName) // generated
{
  QRegExp *o = new QRegExp();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QRegExp).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QREGION_INIT(QObject *parent, const char *objectName) // generated
{
  QRegion *o = new QRegion();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QRegion).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QRESIZEEVENT_INIT(QObject *parent, const char *objectName) // generated
{
  QResizeEvent *o = new QResizeEvent(QSize(0, 0), QSize(0, 0));
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QResizeEvent).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QRGB_INIT(QObject *parent, const char *objectName) // generated
{
  QRgb *o = new QRgb();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QRgb).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSIGNALMAPPER_INIT(QObject *parent, const char *objectName) // generated
{
  QSignalMapper *o = new QSignalMapper();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QSignalMapper).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSIZE_INIT(QObject *parent, const char *objectName) // generated
{
  QSize *o = new QSize();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QSize).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSPLASHSCREEN_INIT(QObject *parent, const char *objectName) // generated
{
  QSplashScreen *o = new QSplashScreen();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QSplashScreen).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSPLITTER_INIT(QObject *parent, const char *objectName) // generated
{
  QSplitter *o = new QSplitter();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QSplitter).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSTATUSBAR_INIT(QObject *parent, const char *objectName) // generated
{
  QStatusBar *o = new QStatusBar();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QStatusBar).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSTRING_INIT(QObject *parent, const char *objectName) // generated
{
  QString *o = new QString();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QString).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSTRINGLIST_INIT(QObject *parent, const char *objectName) // generated
{
  QStringList *o = new QStringList();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QStringList).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QSVGWIDGET_INIT(QObject *parent, const char *objectName) // generated
{
  QSvgWidget *o = new QSvgWidget();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QSvgWidget).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTABBAR_INIT(QObject *parent, const char *objectName) // generated
{
  QTabBar *o = new QTabBar();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTabBar).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTEXTBLOCK_INIT(QObject *parent, const char *objectName) // generated
{
  QTextBlock *o = new QTextBlock();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTextBlock).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTEXTDOCUMENT_INIT(QObject *parent, const char *objectName) // generated
{
  QTextDocument *o = new QTextDocument();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTextDocument).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTHREAD_INIT(QObject *parent, const char *objectName) // generated
{
  QThread *o = new QThread();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QThread).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTIME_INIT(QObject *parent, const char *objectName) // generated
{
  QTime *o = new QTime();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTime).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTIMER_INIT(QObject *parent, const char *objectName) // generated
{
  QTimer *o = new QTimer();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTimer).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTOOLBAR_INIT(QObject *parent, const char *objectName) // generated
{
  QToolBar *o = new QToolBar();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QToolBar).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTRANSFORM_INIT(QObject *parent, const char *objectName) // generated
{
  QTransform *o = new QTransform();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTransform).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QTREEWIDGETITEM_INIT(QObject *parent, const char *objectName) // generated
{
  QTreeWidgetItem *o = new QTreeWidgetItem();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QTreeWidgetItem).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QVARIANT_INIT(QObject *parent, const char *objectName) // generated
{
  QVariant *o = new QVariant();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QVariant).name(), o, !parent->isWidgetType()));   
  return q;
}

Q7B Q7B_QWEBPAGE_INIT(QObject *parent, const char *objectName) // generated
{
  QWebPage *o = new QWebPage();
  //  o->setProperty("Parent", (qint64) parent);
  //  o->setObjectName(objectName);
  Q7B q (new Q7B_id(typeid(QWebPage).name(), o, !parent->isWidgetType()));   
  return q;
}

// End Generator h#6



















void Q7B_QPLAINTEXTEDIT_INSERTPLAINTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->insertPlainText(Q7B_IDQString(Text));
}


//#ifdef BLAHBLA





void Q7B_QABSTRACTBUTTON_ANIMATECLICK(Q7B self, Q7B MiliSeconds) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(MiliSeconds))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractButton(self)->animateClick(Q7B_IDqint64(MiliSeconds));
}

Q7B Q7B_QABSTRACTBUTTON_AUTOEXCLUSIVE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractButton(self)->autoExclusive() );
}

void Q7B_QABSTRACTBUTTON_AUTOEXCLUSIVE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQAbstractButton(self)->setAutoExclusive(Q7B_IDbool(theProperty));
}

Q7B Q7B_QABSTRACTBUTTON_AUTOREPEAT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractButton(self)->autoRepeat() );
}

void Q7B_QABSTRACTBUTTON_AUTOREPEAT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQAbstractButton(self)->setAutoRepeat(Q7B_IDbool(theProperty));
}

Q7B Q7B_QABSTRACTBUTTON_AUTOREPEATDELAY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractButton(self)->autoRepeatDelay() );
}

void Q7B_QABSTRACTBUTTON_AUTOREPEATDELAY(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQAbstractButton(self)->setAutoRepeatDelay(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QABSTRACTBUTTON_AUTOREPEATINTERVAL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractButton(self)->autoRepeatInterval() );
}

void Q7B_QABSTRACTBUTTON_AUTOREPEATINTERVAL(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQAbstractButton(self)->setAutoRepeatInterval(Q7B_IDqint64(theProperty));
}

void Q7B_QABSTRACTBUTTON_CLICK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return ; }

  Q7B_IDQAbstractButton(self)->click();
}

Q7B Q7B_QABSTRACTBUTTON_DOWN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractButton(self)->isDown() );
}

void Q7B_QABSTRACTBUTTON_DOWN(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQAbstractButton(self)->setDown(Q7B_IDbool(theProperty));
}

Q7B Q7B_QABSTRACTBUTTON_GROUP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractButton(self)->group() );
}

Q7B Q7B_QABSTRACTBUTTON_ICONSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractButton(self)->iconSize() );
}

void Q7B_QABSTRACTBUTTON_ICONSIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  Q7B_IDQAbstractButton(self)->setIconSize(Q7B_IDQSize(theProperty));
}

Q7B Q7B_QABSTRACTBUTTON_SHORTCUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractButton(self)->shortcut() );
}

void Q7B_QABSTRACTBUTTON_SHORTCUT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return ; }

  if (Q7B_nil(Q7B_QKEYSEQUENCE(theProperty))){ Q7B_EXCEPTION("QKeySequence expected"); return; }

  Q7B_IDQAbstractButton(self)->setShortcut(Q7B_IDQKeySequence(theProperty));
}

void Q7B_QABSTRACTBUTTON_TOGGLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(self))){ Q7B_EXCEPTION("QAbstractButton expected"); return ; }

  Q7B_IDQAbstractButton(self)->toggle();
}

Q7B Q7B_QCALENDARWIDGET_DATEEDITACCEPTDELAY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCalendarWidget(self)->dateEditAcceptDelay() );
}

void Q7B_QCALENDARWIDGET_DATEEDITACCEPTDELAY(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQCalendarWidget(self)->setDateEditAcceptDelay(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QCALENDARWIDGET_DATEEDITENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCalendarWidget(self)->isDateEditEnabled() );
}

void Q7B_QCALENDARWIDGET_DATEEDITENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQCalendarWidget(self)->setDateEditEnabled(Q7B_IDbool(theProperty));
}

Q7B Q7B_QCALENDARWIDGET_GRIDVISIBLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCalendarWidget(self)->isGridVisible() );
}

void Q7B_QCALENDARWIDGET_GRIDVISIBLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQCalendarWidget(self)->setGridVisible(Q7B_IDbool(theProperty));
}

Q7B Q7B_QCALENDARWIDGET_MAXIMUMDATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCalendarWidget(self)->maximumDate() );
}

void Q7B_QCALENDARWIDGET_MAXIMUMDATE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  if (Q7B_nil(Q7B_QDATE(theProperty))){ Q7B_EXCEPTION("QDate expected"); return; }

  Q7B_IDQCalendarWidget(self)->setMaximumDate(Q7B_IDQDate(theProperty));
}

Q7B Q7B_QCALENDARWIDGET_MINIMUMDATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCalendarWidget(self)->minimumDate() );
}

void Q7B_QCALENDARWIDGET_MINIMUMDATE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  if (Q7B_nil(Q7B_QDATE(theProperty))){ Q7B_EXCEPTION("QDate expected"); return; }

  Q7B_IDQCalendarWidget(self)->setMinimumDate(Q7B_IDQDate(theProperty));
}

Q7B Q7B_QCALENDARWIDGET_MONTHSHOWN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCalendarWidget(self)->monthShown() );
}

Q7B Q7B_QCALENDARWIDGET_NAVIGATIONBARVISIBLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCalendarWidget(self)->isNavigationBarVisible() );
}

void Q7B_QCALENDARWIDGET_NAVIGATIONBARVISIBLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQCalendarWidget(self)->setNavigationBarVisible(Q7B_IDbool(theProperty));
}

Q7B Q7B_QCALENDARWIDGET_SELECTEDDATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCalendarWidget(self)->selectedDate() );
}

void Q7B_QCALENDARWIDGET_SETCURRENTPAGE(Q7B self, Q7B Year, Q7B Month) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Year))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Month))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQCalendarWidget(self)->setCurrentPage(Q7B_IDqint64(Year), Q7B_IDqint64(Month));
}

void Q7B_QCALENDARWIDGET_SETDATERANGE(Q7B self, Q7B Minimum, Q7B Maximum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  if (Q7B_nil(Q7B_QDATE(Minimum))){ Q7B_EXCEPTION("QDate expected"); return ; }

  if (Q7B_nil(Q7B_QDATE(Maximum))){ Q7B_EXCEPTION("QDate expected"); return ; }

  Q7B_IDQCalendarWidget(self)->setDateRange(Q7B_IDQDate(Minimum), Q7B_IDQDate(Maximum));
}

void Q7B_QCALENDARWIDGET_SETSELECTEDDATE(Q7B self, Q7B Date) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  if (Q7B_nil(Q7B_QDATE(Date))){ Q7B_EXCEPTION("QDate expected"); return ; }

  Q7B_IDQCalendarWidget(self)->setSelectedDate(Q7B_IDQDate(Date));
}

void Q7B_QCALENDARWIDGET_SHOWNEXTMONTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  Q7B_IDQCalendarWidget(self)->showNextMonth();
}

void Q7B_QCALENDARWIDGET_SHOWNEXTYEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  Q7B_IDQCalendarWidget(self)->showNextYear();
}

void Q7B_QCALENDARWIDGET_SHOWPREVIOUSMONTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  Q7B_IDQCalendarWidget(self)->showPreviousMonth();
}

void Q7B_QCALENDARWIDGET_SHOWPREVIOUSYEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  Q7B_IDQCalendarWidget(self)->showPreviousYear();
}

void Q7B_QCALENDARWIDGET_SHOWSELECTEDDATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  Q7B_IDQCalendarWidget(self)->showSelectedDate();
}

void Q7B_QCALENDARWIDGET_SHOWTODAY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  Q7B_IDQCalendarWidget(self)->showToday();
}

Q7B Q7B_QCALENDARWIDGET_YEARSHOWN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCALENDARWIDGET(self))){ Q7B_EXCEPTION("QCalendarWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCalendarWidget(self)->yearShown() );
}

Q7B Q7B_QCHAR_HASMIRRORED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).hasMirrored() );
}

Q7B Q7B_QCHAR_ISDIGIT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isDigit() );
}

Q7B Q7B_QCHAR_ISHIGHSURROGATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isHighSurrogate() );
}

Q7B Q7B_QCHAR_ISLETTER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isLetter() );
}

Q7B Q7B_QCHAR_ISLETTERORNUMBER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isLetterOrNumber() );
}

Q7B Q7B_QCHAR_ISLOWSURROGATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isLowSurrogate() );
}

Q7B Q7B_QCHAR_ISLOWER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isLower() );
}

Q7B Q7B_QCHAR_ISMARK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isMark() );
}

Q7B Q7B_QCHAR_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isNull() );
}

Q7B Q7B_QCHAR_ISNUMBER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isNumber() );
}

Q7B Q7B_QCHAR_ISPRINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isPrint() );
}

Q7B Q7B_QCHAR_ISPUNCT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isPunct() );
}

Q7B Q7B_QCHAR_ISSPACE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isSpace() );
}

Q7B Q7B_QCHAR_ISSYMBOL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isSymbol() );
}

Q7B Q7B_QCHAR_ISTITLECASE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isTitleCase() );
}

Q7B Q7B_QCHAR_ISUPPER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).isUpper() );
}

Q7B Q7B_QCHAR_MIRROREDCHAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).mirroredChar() );
}

Q7B Q7B_QCHAR_TOCASEFOLDED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).toCaseFolded() );
}

Q7B Q7B_QCHAR_TOLOWER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).toLower() );
}

Q7B Q7B_QCHAR_TOTITLECASE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).toTitleCase() );
}

Q7B Q7B_QCHAR_TOUPPER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHAR(self))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChar(self).toUpper() );
}

Q7B Q7B_QCHECKBOX_CHECKSTATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHECKBOX(self))){ Q7B_EXCEPTION("QCheckBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCheckBox(self)->checkState() );
}

void Q7B_QCHECKBOX_SETCHECKSTATE(Q7B self, Q7B State) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCHECKBOX(self))){ Q7B_EXCEPTION("QCheckBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(State))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQCheckBox(self)->setCheckState((Qt::CheckState) Q7B_IDqint64(State));
}

Q7B Q7B_QCHECKBOX_TRISTATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHECKBOX(self))){ Q7B_EXCEPTION("QCheckBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCheckBox(self)->isTristate() );
}

void Q7B_QCHECKBOX_TRISTATE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCHECKBOX(self))){ Q7B_EXCEPTION("QCheckBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQCheckBox(self)->setTristate(Q7B_IDbool(theProperty));
}

Q7B Q7B_QDATE_ADDDAYS(Q7B self, Q7B NumberDays) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(NumberDays))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).addDays(Q7B_IDqint64(NumberDays)) );
}

Q7B Q7B_QDATE_ADDMONTHS(Q7B self, Q7B NumberMonths) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(NumberMonths))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).addMonths(Q7B_IDqint64(NumberMonths)) );
}

Q7B Q7B_QDATE_ADDYEARS(Q7B self, Q7B NumberYears) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(NumberYears))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).addYears(Q7B_IDqint64(NumberYears)) );
}

Q7B Q7B_QDATE_DAY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).day() );
}

Q7B Q7B_QDATE_DAYOFWEEK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).dayOfWeek() );
}

Q7B Q7B_QDATE_DAYOFYEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).dayOfYear() );
}

Q7B Q7B_QDATE_DAYSINMONTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).daysInMonth() );
}

Q7B Q7B_QDATE_DAYSINYEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).daysInYear() );
}

Q7B Q7B_QDATE_DAYSTO(Q7B self, Q7B Date) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDATE(Date))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).daysTo(Q7B_IDQDate(Date)) );
}

Q7B Q7B_QDATE_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).isNull() );
}

Q7B Q7B_QDATE_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).isValid() );
}

Q7B Q7B_QDATE_MONTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).month() );
}

Q7B Q7B_QDATE_SETDATE(Q7B self, Q7B Year, Q7B Month, Q7B Day) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Year))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Month))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Day))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).setDate(Q7B_IDqint64(Year), Q7B_IDqint64(Month), Q7B_IDqint64(Day)) );
}

Q7B Q7B_QDATE_TOJULIANDAY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).toJulianDay() );
}

Q7B Q7B_QDATE_TOSTRING(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).toString(Q7B_IDQString(Format)) );
}

Q7B Q7B_QDATE_YEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATE(self))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDate(self).year() );
}

Q7B Q7B_QDATETIME_ADDDAYS(Q7B self, Q7B NumberDays) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(NumberDays))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).addDays(Q7B_IDqint64(NumberDays)) );
}

Q7B Q7B_QDATETIME_ADDMSECS(Q7B self, Q7B Milliseconds) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Milliseconds))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).addMSecs(Q7B_IDqint64(Milliseconds)) );
}

Q7B Q7B_QDATETIME_ADDMONTHS(Q7B self, Q7B NumberMonths) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(NumberMonths))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).addMonths(Q7B_IDqint64(NumberMonths)) );
}

Q7B Q7B_QDATETIME_ADDSECS(Q7B self, Q7B NumberSeconds) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(NumberSeconds))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).addSecs(Q7B_IDqint64(NumberSeconds)) );
}

Q7B Q7B_QDATETIME_ADDYEARS(Q7B self, Q7B NumberYears) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(NumberYears))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).addYears(Q7B_IDqint64(NumberYears)) );
}

Q7B Q7B_QDATETIME_DATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).date() );
}

Q7B Q7B_QDATETIME_DAYSTO(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDATETIME(Other))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).daysTo(Q7B_IDQDateTime(Other)) );
}

Q7B Q7B_QDATETIME_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).isNull() );
}

Q7B Q7B_QDATETIME_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).isValid() );
}

Q7B Q7B_QDATETIME_MSECSTO(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDATETIME(Other))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).msecsTo(Q7B_IDQDateTime(Other)) );
}

Q7B Q7B_QDATETIME_SECSTO(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDATETIME(Other))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).secsTo(Q7B_IDQDateTime(Other)) );
}

void Q7B_QDATETIME_SETDATE(Q7B self, Q7B Date) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return ; }

  if (Q7B_nil(Q7B_QDATE(Date))){ Q7B_EXCEPTION("QDate expected"); return ; }

  Q7B_IDQDateTime(self).setDate(Q7B_IDQDate(Date));
}

void Q7B_QDATETIME_SETMSECSSINCEEPOCH(Q7B self, Q7B Milliseconds) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Milliseconds))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQDateTime(self).setMSecsSinceEpoch(Q7B_IDqint64(Milliseconds));
}

void Q7B_QDATETIME_SETTIME(Q7B self, Q7B Time) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return ; }

  if (Q7B_nil(Q7B_QTIME(Time))){ Q7B_EXCEPTION("QTime expected"); return ; }

  Q7B_IDQDateTime(self).setTime(Q7B_IDQTime(Time));
}

Q7B Q7B_QDATETIME_TIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).time() );
}

Q7B Q7B_QDATETIME_TOLOCALTIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).toLocalTime() );
}

Q7B Q7B_QDATETIME_TOMSECSSINCEEPOCH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).toMSecsSinceEpoch() );
}

Q7B Q7B_QDATETIME_TOSTRING(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIME(self))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTime(self).toString(Q7B_IDQString(Format)) );
}

Q7B Q7B_QDIAL_NOTCHSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIAL(self))){ Q7B_EXCEPTION("QDial expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDial(self)->notchSize() );
}

void Q7B_QDIAL_NOTCHSIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIAL(self))){ Q7B_EXCEPTION("QDial expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQDial(self)->setProperty("notchSize", Q7B_IDqint64(theProperty));
}

Q7B Q7B_QDIAL_NOTCHTARGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIAL(self))){ Q7B_EXCEPTION("QDial expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDial(self)->notchTarget() );
}

void Q7B_QDIAL_NOTCHTARGET(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIAL(self))){ Q7B_EXCEPTION("QDial expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(theProperty))){ Q7B_EXCEPTION("qreal expected"); return; }

  Q7B_IDQDial(self)->setNotchTarget(Q7B_IDqreal(theProperty));
}

Q7B Q7B_QDIAL_NOTCHESVISIBLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIAL(self))){ Q7B_EXCEPTION("QDial expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDial(self)->notchesVisible() );
}

void Q7B_QDIAL_NOTCHESVISIBLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIAL(self))){ Q7B_EXCEPTION("QDial expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQDial(self)->setNotchesVisible(Q7B_IDbool(theProperty));
}

void Q7B_QDIAL_SETNOTCHESVISIBLE(Q7B self, Q7B Visible) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIAL(self))){ Q7B_EXCEPTION("QDial expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Visible))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQDial(self)->setNotchesVisible(Q7B_IDbool(Visible));
}

void Q7B_QDIAL_SETWRAPPING(Q7B self, Q7B On) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIAL(self))){ Q7B_EXCEPTION("QDial expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(On))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQDial(self)->setWrapping(Q7B_IDbool(On));
}

Q7B Q7B_QDIAL_WRAPPING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIAL(self))){ Q7B_EXCEPTION("QDial expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDial(self)->wrapping() );
}

void Q7B_QDIAL_WRAPPING(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIAL(self))){ Q7B_EXCEPTION("QDial expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQDial(self)->setWrapping(Q7B_IDbool(theProperty));
}

Q7B Q7B_QDOCKWIDGET_ALLOWEDAREAS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDockWidget(self)->allowedAreas() );
}

void Q7B_QDOCKWIDGET_ALLOWEDAREAS(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQDockWidget(self)->setAllowedAreas((Qt::DockWidgetAreas) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QDOCKWIDGET_FEATURES(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDockWidget(self)->features() );
}

void Q7B_QDOCKWIDGET_FEATURES(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQDockWidget(self)->setFeatures((QDockWidget::DockWidgetFeatures) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QDOCKWIDGET_FLOATING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDockWidget(self)->isFloating() );
}

void Q7B_QDOCKWIDGET_FLOATING(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQDockWidget(self)->setFloating(Q7B_IDbool(theProperty));
}

Q7B Q7B_QDOCKWIDGET_ISAREAALLOWED(Q7B self, Q7B Area) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Area))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDockWidget(self)->isAreaAllowed((Qt::DockWidgetArea) Q7B_IDqint64(Area)) );
}

void Q7B_QDOCKWIDGET_SETFEATURES(Q7B self, Q7B Features) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Features))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQDockWidget(self)->setFeatures((QDockWidget::DockWidgetFeatures) Q7B_IDqint64(Features));
}

void Q7B_QDOCKWIDGET_SETTITLEBARWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQDockWidget(self)->setTitleBarWidget(Q7B_IDQWidget(Widget));
}

void Q7B_QDOCKWIDGET_SETWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQDockWidget(self)->setWidget(Q7B_IDQWidget(Widget));
}

Q7B Q7B_QDOCKWIDGET_TITLEBARWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDockWidget(self)->titleBarWidget() );
}

Q7B Q7B_QDOCKWIDGET_TOGGLEVIEWACTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDockWidget(self)->toggleViewAction() );
}

Q7B Q7B_QDOCKWIDGET_WINDOWTITLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDockWidget(self)->windowTitle() );
}

void Q7B_QDOCKWIDGET_WINDOWTITLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDOCKWIDGET(self))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQDockWidget(self)->setWindowTitle(Q7B_IDQString(theProperty));
}

Q7B Q7B_QELAPSEDTIMER_ELAPSED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QELAPSEDTIMER(self))){ Q7B_EXCEPTION("QElapsedTimer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQElapsedTimer(self).elapsed() );
}

Q7B Q7B_QELAPSEDTIMER_HASEXPIRED(Q7B self, Q7B Timeout) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QELAPSEDTIMER(self))){ Q7B_EXCEPTION("QElapsedTimer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Timeout))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQElapsedTimer(self).hasExpired(Q7B_IDqint64(Timeout)) );
}

void Q7B_QELAPSEDTIMER_INVALIDATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QELAPSEDTIMER(self))){ Q7B_EXCEPTION("QElapsedTimer expected"); return ; }

  Q7B_IDQElapsedTimer(self).invalidate();
}

Q7B Q7B_QELAPSEDTIMER_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QELAPSEDTIMER(self))){ Q7B_EXCEPTION("QElapsedTimer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQElapsedTimer(self).isValid() );
}

Q7B Q7B_QELAPSEDTIMER_MSECSSINCEREFERENCE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QELAPSEDTIMER(self))){ Q7B_EXCEPTION("QElapsedTimer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQElapsedTimer(self).msecsSinceReference() );
}

Q7B Q7B_QELAPSEDTIMER_MSECSTO(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QELAPSEDTIMER(self))){ Q7B_EXCEPTION("QElapsedTimer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QELAPSEDTIMER(Other))){ Q7B_EXCEPTION("QElapsedTimer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQElapsedTimer(self).msecsTo(Q7B_IDQElapsedTimer(Other)) );
}

Q7B Q7B_QELAPSEDTIMER_RESTART(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QELAPSEDTIMER(self))){ Q7B_EXCEPTION("QElapsedTimer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQElapsedTimer(self).restart() );
}

Q7B Q7B_QELAPSEDTIMER_SECSTO(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QELAPSEDTIMER(self))){ Q7B_EXCEPTION("QElapsedTimer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QELAPSEDTIMER(Other))){ Q7B_EXCEPTION("QElapsedTimer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQElapsedTimer(self).secsTo(Q7B_IDQElapsedTimer(Other)) );
}

void Q7B_QELAPSEDTIMER_START(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QELAPSEDTIMER(self))){ Q7B_EXCEPTION("QElapsedTimer expected"); return ; }

  Q7B_IDQElapsedTimer(self).start();
}

Q7B Q7B_QFILEINFO_ABSOLUTEDIR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).absoluteDir() );
}

Q7B Q7B_QFILEINFO_ABSOLUTEFILEPATH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).absoluteFilePath() );
}

Q7B Q7B_QFILEINFO_ABSOLUTEPATH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).absolutePath() );
}

Q7B Q7B_QFILEINFO_BASENAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).baseName() );
}

Q7B Q7B_QFILEINFO_BUNDLENAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).bundleName() );
}

Q7B Q7B_QFILEINFO_CACHING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).caching() );
}

Q7B Q7B_QFILEINFO_CANONICALFILEPATH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).canonicalFilePath() );
}

Q7B Q7B_QFILEINFO_CANONICALPATH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).canonicalPath() );
}

Q7B Q7B_QFILEINFO_COMPLETEBASENAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).completeBaseName() );
}

Q7B Q7B_QFILEINFO_COMPLETESUFFIX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).completeSuffix() );
}

Q7B Q7B_QFILEINFO_CREATED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).created() );
}

Q7B Q7B_QFILEINFO_DIR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).dir() );
}

Q7B Q7B_QFILEINFO_EXISTS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).exists() );
}

Q7B Q7B_QFILEINFO_FILENAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).fileName() );
}

Q7B Q7B_QFILEINFO_FILEPATH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).filePath() );
}

Q7B Q7B_QFILEINFO_GROUP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).group() );
}

Q7B Q7B_QFILEINFO_GROUPID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).groupId() );
}

Q7B Q7B_QFILEINFO_ISABSOLUTE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).isAbsolute() );
}

Q7B Q7B_QFILEINFO_ISBUNDLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).isBundle() );
}

Q7B Q7B_QFILEINFO_ISDIR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).isDir() );
}

Q7B Q7B_QFILEINFO_ISEXECUTABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).isExecutable() );
}

Q7B Q7B_QFILEINFO_ISFILE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).isFile() );
}

Q7B Q7B_QFILEINFO_ISHIDDEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).isHidden() );
}

Q7B Q7B_QFILEINFO_ISREADABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).isReadable() );
}

Q7B Q7B_QFILEINFO_ISRELATIVE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).isRelative() );
}

Q7B Q7B_QFILEINFO_ISROOT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).isRoot() );
}

Q7B Q7B_QFILEINFO_ISSYMLINK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).isSymLink() );
}

Q7B Q7B_QFILEINFO_ISWRITABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).isWritable() );
}

Q7B Q7B_QFILEINFO_LASTMODIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).lastModified() );
}

Q7B Q7B_QFILEINFO_LASTREAD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).lastRead() );
}

Q7B Q7B_QFILEINFO_MAKEABSOLUTE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).makeAbsolute() );
}

Q7B Q7B_QFILEINFO_OWNER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).owner() );
}

Q7B Q7B_QFILEINFO_OWNERID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).ownerId() );
}

Q7B Q7B_QFILEINFO_PATH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).path() );
}

Q7B Q7B_QFILEINFO_PERMISSION(Q7B self, Q7B Permissions) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Permissions))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).permission((QFile::Permissions) Q7B_IDqint64(Permissions)) );
}

Q7B Q7B_QFILEINFO_PERMISSIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).permissions() );
}

void Q7B_QFILEINFO_REFRESH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return ; }

  Q7B_IDQFileInfo(self).refresh();
}

void Q7B_QFILEINFO_SETCACHING(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQFileInfo(self).setCaching(Q7B_IDbool(Enable));
}

void Q7B_QFILEINFO_SETFILE(Q7B self, Q7B File) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(File))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQFileInfo(self).setFile(Q7B_IDQString(File));
}

Q7B Q7B_QFILEINFO_SIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).size() );
}

Q7B Q7B_QFILEINFO_SUFFIX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).suffix() );
}

Q7B Q7B_QFILEINFO_SYMLINKTARGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEINFO(self))){ Q7B_EXCEPTION("QFileInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileInfo(self).symLinkTarget() );
}

void Q7B_QFILESYSTEMWATCHER_ADDPATH(Q7B self, Q7B Path) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFILESYSTEMWATCHER(self))){ Q7B_EXCEPTION("QFileSystemWatcher expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQFileSystemWatcher(self)->addPath(Q7B_IDQString(Path));
}

void Q7B_QFILESYSTEMWATCHER_ADDPATHS(Q7B self, Q7B Paths) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFILESYSTEMWATCHER(self))){ Q7B_EXCEPTION("QFileSystemWatcher expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Paths))){ Q7B_EXCEPTION("QStringList expected"); return ; }

    Q7B_IDQFileSystemWatcher(self)->addPaths(Q7B_IDQStringList(Paths));
}

Q7B Q7B_QFILESYSTEMWATCHER_DIRECTORIES(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILESYSTEMWATCHER(self))){ Q7B_EXCEPTION("QFileSystemWatcher expected"); return Q7B_idnil; }

  Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(Q7B_IDQFileSystemWatcher(self)->directories()))); 
  return q;
//  return Q7B_ID( Q7B_IDQFileSystemWatcher(self)->directories() );
}

Q7B Q7B_QFILESYSTEMWATCHER_FILES(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILESYSTEMWATCHER(self))){ Q7B_EXCEPTION("QFileSystemWatcher expected"); return Q7B_idnil; }

  Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(Q7B_IDQFileSystemWatcher(self)->files()))); 
  return q;
//  return Q7B_ID( Q7B_IDQFileSystemWatcher(self)->files() );
}

void Q7B_QFILESYSTEMWATCHER_REMOVEPATH(Q7B self, Q7B Path) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFILESYSTEMWATCHER(self))){ Q7B_EXCEPTION("QFileSystemWatcher expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQFileSystemWatcher(self)->removePath(Q7B_IDQString(Path));
}

void Q7B_QFILESYSTEMWATCHER_REMOVEPATHS(Q7B self, Q7B Paths) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFILESYSTEMWATCHER(self))){ Q7B_EXCEPTION("QFileSystemWatcher expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Paths))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQFileSystemWatcher(self)->removePaths(Q7B_IDQStringList(Paths));
}

Q7B Q7B_QFRAME_FRAMERECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFrame(self)->frameRect() );
}

void Q7B_QFRAME_FRAMERECT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(theProperty))){ Q7B_EXCEPTION("QRect expected"); return; }

  Q7B_IDQFrame(self)->setFrameRect(Q7B_IDQRect(theProperty));
}

Q7B Q7B_QFRAME_FRAMESHADOW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFrame(self)->frameShadow() );
}

void Q7B_QFRAME_FRAMESHADOW(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQFrame(self)->setFrameShadow((QFrame::Shadow) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QFRAME_FRAMESHAPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFrame(self)->frameShape() );
}

void Q7B_QFRAME_FRAMESHAPE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQFrame(self)->setFrameShape((QFrame::Shape) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QFRAME_FRAMESTYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFrame(self)->frameStyle() );
}

Q7B Q7B_QFRAME_FRAMEWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFrame(self)->frameWidth() );
}

void Q7B_QFRAME_FRAMEWIDTH(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQFrame(self)->setProperty("frameWidth", Q7B_IDqint64(theProperty));
}

Q7B Q7B_QFRAME_LINEWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFrame(self)->lineWidth() );
}

void Q7B_QFRAME_LINEWIDTH(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQFrame(self)->setLineWidth(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QFRAME_MIDLINEWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFrame(self)->midLineWidth() );
}

void Q7B_QFRAME_MIDLINEWIDTH(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQFrame(self)->setMidLineWidth(Q7B_IDqint64(theProperty));
}

void Q7B_QFRAME_SETFRAMESTYLE(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFRAME(self))){ Q7B_EXCEPTION("QFrame expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQFrame(self)->setFrameStyle(Q7B_IDqint64(Style));
}

Q7B Q7B_QGROUPBOX_ALIGNMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QGROUPBOX(self))){ Q7B_EXCEPTION("QGroupBox expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) Q7B_IDQGroupBox(self)->alignment() );
}

void Q7B_QGROUPBOX_ALIGNMENT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QGROUPBOX(self))){ Q7B_EXCEPTION("QGroupBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQGroupBox(self)->setAlignment((Qt::Alignment) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QGROUPBOX_CHECKABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QGROUPBOX(self))){ Q7B_EXCEPTION("QGroupBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQGroupBox(self)->isCheckable() );
}

void Q7B_QGROUPBOX_CHECKABLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QGROUPBOX(self))){ Q7B_EXCEPTION("QGroupBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQGroupBox(self)->setCheckable(Q7B_IDbool(theProperty));
}

Q7B Q7B_QGROUPBOX_CHECKED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QGROUPBOX(self))){ Q7B_EXCEPTION("QGroupBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQGroupBox(self)->isChecked() );
}

void Q7B_QGROUPBOX_CHECKED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QGROUPBOX(self))){ Q7B_EXCEPTION("QGroupBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQGroupBox(self)->setChecked(Q7B_IDbool(theProperty));
}

Q7B Q7B_QGROUPBOX_FLAT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QGROUPBOX(self))){ Q7B_EXCEPTION("QGroupBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQGroupBox(self)->isFlat() );
}

void Q7B_QGROUPBOX_FLAT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QGROUPBOX(self))){ Q7B_EXCEPTION("QGroupBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQGroupBox(self)->setFlat(Q7B_IDbool(theProperty));
}

void Q7B_QGROUPBOX_SETCHECKED(Q7B self, Q7B Checked) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QGROUPBOX(self))){ Q7B_EXCEPTION("QGroupBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Checked))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQGroupBox(self)->setChecked(Q7B_IDbool(Checked));
}

Q7B Q7B_QGROUPBOX_TITLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QGROUPBOX(self))){ Q7B_EXCEPTION("QGroupBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQGroupBox(self)->title() );
}

void Q7B_QGROUPBOX_TITLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QGROUPBOX(self))){ Q7B_EXCEPTION("QGroupBox expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQGroupBox(self)->setTitle(Q7B_IDQString(theProperty));
}

Q7B Q7B_QHOSTINFO_ADDRESSES(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHOSTINFO(self))){ Q7B_EXCEPTION("QHostInfo expected"); return Q7B_idnil; }

  QList<QHostAddress> o = Q7B_IDQHostInfo(self).addresses();

  Q7B_List *l = new Q7B_List(); 
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), l)); 
/*
  for (int i = 0; i < o.size(); i++){
    l->append(o.at(i));
  }
*/
  return q;
}

Q7B Q7B_QHOSTINFO_ERROR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHOSTINFO(self))){ Q7B_EXCEPTION("QHostInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHostInfo(self).error() );
}

Q7B Q7B_QHOSTINFO_ERRORSTRING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHOSTINFO(self))){ Q7B_EXCEPTION("QHostInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHostInfo(self).errorString() );
}

Q7B Q7B_QHOSTINFO_HOSTNAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHOSTINFO(self))){ Q7B_EXCEPTION("QHostInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHostInfo(self).hostName() );
}

Q7B Q7B_QHOSTINFO_LOOKUPID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHOSTINFO(self))){ Q7B_EXCEPTION("QHostInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHostInfo(self).lookupId() );
}

void Q7B_QHOSTINFO_SETADDRESSES(Q7B self, Q7B Addresses) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHOSTINFO(self))){ Q7B_EXCEPTION("QHostInfo expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Addresses))){ Q7B_EXCEPTION("QStringList expected"); return ; }

 // Q7B_IDQHostInfo(self).setAddresses(Q7B_IDQStringList(Addresses));
}

void Q7B_QHOSTINFO_SETERROR(Q7B self, Q7B Error) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHOSTINFO(self))){ Q7B_EXCEPTION("QHostInfo expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Error))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHostInfo(self).setError((QHostInfo::HostInfoError) Q7B_IDqint64(Error));
}

void Q7B_QHOSTINFO_SETERRORSTRING(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHOSTINFO(self))){ Q7B_EXCEPTION("QHostInfo expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQHostInfo(self).setErrorString(Q7B_IDQString(Str));
}

void Q7B_QHOSTINFO_SETHOSTNAME(Q7B self, Q7B HostName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHOSTINFO(self))){ Q7B_EXCEPTION("QHostInfo expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(HostName))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQHostInfo(self).setHostName(Q7B_IDQString(HostName));
}

void Q7B_QHOSTINFO_SETLOOKUPID(Q7B self, Q7B Id) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHOSTINFO(self))){ Q7B_EXCEPTION("QHostInfo expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Id))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHostInfo(self).setLookupId(Q7B_IDqint64(Id));
}

Q7B Q7B_QIMAGE_ALLGRAY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).allGray() );
}

Q7B Q7B_QIMAGE_BITPLANECOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).bitPlaneCount() );
}

Q7B Q7B_QIMAGE_BYTECOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).byteCount() );
}

Q7B Q7B_QIMAGE_BYTESPERLINE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).bytesPerLine() );
}

Q7B Q7B_QIMAGE_CACHEKEY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).cacheKey() );
}

Q7B Q7B_QIMAGE_COLOR(Q7B self, Q7B I) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(I))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).color(Q7B_IDqint64(I)) );
}

Q7B Q7B_QIMAGE_COLORCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).colorCount() );
}

Q7B Q7B_QIMAGE_CONVERTTOFORMAT(Q7B self, Q7B Format, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Format))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).convertToFormat((QImage::Format) Q7B_IDqint64(Format), (Qt::ImageConversionFlags) Q7B_IDqint64(Flags)) );
}

Q7B Q7B_QIMAGE_COPY(Q7B self, Q7B X, Q7B Y, Q7B Width, Q7B Height) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Height))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).copy(Q7B_IDqint64(X), Q7B_IDqint64(Y), Q7B_IDqint64(Width), Q7B_IDqint64(Height)) );
}

Q7B Q7B_QIMAGE_CREATEALPHAMASK(Q7B self, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).createAlphaMask((Qt::ImageConversionFlags) Q7B_IDqint64(Flags)) );
}

Q7B Q7B_QIMAGE_CREATEHEURISTICMASK(Q7B self, Q7B ClipTight) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(ClipTight))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).createHeuristicMask(Q7B_IDbool(ClipTight)) );
}

Q7B Q7B_QIMAGE_CREATEMASKFROMCOLOR(Q7B self, Q7B Color, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QRGB(Color))){ Q7B_EXCEPTION("QRgb expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).createMaskFromColor((QRgb) Q7B_IDQRgb(Color), (Qt::MaskMode) Q7B_IDqint64(Mode)) );
}

Q7B Q7B_QIMAGE_DEPTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).depth() );
}

Q7B Q7B_QIMAGE_DOTSPERMETERX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).dotsPerMeterX() );
}

Q7B Q7B_QIMAGE_DOTSPERMETERY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).dotsPerMeterY() );
}

void Q7B_QIMAGE_FILL(Q7B self, Q7B PixelValue) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(PixelValue))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQImage(self).fill(Q7B_IDqint64(PixelValue));
}

Q7B Q7B_QIMAGE_FORMAT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).format() );
}

Q7B Q7B_QIMAGE_HASALPHACHANNEL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).hasAlphaChannel() );
}

Q7B Q7B_QIMAGE_HEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).height() );
}

void Q7B_QIMAGE_INVERTPIXELS(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQImage(self).invertPixels((QImage::InvertMode) Q7B_IDqint64(Mode));
}

Q7B Q7B_QIMAGE_ISGRAYSCALE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).isGrayscale() );
}

Q7B Q7B_QIMAGE_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).isNull() );
}

Q7B Q7B_QIMAGE_LOAD(Q7B self, Q7B FileName, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  const QString & fileName = Q7B_IDQString(FileName);
  QString format = Q7B_IDQString(Format);

  return Q7B_ID( Q7B_IDQImage(self).load(fileName, format.toLocal8Bit()) );
}

Q7B Q7B_QIMAGE_LOADFROMDATA(Q7B self, Q7B Data, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Data))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString format = Q7B_IDQString(Format);

  return Q7B_ID( Q7B_IDQImage(self).loadFromData(Q7B_IDQByteArray(Data), format.toLocal8Bit()) );
}




















Q7B Q7B_QIMAGE_MIRRORED(Q7B self, Q7B Horizontal, Q7B Vertical) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Horizontal))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Vertical))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).mirrored(Q7B_IDbool(Horizontal), Q7B_IDbool(Vertical)) );
}

Q7B Q7B_QIMAGE_OFFSET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).offset() );
}

Q7B Q7B_QIMAGE_PIXEL(Q7B self, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).pixel(Q7B_IDqint64(X), Q7B_IDqint64(Y)) );
}


Q7B Q7B_QIMAGE_PIXELINDEX(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).pixelIndex(Q7B_IDQPoint(Position)) );
}

Q7B Q7B_QIMAGE_RECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).rect() );
}

Q7B Q7B_QIMAGE_RGBSWAPPED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).rgbSwapped() );
}

Q7B Q7B_QIMAGE_SAVE(Q7B self, Q7B FileName, Q7B Format, Q7B Quality) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Quality))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).save(Q7B_IDQString(FileName), (Q7B_IDQString(Format)).toLocal8Bit(), Q7B_IDqint64(Quality)) );
}

Q7B Q7B_QIMAGE_SCALED(Q7B self, Q7B Width, Q7B Heigth, Q7B AspectRatioMode, Q7B TransformMode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Heigth))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(AspectRatioMode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(TransformMode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).scaled(Q7B_IDqint64(Width), Q7B_IDqint64(Heigth), (Qt::AspectRatioMode) Q7B_IDqint64(AspectRatioMode), (Qt::TransformationMode) Q7B_IDqint64(TransformMode)) );
}

Q7B Q7B_QIMAGE_SCALEDTOHEIGHT(Q7B self, Q7B Height, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Height))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).scaledToHeight(Q7B_IDqint64(Height), (Qt::TransformationMode) Q7B_IDqint64(Mode)) );
}

Q7B Q7B_QIMAGE_SCALEDTOWIDTH(Q7B self, Q7B Width, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).scaledToWidth(Q7B_IDqint64(Width), (Qt::TransformationMode) Q7B_IDqint64(Mode)) );
}

void Q7B_QIMAGE_SETCOLOR(Q7B self, Q7B Index, Q7B ColorValue) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QRGB(ColorValue))){ Q7B_EXCEPTION("QRgb expected"); return ; }

  Q7B_IDQImage(self).setColor(Q7B_IDqint64(Index), Q7B_IDQRgb(ColorValue));
}

void Q7B_QIMAGE_SETCOLORCOUNT(Q7B self, Q7B ColorCount) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(ColorCount))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQImage(self).setColorCount(Q7B_IDqint64(ColorCount));
}

void Q7B_QIMAGE_SETDOTSPERMETERX(Q7B self, Q7B X) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQImage(self).setDotsPerMeterX(Q7B_IDqint64(X));
}

void Q7B_QIMAGE_SETDOTSPERMETERY(Q7B self, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQImage(self).setDotsPerMeterY(Q7B_IDqint64(Y));
}

void Q7B_QIMAGE_SETOFFSET(Q7B self, Q7B Offset) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Offset))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQImage(self).setOffset(Q7B_IDQPoint(Offset));
}

void Q7B_QIMAGE_SETPIXEL(Q7B self, Q7B X, Q7B Y, Q7B IndexOrRgb) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(IndexOrRgb))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQImage(self).setPixel(Q7B_IDqint64(X), Q7B_IDqint64(Y), Q7B_IDqint64(IndexOrRgb));
}

void Q7B_QIMAGE_SETTEXT(Q7B self, Q7B Key, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Key))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQImage(self).setText(Q7B_IDQString(Key), Q7B_IDQString(Text));
}

Q7B Q7B_QIMAGE_SIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).size() );
}

Q7B Q7B_QIMAGE_TEXT(Q7B self, Q7B Key) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Key))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).text(Q7B_IDQString(Key)) );
}

Q7B Q7B_QIMAGE_TEXTKEYS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(Q7B_IDQImage(self).textKeys()))); 
  return q;

  //return Q7B_ID( Q7B_IDQImage(self).textKeys() );
}

Q7B Q7B_QIMAGE_TRANSFORMED(Q7B self, Q7B Matrix, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTRANSFORM(Matrix))){ Q7B_EXCEPTION("QTransform expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).transformed(Q7B_IDQTransform(Matrix), (Qt::TransformationMode) Q7B_IDqint64(Mode)) );
}

Q7B Q7B_QIMAGE_VALID(Q7B self, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).valid(Q7B_IDqint64(X), Q7B_IDqint64(Y)) );
}

Q7B Q7B_QIMAGE_WIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).width() );
}

















Q7B Q7B_QLCDNUMBER_CHECKOVERFLOW(Q7B self, Q7B Number) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREAL(Number))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLCDNumber(self)->checkOverflow((qreal) Q7B_IDqreal(Number)) );
}

Q7B Q7B_QLCDNUMBER_CHECKOVERFLOW2(Q7B self, Q7B Number) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Number))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLCDNumber(self)->checkOverflow((int) Q7B_IDqint64(Number)) );
}

Q7B Q7B_QLCDNUMBER_DIGITCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLCDNumber(self)->digitCount() );
}

void Q7B_QLCDNUMBER_DIGITCOUNT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQLCDNumber(self)->setDigitCount(Q7B_IDqint64(theProperty));
}

void Q7B_QLCDNUMBER_DISPLAY(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQLCDNumber(self)->display(Q7B_IDQString(Text));
}

void Q7B_QLCDNUMBER_DISPLAY2(Q7B self, Q7B Number) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Number))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQLCDNumber(self)->display(Q7B_IDqreal(Number));
}

Q7B Q7B_QLCDNUMBER_INTVALUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLCDNumber(self)->intValue() );
}

void Q7B_QLCDNUMBER_INTVALUE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQLCDNumber(self)->setProperty("intValue", Q7B_IDqint64(theProperty));
}

Q7B Q7B_QLCDNUMBER_MODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLCDNumber(self)->mode() );
}

void Q7B_QLCDNUMBER_MODE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQLCDNumber(self)->setMode((QLCDNumber::Mode) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QLCDNUMBER_SEGMENTSTYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLCDNumber(self)->segmentStyle() );
}

void Q7B_QLCDNUMBER_SEGMENTSTYLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQLCDNumber(self)->setSegmentStyle((QLCDNumber::SegmentStyle) Q7B_IDqint64(theProperty));
}

void Q7B_QLCDNUMBER_SETBINMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return ; }

  Q7B_IDQLCDNumber(self)->setBinMode();
}

void Q7B_QLCDNUMBER_SETDECMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return ; }

  Q7B_IDQLCDNumber(self)->setDecMode();
}

void Q7B_QLCDNUMBER_SETHEXMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return ; }

  Q7B_IDQLCDNumber(self)->setHexMode();
}

void Q7B_QLCDNUMBER_SETOCTMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return ; }

  Q7B_IDQLCDNumber(self)->setOctMode();
}

void Q7B_QLCDNUMBER_SETSMALLDECIMALPOINT(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQLCDNumber(self)->setSmallDecimalPoint(Q7B_IDbool(Enable));
}

Q7B Q7B_QLCDNUMBER_SMALLDECIMALPOINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLCDNumber(self)->smallDecimalPoint() );
}

void Q7B_QLCDNUMBER_SMALLDECIMALPOINT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQLCDNumber(self)->setSmallDecimalPoint(Q7B_IDbool(theProperty));
}

Q7B Q7B_QLCDNUMBER_VALUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLCDNumber(self)->value() );
}

void Q7B_QLCDNUMBER_VALUE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLCDNUMBER(self))){ Q7B_EXCEPTION("QLCDNumber expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(theProperty))){ Q7B_EXCEPTION("qreal expected"); return; }
  
  Q7B_IDQLCDNumber(self)->setProperty("value", Q7B_IDqreal(theProperty));
}


















Q7B Q7B_QLABEL_BUDDY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLabel(self)->buddy() );
}

void Q7B_QLABEL_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return ; }

  Q7B_IDQLabel(self)->clear();
}

Q7B Q7B_QLABEL_HASSCALEDCONTENTS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLabel(self)->hasScaledContents() );
}

Q7B Q7B_QLABEL_HASSELECTEDTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLabel(self)->hasSelectedText() );
}

Q7B Q7B_QLABEL_INDENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLabel(self)->indent() );
}

void Q7B_QLABEL_INDENT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQLabel(self)->setIndent(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QLABEL_MARGIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLabel(self)->margin() );
}

void Q7B_QLABEL_MARGIN(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQLabel(self)->setMargin(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QLABEL_MOVIE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLabel(self)->movie() );
}

Q7B Q7B_QLABEL_PICTURE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLabel(self)->picture() );
}

Q7B Q7B_QLABEL_PIXMAP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLabel(self)->pixmap() );
}

Q7B Q7B_QLABEL_SELECTEDTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLabel(self)->selectedText() );
}

void Q7B_QLABEL_SELECTEDTEXT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQLabel(self)->setProperty("selectedText", Q7B_IDQString(theProperty));
}

Q7B Q7B_QLABEL_SELECTIONSTART(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLabel(self)->selectionStart() );
}

void Q7B_QLABEL_SETBUDDY(Q7B self, Q7B Buddy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Buddy))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQLabel(self)->setBuddy(Q7B_IDQWidget(Buddy));
}

void Q7B_QLABEL_SETMOVIE(Q7B self, Q7B Movie) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return ; }

  if (Q7B_nil(Q7B_QMOVIE(Movie))){ Q7B_EXCEPTION("QMovie expected"); return ; }

  Q7B_IDQLabel(self)->setMovie(Q7B_IDQMovie(Movie));
}

void Q7B_QLABEL_SETNUM(Q7B self, Q7B Num) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Num))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQLabel(self)->setNum(Q7B_IDqreal(Num));
}

void Q7B_QLABEL_SETPICTURE(Q7B self, Q7B Picture) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return ; }

  if (Q7B_nil(Q7B_QPICTURE(Picture))){ Q7B_EXCEPTION("QPicture expected"); return ; }

  Q7B_IDQLabel(self)->setPicture(Q7B_IDQPicture(Picture));
}

void Q7B_QLABEL_SETPIXMAP(Q7B self, Q7B Pixmap) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return ; }

  if (Q7B_nil(Q7B_QPIXMAP(Pixmap))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  Q7B_IDQLabel(self)->setPixmap(Q7B_IDQPixmap(Pixmap));
}

void Q7B_QLABEL_SETSELECTION(Q7B self, Q7B Start, Q7B Length) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Start))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Length))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLabel(self)->setSelection(Q7B_IDqint64(Start), Q7B_IDqint64(Length));
}

void Q7B_QLABEL_SETTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQLabel(self)->setText(Q7B_IDQString(Text));
}

Q7B Q7B_QLABEL_TEXTFORMAT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLabel(self)->textFormat() );
}

void Q7B_QLABEL_TEXTFORMAT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLABEL(self))){ Q7B_EXCEPTION("QLabel expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQLabel(self)->setTextFormat((Qt::TextFormat) Q7B_IDqint64(theProperty));
}



void Q7B_QLISTWIDGET_ADDITEM(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QLISTWIDGETITEM(Item))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  Q7B_IDQListWidget(self)->addItem(&Q7B_IDQListWidgetItem(Item));
}

void Q7B_QLISTWIDGET_ADDITEMS(Q7B self, Q7B Labels) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Labels))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQListWidget(self)->addItems(Q7B_IDQStringList(Labels));
}

void Q7B_QLISTWIDGET_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  Q7B_IDQListWidget(self)->clear();
}

void Q7B_QLISTWIDGET_CLOSEPERSISTENTEDITOR(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QLISTWIDGETITEM(Item))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  Q7B_IDQListWidget(self)->closePersistentEditor(&Q7B_IDQListWidgetItem(Item));
}

Q7B Q7B_QLISTWIDGET_COUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidget(self)->count() );
}

void Q7B_QLISTWIDGET_COUNT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQListWidget(self)->setProperty("count", Q7B_IDqint64(theProperty));
}

Q7B Q7B_QLISTWIDGET_CURRENTITEM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidget(self)->currentItem() );
}

Q7B Q7B_QLISTWIDGET_CURRENTROW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidget(self)->currentRow() );
}

void Q7B_QLISTWIDGET_CURRENTROW(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQListWidget(self)->setCurrentRow(Q7B_IDqint64(theProperty));
}

void Q7B_QLISTWIDGET_EDITITEM(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QLISTWIDGETITEM(Item))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  Q7B_IDQListWidget(self)->editItem(&Q7B_IDQListWidgetItem(Item));
}

Q7B Q7B_QLISTWIDGET_FINDITEMS(Q7B self, Q7B Text, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QList<QListWidgetItem*> o = Q7B_IDQListWidget(self)->findItems(Q7B_IDQString(Text), (Qt::MatchFlags) Q7B_IDqint64(Flags));

  Q7B_List *l = new Q7B_List(); 
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), l)); 

  for (int i = 0; i < o.size(); i++){
    Q7B qq (new Q7B_id(typeid(QListWidgetItem).name(), o.at(i), false)); 
    l->append(qq);
  }

  return q;
}

void Q7B_QLISTWIDGET_INSERTITEM(Q7B self, Q7B Row, Q7B theLabel) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theLabel))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQListWidget(self)->insertItem(Q7B_IDqint64(Row), Q7B_IDQString(theLabel));
}

void Q7B_QLISTWIDGET_INSERTITEMS(Q7B self, Q7B Row, Q7B Labels) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Labels))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQListWidget(self)->insertItems(Q7B_IDqint64(Row), Q7B_IDQStringList(Labels));
}

Q7B Q7B_QLISTWIDGET_ITEM(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidget(self)->item(Q7B_IDqint64(Row)) );
}

Q7B Q7B_QLISTWIDGET_ITEMAT(Q7B self, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidget(self)->itemAt(Q7B_IDqint64(X), Q7B_IDqint64(Y)) );
}

Q7B Q7B_QLISTWIDGET_ITEMWIDGET(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGETITEM(Item))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidget(self)->itemWidget(&Q7B_IDQListWidgetItem(Item)) );
}

void Q7B_QLISTWIDGET_OPENPERSISTENTEDITOR(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QLISTWIDGETITEM(Item))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  Q7B_IDQListWidget(self)->openPersistentEditor(&Q7B_IDQListWidgetItem(Item));
}

void Q7B_QLISTWIDGET_REMOVEITEMWIDGET(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QLISTWIDGETITEM(Item))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  Q7B_IDQListWidget(self)->removeItemWidget(&Q7B_IDQListWidgetItem(Item));
}

Q7B Q7B_QLISTWIDGET_ROW(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGETITEM(Item))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidget(self)->row(&Q7B_IDQListWidgetItem(Item)) );
}

void Q7B_QLISTWIDGET_SCROLLTOITEM(Q7B self, Q7B Item, Q7B Hint) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QLISTWIDGETITEM(Item))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Hint))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListWidget(self)->scrollToItem(&Q7B_IDQListWidgetItem(Item), (QAbstractItemView::ScrollHint) Q7B_IDqint64(Hint));
}

Q7B Q7B_QLISTWIDGET_SELECTEDITEMS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }


  QList<QListWidgetItem*> o = Q7B_IDQListWidget(self)->selectedItems();

  Q7B_List *l = new Q7B_List(); 
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), l)); 

  for (int i = 0; i < o.size(); i++){
    Q7B qq (new Q7B_id(typeid(QListWidgetItem).name(), o.at(i), false)); 
    l->append(qq);
  }

  return q;
}


void Q7B_QLISTWIDGET_SETCURRENTITEM(Q7B self, Q7B Item, Q7B Command) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QLISTWIDGETITEM(Item))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Command))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListWidget(self)->setCurrentItem(&Q7B_IDQListWidgetItem(Item), (QItemSelectionModel::SelectionFlags) Q7B_IDqint64(Command));
}

void Q7B_QLISTWIDGET_SETCURRENTROW(Q7B self, Q7B Row, Q7B Command) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Command))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListWidget(self)->setCurrentRow(Q7B_IDqint64(Row), (QItemSelectionModel::SelectionFlags) Q7B_IDqint64(Command));
}

void Q7B_QLISTWIDGET_SETITEMWIDGET(Q7B self, Q7B Item, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QLISTWIDGETITEM(Item))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQListWidget(self)->setItemWidget(&Q7B_IDQListWidgetItem(Item), Q7B_IDQWidget(Widget));
}

void Q7B_QLISTWIDGET_SORTITEMS(Q7B self, Q7B Order) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Order))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListWidget(self)->sortItems((Qt::SortOrder) Q7B_IDqint64(Order));
}

Q7B Q7B_QLISTWIDGET_SORTINGENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidget(self)->isSortingEnabled() );
}

void Q7B_QLISTWIDGET_SORTINGENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQListWidget(self)->setSortingEnabled(Q7B_IDbool(theProperty));
}

Q7B Q7B_QLISTWIDGET_TAKEITEM(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidget(self)->takeItem(Q7B_IDqint64(Row)) );
}

Q7B Q7B_QLISTWIDGET_VISUALITEMRECT(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGETITEM(Item))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidget(self)->visualItemRect(&Q7B_IDQListWidgetItem(Item)) );
}








Q7B Q7B_QLISTWIDGETITEM_BACKGROUND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).background() );
}

Q7B Q7B_QLISTWIDGETITEM_CHECKSTATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).checkState() );
}

Q7B Q7B_QLISTWIDGETITEM_DATA(Q7B self, Q7B Role) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Role))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).data(Q7B_IDqint64(Role)) );
}

Q7B Q7B_QLISTWIDGETITEM_FLAGS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).flags() );
}






Q7B Q7B_QLISTWIDGETITEM_FONT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).font() );
}

Q7B Q7B_QLISTWIDGETITEM_FOREGROUND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).foreground() );
}

Q7B Q7B_QLISTWIDGETITEM_ICON(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).icon() );
}

Q7B Q7B_QLISTWIDGETITEM_ISHIDDEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).isHidden() );
}

Q7B Q7B_QLISTWIDGETITEM_ISSELECTED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).isSelected() );
}

Q7B Q7B_QLISTWIDGETITEM_LISTWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).listWidget() );
}

void Q7B_QLISTWIDGETITEM_SETBACKGROUND(Q7B self, Q7B Brush) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QBRUSH(Brush))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  Q7B_IDQListWidgetItem(self).setBackground(Q7B_IDQBrush(Brush));
}

void Q7B_QLISTWIDGETITEM_SETCHECKSTATE(Q7B self, Q7B State) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(State))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListWidgetItem(self).setCheckState((Qt::CheckState) Q7B_IDqint64(State));
}

void Q7B_QLISTWIDGETITEM_SETDATA(Q7B self, Q7B Role, Q7B Value) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Role))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QVARIANT(Value))){ Q7B_EXCEPTION("QVariant expected"); return ; }

  Q7B_IDQListWidgetItem(self).setData(Q7B_IDqint64(Role), Q7B_IDQVariant(Value));
}

void Q7B_QLISTWIDGETITEM_SETFLAGS(Q7B self, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListWidgetItem(self).setFlags((Qt::ItemFlags) Q7B_IDqint64(Flags));
}

void Q7B_QLISTWIDGETITEM_SETFONT (Q7B self, Q7B Font) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QFONT(Font))){ Q7B_EXCEPTION("QFont expected"); return ; }

  Q7B_IDQListWidgetItem(self).setFont (Q7B_IDQFont(Font));
}

void Q7B_QLISTWIDGETITEM_SETFOREGROUND(Q7B self, Q7B Brush) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QBRUSH(Brush))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  Q7B_IDQListWidgetItem(self).setForeground(Q7B_IDQBrush(Brush));
}

void Q7B_QLISTWIDGETITEM_SETHIDDEN(Q7B self, Q7B Hide) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Hide))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQListWidgetItem(self).setHidden(Q7B_IDbool(Hide));
}

void Q7B_QLISTWIDGETITEM_SETICON(Q7B self, Q7B Icon) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  Q7B_IDQListWidgetItem(self).setIcon(Q7B_IDQIcon(Icon));
}

void Q7B_QLISTWIDGETITEM_SETSELECTED(Q7B self, Q7B Select) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Select))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQListWidgetItem(self).setSelected(Q7B_IDbool(Select));
}

void Q7B_QLISTWIDGETITEM_SETSIZEHINT(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQListWidgetItem(self).setSizeHint(Q7B_IDQSize(Size));
}

void Q7B_QLISTWIDGETITEM_SETSTATUSTIP(Q7B self, Q7B StatusTip) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(StatusTip))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQListWidgetItem(self).setStatusTip(Q7B_IDQString(StatusTip));
}

void Q7B_QLISTWIDGETITEM_SETTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQListWidgetItem(self).setText(Q7B_IDQString(Text));
}

void Q7B_QLISTWIDGETITEM_SETTEXTALIGNMENT(Q7B self, Q7B Alignment) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Alignment))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListWidgetItem(self).setTextAlignment(Q7B_IDqint64(Alignment));
}

void Q7B_QLISTWIDGETITEM_SETTOOLTIP(Q7B self, Q7B Tooltip) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Tooltip))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQListWidgetItem(self).setToolTip(Q7B_IDQString(Tooltip));
}

void Q7B_QLISTWIDGETITEM_SETWHATSTHIS(Q7B self, Q7B WhatsThis) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(WhatsThis))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQListWidgetItem(self).setWhatsThis(Q7B_IDQString(WhatsThis));
}

Q7B Q7B_QLISTWIDGETITEM_SIZEHINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).sizeHint() );
}

Q7B Q7B_QLISTWIDGETITEM_STATUSTIP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).statusTip() );
}

Q7B Q7B_QLISTWIDGETITEM_TEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).text() );
}

Q7B Q7B_QLISTWIDGETITEM_TEXTALIGNMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).textAlignment() );
}

Q7B Q7B_QLISTWIDGETITEM_TOOLTIP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).toolTip() );
}

Q7B Q7B_QLISTWIDGETITEM_TYPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).type() );
}

Q7B Q7B_QLISTWIDGETITEM_WHATSTHIS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGETITEM(self))){ Q7B_EXCEPTION("QListWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidgetItem(self).whatsThis() );
}

















Q7B Q7B_QLOCALE_AMTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).amText() );
}
/*
Q7B Q7B_QLOCALE_BCP47NAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).bcp47Name() );
}*/

Q7B Q7B_QLOCALE_COUNTRY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).country() );
}
/*
Q7B Q7B_QLOCALE_CREATESEPARATEDLIST(Q7B self, Q7B ItemList) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRINGLIST(ItemList))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).createSeparatedList(Q7B_IDQStringList(ItemList)) );
}*/

/*
Q7B Q7B_QLOCALE_CURRENCYSYMBOL(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Format))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).currencySymbol((QLocale::CurrencySymbolFormat) Q7B_IDqint64(Format)) );
}*/

Q7B Q7B_QLOCALE_DATEFORMAT(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Format))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).dateFormat((QLocale::FormatType) Q7B_IDqint64(Format)) );
}

Q7B Q7B_QLOCALE_DATETIMEFORMAT(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Format))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).dateTimeFormat((QLocale::FormatType) Q7B_IDqint64(Format)) );
}

Q7B Q7B_QLOCALE_DAYNAME(Q7B self, Q7B Day, Q7B Type) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Day))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Type))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).dayName(Q7B_IDqint64(Day), (QLocale::FormatType) Q7B_IDqint64(Type)) );
}

Q7B Q7B_QLOCALE_DECIMALPOINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).decimalPoint() );
}

Q7B Q7B_QLOCALE_EXPONENTIAL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).exponential() );
}
/*
Q7B Q7B_QLOCALE_FIRSTDAYOFWEEK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).firstDayOfWeek() );
}*/

Q7B Q7B_QLOCALE_GROUPSEPARATOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).groupSeparator() );
}

Q7B Q7B_QLOCALE_LANGUAGE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).language() );
}

Q7B Q7B_QLOCALE_MEASUREMENTSYSTEM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).measurementSystem() );
}

Q7B Q7B_QLOCALE_MONTHNAME(Q7B self, Q7B Month, Q7B Type) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Month))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Type))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).monthName(Q7B_IDqint64(Month), (QLocale::FormatType) Q7B_IDqint64(Type)) );
}

Q7B Q7B_QLOCALE_NAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).name() );
}
/*
Q7B Q7B_QLOCALE_NATIVECOUNTRYNAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).nativeCountryName() );
}*/
/*
Q7B Q7B_QLOCALE_NATIVELANGUAGENAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).nativeLanguageName() );
}*/

Q7B Q7B_QLOCALE_NEGATIVESIGN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).negativeSign() );
}

Q7B Q7B_QLOCALE_NUMBEROPTIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).numberOptions() );
}

Q7B Q7B_QLOCALE_PERCENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).percent() );
}

Q7B Q7B_QLOCALE_PMTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).pmText() );
}

Q7B Q7B_QLOCALE_POSITIVESIGN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).positiveSign() );
}
/*
Q7B Q7B_QLOCALE_QUOTESTRING(Q7B self, Q7B Str, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).quoteString(Q7B_IDQString(Str), (QLocale::QuotationStyle) Q7B_IDqint64(Style)) );
}*/
/*
Q7B Q7B_QLOCALE_SCRIPT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).script() );
}*/

void Q7B_QLOCALE_SETNUMBEROPTIONS(Q7B self, Q7B Options) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Options))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLocale(self).setNumberOptions((QLocale::NumberOptions) Q7B_IDqint64(Options));
}

Q7B Q7B_QLOCALE_STANDALONEDAYNAME(Q7B self, Q7B Day, Q7B Type) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Day))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Type))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).standaloneDayName(Q7B_IDqint64(Day), (QLocale::FormatType) Q7B_IDqint64(Type)) );
}

Q7B Q7B_QLOCALE_STANDALONEMONTHNAME(Q7B self, Q7B Month, Q7B Type) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Month))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Type))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).standaloneMonthName(Q7B_IDqint64(Month), (QLocale::FormatType) Q7B_IDqint64(Type)) );
}

Q7B Q7B_QLOCALE_TEXTDIRECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).textDirection() );
}

Q7B Q7B_QLOCALE_TIMEFORMAT(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Format))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).timeFormat((QLocale::FormatType) Q7B_IDqint64(Format)) );
}
/*
Q7B Q7B_QLOCALE_TOCURRENCYSTRING(Q7B self, Q7B Value, Q7B Symbol) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Value))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Symbol))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toCurrencyString(Q7B_IDqint64(Value), Q7B_IDQString(Symbol)) );
}

Q7B Q7B_QLOCALE_TOCURRENCYSTRING2(Q7B self, Q7B Value, Q7B Symbol) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREAL(Value))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Symbol))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toCurrencyString(Q7B_IDqreal(Value), Q7B_IDQString(Symbol)) );
}
*/
Q7B Q7B_QLOCALE_TODATE(Q7B self, Q7B DateString, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(DateString))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Format))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toDate(Q7B_IDQString(DateString), (QLocale::FormatType) Q7B_IDqint64(Format)) );
}

Q7B Q7B_QLOCALE_TODATE2(Q7B self, Q7B DateString, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(DateString))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toDate(Q7B_IDQString(DateString), Q7B_IDQString(Format)) );
}

Q7B Q7B_QLOCALE_TODATETIME(Q7B self, Q7B DateString, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(DateString))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Format))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toDateTime(Q7B_IDQString(DateString), (QLocale::FormatType) Q7B_IDqint64(Format)) );
}

Q7B Q7B_QLOCALE_TODATETIME2(Q7B self, Q7B DateString, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(DateString))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toDateTime(Q7B_IDQString(DateString), Q7B_IDQString(Format)) );
}

Q7B Q7B_QLOCALE_TODOUBLE(Q7B self, Q7B S, Q7B Ok) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(S))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Ok))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }


  bool *b = new bool(); *b = false; 
  Q7B q = Q7B_ID( Q7B_IDQLocale(self).toDouble(Q7B_IDQString(S), b) );
  Ok->ref = b;
  /*
  static bool b; b = false;
  Q7B q = Q7B_ID( Q7B_IDQLocale(self).toDouble(Q7B_IDQString(S), &b) );
  Ok->ref = &b;
  Ok->type = typeid(bool).name();*/
  return q;
}

Q7B Q7B_QLOCALE_TOLONGLONG(Q7B self, Q7B S, Q7B Ok, Q7B Base) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(S))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Ok))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Base))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }



  bool *b = new bool(); *b = false; 
  Q7B q = Q7B_ID( Q7B_IDQLocale(self).toLongLong(Q7B_IDQString(S), b, Q7B_IDqint64(Base)) );
  Ok->ref = b;
  /*
  static bool b; b = false;
  Q7B q = Q7B_ID( Q7B_IDQLocale(self).toLongLong(Q7B_IDQString(S), &b, Q7B_IDqint64(Base)) );
  Ok->ref = &b;
  Ok->type = typeid(bool).name();*/
  return q;
}
/*
Q7B Q7B_QLOCALE_TOLOWER(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toLower(Q7B_IDQString(Str)) );
}*/

Q7B Q7B_QLOCALE_TOSTRING(Q7B self, Q7B I) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(I))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toString(Q7B_IDqint64(I)) );
}

Q7B Q7B_QLOCALE_TOSTRING2(Q7B self, Q7B Date, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDATE(Date))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toString(Q7B_IDQDate(Date), Q7B_IDQString(Format)) );
}

Q7B Q7B_QLOCALE_TOSTRING3(Q7B self, Q7B Date, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDATE(Date))){ Q7B_EXCEPTION("QDate expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Format))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toString(Q7B_IDQDate(Date), (QLocale::FormatType) Q7B_IDqint64(Format)) );
}

Q7B Q7B_QLOCALE_TOSTRING4(Q7B self, Q7B Time, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTIME(Time))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toString(Q7B_IDQTime(Time), Q7B_IDQString(Format)) );
}

Q7B Q7B_QLOCALE_TOSTRING5(Q7B self, Q7B Time, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTIME(Time))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Format))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toString(Q7B_IDQTime(Time), (QLocale::FormatType) Q7B_IDqint64(Format)) );
}

Q7B Q7B_QLOCALE_TOSTRING6(Q7B self, Q7B DateTime, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDATETIME(DateTime))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Format))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toString(Q7B_IDQDateTime(DateTime), (QLocale::FormatType) Q7B_IDqint64(Format)) );
}

Q7B Q7B_QLOCALE_TOSTRING7(Q7B self, Q7B DateTime, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDATETIME(DateTime))){ Q7B_EXCEPTION("QDateTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toString(Q7B_IDQDateTime(DateTime), Q7B_IDQString(Format)) );
}

Q7B Q7B_QLOCALE_TOSTRING8(Q7B self, Q7B I, Q7B F, Q7B Prec) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DOUBLE(I))){ Q7B_EXCEPTION("Double expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(F))){ Q7B_EXCEPTION("String as String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Prec))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  char c = Q7B_IDQString(F).at(0).toAscii();
  return Q7B_ID( Q7B_IDQLocale(self).toString(Q7B_IDqreal(I), c, Q7B_IDqint64(Prec)) );
}

Q7B Q7B_QLOCALE_TOTIME(Q7B self, Q7B TimeString, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(TimeString))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toTime(Q7B_IDQString(TimeString), Q7B_IDQString(Format)) );
}
/*
Q7B Q7B_QLOCALE_TOUPPER(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).toUpper(Q7B_IDQString(Str)) );
}*/
/*
Q7B Q7B_QLOCALE_UILANGUAGES(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(Q7B_IDQLocale(self).uiLanguages()))); 
  return q;

  //return Q7B_ID( Q7B_IDQLocale(self).uiLanguages() );
}*/
/*
Q7B Q7B_QLOCALE_WEEKDAYS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }


  QList<Qt::DayOfWeek> o = Q7B_IDQLocale(self).weekdays();

  Q7B_List *l = new Q7B_List(); 
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), l)); 

  for (int i = 0; i < o.size(); i++){
    qint64 n = (qint64) o.at(i);
    Q7B qq (new Q7B_id(typeid(qint64).name(), new qint64(n))); 
    l->append(qq);
  }

  return q;
}*/

Q7B Q7B_QLOCALE_ZERODIGIT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALE(self))){ Q7B_EXCEPTION("QLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocale(self).zeroDigit() );
}


















void Q7B_QMAINWINDOW_ADDDOCKWIDGET(Q7B self, Q7B Area, Q7B DockWidget, Q7B Orientation) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Area))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QDOCKWIDGET(DockWidget))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Orientation))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQMainWindow(self)->addDockWidget((Qt::DockWidgetArea) Q7B_IDqint64(Area), Q7B_IDQDockWidget(DockWidget), (Qt::Orientation) Q7B_IDqint64(Orientation));
}

Q7B Q7B_QMAINWINDOW_ADDTOOLBAR(Q7B self, Q7B Title) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Title))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->addToolBar(Q7B_IDQString(Title)) );
}

void Q7B_QMAINWINDOW_ADDTOOLBARBREAK(Q7B self, Q7B Area) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Area))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQMainWindow(self)->addToolBarBreak((Qt::ToolBarArea) Q7B_IDqint64(Area));
}

Q7B Q7B_QMAINWINDOW_ANIMATED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->isAnimated() );
}

void Q7B_QMAINWINDOW_ANIMATED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQMainWindow(self)->setAnimated(Q7B_IDbool(theProperty));
}

Q7B Q7B_QMAINWINDOW_CENTRALWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->centralWidget() );
}

Q7B Q7B_QMAINWINDOW_CORNER(Q7B self, Q7B Corner) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Corner))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->corner((Qt::Corner) Q7B_IDqint64(Corner)) );
}

Q7B Q7B_QMAINWINDOW_DOCKNESTINGENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->isDockNestingEnabled() );
}

void Q7B_QMAINWINDOW_DOCKNESTINGENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQMainWindow(self)->setDockNestingEnabled(Q7B_IDbool(theProperty));
}

Q7B Q7B_QMAINWINDOW_DOCKOPTIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->dockOptions() );
}

void Q7B_QMAINWINDOW_DOCKOPTIONS(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQMainWindow(self)->setDockOptions((QMainWindow::DockOption) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QMAINWINDOW_DOCKWIDGETAREA(Q7B self, Q7B DockWidget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDOCKWIDGET(DockWidget))){ Q7B_EXCEPTION("QDockWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->dockWidgetArea(Q7B_IDQDockWidget(DockWidget)) );
}

Q7B Q7B_QMAINWINDOW_DOCUMENTMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->documentMode() );
}

void Q7B_QMAINWINDOW_DOCUMENTMODE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQMainWindow(self)->setDocumentMode(Q7B_IDbool(theProperty));
}

Q7B Q7B_QMAINWINDOW_ICONSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->iconSize() );
}

void Q7B_QMAINWINDOW_ICONSIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  Q7B_IDQMainWindow(self)->setIconSize(Q7B_IDQSize(theProperty));
}

void Q7B_QMAINWINDOW_INSERTTOOLBAR(Q7B self, Q7B Before, Q7B ToolBar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QTOOLBAR(Before))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  if (Q7B_nil(Q7B_QTOOLBAR(ToolBar))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  Q7B_IDQMainWindow(self)->insertToolBar(Q7B_IDQToolBar(Before), Q7B_IDQToolBar(ToolBar));
}

void Q7B_QMAINWINDOW_INSERTTOOLBARBREAK(Q7B self, Q7B Before) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QTOOLBAR(Before))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  Q7B_IDQMainWindow(self)->insertToolBarBreak(Q7B_IDQToolBar(Before));
}

Q7B Q7B_QMAINWINDOW_MENUBAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->menuBar() );
}

Q7B Q7B_QMAINWINDOW_MENUWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->menuWidget() );
}

void Q7B_QMAINWINDOW_REMOVEDOCKWIDGET(Q7B self, Q7B DockWidget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QDOCKWIDGET(DockWidget))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  Q7B_IDQMainWindow(self)->removeDockWidget(Q7B_IDQDockWidget(DockWidget));
}

void Q7B_QMAINWINDOW_REMOVETOOLBAR(Q7B self, Q7B ToolBar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QTOOLBAR(ToolBar))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  Q7B_IDQMainWindow(self)->removeToolBar(Q7B_IDQToolBar(ToolBar));
}

void Q7B_QMAINWINDOW_REMOVETOOLBARBREAK(Q7B self, Q7B Before) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QTOOLBAR(Before))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  Q7B_IDQMainWindow(self)->removeToolBarBreak(Q7B_IDQToolBar(Before));
}

Q7B Q7B_QMAINWINDOW_RESTOREDOCKWIDGET(Q7B self, Q7B DockWidget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDOCKWIDGET(DockWidget))){ Q7B_EXCEPTION("QDockWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->restoreDockWidget(Q7B_IDQDockWidget(DockWidget)) );
}

Q7B Q7B_QMAINWINDOW_RESTORESTATE(Q7B self, Q7B State, Q7B Version) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(State))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Version))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->restoreState(Q7B_IDQByteArray(State), Q7B_IDInteger(Version)) );
}

Q7B Q7B_QMAINWINDOW_SAVESTATE(Q7B self, Q7B Version) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Version))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->saveState(Q7B_IDInteger(Version)) );
}

void Q7B_QMAINWINDOW_SETANIMATED(Q7B self, Q7B Enabled) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enabled))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQMainWindow(self)->setAnimated(Q7B_IDbool(Enabled));
}

void Q7B_QMAINWINDOW_SETCENTRALWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQMainWindow(self)->setCentralWidget(Q7B_IDQWidget(Widget));
}

void Q7B_QMAINWINDOW_SETCORNER(Q7B self, Q7B Corner, Q7B Area) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Corner))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Area))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQMainWindow(self)->setCorner((Qt::Corner) Q7B_IDqint64(Corner), (Qt::DockWidgetArea) Q7B_IDqint64(Area));
}

void Q7B_QMAINWINDOW_SETDOCKNESTINGENABLED(Q7B self, Q7B Enabled) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enabled))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQMainWindow(self)->setDockNestingEnabled(Q7B_IDbool(Enabled));
}

void Q7B_QMAINWINDOW_SETMENUBAR(Q7B self, Q7B MenuBar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QMENUBAR(MenuBar))){ Q7B_EXCEPTION("QMenuBar expected"); return ; }

  Q7B_IDQMainWindow(self)->setMenuBar(Q7B_IDQMenuBar(MenuBar));
}

void Q7B_QMAINWINDOW_SETMENUWIDGET(Q7B self, Q7B MenuBar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(MenuBar))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQMainWindow(self)->setMenuWidget(Q7B_IDQWidget(MenuBar));
}

void Q7B_QMAINWINDOW_SPLITDOCKWIDGET(Q7B self, Q7B First, Q7B Second, Q7B Orientation) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QDOCKWIDGET(First))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  if (Q7B_nil(Q7B_QDOCKWIDGET(Second))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Orientation))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQMainWindow(self)->splitDockWidget(Q7B_IDQDockWidget(First), Q7B_IDQDockWidget(Second), (Qt::Orientation) Q7B_IDqint64(Orientation));
}

void Q7B_QMAINWINDOW_SETSTATUSBAR(Q7B self, Q7B StatusBar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QSTATUSBAR(StatusBar))){ Q7B_EXCEPTION("QStatusBar expected"); return ; }

  Q7B_IDQMainWindow(self)->setStatusBar(Q7B_IDQStatusBar(StatusBar));
}

void Q7B_QMAINWINDOW_SETTABPOSITION(Q7B self, Q7B Areas, Q7B TabPosition) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Areas))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(TabPosition))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQMainWindow(self)->setTabPosition((Qt::DockWidgetAreas) Q7B_IDqint64(Areas), (QTabWidget::TabPosition) Q7B_IDqint64(TabPosition));
}

void Q7B_QMAINWINDOW_SETTABSHAPE(Q7B self, Q7B TabShape) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(TabShape))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQMainWindow(self)->setTabShape((QTabWidget::TabShape) Q7B_IDqint64(TabShape));
}

Q7B Q7B_QMAINWINDOW_STATUSBAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->statusBar() );
}

Q7B Q7B_QMAINWINDOW_TABPOSITION(Q7B self, Q7B Area) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Area))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->tabPosition((Qt::DockWidgetArea) Q7B_IDqint64(Area)) );
}

Q7B Q7B_QMAINWINDOW_TABSHAPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->tabShape() );
}

Q7B Q7B_QMAINWINDOW_TABIFIEDDOCKWIDGETS(Q7B self, Q7B DockWidget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDOCKWIDGET(DockWidget))){ Q7B_EXCEPTION("QDockWidget expected"); return Q7B_idnil; }

  
  QList<QDockWidget*> o = Q7B_IDQMainWindow(self)->tabifiedDockWidgets(Q7B_IDQDockWidget(DockWidget));

  Q7B_List *l = new Q7B_List(); 
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), l)); 

  for (int i = 0; i < o.size(); i++){
    Q7B qq (new Q7B_id(typeid(QDockWidget).name(), o.at(i), false)); 
    l->append(qq);
  }

  return q;
}

void Q7B_QMAINWINDOW_TABIFYDOCKWIDGET(Q7B self, Q7B First, Q7B Second) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QDOCKWIDGET(First))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  if (Q7B_nil(Q7B_QDOCKWIDGET(Second))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  Q7B_IDQMainWindow(self)->tabifyDockWidget(Q7B_IDQDockWidget(First), Q7B_IDQDockWidget(Second));
}

Q7B Q7B_QMAINWINDOW_TOOLBARAREA(Q7B self, Q7B ToolBar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTOOLBAR(ToolBar))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->toolBarArea(Q7B_IDQToolBar(ToolBar)) );
}

Q7B Q7B_QMAINWINDOW_TOOLBARBREAK(Q7B self, Q7B ToolBar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTOOLBAR(ToolBar))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->toolBarBreak(Q7B_IDQToolBar(ToolBar)) );
}

Q7B Q7B_QMAINWINDOW_TOOLBUTTONSTYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->toolButtonStyle() );
}

void Q7B_QMAINWINDOW_TOOLBUTTONSTYLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQMainWindow(self)->setToolButtonStyle((Qt::ToolButtonStyle) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QMAINWINDOW_UNIFIEDTITLEANDTOOLBARONMAC(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMainWindow(self)->unifiedTitleAndToolBarOnMac() );
}

void Q7B_QMAINWINDOW_UNIFIEDTITLEANDTOOLBARONMAC(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQMainWindow(self)->setUnifiedTitleAndToolBarOnMac(Q7B_IDbool(theProperty));
}


























void Q7B_QMDIAREA_ACTIVATENEXTSUBWINDOW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  Q7B_IDQMdiArea(self)->activateNextSubWindow();
}

void Q7B_QMDIAREA_ACTIVATEPREVIOUSSUBWINDOW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  Q7B_IDQMdiArea(self)->activatePreviousSubWindow();
}

Q7B Q7B_QMDIAREA_ACTIVATIONORDER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiArea(self)->activationOrder() );
}

void Q7B_QMDIAREA_ACTIVATIONORDER(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQMdiArea(self)->setActivationOrder((QMdiArea::WindowOrder) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QMDIAREA_ACTIVESUBWINDOW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiArea(self)->activeSubWindow() );
}

Q7B Q7B_QMDIAREA_ADDSUBWINDOW(Q7B self, Q7B Widget, Q7B WindowFlags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(WindowFlags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiArea(self)->addSubWindow(Q7B_IDQWidget(Widget), (Qt::WindowFlags) Q7B_IDqint64(WindowFlags)) );
}

Q7B Q7B_QMDIAREA_BACKGROUND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiArea(self)->background() );
}

void Q7B_QMDIAREA_BACKGROUND(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  if (Q7B_nil(Q7B_QBRUSH(theProperty))){ Q7B_EXCEPTION("QBrush expected"); return; }

  Q7B_IDQMdiArea(self)->setBackground(Q7B_IDQBrush(theProperty));
}

void Q7B_QMDIAREA_CASCADESUBWINDOWS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  Q7B_IDQMdiArea(self)->cascadeSubWindows();
}

void Q7B_QMDIAREA_CLOSEACTIVESUBWINDOW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  Q7B_IDQMdiArea(self)->closeActiveSubWindow();
}

void Q7B_QMDIAREA_CLOSEALLSUBWINDOWS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  Q7B_IDQMdiArea(self)->closeAllSubWindows();
}

Q7B Q7B_QMDIAREA_DOCUMENTMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiArea(self)->documentMode() );
}

void Q7B_QMDIAREA_DOCUMENTMODE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQMdiArea(self)->setDocumentMode(Q7B_IDbool(theProperty));
}

void Q7B_QMDIAREA_REMOVESUBWINDOW(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQMdiArea(self)->removeSubWindow(Q7B_IDQWidget(Widget));
}

void Q7B_QMDIAREA_SETACTIVESUBWINDOW(Q7B self, Q7B Window) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  if (Q7B_nil(Q7B_QMDISUBWINDOW(Window))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return ; }

  Q7B_IDQMdiArea(self)->setActiveSubWindow(Q7B_IDQMdiSubWindow(Window));
}

void Q7B_QMDIAREA_SETOPTION(Q7B self, Q7B Option, Q7B On) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Option))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(On))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQMdiArea(self)->setOption((QMdiArea::AreaOption) Q7B_IDqint64(Option), Q7B_IDbool(On));
}

Q7B Q7B_QMDIAREA_SUBWINDOWLIST(Q7B self, Q7B Order) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Order))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }


  QList<QMdiSubWindow *> o = Q7B_IDQMdiArea(self)->subWindowList((QMdiArea::WindowOrder) Q7B_IDqint64(Order));

  Q7B_List *l = new Q7B_List(); 
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), l)); 

  for (int i = 0; i < o.size(); i++){
    Q7B qq (new Q7B_id(typeid(QMdiSubWindow).name(), o.at(i), false)); 
    l->append(qq);
  }

  return q;
}

Q7B Q7B_QMDIAREA_TABPOSITION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiArea(self)->tabPosition() );
}

void Q7B_QMDIAREA_TABPOSITION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQMdiArea(self)->setTabPosition((QTabWidget::TabPosition) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QMDIAREA_TABSHAPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiArea(self)->tabShape() );
}

void Q7B_QMDIAREA_TABSHAPE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQMdiArea(self)->setTabShape((QTabWidget::TabShape) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QMDIAREA_TESTOPTION(Q7B self, Q7B Option) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Option))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiArea(self)->testOption((QMdiArea::AreaOption) Q7B_IDqint64(Option)) );
}

void Q7B_QMDIAREA_TILESUBWINDOWS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDIAREA(self))){ Q7B_EXCEPTION("QMdiArea expected"); return ; }

  Q7B_IDQMdiArea(self)->tileSubWindows();
}













Q7B Q7B_QMDISUBWINDOW_ISSHADED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiSubWindow(self)->isShaded() );
}

Q7B Q7B_QMDISUBWINDOW_KEYBOARDPAGESTEP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiSubWindow(self)->keyboardPageStep() );
}

void Q7B_QMDISUBWINDOW_KEYBOARDPAGESTEP(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQMdiSubWindow(self)->setKeyboardPageStep(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QMDISUBWINDOW_KEYBOARDSINGLESTEP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiSubWindow(self)->keyboardSingleStep() );
}

void Q7B_QMDISUBWINDOW_KEYBOARDSINGLESTEP(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQMdiSubWindow(self)->setKeyboardSingleStep(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QMDISUBWINDOW_MDIAREA(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiSubWindow(self)->mdiArea() );
}

void Q7B_QMDISUBWINDOW_SETOPTION(Q7B self, Q7B Option, Q7B On) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Option))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(On))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQMdiSubWindow(self)->setOption((QMdiSubWindow::SubWindowOption) Q7B_IDqint64(Option), Q7B_IDbool(On));
}

void Q7B_QMDISUBWINDOW_SETSYSTEMMENU(Q7B self, Q7B SystemMenu) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return ; }

  if (Q7B_nil(Q7B_QMENU(SystemMenu))){ Q7B_EXCEPTION("QMenu expected"); return ; }

  Q7B_IDQMdiSubWindow(self)->setSystemMenu(Q7B_IDQMenu(SystemMenu));
}

void Q7B_QMDISUBWINDOW_SETWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQMdiSubWindow(self)->setWidget(Q7B_IDQWidget(Widget));
}

void Q7B_QMDISUBWINDOW_SHOWSHADED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return ; }

  Q7B_IDQMdiSubWindow(self)->showShaded();
}

void Q7B_QMDISUBWINDOW_SHOWSYSTEMMENU(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return ; }

  Q7B_IDQMdiSubWindow(self)->showSystemMenu();
}

Q7B Q7B_QMDISUBWINDOW_SYSTEMMENU(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiSubWindow(self)->systemMenu() );
}

Q7B Q7B_QMDISUBWINDOW_TESTOPTION(Q7B self, Q7B Option) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Option))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiSubWindow(self)->testOption((QMdiSubWindow::SubWindowOption) Q7B_IDqint64(Option)) );
}

Q7B Q7B_QMDISUBWINDOW_WIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMDISUBWINDOW(self))){ Q7B_EXCEPTION("QMdiSubWindow expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMdiSubWindow(self)->widget() );
}


Q7B Q7B_QMOVIE_BACKGROUNDCOLOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->backgroundColor() );
}

Q7B Q7B_QMOVIE_CACHEMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->cacheMode() );
}

void Q7B_QMOVIE_CACHEMODE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQMovie(self)->setCacheMode((QMovie::CacheMode) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QMOVIE_CURRENTFRAMENUMBER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->currentFrameNumber() );
}

Q7B Q7B_QMOVIE_CURRENTIMAGE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->currentImage() );
}

Q7B Q7B_QMOVIE_CURRENTPIXMAP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->currentPixmap() );
}

Q7B Q7B_QMOVIE_FILENAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->fileName() );
}

Q7B Q7B_QMOVIE_FORMAT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->format() );
}

Q7B Q7B_QMOVIE_FRAMECOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->frameCount() );
}

Q7B Q7B_QMOVIE_FRAMERECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->frameRect() );
}

Q7B Q7B_QMOVIE_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->isValid() );
}

Q7B Q7B_QMOVIE_JUMPTOFRAME(Q7B self, Q7B FrameNumber) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(FrameNumber))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->jumpToFrame(Q7B_IDqint64(FrameNumber)) );
}

Q7B Q7B_QMOVIE_JUMPTONEXTFRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->jumpToNextFrame() );
}

Q7B Q7B_QMOVIE_LOOPCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->loopCount() );
}

Q7B Q7B_QMOVIE_NEXTFRAMEDELAY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->nextFrameDelay() );
}

Q7B Q7B_QMOVIE_SCALEDSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->scaledSize() );
}

void Q7B_QMOVIE_SETBACKGROUNDCOLOR(Q7B self, Q7B Color) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return ; }

  if (Q7B_nil(Q7B_QCOLOR(Color))){ Q7B_EXCEPTION("QColor expected"); return ; }

  Q7B_IDQMovie(self)->setBackgroundColor(Q7B_IDQColor(Color));
}

void Q7B_QMOVIE_SETFILENAME(Q7B self, Q7B FileName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQMovie(self)->setFileName(Q7B_IDQString(FileName));
}

void Q7B_QMOVIE_SETFORMAT(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Format))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQMovie(self)->setFormat(Q7B_IDQByteArray(Format));
}

void Q7B_QMOVIE_SETPAUSED(Q7B self, Q7B Paused) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Paused))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQMovie(self)->setPaused(Q7B_IDbool(Paused));
}

void Q7B_QMOVIE_SETSCALEDSIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQMovie(self)->setScaledSize(Q7B_IDQSize(Size));
}

void Q7B_QMOVIE_SETSPEED(Q7B self, Q7B PercentSpeed) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(PercentSpeed))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQMovie(self)->setSpeed(Q7B_IDqint64(PercentSpeed));
}

Q7B Q7B_QMOVIE_SPEED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->speed() );
}

void Q7B_QMOVIE_SPEED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQMovie(self)->setSpeed(Q7B_IDqint64(theProperty));
}

void Q7B_QMOVIE_START(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return ; }

  Q7B_IDQMovie(self)->start();
}

Q7B Q7B_QMOVIE_STATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMovie(self)->state() );
}

void Q7B_QMOVIE_STOP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMOVIE(self))){ Q7B_EXCEPTION("QMovie expected"); return ; }

  Q7B_IDQMovie(self)->stop();
}













void Q7B_QPROCESS_CLOSEREADCHANNEL(Q7B self, Q7B Channel) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Channel))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProcess(self).closeReadChannel((QProcess::ProcessChannel) Q7B_IDqint64(Channel));
}

void Q7B_QPROCESS_CLOSEWRITECHANNEL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  Q7B_IDQProcess(self).closeWriteChannel();
}

Q7B Q7B_QPROCESS_EXITCODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcess(self).exitCode() );
}

Q7B Q7B_QPROCESS_EXITSTATUS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcess(self).exitStatus() );
}

void Q7B_QPROCESS_KILL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  Q7B_IDQProcess(self).kill();
}
/*
Q7B Q7B_QPROCESS_NATIVEARGUMENTS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcess(self).nativeArguments() );
}*/

Q7B Q7B_QPROCESS_PID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcess(self).pid() );
}

Q7B Q7B_QPROCESS_PROCESSCHANNELMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcess(self).processChannelMode() );
}

Q7B Q7B_QPROCESS_PROCESSENVIRONMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcess(self).processEnvironment() );
}

Q7B Q7B_QPROCESS_READALLSTANDARDERROR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcess(self).readAllStandardError() );
}

Q7B Q7B_QPROCESS_READALLSTANDARDOUTPUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcess(self).readAllStandardOutput() );
}

Q7B Q7B_QPROCESS_READCHANNEL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcess(self).readChannel() );
}
/*
void Q7B_QPROCESS_SETNATIVEARGUMENTS(Q7B self, Q7B Arguments) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Arguments))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQProcess(self).setNativeArguments(Q7B_IDQString(Arguments));
}*/

void Q7B_QPROCESS_SETPROCESSCHANNELMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProcess(self).setProcessChannelMode((QProcess::ProcessChannelMode) Q7B_IDqint64(Mode));
}

void Q7B_QPROCESS_SETPROCESSENVIRONMENT(Q7B self, Q7B Environment) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  if (Q7B_nil(Q7B_QPROCESSENVIRONMENT(Environment))){ Q7B_EXCEPTION("QProcessEnvironment expected"); return ; }

  Q7B_IDQProcess(self).setProcessEnvironment(Q7B_IDQProcessEnvironment(Environment));
}

void Q7B_QPROCESS_SETREADCHANNEL(Q7B self, Q7B Channel) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Channel))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProcess(self).setReadChannel((QProcess::ProcessChannel) Q7B_IDqint64(Channel));
}

void Q7B_QPROCESS_SETSTANDARDERRORFILE(Q7B self, Q7B FileName, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProcess(self).setStandardErrorFile(Q7B_IDQString(FileName), (QIODevice::OpenMode) Q7B_IDqint64(Mode));
}

void Q7B_QPROCESS_SETSTANDARDINPUTFILE(Q7B self, Q7B FileName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQProcess(self).setStandardInputFile(Q7B_IDQString(FileName));
}

void Q7B_QPROCESS_SETSTANDARDOUTPUTFILE(Q7B self, Q7B FileName, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProcess(self).setStandardOutputFile(Q7B_IDQString(FileName), (QIODevice::OpenMode) Q7B_IDqint64(Mode));
}

void Q7B_QPROCESS_SETSTANDARDOUTPUTPROCESS(Q7B self, Q7B Destination) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  if (Q7B_nil(Q7B_QPROCESS(Destination))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  Q7B_IDQProcess(self).setStandardOutputProcess(&Q7B_IDQProcess(Destination));
}

void Q7B_QPROCESS_SETWORKINGDIRECTORY(Q7B self, Q7B theDir) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theDir))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQProcess(self).setWorkingDirectory(Q7B_IDQString(theDir));
}

Q7B Q7B_QPROCESS_STATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcess(self).state() );
}

void Q7B_QPROCESS_TERMINATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  Q7B_IDQProcess(self).terminate();
}

Q7B Q7B_QPROCESS_WAITFORFINISHED(Q7B self, Q7B Msecs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Msecs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcess(self).waitForFinished(Q7B_IDqint64(Msecs)) );
}

Q7B Q7B_QPROCESS_WAITFORSTARTED(Q7B self, Q7B Msecs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Msecs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcess(self).waitForStarted(Q7B_IDqint64(Msecs)) );
}

Q7B Q7B_QPROCESS_WORKINGDIRECTORY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcess(self).workingDirectory() );
}

void Q7B_QPROCESSENVIRONMENT_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESSENVIRONMENT(self))){ Q7B_EXCEPTION("QProcessEnvironment expected"); return ; }

  Q7B_IDQProcessEnvironment(self).clear();
}

Q7B Q7B_QPROCESSENVIRONMENT_CONTAINS(Q7B self, Q7B Name) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESSENVIRONMENT(self))){ Q7B_EXCEPTION("QProcessEnvironment expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcessEnvironment(self).contains(Q7B_IDQString(Name)) );
}

void Q7B_QPROCESSENVIRONMENT_INSERT(Q7B self, Q7B Name, Q7B Value) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESSENVIRONMENT(self))){ Q7B_EXCEPTION("QProcessEnvironment expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQProcessEnvironment(self).insert(Q7B_IDQString(Name), Q7B_IDQString(Value));
}

Q7B Q7B_QPROCESSENVIRONMENT_ISEMPTY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESSENVIRONMENT(self))){ Q7B_EXCEPTION("QProcessEnvironment expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcessEnvironment(self).isEmpty() );
}
/*
Q7B Q7B_QPROCESSENVIRONMENT_KEYS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESSENVIRONMENT(self))){ Q7B_EXCEPTION("QProcessEnvironment expected"); return Q7B_idnil; }

  Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(Q7B_IDQProcessEnvironment(self).keys()))); 
  return q;

  //return Q7B_ID( Q7B_IDQProcessEnvironment(self).keys() );
}*/

void Q7B_QPROCESSENVIRONMENT_REMOVE(Q7B self, Q7B Name) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESSENVIRONMENT(self))){ Q7B_EXCEPTION("QProcessEnvironment expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQProcessEnvironment(self).remove(Q7B_IDQString(Name));
}

Q7B Q7B_QPROCESSENVIRONMENT_TOSTRINGLIST(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESSENVIRONMENT(self))){ Q7B_EXCEPTION("QProcessEnvironment expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcessEnvironment(self).toStringList() );
}

Q7B Q7B_QPROCESSENVIRONMENT_VALUE(Q7B self, Q7B Name, Q7B DefaultValue) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROCESSENVIRONMENT(self))){ Q7B_EXCEPTION("QProcessEnvironment expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(DefaultValue))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProcessEnvironment(self).value(Q7B_IDQString(Name), Q7B_IDQString(DefaultValue)) );
}

Q7B Q7B_QPROGRESSBAR_ALIGNMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) Q7B_IDQProgressBar(self)->alignment() );
}

void Q7B_QPROGRESSBAR_ALIGNMENT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQProgressBar(self)->setAlignment((Qt::Alignment) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QPROGRESSBAR_FORMAT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProgressBar(self)->format() );
}

void Q7B_QPROGRESSBAR_FORMAT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQProgressBar(self)->setFormat(Q7B_IDQString(theProperty));
}

Q7B Q7B_QPROGRESSBAR_INVERTEDAPPEARANCE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProgressBar(self)->invertedAppearance() );
}

void Q7B_QPROGRESSBAR_INVERTEDAPPEARANCE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQProgressBar(self)->setInvertedAppearance(Q7B_IDbool(theProperty));
}

Q7B Q7B_QPROGRESSBAR_ORIENTATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProgressBar(self)->orientation() );
}

void Q7B_QPROGRESSBAR_ORIENTATION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQProgressBar(self)->setOrientation((Qt::Orientation) Q7B_IDqint64(theProperty));
}

void Q7B_QPROGRESSBAR_RESET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return ; }

  Q7B_IDQProgressBar(self)->reset();
}

void Q7B_QPROGRESSBAR_SETMAXIMUM(Q7B self, Q7B Maximum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Maximum))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProgressBar(self)->setMaximum(Q7B_IDqint64(Maximum));
}

void Q7B_QPROGRESSBAR_SETMINIMUM(Q7B self, Q7B Minimum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Minimum))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProgressBar(self)->setMinimum(Q7B_IDqint64(Minimum));
}

void Q7B_QPROGRESSBAR_SETORIENTATION(Q7B self, Q7B a0) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(a0))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProgressBar(self)->setOrientation((Qt::Orientation) Q7B_IDqint64(a0));
}

void Q7B_QPROGRESSBAR_SETRANGE(Q7B self, Q7B Minimum, Q7B Maximum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Minimum))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Maximum))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProgressBar(self)->setRange(Q7B_IDqint64(Minimum), Q7B_IDqint64(Maximum));
}

void Q7B_QPROGRESSBAR_SETVALUE(Q7B self, Q7B Value) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Value))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProgressBar(self)->setValue(Q7B_IDqint64(Value));
}

Q7B Q7B_QPROGRESSBAR_TEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProgressBar(self)->text() );
}

void Q7B_QPROGRESSBAR_TEXT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQProgressBar(self)->setProperty("text", Q7B_IDQString(theProperty));
}

Q7B Q7B_QPROGRESSBAR_TEXTDIRECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProgressBar(self)->textDirection() );
}

void Q7B_QPROGRESSBAR_TEXTDIRECTION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSBAR(self))){ Q7B_EXCEPTION("QProgressBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQProgressBar(self)->setTextDirection((QProgressBar::Direction) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QPROGRESSDIALOG_AUTOCLOSE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProgressDialog(self)->autoClose() );
}

void Q7B_QPROGRESSDIALOG_AUTOCLOSE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQProgressDialog(self)->setAutoClose(Q7B_IDbool(theProperty));
}

Q7B Q7B_QPROGRESSDIALOG_AUTORESET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProgressDialog(self)->autoReset() );
}

void Q7B_QPROGRESSDIALOG_AUTORESET(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQProgressDialog(self)->setAutoReset(Q7B_IDbool(theProperty));
}

void Q7B_QPROGRESSDIALOG_CANCEL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  Q7B_IDQProgressDialog(self)->cancel();
}

Q7B Q7B_QPROGRESSDIALOG_LABELTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProgressDialog(self)->labelText() );
}

void Q7B_QPROGRESSDIALOG_LABELTEXT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQProgressDialog(self)->setLabelText(Q7B_IDQString(theProperty));
}

Q7B Q7B_QPROGRESSDIALOG_MAXIMUM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProgressDialog(self)->maximum() );
}

void Q7B_QPROGRESSDIALOG_MAXIMUM(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQProgressDialog(self)->setMaximum(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QPROGRESSDIALOG_MINIMUM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProgressDialog(self)->minimum() );
}

void Q7B_QPROGRESSDIALOG_MINIMUM(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQProgressDialog(self)->setMinimum(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QPROGRESSDIALOG_MINIMUMDURATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProgressDialog(self)->minimumDuration() );
}

void Q7B_QPROGRESSDIALOG_MINIMUMDURATION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQProgressDialog(self)->setMinimumDuration(Q7B_IDqint64(theProperty));
}

void Q7B_QPROGRESSDIALOG_OPEN(Q7B self, Q7B Receiver, Q7B Member) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QOBJECT(Receiver))){ Q7B_EXCEPTION("QObject expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Member))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQProgressDialog(self)->open(Q7B_IDQObject(Receiver), Q7B_IDQString(Member).toAscii().constData());
}

void Q7B_QPROGRESSDIALOG_RESET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  Q7B_IDQProgressDialog(self)->reset();
}

void Q7B_QPROGRESSDIALOG_SETBAR(Q7B self, Q7B Bar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(Bar))){ Q7B_EXCEPTION("QProgressBar expected"); return ; }

  Q7B_IDQProgressDialog(self)->setBar(Q7B_IDQProgressBar(Bar));
}

void Q7B_QPROGRESSDIALOG_SETCANCELBUTTON(Q7B self, Q7B CancelButton) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QPUSHBUTTON(CancelButton))){ Q7B_EXCEPTION("QPushButton expected"); return ; }

  Q7B_IDQProgressDialog(self)->setCancelButton(Q7B_IDQPushButton(CancelButton));
}

void Q7B_QPROGRESSDIALOG_SETCANCELBUTTONTEXT(Q7B self, Q7B CancelButtonText) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(CancelButtonText))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQProgressDialog(self)->setCancelButtonText(Q7B_IDQString(CancelButtonText));
}

void Q7B_QPROGRESSDIALOG_SETLABEL(Q7B self, Q7B Label) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QLABEL(Label))){ Q7B_EXCEPTION("QLabel expected"); return ; }

  Q7B_IDQProgressDialog(self)->setLabel(Q7B_IDQLabel(Label));
}

void Q7B_QPROGRESSDIALOG_SETLABELTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQProgressDialog(self)->setLabelText(Q7B_IDQString(Text));
}

void Q7B_QPROGRESSDIALOG_SETMAXIMUM(Q7B self, Q7B Maximum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Maximum))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProgressDialog(self)->setMaximum(Q7B_IDqint64(Maximum));
}

void Q7B_QPROGRESSDIALOG_SETMINIMUM(Q7B self, Q7B Minimum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Minimum))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProgressDialog(self)->setMinimum(Q7B_IDqint64(Minimum));
}

void Q7B_QPROGRESSDIALOG_SETMINIMUMDURATION(Q7B self, Q7B Ms) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Ms))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProgressDialog(self)->setMinimumDuration(Q7B_IDqint64(Ms));
}

void Q7B_QPROGRESSDIALOG_SETRANGE(Q7B self, Q7B Minimum, Q7B Maximum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Minimum))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Maximum))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProgressDialog(self)->setRange(Q7B_IDqint64(Minimum), Q7B_IDqint64(Maximum));
}

void Q7B_QPROGRESSDIALOG_SETVALUE(Q7B self, Q7B Progress) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Progress))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQProgressDialog(self)->setValue(Q7B_IDqint64(Progress));
}

Q7B Q7B_QPROGRESSDIALOG_VALUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProgressDialog(self)->value() );
}

void Q7B_QPROGRESSDIALOG_VALUE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQProgressDialog(self)->setValue(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QPROGRESSDIALOG_WASCANCELED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQProgressDialog(self)->wasCanceled() );
}

void Q7B_QPROGRESSDIALOG_WASCANCELED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROGRESSDIALOG(self))){ Q7B_EXCEPTION("QProgressDialog expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQProgressDialog(self)->setProperty("wasCanceled", Q7B_IDbool(theProperty));
}

void Q7B_QPUSHBUTTON_SETMENU(Q7B self, Q7B Menu) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPUSHBUTTON(self))){ Q7B_EXCEPTION("QPushButton expected"); return ; }

  if (Q7B_nil(Q7B_QMENU(Menu))){ Q7B_EXCEPTION("QMenu expected"); return ; }

  Q7B_IDQPushButton(self)->setMenu(Q7B_IDQMenu(Menu));
}

void Q7B_QPUSHBUTTON_SHOWMENU(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPUSHBUTTON(self))){ Q7B_EXCEPTION("QPushButton expected"); return ; }

  Q7B_IDQPushButton(self)->showMenu();
}

Q7B Q7B_QSCROLLAREA_ALIGNMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSCROLLAREA(self))){ Q7B_EXCEPTION("QScrollArea expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) Q7B_IDQScrollArea(self)->alignment() );
}

void Q7B_QSCROLLAREA_ALIGNMENT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSCROLLAREA(self))){ Q7B_EXCEPTION("QScrollArea expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQScrollArea(self)->setAlignment((Qt::Alignment) Q7B_IDqint64(theProperty));
}

void Q7B_QSCROLLAREA_ENSUREVISIBLE(Q7B self, Q7B X, Q7B Y, Q7B YMargin) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSCROLLAREA(self))){ Q7B_EXCEPTION("QScrollArea expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(YMargin))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQScrollArea(self)->ensureVisible(Q7B_IDqint64(X), Q7B_IDqint64(Y), Q7B_IDqint64(YMargin));
}

void Q7B_QSCROLLAREA_ENSUREWIDGETVISIBLE(Q7B self, Q7B ChildWidget, Q7B XMargin, Q7B YMargin) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSCROLLAREA(self))){ Q7B_EXCEPTION("QScrollArea expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(ChildWidget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(XMargin))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(YMargin))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQScrollArea(self)->ensureWidgetVisible(Q7B_IDQWidget(ChildWidget), Q7B_IDqint64(XMargin), Q7B_IDqint64(YMargin));
}

void Q7B_QSCROLLAREA_SETWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSCROLLAREA(self))){ Q7B_EXCEPTION("QScrollArea expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQScrollArea(self)->setWidget(Q7B_IDQWidget(Widget));
}

Q7B Q7B_QSCROLLAREA_TAKEWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSCROLLAREA(self))){ Q7B_EXCEPTION("QScrollArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQScrollArea(self)->takeWidget() );
}

Q7B Q7B_QSCROLLAREA_WIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSCROLLAREA(self))){ Q7B_EXCEPTION("QScrollArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQScrollArea(self)->widget() );
}

Q7B Q7B_QSCROLLAREA_WIDGETRESIZABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSCROLLAREA(self))){ Q7B_EXCEPTION("QScrollArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQScrollArea(self)->widgetResizable() );
}

void Q7B_QSCROLLAREA_WIDGETRESIZABLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSCROLLAREA(self))){ Q7B_EXCEPTION("QScrollArea expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQScrollArea(self)->setWidgetResizable(Q7B_IDbool(theProperty));
}










void Q7B_QSIGNALMAPPER_MAP(Q7B self, Q7B Sender) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIGNALMAPPER(self))){ Q7B_EXCEPTION("QSignalMapper expected"); return ; }

  if (Q7B_nil(Q7B_QOBJECT(Sender))){ Q7B_EXCEPTION("QObject expected"); return ; }

  Q7B_IDQSignalMapper(self)->map(Q7B_IDQObject(Sender));
}

Q7B Q7B_QSIGNALMAPPER_MAPPING(Q7B self, Q7B theObject) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIGNALMAPPER(self))){ Q7B_EXCEPTION("QSignalMapper expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QOBJECT(theObject))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSignalMapper(self)->mapping(Q7B_IDQObject(theObject)) );
}

void Q7B_QSIGNALMAPPER_REMOVEMAPPINGS(Q7B self, Q7B Sender) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIGNALMAPPER(self))){ Q7B_EXCEPTION("QSignalMapper expected"); return ; }

  if (Q7B_nil(Q7B_QOBJECT(Sender))){ Q7B_EXCEPTION("QObject expected"); return ; }

  Q7B_IDQSignalMapper(self)->removeMappings(Q7B_IDQObject(Sender));
}

void Q7B_QSIGNALMAPPER_SETMAPPING(Q7B self, Q7B Sender, Q7B theObject) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIGNALMAPPER(self))){ Q7B_EXCEPTION("QSignalMapper expected"); return ; }

  if (Q7B_nil(Q7B_QOBJECT(Sender))){ Q7B_EXCEPTION("QObject expected"); return ; }

  if (Q7B_nil(Q7B_QOBJECT(theObject))){ Q7B_EXCEPTION("QObject expected"); return ; }

  Q7B_IDQSignalMapper(self)->setMapping(Q7B_IDQObject(Sender), Q7B_IDQObject(theObject));
}





















Q7B Q7B_QSLIDER_TICKINTERVAL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSLIDER(self))){ Q7B_EXCEPTION("QSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSlider(self)->tickInterval() );
}

void Q7B_QSLIDER_TICKINTERVAL(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSLIDER(self))){ Q7B_EXCEPTION("QSlider expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQSlider(self)->setTickInterval(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QSLIDER_TICKPOSITION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSLIDER(self))){ Q7B_EXCEPTION("QSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSlider(self)->tickPosition() );
}

void Q7B_QSLIDER_TICKPOSITION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSLIDER(self))){ Q7B_EXCEPTION("QSlider expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQSlider(self)->setTickPosition((QSlider::TickPosition) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QSPINBOX_CLEANTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPINBOX(self))){ Q7B_EXCEPTION("QSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSpinBox(self)->cleanText() );
}

void Q7B_QSPINBOX_CLEANTEXT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPINBOX(self))){ Q7B_EXCEPTION("QSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQSpinBox(self)->setProperty("clenText", Q7B_IDQString(theProperty));
}

Q7B Q7B_QSPINBOX_PREFIX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPINBOX(self))){ Q7B_EXCEPTION("QSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSpinBox(self)->prefix() );
}

void Q7B_QSPINBOX_PREFIX(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPINBOX(self))){ Q7B_EXCEPTION("QSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQSpinBox(self)->setPrefix(Q7B_IDQString(theProperty));
}

void Q7B_QSPINBOX_SETRANGE(Q7B self, Q7B Minimum, Q7B Maximum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPINBOX(self))){ Q7B_EXCEPTION("QSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Minimum))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Maximum))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSpinBox(self)->setRange(Q7B_IDqint64(Minimum), Q7B_IDqint64(Maximum));
}

void Q7B_QSPINBOX_SETVALUE(Q7B self, Q7B Val) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPINBOX(self))){ Q7B_EXCEPTION("QSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Val))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSpinBox(self)->setValue(Q7B_IDqint64(Val));
}

Q7B Q7B_QSPINBOX_SINGLESTEP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPINBOX(self))){ Q7B_EXCEPTION("QSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSpinBox(self)->singleStep() );
}

void Q7B_QSPINBOX_SINGLESTEP(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPINBOX(self))){ Q7B_EXCEPTION("QSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQSpinBox(self)->setSingleStep(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QSPINBOX_SUFFIX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPINBOX(self))){ Q7B_EXCEPTION("QSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSpinBox(self)->suffix() );
}

void Q7B_QSPINBOX_SUFFIX(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPINBOX(self))){ Q7B_EXCEPTION("QSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQSpinBox(self)->setSuffix(Q7B_IDQString(theProperty));
}

void Q7B_QSPLASHSCREEN_CLEARMESSAGE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLASHSCREEN(self))){ Q7B_EXCEPTION("QSplashScreen expected"); return ; }

  Q7B_IDQSplashScreen(self)->clearMessage();
}

void Q7B_QSPLASHSCREEN_FINISH(Q7B self, Q7B MainWin) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLASHSCREEN(self))){ Q7B_EXCEPTION("QSplashScreen expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(MainWin))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQSplashScreen(self)->finish(Q7B_IDQWidget(MainWin));
}

Q7B Q7B_QSPLASHSCREEN_PIXMAP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLASHSCREEN(self))){ Q7B_EXCEPTION("QSplashScreen expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplashScreen(self)->pixmap() );
}

void Q7B_QSPLASHSCREEN_REPAINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLASHSCREEN(self))){ Q7B_EXCEPTION("QSplashScreen expected"); return ; }

  Q7B_IDQSplashScreen(self)->repaint();
}

void Q7B_QSPLASHSCREEN_SETPIXMAP(Q7B self, Q7B Pixmap) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLASHSCREEN(self))){ Q7B_EXCEPTION("QSplashScreen expected"); return ; }

  if (Q7B_nil(Q7B_QPIXMAP(Pixmap))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  Q7B_IDQSplashScreen(self)->setPixmap(Q7B_IDQPixmap(Pixmap));
}

void Q7B_QSPLASHSCREEN_SHOWMESSAGE(Q7B self, Q7B Message, Q7B Alignment, Q7B Color) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLASHSCREEN(self))){ Q7B_EXCEPTION("QSplashScreen expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Message))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Alignment))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QCOLOR(Color))){ Q7B_EXCEPTION("QColor expected"); return ; }

  Q7B_IDQSplashScreen(self)->showMessage(Q7B_IDQString(Message), Q7B_IDqint64(Alignment), Q7B_IDQColor(Color));
}

void Q7B_QSPLITTER_ADDWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQSplitter(self)->addWidget(Q7B_IDQWidget(Widget));
}

Q7B Q7B_QSPLITTER_CHILDRENCOLLAPSIBLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitter(self)->childrenCollapsible() );
}

void Q7B_QSPLITTER_CHILDRENCOLLAPSIBLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQSplitter(self)->setChildrenCollapsible(Q7B_IDbool(theProperty));
}

Q7B Q7B_QSPLITTER_COUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitter(self)->count() );
}

Q7B Q7B_QSPLITTER_HANDLE(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitter(self)->handle(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QSPLITTER_HANDLEWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitter(self)->handleWidth() );
}

void Q7B_QSPLITTER_HANDLEWIDTH(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQSplitter(self)->setHandleWidth(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QSPLITTER_INDEXOF(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitter(self)->indexOf(Q7B_IDQWidget(Widget)) );
}

void Q7B_QSPLITTER_INSERTWIDGET(Q7B self, Q7B Index, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQSplitter(self)->insertWidget(Q7B_IDqint64(Index), Q7B_IDQWidget(Widget));
}

Q7B Q7B_QSPLITTER_ISCOLLAPSIBLE(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitter(self)->isCollapsible(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QSPLITTER_OPAQUERESIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitter(self)->opaqueResize() );
}

void Q7B_QSPLITTER_OPAQUERESIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQSplitter(self)->setOpaqueResize(Q7B_IDbool(theProperty));
}

Q7B Q7B_QSPLITTER_ORIENTATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitter(self)->orientation() );
}

void Q7B_QSPLITTER_ORIENTATION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQSplitter(self)->setOrientation((Qt::Orientation) Q7B_IDqint64(theProperty));
}

void Q7B_QSPLITTER_REFRESH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return ; }

  Q7B_IDQSplitter(self)->refresh();
}

Q7B Q7B_QSPLITTER_RESTORESTATE(Q7B self, Q7B State) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(State))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitter(self)->restoreState(Q7B_IDQByteArray(State)) );
}

Q7B Q7B_QSPLITTER_SAVESTATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitter(self)->saveState() );
}

void Q7B_QSPLITTER_SETCOLLAPSIBLE(Q7B self, Q7B Index, Q7B Collapse) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Collapse))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQSplitter(self)->setCollapsible(Q7B_IDqint64(Index), Q7B_IDbool(Collapse));
}

void Q7B_QSPLITTER_SETSIZES(Q7B self, Q7B list) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return ; }

  if (Q7B_nil(Q7B_LIST(list))){ Q7B_EXCEPTION("List expected"); return ; }

  static QList<int> list2; // TODO2 collision with different splitters

  list2.clear();

  for (int i = 0; i < ((Q7B_List *) list->ref)->count(); i++){    
    int n = Q7B_IDqint64(((Q7B_List *) list->ref)->getObject(i));

    list2.append(n);
  }  

  Q7B_IDQSplitter(self)->setSizes(list2);
}

void Q7B_QSPLITTER_SETSTRETCHFACTOR(Q7B self, Q7B Index, Q7B Stretch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Stretch))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSplitter(self)->setStretchFactor(Q7B_IDqint64(Index), Q7B_IDqint64(Stretch));
}

Q7B Q7B_QSPLITTER_SIZES(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return Q7B_idnil; }

  QList<int> o = Q7B_IDQSplitter(self)->sizes();

  Q7B_List *l = new Q7B_List(); 
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), l)); 

  for (int i = 0; i < o.size(); i++){
    qint64 n = (qint64) o.at(i);
    Q7B qq (new Q7B_id(typeid(qint64).name(), new qint64(n))); 
    l->append(qq);
  }

  return q;
}

Q7B Q7B_QSPLITTER_WIDGET(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTER(self))){ Q7B_EXCEPTION("QSplitter expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitter(self)->widget(Q7B_IDqint64(Index)) );
}

void Q7B_QSTATUSBAR_ADDPERMANENTWIDGET(Q7B self, Q7B Widget, Q7B Stretch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTATUSBAR(self))){ Q7B_EXCEPTION("QStatusBar expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Stretch))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQStatusBar(self)->addPermanentWidget(Q7B_IDQWidget(Widget), Q7B_IDqint64(Stretch));
}

void Q7B_QSTATUSBAR_ADDWIDGET(Q7B self, Q7B Widget, Q7B Stretch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTATUSBAR(self))){ Q7B_EXCEPTION("QStatusBar expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Stretch))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQStatusBar(self)->addWidget(Q7B_IDQWidget(Widget), Q7B_IDqint64(Stretch));
}

void Q7B_QSTATUSBAR_CLEARMESSAGE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTATUSBAR(self))){ Q7B_EXCEPTION("QStatusBar expected"); return ; }

  Q7B_IDQStatusBar(self)->clearMessage();
}

Q7B Q7B_QSTATUSBAR_CURRENTMESSAGE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTATUSBAR(self))){ Q7B_EXCEPTION("QStatusBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStatusBar(self)->currentMessage() );
}

Q7B Q7B_QSTATUSBAR_INSERTPERMANENTWIDGET(Q7B self, Q7B Index, Q7B Widget, Q7B Stretch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTATUSBAR(self))){ Q7B_EXCEPTION("QStatusBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Stretch))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStatusBar(self)->insertPermanentWidget(Q7B_IDqint64(Index), Q7B_IDQWidget(Widget), Q7B_IDqint64(Stretch)) );
}

Q7B Q7B_QSTATUSBAR_INSERTWIDGET(Q7B self, Q7B Index, Q7B Widget, Q7B Stretch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTATUSBAR(self))){ Q7B_EXCEPTION("QStatusBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Stretch))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStatusBar(self)->insertWidget(Q7B_IDqint64(Index), Q7B_IDQWidget(Widget), Q7B_IDqint64(Stretch)) );
}

void Q7B_QSTATUSBAR_REMOVEWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTATUSBAR(self))){ Q7B_EXCEPTION("QStatusBar expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQStatusBar(self)->removeWidget(Q7B_IDQWidget(Widget));
}

void Q7B_QSTATUSBAR_SHOWMESSAGE(Q7B self, Q7B Message, Q7B Timeout) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTATUSBAR(self))){ Q7B_EXCEPTION("QStatusBar expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Message))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Timeout))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQStatusBar(self)->showMessage(Q7B_IDQString(Message), Q7B_IDqint64(Timeout));
}

Q7B Q7B_QSTATUSBAR_SIZEGRIPENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTATUSBAR(self))){ Q7B_EXCEPTION("QStatusBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStatusBar(self)->isSizeGripEnabled() );
}

void Q7B_QSTATUSBAR_SIZEGRIPENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTATUSBAR(self))){ Q7B_EXCEPTION("QStatusBar expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQStatusBar(self)->setSizeGripEnabled(Q7B_IDbool(theProperty));
}








Q7B Q7B_QSTRING_APPEND(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).append(Q7B_IDQString(Str)) );
}

Q7B Q7B_QSTRING_APPEND2(Q7B self, Q7B Ch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Ch))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).append(Q7B_IDQChar(Ch)) );
}

Q7B Q7B_QSTRING_ARG(Q7B self, Q7B A, Q7B FieldWidth, Q7B FillChar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(A))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(FieldWidth))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(FillChar))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).arg(Q7B_IDQString(A), Q7B_IDqint64(FieldWidth), Q7B_IDQChar(FillChar)) );
}

Q7B Q7B_QSTRING_ARG2(Q7B self, Q7B A, Q7B FieldWidth, Q7B Base, Q7B FillChar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(A))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(FieldWidth))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Base))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(FillChar))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).arg(Q7B_IDqint64(A), Q7B_IDqint64(FieldWidth), Q7B_IDqint64(Base), Q7B_IDQChar(FillChar)) );
}

Q7B Q7B_QSTRING_ARG3(Q7B self, Q7B A, Q7B FieldWidth, Q7B FillChar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(A))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(FieldWidth))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(FillChar))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).arg(Q7B_IDQChar(A), Q7B_IDqint64(FieldWidth), Q7B_IDQChar(FillChar)) );
}

Q7B Q7B_QSTRING_ARG4(Q7B self, Q7B A, Q7B FieldWidth, Q7B Format, Q7B Precision, Q7B FillChar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREAL(A))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(FieldWidth))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Precision))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(FillChar))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).arg(Q7B_IDqreal(A), Q7B_IDqint64(FieldWidth), Q7B_IDQString(Format).at(0).toAscii(), Q7B_IDqint64(Precision), Q7B_IDQChar(FillChar)) );
}

Q7B Q7B_QSTRING_AT(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).at(Q7B_IDqint64(Position)) );
}

Q7B Q7B_QSTRING_CAPACITY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).capacity() );
}

void Q7B_QSTRING_CHOP(Q7B self, Q7B N) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(N))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQString(self).chop(Q7B_IDqint64(N));
}

void Q7B_QSTRING_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQString(self).clear();
}

Q7B Q7B_QSTRING_COMPARE(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Other))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).compare(Q7B_IDQString(Other)) );
}

Q7B Q7B_QSTRING_COMPARE2(Q7B self, Q7B Other, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Other))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).compare(Q7B_IDQString(Other), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_CONTAINS(Q7B self, Q7B Str, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).contains(Q7B_IDQString(Str), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_CONTAINS2(Q7B self, Q7B Ch, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Ch))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).contains(Q7B_IDQChar(Ch), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}


Q7B Q7B_QSTRING_CONTAINS3 (Q7B self, Q7B Rx) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGEXP(Rx))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).contains(Q7B_IDQRegExp(Rx)) );
}

Q7B Q7B_QSTRING_COUNT(Q7B self, Q7B Str, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).count(Q7B_IDQString(Str), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_COUNT2(Q7B self, Q7B Ch, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Ch))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).count(Q7B_IDQChar(Ch), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_COUNT3(Q7B self, Q7B Rx) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGEXP(Rx))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).count(Q7B_IDQRegExp(Rx)) );
}

Q7B Q7B_QSTRING_COUNT4(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).count() );
}

Q7B Q7B_QSTRING_ENDSWITH(Q7B self, Q7B S, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(S))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).endsWith(Q7B_IDQString(S), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_ENDSWITH2(Q7B self, Q7B C, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(C))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).endsWith(Q7B_IDQChar(C), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_FILL(Q7B self, Q7B Ch, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Ch))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Size))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).fill(Q7B_IDQChar(Ch), Q7B_IDqint64(Size)) );
}

Q7B Q7B_QSTRING_INDEXOF(Q7B self, Q7B Str, Q7B From, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(From))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).indexOf(Q7B_IDQString(Str), Q7B_IDqint64(From), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_INDEXOF2(Q7B self, Q7B Ch, Q7B From, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Ch))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(From))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).indexOf(Q7B_IDQChar(Ch), Q7B_IDqint64(From), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_INDEXOF3(Q7B self, Q7B Rx, Q7B From) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGEXP(Rx))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(From))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).indexOf(Q7B_IDQRegExp(Rx), Q7B_IDqint64(From)) );
}

Q7B Q7B_QSTRING_INSERT(Q7B self, Q7B Position, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).insert(Q7B_IDqint64(Position), Q7B_IDQString(Str)) );
}

Q7B Q7B_QSTRING_INSERT2(Q7B self, Q7B Position, Q7B Ch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Ch))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).insert(Q7B_IDqint64(Position), Q7B_IDQChar(Ch)) );
}

Q7B Q7B_QSTRING_ISEMPTY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).isEmpty() );
}

Q7B Q7B_QSTRING_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).isNull() );
}

Q7B Q7B_QSTRING_ISRIGHTTOLEFT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).isRightToLeft() );
}

Q7B Q7B_QSTRING_LASTINDEXOF(Q7B self, Q7B Str, Q7B From, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(From))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).lastIndexOf(Q7B_IDQString(Str), Q7B_IDqint64(From), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_LASTINDEXOF2(Q7B self, Q7B Ch, Q7B From, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Ch))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(From))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).lastIndexOf(Q7B_IDQChar(Ch), Q7B_IDqint64(From), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_LASTINDEXOF3(Q7B self, Q7B Rx, Q7B From) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGEXP(Rx))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(From))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).lastIndexOf(Q7B_IDQRegExp(Rx), Q7B_IDqint64(From)) );
}

Q7B Q7B_QSTRING_LEFT(Q7B self, Q7B N) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(N))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).left(Q7B_IDqint64(N)) );
}

Q7B Q7B_QSTRING_LEFTJUSTIFIED(Q7B self, Q7B Width, Q7B Fill, Q7B Truncate) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Fill))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Truncate))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).leftJustified(Q7B_IDqint64(Width), Q7B_IDQChar(Fill), Q7B_IDbool(Truncate)) );
}

Q7B Q7B_QSTRING_LENGTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).length() );
}

Q7B Q7B_QSTRING_LOCALEAWARECOMPARE(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Other))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).localeAwareCompare(Q7B_IDQString(Other)) );
}

Q7B Q7B_QSTRING_MID(Q7B self, Q7B Position, Q7B N) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(N))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).mid(Q7B_IDqint64(Position), Q7B_IDqint64(N)) );
}

Q7B Q7B_QSTRING_NORMALIZED(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).normalized((QString::NormalizationForm) Q7B_IDqint64(Mode)) );
}

Q7B Q7B_QSTRING_NORMALIZED2(Q7B self, Q7B Mode, Q7B Version) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Version))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).normalized((QString::NormalizationForm) Q7B_IDqint64(Mode), (QChar::UnicodeVersion) Q7B_IDqint64(Version)) );
}

Q7B Q7B_QSTRING_PREPEND(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).prepend(Q7B_IDQString(Str)) );
}

Q7B Q7B_QSTRING_PREPEND2(Q7B self, Q7B Ch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Ch))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).prepend(Q7B_IDQChar(Ch)) );
}

void Q7B_QSTRING_PUSH_BACK(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Other))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQString(self).push_back(Q7B_IDQString(Other));
}

void Q7B_QSTRING_PUSH_BACK2(Q7B self, Q7B Ch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QCHAR(Ch))){ Q7B_EXCEPTION("QChar expected"); return ; }

  Q7B_IDQString(self).push_back(Q7B_IDQChar(Ch));
}

void Q7B_QSTRING_PUSH_FRONT(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Other))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQString(self).push_front(Q7B_IDQString(Other));
}

void Q7B_QSTRING_PUSH_FRONT2(Q7B self, Q7B Ch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QCHAR(Ch))){ Q7B_EXCEPTION("QChar expected"); return ; }

  Q7B_IDQString(self).push_front(Q7B_IDQChar(Ch));
}

Q7B Q7B_QSTRING_REMOVE(Q7B self, Q7B Position, Q7B N) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(N))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).remove(Q7B_IDqint64(Position), Q7B_IDqint64(N)) );
}

Q7B Q7B_QSTRING_REMOVE2(Q7B self, Q7B Ch, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Ch))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).remove(Q7B_IDQChar(Ch), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_REMOVE3(Q7B self, Q7B Str, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).remove(Q7B_IDQString(Str), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_REMOVE4(Q7B self, Q7B Rx) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGEXP(Rx))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).remove(Q7B_IDQRegExp(Rx)) );
}

Q7B Q7B_QSTRING_REPEATED(Q7B self, Q7B Times) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Times))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).repeated(Q7B_IDqint64(Times)) );
}

Q7B Q7B_QSTRING_REPLACE(Q7B self, Q7B Position, Q7B N, Q7B After) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(N))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(After))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).replace(Q7B_IDqint64(Position), Q7B_IDqint64(N), Q7B_IDQString(After)) );
}

Q7B Q7B_QSTRING_REPLACE2(Q7B self, Q7B Position, Q7B N, Q7B After) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(N))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(After))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).replace(Q7B_IDqint64(Position), Q7B_IDqint64(N), Q7B_IDQChar(After)) );
}

Q7B Q7B_QSTRING_REPLACE3(Q7B self, Q7B Before, Q7B After, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Before))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(After))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).replace(Q7B_IDQString(Before), Q7B_IDQString(After), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_REPLACE4(Q7B self, Q7B Before, Q7B After, Q7B a2) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Before))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(After))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(a2))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).replace(Q7B_IDQChar(Before), Q7B_IDQString(After), (Qt::CaseSensitivity) Q7B_IDqint64(a2)) );
}

Q7B Q7B_QSTRING_REPLACE5(Q7B self, Q7B Before, Q7B After, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Before))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(After))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).replace(Q7B_IDQChar(Before), Q7B_IDQChar(After), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_REPLACE6(Q7B self, Q7B Rx, Q7B After) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGEXP(Rx))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(After))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).replace(Q7B_IDQRegExp(Rx), Q7B_IDQString(After)) );
}

void Q7B_QSTRING_RESERVE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Size))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQString(self).reserve(Q7B_IDqint64(Size));
}

void Q7B_QSTRING_RESIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Size))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQString(self).resize(Q7B_IDqint64(Size));
}

Q7B Q7B_QSTRING_RIGHT(Q7B self, Q7B N) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(N))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).right(Q7B_IDqint64(N)) );
}

Q7B Q7B_QSTRING_RIGHTJUSTIFIED(Q7B self, Q7B Width, Q7B Fill, Q7B Truncate) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Fill))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Truncate))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).rightJustified(Q7B_IDqint64(Width), Q7B_IDQChar(Fill), Q7B_IDbool(Truncate)) );
}

Q7B Q7B_QSTRING_SECTION(Q7B self, Q7B Sep, Q7B Start, Q7B End, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Sep))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Start))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(End))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).section(Q7B_IDQChar(Sep), Q7B_IDqint64(Start), Q7B_IDqint64(End), (QString::SectionFlags) Q7B_IDqint64(Flags)) );
}

Q7B Q7B_QSTRING_SECTION2(Q7B self, Q7B Sep, Q7B Start, Q7B End, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Sep))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Start))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(End))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).section(Q7B_IDQString(Sep), Q7B_IDqint64(Start), Q7B_IDqint64(End), (QString::SectionFlags) Q7B_IDqint64(Flags)) );
}

Q7B Q7B_QSTRING_SECTION3(Q7B self, Q7B Reg, Q7B Start, Q7B End, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGEXP(Reg))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Start))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(End))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).section(Q7B_IDQRegExp(Reg), Q7B_IDqint64(Start), Q7B_IDqint64(End), (QString::SectionFlags) Q7B_IDqint64(Flags)) );
}

Q7B Q7B_QSTRING_SETNUM(Q7B self, Q7B N, Q7B Base) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(N))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Base))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).setNum(Q7B_IDqint64(N), Q7B_IDqint64(Base)) );
}

Q7B Q7B_QSTRING_SETNUM2(Q7B self, Q7B N, Q7B Format, Q7B Precision) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREAL(N))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Precision))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).setNum(Q7B_IDqreal(N), Q7B_IDQString(Format).at(0).toAscii(), Q7B_IDqint64(Precision)) );
}

Q7B Q7B_QSTRING_SIMPLIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).simplified() );
}

Q7B Q7B_QSTRING_SIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).size() );
}

Q7B Q7B_QSTRING_SPLIT(Q7B self, Q7B Sep, Q7B Behavior, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Sep))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Behavior))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).split(Q7B_IDQString(Sep), (QString::SplitBehavior) Q7B_IDqint64(Behavior), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_SPLIT2(Q7B self, Q7B Sep, Q7B Behavior, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(Sep))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Behavior))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).split(Q7B_IDQChar(Sep), (QString::SplitBehavior) Q7B_IDqint64(Behavior), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_SPLIT3(Q7B self, Q7B Rx, Q7B Behavior) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGEXP(Rx))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Behavior))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).split(Q7B_IDQRegExp(Rx), (QString::SplitBehavior) Q7B_IDqint64(Behavior)) );
}

void Q7B_QSTRING_SQUEEZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQString(self).squeeze();
}

Q7B Q7B_QSTRING_STARTSWITH(Q7B self, Q7B S, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(S))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).startsWith(Q7B_IDQString(S), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_STARTSWITH2(Q7B self, Q7B C, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCHAR(C))){ Q7B_EXCEPTION("QChar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).startsWith(Q7B_IDQChar(C), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRING_TOASCII(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).toAscii() );
}

Q7B Q7B_QSTRING_TOCASEFOLDED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).toCaseFolded() );
}

Q7B Q7B_QSTRING_TODOUBLE(Q7B self, Q7B Ok) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Ok))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }


  bool *b = new bool(); *b = false; 
  Q7B q = Q7B_ID( Q7B_IDQString(self).toDouble(b) );
  Ok->ref = b;
/*
  static bool b; b = false;
  Q7B q = Q7B_ID( Q7B_IDQString(self).toDouble(&b) );
  Ok->ref = &b;
  Ok->type = typeid(bool).name();
  */
  return q;
}

Q7B Q7B_QSTRING_TOINT(Q7B self, Q7B Ok, Q7B Base) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Ok))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Base))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }


  bool *b = new bool(); *b = false; 
  Q7B q = Q7B_ID( Q7B_IDQString(self).toInt(b) );
  Ok->ref = b;

  /*
  static bool b; b = false; // = new bool(); *b = false;
  Q7B q = Q7B_ID( Q7B_IDQString(self).toInt(&b) );
  Ok->ref = &b;
  Ok->gc_enabled = false;*/
  //Ok->type = typeid(bool).name();
  return q;
}

Q7B Q7B_QSTRING_TOLATIN1(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).toLatin1() );
}

Q7B Q7B_QSTRING_TOLOCAL8BIT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).toLocal8Bit() );
}

Q7B Q7B_QSTRING_TOLONGLONG(Q7B self, Q7B Ok, Q7B Base) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Ok))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Base))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }


  bool *b = new bool(); *b = false; 
  Q7B q = Q7B_ID( Q7B_IDQString(self).toLongLong(b) );
  Ok->ref = b;
  /*

  static bool b; b = false;
  Q7B q = Q7B_ID( Q7B_IDQString(self).toLongLong(&b) );
  Ok->ref = &b;
  Ok->type = typeid(bool).name();
  */
  return q;
}

Q7B Q7B_QSTRING_TOLOWER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).toLower() );
}

Q7B Q7B_QSTRING_TOUPPER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).toUpper() );
}

Q7B Q7B_QSTRING_TOUTF8(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).toUtf8() );
}

Q7B Q7B_QSTRING_TRIMMED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).trimmed() );
}

void Q7B_QSTRING_TRUNCATE(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQString(self).truncate(Q7B_IDqint64(Position));
}








void Q7B_QSVGWIDGET_LOAD(Q7B self, Q7B Contents) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSVGWIDGET(self))){ Q7B_EXCEPTION("QSvgWidget expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Contents))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQSvgWidget(self)->load(Q7B_IDQByteArray(Contents));
}

Q7B Q7B_QSYNTAXHIGHLIGHTER_DOCUMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSYNTAXHIGHLIGHTER(self))){ Q7B_EXCEPTION("QSyntaxHighlighter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSyntaxHighlighter(self)->document() );
}

void Q7B_QSYNTAXHIGHLIGHTER_REHIGHLIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSYNTAXHIGHLIGHTER(self))){ Q7B_EXCEPTION("QSyntaxHighlighter expected"); return ; }

  Q7B_IDQSyntaxHighlighter(self)->rehighlight();
}


void Q7B_QSYNTAXHIGHLIGHTER_REHIGHLIGHTBLOCK(Q7B self, Q7B Block) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSYNTAXHIGHLIGHTER(self))){ Q7B_EXCEPTION("QSyntaxHighlighter expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTBLOCK(Block))){ Q7B_EXCEPTION("QTextBlock expected"); return ; }

  Q7B_IDQSyntaxHighlighter(self)->rehighlightBlock(Q7B_IDQTextBlock(Block));
}

void Q7B_QSYNTAXHIGHLIGHTER_SETDOCUMENT(Q7B self, Q7B Doc) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSYNTAXHIGHLIGHTER(self))){ Q7B_EXCEPTION("QSyntaxHighlighter expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTDOCUMENT(Doc))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  Q7B_IDQSyntaxHighlighter(self)->setDocument(Q7B_IDQTextDocument(Doc));
}

Q7B Q7B_QTABBAR_ADDTAB(Q7B self, Q7B Icon, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->addTab(Q7B_IDQIcon(Icon), Q7B_IDQString(Text)) );
}

Q7B Q7B_QTABBAR_COUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->count() );
}


void Q7B_QTABBAR_COUNT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQTabBar(self)->setProperty("count", Q7B_IDqint64(theProperty));
}

Q7B Q7B_QTABBAR_CURRENTINDEX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->currentIndex() );
}

void Q7B_QTABBAR_CURRENTINDEX(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQTabBar(self)->setCurrentIndex(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QTABBAR_DOCUMENTMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->documentMode() );
}

void Q7B_QTABBAR_DOCUMENTMODE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTabBar(self)->setDocumentMode(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTABBAR_DRAWBASE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->drawBase() );
}

void Q7B_QTABBAR_DRAWBASE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTabBar(self)->setDrawBase(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTABBAR_ELIDEMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->elideMode() );
}

void Q7B_QTABBAR_ELIDEMODE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQTabBar(self)->setElideMode((Qt::TextElideMode) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QTABBAR_EXPANDING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->expanding() );
}

void Q7B_QTABBAR_EXPANDING(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTabBar(self)->setExpanding(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTABBAR_ICONSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->iconSize() );
}

void Q7B_QTABBAR_ICONSIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  Q7B_IDQTabBar(self)->setIconSize(Q7B_IDQSize(theProperty));
}

Q7B Q7B_QTABBAR_INSERTTAB(Q7B self, Q7B Index, Q7B Icon, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->insertTab(Q7B_IDqint64(Index), Q7B_IDQIcon(Icon), Q7B_IDQString(Text)) );
}

Q7B Q7B_QTABBAR_ISTABENABLED(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->isTabEnabled(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTABBAR_MOVABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->isMovable() );
}

void Q7B_QTABBAR_MOVABLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTabBar(self)->setMovable(Q7B_IDbool(theProperty));
}

void Q7B_QTABBAR_MOVETAB(Q7B self, Q7B FromTab, Q7B ToTab) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(FromTab))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(ToTab))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTabBar(self)->moveTab(Q7B_IDqint64(FromTab), Q7B_IDqint64(ToTab));
}

void Q7B_QTABBAR_REMOVETAB(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTabBar(self)->removeTab(Q7B_IDqint64(Index));
}

Q7B Q7B_QTABBAR_SELECTIONBEHAVIORONREMOVE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->selectionBehaviorOnRemove() );
}

void Q7B_QTABBAR_SELECTIONBEHAVIORONREMOVE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQTabBar(self)->setSelectionBehaviorOnRemove((QTabBar::SelectionBehavior) Q7B_IDqint64(theProperty));
}

void Q7B_QTABBAR_SETCURRENTINDEX(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTabBar(self)->setCurrentIndex(Q7B_IDqint64(Index));
}

void Q7B_QTABBAR_SETTABBUTTON(Q7B self, Q7B Index, Q7B Position, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQTabBar(self)->setTabButton(Q7B_IDqint64(Index), (QTabBar::ButtonPosition) Q7B_IDqint64(Position), Q7B_IDQWidget(Widget));
}

void Q7B_QTABBAR_SETTABDATA(Q7B self, Q7B Index, Q7B Data) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QVARIANT(Data))){ Q7B_EXCEPTION("QVariant expected"); return ; }

  Q7B_IDQTabBar(self)->setTabData(Q7B_IDqint64(Index), Q7B_IDQVariant(Data));
}

void Q7B_QTABBAR_SETTABENABLED(Q7B self, Q7B Index, Q7B Enabled) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enabled))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTabBar(self)->setTabEnabled(Q7B_IDqint64(Index), Q7B_IDbool(Enabled));
}

void Q7B_QTABBAR_SETTABICON(Q7B self, Q7B Index, Q7B Icon) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  Q7B_IDQTabBar(self)->setTabIcon(Q7B_IDqint64(Index), Q7B_IDQIcon(Icon));
}

void Q7B_QTABBAR_SETTABTEXT(Q7B self, Q7B Index, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTabBar(self)->setTabText(Q7B_IDqint64(Index), Q7B_IDQString(Text));
}

void Q7B_QTABBAR_SETTABTEXTCOLOR(Q7B self, Q7B Index, Q7B Color) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QCOLOR(Color))){ Q7B_EXCEPTION("QColor expected"); return ; }

  Q7B_IDQTabBar(self)->setTabTextColor(Q7B_IDqint64(Index), Q7B_IDQColor(Color));
}

void Q7B_QTABBAR_SETTABTOOLTIP(Q7B self, Q7B Index, Q7B Tip) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Tip))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTabBar(self)->setTabToolTip(Q7B_IDqint64(Index), Q7B_IDQString(Tip));
}

void Q7B_QTABBAR_SETTABWHATSTHIS(Q7B self, Q7B Index, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTabBar(self)->setTabWhatsThis(Q7B_IDqint64(Index), Q7B_IDQString(Text));
}

Q7B Q7B_QTABBAR_SHAPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->shape() );
}

void Q7B_QTABBAR_SHAPE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQTabBar(self)->setShape((QTabBar::Shape) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QTABBAR_TABAT(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->tabAt(Q7B_IDQPoint(Position)) );
}

Q7B Q7B_QTABBAR_TABBUTTON(Q7B self, Q7B Index, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->tabButton(Q7B_IDqint64(Index), (QTabBar::ButtonPosition) Q7B_IDqint64(Position)) );
}

Q7B Q7B_QTABBAR_TABDATA(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->tabData(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTABBAR_TABICON(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->tabIcon(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTABBAR_TABRECT(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->tabRect(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTABBAR_TABTEXT(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->tabText(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTABBAR_TABTEXTCOLOR(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->tabTextColor(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTABBAR_TABTOOLTIP(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->tabToolTip(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTABBAR_TABWHATSTHIS(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->tabWhatsThis(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTABBAR_TABSCLOSABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->tabsClosable() );
}

void Q7B_QTABBAR_TABSCLOSABLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTabBar(self)->setTabsClosable(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTABBAR_USESSCROLLBUTTONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabBar(self)->usesScrollButtons() );
}

void Q7B_QTABBAR_USESSCROLLBUTTONS(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABBAR(self))){ Q7B_EXCEPTION("QTabBar expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTabBar(self)->setUsesScrollButtons(Q7B_IDbool(theProperty));
}

void Q7B_QTHREAD_EXIT(Q7B self, Q7B ReturnCode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTHREAD(self))){ Q7B_EXCEPTION("QThread expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(ReturnCode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQThread(self)->exit(Q7B_IDqint64(ReturnCode));
}

Q7B Q7B_QTHREAD_ISFINISHED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTHREAD(self))){ Q7B_EXCEPTION("QThread expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQThread(self)->isFinished() );
}

Q7B Q7B_QTHREAD_ISRUNNING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTHREAD(self))){ Q7B_EXCEPTION("QThread expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQThread(self)->isRunning() );
}

Q7B Q7B_QTHREAD_PRIORITY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTHREAD(self))){ Q7B_EXCEPTION("QThread expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQThread(self)->priority() );
}

void Q7B_QTHREAD_QUIT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTHREAD(self))){ Q7B_EXCEPTION("QThread expected"); return ; }

  Q7B_IDQThread(self)->quit();
}

void Q7B_QTHREAD_SETPRIORITY(Q7B self, Q7B Priority) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTHREAD(self))){ Q7B_EXCEPTION("QThread expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Priority))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQThread(self)->setPriority((QThread::Priority) Q7B_IDqint64(Priority));
}

void Q7B_QTHREAD_SETSTACKSIZE(Q7B self, Q7B StackSize) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTHREAD(self))){ Q7B_EXCEPTION("QThread expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(StackSize))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQThread(self)->setStackSize(Q7B_IDqint64(StackSize));
}

Q7B Q7B_QTHREAD_STACKSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTHREAD(self))){ Q7B_EXCEPTION("QThread expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQThread(self)->stackSize() );
}

void Q7B_QTHREAD_START(Q7B self, Q7B Priority) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTHREAD(self))){ Q7B_EXCEPTION("QThread expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Priority))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQThread(self)->start((QThread::Priority) Q7B_IDqint64(Priority));
}

void Q7B_QTHREAD_TERMINATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTHREAD(self))){ Q7B_EXCEPTION("QThread expected"); return ; }

  Q7B_IDQThread(self)->terminate();
}

Q7B Q7B_QTHREAD_WAIT(Q7B self, Q7B Time) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTHREAD(self))){ Q7B_EXCEPTION("QThread expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Time))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQThread(self)->wait(Q7B_IDqint64(Time)) );
}













Q7B Q7B_QTIME_ADDMSECS(Q7B self, Q7B Ms) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Ms))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).addMSecs(Q7B_IDqint64(Ms)) );
}

Q7B Q7B_QTIME_ADDSECS(Q7B self, Q7B S) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(S))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).addSecs(Q7B_IDqint64(S)) );
}

Q7B Q7B_QTIME_ELAPSED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).elapsed() );
}

Q7B Q7B_QTIME_HOUR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).hour() );
}

Q7B Q7B_QTIME_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).isNull() );
}

Q7B Q7B_QTIME_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).isValid() );
}

Q7B Q7B_QTIME_MINUTE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).minute() );
}

Q7B Q7B_QTIME_MSEC(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).msec() );
}

Q7B Q7B_QTIME_MSECSTO(Q7B self, Q7B T) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTIME(T))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).msecsTo(Q7B_IDQTime(T)) );
}

Q7B Q7B_QTIME_RESTART(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).restart() );
}

Q7B Q7B_QTIME_SECOND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).second() );
}

Q7B Q7B_QTIME_SECSTO(Q7B self, Q7B T) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTIME(T))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).secsTo(Q7B_IDQTime(T)) );
}

Q7B Q7B_QTIME_SETHMS(Q7B self, Q7B H, Q7B M, Q7B S, Q7B Ms) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(H))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(M))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(S))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Ms))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).setHMS(Q7B_IDqint64(H), Q7B_IDqint64(M), Q7B_IDqint64(S), Q7B_IDqint64(Ms)) );
}

void Q7B_QTIME_START(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return ; }

  Q7B_IDQTime(self).start();
}

Q7B Q7B_QTIME_TOSTRING(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIME(self))){ Q7B_EXCEPTION("QTime expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTime(self).toString(Q7B_IDQString(Format)) );
}

Q7B Q7B_QTIMER_ACTIVE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMER(self))){ Q7B_EXCEPTION("QTimer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimer(self)->isActive() );
}

void Q7B_QTIMER_ACTIVE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMER(self))){ Q7B_EXCEPTION("QTimer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTimer(self)->setProperty("active", Q7B_IDbool(theProperty));
}

Q7B Q7B_QTIMER_INTERVAL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMER(self))){ Q7B_EXCEPTION("QTimer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimer(self)->interval() );
}

void Q7B_QTIMER_INTERVAL(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMER(self))){ Q7B_EXCEPTION("QTimer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQTimer(self)->setInterval(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QTIMER_SINGLESHOT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMER(self))){ Q7B_EXCEPTION("QTimer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimer(self)->isSingleShot() );
}

void Q7B_QTIMER_SINGLESHOT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMER(self))){ Q7B_EXCEPTION("QTimer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTimer(self)->setSingleShot(Q7B_IDbool(theProperty));
}

void Q7B_QTIMER_START(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMER(self))){ Q7B_EXCEPTION("QTimer expected"); return ; }

  Q7B_IDQTimer(self)->start();
}

void Q7B_QTIMER_START2(Q7B self, Q7B Msec) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMER(self))){ Q7B_EXCEPTION("QTimer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Msec))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTimer(self)->start(Q7B_IDqint64(Msec));
}

void Q7B_QTIMER_STOP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMER(self))){ Q7B_EXCEPTION("QTimer expected"); return ; }

  Q7B_IDQTimer(self)->stop();
}

Q7B Q7B_QTOOLBAR_ACTIONAT(Q7B self, Q7B P) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(P))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->actionAt(Q7B_IDQPoint(P)) );
}

Q7B Q7B_QTOOLBAR_ACTIONAT2(Q7B self, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->actionAt(Q7B_IDqint64(X), Q7B_IDqint64(Y)) );
}

void Q7B_QTOOLBAR_ADDACTION(Q7B self, Q7B Action) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  if (Q7B_nil(Q7B_QACTION(Action))){ Q7B_EXCEPTION("QAction expected"); return ; }

  Q7B_IDQToolBar(self)->addAction(Q7B_IDQAction(Action));
}

Q7B Q7B_QTOOLBAR_ADDACTION2(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->addAction(Q7B_IDQString(Text)) );
}

Q7B Q7B_QTOOLBAR_ADDACTION3(Q7B self, Q7B Icon, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->addAction(Q7B_IDQIcon(Icon), Q7B_IDQString(Text)) );
}

Q7B Q7B_QTOOLBAR_ADDACTION4(Q7B self, Q7B Text, Q7B Receiver, Q7B Member) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QOBJECT(Receiver))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Member))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->addAction(Q7B_IDQString(Text), Q7B_IDQObject(Receiver), Q7B_IDQString(Member).toAscii().constData()) );
}

Q7B Q7B_QTOOLBAR_ADDACTION5(Q7B self, Q7B Icon, Q7B Text, Q7B Receiver, Q7B Member) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QOBJECT(Receiver))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Member))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->addAction(Q7B_IDQIcon(Icon), Q7B_IDQString(Text), Q7B_IDQObject(Receiver), Q7B_IDQString(Member).toAscii().constData()) );
}

Q7B Q7B_QTOOLBAR_ADDSEPARATOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->addSeparator() );
}

Q7B Q7B_QTOOLBAR_ADDWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->addWidget(Q7B_IDQWidget(Widget)) );
}

Q7B Q7B_QTOOLBAR_ALLOWEDAREAS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->allowedAreas() );
}

void Q7B_QTOOLBAR_ALLOWEDAREAS(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQToolBar(self)->setAllowedAreas((Qt::ToolBarAreas) Q7B_IDqint64(theProperty));
}

void Q7B_QTOOLBAR_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  Q7B_IDQToolBar(self)->clear();
}

Q7B Q7B_QTOOLBAR_FLOATABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->isFloatable() );
}

void Q7B_QTOOLBAR_FLOATABLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQToolBar(self)->setFloatable(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTOOLBAR_FLOATING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->isFloating() );
}

void Q7B_QTOOLBAR_FLOATING(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQToolBar(self)->setProperty("floating", Q7B_IDbool(theProperty));
}

Q7B Q7B_QTOOLBAR_ICONSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->iconSize() );
}

void Q7B_QTOOLBAR_ICONSIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  Q7B_IDQToolBar(self)->setIconSize(Q7B_IDQSize(theProperty));
}

Q7B Q7B_QTOOLBAR_INSERTSEPARATOR(Q7B self, Q7B Before) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(Before))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->insertSeparator(Q7B_IDQAction(Before)) );
}

Q7B Q7B_QTOOLBAR_INSERTWIDGET(Q7B self, Q7B Before, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(Before))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->insertWidget(Q7B_IDQAction(Before), Q7B_IDQWidget(Widget)) );
}

Q7B Q7B_QTOOLBAR_ISAREAALLOWED(Q7B self, Q7B Area) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Area))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->isAreaAllowed((Qt::ToolBarArea) Q7B_IDqint64(Area)) );
}

Q7B Q7B_QTOOLBAR_MOVABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->isMovable() );
}

void Q7B_QTOOLBAR_MOVABLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQToolBar(self)->setMovable(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTOOLBAR_ORIENTATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->orientation() );
}

void Q7B_QTOOLBAR_ORIENTATION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQToolBar(self)->setOrientation((Qt::Orientation) Q7B_IDqint64(theProperty));
}

void Q7B_QTOOLBAR_SETICONSIZE(Q7B self, Q7B IconSize) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(IconSize))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQToolBar(self)->setIconSize(Q7B_IDQSize(IconSize));
}

void Q7B_QTOOLBAR_SETTOOLBUTTONSTYLE(Q7B self, Q7B ToolButtonStyle) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(ToolButtonStyle))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQToolBar(self)->setToolButtonStyle((Qt::ToolButtonStyle) Q7B_IDqint64(ToolButtonStyle));
}

Q7B Q7B_QTOOLBAR_TOGGLEVIEWACTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->toggleViewAction() );
}

Q7B Q7B_QTOOLBAR_TOOLBUTTONSTYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->toolButtonStyle() );
}

void Q7B_QTOOLBAR_TOOLBUTTONSTYLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQToolBar(self)->setToolButtonStyle((Qt::ToolButtonStyle) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QTOOLBAR_WIDGETFORACTION(Q7B self, Q7B Action) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBAR(self))){ Q7B_EXCEPTION("QToolBar expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(Action))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBar(self)->widgetForAction(Q7B_IDQAction(Action)) );
}

Q7B Q7B_QTOOLBOX_ADDITEM(Q7B self, Q7B Widget, Q7B IconSet, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QICON(IconSet))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBox(self)->addItem(Q7B_IDQWidget(Widget), Q7B_IDQIcon(IconSet), Q7B_IDQString(Text)) );
}

Q7B Q7B_QTOOLBOX_ADDITEM2(Q7B self, Q7B W, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(W))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBox(self)->addItem(Q7B_IDQWidget(W), Q7B_IDQString(Text)) );
}

Q7B Q7B_QTOOLBOX_COUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBox(self)->count() );
}

void Q7B_QTOOLBOX_COUNT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQToolBox(self)->setProperty("count", Q7B_IDqint64(theProperty));
}

Q7B Q7B_QTOOLBOX_CURRENTWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBox(self)->currentWidget() );
}

Q7B Q7B_QTOOLBOX_INDEXOF(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBox(self)->indexOf(Q7B_IDQWidget(Widget)) );
}

Q7B Q7B_QTOOLBOX_INSERTITEM(Q7B self, Q7B Index, Q7B Widget, Q7B Icon, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBox(self)->insertItem(Q7B_IDqint64(Index), Q7B_IDQWidget(Widget), Q7B_IDQIcon(Icon), Q7B_IDQString(Text)) );
}

Q7B Q7B_QTOOLBOX_INSERTITEM2(Q7B self, Q7B Index, Q7B Widget, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBox(self)->insertItem(Q7B_IDqint64(Index), Q7B_IDQWidget(Widget), Q7B_IDQString(Text)) );
}

Q7B Q7B_QTOOLBOX_ISITEMENABLED(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBox(self)->isItemEnabled(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTOOLBOX_ITEMICON(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBox(self)->itemIcon(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTOOLBOX_ITEMTEXT(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBox(self)->itemText(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTOOLBOX_ITEMTOOLTIP(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBox(self)->itemToolTip(Q7B_IDqint64(Index)) );
}

void Q7B_QTOOLBOX_REMOVEITEM(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQToolBox(self)->removeItem(Q7B_IDqint64(Index));
}

void Q7B_QTOOLBOX_SETCURRENTINDEX(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQToolBox(self)->setCurrentIndex(Q7B_IDqint64(Index));
}

void Q7B_QTOOLBOX_SETCURRENTWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQToolBox(self)->setCurrentWidget(Q7B_IDQWidget(Widget));
}

void Q7B_QTOOLBOX_SETITEMENABLED(Q7B self, Q7B Index, Q7B Enabled) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enabled))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQToolBox(self)->setItemEnabled(Q7B_IDqint64(Index), Q7B_IDbool(Enabled));
}

void Q7B_QTOOLBOX_SETITEMICON(Q7B self, Q7B Index, Q7B Icon) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  Q7B_IDQToolBox(self)->setItemIcon(Q7B_IDqint64(Index), Q7B_IDQIcon(Icon));
}

void Q7B_QTOOLBOX_SETITEMTEXT(Q7B self, Q7B Index, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQToolBox(self)->setItemText(Q7B_IDqint64(Index), Q7B_IDQString(Text));
}

void Q7B_QTOOLBOX_SETITEMTOOLTIP(Q7B self, Q7B Index, Q7B ToolTip) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(ToolTip))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQToolBox(self)->setItemToolTip(Q7B_IDqint64(Index), Q7B_IDQString(ToolTip));
}

Q7B Q7B_QTOOLBOX_WIDGET(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBOX(self))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolBox(self)->widget(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTOOLBUTTON_ARROWTYPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBUTTON(self))){ Q7B_EXCEPTION("QToolButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolButton(self)->arrowType() );
}

void Q7B_QTOOLBUTTON_ARROWTYPE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBUTTON(self))){ Q7B_EXCEPTION("QToolButton expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQToolButton(self)->setArrowType((Qt::ArrowType) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QTOOLBUTTON_AUTORAISE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBUTTON(self))){ Q7B_EXCEPTION("QToolButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolButton(self)->autoRaise() );
}

void Q7B_QTOOLBUTTON_AUTORAISE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBUTTON(self))){ Q7B_EXCEPTION("QToolButton expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQToolButton(self)->setAutoRaise(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTOOLBUTTON_DEFAULTACTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBUTTON(self))){ Q7B_EXCEPTION("QToolButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolButton(self)->defaultAction() );
}

Q7B Q7B_QTOOLBUTTON_POPUPMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBUTTON(self))){ Q7B_EXCEPTION("QToolButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolButton(self)->popupMode() );
}

void Q7B_QTOOLBUTTON_POPUPMODE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBUTTON(self))){ Q7B_EXCEPTION("QToolButton expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQToolButton(self)->setPopupMode((QToolButton::ToolButtonPopupMode) Q7B_IDqint64(theProperty));
}

void Q7B_QTOOLBUTTON_SETDEFAULTACTION(Q7B self, Q7B Action) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBUTTON(self))){ Q7B_EXCEPTION("QToolButton expected"); return ; }

  if (Q7B_nil(Q7B_QACTION(Action))){ Q7B_EXCEPTION("QAction expected"); return ; }

  Q7B_IDQToolButton(self)->setDefaultAction(Q7B_IDQAction(Action));
}

void Q7B_QTOOLBUTTON_SETMENU(Q7B self, Q7B Menu) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBUTTON(self))){ Q7B_EXCEPTION("QToolButton expected"); return ; }

  if (Q7B_nil(Q7B_QMENU(Menu))){ Q7B_EXCEPTION("QMenu expected"); return ; }

  Q7B_IDQToolButton(self)->setMenu(Q7B_IDQMenu(Menu));
}

void Q7B_QTOOLBUTTON_SETTOOLBUTTONSTYLE(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBUTTON(self))){ Q7B_EXCEPTION("QToolButton expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQToolButton(self)->setToolButtonStyle((Qt::ToolButtonStyle) Q7B_IDqint64(Style));
}

Q7B Q7B_QTOOLBUTTON_TOOLBUTTONSTYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTOOLBUTTON(self))){ Q7B_EXCEPTION("QToolButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQToolButton(self)->toolButtonStyle() );
}

void Q7B_QTOOLBUTTON_TOOLBUTTONSTYLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTOOLBUTTON(self))){ Q7B_EXCEPTION("QToolButton expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQToolButton(self)->setToolButtonStyle((Qt::ToolButtonStyle) Q7B_IDqint64(theProperty));
}















void Q7B_QTREEWIDGET_ADDTOPLEVELITEM(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return ; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  Q7B_IDQTreeWidget(self)->addTopLevelItem(&Q7B_IDQTreeWidgetItem(Item));
}

void Q7B_QTREEWIDGET_ADDTOPLEVELITEMS(Q7B self, Q7B Items) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Items))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  static QList<QTreeWidgetItem*> list2; // TODO2 collision with different splitters

  list2.clear();

  for (int i = 0; i < ((Q7B_List *) Items->ref)->count(); i++){    
    QTreeWidgetItem *it = &(Q7B_IDQTreeWidgetItem(((Q7B_List *) Items->ref)->getObject(i)));

    list2.append(it);
  }  

  Q7B_IDQTreeWidget(self)->addTopLevelItems(list2);
}

void Q7B_QTREEWIDGET_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return ; }

  Q7B_IDQTreeWidget(self)->clear();
}

void Q7B_QTREEWIDGET_COLUMNCOUNT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQTreeWidget(self)->setColumnCount(Q7B_IDqint64(theProperty));
}

void Q7B_QTREEWIDGET_INSERTTOPLEVELITEM(Q7B self, Q7B Index, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  Q7B_IDQTreeWidget(self)->insertTopLevelItem(Q7B_IDqint64(Index), &Q7B_IDQTreeWidgetItem(Item));
}

void Q7B_QTREEWIDGET_INSERTTOPLEVELITEMS(Q7B self, Q7B Index, Q7B Items) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Items))){ Q7B_EXCEPTION("QStringList expected"); return ; }


  static QList<QTreeWidgetItem*> list2; // TODO2 collision with different splitters

  list2.clear();

  for (int i = 0; i < ((Q7B_List *) Items->ref)->count(); i++){    
    QTreeWidgetItem *it = &(Q7B_IDQTreeWidgetItem(((Q7B_List *) Items->ref)->getObject(i)));

    list2.append(it);
  }  

  Q7B_IDQTreeWidget(self)->insertTopLevelItems(Q7B_IDqint64(Index), list2);
}

Q7B Q7B_QTREEWIDGET_ISFIRSTITEMCOLUMNSPANNED(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidget(self)->isFirstItemColumnSpanned(&Q7B_IDQTreeWidgetItem(Item)) );
}

Q7B Q7B_QTREEWIDGET_ITEMABOVE(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidget(self)->itemAbove(&Q7B_IDQTreeWidgetItem(Item)) );
}

Q7B Q7B_QTREEWIDGET_ITEMAT2(Q7B self, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidget(self)->itemAt(Q7B_IDqint64(X), Q7B_IDqint64(Y)) );
}

Q7B Q7B_QTREEWIDGET_ITEMBELOW(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidget(self)->itemBelow(&Q7B_IDQTreeWidgetItem(Item)) );
}

Q7B Q7B_QTREEWIDGET_ITEMWIDGET(Q7B self, Q7B Item, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidget(self)->itemWidget(&Q7B_IDQTreeWidgetItem(Item), Q7B_IDqint64(Column)) );
}

void Q7B_QTREEWIDGET_REMOVEITEMWIDGET (Q7B self, Q7B Item, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return ; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeWidget(self)->removeItemWidget (&Q7B_IDQTreeWidgetItem(Item), Q7B_IDqint64(Column));
}

void Q7B_QTREEWIDGET_SETCURRENTITEM3(Q7B self, Q7B Item, Q7B Column, Q7B Command) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return ; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Command))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeWidget(self)->setCurrentItem(&Q7B_IDQTreeWidgetItem(Item), Q7B_IDqint64(Column), (QItemSelectionModel::SelectionFlags) Q7B_IDqint64(Command));
}

void Q7B_QTREEWIDGET_SETFIRSTITEMCOLUMNSPANNED(Q7B self, Q7B Item, Q7B Span) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return ; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Span))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeWidget(self)->setFirstItemColumnSpanned(&Q7B_IDQTreeWidgetItem(Item), Q7B_IDbool(Span));
}

void Q7B_QTREEWIDGET_SETHEADERITEM(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return ; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  Q7B_IDQTreeWidget(self)->setHeaderItem(&Q7B_IDQTreeWidgetItem(Item));
}

void Q7B_QTREEWIDGET_SETHEADERLABELS(Q7B self, Q7B Labels) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Labels))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQTreeWidget(self)->setHeaderLabels(Q7B_IDQStringList(Labels));
}

void Q7B_QTREEWIDGET_SETITEMWIDGET(Q7B self, Q7B Iteam, Q7B Column, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return ; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Iteam))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQTreeWidget(self)->setItemWidget(&Q7B_IDQTreeWidgetItem(Iteam), Q7B_IDqint64(Column), Q7B_IDQWidget(Widget));
}

Q7B Q7B_QTREEWIDGET_TAKETOPLEVELITEM(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidget(self)->takeTopLevelItem(Q7B_IDqint64(Index)) );
}

void Q7B_QTREEWIDGET_TOPLEVELITEMCOUNT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQTreeWidget(self)->setProperty("topLevelItemCount", Q7B_IDqint64(theProperty));
}

Q7B Q7B_QTREEWIDGET_VISUALITEMRECT(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGET(self))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidget(self)->visualItemRect(&Q7B_IDQTreeWidgetItem(Item)) );
}

Q7B Q7B_QWEBPAGE_BYTESRECEIVED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->bytesReceived() );
}

Q7B Q7B_QWEBPAGE_CONTENTEDITABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->isContentEditable() );
}

void Q7B_QWEBPAGE_CONTENTEDITABLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQWebPage(self)->setContentEditable(Q7B_IDbool(theProperty));
}

Q7B Q7B_QWEBPAGE_CURRENTFRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->currentFrame() );
}

Q7B Q7B_QWEBPAGE_FINDTEXT(Q7B self, Q7B SubString, Q7B Options) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(SubString))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Options))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->findText(Q7B_IDQString(SubString), (QWebPage::FindFlags) Q7B_IDqint64(Options)) );
}

Q7B Q7B_QWEBPAGE_FOCUSNEXTPREVCHILD(Q7B self, Q7B Next) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Next))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->focusNextPrevChild(Q7B_IDbool(Next)) );
}

Q7B Q7B_QWEBPAGE_FORWARDUNSUPPORTEDCONTENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->forwardUnsupportedContent() );
}

void Q7B_QWEBPAGE_FORWARDUNSUPPORTEDCONTENT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQWebPage(self)->setForwardUnsupportedContent(Q7B_IDbool(theProperty));
}

Q7B Q7B_QWEBPAGE_FRAMEAT(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Pos))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->frameAt(Q7B_IDQPoint(Pos)) );
}

Q7B Q7B_QWEBPAGE_HISTORY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->history() );
}

Q7B Q7B_QWEBPAGE_LINKDELEGATIONPOLICY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->linkDelegationPolicy() );
}

void Q7B_QWEBPAGE_LINKDELEGATIONPOLICY(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQWebPage(self)->setLinkDelegationPolicy((QWebPage::LinkDelegationPolicy) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QWEBPAGE_MAINFRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->mainFrame() );
}

Q7B Q7B_QWEBPAGE_MODIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->isModified() );
}

void Q7B_QWEBPAGE_MODIFIED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQWebPage(self)->setProperty("modified", Q7B_IDbool(theProperty));
}

Q7B Q7B_QWEBPAGE_PALETTE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->palette() );
}

void Q7B_QWEBPAGE_PALETTE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return ; }

  if (Q7B_nil(Q7B_QPALETTE(theProperty))){ Q7B_EXCEPTION("QPalette expected"); return; }

  Q7B_IDQWebPage(self)->setPalette(Q7B_IDQPalette(theProperty));
}

Q7B Q7B_QWEBPAGE_PREFERREDCONTENTSSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->preferredContentsSize() );
}

void Q7B_QWEBPAGE_PREFERREDCONTENTSSIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  Q7B_IDQWebPage(self)->setPreferredContentsSize(Q7B_IDQSize(theProperty));
}

Q7B Q7B_QWEBPAGE_SELECTEDTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->selectedText() );
}

void Q7B_QWEBPAGE_SELECTEDTEXT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQWebPage(self)->setProperty("selectedText", Q7B_IDQString(theProperty));
}

void Q7B_QWEBPAGE_SETVIEW(Q7B self, Q7B View) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(View))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWebPage(self)->setView(Q7B_IDQWidget(View));
}

void Q7B_QWEBPAGE_SETVIEWPORTSIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQWebPage(self)->setViewportSize(Q7B_IDQSize(Size));
}

Q7B Q7B_QWEBPAGE_SETTINGS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->settings() );
}

Q7B Q7B_QWEBPAGE_SHOULDINTERRUPTJAVASCRIPT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->shouldInterruptJavaScript() );
}

Q7B Q7B_QWEBPAGE_SWALLOWCONTEXTMENUEVENT(Q7B self, Q7B Event) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCONTEXTMENUEVENT(Event))){ Q7B_EXCEPTION("QContextMenuEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->swallowContextMenuEvent(&Q7B_IDQContextMenuEvent(Event)) );
}

Q7B Q7B_QWEBPAGE_TOTALBYTES(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->totalBytes() );
}

void Q7B_QWEBPAGE_UPDATEPOSITIONDEPENDENTACTIONS(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Pos))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQWebPage(self)->updatePositionDependentActions(Q7B_IDQPoint(Pos));
}

Q7B Q7B_QWEBPAGE_VIEW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->view() );
}

Q7B Q7B_QWEBPAGE_VIEWPORTSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebPage(self)->viewportSize() );
}

void Q7B_QWEBPAGE_VIEWPORTSIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBPAGE(self))){ Q7B_EXCEPTION("QWebPage expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  Q7B_IDQWebPage(self)->setViewportSize(Q7B_IDQSize(theProperty));
}




















Q7B Q7B_QWIDGET_ACCEPTDROPS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->acceptDrops() );
}

void Q7B_QWIDGET_ACCEPTDROPS(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQWidget(self)->setAcceptDrops(Q7B_IDbool(theProperty));
}

Q7B Q7B_QWIDGET_ACCESSIBLEDESCRIPTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->accessibleDescription() );
}

void Q7B_QWIDGET_ACCESSIBLEDESCRIPTION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQWidget(self)->setAccessibleDescription(Q7B_IDQString(theProperty));
}

Q7B Q7B_QWIDGET_ACCESSIBLENAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->accessibleName() );
}

void Q7B_QWIDGET_ACCESSIBLENAME(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQWidget(self)->setAccessibleName(Q7B_IDQString(theProperty));
}

void Q7B_QWIDGET_ACTIVATEWINDOW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->activateWindow();
}

void Q7B_QWIDGET_ADDACTION(Q7B self, Q7B Action) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QACTION(Action))){ Q7B_EXCEPTION("QAction expected"); return ; }

  Q7B_IDQWidget(self)->addAction(Q7B_IDQAction(Action));
}

void Q7B_QWIDGET_ADDACTIONS(Q7B self, Q7B Actions) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Actions))){ Q7B_EXCEPTION("QStringList expected"); return ; }


  static QList<QAction*> list2; // TODO2 collision with different splitters

  list2.clear();

  for (int i = 0; i < ((Q7B_List *) Actions->ref)->count(); i++){    
    QAction *it = Q7B_IDQAction(((Q7B_List *) Actions->ref)->getObject(i));

    list2.append(it);
  }  

  Q7B_IDQWidget(self)->addActions(list2);
}

void Q7B_QWIDGET_ADJUSTSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->adjustSize();
}

Q7B Q7B_QWIDGET_AUTOFILLBACKGROUND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->autoFillBackground() );
}

void Q7B_QWIDGET_AUTOFILLBACKGROUND(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQWidget(self)->setAutoFillBackground(Q7B_IDbool(theProperty));
}

Q7B Q7B_QWIDGET_BACKGROUNDROLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->backgroundRole() );
}

Q7B Q7B_QWIDGET_BASESIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->baseSize() );
}

void Q7B_QWIDGET_BASESIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  Q7B_IDQWidget(self)->setBaseSize(Q7B_IDQSize(theProperty));
}

Q7B Q7B_QWIDGET_CHILDAT(Q7B self, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->childAt(Q7B_IDqint64(X), Q7B_IDqint64(Y)) );
}

Q7B Q7B_QWIDGET_CHILDAT2(Q7B self, Q7B P) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(P))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->childAt(Q7B_IDQPoint(P)) );
}

Q7B Q7B_QWIDGET_CHILDRENRECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->childrenRect() );
}

void Q7B_QWIDGET_CHILDRENRECT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(theProperty))){ Q7B_EXCEPTION("QRect expected"); return; }

  Q7B_IDQWidget(self)->setProperty("childrenRect", Q7B_IDQRect(theProperty));
}

Q7B Q7B_QWIDGET_CHILDRENREGION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->childrenRegion() );
}

void Q7B_QWIDGET_CHILDRENREGION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QREGION(theProperty))){ Q7B_EXCEPTION("QRegion expected"); return; }

  Q7B_IDQWidget(self)->setProperty("childrenRegion", Q7B_IDQRect(theProperty));
}

void Q7B_QWIDGET_CLEARFOCUS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->clearFocus();
}

void Q7B_QWIDGET_CLEARMASK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->clearMask();
}

Q7B Q7B_QWIDGET_CLOSE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->close() );
}


Q7B Q7B_QWIDGET_CONTENTSMARGINS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->contentsMargins() );
}

Q7B Q7B_QWIDGET_CONTENTSRECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->contentsRect() );
}

Q7B Q7B_QWIDGET_CURSOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->cursor() );
}

void Q7B_QWIDGET_CURSOR(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QCURSOR(theProperty))){ Q7B_EXCEPTION("QCursor expected"); return; }

  Q7B_IDQWidget(self)->setCursor(Q7B_IDQCursor(theProperty));
}

void Q7B_QWIDGET_ENSUREPOLISHED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->ensurePolished();
}

Q7B Q7B_QWIDGET_FOCUS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->hasFocus() );
}

void Q7B_QWIDGET_FOCUS(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_INTEGER(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQWidget(self)->setFocus((Qt::FocusReason) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QWIDGET_FOCUSPOLICY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->focusPolicy() );
}

void Q7B_QWIDGET_FOCUSPOLICY(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQWidget(self)->setFocusPolicy((Qt::FocusPolicy) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QWIDGET_FOCUSPROXY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->focusProxy() );
}

Q7B Q7B_QWIDGET_FOCUSWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->focusWidget() );
}

Q7B Q7B_QWIDGET_FONT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->font() );
}

void Q7B_QWIDGET_FONT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QFONT(theProperty))){ Q7B_EXCEPTION("QFont expected"); return; }

  Q7B_IDQWidget(self)->setFont(Q7B_IDQFont(theProperty));
}

Q7B Q7B_QWIDGET_FONTINFO(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_idnil;
  // TODO return Q7B_ID( Q7B_IDQWidget(self)->fontInfo() );
}

Q7B Q7B_QWIDGET_FONTMETRICS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_idnil;
  // TODO return Q7B_ID( Q7B_IDQWidget(self)->fontMetrics() );
}

Q7B Q7B_QWIDGET_FOREGROUNDROLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->foregroundRole() );
}

Q7B Q7B_QWIDGET_FRAMEGEOMETRY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->frameGeometry() );
}

void Q7B_QWIDGET_FRAMEGEOMETRY(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(theProperty))){ Q7B_EXCEPTION("QRect expected"); return; }

  Q7B_IDQWidget(self)->setProperty("frameGeometry", Q7B_IDQRect(theProperty));
}

Q7B Q7B_QWIDGET_FRAMESIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->frameSize() );
}

void Q7B_QWIDGET_FRAMESIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  Q7B_IDQWidget(self)->setProperty("frameSize", Q7B_IDQSize(theProperty));
}

Q7B Q7B_QWIDGET_FULLSCREEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->isFullScreen() );
}

void Q7B_QWIDGET_FULLSCREEN(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQWidget(self)->showFullScreen(/*Q7B_IDbool(theProperty)*/);
}

Q7B Q7B_QWIDGET_GEOMETRY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->geometry() );
}

void Q7B_QWIDGET_GEOMETRY(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(theProperty))){ Q7B_EXCEPTION("QRect expected"); return; }

  Q7B_IDQWidget(self)->setGeometry(Q7B_IDQRect(theProperty));
}

void Q7B_QWIDGET_GRABGESTURE(Q7B self, Q7B Gesture, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Gesture))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->grabGesture((Qt::GestureType) Q7B_IDqint64(Gesture), (Qt::GestureFlags) Q7B_IDqint64(Flags));
}

void Q7B_QWIDGET_GRABKEYBOARD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->grabKeyboard();
}

void Q7B_QWIDGET_GRABMOUSE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->grabMouse();
}

void Q7B_QWIDGET_GRABMOUSE2(Q7B self, Q7B Cursor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QCURSOR(Cursor))){ Q7B_EXCEPTION("QCursor expected"); return ; }

  Q7B_IDQWidget(self)->grabMouse(Q7B_IDQCursor(Cursor));
}

Q7B Q7B_QWIDGET_GRABSHORTCUT(Q7B self, Q7B Key, Q7B Context) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QKEYSEQUENCE(Key))){ Q7B_EXCEPTION("QKeySequence expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Context))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->grabShortcut(Q7B_IDQKeySequence(Key), (Qt::ShortcutContext) Q7B_IDqint64(Context)) );
}

Q7B Q7B_QWIDGET_HASFOCUS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->hasFocus() );
}

Q7B Q7B_QWIDGET_HASMOUSETRACKING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->hasMouseTracking() );
}

Q7B Q7B_QWIDGET_HEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->height() );
}

void Q7B_QWIDGET_HEIGHT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }


  QWidget *w = Q7B_IDQWidget(self);
  //QRect r = w->geometry();
  //r.setBottom(Q7B_IDqint64(theProperty));
  //w->setGeometry(r);
  w->setGeometry(w->x(), w->y(), w->width(), Q7B_IDqint64(theProperty));
}

Q7B Q7B_QWIDGET_HEIGHTFORWIDTH(Q7B self, Q7B W) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(W))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->heightForWidth(Q7B_IDqint64(W)) );
}

Q7B Q7B_QWIDGET_INPUTMETHODHINTS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->inputMethodHints() );
}

void Q7B_QWIDGET_INPUTMETHODHINTS(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQWidget(self)->setInputMethodHints((Qt::InputMethodHints) Q7B_IDqint64(theProperty));
}

void Q7B_QWIDGET_INSERTACTION(Q7B self, Q7B Before, Q7B Action) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QACTION(Before))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QACTION(Action))){ Q7B_EXCEPTION("QAction expected"); return ; }

  Q7B_IDQWidget(self)->insertAction(Q7B_IDQAction(Before), Q7B_IDQAction(Action));
}

void Q7B_QWIDGET_INSERTACTIONS(Q7B self, Q7B Before, Q7B Actions) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QACTION(Before))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Actions))){ Q7B_EXCEPTION("QStringList expected"); return ; }


  static QList<QAction*> list2; // TODO2 collision with different splitters

  list2.clear();

  for (int i = 0; i < ((Q7B_List *) Actions->ref)->count(); i++){    
    QAction *it = Q7B_IDQAction(((Q7B_List *) Actions->ref)->getObject(i));

    list2.append(it);
  }  

  Q7B_IDQWidget(self)->insertActions(Q7B_IDQAction(Before), list2);
}

Q7B Q7B_QWIDGET_ISACTIVEWINDOW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->isActiveWindow() );
}

void Q7B_QWIDGET_ISACTIVEWINDOW(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  //Q7B_IDQWidget(self)->setActiveWindow(Q7B_IDbool(theProperty));
}

Q7B Q7B_QWIDGET_ISANCESTOROF(Q7B self, Q7B Child) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Child))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->isAncestorOf(Q7B_IDQWidget(Child)) );
}

Q7B Q7B_QWIDGET_ISENABLEDTO(Q7B self, Q7B Ancestor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Ancestor))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->isEnabledTo(Q7B_IDQWidget(Ancestor)) );
}

Q7B Q7B_QWIDGET_ISHIDDEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->isHidden() );
}

Q7B Q7B_QWIDGET_ISVISIBLETO(Q7B self, Q7B Ancestor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Ancestor))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->isVisibleTo(Q7B_IDQWidget(Ancestor)) );
}

Q7B Q7B_QWIDGET_ISWINDOW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->isWindow() );
}

Q7B Q7B_QWIDGET_ISWINDOWMODIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->isWindowModified() );
}

Q7B Q7B_QWIDGET_LAYOUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->layout() );
}

Q7B Q7B_QWIDGET_LAYOUTDIRECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->layoutDirection() );
}

void Q7B_QWIDGET_LAYOUTDIRECTION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQWidget(self)->setLayoutDirection((Qt::LayoutDirection) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QWIDGET_LOCALE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->locale() );
}

void Q7B_QWIDGET_LOCALE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QLOCALE(theProperty))){ Q7B_EXCEPTION("QLocale expected"); return; }

  Q7B_IDQWidget(self)->setLocale(Q7B_IDQLocale(theProperty));
}

void Q7B_QWIDGET_LOWER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->lower();
}

Q7B Q7B_QWIDGET_MAPFROM(Q7B self, Q7B Parent, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Parent))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Pos))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->mapFrom(Q7B_IDQWidget(Parent), Q7B_IDQPoint(Pos)) );
}

Q7B Q7B_QWIDGET_MAPFROMGLOBAL(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Pos))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->mapFromGlobal(Q7B_IDQPoint(Pos)) );
}

Q7B Q7B_QWIDGET_MAPFROMPARENT(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Pos))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->mapFromParent(Q7B_IDQPoint(Pos)) );
}

Q7B Q7B_QWIDGET_MAPTO(Q7B self, Q7B Parent, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Parent))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Pos))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->mapTo(Q7B_IDQWidget(Parent), Q7B_IDQPoint(Pos)) );
}

Q7B Q7B_QWIDGET_MAPTOGLOBAL(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Pos))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->mapToGlobal(Q7B_IDQPoint(Pos)) );
}

Q7B Q7B_QWIDGET_MAPTOPARENT(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Pos))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->mapToParent(Q7B_IDQPoint(Pos)) );
}

Q7B Q7B_QWIDGET_MASK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->mask() );
}

Q7B Q7B_QWIDGET_MAXIMIZED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->isMaximized() );
}

void Q7B_QWIDGET_MAXIMIZED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQWidget(self)->showMaximized(/*Q7B_IDbool(theProperty)*/);
}

Q7B Q7B_QWIDGET_MAXIMUMHEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->maximumHeight() );
}

void Q7B_QWIDGET_MAXIMUMHEIGHT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQWidget(self)->setMaximumHeight(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QWIDGET_MAXIMUMSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->maximumSize() );
}

void Q7B_QWIDGET_MAXIMUMSIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  Q7B_IDQWidget(self)->setMaximumSize(Q7B_IDQSize(theProperty));
}

Q7B Q7B_QWIDGET_MINIMIZED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->isMinimized() );
}

void Q7B_QWIDGET_MINIMIZED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQWidget(self)->showMinimized(/*Q7B_IDbool(theProperty)*/);
}

Q7B Q7B_QWIDGET_MINIMUMHEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->minimumHeight() );
}

void Q7B_QWIDGET_MINIMUMHEIGHT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQWidget(self)->setMinimumHeight(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QWIDGET_MINIMUMSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->minimumSize() );
}

void Q7B_QWIDGET_MINIMUMSIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  Q7B_IDQWidget(self)->setMinimumSize(Q7B_IDQSize(theProperty));
}

Q7B Q7B_QWIDGET_MINIMUMSIZEHINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->minimumSizeHint() );
}

void Q7B_QWIDGET_MINIMUMSIZEHINT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  //Q7B_IDQWidget(self)->setMinimumSizeHint(Q7B_IDQSize(theProperty));
}

Q7B Q7B_QWIDGET_MODAL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->isModal() );
}

void Q7B_QWIDGET_MODAL(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  //Q7B_IDQWidget(self)->setModal(Q7B_IDbool(theProperty));
}

Q7B Q7B_QWIDGET_MOUSETRACKING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->hasMouseTracking() );
}

void Q7B_QWIDGET_MOUSETRACKING(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQWidget(self)->setMouseTracking(Q7B_IDbool(theProperty));
}

void Q7B_QWIDGET_MOVE(Q7B self, Q7B Point) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Point))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQWidget(self)->move(Q7B_IDQPoint(Point));
}

void Q7B_QWIDGET_MOVE2(Q7B self, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->move(Q7B_IDqint64(X), Q7B_IDqint64(Y));
}

Q7B Q7B_QWIDGET_NATIVEPARENTWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->nativeParentWidget() );
}

Q7B Q7B_QWIDGET_NEXTINFOCUSCHAIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->nextInFocusChain() );
}

Q7B Q7B_QWIDGET_NORMALGEOMETRY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->normalGeometry() );
}

void Q7B_QWIDGET_OVERRIDEWINDOWFLAGS(Q7B self, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->overrideWindowFlags((Qt::WindowFlags) Q7B_IDqint64(Flags));
}

Q7B Q7B_QWIDGET_PALETTE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->palette() );
}

Q7B Q7B_QWIDGET_PARENTWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->parentWidget() );
}

Q7B Q7B_QWIDGET_POS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->pos() );
}

Q7B Q7B_QWIDGET_PREVIOUSINFOCUSCHAIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->previousInFocusChain() );
}

void Q7B_QWIDGET_RAISE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->raise();
}

Q7B Q7B_QWIDGET_RECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->rect() );
}

void Q7B_QWIDGET_RELEASEKEYBOARD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->releaseKeyboard();
}

void Q7B_QWIDGET_RELEASEMOUSE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->releaseMouse();
}

void Q7B_QWIDGET_RELEASESHORTCUT(Q7B self, Q7B Id) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Id))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->releaseShortcut(Q7B_IDqint64(Id));
}

void Q7B_QWIDGET_REMOVEACTION(Q7B self, Q7B Action) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QACTION(Action))){ Q7B_EXCEPTION("QAction expected"); return ; }

  Q7B_IDQWidget(self)->removeAction(Q7B_IDQAction(Action));
}

void Q7B_QWIDGET_REPAINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->repaint();
}

void Q7B_QWIDGET_REPAINT2(Q7B self, Q7B Rect) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rect))){ Q7B_EXCEPTION("QRect expected"); return ; }

  Q7B_IDQWidget(self)->repaint(Q7B_IDQRect(Rect));
}

void Q7B_QWIDGET_REPAINT3(Q7B self, Q7B Rgn) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QREGION(Rgn))){ Q7B_EXCEPTION("QRegion expected"); return ; }

  Q7B_IDQWidget(self)->repaint(Q7B_IDQRegion(Rgn));
}

void Q7B_QWIDGET_RESIZE(Q7B self, Q7B NewSize) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(NewSize))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQWidget(self)->resize(Q7B_IDQSize(NewSize));
}

void Q7B_QWIDGET_RESIZE2(Q7B self, Q7B W, Q7B H) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(W))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(H))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->resize(Q7B_IDqint64(W), Q7B_IDqint64(H));
}

Q7B Q7B_QWIDGET_RESTOREGEOMETRY(Q7B self, Q7B Geometry) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Geometry))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->restoreGeometry(Q7B_IDQByteArray(Geometry)) );
}

Q7B Q7B_QWIDGET_SAVEGEOMETRY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->saveGeometry() );
}

void Q7B_QWIDGET_SCROLL(Q7B self, Q7B Dx, Q7B Dy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dx))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->scroll(Q7B_IDqint64(Dx), Q7B_IDqint64(Dy));
}

void Q7B_QWIDGET_SCROLL2(Q7B self, Q7B Dx, Q7B Dy, Q7B R) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dx))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(R))){ Q7B_EXCEPTION("QRect expected"); return ; }

  Q7B_IDQWidget(self)->scroll(Q7B_IDqint64(Dx), Q7B_IDqint64(Dy), Q7B_IDQRect(R));
}

void Q7B_QWIDGET_SETBACKGROUNDROLE(Q7B self, Q7B Role) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Role))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setBackgroundRole((QPalette::ColorRole) Q7B_IDqint64(Role));
}

void Q7B_QWIDGET_SETBASESIZE(Q7B self, Q7B BaseW, Q7B BaseH) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(BaseW))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(BaseH))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setBaseSize(Q7B_IDqint64(BaseW), Q7B_IDqint64(BaseH));
}

void Q7B_QWIDGET_SETCONTENTSMARGINS(Q7B self, Q7B Left, Q7B Top, Q7B Right, Q7B Bottom) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Left))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Top))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Right))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Bottom))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setContentsMargins(Q7B_IDqint64(Left), Q7B_IDqint64(Top), Q7B_IDqint64(Right), Q7B_IDqint64(Bottom));
}

void Q7B_QWIDGET_SETCONTENTSMARGINS2(Q7B self, Q7B Margins) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QMARGINS(Margins))){ Q7B_EXCEPTION("QMargins expected"); return ; }

  Q7B_IDQWidget(self)->setContentsMargins(Q7B_IDQMargins(Margins));
}

void Q7B_QWIDGET_SETCONTEXTMENUPOLICY(Q7B self, Q7B Policy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Policy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setContextMenuPolicy((Qt::ContextMenuPolicy) Q7B_IDqint64(Policy));
}

void Q7B_QWIDGET_SETDISABLED(Q7B self, Q7B Disable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Disable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQWidget(self)->setDisabled(Q7B_IDbool(Disable));
}

void Q7B_QWIDGET_SETENABLED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQWidget(self)->setEnabled(Q7B_IDbool(Enable));
}

void Q7B_QWIDGET_SETFIXEDHEIGHT(Q7B self, Q7B H) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(H))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setFixedHeight(Q7B_IDqint64(H));
}

void Q7B_QWIDGET_SETFIXEDSIZE(Q7B self, Q7B S) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(S))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQWidget(self)->setFixedSize(Q7B_IDQSize(S));
}

void Q7B_QWIDGET_SETFIXEDSIZE2(Q7B self, Q7B W, Q7B H) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(W))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(H))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setFixedSize(Q7B_IDqint64(W), Q7B_IDqint64(H));
}

void Q7B_QWIDGET_SETFIXEDWIDTH(Q7B self, Q7B W) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(W))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setFixedWidth(Q7B_IDqint64(W));
}

void Q7B_QWIDGET_SETFOCUS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->setFocus();
}

void Q7B_QWIDGET_SETFOCUSPOLICY(Q7B self, Q7B Policy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Policy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setFocusPolicy((Qt::FocusPolicy) Q7B_IDqint64(Policy));
}

void Q7B_QWIDGET_SETFOCUSPROXY(Q7B self, Q7B W) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(W))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->setFocusProxy(Q7B_IDQWidget(W));
}

void Q7B_QWIDGET_SETFOREGROUNDROLE(Q7B self, Q7B Role) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Role))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setForegroundRole((QPalette::ColorRole) Q7B_IDqint64(Role));
}

void Q7B_QWIDGET_SETGEOMETRY(Q7B self, Q7B X, Q7B Y, Q7B W, Q7B H) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(W))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(H))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setGeometry(Q7B_IDqint64(X), Q7B_IDqint64(Y), Q7B_IDqint64(W), Q7B_IDqint64(H));
}

void Q7B_QWIDGET_SETHIDDEN(Q7B self, Q7B Hidden) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Hidden))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQWidget(self)->setHidden(Q7B_IDbool(Hidden));
}

void Q7B_QWIDGET_SETLAYOUT(Q7B self, Q7B Layout) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QLAYOUT(Layout))){ Q7B_EXCEPTION("QLayout expected"); return ; }

  Q7B_IDQWidget(self)->setLayout(&Q7B_IDQLayout(Layout));
}

void Q7B_QWIDGET_SETLAYOUTDIRECTION(Q7B self, Q7B Direction) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Direction))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setLayoutDirection((Qt::LayoutDirection) Q7B_IDqint64(Direction));
}

void Q7B_QWIDGET_SETLOCALE(Q7B self, Q7B Locale) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QLOCALE(Locale))){ Q7B_EXCEPTION("QLocale expected"); return ; }

  Q7B_IDQWidget(self)->setLocale(Q7B_IDQLocale(Locale));
}

void Q7B_QWIDGET_SETMASK(Q7B self, Q7B Bitmap) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QBITMAP(Bitmap))){ Q7B_EXCEPTION("QBitmap expected"); return ; }

  Q7B_IDQWidget(self)->setMask(Q7B_IDQBitmap(Bitmap));
}

void Q7B_QWIDGET_SETMASK2(Q7B self, Q7B Region) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QREGION(Region))){ Q7B_EXCEPTION("QRegion expected"); return ; }

  Q7B_IDQWidget(self)->setMask(Q7B_IDQRegion(Region));
}

void Q7B_QWIDGET_SETMAXIMUMSIZE(Q7B self, Q7B MaxW, Q7B MaxH) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(MaxW))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(MaxH))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setMaximumSize(Q7B_IDqint64(MaxW), Q7B_IDqint64(MaxH));
}

void Q7B_QWIDGET_SETMAXIMUMWIDTH(Q7B self, Q7B MaxW) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(MaxW))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setMaximumWidth(Q7B_IDqint64(MaxW));
}

void Q7B_QWIDGET_SETMINIMUMSIZE(Q7B self, Q7B MinW, Q7B MinH) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(MinW))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(MinH))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setMinimumSize(Q7B_IDqint64(MinW), Q7B_IDqint64(MinH));
}

void Q7B_QWIDGET_SETMINIMUMWIDTH(Q7B self, Q7B MinW) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(MinW))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setMinimumWidth(Q7B_IDqint64(MinW));
}

void Q7B_QWIDGET_SETPARENT2(Q7B self, Q7B Parent, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Parent))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setParent(Q7B_IDQWidget(Parent), (Qt::WindowFlags) Q7B_IDqint64(Flags));
}

void Q7B_QWIDGET_SETSHORTCUTAUTOREPEAT(Q7B self, Q7B Id, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Id))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQWidget(self)->setShortcutAutoRepeat(Q7B_IDqint64(Id), Q7B_IDbool(Enable));
}

void Q7B_QWIDGET_SETSHORTCUTENABLED(Q7B self, Q7B Id, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Id))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQWidget(self)->setShortcutEnabled(Q7B_IDqint64(Id), Q7B_IDbool(Enable));
}

void Q7B_QWIDGET_SETSIZEINCREMENT(Q7B self, Q7B W, Q7B H) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(W))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(H))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setSizeIncrement(Q7B_IDqint64(W), Q7B_IDqint64(H));
}

void Q7B_QWIDGET_SETSIZEPOLICY(Q7B self, Q7B Horizontal, Q7B Vertical) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Horizontal))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Vertical))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setSizePolicy((QSizePolicy::Policy) Q7B_IDqint64(Horizontal), (QSizePolicy::Policy) Q7B_IDqint64(Vertical));
}

void Q7B_QWIDGET_SETSTYLESHEET(Q7B self, Q7B StyleSheet) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(StyleSheet))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQWidget(self)->setStyleSheet(Q7B_IDQString(StyleSheet));
}

void Q7B_QWIDGET_SETVISIBLE(Q7B self, Q7B Visible) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Visible))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQWidget(self)->setVisible(Q7B_IDbool(Visible));
}

void Q7B_QWIDGET_SETWINDOWMODALITY(Q7B self, Q7B WindowModality) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(WindowModality))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setWindowModality((Qt::WindowModality) Q7B_IDqint64(WindowModality));
}

void Q7B_QWIDGET_SETWINDOWMODIFIED(Q7B self, Q7B Modified) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Modified))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQWidget(self)->setWindowModified(Q7B_IDbool(Modified));
}

void Q7B_QWIDGET_SETWINDOWROLE(Q7B self, Q7B Role) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Role))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQWidget(self)->setWindowRole(Q7B_IDQString(Role));
}

void Q7B_QWIDGET_SETWINDOWSTATE(Q7B self, Q7B WindowState) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(WindowState))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->setWindowState((Qt::WindowStates) Q7B_IDqint64(WindowState));
}

void Q7B_QWIDGET_SETWINDOWTITLE(Q7B self, Q7B Title) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Title))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQWidget(self)->setWindowTitle(Q7B_IDQString(Title));
}

Q7B Q7B_QWIDGET_SIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->size() );
}

Q7B Q7B_QWIDGET_SIZEHINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->sizeHint() );
}

void Q7B_QWIDGET_SIZEHINT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  //Q7B_IDQWidget(self)->setSizeHint(Q7B_IDQSize(theProperty));
}

Q7B Q7B_QWIDGET_SIZEINCREMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->sizeIncrement() );
}

void Q7B_QWIDGET_SIZEINCREMENT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  Q7B_IDQWidget(self)->setSizeIncrement(Q7B_IDQSize(theProperty));
}

Q7B Q7B_QWIDGET_SIZEPOLICY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->sizePolicy() );
}

Q7B Q7B_QWIDGET_STATUSTIP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->statusTip() );
}

void Q7B_QWIDGET_STATUSTIP(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQWidget(self)->setStatusTip(Q7B_IDQString(theProperty));
}

Q7B Q7B_QWIDGET_STYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->style() );
}

Q7B Q7B_QWIDGET_STYLESHEET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->styleSheet() );
}

void Q7B_QWIDGET_STYLESHEET(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQWidget(self)->setStyleSheet(Q7B_IDQString(theProperty));
}

Q7B Q7B_QWIDGET_TESTATTRIBUTE(Q7B self, Q7B Attribute) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Attribute))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->testAttribute((Qt::WidgetAttribute) Q7B_IDqint64(Attribute)) );
}

Q7B Q7B_QWIDGET_TOOLTIP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->toolTip() );
}

Q7B Q7B_QWIDGET_UNDERMOUSE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->underMouse() );
}

void Q7B_QWIDGET_UNGRABGESTURE(Q7B self, Q7B Gesture) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Gesture))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWidget(self)->ungrabGesture((Qt::GestureType) Q7B_IDqint64(Gesture));
}

void Q7B_QWIDGET_UNSETCURSOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->unsetCursor();
}

void Q7B_QWIDGET_UNSETLAYOUTDIRECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->unsetLayoutDirection();
}

void Q7B_QWIDGET_UNSETLOCALE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->unsetLocale();
}

void Q7B_QWIDGET_UPDATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->update();
}

void Q7B_QWIDGET_UPDATE2(Q7B self, Q7B Rect) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rect))){ Q7B_EXCEPTION("QRect expected"); return ; }

  Q7B_IDQWidget(self)->update(Q7B_IDQRect(Rect));
}

void Q7B_QWIDGET_UPDATE3(Q7B self, Q7B Rgn) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QREGION(Rgn))){ Q7B_EXCEPTION("QRegion expected"); return ; }

  Q7B_IDQWidget(self)->update(Q7B_IDQRegion(Rgn));
}

void Q7B_QWIDGET_UPDATEGEOMETRY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQWidget(self)->updateGeometry();
}

Q7B Q7B_QWIDGET_UPDATESENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->updatesEnabled() );
}

void Q7B_QWIDGET_UPDATESENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQWidget(self)->setUpdatesEnabled(Q7B_IDbool(theProperty));
}

Q7B Q7B_QWIDGET_VISIBLEREGION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->visibleRegion() );
}

Q7B Q7B_QWIDGET_WHATSTHIS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->whatsThis() );
}

void Q7B_QWIDGET_WHATSTHIS(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQWidget(self)->setWhatsThis(Q7B_IDQString(theProperty));
}

Q7B Q7B_QWIDGET_WIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->width() );
}

void Q7B_QWIDGET_WIDTH(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }


  QWidget *w = Q7B_IDQWidget(self);
 // QRect r = w->geometry();
 // r.setRight(Q7B_IDqint64(theProperty));
  //w->setGeometry(r);
  w->setGeometry(w->x(), w->y(), Q7B_IDqint64(theProperty), w->height());
}

Q7B Q7B_QWIDGET_WINDOW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->window() );
}

Q7B Q7B_QWIDGET_WINDOWFILEPATH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->windowFilePath() );
}

void Q7B_QWIDGET_WINDOWFILEPATH(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQWidget(self)->setWindowFilePath(Q7B_IDQString(theProperty));
}

Q7B Q7B_QWIDGET_WINDOWICONTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->windowIconText() );
}

void Q7B_QWIDGET_WINDOWICONTEXT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQWidget(self)->setWindowIconText(Q7B_IDQString(theProperty));
}

Q7B Q7B_QWIDGET_WINDOWMODALITY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->windowModality() );
}

void Q7B_QWIDGET_WINDOWMODALITY(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQWidget(self)->setWindowModality((Qt::WindowModality) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QWIDGET_WINDOWMODIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->isWindowModified() );
}

void Q7B_QWIDGET_WINDOWMODIFIED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQWidget(self)->setWindowModified(Q7B_IDbool(theProperty));
}

Q7B Q7B_QWIDGET_WINDOWOPACITY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->windowOpacity() );
}

void Q7B_QWIDGET_WINDOWOPACITY(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(theProperty))){ Q7B_EXCEPTION("qreal expected"); return; }

  Q7B_IDQWidget(self)->setWindowOpacity(Q7B_IDqreal(theProperty));
}

Q7B Q7B_QWIDGET_WINDOWROLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->windowRole() );
}

Q7B Q7B_QWIDGET_WINDOWSTATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) Q7B_IDQWidget(self)->windowState() );
}

Q7B Q7B_QWIDGET_WINDOWTYPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->windowType() );
}

Q7B Q7B_QWIDGET_X(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->x() );
}

void Q7B_QWIDGET_X(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }


  QWidget *w = Q7B_IDQWidget(self);
 // QRect r = w->geometry();
//  r.setLeft(Q7B_IDqint64(theProperty));
  w->setGeometry(Q7B_IDqint64(theProperty), w->y(), w->width(), w->height());
}

Q7B Q7B_QWIDGET_Y(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWidget(self)->y() );
}

void Q7B_QWIDGET_Y(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWIDGET(self))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }


  QWidget *w = Q7B_IDQWidget(self);
  //QRect r = w->geometry();
  //r.setTop(Q7B_IDqint64(theProperty));
  //w->setGeometry(r);
  w->setGeometry(w->x(), Q7B_IDqint64(theProperty), w->width(), w->height());

}


void Q7B_QTEXTDOCUMENT_ADDRESOURCE(Q7B self, Q7B theType, Q7B Name, Q7B Resource) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theType))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QURL(Name))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QVARIANT(Resource))){ Q7B_EXCEPTION("QVariant expected"); return ; }

  Q7B_IDQTextDocument(self)->addResource(Q7B_IDqint64(theType), Q7B_IDQUrl(Name), Q7B_IDQVariant(Resource));
}

void Q7B_QTEXTDOCUMENT_ADJUSTSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  Q7B_IDQTextDocument(self)->adjustSize();
}

Q7B Q7B_QTEXTDOCUMENT_AVAILABLEREDOSTEPS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->availableRedoSteps() );
}

Q7B Q7B_QTEXTDOCUMENT_AVAILABLEUNDOSTEPS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->availableUndoSteps() );
}

Q7B Q7B_QTEXTDOCUMENT_BEGIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->begin() );
}

Q7B Q7B_QTEXTDOCUMENT_BLOCKCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->blockCount() );
}

void Q7B_QTEXTDOCUMENT_BLOCKCOUNT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  //Q7B_IDQTextDocument(self)->setBlockCount(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QTEXTDOCUMENT_CHARACTERAT(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Pos))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->characterAt(Q7B_IDqint64(Pos)) );
}

Q7B Q7B_QTEXTDOCUMENT_CHARACTERCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->characterCount() );
}

void Q7B_QTEXTDOCUMENT_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  Q7B_IDQTextDocument(self)->clear();
}
/*
Q7B Q7B_QTEXTDOCUMENT_DEFAULTCURSORMOVESTYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->defaultCursorMoveStyle() );
}*/

Q7B Q7B_QTEXTDOCUMENT_DEFAULTFONT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->defaultFont() );
}

void Q7B_QTEXTDOCUMENT_DEFAULTFONT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QFONT(theProperty))){ Q7B_EXCEPTION("QFont expected"); return; }

  Q7B_IDQTextDocument(self)->setDefaultFont(Q7B_IDQFont(theProperty));
}

Q7B Q7B_QTEXTDOCUMENT_DEFAULTSTYLESHEET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->defaultStyleSheet() );
}

void Q7B_QTEXTDOCUMENT_DEFAULTSTYLESHEET(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQTextDocument(self)->setDefaultStyleSheet(Q7B_IDQString(theProperty));
}

Q7B Q7B_QTEXTDOCUMENT_DOCUMENTLAYOUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->documentLayout() );
}

Q7B Q7B_QTEXTDOCUMENT_DOCUMENTMARGIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->documentMargin() );
}

void Q7B_QTEXTDOCUMENT_DOCUMENTMARGIN(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(theProperty))){ Q7B_EXCEPTION("qreal expected"); return; }

  Q7B_IDQTextDocument(self)->setDocumentMargin(Q7B_IDqreal(theProperty));
}

Q7B Q7B_QTEXTDOCUMENT_END(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->end() );
}


Q7B Q7B_QTEXTDOCUMENT_FIND(Q7B self, Q7B SubString, Q7B Cursor, Q7B Options) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(SubString))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTEXTCURSOR(Cursor))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Options))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->find(Q7B_IDQString(SubString), Q7B_IDQTextCursor(Cursor), (QTextDocument::FindFlags) Q7B_IDqint64(Options)) );
}

Q7B Q7B_QTEXTDOCUMENT_FIND2(Q7B self, Q7B Expr, Q7B Cursor, Q7B Options) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGEXP(Expr))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTEXTCURSOR(Cursor))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Options))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->find(Q7B_IDQRegExp(Expr), Q7B_IDQTextCursor(Cursor), (QTextDocument::FindFlags) Q7B_IDqint64(Options)) );
}

Q7B Q7B_QTEXTDOCUMENT_FIND3(Q7B self, Q7B SubString, Q7B Position, Q7B Options) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(SubString))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Options))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->find(Q7B_IDQString(SubString), Q7B_IDqint64(Position), (QTextDocument::FindFlags) Q7B_IDqint64(Options)) );
}

Q7B Q7B_QTEXTDOCUMENT_FIND4(Q7B self, Q7B Expr, Q7B Position, Q7B Options) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGEXP(Expr))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Options))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->find(Q7B_IDQRegExp(Expr), Q7B_IDqint64(Position), (QTextDocument::FindFlags) Q7B_IDqint64(Options)) );
}

Q7B Q7B_QTEXTDOCUMENT_FINDBLOCK(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Pos))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->findBlock(Q7B_IDqint64(Pos)) );
}

Q7B Q7B_QTEXTDOCUMENT_FINDBLOCKBYLINENUMBER(Q7B self, Q7B LineNumber) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(LineNumber))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->findBlockByLineNumber(Q7B_IDqint64(LineNumber)) );
}

Q7B Q7B_QTEXTDOCUMENT_FINDBLOCKBYNUMBER(Q7B self, Q7B BlockNumber) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(BlockNumber))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->findBlockByNumber(Q7B_IDqint64(BlockNumber)) );
}

Q7B Q7B_QTEXTDOCUMENT_FIRSTBLOCK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->firstBlock() );
}

Q7B Q7B_QTEXTDOCUMENT_IDEALWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->idealWidth() );
}

Q7B Q7B_QTEXTDOCUMENT_INDENTWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->indentWidth() );
}

void Q7B_QTEXTDOCUMENT_INDENTWIDTH(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(theProperty))){ Q7B_EXCEPTION("qreal expected"); return; }

  Q7B_IDQTextDocument(self)->setIndentWidth(Q7B_IDqreal(theProperty));
}

Q7B Q7B_QTEXTDOCUMENT_ISEMPTY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->isEmpty() );
}

Q7B Q7B_QTEXTDOCUMENT_ISREDOAVAILABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->isRedoAvailable() );
}

Q7B Q7B_QTEXTDOCUMENT_ISUNDOAVAILABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->isUndoAvailable() );
}

Q7B Q7B_QTEXTDOCUMENT_LASTBLOCK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->lastBlock() );
}

Q7B Q7B_QTEXTDOCUMENT_LINECOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->lineCount() );
}

void Q7B_QTEXTDOCUMENT_MARKCONTENTSDIRTY(Q7B self, Q7B Position, Q7B Length) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Length))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextDocument(self)->markContentsDirty(Q7B_IDqint64(Position), Q7B_IDqint64(Length));
}

Q7B Q7B_QTEXTDOCUMENT_MAXIMUMBLOCKCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->maximumBlockCount() );
}

void Q7B_QTEXTDOCUMENT_MAXIMUMBLOCKCOUNT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQTextDocument(self)->setMaximumBlockCount(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QTEXTDOCUMENT_METAINFORMATION(Q7B self, Q7B Info) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Info))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->metaInformation((QTextDocument::MetaInformation) Q7B_IDqint64(Info)) );
}

Q7B Q7B_QTEXTDOCUMENT_MODIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->isModified() );
}

void Q7B_QTEXTDOCUMENT_MODIFIED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTextDocument(self)->setModified(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTEXTDOCUMENT_OBJECT(Q7B self, Q7B ObjectIndex) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(ObjectIndex))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->object(Q7B_IDqint64(ObjectIndex)) );
}


Q7B Q7B_QTEXTDOCUMENT_OBJECTFORFORMAT(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTEXTFORMAT(Format))){ Q7B_EXCEPTION("QTextFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->objectForFormat(Q7B_IDQTextFormat(Format)) );
}

Q7B Q7B_QTEXTDOCUMENT_PAGECOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->pageCount() );
}

Q7B Q7B_QTEXTDOCUMENT_PAGESIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->pageSize() );
}

void Q7B_QTEXTDOCUMENT_PAGESIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QSIZEF(theProperty))){ Q7B_EXCEPTION("QSizeF expected"); return; }

  Q7B_IDQTextDocument(self)->setPageSize(Q7B_IDQSizeF(theProperty));
}

void Q7B_QTEXTDOCUMENT_PRINT(Q7B self, Q7B Printer) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QPRINTER(Printer))){ Q7B_EXCEPTION("QPrinter expected"); return ; }

  Q7B_IDQTextDocument(self)->print(&Q7B_IDQPrinter(Printer));
}

void Q7B_QTEXTDOCUMENT_REDO(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  Q7B_IDQTextDocument(self)->redo();
}

Q7B Q7B_QTEXTDOCUMENT_RESOURCE(Q7B self, Q7B Type, Q7B Name) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Type))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QURL(Name))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->resource(Q7B_IDqint64(Type), Q7B_IDQUrl(Name)) );
}

Q7B Q7B_QTEXTDOCUMENT_REVISION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->revision() );
}

Q7B Q7B_QTEXTDOCUMENT_ROOTFRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->rootFrame() );
}
/*
void Q7B_QTEXTDOCUMENT_SETDEFAULTCURSORMOVESTYLE(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextDocument(self)->setDefaultCursorMoveStyle((Qt::CursorMoveStyle) Q7B_IDqint64(Style));
}*/

void Q7B_QTEXTDOCUMENT_SETDOCUMENTLAYOUT(Q7B self, Q7B Layout) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QABSTRACTTEXTDOCUMENTLAYOUT(Layout))){ Q7B_EXCEPTION("QAbstractTextDocumentLayout expected"); return ; }

  Q7B_IDQTextDocument(self)->setDocumentLayout(Q7B_IDQAbstractTextDocumentLayout(Layout));
}

void Q7B_QTEXTDOCUMENT_SETHTML(Q7B self, Q7B Html) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Html))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextDocument(self)->setHtml(Q7B_IDQString(Html));
}

void Q7B_QTEXTDOCUMENT_SETMETAINFORMATION(Q7B self, Q7B Info, Q7B S) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Info))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(S))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextDocument(self)->setMetaInformation((QTextDocument::MetaInformation) Q7B_IDqint64(Info), Q7B_IDQString(S));
}

void Q7B_QTEXTDOCUMENT_SETMODIFIED(Q7B self, Q7B Modified) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Modified))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextDocument(self)->setModified(Q7B_IDbool(Modified));
}

void Q7B_QTEXTDOCUMENT_SETPLAINTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextDocument(self)->setPlainText(Q7B_IDQString(Text));
}

void Q7B_QTEXTDOCUMENT_SETTEXTWIDTH(Q7B self, Q7B Width) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Width))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQTextDocument(self)->setTextWidth(Q7B_IDqreal(Width));
}

void Q7B_QTEXTDOCUMENT_SETUNDOREDOENABLED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextDocument(self)->setUndoRedoEnabled(Q7B_IDbool(Enable));
}

void Q7B_QTEXTDOCUMENT_SETUSEDESIGNMETRICS(Q7B self, Q7B B) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(B))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextDocument(self)->setUseDesignMetrics(Q7B_IDbool(B));
}

Q7B Q7B_QTEXTDOCUMENT_SIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->size() );
}

void Q7B_QTEXTDOCUMENT_SIZE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QSIZEF(theProperty))){ Q7B_EXCEPTION("QSizeF expected"); return; }

  //Q7B_IDQTextDocument(self)->setSize(Q7B_IDQSizeF(theProperty));
}

Q7B Q7B_QTEXTDOCUMENT_TEXTWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->textWidth() );
}

void Q7B_QTEXTDOCUMENT_TEXTWIDTH(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(theProperty))){ Q7B_EXCEPTION("qreal expected"); return; }

  Q7B_IDQTextDocument(self)->setTextWidth(Q7B_IDqreal(theProperty));
}

Q7B Q7B_QTEXTDOCUMENT_TOHTML(Q7B self, Q7B Encoding) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Encoding))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->toHtml(Q7B_IDQByteArray(Encoding)) );
}

Q7B Q7B_QTEXTDOCUMENT_TOPLAINTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->toPlainText() );
}

void Q7B_QTEXTDOCUMENT_UNDO(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  Q7B_IDQTextDocument(self)->undo();
}

Q7B Q7B_QTEXTDOCUMENT_UNDOREDOENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->isUndoRedoEnabled() );
}

void Q7B_QTEXTDOCUMENT_UNDOREDOENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTextDocument(self)->setUndoRedoEnabled(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTEXTDOCUMENT_USEDESIGNMETRICS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->useDesignMetrics() );
}

void Q7B_QTEXTDOCUMENT_USEDESIGNMETRICS(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTextDocument(self)->setUseDesignMetrics(Q7B_IDbool(theProperty));
}


Q7B Q7B_QTEXTDOCUMENT_DEFAULTTEXTOPTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocument(self)->defaultTextOption() );
}

void Q7B_QTEXTDOCUMENT_DEFAULTTEXTOPTION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENT(self))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTOPTION(theProperty))){ Q7B_EXCEPTION("QTextOption expected"); return; }

  Q7B_IDQTextDocument(self)->setDefaultTextOption(Q7B_IDQTextOption(theProperty));
}





Q7B Q7B_QTEXTEDIT_ACCEPTRICHTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->acceptRichText() );
}

Q7B Q7B_QTEXTEDIT_ALIGNMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) Q7B_IDQTextEdit(self)->alignment() );
}

Q7B Q7B_QTEXTEDIT_ANCHORAT(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Pos))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->anchorAt(Q7B_IDQPoint(Pos)) );
}

void Q7B_QTEXTEDIT_APPEND(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextEdit(self)->append(Q7B_IDQString(Text));
}

Q7B Q7B_QTEXTEDIT_AUTOFORMATTING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->autoFormatting() );
}

Q7B Q7B_QTEXTEDIT_CANPASTE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->canPaste() );
}

void Q7B_QTEXTEDIT_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  Q7B_IDQTextEdit(self)->clear();
}

void Q7B_QTEXTEDIT_COPY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  Q7B_IDQTextEdit(self)->copy();
}

Q7B Q7B_QTEXTEDIT_CREATESTANDARDCONTEXTMENU(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->createStandardContextMenu() );
}

Q7B Q7B_QTEXTEDIT_CREATESTANDARDCONTEXTMENU2(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->createStandardContextMenu(Q7B_IDQPoint(Position)) );
}

Q7B Q7B_QTEXTEDIT_CURRENTFONT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->currentFont() );
}

Q7B Q7B_QTEXTEDIT_CURSORFORPOSITION(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Pos))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->cursorForPosition(Q7B_IDQPoint(Pos)) );
}

Q7B Q7B_QTEXTEDIT_CURSORWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->cursorWidth() );
}

void Q7B_QTEXTEDIT_CUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  Q7B_IDQTextEdit(self)->cut();
}

Q7B Q7B_QTEXTEDIT_DOCUMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->document() );
}

Q7B Q7B_QTEXTEDIT_DOCUMENTTITLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->documentTitle() );
}

void Q7B_QTEXTEDIT_ENSURECURSORVISIBLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  Q7B_IDQTextEdit(self)->ensureCursorVisible();
}

Q7B Q7B_QTEXTEDIT_FIND(Q7B self, Q7B Exp, Q7B Options) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Exp))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Options))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->find(Q7B_IDQString(Exp), (QTextDocument::FindFlags) Q7B_IDqint64(Options)) );
}

Q7B Q7B_QTEXTEDIT_FONTFAMILY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->fontFamily() );
}

Q7B Q7B_QTEXTEDIT_FONTITALIC(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->fontItalic() );
}

Q7B Q7B_QTEXTEDIT_FONTPOINTSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->fontPointSize() );
}

Q7B Q7B_QTEXTEDIT_FONTUNDERLINE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->fontUnderline() );
}

Q7B Q7B_QTEXTEDIT_FONTWEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->fontWeight() );
}

void Q7B_QTEXTEDIT_INSERTHTML(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextEdit(self)->insertHtml(Q7B_IDQString(Text));
}

void Q7B_QTEXTEDIT_INSERTPLAINTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextEdit(self)->insertPlainText(Q7B_IDQString(Text));
}

Q7B Q7B_QTEXTEDIT_ISREADONLY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->isReadOnly() );
}

Q7B Q7B_QTEXTEDIT_ISUNDOREDOENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->isUndoRedoEnabled() );
}

Q7B Q7B_QTEXTEDIT_LINEWRAPCOLUMNORWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->lineWrapColumnOrWidth() );
}

Q7B Q7B_QTEXTEDIT_LINEWRAPMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->lineWrapMode() );
}

void Q7B_QTEXTEDIT_MOVECURSOR(Q7B self, Q7B Operation, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Operation))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextEdit(self)->moveCursor((QTextCursor::MoveOperation) Q7B_IDqint64(Operation), (QTextCursor::MoveMode) Q7B_IDqint64(Mode));
}

Q7B Q7B_QTEXTEDIT_OVERWRITEMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->overwriteMode() );
}

void Q7B_QTEXTEDIT_PASTE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  Q7B_IDQTextEdit(self)->paste();
}

Q7B Q7B_QTEXTEDIT_PLAINTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->toPlainText() );
}

void Q7B_QTEXTEDIT_PLAINTEXT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQTextEdit(self)->setPlainText(Q7B_IDQString(theProperty));
}

void Q7B_QTEXTEDIT_PRINT(Q7B self, Q7B Printer) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QPRINTER(Printer))){ Q7B_EXCEPTION("QPrinter expected"); return ; }

  Q7B_IDQTextEdit(self)->print(&Q7B_IDQPrinter(Printer));
}

Q7B Q7B_QTEXTEDIT_READONLY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->isReadOnly() );
}

void Q7B_QTEXTEDIT_READONLY(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTextEdit(self)->setReadOnly(Q7B_IDbool(theProperty));
}

void Q7B_QTEXTEDIT_REDO(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  Q7B_IDQTextEdit(self)->redo();
}

void Q7B_QTEXTEDIT_SCROLLTOANCHOR(Q7B self, Q7B Name) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextEdit(self)->scrollToAnchor(Q7B_IDQString(Name));
}

void Q7B_QTEXTEDIT_SELECTALL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  Q7B_IDQTextEdit(self)->selectAll();
}

void Q7B_QTEXTEDIT_SETACCEPTRICHTEXT(Q7B self, Q7B Accept) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Accept))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextEdit(self)->setAcceptRichText(Q7B_IDbool(Accept));
}

void Q7B_QTEXTEDIT_SETALIGNMENT(Q7B self, Q7B A) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(A))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextEdit(self)->setAlignment((Qt::Alignment) Q7B_IDqint64(A));
}

void Q7B_QTEXTEDIT_SETAUTOFORMATTING(Q7B self, Q7B Features) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Features))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextEdit(self)->setAutoFormatting((QTextEdit::AutoFormatting) Q7B_IDqint64(Features));
}

void Q7B_QTEXTEDIT_SETCURRENTFONT(Q7B self, Q7B F) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QFONT(F))){ Q7B_EXCEPTION("QFont expected"); return ; }

  Q7B_IDQTextEdit(self)->setCurrentFont(Q7B_IDQFont(F));
}

void Q7B_QTEXTEDIT_SETCURSORWIDTH(Q7B self, Q7B Width) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextEdit(self)->setCursorWidth(Q7B_IDqint64(Width));
}

void Q7B_QTEXTEDIT_SETDOCUMENT(Q7B self, Q7B Document) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTDOCUMENT(Document))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  Q7B_IDQTextEdit(self)->setDocument(Q7B_IDQTextDocument(Document));
}

void Q7B_QTEXTEDIT_SETDOCUMENTTITLE(Q7B self, Q7B Title) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Title))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextEdit(self)->setDocumentTitle(Q7B_IDQString(Title));
}

void Q7B_QTEXTEDIT_SETFONTFAMILY(Q7B self, Q7B FontFamily) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(FontFamily))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextEdit(self)->setFontFamily(Q7B_IDQString(FontFamily));
}

void Q7B_QTEXTEDIT_SETFONTITALIC(Q7B self, Q7B Italic) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Italic))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextEdit(self)->setFontItalic(Q7B_IDbool(Italic));
}

void Q7B_QTEXTEDIT_SETFONTPOINTSIZE(Q7B self, Q7B S) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(S))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQTextEdit(self)->setFontPointSize(Q7B_IDqreal(S));
}

void Q7B_QTEXTEDIT_SETFONTUNDERLINE(Q7B self, Q7B Underline) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Underline))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextEdit(self)->setFontUnderline(Q7B_IDbool(Underline));
}

void Q7B_QTEXTEDIT_SETFONTWEIGHT(Q7B self, Q7B Weight) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Weight))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextEdit(self)->setFontWeight(Q7B_IDqint64(Weight));
}

void Q7B_QTEXTEDIT_SETHTML(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextEdit(self)->setHtml(Q7B_IDQString(Text));
}

void Q7B_QTEXTEDIT_SETLINEWRAPCOLUMNORWIDTH(Q7B self, Q7B W) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(W))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextEdit(self)->setLineWrapColumnOrWidth(Q7B_IDqint64(W));
}

void Q7B_QTEXTEDIT_SETLINEWRAPMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextEdit(self)->setLineWrapMode((QTextEdit::LineWrapMode) Q7B_IDqint64(Mode));
}

void Q7B_QTEXTEDIT_SETOVERWRITEMODE(Q7B self, Q7B Overwrite) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Overwrite))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextEdit(self)->setOverwriteMode(Q7B_IDbool(Overwrite));
}

void Q7B_QTEXTEDIT_SETPLAINTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextEdit(self)->setPlainText(Q7B_IDQString(Text));
}

void Q7B_QTEXTEDIT_SETREADONLY(Q7B self, Q7B ReadOnly) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(ReadOnly))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextEdit(self)->setReadOnly(Q7B_IDbool(ReadOnly));
}

void Q7B_QTEXTEDIT_SETTABCHANGESFOCUS(Q7B self, Q7B a0) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOLEAN(a0))){ Q7B_EXCEPTION("B as Boolean expected"); return ; }

  Q7B_IDQTextEdit(self)->setTabChangesFocus(Q7B_IDbool(a0));
}

void Q7B_QTEXTEDIT_SETTABSTOPWIDTH(Q7B self, Q7B Width) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextEdit(self)->setTabStopWidth(Q7B_IDqint64(Width));
}

void Q7B_QTEXTEDIT_SETTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextEdit(self)->setText(Q7B_IDQString(Text));
}

void Q7B_QTEXTEDIT_SETTEXTBACKGROUNDCOLOR(Q7B self, Q7B C) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QCOLOR(C))){ Q7B_EXCEPTION("QColor expected"); return ; }

  Q7B_IDQTextEdit(self)->setTextBackgroundColor(Q7B_IDQColor(C));
}

void Q7B_QTEXTEDIT_SETTEXTCOLOR(Q7B self, Q7B C) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QCOLOR(C))){ Q7B_EXCEPTION("QColor expected"); return ; }

  Q7B_IDQTextEdit(self)->setTextColor(Q7B_IDQColor(C));
}

void Q7B_QTEXTEDIT_SETTEXTCURSOR(Q7B self, Q7B Cursor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTCURSOR(Cursor))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  Q7B_IDQTextEdit(self)->setTextCursor(Q7B_IDQTextCursor(Cursor));
}

void Q7B_QTEXTEDIT_SETTEXTINTERACTIONFLAGS(Q7B self, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextEdit(self)->setTextInteractionFlags((Qt::TextInteractionFlags) Q7B_IDqint64(Flags));
}

void Q7B_QTEXTEDIT_SETUNDOREDOENABLED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextEdit(self)->setUndoRedoEnabled(Q7B_IDbool(Enable));
}

void Q7B_QTEXTEDIT_SETWORDWRAPMODE(Q7B self, Q7B Policy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Policy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextEdit(self)->setWordWrapMode((QTextOption::WrapMode) Q7B_IDqint64(Policy));
}

Q7B Q7B_QTEXTEDIT_TABCHANGESFOCUS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->tabChangesFocus() );
}

Q7B Q7B_QTEXTEDIT_TABSTOPWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->tabStopWidth() );
}

Q7B Q7B_QTEXTEDIT_TEXTBACKGROUNDCOLOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->textBackgroundColor() );
}

Q7B Q7B_QTEXTEDIT_TEXTCOLOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->textColor() );
}

Q7B Q7B_QTEXTEDIT_TEXTCURSOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->textCursor() );
}

Q7B Q7B_QTEXTEDIT_TEXTINTERACTIONFLAGS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->textInteractionFlags() );
}

Q7B Q7B_QTEXTEDIT_TOHTML(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->toHtml() );
}

Q7B Q7B_QTEXTEDIT_TOPLAINTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->toPlainText() );
}

void Q7B_QTEXTEDIT_UNDO(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  Q7B_IDQTextEdit(self)->undo();
}

Q7B Q7B_QTEXTEDIT_UNDOREDOENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->isUndoRedoEnabled() );
}

void Q7B_QTEXTEDIT_UNDOREDOENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTextEdit(self)->setUndoRedoEnabled(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTEXTEDIT_WORDWRAPMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextEdit(self)->wordWrapMode() );
}

void Q7B_QTEXTEDIT_ZOOMIN(Q7B self, Q7B Range) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Range))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextEdit(self)->zoomIn(Q7B_IDqint64(Range));
}

void Q7B_QTEXTEDIT_ZOOMOUT(Q7B self, Q7B Range) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTEDIT(self))){ Q7B_EXCEPTION("QTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Range))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextEdit(self)->zoomOut(Q7B_IDqint64(Range));
}

Q7B Q7B_QWEBSETTINGS_DEFAULTTEXTENCODING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBSETTINGS(self))){ Q7B_EXCEPTION("QWebSettings expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebSettings(self).defaultTextEncoding() );
}

Q7B Q7B_QWEBSETTINGS_FONTFAMILY(Q7B self, Q7B Which) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBSETTINGS(self))){ Q7B_EXCEPTION("QWebSettings expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Which))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebSettings(self).fontFamily((QWebSettings::FontFamily) Q7B_IDqint64(Which)) );
}

Q7B Q7B_QWEBSETTINGS_FONTSIZE(Q7B self, Q7B Type) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBSETTINGS(self))){ Q7B_EXCEPTION("QWebSettings expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Type))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebSettings(self).fontSize((QWebSettings::FontSize) Q7B_IDqint64(Type)) );
}

Q7B Q7B_QWEBSETTINGS_LOCALSTORAGEPATH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBSETTINGS(self))){ Q7B_EXCEPTION("QWebSettings expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebSettings(self).localStoragePath() );
}

void Q7B_QWEBSETTINGS_RESETFONTFAMILY(Q7B self, Q7B Which) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBSETTINGS(self))){ Q7B_EXCEPTION("QWebSettings expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Which))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWebSettings(self).resetFontFamily((QWebSettings::FontFamily) Q7B_IDqint64(Which));
}

void Q7B_QWEBSETTINGS_RESETFONTSIZE(Q7B self, Q7B Type) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBSETTINGS(self))){ Q7B_EXCEPTION("QWebSettings expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Type))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWebSettings(self).resetFontSize((QWebSettings::FontSize) Q7B_IDqint64(Type));
}

void Q7B_QWEBSETTINGS_SETATTRIBUTE(Q7B self, Q7B Attribute, Q7B On) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBSETTINGS(self))){ Q7B_EXCEPTION("QWebSettings expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Attribute))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(On))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQWebSettings(self).setAttribute((QWebSettings::WebAttribute) Q7B_IDqint64(Attribute), Q7B_IDbool(On));
}

void Q7B_QWEBSETTINGS_SETDEFAULTTEXTENCODING(Q7B self, Q7B Encoding) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBSETTINGS(self))){ Q7B_EXCEPTION("QWebSettings expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Encoding))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQWebSettings(self).setDefaultTextEncoding(Q7B_IDQString(Encoding));
}

void Q7B_QWEBSETTINGS_SETFONTFAMILY(Q7B self, Q7B Which, Q7B Family) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBSETTINGS(self))){ Q7B_EXCEPTION("QWebSettings expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Which))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Family))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQWebSettings(self).setFontFamily((QWebSettings::FontFamily) Q7B_IDqint64(Which), Q7B_IDQString(Family));
}

void Q7B_QWEBSETTINGS_SETFONTSIZE(Q7B self, Q7B Type, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBSETTINGS(self))){ Q7B_EXCEPTION("QWebSettings expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Type))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Size))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQWebSettings(self).setFontSize((QWebSettings::FontSize) Q7B_IDqint64(Type), Q7B_IDqint64(Size));
}

void Q7B_QWEBSETTINGS_SETLOCALSTORAGEPATH(Q7B self, Q7B Path) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBSETTINGS(self))){ Q7B_EXCEPTION("QWebSettings expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQWebSettings(self).setLocalStoragePath(Q7B_IDQString(Path));
}

Q7B Q7B_QWEBSETTINGS_TESTATTRIBUTE(Q7B self, Q7B Attribute) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBSETTINGS(self))){ Q7B_EXCEPTION("QWebSettings expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Attribute))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebSettings(self).testAttribute((QWebSettings::WebAttribute) Q7B_IDqint64(Attribute)) );
}

void Q7B_QWEBVIEW_BACK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  Q7B_IDQWebView(self)->back();
}

Q7B Q7B_QWEBVIEW_FINDTEXT(Q7B self, Q7B SubString, Q7B Options) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(SubString))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Options))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebView(self)->findText(Q7B_IDQString(SubString), (QWebPage::FindFlags) Q7B_IDqint64(Options)) );
}

void Q7B_QWEBVIEW_FORWARD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  Q7B_IDQWebView(self)->forward();
}

Q7B Q7B_QWEBVIEW_HISTORY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebView(self)->history() );
}

Q7B Q7B_QWEBVIEW_ICON(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebView(self)->icon() );
}

Q7B Q7B_QWEBVIEW_ISMODIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebView(self)->isModified() );
}

void Q7B_QWEBVIEW_LOAD2(Q7B self, Q7B Request, Q7B Operation, Q7B Body) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  if (Q7B_nil(Q7B_QNETWORKREQUEST(Request))){ Q7B_EXCEPTION("QNetworkRequest expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Operation))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Body))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQWebView(self)->load(Q7B_IDQNetworkRequest(Request), (QNetworkAccessManager::Operation) Q7B_IDqint64(Operation), Q7B_IDQByteArray(Body));
}

Q7B Q7B_QWEBVIEW_MODIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebView(self)->isModified() );
}

void Q7B_QWEBVIEW_MODIFIED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  //Q7B_IDQWebView(self)->setModified(Q7B_IDbool(theProperty));
}

Q7B Q7B_QWEBVIEW_PAGE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebView(self)->page() );
}

void Q7B_QWEBVIEW_PRINT(Q7B self, Q7B Printer) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  if (Q7B_nil(Q7B_QPRINTER(Printer))){ Q7B_EXCEPTION("QPrinter expected"); return ; }

  Q7B_IDQWebView(self)->print(&Q7B_IDQPrinter(Printer));
}

void Q7B_QWEBVIEW_RELOAD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  Q7B_IDQWebView(self)->reload();
}

Q7B Q7B_QWEBVIEW_RENDERHINTS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebView(self)->renderHints() );
}

void Q7B_QWEBVIEW_RENDERHINTS(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQWebView(self)->setRenderHints((QPainter::RenderHints) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QWEBVIEW_SELECTEDTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebView(self)->selectedText() );
}

void Q7B_QWEBVIEW_SELECTEDTEXT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  //Q7B_IDQWebView(self)->setSelectedText(Q7B_IDQString(theProperty));
}

void Q7B_QWEBVIEW_SETPAGE(Q7B self, Q7B Page) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  if (Q7B_nil(Q7B_QWEBPAGE(Page))){ Q7B_EXCEPTION("QWebPage expected"); return ; }

  Q7B_IDQWebView(self)->setPage(Q7B_IDQWebPage(Page));
}

void Q7B_QWEBVIEW_SETTEXTSIZEMULTIPLIER(Q7B self, Q7B Factor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Factor))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQWebView(self)->setTextSizeMultiplier(Q7B_IDqreal(Factor));
}

void Q7B_QWEBVIEW_SETURL(Q7B self, Q7B Url) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  if (Q7B_nil(Q7B_QURL(Url))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  Q7B_IDQWebView(self)->setUrl(Q7B_IDQUrl(Url));
}

void Q7B_QWEBVIEW_SETZOOMFACTOR(Q7B self, Q7B Factor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Factor))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQWebView(self)->setZoomFactor(Q7B_IDqreal(Factor));
}

Q7B Q7B_QWEBVIEW_SETTINGS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebView(self)->settings() );
}

void Q7B_QWEBVIEW_STOP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  Q7B_IDQWebView(self)->stop();
}

Q7B Q7B_QWEBVIEW_TEXTSIZEMULTIPLIER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebView(self)->textSizeMultiplier() );
}

Q7B Q7B_QWEBVIEW_TITLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebView(self)->title() );
}

void Q7B_QWEBVIEW_TRIGGERPAGEACTION(Q7B self, Q7B Action, Q7B Checked) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Action))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Checked))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQWebView(self)->triggerPageAction((QWebPage::WebAction) Q7B_IDqint64(Action), Q7B_IDbool(Checked));
}

Q7B Q7B_QWEBVIEW_URL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebView(self)->url() );
}

Q7B Q7B_QWEBVIEW_ZOOMFACTOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWEBVIEW(self))){ Q7B_EXCEPTION("QWebView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWebView(self)->zoomFactor() );
}


Q7B Q7B_QABSTRACTSLIDER_HASTRACKING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSlider(self)->hasTracking() );
}

Q7B Q7B_QABSTRACTSLIDER_INVERTEDAPPEARANCE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSlider(self)->invertedAppearance() );
}

Q7B Q7B_QABSTRACTSLIDER_INVERTEDCONTROLS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSlider(self)->invertedControls() );
}

Q7B Q7B_QABSTRACTSLIDER_ISSLIDERDOWN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSlider(self)->isSliderDown() );
}

Q7B Q7B_QABSTRACTSLIDER_MAXIMUM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSlider(self)->maximum() );
}

Q7B Q7B_QABSTRACTSLIDER_MINIMUM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSlider(self)->minimum() );
}

Q7B Q7B_QABSTRACTSLIDER_ORIENTATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSlider(self)->orientation() );
}

Q7B Q7B_QABSTRACTSLIDER_PAGESTEP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSlider(self)->pageStep() );
}

void Q7B_QABSTRACTSLIDER_SETINVERTEDAPPEARANCE(Q7B self, Q7B Inverted) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Inverted))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAbstractSlider(self)->setInvertedAppearance(Q7B_IDbool(Inverted));
}

void Q7B_QABSTRACTSLIDER_SETINVERTEDCONTROLS(Q7B self, Q7B Inverted) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Inverted))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAbstractSlider(self)->setInvertedControls(Q7B_IDbool(Inverted));
}

void Q7B_QABSTRACTSLIDER_SETMAXIMUM(Q7B self, Q7B Maximum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Maximum))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractSlider(self)->setMaximum(Q7B_IDqint64(Maximum));
}

void Q7B_QABSTRACTSLIDER_SETMINIMUM(Q7B self, Q7B Minimum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Minimum))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractSlider(self)->setMinimum(Q7B_IDqint64(Minimum));
}

void Q7B_QABSTRACTSLIDER_SETORIENTATION(Q7B self, Q7B Orientation) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Orientation))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractSlider(self)->setOrientation((Qt::Orientation) Q7B_IDqint64(Orientation));
}

void Q7B_QABSTRACTSLIDER_SETPAGESTEP(Q7B self, Q7B Step) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Step))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractSlider(self)->setPageStep(Q7B_IDqint64(Step));
}

void Q7B_QABSTRACTSLIDER_SETRANGE(Q7B self, Q7B Min, Q7B Max) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Min))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Max))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractSlider(self)->setRange(Q7B_IDqint64(Min), Q7B_IDqint64(Max));
}

void Q7B_QABSTRACTSLIDER_SETSINGLESTEP(Q7B self, Q7B Step) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Step))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractSlider(self)->setSingleStep(Q7B_IDqint64(Step));
}

void Q7B_QABSTRACTSLIDER_SETSLIDERDOWN(Q7B self, Q7B Down) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Down))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractSlider(self)->setSliderDown(Q7B_IDqint64(Down));
}

void Q7B_QABSTRACTSLIDER_SETSLIDERPOSITION(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractSlider(self)->setSliderPosition(Q7B_IDqint64(Position));
}

void Q7B_QABSTRACTSLIDER_SETTRACKING(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Enable))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractSlider(self)->setTracking(Q7B_IDqint64(Enable));
}

void Q7B_QABSTRACTSLIDER_SETVALUE(Q7B self, Q7B Value) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Value))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractSlider(self)->setValue(Q7B_IDqint64(Value));
}

Q7B Q7B_QABSTRACTSLIDER_SINGLESTEP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSlider(self)->singleStep() );
}

void Q7B_QABSTRACTSLIDER_SINGLESTEP(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQAbstractSlider(self)->setSingleStep(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QABSTRACTSLIDER_SLIDERDOWN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSlider(self)->isSliderDown() );
}

void Q7B_QABSTRACTSLIDER_SLIDERDOWN(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQAbstractSlider(self)->setSliderDown(Q7B_IDbool(theProperty));
}

Q7B Q7B_QABSTRACTSLIDER_SLIDERPOSITION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSlider(self)->sliderPosition() );
}

Q7B Q7B_QABSTRACTSLIDER_TRACKING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSlider(self)->hasTracking() );
}

void Q7B_QABSTRACTSLIDER_TRACKING(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQAbstractSlider(self)->setTracking(Q7B_IDbool(theProperty));
}

Q7B Q7B_QABSTRACTSLIDER_VALUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSLIDER(self))){ Q7B_EXCEPTION("QAbstractSlider expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSlider(self)->value() );
}

void Q7B_QCOMBOBOX_ADDITEM(Q7B self, Q7B Icon, Q7B Text, Q7B UserData) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QVARIANT(UserData))){ Q7B_EXCEPTION("QVariant expected"); return ; }

  Q7B_IDQComboBox(self)->addItem(Q7B_IDQIcon(Icon), Q7B_IDQString(Text), Q7B_IDQVariant(UserData));
}

void Q7B_QCOMBOBOX_ADDITEMS(Q7B self, Q7B Texts) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Texts))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQComboBox(self)->addItems(Q7B_IDQStringList(Texts));
}

void Q7B_QCOMBOBOX_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  Q7B_IDQComboBox(self)->clear();
}

void Q7B_QCOMBOBOX_CLEAREDITTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  Q7B_IDQComboBox(self)->clearEditText();
}

Q7B Q7B_QCOMBOBOX_COUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->count() );
}

Q7B Q7B_QCOMBOBOX_CURRENTTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->currentText() );
}

Q7B Q7B_QCOMBOBOX_DUPLICATESENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->duplicatesEnabled() );
}

Q7B Q7B_QCOMBOBOX_EDITABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->isEditable() );
}

void Q7B_QCOMBOBOX_EDITABLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQComboBox(self)->setEditable(Q7B_IDbool(theProperty));
}

Q7B Q7B_QCOMBOBOX_FRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->hasFrame() );
}

void Q7B_QCOMBOBOX_FRAME(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQComboBox(self)->setFrame(Q7B_IDbool(theProperty));
}

Q7B Q7B_QCOMBOBOX_HASFRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->hasFrame() );
}

Q7B Q7B_QCOMBOBOX_ICONSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->iconSize() );
}

void Q7B_QCOMBOBOX_INSERTITEM(Q7B self, Q7B Index, Q7B Icon, Q7B Text, Q7B UserData) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QVARIANT(UserData))){ Q7B_EXCEPTION("QVariant expected"); return ; }

  Q7B_IDQComboBox(self)->insertItem(Q7B_IDqint64(Index), Q7B_IDQIcon(Icon), Q7B_IDQString(Text), Q7B_IDQVariant(UserData));
}

void Q7B_QCOMBOBOX_INSERTITEMS(Q7B self, Q7B Index, Q7B List) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(List))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQComboBox(self)->insertItems(Q7B_IDqint64(Index), Q7B_IDQStringList(List));
}

Q7B Q7B_QCOMBOBOX_INSERTPOLICY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->insertPolicy() );
}

void Q7B_QCOMBOBOX_INSERTSEPARATOR(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQComboBox(self)->insertSeparator(Q7B_IDqint64(Index));
}

Q7B Q7B_QCOMBOBOX_ISEDITABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->isEditable() );
}

Q7B Q7B_QCOMBOBOX_ITEMICON(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->itemIcon(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QCOMBOBOX_ITEMTEXT(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->itemText(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QCOMBOBOX_LINEEDIT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->lineEdit() );
}

Q7B Q7B_QCOMBOBOX_MAXCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->maxCount() );
}

Q7B Q7B_QCOMBOBOX_MAXVISIBLEITEMS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->maxVisibleItems() );
}

Q7B Q7B_QCOMBOBOX_MINIMUMCONTENTSLENGTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->minimumContentsLength() );
}

void Q7B_QCOMBOBOX_MINIMUMCONTENTSLENGTH(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQComboBox(self)->setMinimumContentsLength(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QCOMBOBOX_MODELCOLUMN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->modelColumn() );
}

void Q7B_QCOMBOBOX_REMOVEITEM(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQComboBox(self)->removeItem(Q7B_IDqint64(Index));
}

void Q7B_QCOMBOBOX_SETCURRENTINDEX(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQComboBox(self)->setCurrentIndex(Q7B_IDqint64(Index));
}

void Q7B_QCOMBOBOX_SETDUPLICATESENABLED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQComboBox(self)->setDuplicatesEnabled(Q7B_IDbool(Enable));
}

void Q7B_QCOMBOBOX_SETEDITTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQComboBox(self)->setEditText(Q7B_IDQString(Text));
}

void Q7B_QCOMBOBOX_SETEDITABLE(Q7B self, Q7B Editable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Editable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQComboBox(self)->setEditable(Q7B_IDbool(Editable));
}

void Q7B_QCOMBOBOX_SETFRAME(Q7B self, Q7B Frame) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Frame))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQComboBox(self)->setFrame(Q7B_IDbool(Frame));
}

void Q7B_QCOMBOBOX_SETICONSIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQComboBox(self)->setIconSize(Q7B_IDQSize(Size));
}

void Q7B_QCOMBOBOX_SETINSERTPOLICY(Q7B self, Q7B Policy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Policy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQComboBox(self)->setInsertPolicy((QComboBox::InsertPolicy) Q7B_IDqint64(Policy));
}

void Q7B_QCOMBOBOX_SETITEMICON(Q7B self, Q7B Index, Q7B Icon) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  Q7B_IDQComboBox(self)->setItemIcon(Q7B_IDqint64(Index), Q7B_IDQIcon(Icon));
}

void Q7B_QCOMBOBOX_SETITEMTEXT(Q7B self, Q7B Index, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQComboBox(self)->setItemText(Q7B_IDqint64(Index), Q7B_IDQString(Text));
}

void Q7B_QCOMBOBOX_SETLINEEDIT(Q7B self, Q7B Edit) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QLINEEDIT(Edit))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  Q7B_IDQComboBox(self)->setLineEdit(Q7B_IDQLineEdit(Edit));
}

void Q7B_QCOMBOBOX_SETMAXCOUNT(Q7B self, Q7B Max) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Max))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQComboBox(self)->setMaxCount(Q7B_IDqint64(Max));
}

void Q7B_QCOMBOBOX_SETMAXVISIBLEITEMS(Q7B self, Q7B MaxItems) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(MaxItems))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQComboBox(self)->setMaxVisibleItems(Q7B_IDqint64(MaxItems));
}

void Q7B_QCOMBOBOX_SETMINIMUMCONTENTSLENGTH(Q7B self, Q7B Characters) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Characters))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQComboBox(self)->setMinimumContentsLength(Q7B_IDqint64(Characters));
}

void Q7B_QCOMBOBOX_SETMODELCOLUMN(Q7B self, Q7B VisibleColumn) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(VisibleColumn))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQComboBox(self)->setModelColumn(Q7B_IDqint64(VisibleColumn));
}

void Q7B_QCOMBOBOX_SETSIZEADJUSTPOLICY(Q7B self, Q7B Policy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Policy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQComboBox(self)->setSizeAdjustPolicy((QComboBox::SizeAdjustPolicy) Q7B_IDqint64(Policy));
}

Q7B Q7B_QCOMBOBOX_SIZEADJUSTPOLICY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMBOBOX(self))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQComboBox(self)->sizeAdjustPolicy() );
}

Q7B Q7B_QCOMMANDLINKBUTTON_FLAT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMMANDLINKBUTTON(self))){ Q7B_EXCEPTION("QCommandLinkButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCommandLinkButton(self)->isFlat() );
}

void Q7B_QCOMMANDLINKBUTTON_FLAT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMMANDLINKBUTTON(self))){ Q7B_EXCEPTION("QCommandLinkButton expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQCommandLinkButton(self)->setFlat(Q7B_IDbool(theProperty));
}

void Q7B_QCOMMANDLINKBUTTON_SETDESCRIPTION(Q7B self, Q7B Description) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMMANDLINKBUTTON(self))){ Q7B_EXCEPTION("QCommandLinkButton expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Description))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQCommandLinkButton(self)->setDescription(Q7B_IDQString(Description));
}

Q7B Q7B_QLINEEDIT_ACCEPTABLEINPUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->hasAcceptableInput() );
}

void Q7B_QLINEEDIT_ACCEPTABLEINPUT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

//  Q7B_IDQLineEdit(self)->setAcceptableInput(Q7B_IDbool(theProperty));
}

void Q7B_QLINEEDIT_BACKSPACE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  Q7B_IDQLineEdit(self)->backspace();
}

void Q7B_QLINEEDIT_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  Q7B_IDQLineEdit(self)->clear();
}

void Q7B_QLINEEDIT_COPY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  Q7B_IDQLineEdit(self)->copy();
}

Q7B Q7B_QLINEEDIT_CREATESTANDARDCONTEXTMENU(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->createStandardContextMenu() );
}

void Q7B_QLINEEDIT_CURSORBACKWARD(Q7B self, Q7B Mark, Q7B Steps) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Mark))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Steps))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLineEdit(self)->cursorBackward(Q7B_IDbool(Mark), Q7B_IDqint64(Steps));
}

void Q7B_QLINEEDIT_CURSORFORWARD(Q7B self, Q7B Mark, Q7B Steps) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Mark))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Steps))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLineEdit(self)->cursorForward(Q7B_IDbool(Mark), Q7B_IDqint64(Steps));
}
/*
Q7B Q7B_QLINEEDIT_CURSORMOVESTYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->cursorMoveStyle() );
}*/

Q7B Q7B_QLINEEDIT_CURSORPOSITION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->cursorPosition() );
}

Q7B Q7B_QLINEEDIT_CURSORPOSITIONAT(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Pos))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->cursorPositionAt(Q7B_IDQPoint(Pos)) );
}

void Q7B_QLINEEDIT_CURSORWORDBACKWARD(Q7B self, Q7B Mark) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Mark))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQLineEdit(self)->cursorWordBackward(Q7B_IDbool(Mark));
}

void Q7B_QLINEEDIT_CURSORWORDFORWARD(Q7B self, Q7B Mark) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Mark))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQLineEdit(self)->cursorWordForward(Q7B_IDbool(Mark));
}

void Q7B_QLINEEDIT_CUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  Q7B_IDQLineEdit(self)->cut();
}

void Q7B_QLINEEDIT_DEL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  Q7B_IDQLineEdit(self)->del();
}

void Q7B_QLINEEDIT_DESELECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  Q7B_IDQLineEdit(self)->deselect();
}

Q7B Q7B_QLINEEDIT_DISPLAYTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->displayText() );
}

Q7B Q7B_QLINEEDIT_DRAGENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->dragEnabled() );
}

void Q7B_QLINEEDIT_END(Q7B self, Q7B Mark) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Mark))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQLineEdit(self)->end(Q7B_IDbool(Mark));
}

Q7B Q7B_QLINEEDIT_FRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->hasFrame() );
}

void Q7B_QLINEEDIT_FRAME(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQLineEdit(self)->setFrame(Q7B_IDbool(theProperty));
}

Q7B Q7B_QLINEEDIT_HASACCEPTABLEINPUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->hasAcceptableInput() );
}

Q7B Q7B_QLINEEDIT_HASFRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->hasFrame() );
}


Q7B Q7B_QLINEEDIT_HASSELECTEDTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->hasSelectedText() );
}

void Q7B_QLINEEDIT_HOME(Q7B self, Q7B Mark) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Mark))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQLineEdit(self)->home(Q7B_IDbool(Mark));
}

void Q7B_QLINEEDIT_INSERT(Q7B self, Q7B NewText) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(NewText))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQLineEdit(self)->insert(Q7B_IDQString(NewText));
}

Q7B Q7B_QLINEEDIT_ISMODIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->isModified() );
}

Q7B Q7B_QLINEEDIT_ISREADONLY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->isReadOnly() );
}

Q7B Q7B_QLINEEDIT_ISREDOAVAILABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->isRedoAvailable() );
}

Q7B Q7B_QLINEEDIT_ISUNDOAVAILABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->isUndoAvailable() );
}

Q7B Q7B_QLINEEDIT_MAXLENGTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->maxLength() );
}

Q7B Q7B_QLINEEDIT_MODIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->isModified() );
}

void Q7B_QLINEEDIT_MODIFIED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQLineEdit(self)->setModified(Q7B_IDbool(theProperty));
}

void Q7B_QLINEEDIT_PASTE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  Q7B_IDQLineEdit(self)->paste();
}

Q7B Q7B_QLINEEDIT_PLACEHOLDERTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->placeholderText() );
}

void Q7B_QLINEEDIT_REDO(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  Q7B_IDQLineEdit(self)->redo();
}

Q7B Q7B_QLINEEDIT_REDOAVAILABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->isRedoAvailable() );
}

void Q7B_QLINEEDIT_REDOAVAILABLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  //Q7B_IDQLineEdit(self)->setRedoAvailable(Q7B_IDbool(theProperty));
}

Q7B Q7B_QLINEEDIT_SELECTEDTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->selectedText() );
}

Q7B Q7B_QLINEEDIT_SELECTIONSTART(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->selectionStart() );
}

void Q7B_QLINEEDIT_SETALIGNMENT(Q7B self, Q7B Flag) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Flag))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLineEdit(self)->setAlignment((Qt::Alignment) Q7B_IDqint64(Flag));
}
/*
void Q7B_QLINEEDIT_SETCURSORMOVESTYLE(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLineEdit(self)->setCursorMoveStyle((Qt::CursorMoveStyle) Q7B_IDqint64(Style));
}*/

void Q7B_QLINEEDIT_SETCURSORPOSITION(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLineEdit(self)->setCursorPosition(Q7B_IDqint64(Position));
}

void Q7B_QLINEEDIT_SETDRAGENABLED(Q7B self, Q7B B) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(B))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQLineEdit(self)->setDragEnabled(Q7B_IDbool(B));
}

void Q7B_QLINEEDIT_SETECHOMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLineEdit(self)->setEchoMode((QLineEdit::EchoMode) Q7B_IDqint64(Mode));
}

void Q7B_QLINEEDIT_SETFRAME(Q7B self, Q7B Frame) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Frame))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQLineEdit(self)->setFrame(Q7B_IDbool(Frame));
}

void Q7B_QLINEEDIT_SETINPUTMASK(Q7B self, Q7B InputMask) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(InputMask))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQLineEdit(self)->setInputMask(Q7B_IDQString(InputMask));
}

void Q7B_QLINEEDIT_SETMAXLENGTH(Q7B self, Q7B Length) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Length))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLineEdit(self)->setMaxLength(Q7B_IDqint64(Length));
}

void Q7B_QLINEEDIT_SETMODIFIED(Q7B self, Q7B Modified) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Modified))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQLineEdit(self)->setModified(Q7B_IDbool(Modified));
}

void Q7B_QLINEEDIT_SETPLACEHOLDERTEXT(Q7B self, Q7B PlaceHolder) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(PlaceHolder))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQLineEdit(self)->setPlaceholderText(Q7B_IDQString(PlaceHolder));
}

void Q7B_QLINEEDIT_SETREADONLY(Q7B self, Q7B Ro) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Ro))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQLineEdit(self)->setReadOnly(Q7B_IDbool(Ro));
}

void Q7B_QLINEEDIT_SETSELECTION(Q7B self, Q7B Start, Q7B Length) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Start))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Length))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLineEdit(self)->setSelection(Q7B_IDqint64(Start), Q7B_IDqint64(Length));
}

void Q7B_QLINEEDIT_SETTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQLineEdit(self)->setText(Q7B_IDQString(Text));
}

void Q7B_QLINEEDIT_SETTEXTMARGINS(Q7B self, Q7B Left, Q7B Top, Q7B Right, Q7B Bottom) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Left))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Top))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Right))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Bottom))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLineEdit(self)->setTextMargins(Q7B_IDqint64(Left), Q7B_IDqint64(Top), Q7B_IDqint64(Right), Q7B_IDqint64(Bottom));
}

void Q7B_QLINEEDIT_UNDO(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  Q7B_IDQLineEdit(self)->undo();
}

Q7B Q7B_QLINEEDIT_UNDOAVAILABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLineEdit(self)->isUndoAvailable() );
}

void Q7B_QLINEEDIT_UNDOAVAILABLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINEEDIT(self))){ Q7B_EXCEPTION("QLineEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  //Q7B_IDQLineEdit(self)->setUndoAvailable(Q7B_IDbool(theProperty));
}

Q7B Q7B_QPLAINTEXTEDIT_ANCHORAT(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Pos))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->anchorAt(Q7B_IDQPoint(Pos)) );
}

void Q7B_QPLAINTEXTEDIT_APPENDHTML(Q7B self, Q7B Html) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Html))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->appendHtml(Q7B_IDQString(Html));
}

Q7B Q7B_QPLAINTEXTEDIT_BACKGROUNDVISIBLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->backgroundVisible() );
}

Q7B Q7B_QPLAINTEXTEDIT_BLOCKCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->blockCount() );
}

Q7B Q7B_QPLAINTEXTEDIT_CANPASTE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->canPaste() );
}

void Q7B_QPLAINTEXTEDIT_CENTERCURSOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->centerCursor();
}

Q7B Q7B_QPLAINTEXTEDIT_CENTERONSCROLL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->centerOnScroll() );
}

void Q7B_QPLAINTEXTEDIT_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->clear();
}

void Q7B_QPLAINTEXTEDIT_COPY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->copy();
}

Q7B Q7B_QPLAINTEXTEDIT_CREATESTANDARDCONTEXTMENU(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->createStandardContextMenu() );
}

Q7B Q7B_QPLAINTEXTEDIT_CURSORFORPOSITION(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Pos))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->cursorForPosition(Q7B_IDQPoint(Pos)) );
}

Q7B Q7B_QPLAINTEXTEDIT_CURSORWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->cursorWidth() );
}

void Q7B_QPLAINTEXTEDIT_CUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->cut();
}

Q7B Q7B_QPLAINTEXTEDIT_DOCUMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->document() );
}

Q7B Q7B_QPLAINTEXTEDIT_DOCUMENTTITLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->documentTitle() );
}

void Q7B_QPLAINTEXTEDIT_ENSURECURSORVISIBLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->ensureCursorVisible();
}

Q7B Q7B_QPLAINTEXTEDIT_FIND(Q7B self, Q7B Exp, Q7B Options) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Exp))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Options))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->find(Q7B_IDQString(Exp), (QTextDocument::FindFlags) Q7B_IDqint64(Options)) );
}

Q7B Q7B_QPLAINTEXTEDIT_ISREADONLY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->isReadOnly() );
}

Q7B Q7B_QPLAINTEXTEDIT_ISUNDOREDOENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->isUndoRedoEnabled() );
}

Q7B Q7B_QPLAINTEXTEDIT_LINEWRAPMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->lineWrapMode() );
}

Q7B Q7B_QPLAINTEXTEDIT_MAXIMUMBLOCKCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->maximumBlockCount() );
}

void Q7B_QPLAINTEXTEDIT_MOVECURSOR(Q7B self, Q7B Operation, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Operation))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->moveCursor((QTextCursor::MoveOperation) Q7B_IDqint64(Operation), (QTextCursor::MoveMode) Q7B_IDqint64(Mode));
}

Q7B Q7B_QPLAINTEXTEDIT_OVERWRITEMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->overwriteMode() );
}

void Q7B_QPLAINTEXTEDIT_PASTE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->paste();
}

void Q7B_QPLAINTEXTEDIT_PRINT(Q7B self, Q7B Printer) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QPRINTER(Printer))){ Q7B_EXCEPTION("QPrinter expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->print(&Q7B_IDQPrinter(Printer));
}

void Q7B_QPLAINTEXTEDIT_REDO(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->redo();
}

void Q7B_QPLAINTEXTEDIT_SELECTALL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->selectAll();
}

void Q7B_QPLAINTEXTEDIT_SETBACKGROUNDVISIBLE(Q7B self, Q7B Visible) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Visible))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setBackgroundVisible(Q7B_IDbool(Visible));
}

void Q7B_QPLAINTEXTEDIT_SETCENTERONSCROLL(Q7B self, Q7B Enabled) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enabled))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setCenterOnScroll(Q7B_IDbool(Enabled));
}

void Q7B_QPLAINTEXTEDIT_SETCURSORWIDTH(Q7B self, Q7B Width) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setCursorWidth(Q7B_IDqint64(Width));
}

void Q7B_QPLAINTEXTEDIT_SETDOCUMENT(Q7B self, Q7B Document) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTDOCUMENT(Document))){ Q7B_EXCEPTION("QTextDocument expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setDocument(Q7B_IDQTextDocument(Document));
}

void Q7B_QPLAINTEXTEDIT_SETDOCUMENTTITLE(Q7B self, Q7B Title) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Title))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setDocumentTitle(Q7B_IDQString(Title));
}

void Q7B_QPLAINTEXTEDIT_SETLINEWRAPMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setLineWrapMode((QPlainTextEdit::LineWrapMode) Q7B_IDqint64(Mode));
}

void Q7B_QPLAINTEXTEDIT_SETMAXIMUMBLOCKCOUNT(Q7B self, Q7B Maximum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Maximum))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setMaximumBlockCount(Q7B_IDqint64(Maximum));
}

void Q7B_QPLAINTEXTEDIT_SETOVERWRITEMODE(Q7B self, Q7B Overwrite) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Overwrite))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setOverwriteMode(Q7B_IDbool(Overwrite));
}

void Q7B_QPLAINTEXTEDIT_SETPLAINTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setPlainText(Q7B_IDQString(Text));
}

void Q7B_QPLAINTEXTEDIT_SETREADONLY(Q7B self, Q7B Ro) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Ro))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setReadOnly(Q7B_IDbool(Ro));
}

void Q7B_QPLAINTEXTEDIT_SETTABCHANGESFOCUS(Q7B self, Q7B B) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(B))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setTabChangesFocus(Q7B_IDbool(B));
}

void Q7B_QPLAINTEXTEDIT_SETTABSTOPWIDTH(Q7B self, Q7B Width) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setTabStopWidth(Q7B_IDqint64(Width));
}

void Q7B_QPLAINTEXTEDIT_SETTEXTCURSOR(Q7B self, Q7B Cursor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTCURSOR(Cursor))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setTextCursor(Q7B_IDQTextCursor(Cursor));
}

void Q7B_QPLAINTEXTEDIT_SETTEXTINTERACTIONFLAGS(Q7B self, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setTextInteractionFlags((Qt::TextInteractionFlags) Q7B_IDqint64(Flags));
}

void Q7B_QPLAINTEXTEDIT_SETUNDOREDOENABLED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->setUndoRedoEnabled(Q7B_IDbool(Enable));
}

Q7B Q7B_QPLAINTEXTEDIT_TABCHANGESFOCUS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->tabChangesFocus() );
}

Q7B Q7B_QPLAINTEXTEDIT_TABSTOPWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->tabStopWidth() );
}

Q7B Q7B_QPLAINTEXTEDIT_TEXTCURSOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->textCursor() );
}

Q7B Q7B_QPLAINTEXTEDIT_TEXTINTERACTIONFLAGS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->textInteractionFlags() );
}

Q7B Q7B_QPLAINTEXTEDIT_TOPLAINTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->toPlainText() );
}

void Q7B_QPLAINTEXTEDIT_UNDO(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  Q7B_IDQPlainTextEdit(self)->undo();
}

Q7B Q7B_QPLAINTEXTEDIT_UNDOREDOENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->isUndoRedoEnabled() );
}

void Q7B_QPLAINTEXTEDIT_UNDOREDOENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQPlainTextEdit(self)->setUndoRedoEnabled(Q7B_IDbool(theProperty));
}

Q7B Q7B_QPLAINTEXTEDIT_WORDWRAPMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(self))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPlainTextEdit(self)->wordWrapMode() );
}

Q7B Q7B_QSTACKEDWIDGET_ADDWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTACKEDWIDGET(self))){ Q7B_EXCEPTION("QStackedWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStackedWidget(self)->addWidget(Q7B_IDQWidget(Widget)) );
}

Q7B Q7B_QSTACKEDWIDGET_COUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTACKEDWIDGET(self))){ Q7B_EXCEPTION("QStackedWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStackedWidget(self)->count() );
}

Q7B Q7B_QSTACKEDWIDGET_INDEXOF(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTACKEDWIDGET(self))){ Q7B_EXCEPTION("QStackedWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStackedWidget(self)->indexOf(Q7B_IDQWidget(Widget)) );
}

Q7B Q7B_QSTACKEDWIDGET_INSERTWIDGET(Q7B self, Q7B Index, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTACKEDWIDGET(self))){ Q7B_EXCEPTION("QStackedWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStackedWidget(self)->insertWidget(Q7B_IDqint64(Index), Q7B_IDQWidget(Widget)) );
}

void Q7B_QSTACKEDWIDGET_REMOVEWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTACKEDWIDGET(self))){ Q7B_EXCEPTION("QStackedWidget expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQStackedWidget(self)->removeWidget(Q7B_IDQWidget(Widget));
}

void Q7B_QSTACKEDWIDGET_SETCURRENTINDEX(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTACKEDWIDGET(self))){ Q7B_EXCEPTION("QStackedWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQStackedWidget(self)->setCurrentIndex(Q7B_IDqint64(Index));
}

void Q7B_QSTACKEDWIDGET_SETCURRENTWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTACKEDWIDGET(self))){ Q7B_EXCEPTION("QStackedWidget expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQStackedWidget(self)->setCurrentWidget(Q7B_IDQWidget(Widget));
}

Q7B Q7B_QSTACKEDWIDGET_WIDGET(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTACKEDWIDGET(self))){ Q7B_EXCEPTION("QStackedWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStackedWidget(self)->widget(Q7B_IDqint64(Index)) );
}

void Q7B_QSTRINGLIST_APPEND(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTRINGLIST(self))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQStringList(self).append(Q7B_IDQString(Str));
}

Q7B Q7B_QSTRINGLIST_CONTAINS(Q7B self, Q7B Str, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRINGLIST(self))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStringList(self).contains(Q7B_IDQString(Str), (Qt::CaseSensitivity) Q7B_IDqint64(Cs)) );
}

Q7B Q7B_QSTRINGLIST_FILTER(Q7B self, Q7B Rx) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRINGLIST(self))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGEXP(Rx))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStringList(self).filter(Q7B_IDQRegExp(Rx)) );
}

Q7B Q7B_QSTRINGLIST_INDEXOF(Q7B self, Q7B Value, Q7B From) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRINGLIST(self))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(From))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStringList(self).indexOf(Q7B_IDQString(Value), Q7B_IDqint64(From)) );
}

Q7B Q7B_QSTRINGLIST_JOIN(Q7B self, Q7B Separator) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRINGLIST(self))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Separator))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStringList(self).join(Q7B_IDQString(Separator)) );
}

Q7B Q7B_QSTRINGLIST_LASTINDEXOF(Q7B self, Q7B Value, Q7B From) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRINGLIST(self))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(From))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStringList(self).lastIndexOf(Q7B_IDQString(Value), Q7B_IDqint64(From)) );
}

Q7B Q7B_QSTRINGLIST_REMOVEDUPLICATES(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRINGLIST(self))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStringList(self).removeDuplicates() );
}

Q7B Q7B_QSTRINGLIST_REPLACEINSTRINGS(Q7B self, Q7B Rx, Q7B After) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRINGLIST(self))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGEXP(Rx))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(After))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStringList(self).replaceInStrings(Q7B_IDQRegExp(Rx), Q7B_IDQString(After)) );
}

void Q7B_QSTRINGLIST_SORT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTRINGLIST(self))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQStringList(self).sort();
}

Q7B Q7B_QTABWIDGET_ADDTAB(Q7B self, Q7B Page, Q7B Icon, Q7B Label) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Page))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Label))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->addTab(Q7B_IDQWidget(Page), Q7B_IDQIcon(Icon), Q7B_IDQString(Label)) );
}

void Q7B_QTABWIDGET_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  Q7B_IDQTabWidget(self)->clear();
}

Q7B Q7B_QTABWIDGET_CURRENTWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->currentWidget() );
}

Q7B Q7B_QTABWIDGET_DOCUMENTMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->documentMode() );
}

Q7B Q7B_QTABWIDGET_ELIDEMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->elideMode() );
}

Q7B Q7B_QTABWIDGET_ICONSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->iconSize() );
}

Q7B Q7B_QTABWIDGET_INDEXOF(Q7B self, Q7B W) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(W))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->indexOf(Q7B_IDQWidget(W)) );
}

Q7B Q7B_QTABWIDGET_INSERTTAB(Q7B self, Q7B Index, Q7B Page, Q7B Icon, Q7B Label) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Page))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Label))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->insertTab(Q7B_IDqint64(Index), Q7B_IDQWidget(Page), Q7B_IDQIcon(Icon), Q7B_IDQString(Label)) );
}

Q7B Q7B_QTABWIDGET_ISMOVABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->isMovable() );
}

Q7B Q7B_QTABWIDGET_ISTABENABLED(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->isTabEnabled(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTABWIDGET_MOVABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->isMovable() );
}

void Q7B_QTABWIDGET_MOVABLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTabWidget(self)->setMovable(Q7B_IDbool(theProperty));
}

void Q7B_QTABWIDGET_REMOVETAB(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTabWidget(self)->removeTab(Q7B_IDqint64(Index));
}

void Q7B_QTABWIDGET_SETCURRENTINDEX(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTabWidget(self)->setCurrentIndex(Q7B_IDqint64(Index));
}

void Q7B_QTABWIDGET_SETCURRENTWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQTabWidget(self)->setCurrentWidget(Q7B_IDQWidget(Widget));
}

void Q7B_QTABWIDGET_SETDOCUMENTMODE(Q7B self, Q7B Set) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Set))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTabWidget(self)->setDocumentMode(Q7B_IDbool(Set));
}

void Q7B_QTABWIDGET_SETELIDEMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTabWidget(self)->setElideMode((Qt::TextElideMode) Q7B_IDqint64(Mode));
}

void Q7B_QTABWIDGET_SETICONSIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQTabWidget(self)->setIconSize(Q7B_IDQSize(Size));
}

void Q7B_QTABWIDGET_SETMOVABLE(Q7B self, Q7B Movable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Movable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTabWidget(self)->setMovable(Q7B_IDbool(Movable));
}

void Q7B_QTABWIDGET_SETTABENABLED(Q7B self, Q7B Index, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTabWidget(self)->setTabEnabled(Q7B_IDqint64(Index), Q7B_IDbool(Enable));
}

void Q7B_QTABWIDGET_SETTABICON(Q7B self, Q7B Index, Q7B Icon) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  Q7B_IDQTabWidget(self)->setTabIcon(Q7B_IDqint64(Index), Q7B_IDQIcon(Icon));
}

void Q7B_QTABWIDGET_SETTABPOSITION(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTabWidget(self)->setTabPosition((QTabWidget::TabPosition) Q7B_IDqint64(Position));
}

void Q7B_QTABWIDGET_SETTABSHAPE(Q7B self, Q7B Shape) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Shape))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTabWidget(self)->setTabShape((QTabWidget::TabShape) Q7B_IDqint64(Shape));
}

void Q7B_QTABWIDGET_SETTABTEXT(Q7B self, Q7B Index, Q7B Label) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Label))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTabWidget(self)->setTabText(Q7B_IDqint64(Index), Q7B_IDQString(Label));
}

void Q7B_QTABWIDGET_SETTABTOOLTIP(Q7B self, Q7B Index, Q7B Tip) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Tip))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTabWidget(self)->setTabToolTip(Q7B_IDqint64(Index), Q7B_IDQString(Tip));
}

void Q7B_QTABWIDGET_SETTABWHATSTHIS(Q7B self, Q7B Index, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTabWidget(self)->setTabWhatsThis(Q7B_IDqint64(Index), Q7B_IDQString(Text));
}

void Q7B_QTABWIDGET_SETTABSCLOSABLE(Q7B self, Q7B Closeable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Closeable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTabWidget(self)->setTabsClosable(Q7B_IDbool(Closeable));
}

void Q7B_QTABWIDGET_SETUSESSCROLLBUTTONS(Q7B self, Q7B UseButtons) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(UseButtons))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTabWidget(self)->setUsesScrollButtons(Q7B_IDbool(UseButtons));
}

Q7B Q7B_QTABWIDGET_TABICON(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->tabIcon(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTABWIDGET_TABPOSITION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->tabPosition() );
}

Q7B Q7B_QTABWIDGET_TABSHAPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->tabShape() );
}

Q7B Q7B_QTABWIDGET_TABTEXT(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->tabText(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTABWIDGET_TABTOOLTIP(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->tabToolTip(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTABWIDGET_TABWHATSTHIS(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->tabWhatsThis(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTABWIDGET_TABSCLOSABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->tabsClosable() );
}

Q7B Q7B_QTABWIDGET_USESSCROLLBUTTONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABWIDGET(self))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTabWidget(self)->usesScrollButtons() );
}

Q7B Q7B_QTABLEWIDGET_ALTERNATINGROWCOLORS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->alternatingRowColors() );
}

Q7B Q7B_QTABLEWIDGET_AUTOSCROLL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->hasAutoScroll() );
}

void Q7B_QTABLEWIDGET_AUTOSCROLL(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTableWidget(self)->setAutoScroll(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTABLEWIDGET_AUTOSCROLLMARGIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->autoScrollMargin() );
}

Q7B Q7B_QTABLEWIDGET_CELLWIDGET(Q7B self, Q7B Row, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->cellWidget(Q7B_IDqint64(Row), Q7B_IDqint64(Column)) );
}

void Q7B_QTABLEWIDGET_CLEARSELECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  Q7B_IDQTableWidget(self)->clearSelection();
}

void Q7B_QTABLEWIDGET_CLOSEPERSISTENTEDITOR(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  Q7B_IDQTableWidget(self)->closePersistentEditor(&Q7B_IDQTableWidgetItem(Item));
}

Q7B Q7B_QTABLEWIDGET_COLORCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->colorCount() );
}

Q7B Q7B_QTABLEWIDGET_CURRENTCOLUMN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->currentColumn() );
}
Q7B Q7B_QTABLEWIDGET_CURRENTITEM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->currentItem() );
}

Q7B Q7B_QTABLEWIDGET_DEFAULTDROPACTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->defaultDropAction() );
}

Q7B Q7B_QTABLEWIDGET_DEPTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->depth() );
}

Q7B Q7B_QTABLEWIDGET_DRAGDROPMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->dragDropMode() );
}

Q7B Q7B_QTABLEWIDGET_DRAGDROPOVERWRITEMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->dragDropOverwriteMode() );
}

Q7B Q7B_QTABLEWIDGET_DRAGENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->dragEnabled() );
}

void Q7B_QTABLEWIDGET_EDITITEM(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  Q7B_IDQTableWidget(self)->editItem(&Q7B_IDQTableWidgetItem(Item));
}

Q7B Q7B_QTABLEWIDGET_EDITTRIGGERS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->editTriggers() );
}

Q7B Q7B_QTABLEWIDGET_FINDITEMS(Q7B self, Q7B Text, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QList<QTableWidgetItem*> o = Q7B_IDQTableWidget(self)->findItems(Q7B_IDQString(Text), (Qt::MatchFlags) Q7B_IDqint64(Flags));

  Q7B_List *l = new Q7B_List(); 
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), l)); 

  for (int i = 0; i < o.size(); i++){    
    Q7B qq (new Q7B_id(typeid(QTableWidget).name(), o.at(i))); 
    l->append(qq);
  }

  return q;
  //return Q7B_ID( Q7B_IDQTableWidget(self)->findItems(Q7B_IDQString(Text), (Qt::MatchFlags) Q7B_IDqint64(Flags)) );
}

Q7B Q7B_QTABLEWIDGET_HASAUTOSCROLL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->hasAutoScroll() );
}

Q7B Q7B_QTABLEWIDGET_HEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->height() );
}

Q7B Q7B_QTABLEWIDGET_HEIGHTMM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->heightMM() );
}

Q7B Q7B_QTABLEWIDGET_HORIZONTALHEADERITEM(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->horizontalHeaderItem(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTABLEWIDGET_HORIZONTALSCROLLMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->horizontalScrollMode() );
}

Q7B Q7B_QTABLEWIDGET_ICONSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->iconSize() );
}

void Q7B_QTABLEWIDGET_INSERTCOLUMN(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->insertColumn(Q7B_IDqint64(Column));
}

void Q7B_QTABLEWIDGET_INSERTROW(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->insertRow(Q7B_IDqint64(Row));
}

Q7B Q7B_QTABLEWIDGET_ITEMAT(Q7B self, Q7B Ax, Q7B Ay) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Ax))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Ay))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->itemAt(Q7B_IDqint64(Ax), Q7B_IDqint64(Ay)) );
}

void Q7B_QTABLEWIDGET_REMOVECELLWIDGET(Q7B self, Q7B Row, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->removeCellWidget(Q7B_IDqint64(Row), Q7B_IDqint64(Column));
}

void Q7B_QTABLEWIDGET_REMOVECOLUMN(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->removeColumn(Q7B_IDqint64(Column));
}

void Q7B_QTABLEWIDGET_RESET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  Q7B_IDQTableWidget(self)->reset();
}

void Q7B_QTABLEWIDGET_SCROLLTOBOTTOM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  Q7B_IDQTableWidget(self)->scrollToBottom();
}

void Q7B_QTABLEWIDGET_SCROLLTOITEM(Q7B self, Q7B Item, Q7B Hint) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Hint))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->scrollToItem(&Q7B_IDQTableWidgetItem(Item), (QAbstractItemView::ScrollHint) Q7B_IDqint64(Hint));
}

void Q7B_QTABLEWIDGET_SCROLLTOTOP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  Q7B_IDQTableWidget(self)->scrollToTop();
}

void Q7B_QTABLEWIDGET_SELECTALL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  Q7B_IDQTableWidget(self)->selectAll();
}

Q7B Q7B_QTABLEWIDGET_SELECTEDITEMS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }


  QList<QTableWidgetItem*> o = Q7B_IDQTableWidget(self)->selectedItems();

  Q7B_List *l = new Q7B_List(); 
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), l)); 

  for (int i = 0; i < o.size(); i++){    
    Q7B qq (new Q7B_id(typeid(QTableWidget).name(), o.at(i))); 
    l->append(qq);
  }

  return q;
  //return Q7B_ID( Q7B_IDQTableWidget(self)->selectedItems() );
}

Q7B Q7B_QTABLEWIDGET_SELECTIONBEHAVIOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->selectionBehavior() );
}

Q7B Q7B_QTABLEWIDGET_SELECTIONMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->selectionMode() );
}

Q7B Q7B_QTABLEWIDGET_SELECTIONMODEL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->selectionModel() );
}

void Q7B_QTABLEWIDGET_SETALTERNATINGROWCOLORS(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTableWidget(self)->setAlternatingRowColors(Q7B_IDbool(Enable));
}

void Q7B_QTABLEWIDGET_SETAUTOSCROLL(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTableWidget(self)->setAutoScroll(Q7B_IDbool(Enable));
}

void Q7B_QTABLEWIDGET_SETAUTOSCROLLMARGIN(Q7B self, Q7B Margin) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Margin))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->setAutoScrollMargin(Q7B_IDqint64(Margin));
}

void Q7B_QTABLEWIDGET_SETCELLWIDGET(Q7B self, Q7B Row, Q7B Column, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQTableWidget(self)->setCellWidget(Q7B_IDqint64(Row), Q7B_IDqint64(Column), Q7B_IDQWidget(Widget));
}

void Q7B_QTABLEWIDGET_SETCOLUMNCOUNT(Q7B self, Q7B Columns) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Columns))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->setColumnCount(Q7B_IDqint64(Columns));
}

void Q7B_QTABLEWIDGET_SETCURRENTITEM(Q7B self, Q7B Item, Q7B a1) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(a1))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->setCurrentItem(&Q7B_IDQTableWidgetItem(Item), (QItemSelectionModel::SelectionFlags) Q7B_IDqint64(a1));
}

void Q7B_QTABLEWIDGET_SETDEFAULTDROPACTION(Q7B self, Q7B DropAction) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(DropAction))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->setDefaultDropAction((Qt::DropAction) Q7B_IDqint64(DropAction));
}

void Q7B_QTABLEWIDGET_SETDRAGDROPMODE(Q7B self, Q7B Behavior) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Behavior))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->setDragDropMode((QTableWidget::DragDropMode) Q7B_IDqint64(Behavior));
}

void Q7B_QTABLEWIDGET_SETDRAGDROPOVERWRITEMODE(Q7B self, Q7B Overwrite) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Overwrite))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTableWidget(self)->setDragDropOverwriteMode(Q7B_IDbool(Overwrite));
}

void Q7B_QTABLEWIDGET_SETDRAGENABLED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTableWidget(self)->setDragEnabled(Q7B_IDbool(Enable));
}

void Q7B_QTABLEWIDGET_SETDROPINDICATORSHOWN(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTableWidget(self)->setDropIndicatorShown(Q7B_IDbool(Enable));
}

void Q7B_QTABLEWIDGET_SETEDITTRIGGERS(Q7B self, Q7B Triggers) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Triggers))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->setEditTriggers((QTableWidget::EditTriggers) Q7B_IDqint64(Triggers));
}

void Q7B_QTABLEWIDGET_SETHORIZONTALHEADERITEM(Q7B self, Q7B Column, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  Q7B_IDQTableWidget(self)->setHorizontalHeaderItem(Q7B_IDqint64(Column), &Q7B_IDQTableWidgetItem(Item));
}

void Q7B_QTABLEWIDGET_SETHORIZONTALHEADERLABELS(Q7B self, Q7B Labels) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Labels))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQTableWidget(self)->setHorizontalHeaderLabels(Q7B_IDQStringList(Labels));
}

void Q7B_QTABLEWIDGET_SETICONSIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQTableWidget(self)->setIconSize(Q7B_IDQSize(Size));
}

void Q7B_QTABLEWIDGET_SETROWCOUNT(Q7B self, Q7B Rows) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Rows))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->setRowCount(Q7B_IDqint64(Rows));
}

void Q7B_QTABLEWIDGET_SETSELECTIONBEHAVIOR(Q7B self, Q7B Behavior) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Behavior))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->setSelectionBehavior((QAbstractItemView::SelectionBehavior) Q7B_IDqint64(Behavior));
}

void Q7B_QTABLEWIDGET_SETSELECTIONMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->setSelectionMode((QAbstractItemView::SelectionMode) Q7B_IDqint64(Mode));
}

void Q7B_QTABLEWIDGET_SETTABKEYNAVIGATION(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTableWidget(self)->setTabKeyNavigation(Q7B_IDbool(Enable));
}

void Q7B_QTABLEWIDGET_SETTEXTELIDEMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->setTextElideMode((Qt::TextElideMode) Q7B_IDqint64(Mode));
}

void Q7B_QTABLEWIDGET_SETVERTICALHEADERITEM(Q7B self, Q7B Row, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(Item))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  Q7B_IDQTableWidget(self)->setVerticalHeaderItem(Q7B_IDqint64(Row), &Q7B_IDQTableWidgetItem(Item));
}

void Q7B_QTABLEWIDGET_SETVERTICALHEADERLABELS(Q7B self, Q7B Labels) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Labels))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQTableWidget(self)->setVerticalHeaderLabels(Q7B_IDQStringList(Labels));
}

void Q7B_QTABLEWIDGET_SETVERTICALSCROLLMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidget(self)->setVerticalScrollMode((QTableWidget::ScrollMode) Q7B_IDqint64(Mode));
}

Q7B Q7B_QTABLEWIDGET_SHOWDROPINDICATOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->showDropIndicator() );
}

Q7B Q7B_QTABLEWIDGET_TABKEYNAVIGATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->tabKeyNavigation() );
}

Q7B Q7B_QTABLEWIDGET_TAKEHORIZONTALHEADERITEM(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->takeHorizontalHeaderItem(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTABLEWIDGET_TAKEITEM(Q7B self, Q7B Row, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->takeItem(Q7B_IDqint64(Row), Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTABLEWIDGET_TAKEVERTICALHEADERITEM(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->takeVerticalHeaderItem(Q7B_IDqint64(Row)) );
}

Q7B Q7B_QTABLEWIDGET_TEXTELIDEMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->textElideMode() );
}

Q7B Q7B_QTABLEWIDGET_VERTICALHEADERITEM(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->verticalHeaderItem(Q7B_IDqint64(Row)) );
}

Q7B Q7B_QTABLEWIDGET_VERTICALSCROLLMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->verticalScrollMode() );
}

Q7B Q7B_QTABLEWIDGET_WIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->width() );
}

Q7B Q7B_QTABLEWIDGET_WIDTHMM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGET(self))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidget(self)->widthMM() );
}

void Q7B_QTREEWIDGETITEM_ADDCHILD(Q7B self, Q7B Child) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Child))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).addChild(&Q7B_IDQTreeWidgetItem(Child));
}

Q7B Q7B_QTREEWIDGETITEM_BACKGROUND(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).background(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTREEWIDGETITEM_CHECKSTATE(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).checkState(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTREEWIDGETITEM_CHILD(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).child(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTREEWIDGETITEM_CHILDCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).childCount() );
}

Q7B Q7B_QTREEWIDGETITEM_CHILDINDICATORPOLICY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).childIndicatorPolicy() );
}

Q7B Q7B_QTREEWIDGETITEM_CLONE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).clone() );
}

Q7B Q7B_QTREEWIDGETITEM_COLUMNCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).columnCount() );
}

Q7B Q7B_QTREEWIDGETITEM_FLAGS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).flags() );
}

Q7B Q7B_QTREEWIDGETITEM_FONT(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).font(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTREEWIDGETITEM_FOREGROUND(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).foreground(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTREEWIDGETITEM_ICON(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).icon(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTREEWIDGETITEM_INDEXOFCHILD(Q7B self, Q7B Child) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Child))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).indexOfChild(&Q7B_IDQTreeWidgetItem(Child)) );
}

void Q7B_QTREEWIDGETITEM_INSERTCHILD(Q7B self, Q7B Index, Q7B Child) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Child))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).insertChild(Q7B_IDqint64(Index), &Q7B_IDQTreeWidgetItem(Child));
}

Q7B Q7B_QTREEWIDGETITEM_ISDISABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).isDisabled() );
}

Q7B Q7B_QTREEWIDGETITEM_ISEXPANDED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).isExpanded() );
}

Q7B Q7B_QTREEWIDGETITEM_ISFIRSTCOLUMNSPANNED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).isFirstColumnSpanned() );
}

Q7B Q7B_QTREEWIDGETITEM_ISHIDDEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).isHidden() );
}

Q7B Q7B_QTREEWIDGETITEM_ISSELECTED (Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).isSelected () );
}

Q7B Q7B_QTREEWIDGETITEM_PARENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).parent() );
}

void Q7B_QTREEWIDGETITEM_REMOVECHILD(Q7B self, Q7B Child) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QTREEWIDGETITEM(Child))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).removeChild(&Q7B_IDQTreeWidgetItem(Child));
}

void Q7B_QTREEWIDGETITEM_SETBACKGROUND(Q7B self, Q7B Column, Q7B Brush) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QBRUSH(Brush))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setBackground(Q7B_IDqint64(Column), Q7B_IDQBrush(Brush));
}

void Q7B_QTREEWIDGETITEM_SETCHECKSTATE(Q7B self, Q7B Column, Q7B State) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(State))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setCheckState(Q7B_IDqint64(Column), (Qt::CheckState) Q7B_IDqint64(State));
}

void Q7B_QTREEWIDGETITEM_SETCHILDINDICATORPOLICY(Q7B self, Q7B Policy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Policy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setChildIndicatorPolicy((QTreeWidgetItem::ChildIndicatorPolicy) Q7B_IDqint64(Policy));
}

void Q7B_QTREEWIDGETITEM_SETDISABLED(Q7B self, Q7B Disabled) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Disabled))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setDisabled(Q7B_IDbool(Disabled));
}

void Q7B_QTREEWIDGETITEM_SETEXPANDED(Q7B self, Q7B Expand) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Expand))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setExpanded(Q7B_IDbool(Expand));
}

void Q7B_QTREEWIDGETITEM_SETFIRSTCOLUMNSPANNED(Q7B self, Q7B Span) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Span))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setFirstColumnSpanned(Q7B_IDbool(Span));
}

void Q7B_QTREEWIDGETITEM_SETFLAGS(Q7B self, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setFlags((Qt::ItemFlags) Q7B_IDqint64(Flags));
}

void Q7B_QTREEWIDGETITEM_SETFONT(Q7B self, Q7B Column, Q7B Font) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QFONT(Font))){ Q7B_EXCEPTION("QFont expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setFont(Q7B_IDqint64(Column), Q7B_IDQFont(Font));
}

void Q7B_QTREEWIDGETITEM_SETFOREGROUND(Q7B self, Q7B Column, Q7B Brush) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QBRUSH(Brush))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setForeground(Q7B_IDqint64(Column), Q7B_IDQBrush(Brush));
}

void Q7B_QTREEWIDGETITEM_SETHIDDEN(Q7B self, Q7B Hide) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Hide))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setHidden(Q7B_IDbool(Hide));
}

void Q7B_QTREEWIDGETITEM_SETICON(Q7B self, Q7B Column, Q7B Icon) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setIcon(Q7B_IDqint64(Column), Q7B_IDQIcon(Icon));
}

void Q7B_QTREEWIDGETITEM_SETSELECTED(Q7B self, Q7B Select) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Select))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setSelected(Q7B_IDbool(Select));
}

void Q7B_QTREEWIDGETITEM_SETSIZEHINT(Q7B self, Q7B Column, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setSizeHint(Q7B_IDqint64(Column), Q7B_IDQSize(Size));
}

void Q7B_QTREEWIDGETITEM_SETSTATUSTIP(Q7B self, Q7B Column, Q7B StatusTip) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(StatusTip))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setStatusTip(Q7B_IDqint64(Column), Q7B_IDQString(StatusTip));
}

void Q7B_QTREEWIDGETITEM_SETTEXT(Q7B self, Q7B Column, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setText(Q7B_IDqint64(Column), Q7B_IDQString(Text));
}

void Q7B_QTREEWIDGETITEM_SETTEXTALIGNMENT(Q7B self, Q7B Column, Q7B Alignment) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Alignment))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setTextAlignment(Q7B_IDqint64(Column), Q7B_IDqint64(Alignment));
}

void Q7B_QTREEWIDGETITEM_SETTOOLTIP(Q7B self, Q7B Column, Q7B ToolTip) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(ToolTip))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setToolTip(Q7B_IDqint64(Column), Q7B_IDQString(ToolTip));
}

void Q7B_QTREEWIDGETITEM_SETWHATSTHIS(Q7B self, Q7B Column, Q7B WhatThis) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(WhatThis))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTreeWidgetItem(self).setWhatsThis(Q7B_IDqint64(Column), Q7B_IDQString(WhatThis));
}

Q7B Q7B_QTREEWIDGETITEM_SIZEHINT(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).sizeHint(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTREEWIDGETITEM_STATUSTIP(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).statusTip(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTREEWIDGETITEM_TAKECHILD(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).takeChild(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QTREEWIDGETITEM_TEXT(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).text(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTREEWIDGETITEM_TEXTALIGNMENT(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).textAlignment(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTREEWIDGETITEM_TOOLTIP(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).toolTip(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTREEWIDGETITEM_TREEWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).treeWidget() );
}

Q7B Q7B_QTREEWIDGETITEM_TYPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).type() );
}

Q7B Q7B_QTREEWIDGETITEM_WHATSTHIS(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEWIDGETITEM(self))){ Q7B_EXCEPTION("QTreeWidgetItem expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeWidgetItem(self).whatsThis(Q7B_IDqint64(Column)) );
}



Q7B Q7B_QABSTRACTSPINBOX_ACCELERATED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->isAccelerated() );
}

void Q7B_QABSTRACTSPINBOX_ACCELERATED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQAbstractSpinBox(self)->setAccelerated(Q7B_IDbool(theProperty));
}

Q7B Q7B_QABSTRACTSPINBOX_ACCEPTABLEINPUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->hasAcceptableInput() );
}

void Q7B_QABSTRACTSPINBOX_ACCEPTABLEINPUT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

 // Q7B_IDQAbstractSpinBox(self)->setAcceptableInput(Q7B_IDbool(theProperty));
}

Q7B Q7B_QABSTRACTSPINBOX_ALIGNMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) Q7B_IDQAbstractSpinBox(self)->alignment() );
}

Q7B Q7B_QABSTRACTSPINBOX_BUTTONSYMBOLS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->buttonSymbols() );
}

void Q7B_QABSTRACTSPINBOX_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->clear();
}

Q7B Q7B_QABSTRACTSPINBOX_CORRECTIONMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->correctionMode() );
}

Q7B Q7B_QABSTRACTSPINBOX_FRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->hasFrame() );
}

void Q7B_QABSTRACTSPINBOX_FRAME(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQAbstractSpinBox(self)->setFrame(Q7B_IDbool(theProperty));
}

Q7B Q7B_QABSTRACTSPINBOX_HASACCEPTABLEINPUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->hasAcceptableInput() );
}

Q7B Q7B_QABSTRACTSPINBOX_HASFRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->hasFrame() );
}

void Q7B_QABSTRACTSPINBOX_INTERPRETTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->interpretText();
}

Q7B Q7B_QABSTRACTSPINBOX_ISACCELERATED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->isAccelerated() );
}

Q7B Q7B_QABSTRACTSPINBOX_ISREADONLY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->isReadOnly() );
}

Q7B Q7B_QABSTRACTSPINBOX_KEYBOARDTRACKING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->keyboardTracking() );
}

Q7B Q7B_QABSTRACTSPINBOX_READONLY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->isReadOnly() );
}

void Q7B_QABSTRACTSPINBOX_READONLY(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQAbstractSpinBox(self)->setReadOnly(Q7B_IDbool(theProperty));
}

void Q7B_QABSTRACTSPINBOX_SELECTALL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->selectAll();
}

void Q7B_QABSTRACTSPINBOX_SETACCELERATED(Q7B self, Q7B On) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(On))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->setAccelerated(Q7B_IDbool(On));
}

void Q7B_QABSTRACTSPINBOX_SETALIGNMENT(Q7B self, Q7B Flag) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Flag))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->setAlignment((Qt::Alignment) Q7B_IDqint64(Flag));
}

void Q7B_QABSTRACTSPINBOX_SETBUTTONSYMBOLS(Q7B self, Q7B Bs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Bs))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->setButtonSymbols((QAbstractSpinBox::ButtonSymbols) Q7B_IDqint64(Bs));
}

void Q7B_QABSTRACTSPINBOX_SETCORRECTIONMODE(Q7B self, Q7B Cm) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Cm))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->setCorrectionMode((QAbstractSpinBox::CorrectionMode) Q7B_IDqint64(Cm));
}

void Q7B_QABSTRACTSPINBOX_SETFRAME(Q7B self, Q7B Frame) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Frame))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->setFrame(Q7B_IDbool(Frame));
}

void Q7B_QABSTRACTSPINBOX_SETKEYBOARDTRACKING(Q7B self, Q7B Kt) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Kt))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->setKeyboardTracking(Q7B_IDbool(Kt));
}

void Q7B_QABSTRACTSPINBOX_SETREADONLY(Q7B self, Q7B R) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(R))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->setReadOnly(Q7B_IDbool(R));
}

void Q7B_QABSTRACTSPINBOX_SETSPECIALVALUETEXT(Q7B self, Q7B Txt) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Txt))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->setSpecialValueText(Q7B_IDQString(Txt));
}

void Q7B_QABSTRACTSPINBOX_SETWRAPPING(Q7B self, Q7B W) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(W))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->setWrapping(Q7B_IDbool(W));
}

Q7B Q7B_QABSTRACTSPINBOX_SPECIALVALUETEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->specialValueText() );
}

void Q7B_QABSTRACTSPINBOX_STEPDOWN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->stepDown();
}

void Q7B_QABSTRACTSPINBOX_STEPUP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return ; }

  Q7B_IDQAbstractSpinBox(self)->stepUp();
}

Q7B Q7B_QABSTRACTSPINBOX_TEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->text() );
}

Q7B Q7B_QABSTRACTSPINBOX_WRAPPING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSPINBOX(self))){ Q7B_EXCEPTION("QAbstractSpinBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractSpinBox(self)->wrapping() );
}

void Q7B_QDIALOG_DONE(Q7B self, Q7B R) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIALOG(self))){ Q7B_EXCEPTION("QDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(R))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQDialog(self)->done(Q7B_IDqint64(R));
}

void Q7B_QDIALOG_EXEC(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIALOG(self))){ Q7B_EXCEPTION("QDialog expected"); return ; }

  Q7B_IDQDialog(self)->exec();
}

Q7B Q7B_QDIALOG_ISSIZEGRIPENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIALOG(self))){ Q7B_EXCEPTION("QDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDialog(self)->isSizeGripEnabled() );
}

void Q7B_QDIALOG_ISSIZEGRIPENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIALOG(self))){ Q7B_EXCEPTION("QDialog expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQDialog(self)->setSizeGripEnabled(Q7B_IDbool(theProperty));
}

void Q7B_QDIALOG_OPEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIALOG(self))){ Q7B_EXCEPTION("QDialog expected"); return ; }

  Q7B_IDQDialog(self)->open();
}

Q7B Q7B_QDIALOG_RESULT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIALOG(self))){ Q7B_EXCEPTION("QDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDialog(self)->result() );
}

void Q7B_QDIALOG_SETMODAL(Q7B self, Q7B Modal) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIALOG(self))){ Q7B_EXCEPTION("QDialog expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Modal))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQDialog(self)->setModal(Q7B_IDbool(Modal));
}

void Q7B_QDIALOG_SETRESULT(Q7B self, Q7B I) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIALOG(self))){ Q7B_EXCEPTION("QDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(I))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQDialog(self)->setResult(Q7B_IDqint64(I));
}

void Q7B_QDIALOG_SETSIZEGRIPENABLED(Q7B self, Q7B Enabled) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIALOG(self))){ Q7B_EXCEPTION("QDialog expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enabled))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQDialog(self)->setSizeGripEnabled(Q7B_IDbool(Enabled));
}

Q7B Q7B_QDIALOGBUTTONBOX_ADDBUTTON(Q7B self, Q7B Text, Q7B Role) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIALOGBUTTONBOX(self))){ Q7B_EXCEPTION("QDialogButtonBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Role))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDialogButtonBox(self)->addButton(Q7B_IDQString(Text), (QDialogButtonBox::ButtonRole) Q7B_IDqint64(Role)) );
}

Q7B Q7B_QDIALOGBUTTONBOX_ADDBUTTON2(Q7B self, Q7B Button) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIALOGBUTTONBOX(self))){ Q7B_EXCEPTION("QDialogButtonBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Button))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDialogButtonBox(self)->addButton((QDialogButtonBox::StandardButton) Q7B_IDqint64(Button)) );
}

Q7B Q7B_QDIALOGBUTTONBOX_BUTTON(Q7B self, Q7B Which) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIALOGBUTTONBOX(self))){ Q7B_EXCEPTION("QDialogButtonBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Which))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDialogButtonBox(self)->button((QDialogButtonBox::StandardButton) Q7B_IDqint64(Which)) );
}

Q7B Q7B_QDIALOGBUTTONBOX_BUTTONROLE(Q7B self, Q7B button) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIALOGBUTTONBOX(self))){ Q7B_EXCEPTION("QDialogButtonBox expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(button))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDialogButtonBox(self)->buttonRole(Q7B_IDQAbstractButton(button)) );
}

Q7B Q7B_QDIALOGBUTTONBOX_CENTERBUTTONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIALOGBUTTONBOX(self))){ Q7B_EXCEPTION("QDialogButtonBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDialogButtonBox(self)->centerButtons() );
}

void Q7B_QDIALOGBUTTONBOX_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIALOGBUTTONBOX(self))){ Q7B_EXCEPTION("QDialogButtonBox expected"); return ; }

  Q7B_IDQDialogButtonBox(self)->clear();
}

Q7B Q7B_QDIALOGBUTTONBOX_ORIENTATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIALOGBUTTONBOX(self))){ Q7B_EXCEPTION("QDialogButtonBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDialogButtonBox(self)->orientation() );
}

void Q7B_QDIALOGBUTTONBOX_REMOVEBUTTON(Q7B self, Q7B Button) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIALOGBUTTONBOX(self))){ Q7B_EXCEPTION("QDialogButtonBox expected"); return ; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(Button))){ Q7B_EXCEPTION("QAbstractButton expected"); return ; }

  Q7B_IDQDialogButtonBox(self)->removeButton(Q7B_IDQAbstractButton(Button));
}

void Q7B_QDIALOGBUTTONBOX_SETCENTERBUTTONS(Q7B self, Q7B Center) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIALOGBUTTONBOX(self))){ Q7B_EXCEPTION("QDialogButtonBox expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Center))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQDialogButtonBox(self)->setCenterButtons(Q7B_IDbool(Center));
}

void Q7B_QDIALOGBUTTONBOX_SETORIENTATION(Q7B self, Q7B Orientation) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIALOGBUTTONBOX(self))){ Q7B_EXCEPTION("QDialogButtonBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Orientation))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQDialogButtonBox(self)->setOrientation((Qt::Orientation) Q7B_IDqint64(Orientation));
}

void Q7B_QDIALOGBUTTONBOX_SETSTANDARDBUTTONS(Q7B self, Q7B Buttons) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIALOGBUTTONBOX(self))){ Q7B_EXCEPTION("QDialogButtonBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Buttons))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQDialogButtonBox(self)->setStandardButtons((QDialogButtonBox::StandardButtons) Q7B_IDqint64(Buttons));
}

Q7B Q7B_QDIALOGBUTTONBOX_STANDARDBUTTONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIALOGBUTTONBOX(self))){ Q7B_EXCEPTION("QDialogButtonBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDialogButtonBox(self)->standardButtons() );
}

Q7B Q7B_QDIR_ABSOLUTEFILEPATH(Q7B self, Q7B FileName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).absoluteFilePath(Q7B_IDQString(FileName)) );
}

Q7B Q7B_QDIR_ABSOLUTEPATH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).absolutePath() );
}

Q7B Q7B_QDIR_CANONICALPATH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).canonicalPath() );
}

Q7B Q7B_QDIR_CD(Q7B self, Q7B DirName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(DirName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).cd(Q7B_IDQString(DirName)) );
}

Q7B Q7B_QDIR_CDUP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).cdUp() );
}

Q7B Q7B_QDIR_COUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).count() );
}

Q7B Q7B_QDIR_DIRNAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).dirName() );
}

Q7B Q7B_QDIR_ENTRYINFOLIST(Q7B self, Q7B NameFilters, Q7B Filters, Q7B Sort) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRINGLIST(NameFilters))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Filters))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Sort))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).entryInfoList(Q7B_IDQStringList(NameFilters), (QDir::Filters) Q7B_IDqint64(Filters), (QDir::SortFlags) Q7B_IDqint64(Sort)) );
}

Q7B Q7B_QDIR_ENTRYLIST(Q7B self, Q7B NameFilters, Q7B Filters, Q7B Sort) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRINGLIST(NameFilters))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Filters))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Sort))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).entryList(Q7B_IDQStringList(NameFilters), (QDir::Filters) Q7B_IDqint64(Filters), (QDir::SortFlags) Q7B_IDqint64(Sort)) );
}

Q7B Q7B_QDIR_EXISTS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).exists() );
}

Q7B Q7B_QDIR_FILEPATH(Q7B self, Q7B FileName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).filePath(Q7B_IDQString(FileName)) );
}

Q7B Q7B_QDIR_FILTER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).filter() );
}

Q7B Q7B_QDIR_ISABSOLUTE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).isAbsolute() );
}

Q7B Q7B_QDIR_ISREADABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).isReadable() );
}

Q7B Q7B_QDIR_ISRELATIVE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).isRelative() );
}

Q7B Q7B_QDIR_ISROOT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).isRoot() );
}

Q7B Q7B_QDIR_MAKEABSOLUTE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).makeAbsolute() );
}

Q7B Q7B_QDIR_MKDIR(Q7B self, Q7B DirName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(DirName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).mkdir(Q7B_IDQString(DirName)) );
}

Q7B Q7B_QDIR_MKPATH(Q7B self, Q7B DirPath) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(DirPath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).mkpath(Q7B_IDQString(DirPath)) );
}

Q7B Q7B_QDIR_NAMEFILTERS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).nameFilters() );
}

Q7B Q7B_QDIR_PATH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).path() );
}

void Q7B_QDIR_REFRESH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return ; }

  Q7B_IDQDir(self).refresh();
}

Q7B Q7B_QDIR_RELATIVEFILEPATH(Q7B self, Q7B FileName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).relativeFilePath(Q7B_IDQString(FileName)) );
}

Q7B Q7B_QDIR_REMOVE(Q7B self, Q7B FileName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).remove(Q7B_IDQString(FileName)) );
}

Q7B Q7B_QDIR_RENAME(Q7B self, Q7B OldName, Q7B NewName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(OldName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(NewName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).rename(Q7B_IDQString(OldName), Q7B_IDQString(NewName)) );
}

Q7B Q7B_QDIR_RMDIR(Q7B self, Q7B DirName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(DirName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).rmdir(Q7B_IDQString(DirName)) );
}

void Q7B_QDIR_SETFILTER(Q7B self, Q7B Filters) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Filters))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQDir(self).setFilter((QDir::Filters) Q7B_IDqint64(Filters));
}

void Q7B_QDIR_SETNAMEFILTERS(Q7B self, Q7B NameFilters) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(NameFilters))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQDir(self).setNameFilters(Q7B_IDQStringList(NameFilters));
}

void Q7B_QDIR_SETPATH(Q7B self, Q7B Path) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQDir(self).setPath(Q7B_IDQString(Path));
}

void Q7B_QDIR_SETSORTING(Q7B self, Q7B Sort) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Sort))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQDir(self).setSorting((QDir::SortFlags) Q7B_IDqint64(Sort));
}

Q7B Q7B_QDIR_SORTING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDIR(self))){ Q7B_EXCEPTION("QDir expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDir(self).sorting() );
}

Q7B Q7B_QFONTCOMBOBOX_CURRENTFONT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTCOMBOBOX(self))){ Q7B_EXCEPTION("QFontComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontComboBox(self)->currentFont() );
}

Q7B Q7B_QFONTCOMBOBOX_FONTFILTERS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTCOMBOBOX(self))){ Q7B_EXCEPTION("QFontComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontComboBox(self)->fontFilters() );
}

void Q7B_QFONTCOMBOBOX_SETCURRENTFONT(Q7B self, Q7B Font) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONTCOMBOBOX(self))){ Q7B_EXCEPTION("QFontComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QFONT(Font))){ Q7B_EXCEPTION("QFont expected"); return ; }

  Q7B_IDQFontComboBox(self)->setCurrentFont(Q7B_IDQFont(Font));
}

void Q7B_QFONTCOMBOBOX_SETFONTFILTERS(Q7B self, Q7B Filters) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONTCOMBOBOX(self))){ Q7B_EXCEPTION("QFontComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Filters))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQFontComboBox(self)->setFontFilters((QFontComboBox::FontFilters) Q7B_IDqint64(Filters));
}

Q7B Q7B_QFONTCOMBOBOX_WRITINGSYSTEM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTCOMBOBOX(self))){ Q7B_EXCEPTION("QFontComboBox expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontComboBox(self)->writingSystem() );
}

void Q7B_QFONTCOMBOBOX_WRITINGSYSTEM(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONTCOMBOBOX(self))){ Q7B_EXCEPTION("QFontComboBox expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQFontComboBox(self)->setWritingSystem((QFontDatabase::WritingSystem) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QPICTURE_BOUNDINGRECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPICTURE(self))){ Q7B_EXCEPTION("QPicture expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPicture(self).boundingRect() );
}

Q7B Q7B_QPICTURE_DATA(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPICTURE(self))){ Q7B_EXCEPTION("QPicture expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPicture(self).data() );
}

Q7B Q7B_QPICTURE_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPICTURE(self))){ Q7B_EXCEPTION("QPicture expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPicture(self).isNull() );
}

Q7B Q7B_QPICTURE_LOAD(Q7B self, Q7B FileName, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPICTURE(self))){ Q7B_EXCEPTION("QPicture expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  static QString s; s = Q7B_IDQString(FileName);
  const char *ac = Q7B_IDQString(Format).toLocal8Bit().constData();
  return Q7B_ID( Q7B_IDQPicture(self).load(s, ac) );
}

Q7B Q7B_QPICTURE_PLAY(Q7B self, Q7B Painter) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPICTURE(self))){ Q7B_EXCEPTION("QPicture expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPAINTER(Painter))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPicture(self).play(&Q7B_IDQPainter(Painter)) );
}

Q7B Q7B_QPICTURE_SAVE(Q7B self, Q7B FileName, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPICTURE(self))){ Q7B_EXCEPTION("QPicture expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  static QString s; s = Q7B_IDQString(FileName);
  const char *ac = Q7B_IDQString(Format).toLocal8Bit().constData();
  return Q7B_ID( Q7B_IDQPicture(self).save(s, ac) );
}

void Q7B_QPICTURE_SETBOUNDINGRECT(Q7B self, Q7B R) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPICTURE(self))){ Q7B_EXCEPTION("QPicture expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(R))){ Q7B_EXCEPTION("QRect expected"); return ; }

  Q7B_IDQPicture(self).setBoundingRect(Q7B_IDQRect(R));
}

void Q7B_QPICTURE_SETDATA(Q7B self, Q7B Data, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPICTURE(self))){ Q7B_EXCEPTION("QPicture expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Data))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Size))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPicture(self).setData(Q7B_IDQString(Data).toLocal8Bit().constData(), Q7B_IDqint64(Size));
}

Q7B Q7B_QPICTURE_SIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPICTURE(self))){ Q7B_EXCEPTION("QPicture expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPicture(self).size() );
}
/*
void Q7B_QPICTURE_SWAP(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPICTURE(self))){ Q7B_EXCEPTION("QPicture expected"); return ; }

  if (Q7B_nil(Q7B_QPICTURE(Other))){ Q7B_EXCEPTION("QPicture expected"); return ; }

  Q7B_IDQPicture(self).swap(Q7B_IDQPicture(Other));
}*/

Q7B Q7B_QPIXMAP_CACHEKEY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).cacheKey() );
}

Q7B Q7B_QPIXMAP_CONVERTFROMIMAGE(Q7B self, Q7B Image, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QIMAGE(Image))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).convertFromImage(Q7B_IDQImage(Image), (Qt::ImageConversionFlags) Q7B_IDqint64(Flags)) );
}

Q7B Q7B_QPIXMAP_COPY(Q7B self, Q7B X, Q7B Y, Q7B Width, Q7B Height) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Height))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).copy(Q7B_IDqint64(X), Q7B_IDqint64(Y), Q7B_IDqint64(Width), Q7B_IDqint64(Height)) );
}

Q7B Q7B_QPIXMAP_CREATEMASKFROMCOLOR(Q7B self, Q7B MaskColor, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCOLOR(MaskColor))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).createMaskFromColor(Q7B_IDQColor(MaskColor), (Qt::MaskMode) Q7B_IDqint64(Mode)) );
}

Q7B Q7B_QPIXMAP_CREATEMASKFROMCOLOR2(Q7B self, Q7B MaskColor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCOLOR(MaskColor))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).createMaskFromColor(Q7B_IDQColor(MaskColor)) );
}

Q7B Q7B_QPIXMAP_DEPTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).depth() );
}

void Q7B_QPIXMAP_DETACH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  Q7B_IDQPixmap(self).detach();
}

void Q7B_QPIXMAP_FILL(Q7B self, Q7B Widget, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPixmap(self).fill(Q7B_IDQWidget(Widget), Q7B_IDqint64(X), Q7B_IDqint64(Y));
}

Q7B Q7B_QPIXMAP_HASALPHA(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).hasAlpha() );
}

Q7B Q7B_QPIXMAP_HASALPHACHANNEL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).hasAlphaChannel() );
}

Q7B Q7B_QPIXMAP_HEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).height() );
}

Q7B Q7B_QPIXMAP_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).isNull() );
}

Q7B Q7B_QPIXMAP_ISQBITMAP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).isQBitmap() );
}

Q7B Q7B_QPIXMAP_LOAD(Q7B self, Q7B FileName, Q7B Format, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).load(Q7B_IDQString(FileName), Q7B_IDQString(Format).toLocal8Bit().constData(), (Qt::ImageConversionFlags) Q7B_IDqint64(Flags)) );
}

Q7B Q7B_QPIXMAP_LOADFROMDATA(Q7B self, Q7B Data, Q7B Format, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Data))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).loadFromData(Q7B_IDQByteArray(Data), Q7B_IDQString(Format).toLocal8Bit().constData(), (Qt::ImageConversionFlags) Q7B_IDqint64(Flags)) );
}

Q7B Q7B_QPIXMAP_MASK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).mask() );
}

Q7B Q7B_QPIXMAP_RECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).rect() );
}

Q7B Q7B_QPIXMAP_SAVE(Q7B self, Q7B FileName, Q7B Format, Q7B Quality) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Quality))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).save(Q7B_IDQString(FileName), Q7B_IDQString(Format).toLocal8Bit().constData(), Q7B_IDqint64(Quality)) );
}

Q7B Q7B_QPIXMAP_SCALED(Q7B self, Q7B Width, Q7B Height, Q7B AspectRatioMode, Q7B TransformMode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Height))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(AspectRatioMode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(TransformMode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  
  return Q7B_ID( Q7B_IDQPixmap(self).scaled(Q7B_IDqint64(Width), Q7B_IDqint64(Height), (Qt::AspectRatioMode) Q7B_IDqint64(AspectRatioMode), (Qt::TransformationMode) Q7B_IDqint64(TransformMode)) );
}

Q7B Q7B_QPIXMAP_SCALEDTOHEIGHT(Q7B self, Q7B Height, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Height))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).scaledToHeight(Q7B_IDqint64(Height), (Qt::TransformationMode) Q7B_IDqint64(Mode)) );
}

Q7B Q7B_QPIXMAP_SCALEDTOWIDTH(Q7B self, Q7B Width, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).scaledToWidth(Q7B_IDqint64(Width), (Qt::TransformationMode) Q7B_IDqint64(Mode)) );
}

void Q7B_QPIXMAP_SCROLL(Q7B self, Q7B Dx, Q7B Dy, Q7B Rect, Q7B Exposed) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dx))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rect))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QREGION(Exposed))){ Q7B_EXCEPTION("QRegion expected"); return ; }

  Q7B_IDQPixmap(self).scroll(Q7B_IDqint64(Dx), Q7B_IDqint64(Dy), Q7B_IDQRect(Rect), &Q7B_IDQRegion(Exposed));
}

void Q7B_QPIXMAP_SETMASK(Q7B self, Q7B Mask) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  if (Q7B_nil(Q7B_QBITMAP(Mask))){ Q7B_EXCEPTION("QBitmap expected"); return ; }

  Q7B_IDQPixmap(self).setMask(Q7B_IDQBitmap(Mask));
}

Q7B Q7B_QPIXMAP_SIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).size() );
}
/*
void Q7B_QPIXMAP_SWAP(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  if (Q7B_nil(Q7B_QPIXMAP(Other))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  Q7B_IDQPixmap(self).swap(Q7B_IDQPixmap(Other));
}*/

Q7B Q7B_QPIXMAP_TOIMAGE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).toImage() );
}

Q7B Q7B_QPIXMAP_TOICON(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  return Q7B_ID( QIcon(Q7B_IDQPixmap(self)) );
}

Q7B Q7B_QPIXMAP_TRANSFORMED(Q7B self, Q7B Matrix, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMATRIX(Matrix))){ Q7B_EXCEPTION("QMatrix expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).transformed(Q7B_IDQMatrix(Matrix), (Qt::TransformationMode) Q7B_IDqint64(Mode)) );
}

Q7B Q7B_QPIXMAP_WIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).width() );
}

Q7B Q7B_QREGEXP_CAP(Q7B self, Q7B Nth) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Nth))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).cap(Q7B_IDqint64(Nth)) );
}

Q7B Q7B_QREGEXP_CAPTURECOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).captureCount() );
}

Q7B Q7B_QREGEXP_CAPTUREDTEXTS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).capturedTexts() );
}

Q7B Q7B_QREGEXP_CASESENSITIVITY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).caseSensitivity() );
}

Q7B Q7B_QREGEXP_ERRORSTRING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).errorString() );
}

Q7B Q7B_QREGEXP_EXACTMATCH(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).exactMatch(Q7B_IDQString(Str)) );
}

Q7B Q7B_QREGEXP_INDEXIN(Q7B self, Q7B Str, Q7B Offset, Q7B CaretMode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Offset))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(CaretMode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).indexIn(Q7B_IDQString(Str), Q7B_IDqint64(Offset), (QRegExp::CaretMode) Q7B_IDqint64(CaretMode)) );
}

Q7B Q7B_QREGEXP_ISEMPTY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).isEmpty() );
}

Q7B Q7B_QREGEXP_ISMINIMAL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).isMinimal() );
}

Q7B Q7B_QREGEXP_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).isValid() );
}

Q7B Q7B_QREGEXP_LASTINDEXIN(Q7B self, Q7B Str, Q7B Offset, Q7B CaretMode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Offset))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(CaretMode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).lastIndexIn(Q7B_IDQString(Str), Q7B_IDqint64(Offset), (QRegExp::CaretMode) Q7B_IDqint64(CaretMode)) );
}

Q7B Q7B_QREGEXP_MATCHEDLENGTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).matchedLength() );
}

Q7B Q7B_QREGEXP_PATTERN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).pattern() );
}

Q7B Q7B_QREGEXP_PATTERNSYNTAX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).patternSyntax() );
}

Q7B Q7B_QREGEXP_POS(Q7B self, Q7B Nth) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Nth))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExp(self).pos(Q7B_IDqint64(Nth)) );
}

void Q7B_QREGEXP_SETCASESENSITIVITY(Q7B self, Q7B Cs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Cs))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRegExp(self).setCaseSensitivity((Qt::CaseSensitivity) Q7B_IDqint64(Cs));
}

void Q7B_QREGEXP_SETMINIMAL(Q7B self, Q7B Minimal) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Minimal))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQRegExp(self).setMinimal(Q7B_IDbool(Minimal));
}

void Q7B_QREGEXP_SETPATTERN(Q7B self, Q7B Pattern) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Pattern))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQRegExp(self).setPattern(Q7B_IDQString(Pattern));
}

void Q7B_QREGEXP_SETPATTERNSYNTAX(Q7B self, Q7B Syntax) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Syntax))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRegExp(self).setPatternSyntax((QRegExp::PatternSyntax) Q7B_IDqint64(Syntax));
}
/*
void Q7B_QREGEXP_SWAP(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QREGEXP(self))){ Q7B_EXCEPTION("QRegExp expected"); return ; }

  if (Q7B_nil(Q7B_QREGEXP(Other))){ Q7B_EXCEPTION("QRegExp expected"); return ; }

  Q7B_IDQRegExp(self).swap(Q7B_IDQRegExp(Other));
}*/

void Q7B_QTEXTBROWSER_BACKWARD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return ; }

  Q7B_IDQTextBrowser(self)->backward();
}

Q7B Q7B_QTEXTBROWSER_BACKWARDHISTORYCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBrowser(self)->backwardHistoryCount() );
}

void Q7B_QTEXTBROWSER_CLEARHISTORY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return ; }

  Q7B_IDQTextBrowser(self)->clearHistory();
}

void Q7B_QTEXTBROWSER_FORWARD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return ; }

  Q7B_IDQTextBrowser(self)->forward();
}

Q7B Q7B_QTEXTBROWSER_FORWARDHISTORYCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBrowser(self)->forwardHistoryCount() );
}

Q7B Q7B_QTEXTBROWSER_HISTORYTITLE(Q7B self, Q7B I) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(I))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBrowser(self)->historyTitle(Q7B_IDqint64(I)) );
}

Q7B Q7B_QTEXTBROWSER_HISTORYURL(Q7B self, Q7B I) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(I))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBrowser(self)->historyUrl(Q7B_IDqint64(I)) );
}

void Q7B_QTEXTBROWSER_HOME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return ; }

  Q7B_IDQTextBrowser(self)->home();
}

Q7B Q7B_QTEXTBROWSER_ISBACKWARDAVAILABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBrowser(self)->isBackwardAvailable() );
}

Q7B Q7B_QTEXTBROWSER_ISFORWARDAVAILABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBrowser(self)->isForwardAvailable() );
}

Q7B Q7B_QTEXTBROWSER_MODIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return Q7B_idnil; }

  QTextBrowser *tb = Q7B_IDQTextBrowser(self);
  return Q7B_ID( tb->property("modified").toBool() );
}

void Q7B_QTEXTBROWSER_MODIFIED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  //Q7B_IDQTextBrowser(self)->setModified(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTEXTBROWSER_OPENEXTERNALLINKS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBrowser(self)->openExternalLinks() );
}

Q7B Q7B_QTEXTBROWSER_OPENLINKS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBrowser(self)->openLinks() );
}

Q7B Q7B_QTEXTBROWSER_READONLY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBrowser(self)->isReadOnly() );
}

void Q7B_QTEXTBROWSER_READONLY(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTextBrowser(self)->setReadOnly(Q7B_IDbool(theProperty));
}

void Q7B_QTEXTBROWSER_RELOAD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return ; }

  Q7B_IDQTextBrowser(self)->reload();
}

Q7B Q7B_QTEXTBROWSER_SEARCHPATHS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBrowser(self)->searchPaths() );
}

void Q7B_QTEXTBROWSER_SETOPENEXTERNALLINKS(Q7B self, Q7B Open) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Open))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextBrowser(self)->setOpenExternalLinks(Q7B_IDbool(Open));
}

void Q7B_QTEXTBROWSER_SETOPENLINKS(Q7B self, Q7B Open) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Open))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextBrowser(self)->setOpenLinks(Q7B_IDbool(Open));
}

void Q7B_QTEXTBROWSER_SETSEARCHPATHS(Q7B self, Q7B Paths) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Paths))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQTextBrowser(self)->setSearchPaths(Q7B_IDQStringList(Paths));
}

void Q7B_QTEXTBROWSER_SETSOURCE(Q7B self, Q7B Name) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return ; }

  if (Q7B_nil(Q7B_QURL(Name))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  Q7B_IDQTextBrowser(self)->setSource(Q7B_IDQUrl(Name));
}

Q7B Q7B_QTEXTBROWSER_SOURCE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBrowser(self)->source() );
}

Q7B Q7B_QTEXTBROWSER_UNDOREDOENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBrowser(self)->isUndoRedoEnabled() );
}

void Q7B_QTEXTBROWSER_UNDOREDOENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBROWSER(self))){ Q7B_EXCEPTION("QTextBrowser expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTextBrowser(self)->setUndoRedoEnabled(Q7B_IDbool(theProperty));
}

Q7B Q7B_QSPLITTERHANDLE_OPAQUERESIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTERHANDLE(self))){ Q7B_EXCEPTION("QSplitterHandle expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitterHandle(self)->opaqueResize() );
}

Q7B Q7B_QSPLITTERHANDLE_ORIENTATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTERHANDLE(self))){ Q7B_EXCEPTION("QSplitterHandle expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitterHandle(self)->orientation() );
}

void Q7B_QSPLITTERHANDLE_SETORIENTATION(Q7B self, Q7B Orientation) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSPLITTERHANDLE(self))){ Q7B_EXCEPTION("QSplitterHandle expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Orientation))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSplitterHandle(self)->setOrientation((Qt::Orientation) Q7B_IDqint64(Orientation));
}

Q7B Q7B_QSPLITTERHANDLE_SPLITTER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSPLITTERHANDLE(self))){ Q7B_EXCEPTION("QSplitterHandle expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSplitterHandle(self)->splitter() );
}

Q7B Q7B_QTABLEWIDGETITEM_BACKGROUND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).background() );
}

Q7B Q7B_QTABLEWIDGETITEM_CHECKSTATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).checkState() );
}

Q7B Q7B_QTABLEWIDGETITEM_COLUMN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).column() );
}

Q7B Q7B_QTABLEWIDGETITEM_FLAGS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).flags() );
}

Q7B Q7B_QTABLEWIDGETITEM_FONT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).font() );
}

Q7B Q7B_QTABLEWIDGETITEM_FOREGROUND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).foreground() );
}

Q7B Q7B_QTABLEWIDGETITEM_ICON(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).icon() );
}

Q7B Q7B_QTABLEWIDGETITEM_ISSELECTED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).isSelected() );
}

Q7B Q7B_QTABLEWIDGETITEM_ROW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).row() );
}

void Q7B_QTABLEWIDGETITEM_SETBACKGROUND(Q7B self, Q7B Brush) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QBRUSH(Brush))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  Q7B_IDQTableWidgetItem(self).setBackground(Q7B_IDQBrush(Brush));
}

void Q7B_QTABLEWIDGETITEM_SETCHECKSTATE(Q7B self, Q7B State) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(State))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidgetItem(self).setCheckState((Qt::CheckState) Q7B_IDqint64(State));
}

void Q7B_QTABLEWIDGETITEM_SETFLAGS(Q7B self, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidgetItem(self).setFlags((Qt::ItemFlags) Q7B_IDqint64(Flags));
}

void Q7B_QTABLEWIDGETITEM_SETFONT(Q7B self, Q7B Font) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QFONT(Font))){ Q7B_EXCEPTION("QFont expected"); return ; }

  Q7B_IDQTableWidgetItem(self).setFont(Q7B_IDQFont(Font));
}

void Q7B_QTABLEWIDGETITEM_SETFOREGROUND(Q7B self, Q7B Brush) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QBRUSH(Brush))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  Q7B_IDQTableWidgetItem(self).setForeground(Q7B_IDQBrush(Brush));
}

void Q7B_QTABLEWIDGETITEM_SETICON(Q7B self, Q7B Icon) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  Q7B_IDQTableWidgetItem(self).setIcon(Q7B_IDQIcon(Icon));
}

void Q7B_QTABLEWIDGETITEM_SETSELECTED(Q7B self, Q7B Select) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Select))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTableWidgetItem(self).setSelected(Q7B_IDbool(Select));
}

void Q7B_QTABLEWIDGETITEM_SETSIZEHINT(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQTableWidgetItem(self).setSizeHint(Q7B_IDQSize(Size));
}

void Q7B_QTABLEWIDGETITEM_SETSTATUSTIP(Q7B self, Q7B StatusTip) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(StatusTip))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTableWidgetItem(self).setStatusTip(Q7B_IDQString(StatusTip));
}

void Q7B_QTABLEWIDGETITEM_SETTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTableWidgetItem(self).setText(Q7B_IDQString(Text));
}

void Q7B_QTABLEWIDGETITEM_SETTEXTALIGNMENT(Q7B self, Q7B Alignment) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Alignment))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableWidgetItem(self).setTextAlignment(Q7B_IDqint64(Alignment));
}

void Q7B_QTABLEWIDGETITEM_SETTOOLTIP(Q7B self, Q7B ToolTip) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(ToolTip))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTableWidgetItem(self).setToolTip(Q7B_IDQString(ToolTip));
}

void Q7B_QTABLEWIDGETITEM_SETWHATSTHIS(Q7B self, Q7B WhatsThis) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(WhatsThis))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTableWidgetItem(self).setWhatsThis(Q7B_IDQString(WhatsThis));
}

Q7B Q7B_QTABLEWIDGETITEM_SIZEHINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).sizeHint() );
}

Q7B Q7B_QTABLEWIDGETITEM_STATUSTIP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).statusTip() );
}

Q7B Q7B_QTABLEWIDGETITEM_TABLEWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).tableWidget() );
}

Q7B Q7B_QTABLEWIDGETITEM_TEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).text() );
}

Q7B Q7B_QTABLEWIDGETITEM_TEXTALIGNMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).textAlignment() );
}

Q7B Q7B_QTABLEWIDGETITEM_TOOLTIP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).toolTip() );
}

Q7B Q7B_QTABLEWIDGETITEM_TYPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).type() );
}

Q7B Q7B_QTABLEWIDGETITEM_WHATSTHIS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEWIDGETITEM(self))){ Q7B_EXCEPTION("QTableWidgetItem expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableWidgetItem(self).whatsThis() );
}


Q7B Q7B_QCOLOR_ALPHA(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).alpha() );
}

Q7B Q7B_QCOLOR_ALPHAF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).alphaF() );
}

Q7B Q7B_QCOLOR_BLACK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).black() );
}

Q7B Q7B_QCOLOR_BLACKF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).blackF() );
}

Q7B Q7B_QCOLOR_BLUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).blue() );
}

Q7B Q7B_QCOLOR_BLUEF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).blueF() );
}

Q7B Q7B_QCOLOR_CONVERTTO(Q7B self, Q7B ColorSpec) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(ColorSpec))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).convertTo((QColor::Spec) Q7B_IDqint64(ColorSpec)) );
}

Q7B Q7B_QCOLOR_CYAN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).cyan() );
}

Q7B Q7B_QCOLOR_CYANF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).cyanF() );
}

Q7B Q7B_QCOLOR_DARKER(Q7B self, Q7B Factor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Factor))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).darker(Q7B_IDqint64(Factor)) );
}


Q7B Q7B_QCOLOR_GREEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).green() );
}

Q7B Q7B_QCOLOR_GREENF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).greenF() );
}

Q7B Q7B_QCOLOR_HSLHUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).hslHue() );
}

Q7B Q7B_QCOLOR_HSLHUEF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).hslHueF() );
}

Q7B Q7B_QCOLOR_HSLSATURATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).hslSaturation() );
}

Q7B Q7B_QCOLOR_HSLSATURATIONF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).hslSaturationF() );
}

Q7B Q7B_QCOLOR_HSVHUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).hsvHue() );
}

Q7B Q7B_QCOLOR_HSVHUEF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).hsvHueF() );
}

Q7B Q7B_QCOLOR_HSVSATURATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).hsvSaturation() );
}

Q7B Q7B_QCOLOR_HSVSATURATIONF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).hsvSaturationF() );
}

Q7B Q7B_QCOLOR_HUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).hue() );
}

Q7B Q7B_QCOLOR_HUEF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).hueF() );
}

Q7B Q7B_QCOLOR_LIGHTER(Q7B self, Q7B Factor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Factor))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).lighter(Q7B_IDqint64(Factor)) );
}

Q7B Q7B_QCOLOR_LIGHTNESS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).lightness() );
}

Q7B Q7B_QCOLOR_LIGHTNESSF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).lightnessF() );
}

Q7B Q7B_QCOLOR_MAGENTA(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).magenta() );
}

Q7B Q7B_QCOLOR_MAGENTAF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).magentaF() );
}

Q7B Q7B_QCOLOR_NAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).name() );
}

Q7B Q7B_QCOLOR_RED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).red() );
}

Q7B Q7B_QCOLOR_REDF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).redF() );
}

Q7B Q7B_QCOLOR_RGB(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).rgb() );
}

Q7B Q7B_QCOLOR_RGBA(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).rgba() );
}

Q7B Q7B_QCOLOR_SATURATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).saturation() );
}

Q7B Q7B_QCOLOR_SATURATIONF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).saturationF() );
}

void Q7B_QCOLOR_SETALPHA(Q7B self, Q7B Alpha) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Alpha))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQColor(self).setAlpha(Q7B_IDqint64(Alpha));
}

void Q7B_QCOLOR_SETALPHAF(Q7B self, Q7B Alpha) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Alpha))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQColor(self).setAlphaF(Q7B_IDqreal(Alpha));
}

void Q7B_QCOLOR_SETBLUE(Q7B self, Q7B Blue) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Blue))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQColor(self).setBlue(Q7B_IDqint64(Blue));
}

void Q7B_QCOLOR_SETBLUEF(Q7B self, Q7B Blue) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Blue))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQColor(self).setBlueF(Q7B_IDqreal(Blue));
}

void Q7B_QCOLOR_SETCMYK(Q7B self, Q7B C, Q7B M, Q7B Y, Q7B K, Q7B A) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(C))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(M))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(K))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(A))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQColor(self).setCmyk(Q7B_IDqint64(C), Q7B_IDqint64(M), Q7B_IDqint64(Y), Q7B_IDqint64(K), Q7B_IDqint64(A));
}

void Q7B_QCOLOR_SETCMYKF(Q7B self, Q7B C, Q7B M, Q7B Y, Q7B K, Q7B A) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(C))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(M))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Y))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(K))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(A))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQColor(self).setCmykF(Q7B_IDqreal(C), Q7B_IDqreal(M), Q7B_IDqreal(Y), Q7B_IDqreal(K), Q7B_IDqreal(A));
}

void Q7B_QCOLOR_SETGREEN(Q7B self, Q7B Green) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Green))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQColor(self).setGreen(Q7B_IDqint64(Green));
}

void Q7B_QCOLOR_SETGREENF(Q7B self, Q7B Green) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Green))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQColor(self).setGreenF(Q7B_IDqreal(Green));
}

void Q7B_QCOLOR_SETHSL(Q7B self, Q7B H, Q7B S, Q7B L, Q7B A) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(H))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(S))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(L))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(A))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQColor(self).setHsl(Q7B_IDqint64(H), Q7B_IDqint64(S), Q7B_IDqint64(L), Q7B_IDqint64(A));
}

void Q7B_QCOLOR_SETHSLF(Q7B self, Q7B H, Q7B S, Q7B L, Q7B A) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(H))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(S))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(L))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(A))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQColor(self).setHslF(Q7B_IDqreal(H), Q7B_IDqreal(S), Q7B_IDqreal(L), Q7B_IDqreal(A));
}

void Q7B_QCOLOR_SETHSV(Q7B self, Q7B H, Q7B S, Q7B V, Q7B A) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(H))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(S))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(V))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(A))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQColor(self).setHsv(Q7B_IDqint64(H), Q7B_IDqint64(S), Q7B_IDqint64(V), Q7B_IDqint64(A));
}

void Q7B_QCOLOR_SETHSVF(Q7B self, Q7B H, Q7B S, Q7B V, Q7B A) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(H))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(S))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(V))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(A))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQColor(self).setHsvF(Q7B_IDqreal(H), Q7B_IDqreal(S), Q7B_IDqreal(V), Q7B_IDqreal(A));
}

void Q7B_QCOLOR_SETNAMEDCOLOR(Q7B self, Q7B Name) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQColor(self).setNamedColor(Q7B_IDQString(Name));
}

void Q7B_QCOLOR_SETRED(Q7B self, Q7B Red) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Red))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQColor(self).setRed(Q7B_IDqint64(Red));
}

void Q7B_QCOLOR_SETREDF(Q7B self, Q7B Red) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Red))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQColor(self).setRedF(Q7B_IDqreal(Red));
}

void Q7B_QCOLOR_SETRGB(Q7B self, Q7B R, Q7B G, Q7B B, Q7B A) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(R))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(G))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(B))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(A))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQColor(self).setRgb(Q7B_IDqint64(R), Q7B_IDqint64(G), Q7B_IDqint64(B), Q7B_IDqint64(A));
}

void Q7B_QCOLOR_SETRGBF(Q7B self, Q7B R, Q7B G, Q7B B, Q7B A) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(R))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(G))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(B))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(A))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQColor(self).setRgbF(Q7B_IDqreal(R), Q7B_IDqreal(G), Q7B_IDqreal(B), Q7B_IDqreal(A));
}

Q7B Q7B_QCOLOR_SPEC(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).spec() );
}

Q7B Q7B_QCOLOR_TOCMYK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).toCmyk() );
}

Q7B Q7B_QCOLOR_TOHSL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).toHsl() );
}

Q7B Q7B_QCOLOR_TOHSV(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).toHsv() );
}

Q7B Q7B_QCOLOR_TORGB(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).toRgb() );
}

Q7B Q7B_QCOLOR_VALUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).value() );
}

Q7B Q7B_QCOLOR_VALUEF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).valueF() );
}

Q7B Q7B_QCOLOR_YELLOW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).yellow() );
}

Q7B Q7B_QCOLOR_YELLOWF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLOR(self))){ Q7B_EXCEPTION("QColor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColor(self).yellowF() );
}


Q7B Q7B_QCOLUMNVIEW_PREVIEWWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLUMNVIEW(self))){ Q7B_EXCEPTION("QColumnView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColumnView(self)->previewWidget() );
}

Q7B Q7B_QCOLUMNVIEW_RESIZEGRIPSVISIBLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOLUMNVIEW(self))){ Q7B_EXCEPTION("QColumnView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQColumnView(self)->resizeGripsVisible() );
}


void Q7B_QCOLUMNVIEW_SETPREVIEWWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLUMNVIEW(self))){ Q7B_EXCEPTION("QColumnView expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQColumnView(self)->setPreviewWidget(Q7B_IDQWidget(Widget));
}

void Q7B_QCOLUMNVIEW_SETRESIZEGRIPSVISIBLE(Q7B self, Q7B Visible) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOLUMNVIEW(self))){ Q7B_EXCEPTION("QColumnView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Visible))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQColumnView(self)->setResizeGripsVisible(Q7B_IDbool(Visible));
}

Q7B Q7B_QFONT_BOLD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).bold() );
}

Q7B Q7B_QFONT_DEFAULTFAMILY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).defaultFamily() );
}

Q7B Q7B_QFONT_EXACTMATCH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).exactMatch() );
}

Q7B Q7B_QFONT_FAMILY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).family() );
}

Q7B Q7B_QFONT_FIXEDPITCH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).fixedPitch() );
}

Q7B Q7B_QFONT_FROMSTRING(Q7B self, Q7B Descrip) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Descrip))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).fromString(Q7B_IDQString(Descrip)) );
}

Q7B Q7B_QFONT_ITALIC(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).italic() );
}

Q7B Q7B_QFONT_LASTRESORTFAMILY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).lastResortFamily() );
}

Q7B Q7B_QFONT_LASTRESORTFONT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).lastResortFont() );
}

Q7B Q7B_QFONT_LETTERSPACING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).letterSpacing() );
}

Q7B Q7B_QFONT_LETTERSPACINGTYPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).letterSpacingType() );
}

Q7B Q7B_QFONT_OVERLINE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).overline() );
}

Q7B Q7B_QFONT_PIXELSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).pixelSize() );
}

Q7B Q7B_QFONT_POINTSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).pointSize() );
}

Q7B Q7B_QFONT_POINTSIZEF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).pointSizeF() );
}

Q7B Q7B_QFONT_RESOLVE(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QFONT(Other))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).resolve(Q7B_IDQFont(Other)) );
}

void Q7B_QFONT_SETBOLD(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQFont(self).setBold(Q7B_IDbool(Enable));
}

void Q7B_QFONT_SETCAPITALIZATION(Q7B self, Q7B Caps) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Caps))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQFont(self).setCapitalization((QFont::Capitalization) Q7B_IDqint64(Caps));
}

void Q7B_QFONT_SETFAMILY(Q7B self, Q7B Family) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Family))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQFont(self).setFamily(Q7B_IDQString(Family));
}

void Q7B_QFONT_SETFIXEDPITCH(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQFont(self).setFixedPitch(Q7B_IDbool(Enable));
}

void Q7B_QFONT_SETITALIC(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQFont(self).setItalic(Q7B_IDbool(Enable));
}

void Q7B_QFONT_SETLETTERSPACING(Q7B self, Q7B Type, Q7B Spacing) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Type))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Spacing))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQFont(self).setLetterSpacing((QFont::SpacingType) Q7B_IDqint64(Type), Q7B_IDqreal(Spacing));
}

void Q7B_QFONT_SETOVERLINE(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQFont(self).setOverline(Q7B_IDbool(Enable));
}

void Q7B_QFONT_SETPIXELSIZE(Q7B self, Q7B PixelSize) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(PixelSize))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQFont(self).setPixelSize(Q7B_IDqint64(PixelSize));
}

void Q7B_QFONT_SETPOINTSIZE(Q7B self, Q7B PointSize) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(PointSize))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQFont(self).setPointSize(Q7B_IDqint64(PointSize));
}

void Q7B_QFONT_SETPOINTSIZEF(Q7B self, Q7B PointSize) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(PointSize))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQFont(self).setPointSizeF(Q7B_IDqreal(PointSize));
}

void Q7B_QFONT_SETSTRETCH(Q7B self, Q7B Factor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Factor))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQFont(self).setStretch(Q7B_IDqint64(Factor));
}

void Q7B_QFONT_SETSTRIKEOUT(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQFont(self).setStrikeOut(Q7B_IDbool(Enable));
}

void Q7B_QFONT_SETSTYLE(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQFont(self).setStyle((QFont::Style) Q7B_IDqint64(Style));
}

void Q7B_QFONT_SETSTYLESTRATEGY(Q7B self, Q7B S) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(S))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQFont(self).setStyleStrategy((QFont::StyleStrategy) Q7B_IDqint64(S));
}

void Q7B_QFONT_SETUNDERLINE(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQFont(self).setUnderline(Q7B_IDbool(Enable));
}

void Q7B_QFONT_SETWEIGHT(Q7B self, Q7B Weight) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Weight))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQFont(self).setWeight(Q7B_IDqint64(Weight));
}

void Q7B_QFONT_SETWORDSPACING(Q7B self, Q7B Spacing) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Spacing))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQFont(self).setWordSpacing(Q7B_IDqreal(Spacing));
}

Q7B Q7B_QFONT_STRETCH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).stretch() );
}

Q7B Q7B_QFONT_STRIKEOUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).strikeOut() );
}

Q7B Q7B_QFONT_STYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).style() );
}

Q7B Q7B_QFONT_STYLESTRATEGY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).styleStrategy() );
}

Q7B Q7B_QFONT_TOSTRING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).toString() );
}

Q7B Q7B_QFONT_UNDERLINE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).underline() );
}

Q7B Q7B_QFONT_WEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).weight() );
}

Q7B Q7B_QFONT_WORDSPACING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONT(self))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFont(self).wordSpacing() );
}

Q7B Q7B_QHEADERVIEW_CASCADINGSECTIONRESIZES(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->cascadingSectionResizes() );
}

Q7B Q7B_QHEADERVIEW_COUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->count() );
}

Q7B Q7B_QHEADERVIEW_DEFAULTALIGNMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) Q7B_IDQHeaderView(self)->defaultAlignment() );
}

Q7B Q7B_QHEADERVIEW_DEFAULTSECTIONSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->defaultSectionSize() );
}

void Q7B_QHEADERVIEW_HEADERDATACHANGED(Q7B self, Q7B Orientation, Q7B LogicalFirst, Q7B LogicalLast) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Orientation))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(LogicalFirst))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(LogicalLast))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->headerDataChanged((Qt::Orientation) Q7B_IDqint64(Orientation), Q7B_IDqint64(LogicalFirst), Q7B_IDqint64(LogicalLast));
}

Q7B Q7B_QHEADERVIEW_HIDDENSECTIONCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->hiddenSectionCount() );
}

void Q7B_QHEADERVIEW_HIDESECTION(Q7B self, Q7B LogicalIndex) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(LogicalIndex))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->hideSection(Q7B_IDqint64(LogicalIndex));
}

Q7B Q7B_QHEADERVIEW_HIGHLIGHTSECTIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->highlightSections() );
}

Q7B Q7B_QHEADERVIEW_ISCLICKABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->isClickable() );
}

Q7B Q7B_QHEADERVIEW_ISMOVABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->isMovable() );
}

Q7B Q7B_QHEADERVIEW_ISSECTIONHIDDEN(Q7B self, Q7B LogicalIndex) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(LogicalIndex))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->isSectionHidden(Q7B_IDqint64(LogicalIndex)) );
}

Q7B Q7B_QHEADERVIEW_ISSORTINDICATORSHOWN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->isSortIndicatorShown() );
}

Q7B Q7B_QHEADERVIEW_LENGTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->length() );
}

Q7B Q7B_QHEADERVIEW_LOGICALINDEX(Q7B self, Q7B VisualIndex) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(VisualIndex))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->logicalIndex(Q7B_IDqint64(VisualIndex)) );
}

Q7B Q7B_QHEADERVIEW_LOGICALINDEXAT(Q7B self, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->logicalIndexAt(Q7B_IDqint64(X), Q7B_IDqint64(Y)) );
}

Q7B Q7B_QHEADERVIEW_MINIMUMSECTIONSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->minimumSectionSize() );
}

void Q7B_QHEADERVIEW_MOVESECTION(Q7B self, Q7B From, Q7B To) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(From))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(To))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->moveSection(Q7B_IDqint64(From), Q7B_IDqint64(To));
}

Q7B Q7B_QHEADERVIEW_OFFSET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->offset() );
}

Q7B Q7B_QHEADERVIEW_ORIENTATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->orientation() );
}

Q7B Q7B_QHEADERVIEW_RESIZEMODE(Q7B self, Q7B LogicalIndex) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(LogicalIndex))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->resizeMode(Q7B_IDqint64(LogicalIndex)) );
}

void Q7B_QHEADERVIEW_RESIZESECTION(Q7B self, Q7B LogicalIndex, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(LogicalIndex))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Size))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->resizeSection(Q7B_IDqint64(LogicalIndex), Q7B_IDqint64(Size));
}

void Q7B_QHEADERVIEW_RESIZESECTIONS(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->resizeSections((QHeaderView::ResizeMode) Q7B_IDqint64(Mode));
}

Q7B Q7B_QHEADERVIEW_RESTORESTATE(Q7B self, Q7B State) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(State))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->restoreState(Q7B_IDQByteArray(State)) );
}

Q7B Q7B_QHEADERVIEW_SAVESTATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->saveState() );
}

Q7B Q7B_QHEADERVIEW_SECTIONPOSITION(Q7B self, Q7B LogicalIndex) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(LogicalIndex))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->sectionPosition(Q7B_IDqint64(LogicalIndex)) );
}

Q7B Q7B_QHEADERVIEW_SECTIONSIZE(Q7B self, Q7B LogicalIndex) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(LogicalIndex))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->sectionSize(Q7B_IDqint64(LogicalIndex)) );
}

Q7B Q7B_QHEADERVIEW_SECTIONSIZEHINT(Q7B self, Q7B LogicalIndex) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(LogicalIndex))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->sectionSizeHint(Q7B_IDqint64(LogicalIndex)) );
}

Q7B Q7B_QHEADERVIEW_SECTIONVIEWPORTPOSITION(Q7B self, Q7B LogicalIndex) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(LogicalIndex))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->sectionViewportPosition(Q7B_IDqint64(LogicalIndex)) );
}

Q7B Q7B_QHEADERVIEW_SECTIONSHIDDEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->sectionsHidden() );
}

Q7B Q7B_QHEADERVIEW_SECTIONSMOVED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->sectionsMoved() );
}

void Q7B_QHEADERVIEW_SETCASCADINGSECTIONRESIZES(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQHeaderView(self)->setCascadingSectionResizes(Q7B_IDbool(Enable));
}

void Q7B_QHEADERVIEW_SETCLICKABLE(Q7B self, Q7B Clickable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Clickable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQHeaderView(self)->setClickable(Q7B_IDbool(Clickable));
}

void Q7B_QHEADERVIEW_SETDEFAULTALIGNMENT(Q7B self, Q7B Alignment) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Alignment))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->setDefaultAlignment((Qt::Alignment) Q7B_IDqint64(Alignment));
}

void Q7B_QHEADERVIEW_SETDEFAULTSECTIONSIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Size))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->setDefaultSectionSize(Q7B_IDqint64(Size));
}

void Q7B_QHEADERVIEW_SETHIGHLIGHTSECTIONS(Q7B self, Q7B HighLight) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(HighLight))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQHeaderView(self)->setHighlightSections(Q7B_IDbool(HighLight));
}

void Q7B_QHEADERVIEW_SETMINIMUMSECTIONSIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Size))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->setMinimumSectionSize(Q7B_IDqint64(Size));
}

void Q7B_QHEADERVIEW_SETMOVABLE(Q7B self, Q7B Movable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Movable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQHeaderView(self)->setMovable(Q7B_IDbool(Movable));
}

void Q7B_QHEADERVIEW_SETOFFSET(Q7B self, Q7B Offset) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Offset))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->setOffset(Q7B_IDqint64(Offset));
}

void Q7B_QHEADERVIEW_SETOFFSETTOLASTSECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  Q7B_IDQHeaderView(self)->setOffsetToLastSection();
}

void Q7B_QHEADERVIEW_SETOFFSETTOSECTIONPOSITION(Q7B self, Q7B VisualIndex) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(VisualIndex))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->setOffsetToSectionPosition(Q7B_IDqint64(VisualIndex));
}

void Q7B_QHEADERVIEW_SETRESIZEMODE(Q7B self, Q7B LogicalIndex, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(LogicalIndex))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->setResizeMode(Q7B_IDqint64(LogicalIndex), (QHeaderView::ResizeMode) Q7B_IDqint64(Mode));
}

void Q7B_QHEADERVIEW_SETSECTIONHIDDEN(Q7B self, Q7B LogicalIndex, Q7B Hide) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(LogicalIndex))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Hide))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQHeaderView(self)->setSectionHidden(Q7B_IDqint64(LogicalIndex), Q7B_IDbool(Hide));
}

void Q7B_QHEADERVIEW_SETSORTINDICATOR(Q7B self, Q7B LogicalIndex, Q7B Order) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(LogicalIndex))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Order))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->setSortIndicator(Q7B_IDqint64(LogicalIndex), (Qt::SortOrder) Q7B_IDqint64(Order));
}

void Q7B_QHEADERVIEW_SETSORTINDICATORSHOWN(Q7B self, Q7B Show) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Show))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQHeaderView(self)->setSortIndicatorShown(Q7B_IDbool(Show));
}

void Q7B_QHEADERVIEW_SETSTRETCHLASTSECTION(Q7B self, Q7B Stretch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Stretch))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQHeaderView(self)->setStretchLastSection(Q7B_IDbool(Stretch));
}

void Q7B_QHEADERVIEW_SHOWSECTION(Q7B self, Q7B LogicalIndex) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(LogicalIndex))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->showSection(Q7B_IDqint64(LogicalIndex));
}

Q7B Q7B_QHEADERVIEW_SHOWSORTINDICATOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->isSortIndicatorShown() );
}

void Q7B_QHEADERVIEW_SHOWSORTINDICATOR(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQHeaderView(self)->setSortIndicatorShown(Q7B_IDbool(theProperty));
}

Q7B Q7B_QHEADERVIEW_SORTINDICATORORDER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->sortIndicatorOrder() );
}

Q7B Q7B_QHEADERVIEW_SORTINDICATORSECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->sortIndicatorSection() );
}

Q7B Q7B_QHEADERVIEW_STRETCHLASTSECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->stretchLastSection() );
}

Q7B Q7B_QHEADERVIEW_STRETCHSECTIONCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->stretchSectionCount() );
}

void Q7B_QHEADERVIEW_SWAPSECTIONS(Q7B self, Q7B First, Q7B Second) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(First))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Second))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQHeaderView(self)->swapSections(Q7B_IDqint64(First), Q7B_IDqint64(Second));
}

Q7B Q7B_QHEADERVIEW_VISUALINDEX(Q7B self, Q7B LogicalIndex) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(LogicalIndex))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->visualIndex(Q7B_IDqint64(LogicalIndex)) );
}

Q7B Q7B_QHEADERVIEW_VISUALINDEXAT(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHEADERVIEW(self))){ Q7B_EXCEPTION("QHeaderView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHeaderView(self)->visualIndexAt(Q7B_IDqint64(Position)) );
}

Q7B Q7B_QINPUTDIALOG_CANCELBUTTONTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->cancelButtonText() );
}

Q7B Q7B_QINPUTDIALOG_COMBOBOXEDITABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->isComboBoxEditable() );
}

void Q7B_QINPUTDIALOG_COMBOBOXEDITABLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQInputDialog(self)->setComboBoxEditable(Q7B_IDbool(theProperty));
}

Q7B Q7B_QINPUTDIALOG_COMBOBOXITEMS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->comboBoxItems() );
}

Q7B Q7B_QINPUTDIALOG_DOUBLEDECIMALS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->doubleDecimals() );
}

Q7B Q7B_QINPUTDIALOG_DOUBLEMAXIMUM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->doubleMaximum() );
}

Q7B Q7B_QINPUTDIALOG_DOUBLEMINIMUM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->doubleMinimum() );
}

Q7B Q7B_QINPUTDIALOG_DOUBLEVALUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->doubleValue() );
}

Q7B Q7B_QINPUTDIALOG_INPUTMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->inputMode() );
}

Q7B Q7B_QINPUTDIALOG_INTMAXIMUM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->intMaximum() );
}

Q7B Q7B_QINPUTDIALOG_INTMINIMUM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->intMinimum() );
}

Q7B Q7B_QINPUTDIALOG_INTSTEP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->intStep() );
}

Q7B Q7B_QINPUTDIALOG_INTVALUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->intValue() );
}

Q7B Q7B_QINPUTDIALOG_ISCOMBOBOXEDITABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->isComboBoxEditable() );
}

Q7B Q7B_QINPUTDIALOG_LABELTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->labelText() );
}

Q7B Q7B_QINPUTDIALOG_OKBUTTONTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->okButtonText() );
}

Q7B Q7B_QINPUTDIALOG_OPTIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->options() );
}

void Q7B_QINPUTDIALOG_SETCANCELBUTTONTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQInputDialog(self)->setCancelButtonText(Q7B_IDQString(Text));
}

void Q7B_QINPUTDIALOG_SETCOMBOBOXEDITABLE(Q7B self, Q7B Editable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Editable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQInputDialog(self)->setComboBoxEditable(Q7B_IDbool(Editable));
}

void Q7B_QINPUTDIALOG_SETCOMBOBOXITEMS(Q7B self, Q7B Items) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Items))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQInputDialog(self)->setComboBoxItems(Q7B_IDQStringList(Items));
}

void Q7B_QINPUTDIALOG_SETDOUBLEDECIMALS(Q7B self, Q7B Decimals) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Decimals))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQInputDialog(self)->setDoubleDecimals(Q7B_IDqint64(Decimals));
}

void Q7B_QINPUTDIALOG_SETDOUBLEMAXIMUM(Q7B self, Q7B Max) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Max))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQInputDialog(self)->setDoubleMaximum(Q7B_IDqreal(Max));
}

void Q7B_QINPUTDIALOG_SETDOUBLEMINIMUM(Q7B self, Q7B a0) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(a0))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQInputDialog(self)->setDoubleMinimum(Q7B_IDqreal(a0));
}

void Q7B_QINPUTDIALOG_SETDOUBLEVALUE(Q7B self, Q7B Value) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Value))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQInputDialog(self)->setDoubleValue(Q7B_IDqreal(Value));
}

void Q7B_QINPUTDIALOG_SETINPUTMODE(Q7B self, Q7B InputMode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(InputMode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQInputDialog(self)->setInputMode((QInputDialog::InputMode) Q7B_IDqint64(InputMode));
}

void Q7B_QINPUTDIALOG_SETINTMAXIMUM(Q7B self, Q7B Max) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Max))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQInputDialog(self)->setIntMaximum(Q7B_IDqint64(Max));
}

void Q7B_QINPUTDIALOG_SETINTMINIMUM(Q7B self, Q7B Min) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Min))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQInputDialog(self)->setIntMinimum(Q7B_IDqint64(Min));
}

void Q7B_QINPUTDIALOG_SETINTSTEP(Q7B self, Q7B Step) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Step))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQInputDialog(self)->setIntStep(Q7B_IDqint64(Step));
}

void Q7B_QINPUTDIALOG_SETINTVALUE(Q7B self, Q7B Value) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Value))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQInputDialog(self)->setIntValue(Q7B_IDqint64(Value));
}

void Q7B_QINPUTDIALOG_SETLABELTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQInputDialog(self)->setLabelText(Q7B_IDQString(Text));
}

void Q7B_QINPUTDIALOG_SETOKBUTTONTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQInputDialog(self)->setOkButtonText(Q7B_IDQString(Text));
}

void Q7B_QINPUTDIALOG_SETOPTION(Q7B self, Q7B Option, Q7B On) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Option))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(On))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQInputDialog(self)->setOption((QInputDialog::InputDialogOption) Q7B_IDqint64(Option), Q7B_IDbool(On));
}

void Q7B_QINPUTDIALOG_SETTEXTECHOMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQInputDialog(self)->setTextEchoMode((QLineEdit::EchoMode) Q7B_IDqint64(Mode));
}

void Q7B_QINPUTDIALOG_SETTEXTVALUE(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQInputDialog(self)->setTextValue(Q7B_IDQString(Text));
}

Q7B Q7B_QINPUTDIALOG_TEXTECHOMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->textEchoMode() );
}

Q7B Q7B_QINPUTDIALOG_TEXTVALUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTDIALOG(self))){ Q7B_EXCEPTION("QInputDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputDialog(self)->textValue() );
}

Q7B Q7B_QLISTVIEW_BATCHSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->batchSize() );
}

void Q7B_QLISTVIEW_CLEARPROPERTYFLAGS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  Q7B_IDQListView(self)->clearPropertyFlags();
}

Q7B Q7B_QLISTVIEW_FLOW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->flow() );
}

Q7B Q7B_QLISTVIEW_GRIDSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->gridSize() );
}

Q7B Q7B_QLISTVIEW_ISROWHIDDEN(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->isRowHidden(Q7B_IDqint64(Row)) );
}

Q7B Q7B_QLISTVIEW_ISSELECTIONRECTVISIBLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->isSelectionRectVisible() );
}

Q7B Q7B_QLISTVIEW_ISWRAPPING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->isWrapping() );
}

Q7B Q7B_QLISTVIEW_LAYOUTMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->layoutMode() );
}

Q7B Q7B_QLISTVIEW_MODELCOLUMN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->modelColumn() );
}

Q7B Q7B_QLISTVIEW_MOVEMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->movement() );
}

Q7B Q7B_QLISTVIEW_RESIZEMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->resizeMode() );
}

Q7B Q7B_QLISTVIEW_SELECTIONRECTVISIBLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->isSelectionRectVisible() );
}

void Q7B_QLISTVIEW_SELECTIONRECTVISIBLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQListView(self)->setSelectionRectVisible(Q7B_IDbool(theProperty));
}

void Q7B_QLISTVIEW_SETBATCHSIZE(Q7B self, Q7B BatchSize) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(BatchSize))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListView(self)->setBatchSize(Q7B_IDqint64(BatchSize));
}

void Q7B_QLISTVIEW_SETFLOW(Q7B self, Q7B Flow) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Flow))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListView(self)->setFlow((QListView::Flow) Q7B_IDqint64(Flow));
}

void Q7B_QLISTVIEW_SETGRIDSIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQListView(self)->setGridSize(Q7B_IDQSize(Size));
}

void Q7B_QLISTVIEW_SETLAYOUTMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListView(self)->setLayoutMode((QListView::LayoutMode) Q7B_IDqint64(Mode));
}

void Q7B_QLISTVIEW_SETMODELCOLUMN(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListView(self)->setModelColumn(Q7B_IDqint64(Column));
}

void Q7B_QLISTVIEW_SETMOVEMENT(Q7B self, Q7B Movement) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Movement))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListView(self)->setMovement((QListView::Movement) Q7B_IDqint64(Movement));
}

void Q7B_QLISTVIEW_SETRESIZEMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListView(self)->setResizeMode((QListView::ResizeMode) Q7B_IDqint64(Mode));
}

void Q7B_QLISTVIEW_SETROWHIDDEN(Q7B self, Q7B Row, Q7B Hide) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Hide))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQListView(self)->setRowHidden(Q7B_IDqint64(Row), Q7B_IDbool(Hide));
}

void Q7B_QLISTVIEW_SETSELECTIONRECTVISIBLE(Q7B self, Q7B Show) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Show))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQListView(self)->setSelectionRectVisible(Q7B_IDbool(Show));
}

void Q7B_QLISTVIEW_SETSPACING(Q7B self, Q7B Space) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Space))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListView(self)->setSpacing(Q7B_IDqint64(Space));
}

void Q7B_QLISTVIEW_SETUNIFORMITEMSIZES(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQListView(self)->setUniformItemSizes(Q7B_IDbool(Enable));
}

void Q7B_QLISTVIEW_SETVIEWMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQListView(self)->setViewMode((QListView::ViewMode) Q7B_IDqint64(Mode));
}

void Q7B_QLISTVIEW_SETWORDWRAP(Q7B self, Q7B On) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(On))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQListView(self)->setWordWrap(Q7B_IDbool(On));
}

void Q7B_QLISTVIEW_SETWRAPPING(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQListView(self)->setWrapping(Q7B_IDbool(Enable));
}

Q7B Q7B_QLISTVIEW_SPACING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->spacing() );
}

Q7B Q7B_QLISTVIEW_UNIFORMITEMSIZES(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->uniformItemSizes() );
}

Q7B Q7B_QLISTVIEW_VIEWMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->viewMode() );
}

Q7B Q7B_QLISTVIEW_WORDWRAP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTVIEW(self))){ Q7B_EXCEPTION("QListView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListView(self)->wordWrap() );
}

void Q7B_QTABLEVIEW_CLEARSPANS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  Q7B_IDQTableView(self)->clearSpans();
}

Q7B Q7B_QTABLEVIEW_COLUMNAT(Q7B self, Q7B X) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->columnAt(Q7B_IDqint64(X)) );
}

Q7B Q7B_QTABLEVIEW_COLUMNSPAN(Q7B self, Q7B Row, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->columnSpan(Q7B_IDqint64(Row), Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTABLEVIEW_COLUMNVIEWPORTPOSITION(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->columnViewportPosition(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTABLEVIEW_COLUMNWIDTH(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->columnWidth(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTABLEVIEW_CORNERBUTTONENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->isCornerButtonEnabled() );
}

void Q7B_QTABLEVIEW_CORNERBUTTONENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTableView(self)->setCornerButtonEnabled(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTABLEVIEW_GRIDSTYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->gridStyle() );
}

void Q7B_QTABLEVIEW_HIDECOLUMN(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableView(self)->hideColumn(Q7B_IDqint64(Column));
}

void Q7B_QTABLEVIEW_HIDEROW(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableView(self)->hideRow(Q7B_IDqint64(Row));
}

Q7B Q7B_QTABLEVIEW_HORIZONTALHEADER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->horizontalHeader() );
}

Q7B Q7B_QTABLEVIEW_ISCOLUMNHIDDEN(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->isColumnHidden(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTABLEVIEW_ISCORNERBUTTONENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->isCornerButtonEnabled() );
}

Q7B Q7B_QTABLEVIEW_ISROWHIDDEN(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->isRowHidden(Q7B_IDqint64(Row)) );
}

Q7B Q7B_QTABLEVIEW_ISSORTINGENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->isSortingEnabled() );
}

void Q7B_QTABLEVIEW_RESIZECOLUMNTOCONTENTS(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableView(self)->resizeColumnToContents(Q7B_IDqint64(Column));
}

void Q7B_QTABLEVIEW_RESIZECOLUMNSTOCONTENTS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  Q7B_IDQTableView(self)->resizeColumnsToContents();
}

void Q7B_QTABLEVIEW_RESIZEROWTOCONTENTS(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableView(self)->resizeRowToContents(Q7B_IDqint64(Row));
}

void Q7B_QTABLEVIEW_RESIZEROWSTOCONTENTS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  Q7B_IDQTableView(self)->resizeRowsToContents();
}

Q7B Q7B_QTABLEVIEW_ROWAT(Q7B self, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->rowAt(Q7B_IDqint64(Y)) );
}

Q7B Q7B_QTABLEVIEW_ROWHEIGHT(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->rowHeight(Q7B_IDqint64(Row)) );
}

Q7B Q7B_QTABLEVIEW_ROWSPAN(Q7B self, Q7B Row, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->rowSpan(Q7B_IDqint64(Row), Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTABLEVIEW_ROWVIEWPORTPOSITION(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->rowViewportPosition(Q7B_IDqint64(Row)) );
}

void Q7B_QTABLEVIEW_SELECTCOLUMN(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableView(self)->selectColumn(Q7B_IDqint64(Column));
}

void Q7B_QTABLEVIEW_SELECTROW(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableView(self)->selectRow(Q7B_IDqint64(Row));
}

void Q7B_QTABLEVIEW_SETCOLUMNHIDDEN(Q7B self, Q7B Column, Q7B Hide) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Hide))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTableView(self)->setColumnHidden(Q7B_IDqint64(Column), Q7B_IDbool(Hide));
}

void Q7B_QTABLEVIEW_SETCORNERBUTTONENABLED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTableView(self)->setCornerButtonEnabled(Q7B_IDbool(Enable));
}

void Q7B_QTABLEVIEW_SETGRIDSTYLE(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableView(self)->setGridStyle((Qt::PenStyle) Q7B_IDqint64(Style));
}

void Q7B_QTABLEVIEW_SETHORIZONTALHEADER(Q7B self, Q7B Header) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QHEADERVIEW(Header))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  Q7B_IDQTableView(self)->setHorizontalHeader(Q7B_IDQHeaderView(Header));
}

void Q7B_QTABLEVIEW_SETROWHEIGHT(Q7B self, Q7B Row, Q7B Height) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Height))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableView(self)->setRowHeight(Q7B_IDqint64(Row), Q7B_IDqint64(Height));
}

void Q7B_QTABLEVIEW_SETROWHIDDEN(Q7B self, Q7B Row, Q7B Hide) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Hide))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTableView(self)->setRowHidden(Q7B_IDqint64(Row), Q7B_IDbool(Hide));
}

void Q7B_QTABLEVIEW_SETSHOWGRID(Q7B self, Q7B Show) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Show))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTableView(self)->setShowGrid(Q7B_IDbool(Show));
}

void Q7B_QTABLEVIEW_SETSORTINGENABLED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTableView(self)->setSortingEnabled(Q7B_IDbool(Enable));
}

void Q7B_QTABLEVIEW_SETSPAN(Q7B self, Q7B Row, Q7B Column, Q7B RowSpanCount, Q7B ColumnSpanCount) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(RowSpanCount))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(ColumnSpanCount))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableView(self)->setSpan(Q7B_IDqint64(Row), Q7B_IDqint64(Column), Q7B_IDqint64(RowSpanCount), Q7B_IDqint64(ColumnSpanCount));
}

void Q7B_QTABLEVIEW_SETVERTICALHEADER(Q7B self, Q7B Header) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QHEADERVIEW(Header))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  Q7B_IDQTableView(self)->setVerticalHeader(Q7B_IDQHeaderView(Header));
}

void Q7B_QTABLEVIEW_SETWORDWRAP(Q7B self, Q7B On) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(On))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTableView(self)->setWordWrap(Q7B_IDbool(On));
}

void Q7B_QTABLEVIEW_SHOWCOLUMN(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableView(self)->showColumn(Q7B_IDqint64(Column));
}

Q7B Q7B_QTABLEVIEW_SHOWGRID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->showGrid() );
}

void Q7B_QTABLEVIEW_SHOWROW(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableView(self)->showRow(Q7B_IDqint64(Row));
}

void Q7B_QTABLEVIEW_SORTBYCOLUMN(Q7B self, Q7B Column, Q7B Order) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Order))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTableView(self)->sortByColumn(Q7B_IDqint64(Column), (Qt::SortOrder) Q7B_IDqint64(Order));
}

Q7B Q7B_QTABLEVIEW_SORTINGENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->isSortingEnabled() );
}

void Q7B_QTABLEVIEW_SORTINGENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTableView(self)->setSortingEnabled(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTABLEVIEW_VERTICALHEADER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->verticalHeader() );
}

Q7B Q7B_QTABLEVIEW_WORDWRAP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTABLEVIEW(self))){ Q7B_EXCEPTION("QTableView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTableView(self)->wordWrap() );
}

Q7B Q7B_QTREEVIEW_ALLCOLUMNSSHOWFOCUS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->allColumnsShowFocus() );
}

Q7B Q7B_QTREEVIEW_ANIMATED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->isAnimated() );
}

void Q7B_QTREEVIEW_ANIMATED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTreeView(self)->setAnimated(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTREEVIEW_AUTOEXPANDDELAY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->autoExpandDelay() );
}



void Q7B_QTREEVIEW_COLLAPSE(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  Q7B_IDQTreeView(self)->collapse(Q7B_IDQModelIndex(Index));
}

void Q7B_QTREEVIEW_COLLAPSEALL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  Q7B_IDQTreeView(self)->collapseAll();
}

Q7B Q7B_QTREEVIEW_COLUMNAT(Q7B self, Q7B X) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->columnAt(Q7B_IDqint64(X)) );
}

Q7B Q7B_QTREEVIEW_COLUMNVIEWPORTPOSITION(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->columnViewportPosition(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTREEVIEW_COLUMNWIDTH(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->columnWidth(Q7B_IDqint64(Column)) );
}

void Q7B_QTREEVIEW_EXPAND(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  Q7B_IDQTreeView(self)->expand(Q7B_IDQModelIndex(Index));
}

void Q7B_QTREEVIEW_EXPANDALL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  Q7B_IDQTreeView(self)->expandAll();
}

void Q7B_QTREEVIEW_EXPANDTODEPTH(Q7B self, Q7B Depth) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Depth))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeView(self)->expandToDepth(Q7B_IDqint64(Depth));
}

Q7B Q7B_QTREEVIEW_EXPANDSONDOUBLECLICK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->expandsOnDoubleClick() );
}

Q7B Q7B_QTREEVIEW_HEADER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->header() );
}

Q7B Q7B_QTREEVIEW_HEADERHIDDEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->isHeaderHidden() );
}

void Q7B_QTREEVIEW_HEADERHIDDEN(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTreeView(self)->setHeaderHidden(Q7B_IDbool(theProperty));
}

void Q7B_QTREEVIEW_HIDECOLUMN(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeView(self)->hideColumn(Q7B_IDqint64(Column));
}

Q7B Q7B_QTREEVIEW_INDENTATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->indentation() );
}

Q7B Q7B_QTREEVIEW_INDEXABOVE(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->indexAbove(Q7B_IDQModelIndex(Index)) );
}

Q7B Q7B_QTREEVIEW_INDEXBELOW(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->indexBelow(Q7B_IDQModelIndex(Index)) );
}

Q7B Q7B_QTREEVIEW_ISANIMATED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->isAnimated() );
}

Q7B Q7B_QTREEVIEW_ISCOLUMNHIDDEN(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->isColumnHidden(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QTREEVIEW_ISEXPANDED(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->isExpanded(Q7B_IDQModelIndex(Index)) );
}

Q7B Q7B_QTREEVIEW_ISFIRSTCOLUMNSPANNED(Q7B self, Q7B Row, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->isFirstColumnSpanned(Q7B_IDqint64(Row), Q7B_IDQModelIndex(Parent)) );
}

Q7B Q7B_QTREEVIEW_ISHEADERHIDDEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->isHeaderHidden() );
}

Q7B Q7B_QTREEVIEW_ISROWHIDDEN(Q7B self, Q7B Row, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->isRowHidden(Q7B_IDqint64(Row), Q7B_IDQModelIndex(Parent)) );
}

Q7B Q7B_QTREEVIEW_ISSORTINGENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->isSortingEnabled() );
}

Q7B Q7B_QTREEVIEW_ITEMSEXPANDABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->itemsExpandable() );
}

void Q7B_QTREEVIEW_RESIZECOLUMNTOCONTENTS(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeView(self)->resizeColumnToContents(Q7B_IDqint64(Column));
}

Q7B Q7B_QTREEVIEW_ROOTISDECORATED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->rootIsDecorated() );
}

void Q7B_QTREEVIEW_SETALLCOLUMNSSHOWFOCUS(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeView(self)->setAllColumnsShowFocus(Q7B_IDbool(Enable));
}

void Q7B_QTREEVIEW_SETANIMATED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeView(self)->setAnimated(Q7B_IDbool(Enable));
}

void Q7B_QTREEVIEW_SETAUTOEXPANDDELAY(Q7B self, Q7B Delay) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Delay))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeView(self)->setAutoExpandDelay(Q7B_IDqint64(Delay));
}

void Q7B_QTREEVIEW_SETCOLUMNHIDDEN(Q7B self, Q7B Column, Q7B Hide) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Hide))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeView(self)->setColumnHidden(Q7B_IDqint64(Column), Q7B_IDbool(Hide));
}

void Q7B_QTREEVIEW_SETCOLUMNWIDTH(Q7B self, Q7B Column, Q7B Width) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeView(self)->setColumnWidth(Q7B_IDqint64(Column), Q7B_IDqint64(Width));
}

void Q7B_QTREEVIEW_SETEXPANDED(Q7B self, Q7B Index, Q7B Expanded) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Expanded))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeView(self)->setExpanded(Q7B_IDQModelIndex(Index), Q7B_IDbool(Expanded));
}

void Q7B_QTREEVIEW_SETEXPANDSONDOUBLECLICK(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeView(self)->setExpandsOnDoubleClick(Q7B_IDbool(Enable));
}

void Q7B_QTREEVIEW_SETFIRSTCOLUMNSPANNED(Q7B self, Q7B Row, Q7B Parent, Q7B Span) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Span))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeView(self)->setFirstColumnSpanned(Q7B_IDqint64(Row), Q7B_IDQModelIndex(Parent), Q7B_IDbool(Span));
}

void Q7B_QTREEVIEW_SETHEADER(Q7B self, Q7B Header) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QHEADERVIEW(Header))){ Q7B_EXCEPTION("QHeaderView expected"); return ; }

  Q7B_IDQTreeView(self)->setHeader(Q7B_IDQHeaderView(Header));
}

void Q7B_QTREEVIEW_SETHEADERHIDDEN(Q7B self, Q7B Hide) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Hide))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeView(self)->setHeaderHidden(Q7B_IDbool(Hide));
}

void Q7B_QTREEVIEW_SETINDENTATION(Q7B self, Q7B I) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(I))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeView(self)->setIndentation(Q7B_IDqint64(I));
}

void Q7B_QTREEVIEW_SETITEMSEXPANDABLE(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeView(self)->setItemsExpandable(Q7B_IDbool(Enable));
}

void Q7B_QTREEVIEW_SETROOTISDECORATED(Q7B self, Q7B Show) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Show))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeView(self)->setRootIsDecorated(Q7B_IDbool(Show));
}

void Q7B_QTREEVIEW_SETROWHIDDEN(Q7B self, Q7B Row, Q7B Parent, Q7B Hide) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Hide))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeView(self)->setRowHidden(Q7B_IDqint64(Row), Q7B_IDQModelIndex(Parent), Q7B_IDbool(Hide));
}

void Q7B_QTREEVIEW_SETSORTINGENABLED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeView(self)->setSortingEnabled(Q7B_IDbool(Enable));
}

void Q7B_QTREEVIEW_SETUNIFORMROWHEIGHTS(Q7B self, Q7B Uniform) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Uniform))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeView(self)->setUniformRowHeights(Q7B_IDbool(Uniform));
}

void Q7B_QTREEVIEW_SETWORDWRAP(Q7B self, Q7B On) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(On))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTreeView(self)->setWordWrap(Q7B_IDbool(On));
}

void Q7B_QTREEVIEW_SHOWCOLUMN(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeView(self)->showColumn(Q7B_IDqint64(Column));
}

void Q7B_QTREEVIEW_SORTBYCOLUMN(Q7B self, Q7B Column, Q7B Order) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Order))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTreeView(self)->sortByColumn(Q7B_IDqint64(Column), (Qt::SortOrder) Q7B_IDqint64(Order));
}

Q7B Q7B_QTREEVIEW_SORTINGENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->isSortingEnabled() );
}

void Q7B_QTREEVIEW_SORTINGENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQTreeView(self)->setSortingEnabled(Q7B_IDbool(theProperty));
}

Q7B Q7B_QTREEVIEW_UNIFORMROWHEIGHTS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->uniformRowHeights() );
}

Q7B Q7B_QTREEVIEW_WORDWRAP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTREEVIEW(self))){ Q7B_EXCEPTION("QTreeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTreeView(self)->wordWrap() );
}

void Q7B_QVALIDATOR_FIXUP(Q7B self, Q7B Input) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QVALIDATOR(self))){ Q7B_EXCEPTION("QValidator expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Input))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQValidator(self)->fixup(Q7B_IDQString(Input));
}

Q7B Q7B_QVALIDATOR_LOCALE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVALIDATOR(self))){ Q7B_EXCEPTION("QValidator expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQValidator(self)->locale() );
}

void Q7B_QVALIDATOR_SETLOCALE(Q7B self, Q7B Locale) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QVALIDATOR(self))){ Q7B_EXCEPTION("QValidator expected"); return ; }

  if (Q7B_nil(Q7B_QLOCALE(Locale))){ Q7B_EXCEPTION("QLocale expected"); return ; }

  Q7B_IDQValidator(self)->setLocale(Q7B_IDQLocale(Locale));
}

Q7B Q7B_QVALIDATOR_VALIDATE(Q7B self, Q7B Input, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVALIDATOR(self))){ Q7B_EXCEPTION("QValidator expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Input))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Pos))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QString input = Q7B_IDQString(Input);
  int pos = Q7B_IDqint64(Pos); 

  return Q7B_ID( (qint64) Q7B_IDQValidator(self)->validate(input, pos) );
}



void Q7B_QACTION_ACTIVATE(Q7B self, Q7B Event) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Event))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAction(self)->activate((QAction::ActionEvent) Q7B_IDqint64(Event));
}

Q7B Q7B_QACTION_AUTOREPEAT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->autoRepeat() );
}

Q7B Q7B_QACTION_DATA(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->data() );
}

Q7B Q7B_QACTION_FONT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->font() );
}

void Q7B_QACTION_HOVER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  Q7B_IDQAction(self)->hover();
}

Q7B Q7B_QACTION_ICONTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->iconText() );
}

Q7B Q7B_QACTION_ICONVISIBLEINMENU(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->isIconVisibleInMenu() );
}

void Q7B_QACTION_ICONVISIBLEINMENU(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQAction(self)->setIconVisibleInMenu(Q7B_IDbool(theProperty));
}

Q7B Q7B_QACTION_ISCHECKABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->isCheckable() );
}

Q7B Q7B_QACTION_ISCHECKED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->isChecked() );
}

Q7B Q7B_QACTION_ISENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->isEnabled() );
}

Q7B Q7B_QACTION_ISICONVISIBLEINMENU(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->isIconVisibleInMenu() );
}

Q7B Q7B_QACTION_ISSEPARATOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->isSeparator() );
}

Q7B Q7B_QACTION_ISVISIBLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->isVisible() );
}

Q7B Q7B_QACTION_MENU(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->menu() );
}

Q7B Q7B_QACTION_MENUROLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->menuRole() );
}

Q7B Q7B_QACTION_PARENTWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->parentWidget() );
}

Q7B Q7B_QACTION_PRIORITY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->priority() );
}

void Q7B_QACTION_SETAUTOREPEAT(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAction(self)->setAutoRepeat(Q7B_IDbool(Enable));
}

void Q7B_QACTION_SETCHECKABLE(Q7B self, Q7B Checkable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Checkable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAction(self)->setCheckable(Q7B_IDbool(Checkable));
}

void Q7B_QACTION_SETCHECKED(Q7B self, Q7B b) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(b))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAction(self)->setChecked(Q7B_IDbool(b));
}

void Q7B_QACTION_SETDATA(Q7B self, Q7B UserData) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QVARIANT(UserData))){ Q7B_EXCEPTION("QVariant expected"); return ; }

  Q7B_IDQAction(self)->setData(Q7B_IDQVariant(UserData));
}

void Q7B_QACTION_SETDISABLED(Q7B self, Q7B b) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(b))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAction(self)->setDisabled(Q7B_IDbool(b));
}

void Q7B_QACTION_SETENABLED(Q7B self, Q7B b) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(b))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAction(self)->setEnabled(Q7B_IDbool(b));
}

void Q7B_QACTION_SETFONT(Q7B self, Q7B Font) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QFONT(Font))){ Q7B_EXCEPTION("QFont expected"); return ; }

  Q7B_IDQAction(self)->setFont(Q7B_IDQFont(Font));
}

void Q7B_QACTION_SETICON(Q7B self, Q7B Icon) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  Q7B_IDQAction(self)->setIcon(Q7B_IDQIcon(Icon));
}

void Q7B_QACTION_SETICONTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQAction(self)->setIconText(Q7B_IDQString(Text));
}

void Q7B_QACTION_SETICONVISIBLEINMENU(Q7B self, Q7B Visible) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Visible))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAction(self)->setIconVisibleInMenu(Q7B_IDbool(Visible));
}

void Q7B_QACTION_SETMENU(Q7B self, Q7B Menu) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QMENU(Menu))){ Q7B_EXCEPTION("QMenu expected"); return ; }

  Q7B_IDQAction(self)->setMenu(Q7B_IDQMenu(Menu));
}

void Q7B_QACTION_SETMENUROLE(Q7B self, Q7B MenuRole) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(MenuRole))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAction(self)->setMenuRole((QAction::MenuRole) Q7B_IDqint64(MenuRole));
}

void Q7B_QACTION_SETPRIORITY(Q7B self, Q7B Priority) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Priority))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAction(self)->setPriority((QAction::Priority) Q7B_IDqint64(Priority));
}

void Q7B_QACTION_SETSEPARATOR(Q7B self, Q7B B) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(B))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAction(self)->setSeparator(Q7B_IDbool(B));
}

void Q7B_QACTION_SETSHORTCUT(Q7B self, Q7B Shorcut) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QKEYSEQUENCE(Shorcut))){ Q7B_EXCEPTION("QKeySequence expected"); return ; }

  Q7B_IDQAction(self)->setShortcut(Q7B_IDQKeySequence(Shorcut));
}

void Q7B_QACTION_SETSHORTCUTCONTEXT(Q7B self, Q7B Context) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Context))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAction(self)->setShortcutContext((Qt::ShortcutContext) Q7B_IDqint64(Context));
}

void Q7B_QACTION_SETSOFTKEYROLE(Q7B self, Q7B SoftKeyRole) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(SoftKeyRole))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAction(self)->setSoftKeyRole((QAction::SoftKeyRole) Q7B_IDqint64(SoftKeyRole));
}

void Q7B_QACTION_SETSTATUSTIP(Q7B self, Q7B StatusTip) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(StatusTip))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQAction(self)->setStatusTip(Q7B_IDQString(StatusTip));
}

void Q7B_QACTION_SETTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQAction(self)->setText(Q7B_IDQString(Text));
}

void Q7B_QACTION_SETTOOLTIP(Q7B self, Q7B Tip) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Tip))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQAction(self)->setToolTip(Q7B_IDQString(Tip));
}

void Q7B_QACTION_SETVISIBLE(Q7B self, Q7B b) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(b))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAction(self)->setVisible(Q7B_IDbool(b));
}

void Q7B_QACTION_SETWHATSTHIS(Q7B self, Q7B What) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(What))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQAction(self)->setWhatsThis(Q7B_IDQString(What));
}

Q7B Q7B_QACTION_SHORTCUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->shortcut() );
}

Q7B Q7B_QACTION_SHORTCUTCONTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->shortcutContext() );
}

Q7B Q7B_QACTION_SHOWSTATUSTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->showStatusText() );
}

Q7B Q7B_QACTION_SOFTKEYROLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->softKeyRole() );
}

Q7B Q7B_QACTION_STATUSTIP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->statusTip() );
}

void Q7B_QACTION_TOGGLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  Q7B_IDQAction(self)->toggle();
}

Q7B Q7B_QACTION_TOOLTIP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->toolTip() );
}

void Q7B_QACTION_TRIGGER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return ; }

  Q7B_IDQAction(self)->trigger();
}

Q7B Q7B_QACTION_WHATSTHIS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTION(self))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAction(self)->whatsThis() );
}

Q7B Q7B_QACTIONGROUP_ACTIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return Q7B_idnil; }


  QList<QAction*> o = Q7B_IDQActionGroup(self)->actions();

  Q7B_List *l = new Q7B_List(); 
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), l)); 

  for (int i = 0; i < o.size(); i++){    
    Q7B qq (new Q7B_id(typeid(QAction).name(), o.at(i))); 
    l->append(qq);
  }

  return q;

  //return Q7B_ID( Q7B_IDQActionGroup(self)->actions() );
}

Q7B Q7B_QACTIONGROUP_ADDACTION(Q7B self, Q7B Icon, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQActionGroup(self)->addAction(Q7B_IDQIcon(Icon), Q7B_IDQString(Text)) );
}

Q7B Q7B_QACTIONGROUP_CHECKEDACTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQActionGroup(self)->checkedAction() );
}

Q7B Q7B_QACTIONGROUP_ENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQActionGroup(self)->isEnabled() );
}

void Q7B_QACTIONGROUP_ENABLED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQActionGroup(self)->setEnabled(Q7B_IDbool(theProperty));
}

Q7B Q7B_QACTIONGROUP_EXCLUSIVE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQActionGroup(self)->isExclusive() );
}

void Q7B_QACTIONGROUP_EXCLUSIVE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQActionGroup(self)->setExclusive(Q7B_IDbool(theProperty));
}

Q7B Q7B_QACTIONGROUP_ISENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQActionGroup(self)->isEnabled() );
}

Q7B Q7B_QACTIONGROUP_ISEXCLUSIVE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQActionGroup(self)->isExclusive() );
}

Q7B Q7B_QACTIONGROUP_ISVISIBLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQActionGroup(self)->isVisible() );
}

void Q7B_QACTIONGROUP_REMOVEACTION(Q7B self, Q7B Action) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return ; }

  if (Q7B_nil(Q7B_QACTION(Action))){ Q7B_EXCEPTION("QAction expected"); return ; }

  Q7B_IDQActionGroup(self)->removeAction(Q7B_IDQAction(Action));
}

void Q7B_QACTIONGROUP_SETDISABLED(Q7B self, Q7B B) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(B))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQActionGroup(self)->setDisabled(Q7B_IDbool(B));
}

void Q7B_QACTIONGROUP_SETENABLED(Q7B self, Q7B Enabled) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enabled))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQActionGroup(self)->setEnabled(Q7B_IDbool(Enabled));
}

void Q7B_QACTIONGROUP_SETEXCLUSIVE(Q7B self, Q7B E) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(E))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQActionGroup(self)->setExclusive(Q7B_IDbool(E));
}

void Q7B_QACTIONGROUP_SETVISIBLE(Q7B self, Q7B Visible) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Visible))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQActionGroup(self)->setVisible(Q7B_IDbool(Visible));
}

Q7B Q7B_QACTIONGROUP_VISIBLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQActionGroup(self)->isVisible() );
}

void Q7B_QACTIONGROUP_VISIBLE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACTIONGROUP(self))){ Q7B_EXCEPTION("QActionGroup expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQActionGroup(self)->setVisible(Q7B_IDbool(theProperty));
}

void Q7B_QAPPLICATION_ABOUTQT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  Q7B_IDQApplication(self)->aboutQt();
}


void Q7B_QAPPLICATION_CLOSEALLWINDOWS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  Q7B_IDQApplication(self)->closeAllWindows();
}

Q7B Q7B_QAPPLICATION_CURSORFLASHTIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->cursorFlashTime() );
}

void Q7B_QAPPLICATION_CURSORFLASHTIME(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQApplication(self)->setCursorFlashTime(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QAPPLICATION_DOUBLECLICKINTERVAL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->doubleClickInterval() );
}

void Q7B_QAPPLICATION_DOUBLECLICKINTERVAL(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQApplication(self)->setDoubleClickInterval(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QAPPLICATION_GLOBALSTRUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->globalStrut() );
}

void Q7B_QAPPLICATION_GLOBALSTRUT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(theProperty))){ Q7B_EXCEPTION("QSize expected"); return; }

  Q7B_IDQApplication(self)->setGlobalStrut(Q7B_IDQSize(theProperty));
}

Q7B Q7B_QAPPLICATION_INPUTCONTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->inputContext() );
}

Q7B Q7B_QAPPLICATION_ISSESSIONRESTORED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->isSessionRestored() );
}

Q7B Q7B_QAPPLICATION_KEYBOARDINPUTINTERVAL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->keyboardInputInterval() );
}

void Q7B_QAPPLICATION_KEYBOARDINPUTINTERVAL(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQApplication(self)->setKeyboardInputInterval(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QAPPLICATION_LAYOUTDIRECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->layoutDirection() );
}

void Q7B_QAPPLICATION_LAYOUTDIRECTION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQApplication(self)->setLayoutDirection((Qt::LayoutDirection) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QAPPLICATION_QUITONLASTWINDOWCLOSED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->quitOnLastWindowClosed() );
}

void Q7B_QAPPLICATION_QUITONLASTWINDOWCLOSED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQApplication(self)->setQuitOnLastWindowClosed(Q7B_IDbool(theProperty));
}

Q7B Q7B_QAPPLICATION_SESSIONID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->sessionId() );
}

Q7B Q7B_QAPPLICATION_SESSIONKEY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->sessionKey() );
}


void Q7B_QAPPLICATION_SETAUTOSIPENABLED(Q7B self, Q7B Enabled) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enabled))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQApplication(self)->setAutoSipEnabled(Q7B_IDbool(Enabled));
}

void Q7B_QAPPLICATION_SETSTYLESHEET(Q7B self, Q7B Sheet) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Sheet))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQApplication(self)->setStyleSheet(Q7B_IDQString(Sheet));
}

Q7B Q7B_QAPPLICATION_STARTDRAGDISTANCE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->startDragDistance() );
}

void Q7B_QAPPLICATION_STARTDRAGDISTANCE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQApplication(self)->setStartDragDistance(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QAPPLICATION_STARTDRAGTIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->startDragTime() );
}

void Q7B_QAPPLICATION_STARTDRAGTIME(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQApplication(self)->setStartDragTime(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QAPPLICATION_STYLESHEET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->styleSheet() );
}

Q7B Q7B_QAPPLICATION_WHEELSCROLLLINES(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->wheelScrollLines() );
}

void Q7B_QAPPLICATION_WHEELSCROLLLINES(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQApplication(self)->setWheelScrollLines(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QAPPLICATION_WINDOWICON(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQApplication(self)->windowIcon() );
}

void Q7B_QAPPLICATION_WINDOWICON(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QAPPLICATION(self))){ Q7B_EXCEPTION("QApplication expected"); return ; }

  if (Q7B_nil(Q7B_QICON(theProperty))){ Q7B_EXCEPTION("QIcon expected"); return; }

  Q7B_IDQApplication(self)->setWindowIcon(Q7B_IDQIcon(theProperty));
}

Q7B Q7B_QCOMPLETER_CASESENSITIVITY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->caseSensitivity() );
}

void Q7B_QCOMPLETER_COMPLETE(Q7B self, Q7B Rect) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rect))){ Q7B_EXCEPTION("QRect expected"); return ; }

  Q7B_IDQCompleter(self)->complete(Q7B_IDQRect(Rect));
}

Q7B Q7B_QCOMPLETER_COMPLETIONCOLUMN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->completionColumn() );
}

Q7B Q7B_QCOMPLETER_COMPLETIONCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->completionCount() );
}

Q7B Q7B_QCOMPLETER_COMPLETIONMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->completionMode() );
}

Q7B Q7B_QCOMPLETER_COMPLETIONPREFIX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->completionPrefix() );
}

Q7B Q7B_QCOMPLETER_COMPLETIONROLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->completionRole() );
}

Q7B Q7B_QCOMPLETER_CURRENTCOMPLETION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->currentCompletion() );
}

Q7B Q7B_QCOMPLETER_CURRENTINDEX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->currentIndex() );
}

Q7B Q7B_QCOMPLETER_CURRENTROW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->currentRow() );
}

Q7B Q7B_QCOMPLETER_MAXVISIBLEITEMS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->maxVisibleItems() );
}

Q7B Q7B_QCOMPLETER_MODELSORTING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->modelSorting() );
}

Q7B Q7B_QCOMPLETER_POPUP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->popup() );
}

void Q7B_QCOMPLETER_SETCASESENSITIVITY(Q7B self, Q7B CaseSensitivity) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(CaseSensitivity))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQCompleter(self)->setCaseSensitivity((Qt::CaseSensitivity) Q7B_IDqint64(CaseSensitivity));
}

void Q7B_QCOMPLETER_SETCOMPLETIONCOLUMN(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQCompleter(self)->setCompletionColumn(Q7B_IDqint64(Column));
}

void Q7B_QCOMPLETER_SETCOMPLETIONMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQCompleter(self)->setCompletionMode((QCompleter::CompletionMode) Q7B_IDqint64(Mode));
}

void Q7B_QCOMPLETER_SETCOMPLETIONPREFIX(Q7B self, Q7B Prefix) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Prefix))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQCompleter(self)->setCompletionPrefix(Q7B_IDQString(Prefix));
}

void Q7B_QCOMPLETER_SETCOMPLETIONROLE(Q7B self, Q7B Role) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Role))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQCompleter(self)->setCompletionRole(Q7B_IDqint64(Role));
}

Q7B Q7B_QCOMPLETER_SETCURRENTROW(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->setCurrentRow(Q7B_IDqint64(Row)) );
}

void Q7B_QCOMPLETER_SETMAXVISIBLEITEMS(Q7B self, Q7B MaxItems) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(MaxItems))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQCompleter(self)->setMaxVisibleItems(Q7B_IDqint64(MaxItems));
}


void Q7B_QCOMPLETER_SETMODEL(Q7B self, Q7B Model) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return ; }

  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(Model))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return ; }

  Q7B_IDQCompleter(self)->setModel(Q7B_IDQAbstractItemModel(Model));
}

void Q7B_QCOMPLETER_SETMODELSORTING(Q7B self, Q7B Sorting) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Sorting))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQCompleter(self)->setModelSorting((QCompleter::ModelSorting) Q7B_IDqint64(Sorting));
}

void Q7B_QCOMPLETER_SETPOPUP(Q7B self, Q7B Popup) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return ; }

  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(Popup))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  Q7B_IDQCompleter(self)->setPopup(Q7B_IDQAbstractItemView(Popup));
}

void Q7B_QCOMPLETER_SETWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQCompleter(self)->setWidget(Q7B_IDQWidget(Widget));
}

void Q7B_QCOMPLETER_SETWRAPAROUND(Q7B self, Q7B Wrap) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Wrap))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQCompleter(self)->setWrapAround(Q7B_IDbool(Wrap));
}

Q7B Q7B_QCOMPLETER_WIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->widget() );
}

Q7B Q7B_QCOMPLETER_WRAPAROUND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOMPLETER(self))){ Q7B_EXCEPTION("QCompleter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCompleter(self)->wrapAround() );
}

Q7B Q7B_QCOREAPPLICATION_APPLICATIONNAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOREAPPLICATION(self))){ Q7B_EXCEPTION("QCoreApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCoreApplication(self)->applicationName() );
}

void Q7B_QCOREAPPLICATION_APPLICATIONNAME(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOREAPPLICATION(self))){ Q7B_EXCEPTION("QCoreApplication expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQCoreApplication(self)->setApplicationName(Q7B_IDQString(theProperty));
}

Q7B Q7B_QCOREAPPLICATION_APPLICATIONVERSION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOREAPPLICATION(self))){ Q7B_EXCEPTION("QCoreApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCoreApplication(self)->applicationVersion() );
}

void Q7B_QCOREAPPLICATION_APPLICATIONVERSION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOREAPPLICATION(self))){ Q7B_EXCEPTION("QCoreApplication expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQCoreApplication(self)->setApplicationVersion(Q7B_IDQString(theProperty));
}

Q7B Q7B_QCOREAPPLICATION_ORGANIZATIONDOMAIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOREAPPLICATION(self))){ Q7B_EXCEPTION("QCoreApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCoreApplication(self)->organizationDomain() );
}

void Q7B_QCOREAPPLICATION_ORGANIZATIONDOMAIN(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOREAPPLICATION(self))){ Q7B_EXCEPTION("QCoreApplication expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQCoreApplication(self)->setOrganizationDomain(Q7B_IDQString(theProperty));
}

Q7B Q7B_QCOREAPPLICATION_ORGANIZATIONNAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOREAPPLICATION(self))){ Q7B_EXCEPTION("QCoreApplication expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCoreApplication(self)->organizationName() );
}

void Q7B_QCOREAPPLICATION_ORGANIZATIONNAME(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOREAPPLICATION(self))){ Q7B_EXCEPTION("QCoreApplication expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQCoreApplication(self)->setOrganizationName(Q7B_IDQString(theProperty));
}

void Q7B_QCOREAPPLICATION_QUIT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCOREAPPLICATION(self))){ Q7B_EXCEPTION("QCoreApplication expected"); return ; }

  Q7B_IDQCoreApplication(self)->quit();
}

Q7B Q7B_QCOREAPPLICATION_SETEVENTFILTER(Q7B self, Q7B Filter) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCOREAPPLICATION(self))){ Q7B_EXCEPTION("QCoreApplication expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Filter))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCoreApplication(self)->setEventFilter((QCoreApplication::EventFilter) Q7B_IDqint64(Filter)) );
}

Q7B Q7B_QCURSOR_BITMAP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCURSOR(self))){ Q7B_EXCEPTION("QCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCursor(self).bitmap() );
}

Q7B Q7B_QCURSOR_HOTSPOT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCURSOR(self))){ Q7B_EXCEPTION("QCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCursor(self).hotSpot() );
}

Q7B Q7B_QCURSOR_MASK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCURSOR(self))){ Q7B_EXCEPTION("QCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCursor(self).mask() );
}

Q7B Q7B_QCURSOR_PIXMAP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCURSOR(self))){ Q7B_EXCEPTION("QCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCursor(self).pixmap() );
}

void Q7B_QCURSOR_SETSHAPE(Q7B self, Q7B Shape) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCURSOR(self))){ Q7B_EXCEPTION("QCursor expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Shape))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQCursor(self).setShape((Qt::CursorShape) Q7B_IDqint64(Shape));
}

Q7B Q7B_QCURSOR_SHAPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCURSOR(self))){ Q7B_EXCEPTION("QCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQCursor(self).shape() );
}

Q7B Q7B_QMODELINDEX_CHILD(Q7B self, Q7B Row, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMODELINDEX(self))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQModelIndex(self).child(Q7B_IDqint64(Row), Q7B_IDqint64(Column)) );
}

Q7B Q7B_QMODELINDEX_DATA(Q7B self, Q7B Role) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMODELINDEX(self))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Role))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQModelIndex(self).data( Q7B_IDqint64(Role)) );
}

Q7B Q7B_QMODELINDEX_FLAGS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMODELINDEX(self))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQModelIndex(self).flags() );
}

Q7B Q7B_QMODELINDEX_INTERNALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMODELINDEX(self))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQModelIndex(self).internalId() );
}

Q7B Q7B_QMODELINDEX_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMODELINDEX(self))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQModelIndex(self).isValid() );
}

Q7B Q7B_QMODELINDEX_MODEL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMODELINDEX(self))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQModelIndex(self).model() );
}

Q7B Q7B_QMODELINDEX_PARENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMODELINDEX(self))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQModelIndex(self).parent() );
}

Q7B Q7B_QMODELINDEX_ROW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMODELINDEX(self))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQModelIndex(self).row() );
}

Q7B Q7B_QMODELINDEX_SIBLING(Q7B self, Q7B Row, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMODELINDEX(self))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQModelIndex(self).sibling(Q7B_IDqint64(Row), Q7B_IDqint64(Column)) );
}

Q7B Q7B_QPRINTPREVIEWWIDGET_CURRENTPAGE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrintPreviewWidget(self)->currentPage() );
}

void Q7B_QPRINTPREVIEWWIDGET_FITINVIEW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->fitInView();
}

void Q7B_QPRINTPREVIEWWIDGET_FITTOWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->fitToWidth();
}

Q7B Q7B_QPRINTPREVIEWWIDGET_ORIENTATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrintPreviewWidget(self)->orientation() );
}

Q7B Q7B_QPRINTPREVIEWWIDGET_PAGECOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrintPreviewWidget(self)->pageCount() );
}

void Q7B_QPRINTPREVIEWWIDGET_PRINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->print();
}

void Q7B_QPRINTPREVIEWWIDGET_SETALLPAGESVIEWMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->setAllPagesViewMode();
}

void Q7B_QPRINTPREVIEWWIDGET_SETCURRENTPAGE(Q7B self, Q7B Page) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Page))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->setCurrentPage(Q7B_IDqint64(Page));
}

void Q7B_QPRINTPREVIEWWIDGET_SETFACINGPAGESVIEWMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->setFacingPagesViewMode();
}

void Q7B_QPRINTPREVIEWWIDGET_SETLANDSCAPEORIENTATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->setLandscapeOrientation();
}

void Q7B_QPRINTPREVIEWWIDGET_SETORIENTATION(Q7B self, Q7B Orientation) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Orientation))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->setOrientation((QPrinter::Orientation) Q7B_IDqint64(Orientation));
}

void Q7B_QPRINTPREVIEWWIDGET_SETPORTRAITORIENTATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->setPortraitOrientation();
}

void Q7B_QPRINTPREVIEWWIDGET_SETSINGLEPAGEVIEWMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->setSinglePageViewMode();
}

void Q7B_QPRINTPREVIEWWIDGET_SETVIEWMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->setViewMode((QPrintPreviewWidget::ViewMode) Q7B_IDqint64(Mode));
}

void Q7B_QPRINTPREVIEWWIDGET_SETZOOMFACTOR(Q7B self, Q7B Factor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Factor))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->setZoomFactor(Q7B_IDqreal(Factor));
}

void Q7B_QPRINTPREVIEWWIDGET_SETZOOMMODE(Q7B self, Q7B ZoomMode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(ZoomMode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->setZoomMode((QPrintPreviewWidget::ZoomMode) Q7B_IDqint64(ZoomMode));
}

void Q7B_QPRINTPREVIEWWIDGET_UPDATEPREVIEW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->updatePreview();
}

Q7B Q7B_QPRINTPREVIEWWIDGET_VIEWMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrintPreviewWidget(self)->viewMode() );
}

Q7B Q7B_QPRINTPREVIEWWIDGET_ZOOMFACTOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrintPreviewWidget(self)->zoomFactor() );
}

void Q7B_QPRINTPREVIEWWIDGET_ZOOMIN(Q7B self, Q7B Factor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Factor))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->zoomIn(Q7B_IDqreal(Factor));
}

Q7B Q7B_QPRINTPREVIEWWIDGET_ZOOMMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrintPreviewWidget(self)->zoomMode() );
}

void Q7B_QPRINTPREVIEWWIDGET_ZOOMOUT(Q7B self, Q7B Factor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWWIDGET(self))){ Q7B_EXCEPTION("QPrintPreviewWidget expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Factor))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQPrintPreviewWidget(self)->zoomOut(Q7B_IDqreal(Factor));
}

void Q7B_QURL_ADDENCODEDQUERYITEM(Q7B self, Q7B Key, Q7B Value) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Key))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Value))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQUrl(self).addEncodedQueryItem(Q7B_IDQByteArray(Key), Q7B_IDQByteArray(Value));
}

void Q7B_QURL_ADDQUERYITEM(Q7B self, Q7B Key, Q7B Value) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Key))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Value))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQUrl(self).addQueryItem(Q7B_IDQByteArray(Key), Q7B_IDQByteArray(Value));
}

Q7B Q7B_QURL_ALLQUERYITEMVALUES(Q7B self, Q7B Key) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Key))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).allQueryItemValues(Q7B_IDQByteArray(Key)) );
}

Q7B Q7B_QURL_AUTHORITY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).authority() );
}

void Q7B_QURL_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  Q7B_IDQUrl(self).clear();
}

Q7B Q7B_QURL_ENCODEDFRAGMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).encodedFragment() );
}

Q7B Q7B_QURL_ENCODEDHOST(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).encodedHost() );
}

Q7B Q7B_QURL_ENCODEDPASSWORD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).encodedPassword() );
}

Q7B Q7B_QURL_ENCODEDPATH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).encodedPath() );
}

Q7B Q7B_QURL_ENCODEDQUERY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).encodedQuery() );
}

Q7B Q7B_QURL_ENCODEDQUERYITEMVALUE(Q7B self, Q7B Key) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Key))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).encodedQueryItemValue(Q7B_IDQByteArray(Key)) );
}

Q7B Q7B_QURL_ENCODEDUSERNAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).encodedUserName() );
}

Q7B Q7B_QURL_ERRORSTRING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).errorString() );
}

Q7B Q7B_QURL_FRAGMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).fragment() );
}

Q7B Q7B_QURL_HASENCODEDQUERYITEM(Q7B self, Q7B Key) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Key))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).hasEncodedQueryItem(Q7B_IDQByteArray(Key)) );
}

Q7B Q7B_QURL_HASFRAGMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).hasFragment() );
}

Q7B Q7B_QURL_HASQUERY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).hasQuery() );
}

Q7B Q7B_QURL_HASQUERYITEM(Q7B self, Q7B Key) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Key))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).hasQueryItem(Q7B_IDQString(Key)) );
}

Q7B Q7B_QURL_HOST(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).host() );
}

Q7B Q7B_QURL_ISEMPTY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).isEmpty() );
}
/*
Q7B Q7B_QURL_ISLOCALFILE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).isLocalFile() );
}*/

Q7B Q7B_QURL_ISPARENTOF(Q7B self, Q7B ChildUrl) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QURL(ChildUrl))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).isParentOf(Q7B_IDQUrl(ChildUrl)) );
}

Q7B Q7B_QURL_ISRELATIVE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).isRelative() );
}

Q7B Q7B_QURL_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).isValid() );
}

Q7B Q7B_QURL_PASSWORD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).password() );
}

Q7B Q7B_QURL_PATH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).path() );
}

Q7B Q7B_QURL_PORT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).port() );
}

Q7B Q7B_QURL_QUERYITEMVALUE(Q7B self, Q7B Key) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Key))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).queryItemValue(Q7B_IDQString(Key)) );
}

Q7B Q7B_QURL_QUERYPAIRDELIMITER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).queryPairDelimiter() );
}

Q7B Q7B_QURL_QUERYVALUEDELIMITER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).queryValueDelimiter() );
}

void Q7B_QURL_REMOVEALLENCODEDQUERYITEMS(Q7B self, Q7B Key) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Key))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQUrl(self).removeAllEncodedQueryItems(Q7B_IDQByteArray(Key));
}

void Q7B_QURL_REMOVEALLQUERYITEMS(Q7B self, Q7B Key) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Key))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrl(self).removeAllQueryItems(Q7B_IDQString(Key));
}

void Q7B_QURL_REMOVEENCODEDQUERYITEM (Q7B self, Q7B Key) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Key))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQUrl(self).removeEncodedQueryItem (Q7B_IDQByteArray(Key));
}

void Q7B_QURL_REMOVEQUERYITEM(Q7B self, Q7B Key) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Key))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrl(self).removeQueryItem(Q7B_IDQString(Key));
}

Q7B Q7B_QURL_RESOLVED(Q7B self, Q7B Relative) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QURL(Relative))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).resolved(Q7B_IDQUrl(Relative)) );
}

Q7B Q7B_QURL_SCHEME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).scheme() );
}

void Q7B_QURL_SETAUTHORITY(Q7B self, Q7B Authority) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Authority))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrl(self).setAuthority(Q7B_IDQString(Authority));
}

void Q7B_QURL_SETENCODEDHOST(Q7B self, Q7B Host) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Host))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQUrl(self).setEncodedHost(Q7B_IDQByteArray(Host));
}

void Q7B_QURL_SETENCODEDPASSWORD(Q7B self, Q7B Password) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Password))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQUrl(self).setEncodedPassword(Q7B_IDQByteArray(Password));
}

void Q7B_QURL_SETENCODEDPATH(Q7B self, Q7B Path) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Path))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQUrl(self).setEncodedPath(Q7B_IDQByteArray(Path));
}

void Q7B_QURL_SETENCODEDQUERY(Q7B self, Q7B Query) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Query))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQUrl(self).setEncodedQuery(Q7B_IDQByteArray(Query));
}

void Q7B_QURL_SETENCODEDUSERNAME(Q7B self, Q7B UserName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(UserName))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQUrl(self).setEncodedUserName(Q7B_IDQByteArray(UserName));
}

void Q7B_QURL_SETHOST(Q7B self, Q7B Host) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrl(self).setHost(Q7B_IDQString(Host));
}

void Q7B_QURL_SETPASSWORD(Q7B self, Q7B Password) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrl(self).setPassword(Q7B_IDQString(Password));
}

void Q7B_QURL_SETPATH(Q7B self, Q7B Path) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrl(self).setPath(Q7B_IDQString(Path));
}

void Q7B_QURL_SETPORT(Q7B self, Q7B Port) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Port))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQUrl(self).setPort(Q7B_IDqint64(Port));
}

void Q7B_QURL_SETQUERYDELIMITERS(Q7B self, Q7B ValueDelimiter, Q7B PairDelimeter) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(ValueDelimiter))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(PairDelimeter))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrl(self).setQueryDelimiters(Q7B_IDQString(ValueDelimiter).at(0).toAscii(), Q7B_IDQString(PairDelimeter).at(0).toAscii());
}

void Q7B_QURL_SETSCHEME(Q7B self, Q7B Scheme) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Scheme))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrl(self).setScheme(Q7B_IDQString(Scheme));
}

void Q7B_QURL_SETURL(Q7B self, Q7B Url) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Url))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrl(self).setUrl(Q7B_IDQString(Url));
}

void Q7B_QURL_SETUSERINFO(Q7B self, Q7B UserInfo) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(UserInfo))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrl(self).setUserInfo(Q7B_IDQString(UserInfo));
}

void Q7B_QURL_SETUSERNAME(Q7B self, Q7B UserName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(UserName))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrl(self).setUserName(Q7B_IDQString(UserName));
}
/*
void Q7B_QURL_SWAP(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  if (Q7B_nil(Q7B_QURL(Other))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  Q7B_IDQUrl(self).swap(Q7B_IDQUrl(Other));
}*/

Q7B Q7B_QURL_TOENCODED(Q7B self, Q7B Option) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Option))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).toEncoded((QUrl::FormattingOptions) Q7B_IDqint64(Option)) );
}

Q7B Q7B_QURL_FROMLOCALFILE(Q7B self, Q7B localFile) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(localFile))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).fromLocalFile(Q7B_IDQString(localFile)) );
}

Q7B Q7B_QURL_TOLOCALFILE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).toLocalFile() );
}

Q7B Q7B_QURL_TOSTRING(Q7B self, Q7B Option) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Option))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).toString((QUrl::FormattingOptions) Q7B_IDqint64(Option)) );
}
/*
Q7B Q7B_QURL_TOPLEVELDOMAIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).topLevelDomain() );
}*/

Q7B Q7B_QURL_USERINFO(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).userInfo() );
}

Q7B Q7B_QURL_USERNAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURL(self))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrl(self).userName() );
}

Q7B Q7B_QURLINFO_GROUP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).group() );
}

Q7B Q7B_QURLINFO_ISDIR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).isDir() );
}

Q7B Q7B_QURLINFO_ISEXECUTABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).isExecutable() );
}

Q7B Q7B_QURLINFO_ISFILE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).isFile() );
}

Q7B Q7B_QURLINFO_ISREADABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).isReadable() );
}

Q7B Q7B_QURLINFO_ISSYMLINK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).isSymLink() );
}

Q7B Q7B_QURLINFO_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).isValid() );
}

Q7B Q7B_QURLINFO_ISWRITABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).isWritable() );
}

Q7B Q7B_QURLINFO_LASTMODIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).lastModified() );
}

Q7B Q7B_QURLINFO_LASTREAD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).lastRead() );
}

Q7B Q7B_QURLINFO_NAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).name() );
}

Q7B Q7B_QURLINFO_OWNER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).owner() );
}

Q7B Q7B_QURLINFO_PERMISSIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).permissions() );
}

void Q7B_QURLINFO_SETDIR(Q7B self, Q7B B) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(B))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQUrlInfo(self).setDir(Q7B_IDbool(B));
}

void Q7B_QURLINFO_SETFILE(Q7B self, Q7B B) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(B))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQUrlInfo(self).setFile(Q7B_IDbool(B));
}

void Q7B_QURLINFO_SETGROUP(Q7B self, Q7B S) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(S))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrlInfo(self).setGroup(Q7B_IDQString(S));
}

void Q7B_QURLINFO_SETLASTMODIFIED(Q7B self, Q7B Dt) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return ; }

  if (Q7B_nil(Q7B_QDATETIME(Dt))){ Q7B_EXCEPTION("QDateTime expected"); return ; }

  Q7B_IDQUrlInfo(self).setLastModified(Q7B_IDQDateTime(Dt));
}

void Q7B_QURLINFO_SETLASTREAD(Q7B self, Q7B Dt) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return ; }

  if (Q7B_nil(Q7B_QDATETIME(Dt))){ Q7B_EXCEPTION("QDateTime expected"); return ; }

  Q7B_IDQUrlInfo(self).setLastRead(Q7B_IDQDateTime(Dt));
}

void Q7B_QURLINFO_SETNAME(Q7B self, Q7B Name) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrlInfo(self).setName(Q7B_IDQString(Name));
}

void Q7B_QURLINFO_SETOWNER(Q7B self, Q7B S) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(S))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQUrlInfo(self).setOwner(Q7B_IDQString(S));
}

void Q7B_QURLINFO_SETPERMISSIONS(Q7B self, Q7B P) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(P))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQUrlInfo(self).setPermissions(Q7B_IDqint64(P));
}

void Q7B_QURLINFO_SETREADABLE(Q7B self, Q7B B) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(B))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQUrlInfo(self).setReadable(Q7B_IDbool(B));
}

void Q7B_QURLINFO_SETSIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Size))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQUrlInfo(self).setSize(Q7B_IDqint64(Size));
}

void Q7B_QURLINFO_SETSYMLINK(Q7B self, Q7B B) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(B))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQUrlInfo(self).setSymLink(Q7B_IDbool(B));
}

void Q7B_QURLINFO_SETWRITABLE(Q7B self, Q7B B) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(B))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQUrlInfo(self).setWritable(Q7B_IDbool(B));
}

Q7B Q7B_QURLINFO_SIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QURLINFO(self))){ Q7B_EXCEPTION("QUrlInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQUrlInfo(self).size() );
}

Q7B Q7B_QVARIANT_CANCONVERT(Q7B self, Q7B T) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(T))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).canConvert((QVariant::Type) Q7B_IDqint64(T)) );
}

void Q7B_QVARIANT_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return ; }

  Q7B_IDQVariant(self).clear();
}

Q7B Q7B_QVARIANT_CONVERT(Q7B self, Q7B T) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(T))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).convert((QVariant::Type) Q7B_IDqint64(T)) );
}

Q7B Q7B_QVARIANT_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).isNull() );
}

Q7B Q7B_QVARIANT_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).isValid() );
}
/*
void Q7B_QVARIANT_SWAP(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return ; }

  if (Q7B_nil(Q7B_QVARIANT(Other))){ Q7B_EXCEPTION("QVariant expected"); return ; }

  Q7B_IDQVariant(self).swap(Q7B_IDQVariant(Other));
}*/

Q7B Q7B_QVARIANT_TOBITARRAY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toBitArray() );
}

Q7B Q7B_QVARIANT_TOBOOL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toBool() );
}

Q7B Q7B_QVARIANT_TOBYTEARRAY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toByteArray() );
}

Q7B Q7B_QVARIANT_TOCHAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toChar() );
}

Q7B Q7B_QVARIANT_TODATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toDate() );
}

Q7B Q7B_QVARIANT_TODATETIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toDateTime() );
}

Q7B Q7B_QVARIANT_TODOUBLE(Q7B self, Q7B Ok) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Ok))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }


  bool *b = new bool(); *b = false; 
  bool re = Q7B_ID( Q7B_IDQVariant(self).toDouble(b) );
  Ok->ref = b;

  /*
  bool b = false;
  bool re = Q7B_IDQVariant(self).toDouble(&b);
  
  *((bool *) Ok->ref) = b;
*/
  return Q7B_ID( re );
}

Q7B Q7B_QVARIANT_TOINT(Q7B self, Q7B Ok) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Ok))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }


  bool *b = new bool(); *b = false; 
  bool re = Q7B_ID( Q7B_IDQVariant(self).toInt(b) );
  Ok->ref = b;
  /*
  bool b = false;
  bool re = Q7B_IDQVariant(self).toInt(&b);
  
  *((bool *) Ok->ref) = b;
*/
  return Q7B_ID( re );
}

Q7B Q7B_QVARIANT_TOLINE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toLine() );
}

Q7B Q7B_QVARIANT_TOLINEF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toLineF() );
}

Q7B Q7B_QVARIANT_TOLIST(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toList() );
}

Q7B Q7B_QVARIANT_TOLOCALE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toLocale() );
}

Q7B Q7B_QVARIANT_TOPOINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toPoint() );
}

Q7B Q7B_QVARIANT_TOPOINTF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toPointF() );
}

Q7B Q7B_QVARIANT_TORECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toRect() );
}

Q7B Q7B_QVARIANT_TORECTF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toRectF() );
}

Q7B Q7B_QVARIANT_TOREGEXP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toRegExp() );
}

Q7B Q7B_QVARIANT_TOSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toSize() );
}

Q7B Q7B_QVARIANT_TOSIZEF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toSizeF() );
}

Q7B Q7B_QVARIANT_TOSTRING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toString() );
}

Q7B Q7B_QVARIANT_TOSTRINGLIST(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toStringList() );
}

Q7B Q7B_QVARIANT_TOTIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toTime() );
}

Q7B Q7B_QVARIANT_TOURL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).toUrl() );
}

Q7B Q7B_QVARIANT_TYPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQVariant(self).type() );
}




Q7B Q7B_QINTVALIDATOR_BOTTOM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINTVALIDATOR(self))){ Q7B_EXCEPTION("QIntValidator expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQIntValidator(self)->bottom() );
}

void Q7B_QINTVALIDATOR_SETBOTTOM(Q7B self, Q7B v) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINTVALIDATOR(self))){ Q7B_EXCEPTION("QIntValidator expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(v))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQIntValidator(self)->setBottom(Q7B_IDqint64(v));
}

void Q7B_QINTVALIDATOR_SETRANGE(Q7B self, Q7B bottom, Q7B top) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINTVALIDATOR(self))){ Q7B_EXCEPTION("QIntValidator expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(bottom))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(top))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQIntValidator(self)->setRange(Q7B_IDqint64(bottom), Q7B_IDqint64(top));
}

void Q7B_QINTVALIDATOR_SETTOP(Q7B self, Q7B v) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINTVALIDATOR(self))){ Q7B_EXCEPTION("QIntValidator expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(v))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQIntValidator(self)->setTop(Q7B_IDqint64(v));
}

Q7B Q7B_QINTVALIDATOR_TOP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINTVALIDATOR(self))){ Q7B_EXCEPTION("QIntValidator expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQIntValidator(self)->top() );
}

Q7B Q7B_QPRINTDIALOG_OPTIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTDIALOG(self))){ Q7B_EXCEPTION("QPrintDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrintDialog(self)->options() );
}

Q7B Q7B_QPRINTDIALOG_PRINTER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTDIALOG(self))){ Q7B_EXCEPTION("QPrintDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrintDialog(self)->printer() );
}

void Q7B_QPRINTDIALOG_SETOPTION(Q7B self, Q7B option, Q7B on) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPRINTDIALOG(self))){ Q7B_EXCEPTION("QPrintDialog expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(option))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(on))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQPrintDialog(self)->setOption((QAbstractPrintDialog::PrintDialogOption) Q7B_IDqint64(option), Q7B_IDbool(on));
}

Q7B Q7B_QPRINTDIALOG_TESTOPTION(Q7B self, Q7B option) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTDIALOG(self))){ Q7B_EXCEPTION("QPrintDialog expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(option))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrintDialog(self)->testOption((QAbstractPrintDialog::PrintDialogOption) Q7B_IDqint64(option)) );
}

Q7B Q7B_QSTRINGLIST_TOLIST(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRINGLIST(self))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(Q7B_IDQStringList(self)))); 
  return q;
}

Q7B Q7B_QSTRINGLIST_AT(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRINGLIST(self))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStringList(self).at(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QSTRINGLIST_LENGTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRINGLIST(self))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStringList(self).length() );
}

Q7B Q7B_QVARIANT_FROMBOOLEAN(Q7B self, Q7B v) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(v))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( QVariant(Q7B_IDbool(v)) );
}

Q7B Q7B_QVARIANT_FROMDATETIME(Q7B self, Q7B v) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(v))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_ID( QVariant(Q7B_IDQDateTime(v)) );
}

Q7B Q7B_QVARIANT_FROMFLOAT(Q7B self, Q7B v) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREAL(v))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }

  return Q7B_ID( QVariant(Q7B_IDqreal(v)) );
}

Q7B Q7B_QVARIANT_FROMINTEGER(Q7B self, Q7B v) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(v))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( QVariant(Q7B_IDqint64(v)) );
}

Q7B Q7B_QVARIANT_FROMQSTRINGLIST(Q7B self, Q7B v) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRINGLIST(v))){ Q7B_EXCEPTION("QStringList expected"); return Q7B_idnil; }

  return Q7B_ID( QVariant(Q7B_IDQStringList(v)) );
}

Q7B Q7B_QVARIANT_FROMSTRING(Q7B self, Q7B v) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QVARIANT(self))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( QVariant(Q7B_IDQString(v)) );
}
Q7B Q7B_QABSTRACTITEMMODEL_BUDDY(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->buddy(Q7B_IDQModelIndex(Index)) );
}

Q7B Q7B_QABSTRACTITEMMODEL_CANFETCHMORE(Q7B self, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->canFetchMore(Q7B_IDQModelIndex(Parent)) );
}

Q7B Q7B_QABSTRACTITEMMODEL_COLUMNCOUNT(Q7B self, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->columnCount(Q7B_IDQModelIndex(Parent)) );
}

Q7B Q7B_QABSTRACTITEMMODEL_DATA(Q7B self, Q7B Index, Q7B Role) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Role))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->data(Q7B_IDQModelIndex(Index), Q7B_IDqint64(Role)) );
}




void Q7B_QABSTRACTITEMMODEL_FETCHMORE(Q7B self, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  Q7B_IDQAbstractItemModel(self)->fetchMore(Q7B_IDQModelIndex(Parent));
}

Q7B Q7B_QABSTRACTITEMMODEL_FLAGS(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->flags(Q7B_IDQModelIndex(Index)) );
}

Q7B Q7B_QABSTRACTITEMMODEL_HASCHILDREN(Q7B self, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->hasChildren(Q7B_IDQModelIndex(Parent)) );
}

Q7B Q7B_QABSTRACTITEMMODEL_HASINDEX(Q7B self, Q7B Row, Q7B Column, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->hasIndex(Q7B_IDqint64(Row), Q7B_IDqint64(Column), Q7B_IDQModelIndex(Parent)) );
}

Q7B Q7B_QABSTRACTITEMMODEL_HEADERDATA(Q7B self, Q7B Section, Q7B Orientation, Q7B Role) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Section))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Orientation))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Role))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->headerData(Q7B_IDqint64(Section), (Qt::Orientation) Q7B_IDqint64(Orientation), Q7B_IDqint64(Role)) );
}

Q7B Q7B_QABSTRACTITEMMODEL_INDEX(Q7B self, Q7B Row, Q7B Column, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->index(Q7B_IDqint64(Row), Q7B_IDqint64(Column), Q7B_IDQModelIndex(Parent)) );
}

Q7B Q7B_QABSTRACTITEMMODEL_INSERTCOLUMN(Q7B self, Q7B Column, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->insertColumn(Q7B_IDqint64(Column), Q7B_IDQModelIndex(Parent)) );
}

Q7B Q7B_QABSTRACTITEMMODEL_INSERTCOLUMNS(Q7B self, Q7B Column, Q7B Count, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Count))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->insertColumns(Q7B_IDqint64(Column), Q7B_IDqint64(Count), Q7B_IDQModelIndex(Parent)) );
}

Q7B Q7B_QABSTRACTITEMMODEL_REMOVEROW(Q7B self, Q7B Row, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->removeRow(Q7B_IDqint64(Row), Q7B_IDQModelIndex(Parent)) );
}

Q7B Q7B_QABSTRACTITEMMODEL_REMOVEROWS(Q7B self, Q7B Row, Q7B Count, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Count))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->removeRows(Q7B_IDqint64(Row), Q7B_IDqint64(Count), Q7B_IDQModelIndex(Parent)) );
}

void Q7B_QABSTRACTITEMMODEL_REVERT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return ; }

  Q7B_IDQAbstractItemModel(self)->revert();
}

Q7B Q7B_QABSTRACTITEMMODEL_ROWCOUNT(Q7B self, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->rowCount(Q7B_IDQModelIndex(Parent)) );
}

void Q7B_QABSTRACTITEMMODEL_SETSUPPORTEDDRAGACTIONS(Q7B self, Q7B Actions) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Actions))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractItemModel(self)->setSupportedDragActions((Qt::DropActions) Q7B_IDqint64(Actions));
}

Q7B Q7B_QABSTRACTITEMMODEL_SIBLING(Q7B self, Q7B Row, Q7B Column, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->sibling(Q7B_IDqint64(Row), Q7B_IDqint64(Column), Q7B_IDQModelIndex(Index)) );
}

void Q7B_QABSTRACTITEMMODEL_SORT(Q7B self, Q7B Column, Q7B Order) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Order))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractItemModel(self)->sort(Q7B_IDqint64(Column), (Qt::SortOrder) Q7B_IDqint64(Order));
}

Q7B Q7B_QABSTRACTITEMMODEL_SPAN(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->span(Q7B_IDQModelIndex(Index)) );
}

void Q7B_QABSTRACTITEMMODEL_SUBMIT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return ; }

  Q7B_IDQAbstractItemModel(self)->submit();
}

Q7B Q7B_QABSTRACTITEMMODEL_SUPPORTEDDRAGACTIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->supportedDragActions() );
}

Q7B Q7B_QABSTRACTITEMMODEL_SUPPORTEDDROPACTIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(self))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemModel(self)->supportedDropActions() );
}

Q7B Q7B_QABSTRACTITEMVIEW_ALTERNATINGROWCOLORS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->alternatingRowColors() );
}

Q7B Q7B_QABSTRACTITEMVIEW_AUTOSCROLL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->hasAutoScroll() );
}

void Q7B_QABSTRACTITEMVIEW_AUTOSCROLL(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQAbstractItemView(self)->setAutoScroll(Q7B_IDbool(theProperty));
}

Q7B Q7B_QABSTRACTITEMVIEW_AUTOSCROLLMARGIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->autoScrollMargin() );
}

void Q7B_QABSTRACTITEMVIEW_CLEARSELECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  Q7B_IDQAbstractItemView(self)->clearSelection();
}

void Q7B_QABSTRACTITEMVIEW_CLOSEPERSISTENTEDITOR(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  Q7B_IDQAbstractItemView(self)->closePersistentEditor(Q7B_IDQModelIndex(Index));
}

Q7B Q7B_QABSTRACTITEMVIEW_CURRENTINDEX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->currentIndex() );
}

Q7B Q7B_QABSTRACTITEMVIEW_DEFAULTDROPACTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->defaultDropAction() );
}

Q7B Q7B_QABSTRACTITEMVIEW_DRAGDROPMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->dragDropMode() );
}

Q7B Q7B_QABSTRACTITEMVIEW_DRAGDROPOVERWRITEMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->dragDropOverwriteMode() );
}

Q7B Q7B_QABSTRACTITEMVIEW_DRAGENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->dragEnabled() );
}

void Q7B_QABSTRACTITEMVIEW_EDIT(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  Q7B_IDQAbstractItemView(self)->edit(Q7B_IDQModelIndex(Index));
}

Q7B Q7B_QABSTRACTITEMVIEW_EDITTRIGGERS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->editTriggers() );
}

Q7B Q7B_QABSTRACTITEMVIEW_HASAUTOSCROLL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->hasAutoScroll() );
}

Q7B Q7B_QABSTRACTITEMVIEW_HORIZONTALSCROLLMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->horizontalScrollMode() );
}

Q7B Q7B_QABSTRACTITEMVIEW_ICONSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->iconSize() );
}

Q7B Q7B_QABSTRACTITEMVIEW_INDEXAT (Q7B self, Q7B Point) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Point))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->indexAt (Q7B_IDQPoint(Point)) );
}

Q7B Q7B_QABSTRACTITEMVIEW_INDEXWIDGET (Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->indexWidget (Q7B_IDQModelIndex(Index)) );
}

void Q7B_QABSTRACTITEMVIEW_KEYBOARDSEARCH(Q7B self, Q7B Search) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQAbstractItemView(self)->keyboardSearch(Q7B_IDQString(Search));
}

Q7B Q7B_QABSTRACTITEMVIEW_MODEL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->model() );
}

void Q7B_QABSTRACTITEMVIEW_OPENPERSISTENTEDITOR(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  Q7B_IDQAbstractItemView(self)->openPersistentEditor(Q7B_IDQModelIndex(Index));
}

void Q7B_QABSTRACTITEMVIEW_RESET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  Q7B_IDQAbstractItemView(self)->reset();
}

Q7B Q7B_QABSTRACTITEMVIEW_ROOTINDEX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->rootIndex() );
}

void Q7B_QABSTRACTITEMVIEW_SCROLLTO(Q7B self, Q7B Index, Q7B Hint) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Hint))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractItemView(self)->scrollTo(Q7B_IDQModelIndex(Index), (QAbstractItemView::ScrollHint) Q7B_IDqint64(Hint));
}

void Q7B_QABSTRACTITEMVIEW_SCROLLTOBOTTOM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  Q7B_IDQAbstractItemView(self)->scrollToBottom();
}

void Q7B_QABSTRACTITEMVIEW_SCROLLTOTOP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  Q7B_IDQAbstractItemView(self)->scrollToTop();
}

void Q7B_QABSTRACTITEMVIEW_SELECTALL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  Q7B_IDQAbstractItemView(self)->selectAll();
}

Q7B Q7B_QABSTRACTITEMVIEW_SELECTIONBEHAVIOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->selectionBehavior() );
}

Q7B Q7B_QABSTRACTITEMVIEW_SELECTIONMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->selectionMode() );
}

Q7B Q7B_QABSTRACTITEMVIEW_SELECTIONMODEL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->selectionModel() );
}

void Q7B_QABSTRACTITEMVIEW_SETALTERNATINGROWCOLORS(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setAlternatingRowColors(Q7B_IDbool(Enable));
}

void Q7B_QABSTRACTITEMVIEW_SETAUTOSCROLL(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setAutoScroll(Q7B_IDbool(Enable));
}

void Q7B_QABSTRACTITEMVIEW_SETAUTOSCROLLMARGIN(Q7B self, Q7B Margin) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Margin))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setAutoScrollMargin(Q7B_IDqint64(Margin));
}

void Q7B_QABSTRACTITEMVIEW_SETCURRENTINDEX(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setCurrentIndex(Q7B_IDQModelIndex(Index));
}

void Q7B_QABSTRACTITEMVIEW_SETDEFAULTDROPACTION(Q7B self, Q7B DropAction) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(DropAction))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setDefaultDropAction((Qt::DropAction) Q7B_IDqint64(DropAction));
}

void Q7B_QABSTRACTITEMVIEW_SETDRAGDROPMODE(Q7B self, Q7B Behavior) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Behavior))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setDragDropMode((QAbstractItemView::DragDropMode) Q7B_IDqint64(Behavior));
}

void Q7B_QABSTRACTITEMVIEW_SETDRAGDROPOVERWRITEMODE(Q7B self, Q7B Overwrite) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Overwrite))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setDragDropOverwriteMode(Q7B_IDbool(Overwrite));
}

void Q7B_QABSTRACTITEMVIEW_SETDRAGENABLED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setDragEnabled(Q7B_IDbool(Enable));
}

void Q7B_QABSTRACTITEMVIEW_SETDROPINDICATORSHOWN(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setDropIndicatorShown(Q7B_IDbool(Enable));
}

void Q7B_QABSTRACTITEMVIEW_SETEDITTRIGGERS(Q7B self, Q7B Triggers) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Triggers))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setEditTriggers((QAbstractItemView::EditTriggers) Q7B_IDqint64(Triggers));
}

void Q7B_QABSTRACTITEMVIEW_SETHORIZONTALSCROLLMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setHorizontalScrollMode((QAbstractItemView::ScrollMode) Q7B_IDqint64(Mode));
}

void Q7B_QABSTRACTITEMVIEW_SETICONSIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setIconSize(Q7B_IDQSize(Size));
}

void Q7B_QABSTRACTITEMVIEW_SETINDEXWIDGET(Q7B self, Q7B Index, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setIndexWidget(Q7B_IDQModelIndex(Index), Q7B_IDQWidget(Widget));
}

void Q7B_QABSTRACTITEMVIEW_SETMODEL(Q7B self, Q7B Model) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QABSTRACTITEMMODEL(Model))){ Q7B_EXCEPTION("QAbstractItemModel expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setModel(Q7B_IDQAbstractItemModel(Model));
}

void Q7B_QABSTRACTITEMVIEW_SETROOTINDEX(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setRootIndex(Q7B_IDQModelIndex(Index));
}

void Q7B_QABSTRACTITEMVIEW_SETSELECTIONBEHAVIOR(Q7B self, Q7B Behavior) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Behavior))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setSelectionBehavior((QAbstractItemView::SelectionBehavior) Q7B_IDqint64(Behavior));
}

void Q7B_QABSTRACTITEMVIEW_SETSELECTIONMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setSelectionMode((QAbstractItemView::SelectionMode) Q7B_IDqint64(Mode));
}

void Q7B_QABSTRACTITEMVIEW_SETSELECTIONMODEL(Q7B self, Q7B SelectionModel) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QITEMSELECTIONMODEL(SelectionModel))){ Q7B_EXCEPTION("QItemSelectionModel expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setSelectionModel(Q7B_IDQItemSelectionModel(SelectionModel));
}

void Q7B_QABSTRACTITEMVIEW_SETTABKEYNAVIGATION(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setTabKeyNavigation(Q7B_IDbool(Enable));
}

void Q7B_QABSTRACTITEMVIEW_SETTEXTELIDEMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setTextElideMode(( Qt::TextElideMode) Q7B_IDqint64(Mode));
}

void Q7B_QABSTRACTITEMVIEW_SETVERTICALSCROLLMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractItemView(self)->setVerticalScrollMode((QAbstractItemView::ScrollMode) Q7B_IDqint64(Mode));
}

Q7B Q7B_QABSTRACTITEMVIEW_SHOWDROPINDICATOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->showDropIndicator() );
}

Q7B Q7B_QABSTRACTITEMVIEW_SIZEHINTFORCOLUMN(Q7B self, Q7B Column) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->sizeHintForColumn(Q7B_IDqint64(Column)) );
}

Q7B Q7B_QABSTRACTITEMVIEW_SIZEHINTFORINDEX(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->sizeHintForIndex(Q7B_IDQModelIndex(Index)) );
}

Q7B Q7B_QABSTRACTITEMVIEW_SIZEHINTFORROW(Q7B self, Q7B Row) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->sizeHintForRow(Q7B_IDqint64(Row)) );
}

Q7B Q7B_QABSTRACTITEMVIEW_TABKEYNAVIGATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->tabKeyNavigation() );
}

Q7B Q7B_QABSTRACTITEMVIEW_TEXTELIDEMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->textElideMode() );
}

void Q7B_QABSTRACTITEMVIEW_UPDATE(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  Q7B_IDQAbstractItemView(self)->update(Q7B_IDQModelIndex(Index));
}

Q7B Q7B_QABSTRACTITEMVIEW_VERTICALSCROLLMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->verticalScrollMode() );
}

Q7B Q7B_QABSTRACTITEMVIEW_VISUALRECT(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTITEMVIEW(self))){ Q7B_EXCEPTION("QAbstractItemView expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractItemView(self)->visualRect(Q7B_IDQModelIndex(Index)) );
}

Q7B Q7B_QABSTRACTSCROLLAREA_CORNERWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSCROLLAREA(self))){ Q7B_EXCEPTION("QAbstractScrollArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractScrollArea(self)->cornerWidget() );
}

Q7B Q7B_QABSTRACTSCROLLAREA_HORIZONTALSCROLLBAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSCROLLAREA(self))){ Q7B_EXCEPTION("QAbstractScrollArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractScrollArea(self)->horizontalScrollBar() );
}

Q7B Q7B_QABSTRACTSCROLLAREA_HORIZONTALSCROLLBARPOLICY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSCROLLAREA(self))){ Q7B_EXCEPTION("QAbstractScrollArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractScrollArea(self)->horizontalScrollBarPolicy() );
}

Q7B Q7B_QABSTRACTSCROLLAREA_MAXIMUMVIEWPORTSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSCROLLAREA(self))){ Q7B_EXCEPTION("QAbstractScrollArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractScrollArea(self)->maximumViewportSize() );
}

void Q7B_QABSTRACTSCROLLAREA_SETCORNERWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSCROLLAREA(self))){ Q7B_EXCEPTION("QAbstractScrollArea expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQAbstractScrollArea(self)->setCornerWidget(Q7B_IDQWidget(Widget));
}

void Q7B_QABSTRACTSCROLLAREA_SETHORIZONTALSCROLLBAR(Q7B self, Q7B ScrollBar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSCROLLAREA(self))){ Q7B_EXCEPTION("QAbstractScrollArea expected"); return ; }

  if (Q7B_nil(Q7B_QSCROLLBAR(ScrollBar))){ Q7B_EXCEPTION("QScrollBar expected"); return ; }

  Q7B_IDQAbstractScrollArea(self)->setHorizontalScrollBar(Q7B_IDQScrollBar(ScrollBar));
}

void Q7B_QABSTRACTSCROLLAREA_SETHORIZONTALSCROLLBARPOLICY(Q7B self, Q7B Policy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSCROLLAREA(self))){ Q7B_EXCEPTION("QAbstractScrollArea expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Policy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractScrollArea(self)->setHorizontalScrollBarPolicy((Qt::ScrollBarPolicy) Q7B_IDqint64(Policy));
}

void Q7B_QABSTRACTSCROLLAREA_SETVERTICALSCROLLBAR(Q7B self, Q7B ScrollBar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSCROLLAREA(self))){ Q7B_EXCEPTION("QAbstractScrollArea expected"); return ; }

  if (Q7B_nil(Q7B_QSCROLLBAR(ScrollBar))){ Q7B_EXCEPTION("QScrollBar expected"); return ; }

  Q7B_IDQAbstractScrollArea(self)->setVerticalScrollBar(Q7B_IDQScrollBar(ScrollBar));
}

void Q7B_QABSTRACTSCROLLAREA_SETVERTICALSCROLLBARPOLICY(Q7B self, Q7B Policy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSCROLLAREA(self))){ Q7B_EXCEPTION("QAbstractScrollArea expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Policy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQAbstractScrollArea(self)->setVerticalScrollBarPolicy((Qt::ScrollBarPolicy) Q7B_IDqint64(Policy));
}

void Q7B_QABSTRACTSCROLLAREA_SETVIEWPORT(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QABSTRACTSCROLLAREA(self))){ Q7B_EXCEPTION("QAbstractScrollArea expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQAbstractScrollArea(self)->setViewport(Q7B_IDQWidget(Widget));
}

Q7B Q7B_QABSTRACTSCROLLAREA_VERTICALSCROLLBAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSCROLLAREA(self))){ Q7B_EXCEPTION("QAbstractScrollArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractScrollArea(self)->verticalScrollBar() );
}

Q7B Q7B_QABSTRACTSCROLLAREA_VERTICALSCROLLBARPOLICY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSCROLLAREA(self))){ Q7B_EXCEPTION("QAbstractScrollArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractScrollArea(self)->verticalScrollBarPolicy() );
}

Q7B Q7B_QABSTRACTSCROLLAREA_VIEWPORT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QABSTRACTSCROLLAREA(self))){ Q7B_EXCEPTION("QAbstractScrollArea expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAbstractScrollArea(self)->viewport() );
}

void Q7B_QBITMAP_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBITMAP(self))){ Q7B_EXCEPTION("QBitmap expected"); return ; }

  Q7B_IDQBitmap(self).clear();
}
/*
void Q7B_QBITMAP_SWAP(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBITMAP(self))){ Q7B_EXCEPTION("QBitmap expected"); return ; }

  if (Q7B_nil(Q7B_QBITMAP(Other))){ Q7B_EXCEPTION("QBitmap expected"); return ; }

  Q7B_IDQBitmap(self).swap(Q7B_IDQBitmap(Other));
}*/

Q7B Q7B_QBITMAP_TRANSFORMED(Q7B self, Q7B Matrix) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBITMAP(self))){ Q7B_EXCEPTION("QBitmap expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTRANSFORM(Matrix))){ Q7B_EXCEPTION("QTransform expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQBitmap(self).transformed(Q7B_IDQTransform(Matrix)) );
}

Q7B Q7B_QBRUSH_COLOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQBrush(self).color() );
}

Q7B Q7B_QBRUSH_GRADIENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQBrush(self).gradient() );
}

Q7B Q7B_QBRUSH_ISOPAQUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQBrush(self).isOpaque() );
}

Q7B Q7B_QBRUSH_MATRIX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQBrush(self).matrix() );
}

void Q7B_QBRUSH_SETCOLOR(Q7B self, Q7B Color) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  if (Q7B_nil(Q7B_QCOLOR(Color))){ Q7B_EXCEPTION("QColor expected"); return ; }

  Q7B_IDQBrush(self).setColor(Q7B_IDQColor(Color));
}

void Q7B_QBRUSH_SETCOLOR2(Q7B self, Q7B Color) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Color))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQBrush(self).setColor((Qt::GlobalColor) Q7B_IDqint64(Color));
}

void Q7B_QBRUSH_SETMATRIX(Q7B self, Q7B Matrix) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  if (Q7B_nil(Q7B_QMATRIX(Matrix))){ Q7B_EXCEPTION("QMatrix expected"); return ; }

  Q7B_IDQBrush(self).setMatrix(Q7B_IDQMatrix(Matrix));
}

void Q7B_QBRUSH_SETSTYLE(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQBrush(self).setStyle((Qt::BrushStyle) Q7B_IDqint64(Style));
}

void Q7B_QBRUSH_SETTEXTURE(Q7B self, Q7B Pixmap) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  if (Q7B_nil(Q7B_QPIXMAP(Pixmap))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  Q7B_IDQBrush(self).setTexture(Q7B_IDQPixmap(Pixmap));
}

void Q7B_QBRUSH_SETTEXTUREIMAGE(Q7B self, Q7B Image) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  if (Q7B_nil(Q7B_QIMAGE(Image))){ Q7B_EXCEPTION("QImage expected"); return ; }

  Q7B_IDQBrush(self).setTextureImage(Q7B_IDQImage(Image));
}

void Q7B_QBRUSH_SETTRANSFORM(Q7B self, Q7B Matrix) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  if (Q7B_nil(Q7B_QTRANSFORM(Matrix))){ Q7B_EXCEPTION("QTransform expected"); return ; }

  Q7B_IDQBrush(self).setTransform(Q7B_IDQTransform(Matrix));
}

Q7B Q7B_QBRUSH_STYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQBrush(self).style() );
}
/*
void Q7B_QBRUSH_SWAP(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  if (Q7B_nil(Q7B_QBRUSH(Other))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  Q7B_IDQBrush(self).swap(Q7B_IDQBrush(Other));
}*/

Q7B Q7B_QBRUSH_TEXTURE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQBrush(self).texture() );
}

Q7B Q7B_QBRUSH_TEXTUREIMAGE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQBrush(self).textureImage() );
}

Q7B Q7B_QBRUSH_TRANSFORM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBRUSH(self))){ Q7B_EXCEPTION("QBrush expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQBrush(self).transform() );
}

Q7B Q7B_QFONTINFO_BOLD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTINFO(self))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontInfo(self).bold() );
}

Q7B Q7B_QFONTINFO_EXACTMATCH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTINFO(self))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontInfo(self).exactMatch() );
}

Q7B Q7B_QFONTINFO_FAMILY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTINFO(self))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontInfo(self).family() );
}

Q7B Q7B_QFONTINFO_FIXEDPITCH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTINFO(self))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontInfo(self).fixedPitch() );
}

Q7B Q7B_QFONTINFO_ITALIC(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTINFO(self))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontInfo(self).italic() );
}

Q7B Q7B_QFONTINFO_PIXELSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTINFO(self))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontInfo(self).pixelSize() );
}

Q7B Q7B_QFONTINFO_POINTSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTINFO(self))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontInfo(self).pointSize() );
}

Q7B Q7B_QFONTINFO_POINTSIZEF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTINFO(self))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontInfo(self).pointSizeF() );
}

Q7B Q7B_QFONTINFO_RAWMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTINFO(self))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontInfo(self).rawMode() );
}

Q7B Q7B_QFONTINFO_STYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTINFO(self))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontInfo(self).style() );
}

Q7B Q7B_QFONTINFO_STYLEHINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTINFO(self))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontInfo(self).styleHint() );
}
/*
Q7B Q7B_QFONTINFO_STYLENAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTINFO(self))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontInfo(self).styleName() );
}*/

Q7B Q7B_QFONTINFO_WEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTINFO(self))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontInfo(self).weight() );
}

Q7B Q7B_QFONTMETRICS_ASCENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).ascent() );
}

Q7B Q7B_QFONTMETRICS_AVERAGECHARWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).averageCharWidth() );
}

Q7B Q7B_QFONTMETRICS_BOUNDINGRECT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).boundingRect(Q7B_IDQString(Text)) );
}

Q7B Q7B_QFONTMETRICS_DESCENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).descent() );
}

Q7B Q7B_QFONTMETRICS_ELIDEDTEXT(Q7B self, Q7B Text, Q7B Mode, Q7B Width, Q7B Flags) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).elidedText(Q7B_IDQString(Text), (Qt::TextElideMode) Q7B_IDqint64(Mode), Q7B_IDqint64(Width), Q7B_IDqint64(Flags)) );
}

Q7B Q7B_QFONTMETRICS_HEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).height() );
}

Q7B Q7B_QFONTMETRICS_INFONT(Q7B self, Q7B Ch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Ch))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).inFont(Q7B_IDQString(Ch).at(0)) );
}

Q7B Q7B_QFONTMETRICS_LEADING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).leading() );
}

Q7B Q7B_QFONTMETRICS_LEFTBEARING(Q7B self, Q7B Ch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Ch))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).leftBearing(Q7B_IDQString(Ch).at(0)) );
}

Q7B Q7B_QFONTMETRICS_LINESPACING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).lineSpacing() );
}

Q7B Q7B_QFONTMETRICS_LINEWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).lineWidth() );
}

Q7B Q7B_QFONTMETRICS_MAXWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).maxWidth() );
}

Q7B Q7B_QFONTMETRICS_MINLEFTBEARING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).minLeftBearing() );
}

Q7B Q7B_QFONTMETRICS_MINRIGHTBEARING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).minRightBearing() );
}

Q7B Q7B_QFONTMETRICS_OVERLINEPOS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).overlinePos() );
}

Q7B Q7B_QFONTMETRICS_RIGHTBEARING(Q7B self, Q7B Ch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Ch))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).rightBearing(Q7B_IDQString(Ch).at(0)) );
}

Q7B Q7B_QFONTMETRICS_STRIKEOUTPOS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).strikeOutPos() );
}

Q7B Q7B_QFONTMETRICS_TIGHTBOUNDINGRECT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).tightBoundingRect(Q7B_IDQString(Text)) );
}

Q7B Q7B_QFONTMETRICS_UNDERLINEPOS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).underlinePos() );
}

Q7B Q7B_QFONTMETRICS_WIDTH(Q7B self, Q7B Ch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Ch))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).width(Q7B_IDQString(Ch)) );
}

Q7B Q7B_QFONTMETRICS_XHEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).xHeight() );
}

Q7B Q7B_QICON_ACTUALSIZE(Q7B self, Q7B Size, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(self))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQIcon(self).actualSize(Q7B_IDQSize(Size), (QIcon::Mode) Q7B_IDqint64(Mode)) );
}

void Q7B_QICON_ADDFILE(Q7B self, Q7B FileName, Q7B Size, Q7B Mode, Q7B State) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QICON(self))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(State))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQIcon(self).addFile(Q7B_IDQString(FileName), Q7B_IDQSize(Size), (QIcon::Mode) Q7B_IDqint64(Mode), (QIcon::State) Q7B_IDqint64(State));
}

void Q7B_QICON_ADDPIXMAP(Q7B self, Q7B Pixmap, Q7B Mode, Q7B State) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QICON(self))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  if (Q7B_nil(Q7B_QPIXMAP(Pixmap))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(State))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQIcon(self).addPixmap(Q7B_IDQPixmap(Pixmap), (QIcon::Mode) Q7B_IDqint64(Mode), (QIcon::State) Q7B_IDqint64(State));
}

Q7B Q7B_QICON_CACHEKEY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(self))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQIcon(self).cacheKey() );
}

Q7B Q7B_QICON_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(self))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQIcon(self).isNull() );
}

Q7B Q7B_QICON_NAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(self))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQIcon(self).name() );
}

void Q7B_QICON_PAINT(Q7B self, Q7B Painter, Q7B X, Q7B Y, Q7B W, Q7B H, Q7B Alignment, Q7B Mode, Q7B State) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QICON(self))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  if (Q7B_nil(Q7B_QPAINTER(Painter))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(W))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(H))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Alignment))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(State))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQIcon(self).paint(&Q7B_IDQPainter(Painter), Q7B_IDqint64(X), Q7B_IDqint64(Y), Q7B_IDqint64(W), Q7B_IDqint64(H), (Qt::Alignment) Q7B_IDqint64(Alignment), (QIcon::Mode) Q7B_IDqint64(Mode), (QIcon::State) Q7B_IDqint64(State));
}

Q7B Q7B_QICON_PIXMAP(Q7B self, Q7B Extent, Q7B Mode, Q7B State) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(self))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Extent))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(State))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQIcon(self).pixmap(Q7B_IDqint64(Extent), (QIcon::Mode) Q7B_IDqint64(Mode), (QIcon::State) Q7B_IDqint64(State)) );
}
/*
void Q7B_QICON_SWAP(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QICON(self))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  if (Q7B_nil(Q7B_QICON(Other))){ Q7B_EXCEPTION("QIcon expected"); return ; }

  Q7B_IDQIcon(self).swap(Q7B_IDQIcon(Other));
}*/

Q7B Q7B_QLAYOUT_ACTIVATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLayout(self).activate() );
}

void Q7B_QLAYOUT_ADDITEM(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return ; }

  if (Q7B_nil(Q7B_QLAYOUTITEM(Item))){ Q7B_EXCEPTION("QLayoutItem expected"); return ; }

  Q7B_IDQLayout(self).addItem(&Q7B_IDQLayoutItem(Item));
}

void Q7B_QLAYOUT_ADDWIDGET(Q7B self, Q7B W) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(W))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQLayout(self).addWidget(Q7B_IDQWidget(W));
}

Q7B Q7B_QLAYOUT_CONTENTSRECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLayout(self).contentsRect() );
}

Q7B Q7B_QLAYOUT_INDEXOF(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLayout(self).indexOf(Q7B_IDQWidget(Widget)) );
}

Q7B Q7B_QLAYOUT_ISENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLayout(self).isEnabled() );
}

Q7B Q7B_QLAYOUT_ITEMAT(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLayout(self).itemAt(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QLAYOUT_MENUBAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLayout(self).menuBar() );
}

Q7B Q7B_QLAYOUT_PARENTWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLayout(self).parentWidget() );
}

void Q7B_QLAYOUT_REMOVEITEM(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return ; }

  if (Q7B_nil(Q7B_QLAYOUTITEM(Item))){ Q7B_EXCEPTION("QLayoutItem expected"); return ; }

  Q7B_IDQLayout(self).removeItem(&Q7B_IDQLayoutItem(Item));
}

void Q7B_QLAYOUT_REMOVEWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQLayout(self).removeWidget(Q7B_IDQWidget(Widget));
}

void Q7B_QLAYOUT_SETCONTENTSMARGINS(Q7B self, Q7B Left, Q7B Top, Q7B Right, Q7B Bottom) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Left))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Top))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Right))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Bottom))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLayout(self).setContentsMargins(Q7B_IDqint64(Left), Q7B_IDqint64(Top), Q7B_IDqint64(Right), Q7B_IDqint64(Bottom));
}

void Q7B_QLAYOUT_SETENABLED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return ; }

  if (Q7B_nil(Q7B_BOOLEAN(Enable))){ Q7B_EXCEPTION("Boolen expected"); return ; }

  Q7B_IDQLayout(self).setEnabled(Q7B_IDbool(Enable));
}

void Q7B_QLAYOUT_SETMENUBAR(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQLayout(self).setMenuBar(Q7B_IDQWidget(Widget));
}

void Q7B_QLAYOUT_SETSIZECONSTRAINT(Q7B self, Q7B Constraint) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Constraint))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLayout(self).setSizeConstraint((QLayout::SizeConstraint) Q7B_IDqint64(Constraint));
}

void Q7B_QLAYOUT_SETSPACING(Q7B self, Q7B Spacing) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Spacing))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLayout(self).setSpacing(Q7B_IDqint64(Spacing));
}

Q7B Q7B_QLAYOUT_SIZECONSTRAINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLayout(self).sizeConstraint() );
}

Q7B Q7B_QLAYOUT_SPACING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLayout(self).spacing() );
}

void Q7B_QLAYOUT_UPDATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLAYOUT(self))){ Q7B_EXCEPTION("QLayout expected"); return ; }

  Q7B_IDQLayout(self).update();
}

Q7B Q7B_QPAINTER_BACKGROUND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).background() );
}

Q7B Q7B_QPAINTER_BACKGROUNDMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).backgroundMode() );
}

Q7B Q7B_QPAINTER_BEGIN(Q7B self, Q7B Device) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Device))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).begin((QPaintDevice *) Q7B_IDQWidget(Device)) );
}

void Q7B_QPAINTER_BEGINNATIVEPAINTING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  Q7B_IDQPainter(self).beginNativePainting();
}

Q7B Q7B_QPAINTER_BOUNDINGRECT(Q7B self, Q7B Rectangle, Q7B Flags, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Flags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).boundingRect(Q7B_IDQRect(Rectangle), Q7B_IDqint64(Flags), Q7B_IDQString(Text)) );
}

Q7B Q7B_QPAINTER_BRUSH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).brush() );
}

Q7B Q7B_QPAINTER_BRUSHORIGIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).brushOrigin() );
}

Q7B Q7B_QPAINTER_CLIPREGION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).clipRegion() );
}

Q7B Q7B_QPAINTER_COMBINEDTRANSFORM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).combinedTransform() );
}

Q7B Q7B_QPAINTER_COMPOSITIONMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).compositionMode() );
}

Q7B Q7B_QPAINTER_DEVICE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).device() );
}

Q7B Q7B_QPAINTER_DEVICETRANSFORM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).deviceTransform() );
}

void Q7B_QPAINTER_DRAWARC(Q7B self, Q7B Rectangle, Q7B StartAngle, Q7B SpanAngle) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(StartAngle))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(SpanAngle))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).drawArc(Q7B_IDQRect(Rectangle), Q7B_IDqint64(StartAngle), Q7B_IDqint64(SpanAngle));
}

void Q7B_QPAINTER_DRAWCHORD(Q7B self, Q7B Rectangle, Q7B StartAngle, Q7B SpanAngle) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(StartAngle))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(SpanAngle))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).drawChord(Q7B_IDQRect(Rectangle), Q7B_IDqint64(StartAngle), Q7B_IDqint64(SpanAngle));
}

void Q7B_QPAINTER_DRAWCONVEXPOLYGON(Q7B self, Q7B Points) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOLYGON(Points))){ Q7B_EXCEPTION("QPolygon expected"); return ; }

  Q7B_IDQPainter(self).drawConvexPolygon(Q7B_IDQPolygon(Points));
}

void Q7B_QPAINTER_DRAWELLIPSE(Q7B self, Q7B Center, Q7B Rx, Q7B Ry) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Center))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Rx))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Ry))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).drawEllipse(Q7B_IDQPoint(Center), Q7B_IDqint64(Rx), Q7B_IDqint64(Ry));
}

void Q7B_QPAINTER_DRAWIMAGE(Q7B self, Q7B Rectangle, Q7B Image) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QIMAGE(Image))){ Q7B_EXCEPTION("QImage expected"); return ; }

  Q7B_IDQPainter(self).drawImage(Q7B_IDQRect(Rectangle), Q7B_IDQImage(Image));
}

void Q7B_QPAINTER_DRAWPICTURE(Q7B self, Q7B X, Q7B Y, Q7B Picture) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QPICTURE(Picture))){ Q7B_EXCEPTION("QPicture expected"); return ; }

  Q7B_IDQPainter(self).drawPicture(Q7B_IDqint64(X), Q7B_IDqint64(Y), Q7B_IDQPicture(Picture));
}

void Q7B_QPAINTER_DRAWPIE(Q7B self, Q7B Rectangle, Q7B StartAngle, Q7B SpanAngle) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(StartAngle))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(SpanAngle))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).drawPie(Q7B_IDQRect(Rectangle), Q7B_IDqint64(StartAngle), Q7B_IDqint64(SpanAngle));
}

void Q7B_QPAINTER_DRAWPIXMAP(Q7B self, Q7B Rectangle, Q7B Pixmap) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPIXMAP(Pixmap))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  Q7B_IDQPainter(self).drawPixmap(Q7B_IDQRect(Rectangle), Q7B_IDQPixmap(Pixmap));
}

void Q7B_QPAINTER_DRAWPOINT(Q7B self, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).drawPoint(Q7B_IDqint64(X), Q7B_IDqint64(Y));
}

void Q7B_QPAINTER_DRAWPOINTS(Q7B self, Q7B Points) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOLYGON(Points))){ Q7B_EXCEPTION("QPolygon expected"); return ; }

  Q7B_IDQPainter(self).drawPoints(Q7B_IDQPolygon(Points));
}

void Q7B_QPAINTER_DRAWPOLYGON(Q7B self, Q7B Polygon, Q7B FillRule) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOLYGON(Polygon))){ Q7B_EXCEPTION("QPolygon expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(FillRule))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).drawPolygon(Q7B_IDQPolygon(Polygon), (Qt::FillRule) Q7B_IDqint64(FillRule));
}

void Q7B_QPAINTER_DRAWPOLYLINE(Q7B self, Q7B Points) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOLYGON(Points))){ Q7B_EXCEPTION("QPolygon expected"); return ; }

  Q7B_IDQPainter(self).drawPolyline(Q7B_IDQPolygon(Points));
}

void Q7B_QPAINTER_DRAWRECT(Q7B self, Q7B Rectangle) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  Q7B_IDQPainter(self).drawRect(Q7B_IDQRect(Rectangle));
}

void Q7B_QPAINTER_DRAWROUNDEDRECT(Q7B self, Q7B Rectangle, Q7B XRadius, Q7B YRadius, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(XRadius))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(YRadius))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).drawRoundedRect(Q7B_IDQRect(Rectangle), Q7B_IDqreal(XRadius), Q7B_IDqreal(YRadius), (Qt::SizeMode) Q7B_IDqint64(Mode));
}

void Q7B_QPAINTER_DRAWTEXT(Q7B self, Q7B X, Q7B Y, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQPainter(self).drawText(Q7B_IDqint64(X), Q7B_IDqint64(Y), Q7B_IDQString(Text));
}

void Q7B_QPAINTER_DRAWTILEDPIXMAP(Q7B self, Q7B Rectangle, Q7B Pixmap, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPIXMAP(Pixmap))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQPainter(self).drawTiledPixmap(Q7B_IDQRect(Rectangle), Q7B_IDQPixmap(Pixmap), Q7B_IDQPoint(Position));
}

Q7B Q7B_QPAINTER_END(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).end() );
}

void Q7B_QPAINTER_ENDNATIVEPAINTING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  Q7B_IDQPainter(self).endNativePainting();
}

void Q7B_QPAINTER_ERASERECT(Q7B self, Q7B Rectangle) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  Q7B_IDQPainter(self).eraseRect(Q7B_IDQRect(Rectangle));
}

void Q7B_QPAINTER_FILLRECT(Q7B self, Q7B Rectangle, Q7B Color) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Color))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).fillRect(Q7B_IDQRect(Rectangle), (Qt::GlobalColor) Q7B_IDqint64(Color));
}

Q7B Q7B_QPAINTER_FONT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).font() );
}

Q7B Q7B_QPAINTER_FONTINFO(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).fontInfo() );
}

Q7B Q7B_QPAINTER_FONTMETRICS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).fontMetrics() );
}

Q7B Q7B_QPAINTER_HASCLIPPING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).hasClipping() );
}

void Q7B_QPAINTER_INITFROM(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQPainter(self).initFrom(Q7B_IDQWidget(Widget));
}

Q7B Q7B_QPAINTER_ISACTIVE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).isActive() );
}

Q7B Q7B_QPAINTER_LAYOUTDIRECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).layoutDirection() );
}

Q7B Q7B_QPAINTER_OPACITY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).opacity() );
}

Q7B Q7B_QPAINTER_PAINTENGINE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).paintEngine() );
}

Q7B Q7B_QPAINTER_PEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).pen() );
}

Q7B Q7B_QPAINTER_RENDERHINTS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).renderHints() );
}

void Q7B_QPAINTER_RESETTRANSFORM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  Q7B_IDQPainter(self).resetTransform();
}

void Q7B_QPAINTER_RESTORE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  Q7B_IDQPainter(self).restore();
}

void Q7B_QPAINTER_ROTATE(Q7B self, Q7B Angle) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Angle))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQPainter(self).rotate(Q7B_IDqreal(Angle));
}

void Q7B_QPAINTER_SAVE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  Q7B_IDQPainter(self).save();
}

void Q7B_QPAINTER_SCALE(Q7B self, Q7B Sx, Q7B a1) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Sx))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(a1))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQPainter(self).scale(Q7B_IDqreal(Sx), Q7B_IDqreal(a1));
}

void Q7B_QPAINTER_SETBACKGROUND(Q7B self, Q7B Brush) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QBRUSH(Brush))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  Q7B_IDQPainter(self).setBackground(Q7B_IDQBrush(Brush));
}

void Q7B_QPAINTER_SETBACKGROUNDMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).setBackgroundMode((Qt::BGMode) Q7B_IDqint64(Mode));
}

void Q7B_QPAINTER_SETBRUSH(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).setBrush((Qt::BrushStyle) Q7B_IDqint64(Style));
}

void Q7B_QPAINTER_SETBRUSHORIGIN(Q7B self, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).setBrushOrigin(Q7B_IDqint64(X), Q7B_IDqint64(Y));
}

void Q7B_QPAINTER_SETCLIPRECT(Q7B self, Q7B Rectangle, Q7B Operation) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Operation))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).setClipRect(Q7B_IDQRect(Rectangle), (Qt::ClipOperation) Q7B_IDqint64(Operation));
}

void Q7B_QPAINTER_SETCLIPREGION(Q7B self, Q7B Region, Q7B Operation) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QREGION(Region))){ Q7B_EXCEPTION("QRegion expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Operation))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).setClipRegion(Q7B_IDQRegion(Region), (Qt::ClipOperation) Q7B_IDqint64(Operation));
}

void Q7B_QPAINTER_SETCLIPPING(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQPainter(self).setClipping(Q7B_IDbool(Enable));
}

void Q7B_QPAINTER_SETCOMPOSITIONMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).setCompositionMode((QPainter::CompositionMode) Q7B_IDqint64(Mode));
}

void Q7B_QPAINTER_SETFONT(Q7B self, Q7B Font) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QFONT(Font))){ Q7B_EXCEPTION("QFont expected"); return ; }

  Q7B_IDQPainter(self).setFont(Q7B_IDQFont(Font));
}

void Q7B_QPAINTER_SETLAYOUTDIRECTION(Q7B self, Q7B Direction) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Direction))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).setLayoutDirection((Qt::LayoutDirection) Q7B_IDqint64(Direction));
}

void Q7B_QPAINTER_SETOPACITY(Q7B self, Q7B Opacity) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Opacity))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQPainter(self).setOpacity(Q7B_IDqreal(Opacity));
}

void Q7B_QPAINTER_SETPEN(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).setPen((Qt::PenStyle) Q7B_IDqint64(Style));
}

void Q7B_QPAINTER_SETRENDERHINT(Q7B self, Q7B Hint) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Hint))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).setRenderHint((QPainter::RenderHint) Q7B_IDqint64(Hint));
}

void Q7B_QPAINTER_SETRENDERHINTS(Q7B self, Q7B Hints) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Hints))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).setRenderHints((QPainter::RenderHints) Q7B_IDqint64(Hints));
}

void Q7B_QPAINTER_SETTRANSFORM(Q7B self, Q7B Transform, Q7B Combine) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QTRANSFORM(Transform))){ Q7B_EXCEPTION("QTransform expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Combine))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQPainter(self).setTransform(Q7B_IDQTransform(Transform), Q7B_IDbool(Combine));
}

void Q7B_QPAINTER_SETVIEWTRANSFORMENABLED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQPainter(self).setViewTransformEnabled(Q7B_IDbool(Enable));
}

void Q7B_QPAINTER_SETVIEWPORT(Q7B self, Q7B Rectangle) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  Q7B_IDQPainter(self).setViewport(Q7B_IDQRect(Rectangle));
}

void Q7B_QPAINTER_SETWINDOW(Q7B self, Q7B Rectangle) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  Q7B_IDQPainter(self).setWindow(Q7B_IDQRect(Rectangle));
}

void Q7B_QPAINTER_SETWORLDMATRIXENABLED(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQPainter(self).setWorldMatrixEnabled(Q7B_IDbool(Enable));
}

void Q7B_QPAINTER_SETWORLDTRANSFORM(Q7B self, Q7B Matrix, Q7B Combine) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QTRANSFORM(Matrix))){ Q7B_EXCEPTION("QTransform expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Combine))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQPainter(self).setWorldTransform(Q7B_IDQTransform(Matrix), Q7B_IDbool(Combine));
}

Q7B Q7B_QPAINTER_TESTRENDERHINT(Q7B self, Q7B Hint) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Hint))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).testRenderHint((QPainter::RenderHint) Q7B_IDqint64(Hint)) );
}

Q7B Q7B_QPAINTER_TRANSFORM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).transform() );
}

void Q7B_QPAINTER_TRANSLATE(Q7B self, Q7B Dx, Q7B Dy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dx))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).translate(Q7B_IDqint64(Dx), Q7B_IDqint64(Dy));
}

Q7B Q7B_QPAINTER_VIEWTRANSFORMENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).viewTransformEnabled() );
}

Q7B Q7B_QPAINTER_VIEWPORT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).viewport() );
}

Q7B Q7B_QPAINTER_WINDOW(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).window() );
}

Q7B Q7B_QPAINTER_WORLDMATRIXENABLED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).worldMatrixEnabled() );
}

Q7B Q7B_QPAINTER_WORLDTRANSFORM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPainter(self).worldTransform() );
}

Q7B Q7B_QREGION_BOUNDINGRECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).boundingRect() );
}

Q7B Q7B_QREGION_CONTAINS(Q7B self, Q7B R) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QRECT(R))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).contains(Q7B_IDQRect(R)) );
}

Q7B Q7B_QREGION_INTERSECTED(Q7B self, Q7B Rect) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QRECT(Rect))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).intersected(Q7B_IDQRect(Rect)) );
}

Q7B Q7B_QREGION_INTERSECTS(Q7B self, Q7B Rect) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QRECT(Rect))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).intersects(Q7B_IDQRect(Rect)) );
}

Q7B Q7B_QREGION_ISEMPTY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).isEmpty() );
}

Q7B Q7B_QREGION_RECTCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).rectCount() );
}

Q7B Q7B_QREGION_SUBTRACTED(Q7B self, Q7B R) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGION(R))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).subtracted(Q7B_IDQRegion(R)) );
}
/*
void Q7B_QREGION_SWAP(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return ; }

  if (Q7B_nil(Q7B_QREGION(Other))){ Q7B_EXCEPTION("Region expected"); return ; }

  Q7B_IDQRegion(self).swap(Q7B_IDQRegion(Other));
}*/

void Q7B_QREGION_TRANSLATE(Q7B self, Q7B Point) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Point))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRegion(self).translate(Q7B_IDQPoint(Point));
}

Q7B Q7B_QREGION_TRANSLATED(Q7B self, Q7B Point) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Point))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).translated(Q7B_IDQPoint(Point)) );
}

Q7B Q7B_QREGION_UNITED(Q7B self, Q7B Rect) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QRECT(Rect))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).united(Q7B_IDQRect(Rect)) );
}

Q7B Q7B_QREGION_XORED(Q7B self, Q7B R) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREGION(R))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).xored(Q7B_IDQRegion(R)) );
}

Q7B Q7B_QSIZE_BOUNDEDTO(Q7B self, Q7B OtherSize) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSIZE(OtherSize))){ Q7B_EXCEPTION("QSize expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSize(self).boundedTo(Q7B_IDQSize(OtherSize)) );
}

Q7B Q7B_QSIZE_EXPANDEDTO(Q7B self, Q7B OtherSize) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSIZE(OtherSize))){ Q7B_EXCEPTION("QSize expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSize(self).expandedTo(Q7B_IDQSize(OtherSize)) );
}

Q7B Q7B_QSIZE_HEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSize(self).height() );
}

Q7B Q7B_QSIZE_ISEMPTY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSize(self).isEmpty() );
}

Q7B Q7B_QSIZE_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSize(self).isNull() );
}

Q7B Q7B_QSIZE_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSize(self).isValid() );
}

Q7B Q7B_QSIZE_RHEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSize(self).rheight() );
}

Q7B Q7B_QSIZE_RWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSize(self).rwidth() );
}

void Q7B_QSIZE_SCALE(Q7B self, Q7B Size, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSize(self).scale(Q7B_IDQSize(Size), (Qt::AspectRatioMode) Q7B_IDqint64(Mode));
}

void Q7B_QSIZE_SETHEIGHT(Q7B self, Q7B Height) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Height))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSize(self).setHeight(Q7B_IDqint64(Height));
}

void Q7B_QSIZE_SETWIDTH(Q7B self, Q7B Width) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSize(self).setWidth(Q7B_IDqint64(Width));
}

void Q7B_QSIZE_TRANSPOSE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQSize(self).transpose();
}

Q7B Q7B_QSIZE_WIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSize(self).width() );
}

Q7B Q7B_QTEXTCURSOR_ANCHOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).anchor() );
}

Q7B Q7B_QTEXTCURSOR_ATBLOCKEND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).atBlockEnd() );
}

Q7B Q7B_QTEXTCURSOR_ATBLOCKSTART(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).atBlockStart() );
}

Q7B Q7B_QTEXTCURSOR_ATEND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).atEnd() );
}

Q7B Q7B_QTEXTCURSOR_ATSTART(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).atStart() );
}

void Q7B_QTEXTCURSOR_BEGINEDITBLOCK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  Q7B_IDQTextCursor(self).beginEditBlock();
}

Q7B Q7B_QTEXTCURSOR_BLOCK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).block() );
}

Q7B Q7B_QTEXTCURSOR_BLOCKCHARFORMAT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).blockCharFormat() );
}

Q7B Q7B_QTEXTCURSOR_BLOCKFORMAT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).blockFormat() );
}

Q7B Q7B_QTEXTCURSOR_BLOCKNUMBER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).blockNumber() );
}

Q7B Q7B_QTEXTCURSOR_CHARFORMAT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).charFormat() );
}

void Q7B_QTEXTCURSOR_CLEARSELECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  Q7B_IDQTextCursor(self).clearSelection();
}

Q7B Q7B_QTEXTCURSOR_COLUMNNUMBER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).columnNumber() );
}

Q7B Q7B_QTEXTCURSOR_CREATELIST(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).createList((QTextListFormat::Style) Q7B_IDqint64(Style)) );
}

Q7B Q7B_QTEXTCURSOR_CURRENTFRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).currentFrame() );
}

Q7B Q7B_QTEXTCURSOR_CURRENTLIST(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).currentList() );
}

Q7B Q7B_QTEXTCURSOR_CURRENTTABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).currentTable() );
}

void Q7B_QTEXTCURSOR_DELETECHAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  Q7B_IDQTextCursor(self).deleteChar();
}

void Q7B_QTEXTCURSOR_DELETEPREVIOUSCHAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  Q7B_IDQTextCursor(self).deletePreviousChar();
}

Q7B Q7B_QTEXTCURSOR_DOCUMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).document() );
}

void Q7B_QTEXTCURSOR_ENDEDITBLOCK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  Q7B_IDQTextCursor(self).endEditBlock();
}

Q7B Q7B_QTEXTCURSOR_HASCOMPLEXSELECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).hasComplexSelection() );
}

Q7B Q7B_QTEXTCURSOR_HASSELECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).hasSelection() );
}

void Q7B_QTEXTCURSOR_INSERTBLOCK(Q7B self, Q7B Format, Q7B CharFormat) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(Format))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(CharFormat))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  Q7B_IDQTextCursor(self).insertBlock(Q7B_IDQTextBlockFormat(Format), Q7B_IDQTextCharFormat(CharFormat));
}

void Q7B_QTEXTCURSOR_INSERTFRAGMENT(Q7B self, Q7B Fragment) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTDOCUMENTFRAGMENT(Fragment))){ Q7B_EXCEPTION("QTextDocumentFragment expected"); return ; }

  Q7B_IDQTextCursor(self).insertFragment(Q7B_IDQTextDocumentFragment(Fragment));
}

Q7B Q7B_QTEXTCURSOR_INSERTFRAME(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTEXTFRAMEFORMAT(Format))){ Q7B_EXCEPTION("QTextFrameFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).insertFrame(Q7B_IDQTextFrameFormat(Format)) );
}

void Q7B_QTEXTCURSOR_INSERTHTML(Q7B self, Q7B Html) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Html))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextCursor(self).insertHtml(Q7B_IDQString(Html));
}

void Q7B_QTEXTCURSOR_INSERTIMAGE(Q7B self, Q7B Image, Q7B Name) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QIMAGE(Image))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextCursor(self).insertImage(Q7B_IDQImage(Image), Q7B_IDQString(Name));
}

Q7B Q7B_QTEXTCURSOR_INSERTLIST(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).insertList((QTextListFormat::Style) Q7B_IDqint64(Style)) );
}

Q7B Q7B_QTEXTCURSOR_INSERTTABLE(Q7B self, Q7B Rows, Q7B Columns) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Rows))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Columns))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).insertTable(Q7B_IDqint64(Rows), Q7B_IDqint64(Columns)) );
}

void Q7B_QTEXTCURSOR_INSERTTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextCursor(self).insertText(Q7B_IDQString(Text));
}

Q7B Q7B_QTEXTCURSOR_ISCOPYOF(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTEXTCURSOR(Other))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).isCopyOf(Q7B_IDQTextCursor(Other)) );
}

Q7B Q7B_QTEXTCURSOR_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).isNull() );
}

void Q7B_QTEXTCURSOR_JOINPREVIOUSEDITBLOCK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  Q7B_IDQTextCursor(self).joinPreviousEditBlock();
}

Q7B Q7B_QTEXTCURSOR_KEEPPOSITIONONINSERT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).keepPositionOnInsert() );
}

void Q7B_QTEXTCURSOR_MERGEBLOCKCHARFORMAT(Q7B self, Q7B Modifier) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(Modifier))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  Q7B_IDQTextCursor(self).mergeBlockCharFormat(Q7B_IDQTextCharFormat(Modifier));
}

void Q7B_QTEXTCURSOR_MERGEBLOCKFORMAT(Q7B self, Q7B Modifier) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(Modifier))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  Q7B_IDQTextCursor(self).mergeBlockFormat(Q7B_IDQTextBlockFormat(Modifier));
}

void Q7B_QTEXTCURSOR_MERGECHARFORMAT(Q7B self, Q7B Modifier) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(Modifier))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  Q7B_IDQTextCursor(self).mergeCharFormat(Q7B_IDQTextCharFormat(Modifier));
}

Q7B Q7B_QTEXTCURSOR_MOVEPOSITION(Q7B self, Q7B Operation, Q7B Move) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Operation))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Move))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).movePosition((QTextCursor::MoveOperation) Q7B_IDqint64(Operation), (QTextCursor::MoveMode) Q7B_IDqint64(Move)) );
}

Q7B Q7B_QTEXTCURSOR_POSITION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).position() );
}

Q7B Q7B_QTEXTCURSOR_POSITIONINBLOCK(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).positionInBlock() );
}

void Q7B_QTEXTCURSOR_REMOVESELECTEDTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  Q7B_IDQTextCursor(self).removeSelectedText();
}

void Q7B_QTEXTCURSOR_SELECT(Q7B self, Q7B Selection) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Selection))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextCursor(self).select((QTextCursor::SelectionType) Q7B_IDqint64(Selection));
}

Q7B Q7B_QTEXTCURSOR_SELECTEDTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).selectedText() );
}

Q7B Q7B_QTEXTCURSOR_SELECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).selection() );
}

Q7B Q7B_QTEXTCURSOR_SELECTIONEND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).selectionEnd() );
}

Q7B Q7B_QTEXTCURSOR_SELECTIONSTART(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).selectionStart() );
}

void Q7B_QTEXTCURSOR_SETBLOCKCHARFORMAT(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(Format))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  Q7B_IDQTextCursor(self).setBlockCharFormat(Q7B_IDQTextCharFormat(Format));
}

void Q7B_QTEXTCURSOR_SETBLOCKFORMAT(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(Format))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  Q7B_IDQTextCursor(self).setBlockFormat(Q7B_IDQTextBlockFormat(Format));
}

void Q7B_QTEXTCURSOR_SETCHARFORMAT(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(Format))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  Q7B_IDQTextCursor(self).setCharFormat(Q7B_IDQTextCharFormat(Format));
}

void Q7B_QTEXTCURSOR_SETKEEPPOSITIONONINSERT(Q7B self, Q7B B) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(B))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextCursor(self).setKeepPositionOnInsert(Q7B_IDbool(B));
}

void Q7B_QTEXTCURSOR_SETPOSITION(Q7B self, Q7B Pos, Q7B M) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Pos))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(M))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextCursor(self).setPosition(Q7B_IDqint64(Pos), (QTextCursor::MoveMode) Q7B_IDqint64(M));
}

void Q7B_QTEXTCURSOR_SETVERTICALMOVEMENTX(Q7B self, Q7B X) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextCursor(self).setVerticalMovementX(Q7B_IDqint64(X));
}

void Q7B_QTEXTCURSOR_SETVISUALNAVIGATION(Q7B self, Q7B B) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(B))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextCursor(self).setVisualNavigation(Q7B_IDbool(B));
}

Q7B Q7B_QTEXTCURSOR_VERTICALMOVEMENTX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).verticalMovementX() );
}

Q7B Q7B_QTEXTCURSOR_VISUALNAVIGATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).visualNavigation() );
}

Q7B Q7B_QOBJECT_ISWIDGETTYPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QOBJECT(self))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQObject(self)->isWidgetType() );
}

Q7B Q7B_QOBJECT_PARENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QOBJECT(self))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQObject(self)->parent() );
}

void Q7B_QOBJECT_KILLTIMER(Q7B self, Q7B theId) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QOBJECT(self))){ Q7B_EXCEPTION("QObject expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theId))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQObject(self)->killTimer(Q7B_IDqint64(theId));
}

Q7B Q7B_QOBJECT_STARTTIMER(Q7B self, Q7B interval) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QOBJECT(self))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(interval))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQObject(self)->startTimer(Q7B_IDqint64(interval)) );
}


Q7B Q7B_QICON_PIXMAP2(Q7B self, Q7B Size, Q7B Mode, Q7B State) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(self))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(State))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQIcon(self).pixmap(Q7B_IDQSize(Size), (QIcon::Mode) Q7B_IDqint64(Mode), (QIcon::State) Q7B_IDqint64(State)) );
}

Q7B Q7B_QICON_PIXMAP3(Q7B self, Q7B Extent, Q7B Mode, Q7B State) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(self))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Extent))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(State))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQIcon(self).pixmap(Q7B_IDqint64(Extent), (QIcon::Mode) Q7B_IDqint64(Mode), (QIcon::State) Q7B_IDqint64(State)) );
}

Q7B Q7B_QIMAGE_SCALED2(Q7B self, Q7B Width, Q7B Heigth, Q7B AspectRatioMode, Q7B TransformMode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Heigth))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(AspectRatioMode))){ Q7B_EXCEPTION("Qt.AspectRatioMode expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(TransformMode))){ Q7B_EXCEPTION("Qt.TransformationMode expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).scaled(Q7B_IDqint64(Width), Q7B_IDqint64(Heigth), (Qt::AspectRatioMode) Q7B_IDqint64(AspectRatioMode), (Qt::TransformationMode) Q7B_IDqint64(TransformMode)) );
}

void Q7B_QIMAGE_SETPIXEL2(Q7B self, Q7B X, Q7B Y, Q7B IndexOrRgb) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(IndexOrRgb))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQImage(self).setPixel(Q7B_IDqint64(X), Q7B_IDqint64(Y), Q7B_IDqint64(IndexOrRgb));
}

Q7B Q7B_QIMAGE_TRANSFORMED2(Q7B self, Q7B Matrix, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTRANSFORM(Matrix))){ Q7B_EXCEPTION("QTransform expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Qt.TransformationMode expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).transformed(Q7B_IDQTransform(Matrix), (Qt::TransformationMode) Q7B_IDqint64(Mode)) );
}

Q7B Q7B_QIMAGE_VALID2(Q7B self, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QIMAGE(self))){ Q7B_EXCEPTION("QImage expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQImage(self).valid(Q7B_IDqint64(X), Q7B_IDqint64(Y)) );
}

void Q7B_QLISTWIDGET_ADDITEM2(Q7B self, Q7B Item) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QLISTWIDGETITEM(Item))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  Q7B_IDQListWidget(self)->addItem(&Q7B_IDQListWidgetItem(Item));
}

void Q7B_QLISTWIDGET_INSERTITEM2(Q7B self, Q7B Row, Q7B theLabel) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theLabel))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQListWidget(self)->insertItem(Q7B_IDqint64(Row), Q7B_IDQString(theLabel));
}

Q7B Q7B_QLISTWIDGET_ITEMAT2(Q7B self, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListWidget(self)->itemAt(Q7B_IDqint64(X), Q7B_IDqint64(Y)) );
}

void Q7B_QLISTWIDGET_SETCURRENTITEM2(Q7B self, Q7B Item, Q7B Command) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTWIDGET(self))){ Q7B_EXCEPTION("QListWidget expected"); return ; }

  if (Q7B_nil(Q7B_QLISTWIDGETITEM(Item))){ Q7B_EXCEPTION("QListWidgetItem expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Command))){ Q7B_EXCEPTION("QItemSelectionModel.SelectionFlags expected"); return ; }

  Q7B_IDQListWidget(self)->setCurrentItem(&Q7B_IDQListWidgetItem(Item), (QItemSelectionModel::SelectionFlag) Q7B_IDqint64(Command));
}

void Q7B_QMAINWINDOW_ADDDOCKWIDGET2(Q7B self, Q7B Area, Q7B DockWidget, Q7B Orientation) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Area))){ Q7B_EXCEPTION("Qt.DockWidgetArea expected"); return ; }

  if (Q7B_nil(Q7B_QDOCKWIDGET(DockWidget))){ Q7B_EXCEPTION("QDockWidget expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Orientation))){ Q7B_EXCEPTION("Qt.Orientation expected"); return ; }

  Q7B_IDQMainWindow(self)->addDockWidget((Qt::DockWidgetArea) Q7B_IDqint64(Area), Q7B_IDQDockWidget(DockWidget), (Qt::Orientation) Q7B_IDqint64(Orientation));
}

void Q7B_QMAINWINDOW_ADDTOOLBAR2(Q7B self, Q7B ToolBar) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMAINWINDOW(self))){ Q7B_EXCEPTION("QMainWindow expected"); return ; }

  if (Q7B_nil(Q7B_QTOOLBAR(ToolBar))){ Q7B_EXCEPTION("QToolBar expected"); return ; }

  Q7B_IDQMainWindow(self)->addToolBar(Q7B_IDQToolBar(ToolBar));
}

void Q7B_QPAINTER_DRAWELLIPSE2(Q7B self, Q7B Center, Q7B Rx, Q7B Ry) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Center))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Rx))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Ry))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).drawEllipse(Q7B_IDQPoint(Center), Q7B_IDqint64(Rx), Q7B_IDqint64(Ry));
}

void Q7B_QPAINTER_DRAWIMAGE2(Q7B self, Q7B Point, Q7B Image) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Point))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  if (Q7B_nil(Q7B_QIMAGE(Image))){ Q7B_EXCEPTION("QImage expected"); return ; }

  Q7B_IDQPainter(self).drawImage(Q7B_IDQPoint(Point), Q7B_IDQImage(Image));
}

void Q7B_QPAINTER_DRAWLINE2(Q7B self, Q7B P1, Q7B P2) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(P1))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(P2))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQPainter(self).drawLine(Q7B_IDQPoint(P1), Q7B_IDQPoint(P2));
}

void Q7B_QPAINTER_DRAWPICTURE2(Q7B self, Q7B Point, Q7B Picture) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Point))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  if (Q7B_nil(Q7B_QPICTURE(Picture))){ Q7B_EXCEPTION("QPicture expected"); return ; }

  Q7B_IDQPainter(self).drawPicture(Q7B_IDQPoint(Point), Q7B_IDQPicture(Picture));
}

void Q7B_QPAINTER_DRAWPIXMAP2(Q7B self, Q7B Target, Q7B Pixmap, Q7B Source) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Target))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPIXMAP(Pixmap))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Source))){ Q7B_EXCEPTION("QRect expected"); return ; }

  Q7B_IDQPainter(self).drawPixmap(Q7B_IDQRect(Target), Q7B_IDQPixmap(Pixmap), Q7B_IDQRect(Source));
}

void Q7B_QPAINTER_DRAWPIXMAP3(Q7B self, Q7B Point, Q7B Pixmap, Q7B Source) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Point))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  if (Q7B_nil(Q7B_QPIXMAP(Pixmap))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Source))){ Q7B_EXCEPTION("QRect expected"); return ; }

  Q7B_IDQPainter(self).drawPixmap(Q7B_IDQPoint(Point), Q7B_IDQPixmap(Pixmap), Q7B_IDQRect(Source));
}

void Q7B_QPAINTER_DRAWPIXMAP4(Q7B self, Q7B Rectangle, Q7B Pixmap) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPIXMAP(Pixmap))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  Q7B_IDQPainter(self).drawPixmap(Q7B_IDQRect(Rectangle), Q7B_IDQPixmap(Pixmap));
}

void Q7B_QPAINTER_DRAWPOINT2(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQPainter(self).drawPoint(Q7B_IDQPoint(Position));
}

void Q7B_QPAINTER_DRAWTEXT2(Q7B self, Q7B Position, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQPainter(self).drawText(Q7B_IDQPoint(Position), Q7B_IDQString(Text));
}

void Q7B_QPAINTER_FILLRECT2(Q7B self, Q7B Rectangle, Q7B Brush) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QBRUSH(Brush))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  Q7B_IDQPainter(self).fillRect(Q7B_IDQRect(Rectangle), Q7B_IDQBrush(Brush));
}

void Q7B_QPAINTER_FILLRECT3(Q7B self, Q7B Rectangle, Q7B Color) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QCOLOR(Color))){ Q7B_EXCEPTION("QColor expected"); return ; }

  Q7B_IDQPainter(self).fillRect(Q7B_IDQRect(Rectangle), Q7B_IDQColor(Color));
}

void Q7B_QPAINTER_FILLRECT4(Q7B self, Q7B Rectangle, Q7B Color) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Color))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).fillRect(Q7B_IDQRect(Rectangle), (Qt::GlobalColor) Q7B_IDqint64(Color));
}

void Q7B_QPAINTER_SETBRUSH2(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).setBrush((Qt::BrushStyle) Q7B_IDqint64(Style));
}

void Q7B_QPAINTER_SETBRUSHORIGIN2(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQPainter(self).setBrushOrigin(Q7B_IDQPoint(Position));
}

void Q7B_QPAINTER_SETPEN2(Q7B self, Q7B Color) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QCOLOR(Color))){ Q7B_EXCEPTION("QColor expected"); return ; }

  Q7B_IDQPainter(self).setPen(Q7B_IDQColor(Color));
}

void Q7B_QPAINTER_SETPEN3(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPainter(self).setPen((Qt::PenStyle) Q7B_IDqint64(Style));
}

void Q7B_QPAINTER_TRANSLATE2(Q7B self, Q7B Offset) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPAINTER(self))){ Q7B_EXCEPTION("QPainter expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Offset))){ Q7B_EXCEPTION("Point expected"); return ; }

  Q7B_IDQPainter(self).translate(Q7B_IDQPoint(Offset));
}

Q7B Q7B_QPEN_BRUSH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPen(self).brush() );
}

Q7B Q7B_QPEN_CAPSTYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPen(self).capStyle() );
}

Q7B Q7B_QPEN_COLOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPen(self).color() );
}

Q7B Q7B_QPEN_DASHOFFSET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPen(self).dashOffset() );
}

Q7B Q7B_QPEN_ISCOSMETIC(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPen(self).isCosmetic() );
}

Q7B Q7B_QPEN_ISSOLID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPen(self).isSolid() );
}

Q7B Q7B_QPEN_JOINSTYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPen(self).joinStyle() );
}

Q7B Q7B_QPEN_MITERLIMIT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPen(self).miterLimit() );
}

void Q7B_QPEN_SETBRUSH(Q7B self, Q7B Brush) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return ; }

  if (Q7B_nil(Q7B_QBRUSH(Brush))){ Q7B_EXCEPTION("QBrush expected"); return ; }

  Q7B_IDQPen(self).setBrush(Q7B_IDQBrush(Brush));
}

void Q7B_QPEN_SETCAPSTYLE(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPen(self).setCapStyle((Qt::PenCapStyle) Q7B_IDqint64(Style));
}

void Q7B_QPEN_SETCOLOR(Q7B self, Q7B Color) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return ; }

  if (Q7B_nil(Q7B_QCOLOR(Color))){ Q7B_EXCEPTION("QColor expected"); return ; }

  Q7B_IDQPen(self).setColor(Q7B_IDQColor(Color));
}

void Q7B_QPEN_SETCOSMETIC(Q7B self, Q7B Cosmetic) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Cosmetic))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQPen(self).setCosmetic(Q7B_IDbool(Cosmetic));
}

void Q7B_QPEN_SETDASHOFFSET(Q7B self, Q7B Offset) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Offset))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQPen(self).setDashOffset(Q7B_IDqreal(Offset));
}

void Q7B_QPEN_SETJOINSTYLE(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPen(self).setJoinStyle((Qt::PenJoinStyle) Q7B_IDqint64(Style));
}

void Q7B_QPEN_SETMITERLIMIT(Q7B self, Q7B Limit) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Limit))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQPen(self).setMiterLimit(Q7B_IDqreal(Limit));
}

void Q7B_QPEN_SETSTYLE(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPen(self).setStyle((Qt::PenStyle) Q7B_IDqint64(Style));
}

void Q7B_QPEN_SETWIDTH(Q7B self, Q7B Width) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPen(self).setWidth(Q7B_IDqint64(Width));
}

void Q7B_QPEN_SETWIDTHF(Q7B self, Q7B Width) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Width))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQPen(self).setWidthF(Q7B_IDqreal(Width));
}

Q7B Q7B_QPEN_STYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPen(self).style() );
}
/*
void Q7B_QPEN_SWAP(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return ; }

  if (Q7B_nil(Q7B_QPEN(Other))){ Q7B_EXCEPTION("QPen expected"); return ; }

  Q7B_IDQPen(self).swap(Q7B_IDQPen(Other));
}*/

Q7B Q7B_QPEN_WIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPen(self).width() );
}

Q7B Q7B_QPEN_WIDTHF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPEN(self))){ Q7B_EXCEPTION("QPen expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPen(self).widthF() );
}

void Q7B_QPIXMAP_SCROLL2(Q7B self, Q7B Dx, Q7B Dy, Q7B Rect, Q7B Exposed) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dx))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QRECT(Rect))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QREGION(Exposed))){ Q7B_EXCEPTION("QRegion expected"); return ; }

  Q7B_IDQPixmap(self).scroll(Q7B_IDqint64(Dx), Q7B_IDqint64(Dy), Q7B_IDQRect(Rect), &Q7B_IDQRegion(Exposed));
}

Q7B Q7B_QPIXMAP_TRANSFORMED2(Q7B self, Q7B Matrix, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPIXMAP(self))){ Q7B_EXCEPTION("QPixmap expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMATRIX(Matrix))){ Q7B_EXCEPTION("QMatrix expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPixmap(self).transformed(Q7B_IDQMatrix(Matrix), (Qt::TransformationMode) Q7B_IDqint64(Mode)) );
}

void Q7B_QPROCESS_START(Q7B self, Q7B Program, Q7B Arguments) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPROCESS(self))){ Q7B_EXCEPTION("QProcess expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Program))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Arguments))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQProcess(self).start(Q7B_IDQString(Program), Q7B_IDQStringList(Arguments));
}

void Q7B_QSIGNALMAPPER_MAP2(Q7B self, Q7B Sender) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIGNALMAPPER(self))){ Q7B_EXCEPTION("QSignalMapper expected"); return ; }

  if (Q7B_nil(Q7B_QOBJECT(Sender))){ Q7B_EXCEPTION("QObject expected"); return ; }

  Q7B_IDQSignalMapper(self)->map(Q7B_IDQObject(Sender));
}

Q7B Q7B_QSIGNALMAPPER_MAPPING2(Q7B self, Q7B theId) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIGNALMAPPER(self))){ Q7B_EXCEPTION("QSignalMapper expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(theId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSignalMapper(self)->mapping(Q7B_IDQString(theId)) );
}

Q7B Q7B_QSIGNALMAPPER_MAPPING3(Q7B self, Q7B theObject) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIGNALMAPPER(self))){ Q7B_EXCEPTION("QSignalMapper expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QOBJECT(theObject))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSignalMapper(self)->mapping(Q7B_IDQObject(theObject)) );
}

void Q7B_QSIGNALMAPPER_SETMAPPING2(Q7B self, Q7B Sender, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIGNALMAPPER(self))){ Q7B_EXCEPTION("QSignalMapper expected"); return ; }

  if (Q7B_nil(Q7B_QOBJECT(Sender))){ Q7B_EXCEPTION("QObject expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQSignalMapper(self)->setMapping(Q7B_IDQObject(Sender), Q7B_IDQString(Text));
}

void Q7B_QSIGNALMAPPER_SETMAPPING3(Q7B self, Q7B Sender, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIGNALMAPPER(self))){ Q7B_EXCEPTION("QSignalMapper expected"); return ; }

  if (Q7B_nil(Q7B_QOBJECT(Sender))){ Q7B_EXCEPTION("QObject expected"); return ; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return ; }

  Q7B_IDQSignalMapper(self)->setMapping(Q7B_IDQObject(Sender), Q7B_IDQWidget(Widget));
}

void Q7B_QSIGNALMAPPER_SETMAPPING4(Q7B self, Q7B Sender, Q7B theObject) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIGNALMAPPER(self))){ Q7B_EXCEPTION("QSignalMapper expected"); return ; }

  if (Q7B_nil(Q7B_QOBJECT(Sender))){ Q7B_EXCEPTION("QObject expected"); return ; }

  if (Q7B_nil(Q7B_QOBJECT(theObject))){ Q7B_EXCEPTION("QObject expected"); return ; }

  Q7B_IDQSignalMapper(self)->setMapping(Q7B_IDQObject(Sender), Q7B_IDQObject(theObject));
}

void Q7B_QSIZE_SCALE2(Q7B self, Q7B Size, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZE(self))){ Q7B_EXCEPTION("QSize expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSize(self).scale(Q7B_IDQSize(Size), (Qt::AspectRatioMode) Q7B_IDqint64(Mode));
}

void Q7B_QCLIPBOARD_CLEAR(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQClipboard(self)->clear((QClipboard::Mode) Q7B_IDqint64(Mode));
}

Q7B Q7B_QCLIPBOARD_IMAGE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQClipboard(self)->image((QClipboard::Mode) Q7B_IDqint64(Mode)) );
}

Q7B Q7B_QCLIPBOARD_MIMEDATA(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQClipboard(self)->mimeData((QClipboard::Mode) Q7B_IDqint64(Mode)) );
}

Q7B Q7B_QCLIPBOARD_OWNSCLIPBOARD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQClipboard(self)->ownsClipboard() );
}

Q7B Q7B_QCLIPBOARD_OWNSFINDBUFFER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQClipboard(self)->ownsFindBuffer() );
}

Q7B Q7B_QCLIPBOARD_OWNSSELECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQClipboard(self)->ownsSelection() );
}

Q7B Q7B_QCLIPBOARD_PIXMAP(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQClipboard(self)->pixmap((QClipboard::Mode) Q7B_IDqint64(Mode)) );
}

void Q7B_QCLIPBOARD_SETIMAGE(Q7B self, Q7B Image, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return ; }

  if (Q7B_nil(Q7B_QIMAGE(Image))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQClipboard(self)->setImage(Q7B_IDQImage(Image), (QClipboard::Mode) Q7B_IDqint64(Mode));
}

void Q7B_QCLIPBOARD_SETMIMEDATA(Q7B self, Q7B Src, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return ; }

  if (Q7B_nil(Q7B_QMIMEDATA(Src))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQClipboard(self)->setMimeData(Q7B_IDQMimeData(Src), (QClipboard::Mode) Q7B_IDqint64(Mode));
}

void Q7B_QCLIPBOARD_SETPIXMAP(Q7B self, Q7B Pixmap, Q7B a1) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return ; }

  if (Q7B_nil(Q7B_QPIXMAP(Pixmap))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(a1))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQClipboard(self)->setPixmap(Q7B_IDQPixmap(Pixmap), (QClipboard::Mode) Q7B_IDqint64(a1));
}

void Q7B_QCLIPBOARD_SETTEXT(Q7B self, Q7B Text, Q7B a1) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(a1))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQClipboard(self)->setText(Q7B_IDQString(Text), (QClipboard::Mode) Q7B_IDqint64(a1));
}

Q7B Q7B_QCLIPBOARD_SUPPORTSFINDBUFFER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQClipboard(self)->supportsFindBuffer() );
}

Q7B Q7B_QCLIPBOARD_TEXT(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQClipboard(self)->text((QClipboard::Mode) Q7B_IDqint64(Mode)) );
}

Q7B Q7B_QCLIPBOARD_TEXT2(Q7B self, Q7B SubType, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCLIPBOARD(self))){ Q7B_EXCEPTION("QClipboard expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(SubType))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQClipboard(self)->text(Q7B_IDQString(SubType), (QClipboard::Mode) Q7B_IDqint64(Mode)) );
}

Q7B Q7B_QDRAG_EXEC(Q7B self, Q7B SupportedActions) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDRAG(self))){ Q7B_EXCEPTION("QDrag expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(SupportedActions))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDrag(self)->exec((Qt::DropActions) Q7B_IDqint64(SupportedActions)) );
}

Q7B Q7B_QDRAG_EXEC2(Q7B self, Q7B SupportedActions, Q7B DefaultDropAction) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDRAG(self))){ Q7B_EXCEPTION("QDrag expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(SupportedActions))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(DefaultDropAction))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDrag(self)->exec((Qt::DropActions) Q7B_IDqint64(SupportedActions), (Qt::DropAction) Q7B_IDqint64(DefaultDropAction)) );
}

Q7B Q7B_QDRAG_HOTSPOT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDRAG(self))){ Q7B_EXCEPTION("QDrag expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDrag(self)->hotSpot() );
}

Q7B Q7B_QDRAG_MIMEDATA(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDRAG(self))){ Q7B_EXCEPTION("QDrag expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDrag(self)->mimeData() );
}

Q7B Q7B_QDRAG_PIXMAP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDRAG(self))){ Q7B_EXCEPTION("QDrag expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDrag(self)->pixmap() );
}

void Q7B_QDRAG_SETDRAGCURSOR(Q7B self, Q7B Cursor, Q7B Action) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDRAG(self))){ Q7B_EXCEPTION("QDrag expected"); return ; }

  if (Q7B_nil(Q7B_QPIXMAP(Cursor))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Action))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQDrag(self)->setDragCursor(Q7B_IDQPixmap(Cursor), (Qt::DropAction) Q7B_IDqint64(Action));
}

void Q7B_QDRAG_SETHOTSPOT(Q7B self, Q7B Hotspot) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDRAG(self))){ Q7B_EXCEPTION("QDrag expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Hotspot))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQDrag(self)->setHotSpot(Q7B_IDQPoint(Hotspot));
}

void Q7B_QDRAG_SETMIMEDATA(Q7B self, Q7B Data) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDRAG(self))){ Q7B_EXCEPTION("QDrag expected"); return ; }

  if (Q7B_nil(Q7B_QMIMEDATA(Data))){ Q7B_EXCEPTION("QMimeData expected"); return ; }

  Q7B_IDQDrag(self)->setMimeData(Q7B_IDQMimeData(Data));
}

void Q7B_QDRAG_SETPIXMAP(Q7B self, Q7B Pixmap) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDRAG(self))){ Q7B_EXCEPTION("QDrag expected"); return ; }

  if (Q7B_nil(Q7B_QPIXMAP(Pixmap))){ Q7B_EXCEPTION("QPixmap expected"); return ; }

  Q7B_IDQDrag(self)->setPixmap(Q7B_IDQPixmap(Pixmap));
}

Q7B Q7B_QDRAG_SOURCE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDRAG(self))){ Q7B_EXCEPTION("QDrag expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDrag(self)->source() );
}

Q7B Q7B_QDRAG_TARGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDRAG(self))){ Q7B_EXCEPTION("QDrag expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDrag(self)->target() );
}

Q7B Q7B_QFONTDATABASE_BOLD(Q7B self, Q7B Family, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTDATABASE(self))){ Q7B_EXCEPTION("QFontDatabase expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Family))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Style))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontDatabase(self).bold(Q7B_IDQString(Family), Q7B_IDQString(Style)) );
}

Q7B Q7B_QFONTDATABASE_FAMILIES(Q7B self, Q7B WritingSystem) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTDATABASE(self))){ Q7B_EXCEPTION("QFontDatabase expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(WritingSystem))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontDatabase(self).families((QFontDatabase::WritingSystem) Q7B_IDqint64(WritingSystem)) );
}

Q7B Q7B_QFONTDATABASE_FONT(Q7B self, Q7B Family, Q7B Style, Q7B PointSize) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTDATABASE(self))){ Q7B_EXCEPTION("QFontDatabase expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Family))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Style))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(PointSize))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontDatabase(self).font(Q7B_IDQString(Family), Q7B_IDQString(Style), Q7B_IDqint64(PointSize)) );
}

Q7B Q7B_QFONTDATABASE_ISBITMAPSCALABLE(Q7B self, Q7B Family, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTDATABASE(self))){ Q7B_EXCEPTION("QFontDatabase expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Family))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Style))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontDatabase(self).isBitmapScalable(Q7B_IDQString(Family), Q7B_IDQString(Style)) );
}

Q7B Q7B_QFONTDATABASE_ISFIXEDPITCH(Q7B self, Q7B Family, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTDATABASE(self))){ Q7B_EXCEPTION("QFontDatabase expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Family))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Style))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontDatabase(self).isFixedPitch(Q7B_IDQString(Family), Q7B_IDQString(Style)) );
}

Q7B Q7B_QFONTDATABASE_ISSCALABLE(Q7B self, Q7B Family, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTDATABASE(self))){ Q7B_EXCEPTION("QFontDatabase expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Family))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Style))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontDatabase(self).isScalable(Q7B_IDQString(Family), Q7B_IDQString(Style)) );
}

Q7B Q7B_QFONTDATABASE_ISSMOOTHLYSCALABLE(Q7B self, Q7B Family, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTDATABASE(self))){ Q7B_EXCEPTION("QFontDatabase expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Family))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Style))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontDatabase(self).isSmoothlyScalable(Q7B_IDQString(Family), Q7B_IDQString(Style)) );
}

Q7B Q7B_QFONTDATABASE_ITALIC(Q7B self, Q7B Family, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTDATABASE(self))){ Q7B_EXCEPTION("QFontDatabase expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Family))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Style))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontDatabase(self).italic(Q7B_IDQString(Family), Q7B_IDQString(Style)) );
}

Q7B Q7B_QFONTDATABASE_STYLESTRING(Q7B self, Q7B Font) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTDATABASE(self))){ Q7B_EXCEPTION("QFontDatabase expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QFONT(Font))){ Q7B_EXCEPTION("QFont expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontDatabase(self).styleString(Q7B_IDQFont(Font)) );
}

Q7B Q7B_QFONTDATABASE_STYLESTRING2(Q7B self, Q7B FontInfo) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTDATABASE(self))){ Q7B_EXCEPTION("QFontDatabase expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QFONTINFO(FontInfo))){ Q7B_EXCEPTION("QFontInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontDatabase(self).styleString(Q7B_IDQFontInfo(FontInfo)) );
}

Q7B Q7B_QFONTDATABASE_STYLES(Q7B self, Q7B Family) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTDATABASE(self))){ Q7B_EXCEPTION("QFontDatabase expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Family))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontDatabase(self).styles(Q7B_IDQString(Family)) );
}

Q7B Q7B_QFONTDATABASE_WEIGHT(Q7B self, Q7B Family, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTDATABASE(self))){ Q7B_EXCEPTION("QFontDatabase expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Family))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Style))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontDatabase(self).weight(Q7B_IDQString(Family), Q7B_IDQString(Style)) );
}

Q7B Q7B_QFONTMETRICS_WIDTH2(Q7B self, Q7B Ch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFONTMETRICS(self))){ Q7B_EXCEPTION("QFontMetrics expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Ch))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFontMetrics(self).width(Q7B_IDQString(Ch)) );
}

void Q7B_QFTP_ABORT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return ; }

  Q7B_IDQFtp(self)->abort();
}

Q7B Q7B_QFTP_BYTESAVAILABLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->bytesAvailable() );
}

Q7B Q7B_QFTP_CD(Q7B self, Q7B Dir) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Dir))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->cd(Q7B_IDQString(Dir)) );
}

void Q7B_QFTP_CLEARPENDINGCOMMANDS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return ; }

  Q7B_IDQFtp(self)->clearPendingCommands();
}

Q7B Q7B_QFTP_CLOSE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->close() );
}

Q7B Q7B_QFTP_CONNECTTOHOST(Q7B self, Q7B Host, Q7B Port) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Port))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->connectToHost(Q7B_IDQString(Host), Q7B_IDqint64(Port)) );
}

Q7B Q7B_QFTP_CURRENTCOMMAND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->currentCommand() );
}

Q7B Q7B_QFTP_CURRENTDEVICE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->currentDevice() );
}

Q7B Q7B_QFTP_CURRENTID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->currentId() );
}

Q7B Q7B_QFTP_ERROR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->error() );
}

Q7B Q7B_QFTP_ERRORSTRING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->errorString() );
}

Q7B Q7B_QFTP_HASPENDINGCOMMANDS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->hasPendingCommands() );
}

Q7B Q7B_QFTP_LIST(Q7B self, Q7B Dir) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Dir))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->list(Q7B_IDQString(Dir)) );
}

Q7B Q7B_QFTP_LOGIN(Q7B self, Q7B User, Q7B Password) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->login(Q7B_IDQString(User), Q7B_IDQString(Password)) );
}

Q7B Q7B_QFTP_MKDIR(Q7B self, Q7B Dir) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Dir))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->mkdir(Q7B_IDQString(Dir)) );
}

Q7B Q7B_QFTP_PUT(Q7B self, Q7B Data, Q7B File, Q7B Type) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Data))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(File))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Type))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->put(Q7B_IDQByteArray(Data), Q7B_IDQString(File), (QFtp::TransferType) Q7B_IDqint64(Type)) );
}

Q7B Q7B_QFTP_RAWCOMMAND(Q7B self, Q7B Command) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Command))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->rawCommand(Q7B_IDQString(Command)) );
}

Q7B Q7B_QFTP_READALL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->readAll() );
}

Q7B Q7B_QFTP_REMOVE(Q7B self, Q7B File) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(File))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->remove(Q7B_IDQString(File)) );
}

Q7B Q7B_QFTP_RENAME(Q7B self, Q7B OldName, Q7B NewName) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(OldName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(NewName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->rename(Q7B_IDQString(OldName), Q7B_IDQString(NewName)) );
}

Q7B Q7B_QFTP_RMDIR(Q7B self, Q7B Dir) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Dir))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->rmdir(Q7B_IDQString(Dir)) );
}

Q7B Q7B_QFTP_SETPROXY(Q7B self, Q7B Host, Q7B Port) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Port))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->setProxy(Q7B_IDQString(Host), Q7B_IDqint64(Port)) );
}

Q7B Q7B_QFTP_SETTRANSFERMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->setTransferMode((QFtp::TransferMode) Q7B_IDqint64(Mode)) );
}

Q7B Q7B_QFTP_STATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFTP(self))){ Q7B_EXCEPTION("QFtp expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFtp(self)->state() );
}

void Q7B_QHOSTADDRESS_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHOSTADDRESS(self))){ Q7B_EXCEPTION("QHostAddress expected"); return ; }

  Q7B_IDQHostAddress(self).clear();
}

Q7B Q7B_QHOSTADDRESS_ISINSUBNET(Q7B self, Q7B SubNet, Q7B NetMask) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHOSTADDRESS(self))){ Q7B_EXCEPTION("QHostAddress expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QHOSTADDRESS(SubNet))){ Q7B_EXCEPTION("QHostAddress expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(NetMask))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHostAddress(self).isInSubnet(Q7B_IDQHostAddress(SubNet), Q7B_IDqint64(NetMask)) );
}

Q7B Q7B_QHOSTADDRESS_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHOSTADDRESS(self))){ Q7B_EXCEPTION("QHostAddress expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHostAddress(self).isNull() );
}

Q7B Q7B_QHOSTADDRESS_PROTOCOL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHOSTADDRESS(self))){ Q7B_EXCEPTION("QHostAddress expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHostAddress(self).protocol() );
}

Q7B Q7B_QHOSTADDRESS_SCOPEID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHOSTADDRESS(self))){ Q7B_EXCEPTION("QHostAddress expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHostAddress(self).scopeId() );
}

void Q7B_QHOSTADDRESS_SETADDRESS(Q7B self, Q7B Address) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHOSTADDRESS(self))){ Q7B_EXCEPTION("QHostAddress expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Address))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQHostAddress(self).setAddress(Q7B_IDQString(Address));
}

void Q7B_QHOSTADDRESS_SETSCOPEID(Q7B self, Q7B Id) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QHOSTADDRESS(self))){ Q7B_EXCEPTION("QHostAddress expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Id))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQHostAddress(self).setScopeId(Q7B_IDQString(Id));
}

Q7B Q7B_QHOSTADDRESS_TOSTRING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHOSTADDRESS(self))){ Q7B_EXCEPTION("QHostAddress expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHostAddress(self).toString() );
}

Q7B Q7B_QLINE_DX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLine(self).dx() );
}

Q7B Q7B_QLINE_DY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLine(self).dy() );
}

Q7B Q7B_QLINE_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLine(self).isNull() );
}

Q7B Q7B_QLINE_P1(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLine(self).p1() );
}

Q7B Q7B_QLINE_P2(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLine(self).p2() );
}

void Q7B_QLINE_SETLINE(Q7B self, Q7B X1, Q7B Y1, Q7B X2, Q7B Y2) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X1))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y1))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X2))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y2))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLine(self).setLine(Q7B_IDqint64(X1), Q7B_IDqint64(Y1), Q7B_IDqint64(X2), Q7B_IDqint64(Y2));
}

void Q7B_QLINE_SETP1(Q7B self, Q7B P1) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(P1))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQLine(self).setP1(Q7B_IDQPoint(P1));
}

void Q7B_QLINE_SETP2(Q7B self, Q7B P2) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(P2))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQLine(self).setP2(Q7B_IDQPoint(P2));
}

void Q7B_QLINE_SETPOINTS(Q7B self, Q7B P1, Q7B P2) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(P1))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(P2))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQLine(self).setPoints(Q7B_IDQPoint(P1), Q7B_IDQPoint(P2));
}

void Q7B_QLINE_TRANSLATE(Q7B self, Q7B Dx, Q7B Dy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dx))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLine(self).translate(Q7B_IDqint64(Dx), Q7B_IDqint64(Dy));
}

void Q7B_QLINE_TRANSLATE2(Q7B self, Q7B Offset) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Offset))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQLine(self).translate(Q7B_IDQPoint(Offset));
}

Q7B Q7B_QLINE_TRANSLATED(Q7B self, Q7B Dx, Q7B Dy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Dx))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Dy))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLine(self).translated(Q7B_IDqint64(Dx), Q7B_IDqint64(Dy)) );
}

Q7B Q7B_QLINE_TRANSLATED2(Q7B self, Q7B Offset) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Offset))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLine(self).translated(Q7B_IDQPoint(Offset)) );
}

Q7B Q7B_QLINE_X1(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLine(self).x1() );
}

Q7B Q7B_QLINE_X2(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLine(self).x2() );
}

Q7B Q7B_QLINE_Y1(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLine(self).y1() );
}

Q7B Q7B_QLINE_Y2(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLINE(self))){ Q7B_EXCEPTION("QLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLine(self).y2() );
}

void Q7B_QLOCALSERVER_CLOSE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLOCALSERVER(self))){ Q7B_EXCEPTION("QLocalServer expected"); return ; }

  Q7B_IDQLocalServer(self)->close();
}

Q7B Q7B_QLOCALSERVER_ERRORSTRING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSERVER(self))){ Q7B_EXCEPTION("QLocalServer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalServer(self)->errorString() );
}

Q7B Q7B_QLOCALSERVER_FULLSERVERNAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSERVER(self))){ Q7B_EXCEPTION("QLocalServer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalServer(self)->fullServerName() );
}

Q7B Q7B_QLOCALSERVER_HASPENDINGCONNECTIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSERVER(self))){ Q7B_EXCEPTION("QLocalServer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalServer(self)->hasPendingConnections() );
}

Q7B Q7B_QLOCALSERVER_ISLISTENING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSERVER(self))){ Q7B_EXCEPTION("QLocalServer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalServer(self)->isListening() );
}

Q7B Q7B_QLOCALSERVER_LISTEN(Q7B self, Q7B Name) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSERVER(self))){ Q7B_EXCEPTION("QLocalServer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalServer(self)->listen(Q7B_IDQString(Name)) );
}

Q7B Q7B_QLOCALSERVER_MAXPENDINGCONNECTIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSERVER(self))){ Q7B_EXCEPTION("QLocalServer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalServer(self)->maxPendingConnections() );
}

Q7B Q7B_QLOCALSERVER_NEXTPENDINGCONNECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSERVER(self))){ Q7B_EXCEPTION("QLocalServer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalServer(self)->nextPendingConnection() );
}

Q7B Q7B_QLOCALSERVER_SERVERERROR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSERVER(self))){ Q7B_EXCEPTION("QLocalServer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalServer(self)->serverError() );
}

Q7B Q7B_QLOCALSERVER_SERVERNAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSERVER(self))){ Q7B_EXCEPTION("QLocalServer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalServer(self)->serverName() );
}

void Q7B_QLOCALSERVER_SETMAXPENDINGCONNECTIONS(Q7B self, Q7B NumConnections) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLOCALSERVER(self))){ Q7B_EXCEPTION("QLocalServer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(NumConnections))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLocalServer(self)->setMaxPendingConnections(Q7B_IDqint64(NumConnections));
}

Q7B Q7B_QLOCALSERVER_WAITFORNEWCONNECTION(Q7B self, Q7B MSec, Q7B TimedOut) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSERVER(self))){ Q7B_EXCEPTION("QLocalServer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(MSec))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(TimedOut))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  bool b = false;

  bool bb = Q7B_IDQLocalServer(self)->waitForNewConnection(Q7B_IDqint64(MSec), &b);

  *((bool *) (TimedOut->ref)) = b;

  return Q7B_ID(bb);
}

void Q7B_QLOCALSOCKET_ABORT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return ; }

  Q7B_IDQLocalSocket(self).abort();
}

void Q7B_QLOCALSOCKET_CONNECTTOSERVER(Q7B self, Q7B Name, Q7B OpenMode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(OpenMode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLocalSocket(self).connectToServer(Q7B_IDQString(Name), (QLocalSocket::OpenMode) Q7B_IDqint64(OpenMode));
}

void Q7B_QLOCALSOCKET_DISCONNECTFROMSERVER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return ; }

  Q7B_IDQLocalSocket(self).disconnectFromServer();
}

Q7B Q7B_QLOCALSOCKET_FLUSH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalSocket(self).flush() );
}

Q7B Q7B_QLOCALSOCKET_FULLSERVERNAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalSocket(self).fullServerName() );
}

Q7B Q7B_QLOCALSOCKET_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalSocket(self).isValid() );
}

Q7B Q7B_QLOCALSOCKET_READBUFFERSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalSocket(self).readBufferSize() );
}

Q7B Q7B_QLOCALSOCKET_SERVERNAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalSocket(self).serverName() );
}

void Q7B_QLOCALSOCKET_SETREADBUFFERSIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Size))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQLocalSocket(self).setReadBufferSize(Q7B_IDqint64(Size));
}

Q7B Q7B_QLOCALSOCKET_SETSOCKETDESCRIPTOR(Q7B self, Q7B SocketDescriptor, Q7B SocketState, Q7B OpenMode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(SocketDescriptor))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(SocketState))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(OpenMode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalSocket(self).setSocketDescriptor(Q7B_IDqint64(SocketDescriptor), (QLocalSocket::LocalSocketState) Q7B_IDqint64(SocketState), (QLocalSocket::OpenMode) Q7B_IDqint64(OpenMode)) );
}

Q7B Q7B_QLOCALSOCKET_SOCKETDESCRIPTOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalSocket(self).socketDescriptor() );
}

Q7B Q7B_QLOCALSOCKET_STATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalSocket(self).state() );
}

Q7B Q7B_QLOCALSOCKET_WAITFORCONNECTED(Q7B self, Q7B MSecs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(MSecs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalSocket(self).waitForConnected(Q7B_IDqint64(MSecs)) );
}

Q7B Q7B_QLOCALSOCKET_WAITFORDISCONNECTED(Q7B self, Q7B MSecs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLOCALSOCKET(self))){ Q7B_EXCEPTION("QLocalSocket expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(MSecs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQLocalSocket(self).waitForDisconnected(Q7B_IDqint64(MSecs)) );
}

void Q7B_QMIMEDATA_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return ; }

  Q7B_IDQMimeData(self)->clear();
}

Q7B Q7B_QMIMEDATA_COLORDATA(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMimeData(self)->colorData() );
}

Q7B Q7B_QMIMEDATA_DATA(Q7B self, Q7B MimeType) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(MimeType))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMimeData(self)->data(Q7B_IDQString(MimeType)) );
}

Q7B Q7B_QMIMEDATA_FORMATS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMimeData(self)->formats() );
}

Q7B Q7B_QMIMEDATA_HASCOLOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMimeData(self)->hasColor() );
}

Q7B Q7B_QMIMEDATA_HASFORMAT(Q7B self, Q7B MimeType) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(MimeType))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMimeData(self)->hasFormat(Q7B_IDQString(MimeType)) );
}

Q7B Q7B_QMIMEDATA_HASHTML(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMimeData(self)->hasHtml() );
}

Q7B Q7B_QMIMEDATA_HASIMAGE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMimeData(self)->hasImage() );
}

Q7B Q7B_QMIMEDATA_HASTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMimeData(self)->hasText() );
}

Q7B Q7B_QMIMEDATA_HASURLS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMimeData(self)->hasUrls() );
}

Q7B Q7B_QMIMEDATA_IMAGEDATA(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMimeData(self)->imageData() );
}

void Q7B_QMIMEDATA_REMOVEFORMAT(Q7B self, Q7B MimeType) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(MimeType))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQMimeData(self)->removeFormat(Q7B_IDQString(MimeType));
}

void Q7B_QMIMEDATA_SETCOLORDATA(Q7B self, Q7B Color) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return ; }

  if (Q7B_nil(Q7B_QVARIANT(Color))){ Q7B_EXCEPTION("QVariant expected"); return ; }

  Q7B_IDQMimeData(self)->setColorData(Q7B_IDQVariant(Color));
}

void Q7B_QMIMEDATA_SETDATA(Q7B self, Q7B MimeType, Q7B Data) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(MimeType))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Data))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQMimeData(self)->setData(Q7B_IDQString(MimeType), Q7B_IDQByteArray(Data));
}

void Q7B_QMIMEDATA_SETHTML(Q7B self, Q7B Html) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Html))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQMimeData(self)->setHtml(Q7B_IDQString(Html));
}

void Q7B_QMIMEDATA_SETIMAGEDATA(Q7B self, Q7B Image) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return ; }

  if (Q7B_nil(Q7B_QVARIANT(Image))){ Q7B_EXCEPTION("QVariant expected"); return ; }

  Q7B_IDQMimeData(self)->setImageData(Q7B_IDQVariant(Image));
}

void Q7B_QMIMEDATA_SETTEXT(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQMimeData(self)->setText(Q7B_IDQString(Text));
}

Q7B Q7B_QMIMEDATA_TEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMIMEDATA(self))){ Q7B_EXCEPTION("QMimeData expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMimeData(self)->text() );
}

void Q7B_QNETWORKSESSION_ACCEPT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return ; }

  Q7B_IDQNetworkSession(self)->accept();
}

Q7B Q7B_QNETWORKSESSION_ACTIVETIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQNetworkSession(self)->activeTime() );
}

Q7B Q7B_QNETWORKSESSION_BYTESRECEIVED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQNetworkSession(self)->bytesReceived() );
}

Q7B Q7B_QNETWORKSESSION_BYTESWRITTEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQNetworkSession(self)->bytesWritten() );
}

void Q7B_QNETWORKSESSION_CLOSE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return ; }

  Q7B_IDQNetworkSession(self)->close();
}

Q7B Q7B_QNETWORKSESSION_ERRORSTRING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQNetworkSession(self)->errorString() );
}

void Q7B_QNETWORKSESSION_IGNORE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return ; }

  Q7B_IDQNetworkSession(self)->ignore();
}

Q7B Q7B_QNETWORKSESSION_ISOPEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQNetworkSession(self)->isOpen() );
}

void Q7B_QNETWORKSESSION_MIGRATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return ; }

  Q7B_IDQNetworkSession(self)->migrate();
}

void Q7B_QNETWORKSESSION_OPEN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return ; }

  Q7B_IDQNetworkSession(self)->open();
}

void Q7B_QNETWORKSESSION_REJECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return ; }

  Q7B_IDQNetworkSession(self)->reject();
}

Q7B Q7B_QNETWORKSESSION_SESSIONPROPERTY(Q7B self, Q7B Key) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Key))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQNetworkSession(self)->sessionProperty(Q7B_IDQString(Key)) );
}

void Q7B_QNETWORKSESSION_SETSESSIONPROPERTY(Q7B self, Q7B Key, Q7B Value) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Key))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QVARIANT(Value))){ Q7B_EXCEPTION("QVariant expected"); return ; }

  Q7B_IDQNetworkSession(self)->setSessionProperty(Q7B_IDQString(Key), Q7B_IDQVariant(Value));
}

Q7B Q7B_QNETWORKSESSION_STATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQNetworkSession(self)->state() );
}

void Q7B_QNETWORKSESSION_STOP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return ; }

  Q7B_IDQNetworkSession(self)->stop();
}

Q7B Q7B_QNETWORKSESSION_WAITFOROPENED(Q7B self, Q7B MSecs) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QNETWORKSESSION(self))){ Q7B_EXCEPTION("QNetworkSession expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(MSecs))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQNetworkSession(self)->waitForOpened(Q7B_IDqint64(MSecs)) );
}

Q7B Q7B_QREGEXPVALIDATOR_REGEXP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGEXPVALIDATOR(self))){ Q7B_EXCEPTION("QRegExpValidator expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegExpValidator(self)->regExp() );
}

void Q7B_QREGEXPVALIDATOR_SETREGEXP(Q7B self, Q7B Rx) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QREGEXPVALIDATOR(self))){ Q7B_EXCEPTION("QRegExpValidator expected"); return ; }

  if (Q7B_nil(Q7B_QREGEXP(Rx))){ Q7B_EXCEPTION("QRegExp expected"); return ; }

  Q7B_IDQRegExpValidator(self)->setRegExp(Q7B_IDQRegExp(Rx));
}

Q7B Q7B_QREGION_INTERSECTED2(Q7B self, Q7B Rect) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QRECT(Rect))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).intersected(Q7B_IDQRect(Rect)) );
}

Q7B Q7B_QREGION_INTERSECTS2(Q7B self, Q7B Rect) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QRECT(Rect))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).intersects(Q7B_IDQRect(Rect)) );
}

void Q7B_QREGION_TRANSLATE2(Q7B self, Q7B Point) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Point))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRegion(self).translate(Q7B_IDQPoint(Point));
}

Q7B Q7B_QREGION_TRANSLATED2(Q7B self, Q7B Point) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Point))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).translated(Q7B_IDQPoint(Point)) );
}

Q7B Q7B_QREGION_UNITED2(Q7B self, Q7B Rect) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QREGION(self))){ Q7B_EXCEPTION("QRegion expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QRECT(Rect))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRegion(self).united(Q7B_IDQRect(Rect)) );
}

Q7B Q7B_QRESOURCE_FILENAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRESOURCE(self))){ Q7B_EXCEPTION("QResource expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQResource(self).fileName() );
}

Q7B Q7B_QRESOURCE_ISCOMPRESSED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRESOURCE(self))){ Q7B_EXCEPTION("QResource expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQResource(self).isCompressed() );
}

Q7B Q7B_QRESOURCE_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRESOURCE(self))){ Q7B_EXCEPTION("QResource expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQResource(self).isValid() );
}

Q7B Q7B_QRESOURCE_LOCALE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRESOURCE(self))){ Q7B_EXCEPTION("QResource expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQResource(self).locale() );
}

void Q7B_QRESOURCE_SETFILENAME(Q7B self, Q7B File) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRESOURCE(self))){ Q7B_EXCEPTION("QResource expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(File))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQResource(self).setFileName(Q7B_IDQString(File));
}

void Q7B_QRESOURCE_SETLOCALE(Q7B self, Q7B Locale) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRESOURCE(self))){ Q7B_EXCEPTION("QResource expected"); return ; }

  if (Q7B_nil(Q7B_QLOCALE(Locale))){ Q7B_EXCEPTION("QLocale expected"); return ; }

  Q7B_IDQResource(self).setLocale(Q7B_IDQLocale(Locale));
}

Q7B Q7B_QRESOURCE_SIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRESOURCE(self))){ Q7B_EXCEPTION("QResource expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQResource(self).size() );
}

void Q7B_QRUBBERBAND_MOVE(Q7B self, Q7B X, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRUBBERBAND(self))){ Q7B_EXCEPTION("QRubberBand expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRubberBand(self)->move(Q7B_IDqint64(X), Q7B_IDqint64(Y));
}

void Q7B_QRUBBERBAND_MOVE2(Q7B self, Q7B P) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRUBBERBAND(self))){ Q7B_EXCEPTION("QRubberBand expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(P))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRubberBand(self)->move(Q7B_IDQPoint(P));
}

void Q7B_QRUBBERBAND_RESIZE(Q7B self, Q7B Width, Q7B Height) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRUBBERBAND(self))){ Q7B_EXCEPTION("QRubberBand expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Height))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRubberBand(self)->resize(Q7B_IDqint64(Width), Q7B_IDqint64(Height));
}

void Q7B_QRUBBERBAND_RESIZE2(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRUBBERBAND(self))){ Q7B_EXCEPTION("QRubberBand expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQRubberBand(self)->resize(Q7B_IDQSize(Size));
}

void Q7B_QRUBBERBAND_SETGEOMETRY(Q7B self, Q7B X, Q7B Y, Q7B Width, Q7B Height) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRUBBERBAND(self))){ Q7B_EXCEPTION("QRubberBand expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Height))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRubberBand(self)->setGeometry(Q7B_IDqint64(X), Q7B_IDqint64(Y), Q7B_IDqint64(Width), Q7B_IDqint64(Height));
}

Q7B Q7B_QRUBBERBAND_SHAPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRUBBERBAND(self))){ Q7B_EXCEPTION("QRubberBand expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRubberBand(self)->shape() );
}

Q7B Q7B_QSESSIONMANAGER_ALLOWSERRORINTERACTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSessionManager(self)->allowsErrorInteraction() );
}

Q7B Q7B_QSESSIONMANAGER_ALLOWSINTERACTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSessionManager(self)->allowsInteraction() );
}

void Q7B_QSESSIONMANAGER_CANCEL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return ; }

  Q7B_IDQSessionManager(self)->cancel();
}

Q7B Q7B_QSESSIONMANAGER_DISCARDCOMMAND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSessionManager(self)->discardCommand() );
}

Q7B Q7B_QSESSIONMANAGER_ISPHASE2(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSessionManager(self)->isPhase2() );
}

void Q7B_QSESSIONMANAGER_RELEASE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return ; }

  Q7B_IDQSessionManager(self)->release();
}

void Q7B_QSESSIONMANAGER_REQUESTPHASE2(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return ; }

  Q7B_IDQSessionManager(self)->requestPhase2();
}

Q7B Q7B_QSESSIONMANAGER_RESTARTCOMMAND(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSessionManager(self)->restartCommand() );
}

Q7B Q7B_QSESSIONMANAGER_RESTARTHINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSessionManager(self)->restartHint() );
}

Q7B Q7B_QSESSIONMANAGER_SESSIONID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSessionManager(self)->sessionId() );
}

Q7B Q7B_QSESSIONMANAGER_SESSIONKEY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSessionManager(self)->sessionKey() );
}

void Q7B_QSESSIONMANAGER_SETDISCARDCOMMAND(Q7B self, Q7B List) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(List))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQSessionManager(self)->setDiscardCommand(Q7B_IDQStringList(List));
}

void Q7B_QSESSIONMANAGER_SETMANAGERPROPERTY(Q7B self, Q7B Name, Q7B Value) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQSessionManager(self)->setManagerProperty(Q7B_IDQString(Name), Q7B_IDQString(Value));
}

void Q7B_QSESSIONMANAGER_SETRESTARTCOMMAND(Q7B self, Q7B Command) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Command))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQSessionManager(self)->setRestartCommand(Q7B_IDQStringList(Command));
}

void Q7B_QSESSIONMANAGER_SETRESTARTHINT(Q7B self, Q7B Hint) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSESSIONMANAGER(self))){ Q7B_EXCEPTION("QSessionManager expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Hint))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSessionManager(self)->setRestartHint((QSessionManager::RestartHint) Q7B_IDqint64(Hint));
}

void Q7B_QSIZEGRIP_SETVISIBLE(Q7B self, Q7B Visible) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZEGRIP(self))){ Q7B_EXCEPTION("QSizeGrip expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Visible))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQSizeGrip(self)->setVisible(Q7B_IDbool(Visible));
}

Q7B Q7B_QSIZEGRIP_SIZEHINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZEGRIP(self))){ Q7B_EXCEPTION("QSizeGrip expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSizeGrip(self)->sizeHint() );
}

Q7B Q7B_QSIZEPOLICY_CONTROLTYPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSizePolicy(self).controlType() );
}

Q7B Q7B_QSIZEPOLICY_EXPANDINGDIRECTIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSizePolicy(self).expandingDirections() );
}

Q7B Q7B_QSIZEPOLICY_HASHEIGHTFORWIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSizePolicy(self).hasHeightForWidth() );
}
/*
Q7B Q7B_QSIZEPOLICY_HASWIDTHFORHEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSizePolicy(self).hasWidthForHeight() );
}*/

Q7B Q7B_QSIZEPOLICY_HORIZONTALPOLICY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSizePolicy(self).horizontalPolicy() );
}

Q7B Q7B_QSIZEPOLICY_HORIZONTALSTRETCH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSizePolicy(self).horizontalStretch() );
}

void Q7B_QSIZEPOLICY_SETCONTROLTYPE(Q7B self, Q7B Type) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Type))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSizePolicy(self).setControlType((QSizePolicy::ControlType) Q7B_IDqint64(Type));
}

void Q7B_QSIZEPOLICY_SETHEIGHTFORWIDTH(Q7B self, Q7B Dependent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Dependent))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQSizePolicy(self).setHeightForWidth(Q7B_IDbool(Dependent));
}

void Q7B_QSIZEPOLICY_SETHORIZONTALPOLICY(Q7B self, Q7B Policy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Policy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSizePolicy(self).setHorizontalPolicy((QSizePolicy::Policy) Q7B_IDqint64(Policy));
}

void Q7B_QSIZEPOLICY_SETHORIZONTALSTRETCH(Q7B self, Q7B StretchFactor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(StretchFactor))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSizePolicy(self).setHorizontalStretch(Q7B_IDqint64(StretchFactor));
}

void Q7B_QSIZEPOLICY_SETVERTICALPOLICY(Q7B self, Q7B Policy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Policy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSizePolicy(self).setVerticalPolicy((QSizePolicy::Policy) Q7B_IDqint64(Policy));
}

void Q7B_QSIZEPOLICY_SETVERTICALSTRETCH(Q7B self, Q7B StretchFactor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(StretchFactor))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSizePolicy(self).setVerticalStretch(Q7B_IDqint64(StretchFactor));
}
/*
void Q7B_QSIZEPOLICY_SETWIDTHFORHEIGHT(Q7B self, Q7B Dependent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Dependent))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQSizePolicy(self).setWidthForHeight(Q7B_IDbool(Dependent));
}
*/
void Q7B_QSIZEPOLICY_TRANSPOSE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return ; }

  Q7B_IDQSizePolicy(self).transpose();
}

Q7B Q7B_QSIZEPOLICY_VERTICALPOLICY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSizePolicy(self).verticalPolicy() );
}

Q7B Q7B_QSIZEPOLICY_VERTICALSTRETCH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSIZEPOLICY(self))){ Q7B_EXCEPTION("QSizePolicy expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSizePolicy(self).verticalStretch() );
}

Q7B Q7B_QSOUND_FILENAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSOUND(self))){ Q7B_EXCEPTION("QSound expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSound(self)->fileName() );
}

Q7B Q7B_QSOUND_ISFINISHED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSOUND(self))){ Q7B_EXCEPTION("QSound expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSound(self)->isFinished() );
}

Q7B Q7B_QSOUND_LOOPS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSOUND(self))){ Q7B_EXCEPTION("QSound expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSound(self)->loops() );
}

Q7B Q7B_QSOUND_LOOPSREMAINING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSOUND(self))){ Q7B_EXCEPTION("QSound expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSound(self)->loopsRemaining() );
}

void Q7B_QSOUND_PLAY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSOUND(self))){ Q7B_EXCEPTION("QSound expected"); return ; }

  Q7B_IDQSound(self)->play();
}

void Q7B_QSOUND_SETLOOPS(Q7B self, Q7B Number) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSOUND(self))){ Q7B_EXCEPTION("QSound expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Number))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQSound(self)->setLoops(Q7B_IDqint64(Number));
}

void Q7B_QSOUND_STOP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSOUND(self))){ Q7B_EXCEPTION("QSound expected"); return ; }

  Q7B_IDQSound(self)->stop();
}

Q7B Q7B_QSTACKEDLAYOUT_ADDWIDGET(Q7B self, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTACKEDLAYOUT(self))){ Q7B_EXCEPTION("QStackedLayout expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStackedLayout(self).addWidget(Q7B_IDQWidget(Widget)) );
}

Q7B Q7B_QSTACKEDLAYOUT_COUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTACKEDLAYOUT(self))){ Q7B_EXCEPTION("QStackedLayout expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStackedLayout(self).count() );
}

void Q7B_QSTACKEDLAYOUT_COUNT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTACKEDLAYOUT(self))){ Q7B_EXCEPTION("QStackedLayout expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  //Q7B_IDQStackedLayout(self).setCount(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QSTACKEDLAYOUT_CURRENTINDEX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTACKEDLAYOUT(self))){ Q7B_EXCEPTION("QStackedLayout expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStackedLayout(self).currentIndex() );
}

Q7B Q7B_QSTACKEDLAYOUT_CURRENTWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTACKEDLAYOUT(self))){ Q7B_EXCEPTION("QStackedLayout expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStackedLayout(self).currentWidget() );
}

Q7B Q7B_QSTACKEDLAYOUT_INSERTWIDGET(Q7B self, Q7B Index, Q7B Widget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTACKEDLAYOUT(self))){ Q7B_EXCEPTION("QStackedLayout expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStackedLayout(self).insertWidget(Q7B_IDqint64(Index), Q7B_IDQWidget(Widget)) );
}

void Q7B_QSTACKEDLAYOUT_SETSTACKINGMODE(Q7B self, Q7B StackingMode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QSTACKEDLAYOUT(self))){ Q7B_EXCEPTION("QStackedLayout expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(StackingMode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQStackedLayout(self).setStackingMode((QStackedLayout::StackingMode) Q7B_IDqint64(StackingMode));
}

Q7B Q7B_QSTACKEDLAYOUT_STACKINGMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTACKEDLAYOUT(self))){ Q7B_EXCEPTION("QStackedLayout expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStackedLayout(self).stackingMode() );
}

Q7B Q7B_QSTACKEDLAYOUT_WIDGET(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTACKEDLAYOUT(self))){ Q7B_EXCEPTION("QStackedLayout expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStackedLayout(self).widget(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QSYSTEMLOCALE_FALLBACKLOCALE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSYSTEMLOCALE(self))){ Q7B_EXCEPTION("QSystemLocale expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSystemLocale(self).fallbackLocale() );
}

Q7B Q7B_QSYSTEMLOCALE_QUERY(Q7B self, Q7B Type, Q7B in) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSYSTEMLOCALE(self))){ Q7B_EXCEPTION("QSystemLocale expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Type))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QVARIANT(in))){ Q7B_EXCEPTION("QVariant expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQSystemLocale(self).query((QSystemLocale::QueryType) Q7B_IDqint64(Type) , Q7B_IDQVariant(in)) );
}

Q7B Q7B_QTEXTCURSOR_CREATELIST2(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).createList((QTextListFormat::Style) Q7B_IDqint64(Style)) );
}

void Q7B_QTEXTCURSOR_INSERTBLOCK2(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(Format))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  Q7B_IDQTextCursor(self).insertBlock(Q7B_IDQTextBlockFormat(Format));
}

void Q7B_QTEXTCURSOR_INSERTBLOCK3(Q7B self, Q7B Format, Q7B CharFormat) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(Format))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(CharFormat))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  Q7B_IDQTextCursor(self).insertBlock(Q7B_IDQTextBlockFormat(Format), Q7B_IDQTextCharFormat(CharFormat));
}

void Q7B_QTEXTCURSOR_INSERTIMAGE2(Q7B self, Q7B Image, Q7B Name) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return ; }

  if (Q7B_nil(Q7B_QIMAGE(Image))){ Q7B_EXCEPTION("QImage expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextCursor(self).insertImage(Q7B_IDQImage(Image), Q7B_IDQString(Name));
}

Q7B Q7B_QTEXTCURSOR_INSERTLIST2(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).insertList((QTextListFormat::Style) Q7B_IDqint64(Style)) );
}

Q7B Q7B_QTEXTCURSOR_INSERTTABLE2(Q7B self, Q7B Rows, Q7B Columns) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCURSOR(self))){ Q7B_EXCEPTION("QTextCursor expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Rows))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Columns))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCursor(self).insertTable(Q7B_IDqint64(Rows), Q7B_IDqint64(Columns)) );
}

Q7B Q7B_QTIMELINE_CURRENTFRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimeLine(self)->currentFrame() );
}

Q7B Q7B_QTIMELINE_CURRENTTIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimeLine(self)->currentTime() );
}

Q7B Q7B_QTIMELINE_CURRENTVALUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimeLine(self)->currentValue() );
}

Q7B Q7B_QTIMELINE_CURVESHAPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimeLine(self)->curveShape() );
}

Q7B Q7B_QTIMELINE_DIRECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimeLine(self)->direction() );
}

Q7B Q7B_QTIMELINE_DURATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimeLine(self)->duration() );
}

Q7B Q7B_QTIMELINE_ENDFRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimeLine(self)->endFrame() );
}

Q7B Q7B_QTIMELINE_FRAMEFORTIME(Q7B self, Q7B Msec) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Msec))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimeLine(self)->frameForTime(Q7B_IDqint64(Msec)) );
}

Q7B Q7B_QTIMELINE_LOOPCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimeLine(self)->loopCount() );
}

void Q7B_QTIMELINE_SETCURVESHAPE(Q7B self, Q7B Shape) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Shape))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTimeLine(self)->setCurveShape((QTimeLine::CurveShape) Q7B_IDqint64(Shape));
}

void Q7B_QTIMELINE_SETDIRECTION(Q7B self, Q7B Direction) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Direction))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTimeLine(self)->setDirection((QTimeLine::Direction) Q7B_IDqint64(Direction));
}

void Q7B_QTIMELINE_SETDURATION(Q7B self, Q7B Duration) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Duration))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTimeLine(self)->setDuration(Q7B_IDqint64(Duration));
}

void Q7B_QTIMELINE_SETENDFRAME(Q7B self, Q7B Frame) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Frame))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTimeLine(self)->setEndFrame(Q7B_IDqint64(Frame));
}

void Q7B_QTIMELINE_SETFRAMERANGE(Q7B self, Q7B StartFrame, Q7B EndFrame) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(StartFrame))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(EndFrame))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTimeLine(self)->setFrameRange(Q7B_IDqint64(StartFrame), Q7B_IDqint64(EndFrame));
}

void Q7B_QTIMELINE_SETLOOPCOUNT(Q7B self, Q7B Count) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Count))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTimeLine(self)->setLoopCount(Q7B_IDqint64(Count));
}

void Q7B_QTIMELINE_SETSTARTFRAME(Q7B self, Q7B Frame) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Frame))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTimeLine(self)->setStartFrame(Q7B_IDqint64(Frame));
}

void Q7B_QTIMELINE_SETUPDATEINTERVAL(Q7B self, Q7B Interval) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Interval))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTimeLine(self)->setUpdateInterval(Q7B_IDqint64(Interval));
}

Q7B Q7B_QTIMELINE_STARTFRAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimeLine(self)->startFrame() );
}

Q7B Q7B_QTIMELINE_STATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimeLine(self)->state() );
}

Q7B Q7B_QTIMELINE_UPDATEINTERVAL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimeLine(self)->updateInterval() );
}

Q7B Q7B_QTIMELINE_VALUEFORTIME(Q7B self, Q7B Msec) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMELINE(self))){ Q7B_EXCEPTION("QTimeLine expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Msec))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimeLine(self)->valueForTime(Q7B_IDqint64(Msec)) );
}

Q7B Q7B_QACCESSIBLEEVENT_CHILD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACCESSIBLEEVENT(self))){ Q7B_EXCEPTION("QAccessibleEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAccessibleEvent(self).child() );
}

void Q7B_QACCESSIBLEEVENT_SETVALUE(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QACCESSIBLEEVENT(self))){ Q7B_EXCEPTION("QAccessibleEvent expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQAccessibleEvent(self).setValue(Q7B_IDQString(Text));
}

Q7B Q7B_QACCESSIBLEEVENT_VALUE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACCESSIBLEEVENT(self))){ Q7B_EXCEPTION("QAccessibleEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQAccessibleEvent(self).value() );
}

Q7B Q7B_QACTIONEVENT_ACTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTIONEVENT(self))){ Q7B_EXCEPTION("QActionEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQActionEvent(self).action() );
}

Q7B Q7B_QACTIONEVENT_BEFORE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QACTIONEVENT(self))){ Q7B_EXCEPTION("QActionEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQActionEvent(self).before() );
}

Q7B Q7B_QBYTEARRAY_APPEND(Q7B self, Q7B Ba) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Ba))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).append(Q7B_IDQByteArray(Ba)) );
}

Q7B Q7B_QBYTEARRAY_APPEND2(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).append(Q7B_IDQString(Str)) );
}

Q7B Q7B_QBYTEARRAY_AT(Q7B self, Q7B I) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(I))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).at(Q7B_IDqint64(I)) );
}

Q7B Q7B_QBYTEARRAY_CAPACITY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).capacity() );
}

void Q7B_QBYTEARRAY_CHOP(Q7B self, Q7B N) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(N))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQByteArray(self).chop(Q7B_IDqint64(N));
}

void Q7B_QBYTEARRAY_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQByteArray(self).clear();
}

Q7B Q7B_QBYTEARRAY_CONTAINS(Q7B self, Q7B Ba) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Ba))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).contains(Q7B_IDQByteArray(Ba)) );
}

Q7B Q7B_QBYTEARRAY_CONTAINS2(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).contains(Q7B_IDQString(Str).toUtf8()) );
}

Q7B Q7B_QBYTEARRAY_COUNT(Q7B self, Q7B Ba) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Ba))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).count(Q7B_IDQByteArray(Ba)) );
}

Q7B Q7B_QBYTEARRAY_COUNT2(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).count(Q7B_IDQString(Str).toUtf8()) );
}

Q7B Q7B_QBYTEARRAY_COUNT3(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).count() );
}

Q7B Q7B_QBYTEARRAY_DATA(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).data() );
}

Q7B Q7B_QBYTEARRAY_ENDSWITH(Q7B self, Q7B Ba) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Ba))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).endsWith(Q7B_IDQByteArray(Ba)) );
}

Q7B Q7B_QBYTEARRAY_ENDSWITH2(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).endsWith(Q7B_IDQString(Str).toUtf8()) );
}

Q7B Q7B_QBYTEARRAY_FILL(Q7B self, Q7B Ch, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Ch))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Size))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).fill(Q7B_IDQString(Ch).at(0).toAscii(), Q7B_IDqint64(Size)) );
}

Q7B Q7B_QBYTEARRAY_INDEXOF(Q7B self, Q7B Str, Q7B From) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(From))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).indexOf(Q7B_IDQString(Str), Q7B_IDqint64(From)) );
}

Q7B Q7B_QBYTEARRAY_INSERT(Q7B self, Q7B I, Q7B Ba) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(I))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Ba))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).insert(Q7B_IDqint64(I), Q7B_IDQByteArray(Ba)) );
}

Q7B Q7B_QBYTEARRAY_INSERT2(Q7B self, Q7B I, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(I))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).insert(Q7B_IDqint64(I), Q7B_IDQString(Str)) );
}

Q7B Q7B_QBYTEARRAY_ISEMPTY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).isEmpty() );
}

Q7B Q7B_QBYTEARRAY_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).isNull() );
}

Q7B Q7B_QBYTEARRAY_LASTINDEXOF(Q7B self, Q7B Ba, Q7B From) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Ba))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(From))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).lastIndexOf(Q7B_IDQByteArray(Ba), Q7B_IDqint64(From)) );
}

Q7B Q7B_QBYTEARRAY_LASTINDEXOF2(Q7B self, Q7B Str, Q7B From) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(From))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).lastIndexOf(Q7B_IDQString(Str), Q7B_IDqint64(From)) );
}

Q7B Q7B_QBYTEARRAY_LEFT(Q7B self, Q7B Len) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Len))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).left(Q7B_IDqint64(Len)) );
}

Q7B Q7B_QBYTEARRAY_LEFTJUSTIFIED(Q7B self, Q7B Width, Q7B Fill, Q7B Truncate) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Fill))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Truncate))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).leftJustified(Q7B_IDqint64(Width), Q7B_IDQString(Fill).at(0).toAscii(), Q7B_IDbool(Truncate)) );
}

Q7B Q7B_QBYTEARRAY_LENGTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).length() );
}

Q7B Q7B_QBYTEARRAY_MID(Q7B self, Q7B Pos, Q7B Len) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Pos))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Len))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).mid(Q7B_IDqint64(Pos), Q7B_IDqint64(Len)) );
}

Q7B Q7B_QBYTEARRAY_PREPEND(Q7B self, Q7B Ba) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Ba))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).prepend(Q7B_IDQByteArray(Ba)) );
}

Q7B Q7B_QBYTEARRAY_PREPEND2(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).prepend(Q7B_IDQString(Str).toUtf8()) );
}

void Q7B_QBYTEARRAY_PUSH_BACK(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Other))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQByteArray(self).push_back(Q7B_IDQByteArray(Other));
}

void Q7B_QBYTEARRAY_PUSH_BACK2(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQByteArray(self).push_back(Q7B_IDQString(Str).toUtf8());
}

void Q7B_QBYTEARRAY_PUSH_FRONT(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Other))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQByteArray(self).push_front(Q7B_IDQByteArray(Other));
}

void Q7B_QBYTEARRAY_PUSH_FRONT2(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQByteArray(self).push_front(Q7B_IDQString(Str).toUtf8());
}

Q7B Q7B_QBYTEARRAY_REPLACE(Q7B self, Q7B Pos, Q7B Len, Q7B After) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Pos))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Len))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(After))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).replace(Q7B_IDqint64(Pos), Q7B_IDqint64(Len), Q7B_IDQByteArray(After)) );
}

Q7B Q7B_QBYTEARRAY_REPLACE2(Q7B self, Q7B Pos, Q7B Len, Q7B After, Q7B Alen) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Pos))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Len))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(After))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Alen))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).replace(Q7B_IDqint64(Pos), Q7B_IDqint64(Len), Q7B_IDQString(After).toUtf8(), Q7B_IDqint64(Alen)) );
}

Q7B Q7B_QBYTEARRAY_REPLACE3(Q7B self, Q7B Before, Q7B After) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Before))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(After))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).replace(Q7B_IDQByteArray(Before), Q7B_IDQByteArray(After)) );
}

void Q7B_QBYTEARRAY_RESERVE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Size))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQByteArray(self).reserve(Q7B_IDqint64(Size));
}

void Q7B_QBYTEARRAY_RESIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Size))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQByteArray(self).resize(Q7B_IDqint64(Size));
}

Q7B Q7B_QBYTEARRAY_RIGHT(Q7B self, Q7B Len) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Len))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).right(Q7B_IDqint64(Len)) );
}

Q7B Q7B_QBYTEARRAY_RIGHTJUSTIFIED(Q7B self, Q7B Width, Q7B Fill, Q7B Truncate) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Fill))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Truncate))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).rightJustified(Q7B_IDqint64(Width), Q7B_IDQString(Fill).at(0).toAscii(), Q7B_IDbool(Truncate)) );
}

Q7B Q7B_QBYTEARRAY_SETNUM(Q7B self, Q7B N, Q7B Base) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(N))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Base))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).setNum(Q7B_IDqint64(N), Q7B_IDqint64(Base)) );
}

Q7B Q7B_QBYTEARRAY_SETNUM2(Q7B self, Q7B N, Q7B Base) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QREAL(N))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Base))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).setNum(Q7B_IDqreal(N), Q7B_IDqint64(Base)) );
}

Q7B Q7B_QBYTEARRAY_SIMPLIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).simplified() );
}

Q7B Q7B_QBYTEARRAY_SIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).size() );
}

void Q7B_QBYTEARRAY_SQUEEZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQByteArray(self).squeeze();
}

Q7B Q7B_QBYTEARRAY_STARTSWITH(Q7B self, Q7B Ba) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Ba))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).startsWith(Q7B_IDQByteArray(Ba)) );
}

Q7B Q7B_QBYTEARRAY_STARTSWITH2(Q7B self, Q7B Str) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).startsWith(Q7B_IDQString(Str).toUtf8()) );
}
/*
void Q7B_QBYTEARRAY_SWAP(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Other))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  Q7B_IDQByteArray(self).swap(Q7B_IDQByteArray(Other));
}
*/
Q7B Q7B_QBYTEARRAY_TOBASE64(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).toBase64() );
}

Q7B Q7B_QBYTEARRAY_TOFLOAT(Q7B self, Q7B Ok) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Ok))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  

  bool *b = new bool(); *b = false; 
  qreal r = ((QByteArray *) self->ref)->toFloat(b);
  Ok->ref = b;
  /*
  static bool ok;
  qreal r = ((QByteArray *) self->ref)->toFloat(&ok);
  Ok->ref = &ok;
  */
  if (*b) return Q7B_ID(r);

  return Q7B_idnil;
}

Q7B Q7B_QBYTEARRAY_TOHEX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).toHex() );
}

Q7B Q7B_QBYTEARRAY_TOINT(Q7B self, Q7B Ok, Q7B Base) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Ok))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Base))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }


  bool *b = new bool(); *b = false; 
  qreal r = Q7B_IDQByteArray(self).toInt(b, Q7B_IDqint64(Base));
  Ok->ref = b;
  /*
  static bool ok;
  qreal r = ((QByteArray *) self->ref)->toInt(&ok, Q7B_IDqint64(Base));
  Ok->ref = &ok;
  */
  if (*b) return Q7B_ID(r);

  return Q7B_idnil;
}

Q7B Q7B_QBYTEARRAY_TOLOWER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).toLower() );
}

Q7B Q7B_QBYTEARRAY_TOPERCENTENCODING(Q7B self, Q7B Exclude, Q7B Include, Q7B Percent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Exclude))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBYTEARRAY(Include))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Percent))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).toPercentEncoding(Q7B_IDQByteArray(Exclude), Q7B_IDQByteArray(Include), Q7B_IDQString(Percent).at(0).toAscii()) );
}

Q7B Q7B_QBYTEARRAY_TOUPPER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).toUpper() );
}

Q7B Q7B_QBYTEARRAY_TRIMMED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQByteArray(self).trimmed() );
}

void Q7B_QBYTEARRAY_TRUNCATE(Q7B self, Q7B Pos) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QBYTEARRAY(self))){ Q7B_EXCEPTION("QByteArray expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Pos))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQByteArray(self).truncate(Q7B_IDqint64(Pos));
}

Q7B Q7B_QCHILDEVENT_ADDED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHILDEVENT(self))){ Q7B_EXCEPTION("QChildEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChildEvent(self).added() );
}

Q7B Q7B_QCHILDEVENT_CHILD(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHILDEVENT(self))){ Q7B_EXCEPTION("QChildEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChildEvent(self).child() );
}

Q7B Q7B_QCHILDEVENT_POLISHED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHILDEVENT(self))){ Q7B_EXCEPTION("QChildEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChildEvent(self).polished() );
}

Q7B Q7B_QCHILDEVENT_REMOVED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QCHILDEVENT(self))){ Q7B_EXCEPTION("QChildEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQChildEvent(self).removed() );
}

Q7B Q7B_QDECLARATIVECONTEXT_BASEURL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDECLARATIVECONTEXT(self))){ Q7B_EXCEPTION("QDeclarativeContext expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDeclarativeContext(self).baseUrl() );
}

Q7B Q7B_QDECLARATIVECONTEXT_CONTEXTOBJECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDECLARATIVECONTEXT(self))){ Q7B_EXCEPTION("QDeclarativeContext expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDeclarativeContext(self).contextObject() );
}

Q7B Q7B_QDECLARATIVECONTEXT_CONTEXTPROPERTY(Q7B self, Q7B Name) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDECLARATIVECONTEXT(self))){ Q7B_EXCEPTION("QDeclarativeContext expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDeclarativeContext(self).contextProperty(Q7B_IDQString(Name)) );
}

Q7B Q7B_QDECLARATIVECONTEXT_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDECLARATIVECONTEXT(self))){ Q7B_EXCEPTION("QDeclarativeContext expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDeclarativeContext(self).isValid() );
}

Q7B Q7B_QDECLARATIVECONTEXT_PARENTCONTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDECLARATIVECONTEXT(self))){ Q7B_EXCEPTION("QDeclarativeContext expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDeclarativeContext(self).parentContext() );
}

Q7B Q7B_QDECLARATIVECONTEXT_RESOLVEDURL(Q7B self, Q7B Src) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDECLARATIVECONTEXT(self))){ Q7B_EXCEPTION("QDeclarativeContext expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QURL(Src))){ Q7B_EXCEPTION("QUrl expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDeclarativeContext(self).resolvedUrl(Q7B_IDQUrl(Src)) );
}

Q7B Q7B_QDECLARATIVEVIEW_INITIALSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDECLARATIVEVIEW(self))){ Q7B_EXCEPTION("QDeclarativeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDeclarativeView(self)->initialSize() );
}

Q7B Q7B_QDECLARATIVEVIEW_RESIZEMODE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDECLARATIVEVIEW(self))){ Q7B_EXCEPTION("QDeclarativeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDeclarativeView(self)->resizeMode() );
}

Q7B Q7B_QDECLARATIVEVIEW_ROOTCONTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDECLARATIVEVIEW(self))){ Q7B_EXCEPTION("QDeclarativeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDeclarativeView(self)->rootContext() );
}

Q7B Q7B_QDECLARATIVEVIEW_ROOTOBJECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDECLARATIVEVIEW(self))){ Q7B_EXCEPTION("QDeclarativeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDeclarativeView(self)->rootObject() );
}

void Q7B_QDECLARATIVEVIEW_SETRESIZEMODE(Q7B self, Q7B Mode) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDECLARATIVEVIEW(self))){ Q7B_EXCEPTION("QDeclarativeView expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Mode))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQDeclarativeView(self)->setResizeMode((QDeclarativeView::ResizeMode) Q7B_IDqint64(Mode));
}

void Q7B_QDECLARATIVEVIEW_SETSOURCE(Q7B self, Q7B Url) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDECLARATIVEVIEW(self))){ Q7B_EXCEPTION("QDeclarativeView expected"); return ; }

  if (Q7B_nil(Q7B_QURL(Url))){ Q7B_EXCEPTION("QUrl expected"); return ; }

  Q7B_IDQDeclarativeView(self)->setSource(Q7B_IDQUrl(Url));
}

Q7B Q7B_QDECLARATIVEVIEW_SOURCE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDECLARATIVEVIEW(self))){ Q7B_EXCEPTION("QDeclarativeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDeclarativeView(self)->source() );
}

Q7B Q7B_QDECLARATIVEVIEW_STATUS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDECLARATIVEVIEW(self))){ Q7B_EXCEPTION("QDeclarativeView expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDeclarativeView(self)->status() );
}

void Q7B_QDROPEVENT_ACCEPTPROPOSEDACTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDROPEVENT(self))){ Q7B_EXCEPTION("QDropEvent expected"); return ; }

  Q7B_IDQDropEvent(self).acceptProposedAction();
}

Q7B Q7B_QDROPEVENT_DROPACTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDROPEVENT(self))){ Q7B_EXCEPTION("QDropEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDropEvent(self).dropAction() );
}

Q7B Q7B_QDROPEVENT_KEYBOARDMODIFIERS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDROPEVENT(self))){ Q7B_EXCEPTION("QDropEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDropEvent(self).keyboardModifiers() );
}

Q7B Q7B_QDROPEVENT_MIMEDATA(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDROPEVENT(self))){ Q7B_EXCEPTION("QDropEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDropEvent(self).mimeData() );
}

Q7B Q7B_QDROPEVENT_MOUSEBUTTONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDROPEVENT(self))){ Q7B_EXCEPTION("QDropEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDropEvent(self).mouseButtons() );
}

Q7B Q7B_QDROPEVENT_POS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDROPEVENT(self))){ Q7B_EXCEPTION("QDropEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDropEvent(self).pos() );
}

Q7B Q7B_QDROPEVENT_POSSIBLEACTIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDROPEVENT(self))){ Q7B_EXCEPTION("QDropEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDropEvent(self).possibleActions() );
}

Q7B Q7B_QDROPEVENT_PROPOSEDACTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDROPEVENT(self))){ Q7B_EXCEPTION("QDropEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDropEvent(self).proposedAction() );
}

void Q7B_QDROPEVENT_SETDROPACTION(Q7B self, Q7B Action) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDROPEVENT(self))){ Q7B_EXCEPTION("QDropEvent expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Action))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQDropEvent(self).setDropAction((Qt::DropAction) Q7B_IDqint64(Action));
}

Q7B Q7B_QDROPEVENT_SOURCE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDROPEVENT(self))){ Q7B_EXCEPTION("QDropEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDropEvent(self).source() );
}

Q7B Q7B_QDYNAMICPROPERTYCHANGEEVENT_PROPERTYNAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDYNAMICPROPERTYCHANGEEVENT(self))){ Q7B_EXCEPTION("QDynamicPropertyChangeEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDynamicPropertyChangeEvent(self).propertyName() );
}

void Q7B_QEVENT_ACCEPT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QEVENT(self))){ Q7B_EXCEPTION("QEvent expected"); return ; }

  Q7B_IDQEvent(self).accept();
}

Q7B Q7B_QEVENT_ACCEPTED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QEVENT(self))){ Q7B_EXCEPTION("QEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQEvent(self).isAccepted() );
}

void Q7B_QEVENT_ACCEPTED(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QEVENT(self))){ Q7B_EXCEPTION("QEvent expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQEvent(self).setAccepted(Q7B_IDbool(theProperty));
}

void Q7B_QEVENT_IGNORE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QEVENT(self))){ Q7B_EXCEPTION("QEvent expected"); return ; }

  Q7B_IDQEvent(self).ignore();
}

Q7B Q7B_QEVENT_ISACCEPTED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QEVENT(self))){ Q7B_EXCEPTION("QEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQEvent(self).isAccepted() );
}

void Q7B_QEVENT_SETACCEPTED(Q7B self, Q7B Accepted) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QEVENT(self))){ Q7B_EXCEPTION("QEvent expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Accepted))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQEvent(self).setAccepted(Q7B_IDbool(Accepted));
}

Q7B Q7B_QEVENT_SPONTANEOUS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QEVENT(self))){ Q7B_EXCEPTION("QEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQEvent(self).spontaneous() );
}

Q7B Q7B_QEVENT_TYPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QEVENT(self))){ Q7B_EXCEPTION("QEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQEvent(self).type() );
}

Q7B Q7B_QFILEOPENEVENT_FILE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEOPENEVENT(self))){ Q7B_EXCEPTION("QFileOpenEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileOpenEvent(self).file() );
}

Q7B Q7B_QFILEOPENEVENT_URL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFILEOPENEVENT(self))){ Q7B_EXCEPTION("QFileOpenEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFileOpenEvent(self).url() );
}

Q7B Q7B_QFOCUSEVENT_GOTFOCUS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFOCUSEVENT(self))){ Q7B_EXCEPTION("QFocusEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFocusEvent(self).gotFocus() );
}

Q7B Q7B_QFOCUSEVENT_LOSTFOCUS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFOCUSEVENT(self))){ Q7B_EXCEPTION("QFocusEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFocusEvent(self).lostFocus() );
}

Q7B Q7B_QFOCUSEVENT_REASON(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QFOCUSEVENT(self))){ Q7B_EXCEPTION("QFocusEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQFocusEvent(self).reason() );
}

Q7B Q7B_QGRAPHICSSCENEEVENT_WIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QGRAPHICSSCENEEVENT(self))){ Q7B_EXCEPTION("QGraphicsSceneEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQGraphicsSceneEvent(self).widget() );
}

Q7B Q7B_QHELPEVENT_GLOBALPOS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHELPEVENT(self))){ Q7B_EXCEPTION("QHelpEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHelpEvent(self).globalPos() );
}

Q7B Q7B_QHELPEVENT_GLOBALX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHELPEVENT(self))){ Q7B_EXCEPTION("QHelpEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHelpEvent(self).globalX() );
}

Q7B Q7B_QHELPEVENT_GLOBALY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHELPEVENT(self))){ Q7B_EXCEPTION("QHelpEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHelpEvent(self).globalY() );
}

Q7B Q7B_QHELPEVENT_POS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHELPEVENT(self))){ Q7B_EXCEPTION("QHelpEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHelpEvent(self).pos() );
}

Q7B Q7B_QHELPEVENT_X(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHELPEVENT(self))){ Q7B_EXCEPTION("QHelpEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHelpEvent(self).x() );
}

Q7B Q7B_QHELPEVENT_Y(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHELPEVENT(self))){ Q7B_EXCEPTION("QHelpEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHelpEvent(self).y() );
}

Q7B Q7B_QHOVEREVENT_OLDPOS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHOVEREVENT(self))){ Q7B_EXCEPTION("QHoverEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHoverEvent(self).oldPos() );
}

Q7B Q7B_QHOVEREVENT_POS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QHOVEREVENT(self))){ Q7B_EXCEPTION("QHoverEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQHoverEvent(self).pos() );
}

Q7B Q7B_QINPUTEVENT_MODIFIERS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTEVENT(self))){ Q7B_EXCEPTION("QInputEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputEvent(self).modifiers() );
}

Q7B Q7B_QINPUTMETHODEVENT_COMMITSTRING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTMETHODEVENT(self))){ Q7B_EXCEPTION("QInputMethodEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputMethodEvent(self).commitString() );
}

Q7B Q7B_QINPUTMETHODEVENT_PREEDITSTRING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTMETHODEVENT(self))){ Q7B_EXCEPTION("QInputMethodEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputMethodEvent(self).preeditString() );
}

Q7B Q7B_QINPUTMETHODEVENT_REPLACEMENTLENGTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTMETHODEVENT(self))){ Q7B_EXCEPTION("QInputMethodEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputMethodEvent(self).replacementLength() );
}

Q7B Q7B_QINPUTMETHODEVENT_REPLACEMENTSTART(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QINPUTMETHODEVENT(self))){ Q7B_EXCEPTION("QInputMethodEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQInputMethodEvent(self).replacementStart() );
}

void Q7B_QINPUTMETHODEVENT_SETCOMMITSTRING(Q7B self, Q7B CommitString, Q7B ReplaceFrom, Q7B ReplaceLength) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QINPUTMETHODEVENT(self))){ Q7B_EXCEPTION("QInputMethodEvent expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(CommitString))){ Q7B_EXCEPTION("String expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(ReplaceFrom))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(ReplaceLength))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQInputMethodEvent(self).setCommitString(Q7B_IDQString(CommitString), Q7B_IDqint64(ReplaceFrom), Q7B_IDqint64(ReplaceLength));
}

void Q7B_QITEMSELECTIONMODEL_CLEAR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QITEMSELECTIONMODEL(self))){ Q7B_EXCEPTION("QItemSelectionModel expected"); return ; }

  Q7B_IDQItemSelectionModel(self)->clear();
}

void Q7B_QITEMSELECTIONMODEL_CLEARSELECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QITEMSELECTIONMODEL(self))){ Q7B_EXCEPTION("QItemSelectionModel expected"); return ; }

  Q7B_IDQItemSelectionModel(self)->clearSelection();
}

Q7B Q7B_QITEMSELECTIONMODEL_COLUMNINTERSECTSSELECTION(Q7B self, Q7B Column, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QITEMSELECTIONMODEL(self))){ Q7B_EXCEPTION("QItemSelectionModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQItemSelectionModel(self)->columnIntersectsSelection(Q7B_IDqint64(Column), Q7B_IDQModelIndex(Parent)) );
}

Q7B Q7B_QITEMSELECTIONMODEL_CURRENTINDEX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QITEMSELECTIONMODEL(self))){ Q7B_EXCEPTION("QItemSelectionModel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQItemSelectionModel(self)->currentIndex() );
}

Q7B Q7B_QITEMSELECTIONMODEL_HASSELECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QITEMSELECTIONMODEL(self))){ Q7B_EXCEPTION("QItemSelectionModel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQItemSelectionModel(self)->hasSelection() );
}

Q7B Q7B_QITEMSELECTIONMODEL_ISCOLUMNSELECTED(Q7B self, Q7B Column, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QITEMSELECTIONMODEL(self))){ Q7B_EXCEPTION("QItemSelectionModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQItemSelectionModel(self)->isColumnSelected(Q7B_IDqint64(Column), Q7B_IDQModelIndex(Parent)) );
}

Q7B Q7B_QITEMSELECTIONMODEL_ISROWSELECTED(Q7B self, Q7B Row, Q7B Parent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QITEMSELECTIONMODEL(self))){ Q7B_EXCEPTION("QItemSelectionModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Parent))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQItemSelectionModel(self)->isRowSelected(Q7B_IDqint64(Row), Q7B_IDQModelIndex(Parent)) );
}

Q7B Q7B_QITEMSELECTIONMODEL_ISSELECTED(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QITEMSELECTIONMODEL(self))){ Q7B_EXCEPTION("QItemSelectionModel expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQItemSelectionModel(self)->isSelected(Q7B_IDQModelIndex(Index)) );
}

Q7B Q7B_QITEMSELECTIONMODEL_MODEL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QITEMSELECTIONMODEL(self))){ Q7B_EXCEPTION("QItemSelectionModel expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQItemSelectionModel(self)->model() );
}

void Q7B_QITEMSELECTIONMODEL_RESET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QITEMSELECTIONMODEL(self))){ Q7B_EXCEPTION("QItemSelectionModel expected"); return ; }

  Q7B_IDQItemSelectionModel(self)->reset();
}

void Q7B_QITEMSELECTIONMODEL_SETCURRENTINDEX(Q7B self, Q7B Index, Q7B Command) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QITEMSELECTIONMODEL(self))){ Q7B_EXCEPTION("QItemSelectionModel expected"); return ; }

  if (Q7B_nil(Q7B_QMODELINDEX(Index))){ Q7B_EXCEPTION("QModelIndex expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Command))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQItemSelectionModel(self)->setCurrentIndex(Q7B_IDQModelIndex(Index), (QItemSelectionModel::SelectionFlags) Q7B_IDqint64(Command));
}

Q7B Q7B_QKEYSEQUENCE_COUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QKEYSEQUENCE(self))){ Q7B_EXCEPTION("QKeySequence expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQKeySequence(self).count() );
}

Q7B Q7B_QKEYSEQUENCE_ISEMPTY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QKEYSEQUENCE(self))){ Q7B_EXCEPTION("QKeySequence expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQKeySequence(self).isEmpty() );
}

Q7B Q7B_QKEYSEQUENCE_MATCHES(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QKEYSEQUENCE(self))){ Q7B_EXCEPTION("QKeySequence expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QKEYSEQUENCE(Other))){ Q7B_EXCEPTION("QKeySequence expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQKeySequence(self).matches(Q7B_IDQKeySequence(Other)) );
}
/*
void Q7B_QKEYSEQUENCE_SWAP(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QKEYSEQUENCE(self))){ Q7B_EXCEPTION("QKeySequence expected"); return ; }

  if (Q7B_nil(Q7B_QKEYSEQUENCE(Other))){ Q7B_EXCEPTION("QKeySequence expected"); return ; }

  Q7B_IDQKeySequence(self).swap(Q7B_IDQKeySequence(Other));
}*/

Q7B Q7B_QKEYSEQUENCE_TOSTRING(Q7B self, Q7B Format) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QKEYSEQUENCE(self))){ Q7B_EXCEPTION("QKeySequence expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Format))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQKeySequence(self).toString((QKeySequence::SequenceFormat) Q7B_IDqint64(Format)) );
}

Q7B Q7B_QMOVEEVENT_OLDPOS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVEEVENT(self))){ Q7B_EXCEPTION("QMoveEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMoveEvent(self).oldPos() );
}

Q7B Q7B_QMOVEEVENT_POS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QMOVEEVENT(self))){ Q7B_EXCEPTION("QMoveEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQMoveEvent(self).pos() );
}

Q7B Q7B_QPAINTEVENT_RECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTEVENT(self))){ Q7B_EXCEPTION("QPaintEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPaintEvent(self).rect() );
}

Q7B Q7B_QPAINTEVENT_REGION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPAINTEVENT(self))){ Q7B_EXCEPTION("QPaintEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPaintEvent(self).region() );
}

Q7B Q7B_QPOINT_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPOINT(self))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPoint(self).isNull() );
}

Q7B Q7B_QPOINT_MANHATTANLENGTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPOINT(self))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPoint(self).manhattanLength() );
}

Q7B Q7B_QPOINT_RX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPOINT(self))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPoint(self).rx() );
}

Q7B Q7B_QPOINT_RY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPOINT(self))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPoint(self).ry() );
}

void Q7B_QPOINT_SETX(Q7B self, Q7B X) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPOINT(self))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPoint(self).setX(Q7B_IDqint64(X));
}

void Q7B_QPOINT_SETY(Q7B self, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPOINT(self))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPoint(self).setY(Q7B_IDqint64(Y));
}

Q7B Q7B_QPOINT_X(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPOINT(self))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPoint(self).x() );
}

Q7B Q7B_QPOINT_Y(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPOINT(self))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPoint(self).y() );
}

Q7B Q7B_QPOLYGON_BOUNDINGRECT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPOLYGON(self))){ Q7B_EXCEPTION("QPolygon expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPolygon(self).boundingRect() );
}

Q7B Q7B_QPOLYGON_CONTAINSPOINT(Q7B self, Q7B Point, Q7B FillRule) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPOLYGON(self))){ Q7B_EXCEPTION("QPolygon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Point))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(FillRule))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPolygon(self).containsPoint(Q7B_IDQPoint(Point), (Qt::FillRule) Q7B_IDqint64(FillRule)) );
}

Q7B Q7B_QPOLYGON_INTERSECTED(Q7B self, Q7B R) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPOLYGON(self))){ Q7B_EXCEPTION("QPolygon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOLYGON(R))){ Q7B_EXCEPTION("QPolygon expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPolygon(self).intersected(Q7B_IDQPolygon(R)) );
}

Q7B Q7B_QPOLYGON_POINT(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPOLYGON(self))){ Q7B_EXCEPTION("QPolygon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPolygon(self).point(Q7B_IDqint64(Index)) );
}

void Q7B_QPOLYGON_PUTPOINTS(Q7B self, Q7B Index, Q7B NPoints, Q7B FromPolygon, Q7B FromIndex) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPOLYGON(self))){ Q7B_EXCEPTION("QPolygon expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(NPoints))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QPOLYGON(FromPolygon))){ Q7B_EXCEPTION("QPolygon expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(FromIndex))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQPolygon(self).putPoints(Q7B_IDqint64(Index), Q7B_IDqint64(NPoints), Q7B_IDQPolygon(FromPolygon), Q7B_IDqint64(FromIndex));
}

void Q7B_QPOLYGON_SETPOINT(Q7B self, Q7B Index, Q7B Point) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPOLYGON(self))){ Q7B_EXCEPTION("QPolygon expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Point))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQPolygon(self).setPoint(Q7B_IDqint64(Index), Q7B_IDQPoint(Point));
}
/*
void Q7B_QPOLYGON_SWAP(Q7B self, Q7B Other) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPOLYGON(self))){ Q7B_EXCEPTION("QPolygon expected"); return ; }

  if (Q7B_nil(Q7B_QPOLYGON(Other))){ Q7B_EXCEPTION("QPolygon expected"); return ; }

  Q7B_IDQPolygon(self).swap(Q7B_IDQPolygon(Other));
}*/

void Q7B_QPOLYGON_TRANSLATE(Q7B self, Q7B Offset) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QPOLYGON(self))){ Q7B_EXCEPTION("QPolygon expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Offset))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQPolygon(self).translate(Q7B_IDQPoint(Offset));
}

Q7B Q7B_QPOLYGON_UNITED(Q7B self, Q7B R) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPOLYGON(self))){ Q7B_EXCEPTION("QPolygon expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOLYGON(R))){ Q7B_EXCEPTION("QPolygon expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPolygon(self).united(Q7B_IDQPolygon(R)) );
}

Q7B Q7B_QPRINTPREVIEWDIALOG_PRINTER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTPREVIEWDIALOG(self))){ Q7B_EXCEPTION("QPrintPreviewDialog expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrintPreviewDialog(self)->printer() );
}

Q7B Q7B_QPRINTERINFO_ISDEFAULT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTERINFO(self))){ Q7B_EXCEPTION("QPrinterInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrinterInfo(self).isDefault() );
}

Q7B Q7B_QPRINTERINFO_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTERINFO(self))){ Q7B_EXCEPTION("QPrinterInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrinterInfo(self).isNull() );
}

Q7B Q7B_QPRINTERINFO_PRINTERNAME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTERINFO(self))){ Q7B_EXCEPTION("QPrinterInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrinterInfo(self).printerName() );
}

Q7B Q7B_QPRINTERINFO_AVAILABLEPRINTERS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTERINFO(self))){ Q7B_EXCEPTION("QPrinterInfo expected"); return Q7B_idnil; }

  QList<QPrinterInfo> l = Q7B_IDQPrinterInfo(self).availablePrinters();

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

  for (int i = 0; i < l.size(); i++){
     a->append(Q7B_ID( l.at(i)));
  }

  return q;
}

Q7B Q7B_QPRINTERINFO_DEFAULTPRINTER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QPRINTERINFO(self))){ Q7B_EXCEPTION("QPrinterInfo expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQPrinterInfo(self).defaultPrinter() );
}

void Q7B_QRECT_ADJUST(Q7B self, Q7B Dx1, Q7B Dy1, Q7B Dx2, Q7B Dy2) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dx1))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dy1))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dx2))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Dy2))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).adjust(Q7B_IDqint64(Dx1), Q7B_IDqint64(Dy1), Q7B_IDqint64(Dx2), Q7B_IDqint64(Dy2));
}

Q7B Q7B_QRECT_ADJUSTED(Q7B self, Q7B Dx1, Q7B Dy1, Q7B Dx2, Q7B Dy2) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Dx1))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Dy1))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Dx2))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Dy2))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).adjusted(Q7B_IDqint64(Dx1), Q7B_IDqint64(Dy1), Q7B_IDqint64(Dx2), Q7B_IDqint64(Dy2)) );
}

Q7B Q7B_QRECT_BOTTOM(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).bottom() );
}

Q7B Q7B_QRECT_BOTTOMLEFT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).bottomLeft() );
}

Q7B Q7B_QRECT_BOTTOMRIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).bottomRight() );
}

Q7B Q7B_QRECT_CENTER(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).center() );
}

Q7B Q7B_QRECT_CONTAINS(Q7B self, Q7B Rectangle, Q7B Proper) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOL(Proper))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).contains(Q7B_IDQRect(Rectangle), Q7B_IDbool(Proper)) );
}

Q7B Q7B_QRECT_HEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).height() );
}

Q7B Q7B_QRECT_INTERSECTED(Q7B self, Q7B Rectangle) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).intersected(Q7B_IDQRect(Rectangle)) );
}

Q7B Q7B_QRECT_INTERSECTS(Q7B self, Q7B Rectangle) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).intersects(Q7B_IDQRect(Rectangle)) );
}

Q7B Q7B_QRECT_ISEMPTY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).isEmpty() );
}

Q7B Q7B_QRECT_ISNULL(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).isNull() );
}

Q7B Q7B_QRECT_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).isValid() );
}

Q7B Q7B_QRECT_LEFT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).left() );
}

void Q7B_QRECT_MOVEBOTTOM(Q7B self, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).moveBottom(Q7B_IDqint64(Y));
}

void Q7B_QRECT_MOVEBOTTOMLEFT(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRect(self).moveBottomLeft(Q7B_IDQPoint(Position));
}

void Q7B_QRECT_MOVEBOTTOMRIGHT(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRect(self).moveBottomRight(Q7B_IDQPoint(Position));
}

void Q7B_QRECT_MOVECENTER(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRect(self).moveCenter(Q7B_IDQPoint(Position));
}

void Q7B_QRECT_MOVELEFT(Q7B self, Q7B X) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).moveLeft(Q7B_IDqint64(X));
}

void Q7B_QRECT_MOVERIGHT(Q7B self, Q7B X) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).moveRight(Q7B_IDqint64(X));
}

void Q7B_QRECT_MOVETO(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRect(self).moveTo(Q7B_IDQPoint(Position));
}

void Q7B_QRECT_MOVETOP(Q7B self, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).moveTop(Q7B_IDqint64(Y));
}

void Q7B_QRECT_MOVETOPLEFT(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRect(self).moveTopLeft(Q7B_IDQPoint(Position));
}

void Q7B_QRECT_MOVETOPRIGHT(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRect(self).moveTopRight(Q7B_IDQPoint(Position));
}

Q7B Q7B_QRECT_NORMALIZED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).normalized() );
}

Q7B Q7B_QRECT_RIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).right() );
}

void Q7B_QRECT_SETBOTTOM(Q7B self, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).setBottom(Q7B_IDqint64(Y));
}

void Q7B_QRECT_SETBOTTOMLEFT(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRect(self).setBottomLeft(Q7B_IDQPoint(Position));
}

void Q7B_QRECT_SETBOTTOMRIGHT(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRect(self).setBottomRight(Q7B_IDQPoint(Position));
}

void Q7B_QRECT_SETCOORDS(Q7B self, Q7B X1, Q7B Y1, Q7B X2, Q7B Y2) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X1))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y1))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X2))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y2))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).setCoords(Q7B_IDqint64(X1), Q7B_IDqint64(Y1), Q7B_IDqint64(X2), Q7B_IDqint64(Y2));
}

void Q7B_QRECT_SETHEIGHT(Q7B self, Q7B Height) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Height))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).setHeight(Q7B_IDqint64(Height));
}

void Q7B_QRECT_SETLEFT(Q7B self, Q7B X) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).setLeft(Q7B_IDqint64(X));
}

void Q7B_QRECT_SETRECT(Q7B self, Q7B X, Q7B Y, Q7B Width, Q7B Height) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Height))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).setRect(Q7B_IDqint64(X), Q7B_IDqint64(Y), Q7B_IDqint64(Width), Q7B_IDqint64(Height));
}

void Q7B_QRECT_SETRIGHT(Q7B self, Q7B X) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).setRight(Q7B_IDqint64(X));
}

void Q7B_QRECT_SETSIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QSIZE(Size))){ Q7B_EXCEPTION("QSize expected"); return ; }

  Q7B_IDQRect(self).setSize(Q7B_IDQSize(Size));
}

void Q7B_QRECT_SETTOP(Q7B self, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).setTop(Q7B_IDqint64(Y));
}

void Q7B_QRECT_SETTOPLEFT(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRect(self).setTopLeft(Q7B_IDQPoint(Position));
}

void Q7B_QRECT_SETTOPRIGHT(Q7B self, Q7B Position) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Position))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRect(self).setTopRight(Q7B_IDQPoint(Position));
}

void Q7B_QRECT_SETWIDTH(Q7B self, Q7B Width) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Width))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).setWidth(Q7B_IDqint64(Width));
}

void Q7B_QRECT_SETX(Q7B self, Q7B X) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(X))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).setX(Q7B_IDqint64(X));
}

void Q7B_QRECT_SETY(Q7B self, Q7B Y) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Y))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQRect(self).setY(Q7B_IDqint64(Y));
}

Q7B Q7B_QRECT_SIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).size() );
}

Q7B Q7B_QRECT_TOP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).top() );
}

Q7B Q7B_QRECT_TOPLEFT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).topLeft() );
}

Q7B Q7B_QRECT_TOPRIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).topRight() );
}

void Q7B_QRECT_TRANSLATE(Q7B self, Q7B Offset) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return ; }

  if (Q7B_nil(Q7B_QPOINT(Offset))){ Q7B_EXCEPTION("QPoint expected"); return ; }

  Q7B_IDQRect(self).translate(Q7B_IDQPoint(Offset));
}

Q7B Q7B_QRECT_TRANSLATED(Q7B self, Q7B Offset) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPOINT(Offset))){ Q7B_EXCEPTION("QPoint expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).translated(Q7B_IDQPoint(Offset)) );
}

Q7B Q7B_QRECT_UNITED(Q7B self, Q7B Rectangle) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QRECT(Rectangle))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).united(Q7B_IDQRect(Rectangle)) );
}

Q7B Q7B_QRECT_WIDTH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).width() );
}

Q7B Q7B_QRECT_X(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).x() );
}

Q7B Q7B_QRECT_Y(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRECT(self))){ Q7B_EXCEPTION("QRect expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQRect(self).y() );
}

Q7B Q7B_QRESIZEEVENT_OLDSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRESIZEEVENT(self))){ Q7B_EXCEPTION("QResizeEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQResizeEvent(self).oldSize() );
}

Q7B Q7B_QRESIZEEVENT_SIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QRESIZEEVENT(self))){ Q7B_EXCEPTION("QResizeEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQResizeEvent(self).size() );
}

Q7B Q7B_QSHORTCUTEVENT_ISAMBIGUOUS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSHORTCUTEVENT(self))){ Q7B_EXCEPTION("QShortcutEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQShortcutEvent(self).isAmbiguous() );
}

Q7B Q7B_QSHORTCUTEVENT_KEY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSHORTCUTEVENT(self))){ Q7B_EXCEPTION("QShortcutEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQShortcutEvent(self).key() );
}

Q7B Q7B_QSHORTCUTEVENT_SHORTCUTID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSHORTCUTEVENT(self))){ Q7B_EXCEPTION("QShortcutEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQShortcutEvent(self).shortcutId() );
}

Q7B Q7B_QSTATUSTIPEVENT_TIP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTATUSTIPEVENT(self))){ Q7B_EXCEPTION("QStatusTipEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQStatusTipEvent(self).tip() );
}

Q7B Q7B_QTEXTBLOCKFORMAT_ALIGNMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) Q7B_IDQTextBlockFormat(self).alignment() );
}

Q7B Q7B_QTEXTBLOCKFORMAT_BOTTOMMARGIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBlockFormat(self).bottomMargin() );
}

Q7B Q7B_QTEXTBLOCKFORMAT_INDENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBlockFormat(self).indent() );
}

Q7B Q7B_QTEXTBLOCKFORMAT_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBlockFormat(self).isValid() );
}

Q7B Q7B_QTEXTBLOCKFORMAT_LEFTMARGIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBlockFormat(self).leftMargin() );
}
/*
Q7B Q7B_QTEXTBLOCKFORMAT_LINEHEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBlockFormat(self).lineHeight() );
}*//*

Q7B Q7B_QTEXTBLOCKFORMAT_LINEHEIGHTTYPE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBlockFormat(self).lineHeightType() );
}*/

Q7B Q7B_QTEXTBLOCKFORMAT_NONBREAKABLELINES(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBlockFormat(self).nonBreakableLines() );
}

Q7B Q7B_QTEXTBLOCKFORMAT_PAGEBREAKPOLICY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBlockFormat(self).pageBreakPolicy() );
}

Q7B Q7B_QTEXTBLOCKFORMAT_RIGHTMARGIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBlockFormat(self).rightMargin() );
}

void Q7B_QTEXTBLOCKFORMAT_SETALIGNMENT(Q7B self, Q7B Alignment) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Alignment))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextBlockFormat(self).setAlignment((Qt::Alignment) Q7B_IDqint64(Alignment));
}

void Q7B_QTEXTBLOCKFORMAT_SETBOTTOMMARGIN(Q7B self, Q7B Margin) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Margin))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQTextBlockFormat(self).setBottomMargin(Q7B_IDqreal(Margin));
}

void Q7B_QTEXTBLOCKFORMAT_SETINDENT(Q7B self, Q7B Indentation) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Indentation))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextBlockFormat(self).setIndent(Q7B_IDqint64(Indentation));
}

void Q7B_QTEXTBLOCKFORMAT_SETLEFTMARGIN(Q7B self, Q7B Margin) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Margin))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQTextBlockFormat(self).setLeftMargin(Q7B_IDqreal(Margin));
}
/*
void Q7B_QTEXTBLOCKFORMAT_SETLINEHEIGHT(Q7B self, Q7B Height, Q7B HeightType) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Height))){ Q7B_EXCEPTION("Float expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(HeightType))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextBlockFormat(self).setLineHeight(Q7B_IDqreal(Height), Q7B_IDqint64(HeightType));
}*/

void Q7B_QTEXTBLOCKFORMAT_SETNONBREAKABLELINES(Q7B self, Q7B B) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(B))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextBlockFormat(self).setNonBreakableLines(Q7B_IDbool(B));
}

void Q7B_QTEXTBLOCKFORMAT_SETPAGEBREAKPOLICY(Q7B self, Q7B Policy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Policy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextBlockFormat(self).setPageBreakPolicy((QTextBlockFormat::PageBreakFlags) Q7B_IDqint64(Policy));
}

void Q7B_QTEXTBLOCKFORMAT_SETRIGHTMARGIN(Q7B self, Q7B Margin) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Margin))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQTextBlockFormat(self).setRightMargin(Q7B_IDqreal(Margin));
}

void Q7B_QTEXTBLOCKFORMAT_SETTEXTINDENT(Q7B self, Q7B Indent) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Indent))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQTextBlockFormat(self).setTextIndent(Q7B_IDqreal(Indent));
}

void Q7B_QTEXTBLOCKFORMAT_SETTOPMARGIN(Q7B self, Q7B Margin) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Margin))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQTextBlockFormat(self).setTopMargin(Q7B_IDqreal(Margin));
}

Q7B Q7B_QTEXTBLOCKFORMAT_TEXTINDENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBlockFormat(self).textIndent() );
}

Q7B Q7B_QTEXTBLOCKFORMAT_TOPMARGIN(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTBLOCKFORMAT(self))){ Q7B_EXCEPTION("QTextBlockFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextBlockFormat(self).topMargin() );
}

Q7B Q7B_QTEXTCHARFORMAT_ANCHORHREF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).anchorHref() );
}

Q7B Q7B_QTEXTCHARFORMAT_ANCHORNAMES(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).anchorNames() );
}

Q7B Q7B_QTEXTCHARFORMAT_FONT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).font() );
}

Q7B Q7B_QTEXTCHARFORMAT_FONTCAPITALIZATION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontCapitalization() );
}

Q7B Q7B_QTEXTCHARFORMAT_FONTFAMILY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontFamily() );
}

Q7B Q7B_QTEXTCHARFORMAT_FONTFIXEDPITCH(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontFixedPitch() );
}
/*
Q7B Q7B_QTEXTCHARFORMAT_FONTHINTINGPREFERENCE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontHintingPreference() );
}*/

Q7B Q7B_QTEXTCHARFORMAT_FONTITALIC(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontItalic() );
}

Q7B Q7B_QTEXTCHARFORMAT_FONTLETTERSPACING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontLetterSpacing() );
}

Q7B Q7B_QTEXTCHARFORMAT_FONTOVERLINE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontOverline() );
}

Q7B Q7B_QTEXTCHARFORMAT_FONTPOINTSIZE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontPointSize() );
}

Q7B Q7B_QTEXTCHARFORMAT_FONTSTRIKEOUT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontStrikeOut() );
}

Q7B Q7B_QTEXTCHARFORMAT_FONTSTYLEHINT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontStyleHint() );
}

Q7B Q7B_QTEXTCHARFORMAT_FONTSTYLESTRATEGY(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontStyleStrategy() );
}

Q7B Q7B_QTEXTCHARFORMAT_FONTUNDERLINE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontUnderline() );
}

Q7B Q7B_QTEXTCHARFORMAT_FONTWEIGHT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontWeight() );
}

Q7B Q7B_QTEXTCHARFORMAT_FONTWORDSPACING(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).fontWordSpacing() );
}

Q7B Q7B_QTEXTCHARFORMAT_ISANCHOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).isAnchor() );
}

Q7B Q7B_QTEXTCHARFORMAT_ISVALID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).isValid() );
}

void Q7B_QTEXTCHARFORMAT_SETANCHOR(Q7B self, Q7B Anchor) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Anchor))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextCharFormat(self).setAnchor(Q7B_IDbool(Anchor));
}

void Q7B_QTEXTCHARFORMAT_SETANCHORHREF(Q7B self, Q7B Value) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextCharFormat(self).setAnchorHref(Q7B_IDQString(Value));
}

void Q7B_QTEXTCHARFORMAT_SETANCHORNAMES(Q7B self, Q7B Names) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(Names))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQTextCharFormat(self).setAnchorNames(Q7B_IDQStringList(Names));
}

void Q7B_QTEXTCHARFORMAT_SETFONT(Q7B self, Q7B Font) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QFONT(Font))){ Q7B_EXCEPTION("QFont expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFont(Q7B_IDQFont(Font));
}

void Q7B_QTEXTCHARFORMAT_SETFONTCAPITALIZATION(Q7B self, Q7B Capitalization) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Capitalization))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontCapitalization((QFont::Capitalization) Q7B_IDqint64(Capitalization));
}

void Q7B_QTEXTCHARFORMAT_SETFONTFAMILY(Q7B self, Q7B Family) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Family))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontFamily(Q7B_IDQString(Family));
}

void Q7B_QTEXTCHARFORMAT_SETFONTFIXEDPITCH(Q7B self, Q7B FixedPitch) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(FixedPitch))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontFixedPitch(Q7B_IDbool(FixedPitch));
}
/*
void Q7B_QTEXTCHARFORMAT_SETFONTHINTINGPREFERENCE(Q7B self, Q7B HintingPreference) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(HintingPreference))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontHintingPreference((QFont::HintingPreference) Q7B_IDqint64(HintingPreference));
}*/

void Q7B_QTEXTCHARFORMAT_SETFONTITALIC(Q7B self, Q7B Italic) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Italic))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontItalic(Q7B_IDbool(Italic));
}

void Q7B_QTEXTCHARFORMAT_SETFONTLETTERSPACING(Q7B self, Q7B Spacing) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Spacing))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontLetterSpacing(Q7B_IDqreal(Spacing));
}

void Q7B_QTEXTCHARFORMAT_SETFONTOVERLINE(Q7B self, Q7B Overline) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Overline))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontOverline(Q7B_IDbool(Overline));
}

void Q7B_QTEXTCHARFORMAT_SETFONTPOINTSIZE(Q7B self, Q7B Size) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Size))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontPointSize(Q7B_IDqreal(Size));
}

void Q7B_QTEXTCHARFORMAT_SETFONTSTRIKEOUT(Q7B self, Q7B StrikeOut) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(StrikeOut))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontStrikeOut(Q7B_IDbool(StrikeOut));
}

void Q7B_QTEXTCHARFORMAT_SETFONTSTYLEHINT(Q7B self, Q7B Hint, Q7B Strategy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Hint))){ Q7B_EXCEPTION("Integer expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Strategy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontStyleHint((QFont::StyleHint) Q7B_IDqint64(Hint), (QFont::StyleStrategy) Q7B_IDqint64(Strategy));
}

void Q7B_QTEXTCHARFORMAT_SETFONTSTYLESTRATEGY(Q7B self, Q7B Strategy) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Strategy))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontStyleStrategy((QFont::StyleStrategy) Q7B_IDqint64(Strategy));
}

void Q7B_QTEXTCHARFORMAT_SETFONTUNDERLINE(Q7B self, Q7B UnderLine) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(UnderLine))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontUnderline(Q7B_IDbool(UnderLine));
}

void Q7B_QTEXTCHARFORMAT_SETFONTWEIGHT(Q7B self, Q7B Weight) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Weight))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontWeight(Q7B_IDqint64(Weight));
}

void Q7B_QTEXTCHARFORMAT_SETFONTWORDSPACING(Q7B self, Q7B Spacing) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QREAL(Spacing))){ Q7B_EXCEPTION("Float expected"); return ; }

  Q7B_IDQTextCharFormat(self).setFontWordSpacing(Q7B_IDqreal(Spacing));
}

void Q7B_QTEXTCHARFORMAT_SETTEXTOUTLINE(Q7B self, Q7B Pen) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QPEN(Pen))){ Q7B_EXCEPTION("QPen expected"); return ; }

  Q7B_IDQTextCharFormat(self).setTextOutline(Q7B_IDQPen(Pen));
}

void Q7B_QTEXTCHARFORMAT_SETTOOLTIP(Q7B self, Q7B Text) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return ; }

  Q7B_IDQTextCharFormat(self).setToolTip(Q7B_IDQString(Text));
}

void Q7B_QTEXTCHARFORMAT_SETUNDERLINECOLOR(Q7B self, Q7B Color) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QCOLOR(Color))){ Q7B_EXCEPTION("QColor expected"); return ; }

  Q7B_IDQTextCharFormat(self).setUnderlineColor(Q7B_IDQColor(Color));
}

void Q7B_QTEXTCHARFORMAT_SETUNDERLINESTYLE(Q7B self, Q7B Style) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Style))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextCharFormat(self).setUnderlineStyle((QTextCharFormat::UnderlineStyle) Q7B_IDqint64(Style));
}

void Q7B_QTEXTCHARFORMAT_SETVERTICALALIGNMENT(Q7B self, Q7B Alignment) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Alignment))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQTextCharFormat(self).setVerticalAlignment((QTextCharFormat::VerticalAlignment) Q7B_IDqint64(Alignment));
}

Q7B Q7B_QTEXTCHARFORMAT_TEXTOUTLINE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).textOutline() );
}

Q7B Q7B_QTEXTCHARFORMAT_TOOLTIP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).toolTip() );
}

Q7B Q7B_QTEXTCHARFORMAT_UNDERLINECOLOR(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).underlineColor() );
}

Q7B Q7B_QTEXTCHARFORMAT_UNDERLINESTYLE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).underlineStyle() );
}

Q7B Q7B_QTEXTCHARFORMAT_VERTICALALIGNMENT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTCHARFORMAT(self))){ Q7B_EXCEPTION("QTextCharFormat expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextCharFormat(self).verticalAlignment() );
}

Q7B Q7B_QTEXTDOCUMENTFRAGMENT_TOHTML(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENTFRAGMENT(self))){ Q7B_EXCEPTION("QTextDocumentFragment expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocumentFragment(self).toHtml() );
}

Q7B Q7B_QTEXTDOCUMENTFRAGMENT_TOPLAINTEXT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTEXTDOCUMENTFRAGMENT(self))){ Q7B_EXCEPTION("QTextDocumentFragment expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTextDocumentFragment(self).toPlainText() );
}

Q7B Q7B_QTIMEREVENT_TIMERID(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QTIMEREVENT(self))){ Q7B_EXCEPTION("QTimerEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQTimerEvent(self).timerId() );
}

Q7B Q7B_QWHATSTHISCLICKEDEVENT_HREF(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWHATSTHISCLICKEDEVENT(self))){ Q7B_EXCEPTION("QWhatsThisClickedEvent expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQWhatsThisClickedEvent(self).href() );
}

Q7B Q7B_QWINDOWSTATECHANGEEVENT_OLDSTATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QWINDOWSTATECHANGEEVENT(self))){ Q7B_EXCEPTION("QWindowStateChangeEvent expected"); return Q7B_idnil; }

  return Q7B_ID( (qint64) Q7B_IDQWindowStateChangeEvent(self).oldState() );
}


Q7B Q7B_QDATETIMEEDIT_CALENDARPOPUP(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->calendarPopup() );
}

void Q7B_QDATETIMEEDIT_CALENDARPOPUP(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(theProperty))){ Q7B_EXCEPTION("bool expected"); return; }

  Q7B_IDQDateTimeEdit(self)->setCalendarPopup(Q7B_IDbool(theProperty));
}

Q7B Q7B_QDATETIMEEDIT_CALENDARWIDGET(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->calendarWidget() );
}

void Q7B_QDATETIMEEDIT_CLEARMAXIMUMDATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->clearMaximumDate();
}

void Q7B_QDATETIMEEDIT_CLEARMAXIMUMDATETIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->clearMaximumDateTime();
}

void Q7B_QDATETIMEEDIT_CLEARMAXIMUMTIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->clearMaximumTime();
}

void Q7B_QDATETIMEEDIT_CLEARMINIMUMDATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->clearMinimumDate();
}

void Q7B_QDATETIMEEDIT_CLEARMINIMUMDATETIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->clearMinimumDateTime();
}

void Q7B_QDATETIMEEDIT_CLEARMINIMUMTIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->clearMinimumTime();
}

Q7B Q7B_QDATETIMEEDIT_CURRENTSECTION(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->currentSection() );
}

void Q7B_QDATETIMEEDIT_CURRENTSECTION(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQDateTimeEdit(self)->setCurrentSection((QDateTimeEdit::Section) Q7B_IDqint64(theProperty));
}

Q7B Q7B_QDATETIMEEDIT_CURRENTSECTIONINDEX(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->currentSectionIndex() );
}

void Q7B_QDATETIMEEDIT_CURRENTSECTIONINDEX(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQDateTimeEdit(self)->setCurrentSectionIndex(Q7B_IDqint64(theProperty));
}

Q7B Q7B_QDATETIMEEDIT_DATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->date() );
}

void Q7B_QDATETIMEEDIT_DATE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QDATE(theProperty))){ Q7B_EXCEPTION("QDate expected"); return; }

  Q7B_IDQDateTimeEdit(self)->setDate(Q7B_IDQDate(theProperty));
}

Q7B Q7B_QDATETIMEEDIT_DATETIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->dateTime() );
}

void Q7B_QDATETIMEEDIT_DATETIME(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QDATETIME(theProperty))){ Q7B_EXCEPTION("QDateTime expected"); return; }

  Q7B_IDQDateTimeEdit(self)->setDateTime(Q7B_IDQDateTime(theProperty));
}

Q7B Q7B_QDATETIMEEDIT_DISPLAYFORMAT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->displayFormat() );
}

void Q7B_QDATETIMEEDIT_DISPLAYFORMAT(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QSTRING(theProperty))){ Q7B_EXCEPTION("QString expected"); return; }

  Q7B_IDQDateTimeEdit(self)->setDisplayFormat(Q7B_IDQString(theProperty));
}

Q7B Q7B_QDATETIMEEDIT_DISPLAYEDSECTIONS(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->displayedSections() );
}

void Q7B_QDATETIMEEDIT_DISPLAYEDSECTIONS(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(theProperty))){ Q7B_EXCEPTION("qint64 expected"); return; }

  Q7B_IDQDateTimeEdit(self)->setProperty("displayedSections", Q7B_IDqint64(theProperty));
}

Q7B Q7B_QDATETIMEEDIT_MAXIMUMDATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->maximumDate() );
}

void Q7B_QDATETIMEEDIT_MAXIMUMDATE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QDATE(theProperty))){ Q7B_EXCEPTION("QDate expected"); return; }

  Q7B_IDQDateTimeEdit(self)->setMaximumDate(Q7B_IDQDate(theProperty));
}

Q7B Q7B_QDATETIMEEDIT_MAXIMUMDATETIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->maximumDateTime() );
}

void Q7B_QDATETIMEEDIT_MAXIMUMDATETIME(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QDATETIME(theProperty))){ Q7B_EXCEPTION("QDateTime expected"); return; }

  Q7B_IDQDateTimeEdit(self)->setMaximumDateTime(Q7B_IDQDateTime(theProperty));
}

Q7B Q7B_QDATETIMEEDIT_MAXIMUMTIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->maximumTime() );
}

void Q7B_QDATETIMEEDIT_MAXIMUMTIME(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QTIME(theProperty))){ Q7B_EXCEPTION("QTime expected"); return; }

  Q7B_IDQDateTimeEdit(self)->setMaximumTime(Q7B_IDQTime(theProperty));
}

Q7B Q7B_QDATETIMEEDIT_MINIMUMDATE(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->minimumDate() );
}

void Q7B_QDATETIMEEDIT_MINIMUMDATE(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QDATE(theProperty))){ Q7B_EXCEPTION("QDate expected"); return; }

  Q7B_IDQDateTimeEdit(self)->setMinimumDate(Q7B_IDQDate(theProperty));
}

Q7B Q7B_QDATETIMEEDIT_MINIMUMDATETIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->minimumDateTime() );
}

void Q7B_QDATETIMEEDIT_MINIMUMDATETIME(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QDATETIME(theProperty))){ Q7B_EXCEPTION("QDateTime expected"); return; }

  Q7B_IDQDateTimeEdit(self)->setMinimumDateTime(Q7B_IDQDateTime(theProperty));
}

Q7B Q7B_QDATETIMEEDIT_MINIMUMTIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->minimumTime() );
}

void Q7B_QDATETIMEEDIT_MINIMUMTIME(Q7B self, Q7B theProperty) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QTIME(theProperty))){ Q7B_EXCEPTION("QTime expected"); return; }

  Q7B_IDQDateTimeEdit(self)->setMinimumTime(Q7B_IDQTime(theProperty));
}

Q7B Q7B_QDATETIMEEDIT_SECTIONAT(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->sectionAt(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QDATETIMEEDIT_SECTIONCOUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->sectionCount() );
}

Q7B Q7B_QDATETIMEEDIT_SECTIONTEXT(Q7B self, Q7B Section) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QINT64(Section))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->sectionText((QDateTimeEdit::Section) Q7B_IDqint64(Section)) );
}

void Q7B_QDATETIMEEDIT_SETCALENDARPOPUP(Q7B self, Q7B Enable) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_BOOL(Enable))){ Q7B_EXCEPTION("Boolean expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->setCalendarPopup(Q7B_IDbool(Enable));
}

void Q7B_QDATETIMEEDIT_SETCALENDARWIDGET(Q7B self, Q7B CalendarWidget) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QCALENDARWIDGET(CalendarWidget))){ Q7B_EXCEPTION("QCalendarWidget expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->setCalendarWidget(Q7B_IDQCalendarWidget(CalendarWidget));
}

void Q7B_QDATETIMEEDIT_SETDATE(Q7B self, Q7B Date) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QDATE(Date))){ Q7B_EXCEPTION("QDate expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->setDate(Q7B_IDQDate(Date));
}

void Q7B_QDATETIMEEDIT_SETDATERANGE(Q7B self, Q7B Minimum, Q7B Maximum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QDATE(Minimum))){ Q7B_EXCEPTION("QDate expected"); return ; }

  if (Q7B_nil(Q7B_QDATE(Maximum))){ Q7B_EXCEPTION("QDate expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->setDateRange(Q7B_IDQDate(Minimum), Q7B_IDQDate(Maximum));
}

void Q7B_QDATETIMEEDIT_SETDATETIME(Q7B self, Q7B DateTime) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QDATETIME(DateTime))){ Q7B_EXCEPTION("QDateTime expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->setDateTime(Q7B_IDQDateTime(DateTime));
}

void Q7B_QDATETIMEEDIT_SETDATETIMERANGE(Q7B self, Q7B Minimum, Q7B Maximum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QDATETIME(Minimum))){ Q7B_EXCEPTION("QDateTime expected"); return ; }

  if (Q7B_nil(Q7B_QDATETIME(Maximum))){ Q7B_EXCEPTION("QDateTime expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->setDateTimeRange(Q7B_IDQDateTime(Minimum), Q7B_IDQDateTime(Maximum));
}

void Q7B_QDATETIMEEDIT_SETSELECTEDSECTION(Q7B self, Q7B Section) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QINT64(Section))){ Q7B_EXCEPTION("Integer expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->setSelectedSection((QDateTimeEdit::Section) Q7B_IDqint64(Section));
}

void Q7B_QDATETIMEEDIT_SETTIME(Q7B self, Q7B Time) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QTIME(Time))){ Q7B_EXCEPTION("QTime expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->setTime(Q7B_IDQTime(Time));
}

void Q7B_QDATETIMEEDIT_SETTIMERANGE(Q7B self, Q7B Minimum, Q7B Maximum) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return ; }

  if (Q7B_nil(Q7B_QTIME(Minimum))){ Q7B_EXCEPTION("QTime expected"); return ; }

  if (Q7B_nil(Q7B_QTIME(Maximum))){ Q7B_EXCEPTION("QTime expected"); return ; }

  Q7B_IDQDateTimeEdit(self)->setTimeRange(Q7B_IDQTime(Minimum), Q7B_IDQTime(Maximum));
}

Q7B Q7B_QDATETIMEEDIT_TIME(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QDATETIMEEDIT(self))){ Q7B_EXCEPTION("QDateTimeEdit expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQDateTimeEdit(self)->time() );
}

void Q7B_QLISTQSTRINGLIST_APPEND(Q7B self, Q7B s) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return ; }
  if (Q7B_nil(Q7B_QLISTQSTRINGLIST(self))){ Q7B_EXCEPTION("QList<QStringList> expected"); return ; }

  if (Q7B_nil(Q7B_QSTRINGLIST(s))){ Q7B_EXCEPTION("QStringList expected"); return ; }

  Q7B_IDQListQStringList(self).append(Q7B_IDQStringList(s));
}

Q7B Q7B_QLISTQSTRINGLIST_AT(Q7B self, Q7B Index) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTQSTRINGLIST(self))){ Q7B_EXCEPTION("QList<QStringList> expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListQStringList(self).at(Q7B_IDqint64(Index)) );
}

Q7B Q7B_QLISTQSTRINGLIST_COUNT(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QLISTQSTRINGLIST(self))){ Q7B_EXCEPTION("QList<QStringList> expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQListQStringList(self).count() );
}

//#endif

/*

Q7B Q7B_QSTRING_SIMPLIFIED(Q7B self) // generated
{
  if (Q7B_nil(self)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(self))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_ID( Q7B_IDQString(self).simplified() );
}*/

/*
class _bytecode
{
public:
  QString id;
  QVariant value;
};

#define _bytecodes QList<_bytecode>
*/

bool Q7B_bVMError = false;

extern Q7B VM_Q7B_Call(QString sClass, QString sProcedure, void *theObject, QList<Q7B> args);
extern Q7B VM_Q7B_ClassSingleTone(QString sClass);

//extern QMap<QString, Q7B> * Q7B_VM_me_vars_get(Q7B theObject);
extern Q7B Q7B_MainWindow_Object();
extern Q7B Q7B_Global_Object();

//QMap<QString, Q7B>  Q7B_VM_objects;

class Q7B_VM
{
public:
/*
Q7B_VM()
{
  Q7B_VM_bytecode_pos = 0;
  me_pointer_VM = 0;
}*/

_bytecodes Q7B_VM_bytecode;
int Q7B_VM_bytecode_pos;
QStack<Q7B> Q7B_VM_stack;
QMap<QString, Q7B>  Q7B_VM_localdim;
QMap<QString, Q7B>  Q7B_VM_me_vars;
QMap<QString, Q7B>  Q7B_VM_args;
QMap<QString, Q7B>  *Q7B_VM_statics;
QStack<qint64> LOOPSTART;
QStack<qint64> LOOPEND;
void *me_pointer_VM;
QString me_classname_VM;
const char *ac_me_classname_VM;
Q7B Q7B_return;
Q7B me_VM;



Q7B Q7B_peek()
{  
  return Q7B_VM_stack.top();
}

Q7B Q7B_pop()
{  
  return Q7B_VM_stack.pop();
}

void Q7B_push(Q7B o)
{  
  Q7B_VM_stack.push(o);
}

void Q7B_BuiltinSubFunction_VM()
{
  QString s = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toString(); 
  bool bReturn = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toBool(); 

  // TODO generator f?r alle functions
  if (s == "Q7B__MSGBOX") if (bReturn) Q7B_push(Q7B__MSGBOX(Q7B_pop())); else Q7B__MSGBOX(Q7B_pop());
  if (s == "Q7B_PROPERTY") if (bReturn) Q7B_push(Q7B_PROPERTY(Q7B_pop(), Q7B_pop())); else Q7B_PROPERTY(Q7B_pop(), Q7B_pop());
  else s = s; // error
}

void Q7B_BuiltinClassPropertyOrProcedure_VM()  
{
  QString s = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toString(); 
  bool bReturn = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toBool(); 
  int nArgsCount = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toInt() + 1; 

  // TODO generator f?r alle functions
  if (s == "Q7B_QSTRING_SIMPLIFIED") if (bReturn) Q7B_push(Q7B_QSTRING_SIMPLIFIED(Q7B_pop())); else Q7B_QSTRING_SIMPLIFIED(Q7B_pop());
  else if (s == "Q7B_QABSTRACTBUTTON_TEXT" && nArgsCount == 2) Q7B_QABSTRACTBUTTON_TEXT(Q7B_pop(), Q7B_pop()); 
  else if (s == "Q7B_QABSTRACTBUTTON_TEXT" && nArgsCount == 1) if (bReturn) Q7B_push(Q7B_QABSTRACTBUTTON_TEXT(Q7B_pop())); else Q7B_QABSTRACTBUTTON_TEXT(Q7B_pop());

  else if (s == "Q7B_DIR_LIST" && nArgsCount == 2) if (bReturn) Q7B_push(Q7B_DIR_LIST(Q7B_pop(), Q7B_pop())); else Q7B_DIR_LIST(Q7B_pop(), Q7B_pop());


  else s = s; // error
}

void Q7B_Call_VM()
{
  //QString sClass = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toString(); 
  QString sProcedure = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toString(); 
  bool bReturn = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toBool(); 
  int nArgsCount = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toInt(); 

  QList<Q7B> args;

  for (int i = 0; i < nArgsCount; i++){
    args << Q7B_pop();
  }

  Q7B theObject = Q7B_pop();
  QString sClass = theObject->type;

  if (bReturn) Q7B_push(VM_Q7B_Call(sClass, sProcedure, theObject->ref, args)); else VM_Q7B_Call(sClass, sProcedure, theObject->ref, args); 
}

void Q7B_Float_VM()
{  
  qreal Float = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toDouble(); 

  Q7B_push(Q7B_ID(Float));
}

void Q7B_Integer_VM()
{  
  qint64 Integer = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toLongLong(); 

  Q7B_push(Q7B_ID(Integer));
}

void Q7B_Boolean_VM()
{  
  bool Boolean = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toBool(); 

  Q7B_push(Q7B_ID(Boolean));
}

void Q7B_String_VM()
{  
  QString s = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toString(); 

  Q7B_push(Q7B_ID(s));
}

void Q7B_Decimal_VM()
{  
  QString bc = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toString(); 
  QString ad = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toString(); 

  Q7B_push(Q7B_ID_DECIMAL(bc.toLongLong(), ad.toLongLong()));
}

void Q7B_Debug_VM()
{
  Q7BS(Q7B_toString2(Q7B_pop()), Q7B_toString2(Q7B_pop()), Q7B_toString2(Q7B_pop()), Q7B_toString2(Q7B_pop()));
}

void Q7B_DebugAndAlso_VM()
{
  Q7BS(Q7B_toString2(Q7B_pop()), Q7B_toString2(Q7B_pop()), Q7B_toString2(Q7B_pop()), Q7B_toString2(Q7B_pop()));

  Q7B_push(Q7B_ID(true));
}

void Q7B_LocalDim_VM()
{
  QString s = Q7B_toString2(Q7B_pop());

  Q7B_VM_localdim[s] = Q7B_ID(); 
  Q7B_VM_localdim[s]->VM_self_Q7B = &Q7B_VM_localdim[s];
}

void Q7B_LocalStatic_VM()
{
  QString s = Q7B_toString2(Q7B_pop());

  Q7B_VM_statics->insert(s, Q7B_ID()); 
  (*Q7B_VM_statics)[s]->VM_self_Q7B = &(*Q7B_VM_statics)[s];

  //Q7B_VM_statics[s]->VM_self_Q7B = &Q7B_VM_statics[s];
  //*Q7B_VM_statics[s]->VM_self_Q7B = &(*Q7B_VM_statics[s]);

  //(Q7B_VM_statics->value(s))->VM_self_Q7B = &(Q7B_VM_statics->value(s));
}

void Q7B_Assignment_VM()
{
  Q7B l = Q7B_pop();
  Q7B r = Q7B_pop();
  
  Q7B *zu = l->VM_self_Q7B;
  Q7B_ASSIGNMENT(&l, &r);

  l->VM_self_Q7B = zu;
  *l->VM_self_Q7B = l;
//  Q7B_ASSIGNMENT(l->VM_self_Q7B, &r);
}

void Q7B_Argument_VM()
{
  QString s = Q7B_toString2(Q7B_pop());

  Q7B_push(Q7B_VM_args[s]); 
  Q7B_VM_args[s]->VM_self_Q7B = &Q7B_VM_args[s];
}
/*
void Q7B_LocalVariableAssignment_VM()
{
  QString s = Q7B_toString2(Q7B_pop());

  Q7B_push(s); 
}*/

void Q7B_LocalVariable_VM()
{
  QString s = Q7B_toString2(Q7B_pop());

  if (Q7B_VM_localdim.contains(s)){
    Q7B_push(Q7B_VM_localdim[s]);
    Q7B_VM_localdim[s]->VM_self_Q7B = &Q7B_VM_localdim[s];
  } else { // must be static then
    Q7B_push(Q7B_VM_statics->value(s));
    (*Q7B_VM_statics)[s]->VM_self_Q7B = &(*Q7B_VM_statics)[s];    
  }
}

void Q7B_ClassVariable_VM()
{
  QString s = Q7B_toString2(Q7B_pop());
  Q7B theObject = Q7B_pop();

  QMap<QString, Q7B> *me_vars = theObject->VM_Q7B_me_vars;
  Q7B_push((*me_vars)[s]); 
  (*me_vars)[s]->VM_self_Q7B = &((*me_vars)[s]);
}

void Q7B_Object_VM()
{
  QString s = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toString(); 

  // TODO generate here    alle builtin-objekte

  if (s == "Dir"){ Q7B_push(Q7B_Dir_Object()); }
  else if (s == "MainWindow"){ Q7B_push(Q7B_MainWindow_Object()); }
  else if (s == "Global"){ Q7B_push(Q7B_Global_Object()); }
  else s = s; // error

  //Q7B_Dir_Object()->VM_self_Q7B = &Q7B_Dir_Object();
}

void Q7B_ClassSingleton_VM()
{
  QString s = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toString(); 

  Q7B_push(VM_Q7B_ClassSingleTone(s));
}

void Q7B_IF_VM()
{
  bool b = Q7B_toBoolean2(Q7B_pop()); 

  qint64 Integer = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toLongLong(); 

  if (b == false){
    Q7B_VM_bytecode_pos += Integer;
    Q7B_push(Q7B_ID(false));
  } else {
    Q7B_push(Q7B_ID(true));
  }
}

void Q7B_ELSEIF_VM()
{
  bool b = Q7B_toBoolean2(Q7B_pop()); 
  bool bIf = Q7B_toBoolean2(Q7B_pop()); 

  qint64 Integer = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toLongLong(); 

  if (b == false || bIf == true){
    Q7B_VM_bytecode_pos += Integer;
    Q7B_push(Q7B_ID(bIf));
  } else {
    Q7B_push(Q7B_ID(true));
  }
}

void Q7B_ELSE_VM()
{  
  bool bIf = Q7B_toBoolean2(Q7B_pop()); 

  qint64 Integer = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toLongLong(); 

  if (bIf == true){
    Q7B_VM_bytecode_pos += Integer;
    Q7B_push(Q7B_ID(false));
  } else {
    Q7B_push(Q7B_ID(true));
  } 
}

void Q7B_ENDIF_VM()
{  
  Q7B_pop();
}

void Q7B_DOWHILELOOP_VM()
{
  bool b = Q7B_toBoolean2(Q7B_pop()); 

  qint64 Integer = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toLongLong(); 

  if (b == false){
    Q7B_VM_bytecode_pos += Integer;
  }
}

void Q7B_DOUNTILLOOP_VM()
{
  bool b = Q7B_toBoolean2(Q7B_pop()); 

  qint64 Integer = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toLongLong(); 

  if (b == true){
    Q7B_VM_bytecode_pos += Integer;
  }
}

void Q7B_DOLOOPWHILE_VM()
{
  bool b = Q7B_toBoolean2(Q7B_pop()); 

  qint64 Integer = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toLongLong(); 

  if (b == false){
    Q7B_VM_bytecode_pos += Integer;
  }
}

void Q7B_DOLOOPUNTIL_VM()
{
  bool b = Q7B_toBoolean2(Q7B_pop()); 

  qint64 Integer = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toLongLong(); 

  if (b == true){
    Q7B_VM_bytecode_pos += Integer;
  }
}

void Q7B_JMP_VM()
{
  qint64 Integer = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toLongLong(); 

  Q7B_VM_bytecode_pos += Integer;
}

void Q7B_LOOPEND_VM()
{
  qint64 Integer = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toLongLong(); 

  LOOPEND.push(Q7B_VM_bytecode_pos + Integer);  
}

void Q7B_LOOPEND2_VM()
{
  LOOPSTART.pop();
  LOOPEND.pop();
}

void Q7B_IIF_VM()
{
  bool b = Q7B_toBoolean2(Q7B_pop()); 

  qint64 Integer = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toLongLong(); 

  if (b == false){
    Q7B_VM_bytecode_pos += Integer;
  }
}

void Q7B_GOTO_VM()
{
  qint64 Integer = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toLongLong(); 

  Q7B_VM_bytecode_pos += Integer;
}

void Q7B_ME_VM()
{
  Q7B_push(me_VM);
}

void Q7B_NULL_VM()
{
  Q7B_push(Q7B_IDNULL());
}

void Q7B_NIL_VM()
{
  Q7B_push(Q7B_IDNIL());
}

void Q7B_RETURN_VM()
{
  Q7B_VM_bytecode_pos = Q7B_VM_bytecode.size();
}

void Q7B_RETURN2_VM()
{
  Q7B_VM_bytecode_pos = Q7B_VM_bytecode.size();  

  Q7B_return = Q7B_pop();
}

void Q7B_QObjectPropertyOrKVCAssignment_VM()
{
  Q7B Expression = Q7B_pop(); 
  Q7B QObjectPropertyOrKVC = Q7B_pop(); 
  Q7B Identifier = Q7B_pop();   

  Q7B_PROPERTY(Identifier, QObjectPropertyOrKVC, Expression);
}

void Q7B_STATIC_VM()
{
  qint64 Integer = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toLongLong(); 
  QString sIdentifier = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toString(); 

  if (Q7B_VM_statics->contains(sIdentifier)){
    Q7B_VM_bytecode_pos += Integer;    
  }
}

Q7B Q7B_VM_RUN(QString sFileName, QString sProcedureName, _bytecodes _Q7B_VM_bytecode, Q7B me, QMap<QString, Q7B> args, QMap<QString, Q7B> *statics, QMap<QString, Q7B> me_vars/*, QList<Q7B> global_vars*/)
{
  Q7B_VM_bytecode = _Q7B_VM_bytecode;

  me_pointer_VM = me->ref;
  me_VM = me;
  me_classname_VM = me_VM->type;
  QByteArray ba = me_classname_VM.toAscii();
  ac_me_classname_VM = ba.constData();
  
  Q7B_VM_me_vars = me_vars;

  Q7B_VM_args = args;
  Q7B_VM_statics = statics;

  Q7B_VM_bytecode_pos = 0;
  Q7B_VM_stack.clear();

  Q7B_return = Q7B_IDNULL();

  while (Q7B_bVMError == false && Q7B_VM_bytecode_pos < Q7B_VM_bytecode.size()){
    QString s = Q7B_VM_bytecode.at(Q7B_VM_bytecode_pos++).toString(); 

    if (s == "BuiltinSubFunction") Q7B_BuiltinSubFunction_VM();
    else if (s == "BuiltinClassPropertyOrProcedure") Q7B_BuiltinClassPropertyOrProcedure_VM();    
    else if (s == "Call") Q7B_Call_VM();    
    
    else if (s == "Float") Q7B_Float_VM();
    else if (s == "Integer") Q7B_Integer_VM();
    else if (s == "Boolean") Q7B_Boolean_VM();
    else if (s == "String") Q7B_String_VM();
    else if (s == "Decimal") Q7B_Decimal_VM();

    else if (s == "Debug") Q7B_Debug_VM();
    else if (s == "DebugAndAlso") Q7B_DebugAndAlso_VM();

    else if (s == "Local Dim") Q7B_LocalDim_VM();
    else if (s == "Local Static") Q7B_LocalStatic_VM();

    else if (s == "Assignment") Q7B_Assignment_VM();


    else if (s == "Argument") Q7B_Argument_VM();
    else if (s == "Local Variable") Q7B_LocalVariable_VM();
    else if (s == "Class Variable") Q7B_ClassVariable_VM();    
    else if (s == "Object") Q7B_Object_VM();    
    else if (s == "Class Singleton") Q7B_ClassSingleton_VM();    
    

    else if (s == "CONCAT") Q7B_push(Q7B_CONCAT(Q7B_pop(), Q7B_pop()));    
    else if (s == "MUL") Q7B_push(Q7B_MUL(Q7B_pop(), Q7B_pop()));    
    else if (s == "DIV") Q7B_push(Q7B_DIV(Q7B_pop(), Q7B_pop()));    
    else if (s == "IDIV") Q7B_push(Q7B_IDIV(Q7B_pop(), Q7B_pop()));    
    else if (s == "MOD") Q7B_push(Q7B_MOD(Q7B_pop(), Q7B_pop()));    
    else if (s == "ADD") Q7B_push(Q7B_ADD(Q7B_pop(), Q7B_pop()));    
    else if (s == "SUB") Q7B_push(Q7B_SUB(Q7B_pop(), Q7B_pop()));    
    else if (s == "POWER") Q7B_push(Q7B_POWER(Q7B_pop(), Q7B_pop()));    
    else if (s == "SHR") Q7B_push(Q7B_SHR(Q7B_pop(), Q7B_pop()));    
    else if (s == "SHL") Q7B_push(Q7B_SHL(Q7B_pop(), Q7B_pop()));    
    else if (s == "EQUAL") Q7B_push(Q7B_EQUAL(Q7B_pop(), Q7B_pop()));    
    else if (s == "EQUALEQUAL") Q7B_push(Q7B_EQUALEQUAL(Q7B_pop(), Q7B_pop()));    
    else if (s == "EQUALEQUALEQUAL") Q7B_push(Q7B_EQUALEQUALEQUAL(Q7B_pop(), Q7B_pop()));    
    else if (s == "UNEQUAL") Q7B_push(Q7B_UNEQUAL(Q7B_pop(), Q7B_pop()));    
    else if (s == "GREATER") Q7B_push(Q7B_GREATER(Q7B_pop(), Q7B_pop()));    
    else if (s == "SMALLER") Q7B_push(Q7B_SMALLER(Q7B_pop(), Q7B_pop()));    
    else if (s == "GREATEREQUAL") Q7B_push(Q7B_GREATEREQUAL(Q7B_pop(), Q7B_pop()));    
    else if (s == "SMALLEREQUAL") Q7B_push(Q7B_SMALLEREQUAL(Q7B_pop(), Q7B_pop()));    
    else if (s == "AND") Q7B_push(Q7B_AND(Q7B_pop(), Q7B_pop()));    
    else if (s == "OR") Q7B_push(Q7B_OR(Q7B_pop(), Q7B_pop()));    
    else if (s == "XOR") Q7B_push(Q7B_XOR(Q7B_pop(), Q7B_pop()));    

    else if (s == "MINUS") Q7B_push(Q7B_MINUS(Q7B_pop()));    
    else if (s == "PLUS") Q7B_push(Q7B_pop());  // do nothing
    else if (s == "FLIP") Q7B_push(Q7B_FLIP(Q7B_pop()));    
    else if (s == "NOT") Q7B_push(Q7B_NOT(Q7B_pop()));    

    else if (s == "ORELSE") Q7B_push(Q7B_ORELSE(Q7B_pop(), Q7B_pop()));    
    else if (s == "ANDALSO") Q7B_push(Q7B_ANDALSO(Q7B_pop(), Q7B_pop()));    
    else if (s == "DEBUG_ANDALSO");//Q7B_push(Q7B_ANDALSO(Q7B_pop(), Q7B_pop()));        


    else if (s == "IF") Q7B_IF_VM();    
    else if (s == "ELSEIF") Q7B_ELSEIF_VM();    
    else if (s == "ELSE") Q7B_ELSE_VM();    
    else if (s == "ENDIF") Q7B_ENDIF_VM();    

    else if (s == "DOWHILELOOP") Q7B_DOWHILELOOP_VM();    
    else if (s == "DOUNTILLOOP") Q7B_DOUNTILLOOP_VM();    
    else if (s == "DOLOOPWHILE") Q7B_DOLOOPWHILE_VM();    
    else if (s == "DOLOOPUNTIL") Q7B_DOLOOPUNTIL_VM();    
    
    else if (s == "LOOPSTART"){ LOOPSTART.push(Q7B_VM_bytecode_pos); }
    else if (s == "LOOPEND") Q7B_LOOPEND_VM();
    else if (s == "LOOPEND2") Q7B_LOOPEND2_VM();
    else if (s == "BREAK") Q7B_VM_bytecode_pos = LOOPEND.top();    
    else if (s == "CONTINUE") Q7B_VM_bytecode_pos = LOOPSTART.top();    
    
    else if (s == "JMP") Q7B_JMP_VM();    

    else if (s == "IIF") Q7B_IIF_VM();    

    else if (s == "GOTO") Q7B_GOTO_VM();    

    else if (s == "ME") Q7B_ME_VM();    
    else if (s == "NULL") Q7B_NULL_VM();    
    else if (s == "NIL") Q7B_NIL_VM();    

    else if (s == "Return") Q7B_RETURN_VM();    
    else if (s == "Return ?") Q7B_RETURN2_VM();    

    else if (s == "QObjectPropertyOrKVCAssignment") Q7B_QObjectPropertyOrKVCAssignment_VM();    

    else if (s == "STATIC") Q7B_STATIC_VM();    

    else {
      s = s; // error
    }

    
    
      
   // else if (s == "Local Variable Assignment") Q7B_LocalVariableAssignment_VM();
  }
  if (Q7B_VM_stack.size()){
    return Q7B_pop();
  }
  return Q7B_return;
}

};

Q7B Q7B_VM_RUN(QString sFileName, QString sProcedureName, _bytecodes _Q7B_VM_bytecode, Q7B me, QMap<QString, Q7B> args, QMap<QString, Q7B> *statics, QMap<QString, Q7B> me_vars/*, QList<Q7B> global_vars*/)
{
  Q7B_VM *o = new Q7B_VM();
  Q7B r = o->Q7B_VM_RUN(sFileName, sProcedureName, _Q7B_VM_bytecode, me, args, statics, me_vars/*, QList<Q7B> global_vars*/);
  delete o;
  return r;
}

